'''
Plot energy e+ e- from single and real

run tightBinding2.py pathdir projectionS1S2.txt energy.txt

'''

import os
import sys
import numpy as np
import matplotlib
import matplotlib.pyplot as plt
# from natsort import natsorted, ns
import re

font = {'family' : 'normal',
        'weight' : 'normal',
        'size'   : 22}

matplotlib.rc('font', **font)

matplotlib.rc('axes', titlesize=22)
matplotlib.rc('legend', fontsize=16)
matplotlib.rc('xtick', labelsize=16)
matplotlib.rc('ytick', labelsize=16)

indir=sys.argv[1]
filename=sys.argv[2]
filename2=sys.argv[3]

data=np.loadtxt(indir+filename)
data2=np.loadtxt(indir+filename2)


plt.clf()
plt.plot(data[:,0]-10,data[:,-1],marker='o',linestyle='-',label=r'$\omega^2_{- \rm TB}$')
plt.plot(data[:,0]-10,data[:,-2],marker='o',linestyle='-',label=r'$\omega^2_{+ \rm TB}$')
plt.plot(data2[:,3]-10,data2[:,-2],marker='o',linestyle='-',label='Direct diag. '+r'$\omega^2_-$')
plt.plot(data2[:,3]-10,data2[:,-1],marker='o',linestyle='-',label='Direct diag. '+r'$\omega^2_+$')

plt.legend(loc='best')
plt.xlabel(r'$d/| a_1 |$')
plt.ylabel(r'$\omega^2/\omega_0^2$')
outfigname='tb_energy.pdf'
plt.savefig(indir+outfigname,bbox_inches='tight')


plt.clf()
plt.semilogy(data[:,0],1.1*(data[:,-2]-data[:,-1]),marker='o',linestyle='-',label='Tight-binding model')  
plt.semilogy(data2[:,3],(-data2[:,-2]+data2[:,-1])*1.,marker='o',linestyle='-',label='Direct diag.')  
plt.legend(loc='best')
# plt.xlim([1e-4,1e0])
# plt.ylim([1e-7,1e1])
plt.xlabel('x')
plt.ylabel(r'$\omega^2_+  -  \omega^2_-$')

outfigname='tb_delta_energy.jpg'
plt.savefig(indir+outfigname)
