#Time-stamp: "2017-03-17 22:03:15 Friday by zhou"
'''
Scan from 0 to lx

----------------------------------------------------------------------------------------------------
|                                                                                                   |
|                                                                                                   |
|                                                                                                   |
| #2cut,lable=1-6 move-> (0,lx)                #1cut,lable=1
|                                                                                                   |
|                                                                                                   |
|                                                                                                   |
-----------------------------------------------------------------------------------------------------

or

Scan y direction

Output:

data:
Gap mode energy

figure:
2 gap modes

'''
import sys
sys.path.append('../../../code/topomesh')
import topomesh
import removetrans
import rigidity as rr
from termcolor import colored
import numpy as np
import networkx as nx
import os
import matplotlib.pyplot as plt
import pickle
from termcolor import colored
import random

# frange() from http://code.activestate.com/recipes/66472-frange-a-range-function-with-float-increments/#c4
def frange(end,start=0,inc=0,precision=1):
    """A range function that accepts float increments."""
    import math

    if not start:
        start = end + 0.0
        end = 0.0
    else: end += 0.0

    if not inc:
        inc = 1.0
    count = int(math.ceil((start - end) / inc))

    L = [None] * count

    L[0] = end
    for i in (xrange(1,count)):
        L[i] = L[i-1] + inc
    return L

# --------------------


lx0=20
lxe=20
lxstep=2

ly0=20                           # or set = lx0
lye=20
lystep=2

x20=0
x2e=lxe
x2step=1

y20=0
y2e=lye/2
y2step=1

twp0=0.2
twpe=0.2
twpstep=0.005

cutnum=2
xc=np.zeros(cutnum,dtype=np.int)
yc=np.zeros(cutnum,dtype=np.int)
bondlabelc=np.zeros(cutnum,dtype=np.int)
labelprimec=np.zeros(cutnum,dtype=np.int)

    



num1=0
for lx in range(lx0,lxe+1,lxstep):
    for ly in range(ly0,lye+1,lystep):     
        for twp in frange(twp0,twpe+0.0001,twpstep):

            # dire
            dire='./'
            dire = dire + 'new2_projection_lx' + str(lx)
            if lx0!=ly0:
                dire = dire + 'ly' + str(ly)
            dire=dire+'/'

            dire0=dire

            if not os.path.exists(dire):
                os.makedirs(dire)

            os.system('cp ' + os.path.basename(__file__) +
                      ' ' + dire + os.path.basename(__file__))

            num1=num1+1
            
            # if lx0!=lxe:                  # how to do lazy evaluation in python?
            #     x20=int(lx/2)
            #     x2e=int(lx/2)
            #     x2step=1
            #     y20=int(lx/4)
            #     y2e=int(lx/4)
            #     y2step=1
                


            # 1st bond cut
            xc[0] = int(lx/2)   
            yc[0] = int(ly/4)
            for bl1 in [1]:  # should be (1, 7)
                bondlabelc[0] = bl1
                labelprimec[0] = 0

                mesh = topomesh.HexMesh(lx,ly)
                kagomemesh = topomesh.decorate_kagome(mesh,twp,twp,twp)
                
                b1,b2=topomesh.kagome_bond_by_points_pair(xc[0],yc[0],bondlabelc[0],labelprimec[0],lx,ly)
                kagomemesh.remove_bond(b1,b2)

                
                ro = rr.RigidityObject(kagomemesh,normed=True,sparse=False)
                dm = ro.dynamicalmodes_symm(remove_sp=True)
                es1,vs1 = dm

                for i in range(len(vs1)):
                    if (rr.ipr(vs1[i])>0.02 )and (0.6<es1[i]<1.5):
                        vs1gap=vs1[i]
                        es1gap=es1[i]

                # topomesh.vis2d(kagomemesh,
                #                figname=dire0 + 'vs1gap.jpg',
                #                eigenfunction=vs1gap,
                #                scale=4, sizex=12, sizey=12. * ly / lx, minlength=10**-10)
                                                           
                kagomemesh.add_bond(b1,b2)

                for bondlabel2 in [3]:   #bond type be (bl1,7) to scan
                    vs2gaplist=[]
                    for x2 in range(lx):  # scan x, range(lx) ; scan y, [int(lx/2)]
                        for y2 in [int(ly/4)]:            # scan x, [int(ly/4)]; scan y, range(ly/2)
                            for labelprime2 in [0]:   #scan x, [0], scan y [0,1]
                                dire=dire0+'bond'+str(bondlabelc[0])+str(bondlabel2)+'/'
                                if not os.path.exists(dire):
                                    os.makedirs(dire)

                                if (x2,y2,bondlabel2,labelprime2)==(xc[0],yc[0],bondlabelc[0],labelprimec[0]):
                                    print 'OVERLAP'
                                    vs2gaplist.append(vs1gap)                                    
                                    continue

                                # '''
                                # temp! REMOVE THIS AFTERWARDS
                                # '''
                                # if bondlabel2==3 and bondlabelc[0]==1:
                                #     continue

                                print 'num1='+colored(str(num1),'red'),
                                print 'lx='+colored(str(lx),'red')+'/'+str(lxe),
                                print 'twp='+colored(str(twp),'red')+'/'+str(twpe),
                                print 'x2='+colored(str(x2),'red')+'/'+str(x2e),
                                print 'y2='+colored(str(y2),'red')+'/'+str(y2e),
                                print 'bl1='+colored(str(bondlabelc[0]),'red'),
                                print 'bl2='+colored(str(bondlabel2),'red'),
                                print 'lp='+colored(str(labelprime2),'red'),
                                print ''



                                # 2nd bond cut
                                xc[1],yc[1],bondlabelc[1],labelprimec[1]=x2,y2,bondlabel2,labelprime2
                                b1,b2=topomesh.kagome_bond_by_points_pair(xc[1],yc[1],bondlabelc[1],labelprimec[1],lx,ly)
                                kagomemesh.remove_bond(b1,b2)

                                if lx*ly*6-len(kagomemesh.Bonds)!=1:
                                    print 'Error, #Cut Bond!=1'
                                    sys.exit()

                                ro = rr.RigidityObject(kagomemesh,normed=True,sparse=False)
                                dm = ro.dynamicalmodes_symm(remove_sp=True)
                                es2,vs2 = dm


                                for i in range(len(vs2)):
                                    if (rr.ipr(vs2[i])>0.02 )and (0.6<es2[i]<1.5):
                                        vs2gap=vs2[i]
                                        vs2gaplist.append(vs2[i])
                                        es2gap=es2[i]

                                txtSingleEnergy='singleEnergy.txt'
                                if x2==0:
                                    with open(dire+txtSingleEnergy,'a') as f_handle:
                                        f_handle.write("%.16f\t%.16f" % (es1gap,es2gap))
                                        
                                # topomesh.vis2d(kagomemesh,
                                #                figname=dire + 'vs2gap_x2='+str(x2)+'.jpg',
                                #                eigenfunction=vs2gap,
                                #                scale=4, sizex=12, sizey=12. * ly / lx, minlength=10**-10)
                               

                                bb1,bb2=topomesh.kagome_bond_by_points_pair(xc[0],yc[0],bondlabelc[0],labelprimec[0],lx,ly)
                                kagomemesh.remove_bond(bb1,bb2)

                                
                                if lx*ly*6-len(kagomemesh.Bonds)!=2:
                                    print 'Error, #Cut Bond!=2'
                                    sys.exit()

                                ro = rr.RigidityObject(kagomemesh,normed=True,sparse=False)
                                dm = ro.dynamicalmodes_symm(remove_sp=True)
                                e1,v1 = dm

                                               
                                # Output
                                dirPicA = dire + 'mode' + '/'
                                if not os.path.exists(dirPicA):
                                    os.makedirs(dirPicA)                            
                                txtenergy='energy.txt'
                                with open(dire+txtenergy,'a') as f_handle:
                                    f_handle.write("%i\t%i\t%.4f\t%i\t%i\t%i\t%i\t%i\t%i\t" %
                                               (lx,ly,twp,x2,y2,bondlabel2,labelprime2,b1,b2))
                                    for i in range(len(v1)):
                                        if (rr.ipr(v1[i])>0.02 )and (0.6<e1[i]<1.5):
                                            print 'gap mode'+str(i)
                                            f_handle.write("%.16f\t" % e1[i])
                                            topomesh.vis2d(kagomemesh,
                                                           figname=dirPicA + 'xybp' + str(x2)+'_'+str(y2)+'_'+str(bondlabel2)+'_'+str(labelprime2)+ 'mode' + str(i) + '.png',
                                                           eigenfunction=v1[i],
                                                           scale=4, sizex=12, sizey=12. * ly / lx, minlength=10**-10  
                                                           # draw_annotate='i='+str(i)+'\t'+
                                                           # 'IPR='+str(rr.ipr(v1[i]))+'\t'+
                                                           # 'omega2='+str(e1[i])+'\t'+
                                                           # 'bond='+str(bondlabel2)
                                            )
                                            topomesh.vis2d(kagomemesh,
                                                           figname=dirPicA + 'xybp' + str(x2)+'_'+str(y2)+'_'+str(bondlabel2)+'_'+str(labelprime2)+ 'mode' + str(i) + 'minus.png',
                                                           eigenfunction=-v1[i],
                                                           scale=4, sizex=12, sizey=12. * ly / lx, minlength=10**-10  
                                                           # draw_annotate='i='+str(i)+'\t'+
                                                           # 'IPR='+str(rr.ipr(v1[i]))+'\t'+
                                                           # 'omega2='+str(e1[i])+'\t'+
                                                           # 'bond='+str(bondlabel2)
                                            )
                                    f_handle.write("\n")

                                txtProjection1='projectionS1S2.txt'
                                H=np.array(ro.dynamicalmatrix())
                                phi1=vs1gap
                                phi2=vs2gaplist[x2]
                                S=np.vdot(phi1,phi2)
                                alpha1=np.vdot(phi1,H.dot(phi1))
                                alpha2=np.vdot(phi2,H.dot(phi2))
                                beta=np.vdot(phi1,H.dot(phi2))
                                A=1-S**2
                                B=-(alpha1+alpha2-2*S*beta)
                                C=alpha1*alpha2-beta**2
                                eplus=(-B+np.sqrt(B**2-4*A*C))/(2*A)
                                eminus=(-B-np.sqrt(B**2-4*A*C))/(2*A)
                                with open(dire+txtProjection1,'a') as f_handle:
                                    f_handle.write("%i\t" % x2)
                                    f_handle.write("%.16f\t" %(S))  # S = <phi1 | phi2>
                                    f_handle.write("%.16f\t" %(alpha1))  # alpha = <phi1 | H | phi1>
                                    f_handle.write("%.16f\t" %(alpha2))  # alpha'= <phi2 | H | phi2>
                                    f_handle.write("%.16f\t" %(beta))  # beta = <phi1 | H | phi2>
                                    f_handle.write("%.16f\t%.16f\t" %(eplus,eminus))  # e+ and e-
                                    f_handle.write("\n")

                                    
                                vsN=removetrans.realMakeOrthonormal(np.array([vs1gap,vs2gaplist[x2]]))
                                txtProjection2='projectionTwoMode.txt'
                                with open(dire+txtProjection2,'a') as f_handle:
                                    f_handle.write("%i\t" % x2)
                                    for i in range(len(v1)):  # c1-, c2-, cR-, c1+, c2+, cR+
                                        if (rr.ipr(v1[i])>0.02) and (0.6<e1[i]<1.5):
                                            c1=np.vdot(vs1gap,v1[i])
                                            c2=np.vdot(vs2gaplist[x2],v1[i])
                                            c1N=np.vdot(vsN[0],v1[i])
                                            c2N=np.vdot(vsN[1],v1[i])
                                            cR=np.linalg.norm(v1[i]-c1*vs1gap-c2*vs2gaplist[x2])
                                            cRN=np.linalg.norm(v1[i]-c1N*vsN[0]-c2N*vsN[1])
                                            f_handle.write("%.16f\t" % c1)
                                            f_handle.write("%.16f\t" % c2)
                                            f_handle.write("%.16f\t" % cR)
                                            f_handle.write("%.16f\t" % cRN)
                                    f_handle.write("\n")

                                    
                                kagomemesh.add_bond(b1,b2)
                                kagomemesh.add_bond(bb1,bb2)
