import os
import sys
sys.path.append('../../../../code/topomesh/')
import numpy as np
import matplotlib.pyplot
import matplotlib.pyplot as plt
# from natsort import natsorted, ns
import re
import topomesh

def latex_float(f):
    float_str = "{0:.4g}".format(f)
    if "e" in float_str:
        base, exponent = float_str.split("e")
        return r"{0} \times 10^{{{1}}}".format(base, int(exponent))
    else:
        return float_str

    
font = {'family' : 'normal',
        'weight' : 'normal',
        'size'   : 22}
matplotlib.rc('font', **font)
matplotlib.rc('axes', titlesize=22)
matplotlib.rc('legend', fontsize=16)
matplotlib.rc('xtick', labelsize=16)
matplotlib.rc('ytick', labelsize=16)

indir=sys.argv[1]
energyfilename=sys.argv[2]


dataEnergy=np.loadtxt(indir+energyfilename)

plt.clf()        
for i in range(len(dataEnergy)):
    if dataEnergy[i][2]<=0.50 and round(round(dataEnergy[i,2],3)%0.01,3)%0.01==0:  # 2nd cond select +0.01 twp
        print dataEnergy[i][2]
        for j in range(3,len(dataEnergy[i]),1):
            x=topomesh.twisting_parameter_to_angle(dataEnergy[i][2])/np.pi*180
            y=np.sqrt(dataEnergy[i][j])
            plt.plot(x,y,marker='.', alpha=0.05,linestyle=None,c='b',mec='none')
        if dataEnergy[i][2]>0.11:  # gap mode
            for j in [dataEnergy[i][0]*dataEnergy[i][1]*2+3]:
                x=topomesh.twisting_parameter_to_angle(dataEnergy[i][2])/np.pi*180
                y=np.sqrt(dataEnergy[i][int(j)])
                # yplus=np.sqrt(dataEnergy[i][j+1])
                # yminus=np.sqrt(dataEnergy[i][j-1])
                # plt.plot(x,y,marker='o', alpha=1,linestyle=None,c='b',mec='none')
                # plt.plot(x,yplus,marker='o', alpha=1,linestyle=None,c='k',mec='none')
                # plt.plot(x,yminus,marker='o', alpha=1,linestyle=None,c='k',mec='none')
            
plt.legend(loc='best')
plt.xlabel(r'$\rm Twisting\ angle\ \theta\ [deg]$')
plt.ylabel(r'$\omega/ \omega_0$')
plt.xlim([0,60])
plt.ylim([0,2.5])



outfigname='spectrum_angle_defect'+'.pdf'
# outfigname='spectrum_angle_defect'+'.jpg'
dirTemp=indir+'l_twp/' #output dire
if not os.path.exists(dirTemp):
    os.makedirs(dirTemp)
plt.savefig(dirTemp+outfigname,bbox_inches='tight')
