#Time-stamp: "2017-09-20 10:02:32 Wednesday by yujie"
import sys
sys.path.append('../../code/topomesh')
import topomesh
import rigidity as rr
from termcolor import colored
import numpy as np
import networkx as nx
import os
import matplotlib.pyplot as plt
import pickle
from termcolor import colored
import random

# frange() from http://code.activestate.com/recipes/66472-frange-a-range-function-with-float-increments/#c4
def frange(end,start=0,inc=0,precision=1):
    """A range function that accepts float increments."""
    import math

    if not start:
        start = end + 0.0
        end = 0.0
    else: end += 0.0

    if not inc:
        inc = 1.0
    count = int(math.ceil((start - end) / inc))

    L = [None] * count

    L[0] = end
    for i in (xrange(1,count)):
        L[i] = L[i-1] + inc
    return L

# --------------------


lx0=10
lxe=10
lxstep=2


x20=0
x2e=lxe
x2step=1

y20=0
y2e=lxe/2
y2step=1

twp0=0.20
twpe=0.20
twpstep=0.01

cutnum=2
xc=np.zeros(cutnum,dtype=np.int)
yc=np.zeros(cutnum,dtype=np.int)
bondlabelc=np.zeros(cutnum,dtype=np.int)
labelprimec=np.zeros(cutnum,dtype=np.int)

    
# dire
dire='./'
dire = dire + 'single/lx' + str(lx0)+'-'+str(lxe)
dire = dire + 'twp' + str(twp0)+'-'+str(twpe)
dire=dire+'/'


if not os.path.exists(dire):
    os.makedirs(dire)

os.system('cp ' + os.path.basename(__file__) +
          ' ' + dire + os.path.basename(__file__))

num1=0
for lx in range(lx0,lxe+1,lxstep):
    for ly in range(lx,lx+1,lxstep):      #ly=lx
        for twp in frange(twp0,twpe+0.0001,twpstep):

            print 'num1='+colored(str(num1),'red'),
            print 'lx='+colored(str(lx),'red')+'/'+str(lxe),
            print 'twp='+colored(str(twp),'red')+'/'+str(twpe),
            print ''

            num1=num1+1
            
            if lx0!=lxe:                  # how to do lazy evaluation in python?
                x20=int(lx/2)
                x2e=int(lx/2)
                x2step=1
                y20=int(lx/4)
                y2e=int(lx/4)
                y2step=1
                
            mesh = topomesh.HexMesh(lx,ly)
            kagomemesh = topomesh.decorate_kagome(mesh,twp,twp,twp)

            # 1st bond cut
            xc[0] = int(lx/2) 
            yc[0] = int(lx/4)
            bondlabelc[0] = 1
            labelprimec[0] = 0
            b1,b2=topomesh.kagome_bond_by_points_pair(xc[0],yc[0],bondlabelc[0],labelprimec[0],lx,ly)
            kagomemesh.remove_bond(b1,b2)


            ro = rr.RigidityObject(kagomemesh,normed=True,sparse=False)
            dm = ro.dynamicalmodes_symm(remove_sp=True)
            e1,v1 = dm


            # Enengy
            txtenergy='energy.txt'
            with open(dire+txtenergy,'a') as f_handle:
                f_handle.write("%i\t%i\t%.4f\t" %(lx,ly,twp))
                for item in e1:
                    f_handle.write("%.16f\t" % item)
                f_handle.write("\n")


                
                                
            dirPicA = dire + 'modePic' + '/'
            if not os.path.exists(dirPicA):
                os.makedirs(dirPicA)
                
            for i in range(len(v1)):
                if rr.ipr(v1[i])>0.00 and i==lx*ly*2:
                    topomesh.vis2d(kagomemesh,
                               figname=dirPicA + 'twp' + '{:.3f}'.format(twp)  + 'mode' + str(i)+ '.png',
                               eigenfunction=-v1[i],
                               scale=6, sizex=12, sizey=12. * ly / lx, minlength=10**-10# ,  
                               # draw_annotate='i='+str(i)+'\t'+
                               # 'twp='+str(twp)+'\n'+
                               # 'IPR='+str(rr.ipr(v1[i]))+'\n'+
                               # 'omega2='+str(e1[i])+'\n'
                    )
