(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   3620898,      83082]
NotebookOptionsPosition[   3600396,      82557]
NotebookOutlinePosition[   3600842,      82576]
CellTagsIndexPosition[   3600799,      82573]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["version2: Added Anti-kink configuration generator", "Text",
 CellChangeTimes->{{3.648976510932583*^9, 3.648976541844862*^9}}],

Cell[CellGroupData[{

Cell["Function Library", "Subsubsection",
 CellChangeTimes->{{3.633107868465901*^9, 3.633107871621709*^9}, 
   3.646901892311627*^9, 3.6515583381921062`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"splineCircle", "[", 
   RowBox[{"m_List", ",", "r_", ",", 
    RowBox[{"angles_List:", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "seg", ",", "\[Phi]", ",", "start", ",", "end", ",", "pts", ",", "w", 
       ",", "k", ",", "endtemp", ",", "starttemp"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"starttemp", ",", "endtemp"}], "}"}], "=", 
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{"angles", "//", "N"}], ",", 
         RowBox[{"2", " ", "\[Pi]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"endtemp", "\[LessEqual]", "starttemp"}], ",", 
        RowBox[{
         RowBox[{"start", "=", "endtemp"}], ";", 
         RowBox[{"end", "=", "starttemp"}], ";"}], ",", 
        RowBox[{
         RowBox[{"start", "=", "starttemp"}], ";", 
         RowBox[{"end", "=", "endtemp"}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"seg", "=", 
       RowBox[{"Quotient", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"end", "-", "start"}], "//", "N"}], ",", 
         RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Phi]", "=", 
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"end", "-", "start"}], "//", "N"}], ",", 
         RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"seg", "\[Equal]", "4"}], ",", 
        RowBox[{
         RowBox[{"seg", "=", "3"}], ";", 
         RowBox[{"\[Phi]", "=", 
          RowBox[{"\[Pi]", "/", "2"}]}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"pts", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"r", " ", 
          RowBox[{
           RowBox[{"RotationMatrix", "[", "start", "]"}], ".", "#"}]}], "&"}],
         "/@", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
            RowBox[{
             RowBox[{"2", " ", "seg"}], "+", "1"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"RotationMatrix", "[", 
              RowBox[{"seg", " ", 
               RowBox[{"\[Pi]", "/", "2"}]}], "]"}], ".", "#"}], "&"}], "/@", 
           
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"Tan", "[", 
                RowBox[{"\[Phi]", "/", "2"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Cos", "[", "\[Phi]", "]"}], ",", 
               RowBox[{"Sin", "[", "\[Phi]", "]"}]}], "}"}]}], "}"}]}]}], 
         "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "2"}], ",", 
        RowBox[{"pts", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"m", "+", "#"}], "&"}], "/@", "pts"}]}], ",", 
        RowBox[{"pts", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"m", "+", "#"}], "&"}], "/@", 
          RowBox[{"Transpose", "[", 
           RowBox[{"Append", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", "pts", "]"}], ",", 
             RowBox[{"ConstantArray", "[", 
              RowBox[{"0", ",", 
               RowBox[{"Length", "[", "pts", "]"}]}], "]"}]}], "]"}], 
           "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"w", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1", ",", 
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1", ",", 
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1"}], "}"}], ",", 
           RowBox[{
            RowBox[{"2", " ", "seg"}], "+", "1"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"\[Phi]", "/", "2"}], "]"}], ",", "1"}], "}"}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"k", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Riffle", "[", 
            RowBox[{"#", ",", "#"}], "]"}], "&"}], "@", 
          RowBox[{"Range", "[", 
           RowBox[{"seg", "+", "1"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"seg", "+", "1"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"endtemp", "\[LessEqual]", "starttemp"}], ",", 
        RowBox[{
         RowBox[{"w", "=", 
          RowBox[{"Reverse", "[", "w", "]"}]}], ";", 
         RowBox[{"pts", "=", 
          RowBox[{"Reverse", "[", "pts", "]"}]}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"BSplineCurve", "[", 
       RowBox[{"pts", ",", 
        RowBox[{"SplineDegree", "\[Rule]", "2"}], ",", 
        RowBox[{"SplineKnots", "\[Rule]", "k"}], ",", 
        RowBox[{"SplineWeights", "\[Rule]", "w"}]}], "]"}]}]}], "]"}], "/;", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "2"}], "||", 
    RowBox[{
     RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "3"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicvec", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "Red", ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{".2", "/", "num"}], "]"}], ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}]}]}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"ver2", ":", " ", 
    RowBox[{"red", " ", "mid", " ", "spring"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicvec2", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "Green", ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", "}"}], "]"}], ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}]}]}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{
              RowBox[{"num", "/", "2"}], "-", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}]}]}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{
              RowBox[{"num", "/", "2"}], "+", "1"}], ",", 
             RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "Red", ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{".2", "/", "num"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}]}]}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"num", "/", "2"}], ",", 
             RowBox[{"num", "/", "2"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"ver3", ":", " ", 
    RowBox[{"all", " ", "solid", " ", "green"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicvec3", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "Green", ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", "}"}], "]"}], ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}]}]}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"numerical", " ", "functions"}], ",", " ", 
    RowBox[{
    "components", " ", "in", " ", "the", " ", "rigidity", " ", "matrix"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"l", "[", 
     RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"]}], "-", 
      RowBox[{"2", "  ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}], "]"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"measure", " ", "from"}], " ", "+", 
    RowBox[{"y", " ", 
     RowBox[{"vertical", ":", " ", 
      RowBox[{
       RowBox[{"not", " ", "kane"}], "-", "lubensky"}]}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l", "[", 
   RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_", ",", 
    RowBox[{"a_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "-", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "[", 
   RowBox[{"\[Theta]_", ",", "r_", ",", 
    RowBox[{"a_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"llist", "[", "num_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "ldef", ",", 
       RowBox[{"Sqrt", "[", "lzerosq", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"pi", "/", "2"}], " ", "convention", " ", "for", " ", "thetas", 
    " ", "again", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"measured", " ", "from", " ", "x"}], "-", 
      RowBox[{"axis", "!"}]}], ")"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SSHq1", "[", 
   RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "r", " ", 
     RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "2"], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}]}], 
   RowBox[{"2", " ", 
    SqrtBox[
     RowBox[{"1", "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"]}], "-", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{
       "Cos", "[", "\[Theta]2", "]"}]}]}]]}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SSHq2", "[", 
    RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["r", "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "-", 
     RowBox[{"2", " ", "r", " ", 
      RowBox[{"Sin", "[", "\[Theta]2", "]"}]}]}], 
    RowBox[{"2", " ", 
     SqrtBox[
      RowBox[{"1", "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       RowBox[{"2", " ", "r", " ", 
        RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["r", "2"], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
       RowBox[{"2", " ", "r", " ", 
        RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}]]}]]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "make", " ", "rigidity", " ", "matrix", " ", "given", " ", "a", " ", 
    "system", " ", "with", " ", "equilibrium", " ", "angles", " ", "in", " ", 
    "the", " ", "list", " ", "theta", " ", "and", " ", "length", " ", "of", 
    " ", "bars", " ", "equal", " ", "to", " ", "r"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHrig", "[", 
    RowBox[{"\[Theta]_", ",", "r_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SparseArray", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", " ", 
             RowBox[{"SSHq1", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "r"}], "]"}]}], 
            ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"i", "+", "1"}]}], "}"}], "\[Rule]", " ", 
             RowBox[{"SSHq2", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "r"}], "]"}]}]}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"n", "-", "1"}], ",", "n"}], "}"}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tencoef", "[", 
    RowBox[{"i_", ",", "j_", ",", "\[Theta]_"}], "]"}], ":=", 
   RowBox[{"Which", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"i", "-", "j"}], "]"}], "\[Equal]", "1"}], ",", 
     RowBox[{"1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"]}]]]}], ",", 
     RowBox[{"i", "\[Equal]", "j"}], ",", 
     RowBox[{"1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "-", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
           ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "-", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
           ")"}], "2"]}]]], "+", "1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"]}]]]}], ",", 
     "True", ",", "0"}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"j", ">", "i"}], ",", " ", 
    RowBox[{"j", " ", "at", " ", "right", " ", "of", " ", "i"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Prestressed", " ", "dynamical", " ", "matrix", " ", "calculation"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ghat", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"kk", "[", "p", "]"}], 
   RowBox[{"lzero", "/", 
    RowBox[{"Norm", "[", 
     RowBox[{"ll", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"ll", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "+", 
     RowBox[{"r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
        RowBox[{"p", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], "-", 
     RowBox[{"r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
       "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
        RowBox[{"p", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], "-", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{
       "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "]"}]}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"vv", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Sin", "[", 
      RowBox[{
      "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
      "]"}]}], ",", 
    RowBox[{"Cos", "[", 
     RowBox[{
     "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
     "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"tension", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"kk", "[", "p", "]"}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Norm", "[", 
       RowBox[{"ll", "[", 
        RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}], "-", "lzero"}], ")"}], 
    "/", 
    RowBox[{"Norm", "[", 
     RowBox[{"ll", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"aa", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"p", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"vv", "[", 
           RowBox[{"p", ",", "\[Theta]"}], "]"}], ".", 
          RowBox[{"ll", "[", 
           RowBox[{"p", ",", "\[Theta]"}], "]"}]}]}], "/", 
        RowBox[{"Norm", "[", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p", "+", "1"}], ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{
        RowBox[{
         RowBox[{"vv", "[", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", "\[Theta]"}], "]"}], ".", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}]}], "/", 
        RowBox[{"Norm", "[", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"num", ",", "1"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Kp", "[", "\[Theta]_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ghat", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], 
     RowBox[{"KroneckerProduct", "[", 
      RowBox[{
       RowBox[{"aa", "[", 
        RowBox[{"p", ",", "\[Theta]"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"aa", "[", 
         RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"p", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"S", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"p", ",", "p"}], "}"}], "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"vv", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}], ".", 
             RowBox[{"ll", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
            RowBox[{
            "\[Theta]\[Theta]", "\[LeftDoubleBracket]", "pp", 
             "\[RightDoubleBracket]"}]}], "]"}]}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"p", ",", 
           RowBox[{"p", "+", "1"}]}], "}"}], "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"vv", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}], ".", 
             RowBox[{"ll", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
            RowBox[{"\[Theta]\[Theta]", "\[LeftDoubleBracket]", 
             RowBox[{"pp", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}],
         "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", "p"}], "}"}], "\[Rule]", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"vv", "[", 
             RowBox[{
              RowBox[{"pp", "+", "1"}], ",", "\[Theta]\[Theta]"}], "]"}], ".", 
            RowBox[{"ll", "[", 
             RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
           RowBox[{
           "\[Theta]\[Theta]", "\[LeftDoubleBracket]", "pp", 
            "\[RightDoubleBracket]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", 
           RowBox[{"p", "+", "1"}]}], "}"}], "\[Rule]", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"vv", "[", 
             RowBox[{
              RowBox[{"pp", "+", "1"}], ",", "\[Theta]\[Theta]"}], "]"}], ".", 
            RowBox[{"ll", "[", 
             RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
           RowBox[{"\[Theta]\[Theta]", "\[LeftDoubleBracket]", 
            RowBox[{"pp", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"num", ",", "num"}], "}"}]}], "]"}], "*", 
   RowBox[{
    RowBox[{"tension", "[", 
     RowBox[{"p", ",", "\[Theta]"}], "]"}], "/", "r"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMat", "[", "\[Theta]_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Kp", "[", "\[Theta]", "]"}], "+", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"Quiet", "[", 
       RowBox[{"S", "[", 
        RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"thetadynamic", " ", "measured", " ", "from"}], " ", "+", 
    RowBox[{"y", "?"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"klodesystemgenparams", "[", 
    RowBox[{
    "n_", ",", "thetadynamic_", ",", "M_", ",", "r_", ",", "k_", ",", 
     "th0_"}], "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "M"}], " ", 
       SuperscriptBox["r", 
        RowBox[{"2", " "}]], 
       RowBox[{
        RowBox[{
         RowBox[{"thetadynamic", "[", "i", "]"}], "''"}], "[", "t", "]"}]}], 
      "\[Equal]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"torque", " ", "from", " ", "ahead"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "<", "n"}], ",", 
         RowBox[{
          RowBox[{"-", "k"}], " ", "r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "r"}], " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], "-", 
               RowBox[{
                RowBox[{"thetadynamic", "[", 
                 RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}]}], "]"}]}], 
            "+", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{
              RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
             "]"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{
              RowBox[{"llist", "[", "num", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], 
             RowBox[{"l", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
               RowBox[{
                RowBox[{"thetadynamic", "[", 
                 RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}], ",", "r"}], 
              "]"}]]}], ")"}]}], ",", "0"}], "]"}], "+", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"torque", " ", "from", " ", "behind"}], " ", "*)"}], 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", ">", "1"}], ",", 
         RowBox[{
          RowBox[{"-", "k"}], " ", "r", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"thetadynamic", "[", 
                 RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], "-", 
               RowBox[{
                RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}]}], 
              "]"}]}], "-", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{
              RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
             "]"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{
              RowBox[{"llist", "[", "num", "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", "-", "1"}], "]"}], "]"}], 
             RowBox[{"l", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"thetadynamic", "[", 
                 RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], ",", 
               RowBox[{
                RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",",
                "r"}], "]"}]]}], ")"}]}], ",", "0"}], "]"}]}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"initialklgen", "[", 
    RowBox[{"n_", ",", "th_", ",", "v_", ",", "thetadynamic_"}], "]"}], ":=", 
   
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"thetadynamic", "[", "i", "]"}], "[", "0", "]"}], 
          "\[Equal]", 
          RowBox[{"th", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"thetadynamic", "[", "i", "]"}], "'"}], "[", "0", "]"}], 
          "\[Equal]", 
          RowBox[{"v", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"klchainmd", "[", 
    RowBox[{
    "num_", ",", "tmax_", ",", "M_", ",", "k_", ",", "r_", ",", "th0_", ",", 
     "initial_", ",", "v_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"thetadynamic", ",", "ans"}], "}"}], ",", "\[IndentingNewLine]",
      "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "/.", 
       RowBox[{
        RowBox[{"NDSolve", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"klodesystemgenparams", "[", 
             RowBox[{
             "num", ",", "thetadynamic", ",", "M", ",", "r", ",", "k", ",", 
              "th0"}], "]"}], ",", 
            RowBox[{"initialklgen", "[", 
             RowBox[{"num", ",", "initial", ",", "v", ",", "thetadynamic"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "0", ",", "tmax"}], "}"}], ",", 
          RowBox[{"MaxSteps", "\[Rule]", "Infinity"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "the", " ", "following", " ", "three", " ", "function", " ", "for", " ", 
    "various", " ", "k", " ", "as", " ", 
    RowBox[{"kk", "[", "i", "]"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"klodesystemgenparams2original", "[", 
   RowBox[{
   "n_", ",", "thetadynamic_", ",", "M_", ",", "r_", ",", "k_", ",", "th0_"}],
    "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"M", "[", "i", "]"}]}], " ", 
      SuperscriptBox["r", 
       RowBox[{"2", " "}]], 
      RowBox[{
       RowBox[{
        RowBox[{"thetadynamic", "[", "i", "]"}], "''"}], "[", "t", "]"}]}], 
     "\[Equal]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"torque", " ", "from", " ", "ahead"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", "<", "n"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", "i", "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "r"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], "-", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}]}], "]"}]}], 
           "+", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}], ",", "r"}], 
             "]"}]]}], ")"}]}], ",", "0"}], "]"}], "+", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"torque", " ", "from", " ", "behind"}], " ", "*)"}], 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", ">", "1"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", 
           RowBox[{"i", "-", "1"}], "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], "-", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}]}], 
             "]"}]}], "-", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", "-", "1"}], "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], ",", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              "r"}], "]"}]]}], ")"}]}], ",", "0"}], "]"}]}]}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"klodesystemgenparams2", "[", 
   RowBox[{
   "n_", ",", "thetadynamic_", ",", "M_", ",", "r_", ",", "k_", ",", "th0_"}],
    "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"M", "[", "i", "]"}]}], " ", 
       SuperscriptBox["r", 
        RowBox[{"2", " "}]], 
       RowBox[{
        RowBox[{
         RowBox[{"thetadynamic", "[", "i", "]"}], "''"}], "[", "t", "]"}]}], 
      "-", 
      RowBox[{"\[Eta]", " ", "r", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"thetadynamic", "[", "i", "]"}], "'"}], "[", "t", "]"}]}]}], 
     "\[Equal]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"torque", " ", "from", " ", "ahead"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", "<", "n"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", "i", "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "r"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], "-", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}]}], "]"}]}], 
           "+", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}], ",", "r"}], 
             "]"}]]}], ")"}]}], ",", "0"}], "]"}], "+", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"torque", " ", "from", " ", "behind"}], " ", "*)"}], 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", ">", "1"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", 
           RowBox[{"i", "-", "1"}], "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], "-", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}]}], 
             "]"}]}], "-", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", "-", "1"}], "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], ",", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              "r"}], "]"}]]}], ")"}]}], ",", "0"}], "]"}]}]}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"klchainmd2", "[", 
   RowBox[{
   "num_", ",", "tmax_", ",", "M_", ",", "k_", ",", "r_", ",", "th0_", ",", 
    "initial_", ",", "v_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"thetadynamic", ",", "ans"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"ans", "=", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "/.", 
      RowBox[{
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"klodesystemgenparams2", "[", 
            RowBox[{
            "num", ",", "thetadynamic", ",", "M", ",", "r", ",", "k", ",", 
             "th0"}], "]"}], ",", 
           RowBox[{"initialklgen", "[", 
            RowBox[{"num", ",", "initial", ",", "v", ",", "thetadynamic"}], 
            "]"}]}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "tmax"}], "}"}], ",", 
         RowBox[{"MaxSteps", "\[Rule]", "Infinity"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PotentialEnergy2", "[", 
     RowBox[{"c_", ",", "i_"}], "]"}], ":=", 
    RowBox[{
     FractionBox[
      RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "-", 
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Sin", "[", 
                 RowBox[{"conftab", "[", 
                  RowBox[{"[", 
                   RowBox[{"c", ",", "i"}], "]"}], "]"}], "]"}], "-", "  ", 
                RowBox[{"Sin", "[", 
                 RowBox[{"conftab", "[", 
                  RowBox[{"[", 
                   RowBox[{"c", ",", 
                    RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "]"}]}], 
               ")"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", " ", 
            RowBox[{"r", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"conftab", "[", 
                 RowBox[{"[", 
                  RowBox[{"c", ",", "i"}], "]"}], "]"}], "]"}], "+", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"conftab", "[", 
                 RowBox[{"[", 
                  RowBox[{"c", ",", 
                   RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "]"}]}], ")"}]}], 
            ")"}], "2"]}], "]"}], "-", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"numdef", "-", "1"}]}], ",", 
           SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], 
       ")"}], "2"]}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PotentialEnergy", "[", 
    RowBox[{"c_", ",", "i_"}], "]"}], ":=", 
   RowBox[{
    FractionBox["k", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"r", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Sin", "[", 
                RowBox[{"conftab", "[", 
                 RowBox[{"[", 
                  RowBox[{"c", ",", "i"}], "]"}], "]"}], "]"}], "-", "  ", 
               RowBox[{"Sin", "[", 
                RowBox[{"conftab", "[", 
                 RowBox[{"[", 
                  RowBox[{"c", ",", 
                   RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "]"}]}], 
              ")"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", " ", 
           RowBox[{"r", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"conftab", "[", 
                RowBox[{"[", 
                 RowBox[{"c", ",", "i"}], "]"}], "]"}], "]"}], "+", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"conftab", "[", 
                RowBox[{"[", 
                 RowBox[{"c", ",", 
                  RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "]"}]}], ")"}]}], 
           ")"}], "2"]}], "]"}], "-", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", 
           RowBox[{"numdef", "-", "1"}]}], ",", 
          SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], 
      ")"}], "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticEnergy", "[", "i_", "]"}], ":=", 
    RowBox[{
     FractionBox[
      RowBox[{"M", "[", "i", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"r", " ", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ans", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", "t"}], 
         "]"}]}], ")"}], "2"]}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GetDat", "[", 
    RowBox[{"ans_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dat", ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "ans", "]"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"dat", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Mod", "[", 
               RowBox[{"j", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"\[Pi]", "-", 
                RowBox[{
                 RowBox[{"ans", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}]}], ",", 
               RowBox[{"2", "\[Pi]"}], ",", 
               RowBox[{"-", "\[Pi]"}]}], "]"}], ",", 
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}], ",", 
               RowBox[{"2", "\[Pi]"}], ",", 
               RowBox[{"-", "\[Pi]"}]}], "]"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"dat", "[", 
           RowBox[{"[", 
            RowBox[{"j", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"angle", "[", "j", "]"}]}], "}"}], ",", " ", 
    RowBox[{"up", "-", "and", "-", 
     RowBox[{"down", " ", "convention"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FindCrossing", "[", "dat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dat2", "=", 
       RowBox[{"dat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "s", ",", "stoptime",
       ",", "x0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"s", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{"dat2", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "s"}], "<", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"Length", "[", "dat2", "]"}]}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<no sign change\>\"", "]"}], ";"}], 
            "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "dat2", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"x0", "=", 
      RowBox[{"stoptime", "-", "1", "+", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{"-", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"stoptime", "-", "1"}], "]"}], "]"}]}], ")"}], 
        RowBox[{
         RowBox[{"dat2", "[", 
          RowBox[{"[", "stoptime", "]"}], "]"}], "-", 
         RowBox[{"dat2", "[", 
          RowBox[{"[", 
           RowBox[{"stoptime", "-", "1"}], "]"}], "]"}]}]]}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FindCrossingDual", "[", "dat_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dat2", "=", 
        RowBox[{"dat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "s", ",", 
       "stoptime", ",", "xleft", ",", "xright"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{"dat2", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], "]"}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "s"}], "<", "0"}], ",", 
          RowBox[{
           RowBox[{"stoptime", "=", "i"}], ";", 
           RowBox[{"Break", "[", "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "2"}], ",", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "Print", "[", "\"\<soliton at chain left end\>\"", "]"}], ";"}],
              "*)"}], 
            RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{
           RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
        RowBox[{"xleft", "=", "stoptime"}], ",", 
        RowBox[{"xleft", "=", 
         RowBox[{"stoptime", "+", "1", "-", 
          FractionBox[
           RowBox[{"Abs", "[", 
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}], 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}]}]]}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"s", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{"dat2", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], "+", "1"}], 
          "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"stoptime", "=", 
       RowBox[{
        RowBox[{"Length", "[", "dat2", "]"}], "-", "1", "+", "0.01"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "s"}], "<", "0"}], ",", 
          RowBox[{
           RowBox[{"stoptime", "=", "i"}], ";", 
           RowBox[{"Break", "[", "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{
              RowBox[{"Length", "[", "dat2", "]"}], "-", "1"}]}], ",", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "Print", "[", "\"\<Solition at chain right end\>\"", "]"}], 
              ";"}], "*)"}], 
            RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], "+", "1"}], ",", 
          RowBox[{
           RowBox[{"Length", "[", "dat2", "]"}], "-", "1"}]}], "}"}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"stoptime", "==", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "-", "1", "+", "0.01"}]}], 
        ",", 
        RowBox[{"xright", "=", "stoptime"}], ",", 
        RowBox[{"xright", "=", 
         RowBox[{"stoptime", "-", "1", "+", 
          FractionBox[
           RowBox[{"Abs", "[", 
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"stoptime", "-", "1"}], "]"}], "]"}], "]"}], 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"stoptime", "-", "1"}], "]"}], "]"}], "]"}]}]]}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"xleft", ",", "xright"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Always", " ", "assume", " ", "the", " ", "defect", " ", "is", " ", "in", 
    " ", "the", " ", 
    RowBox[{"middle", ":", " ", 
     RowBox[{"using", " ", 
      RowBox[{
       RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}]}]}]}], 
   "\[IndentingNewLine]", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindCrossingDual2", "[", 
    RowBox[{"dat_", ",", "thetapos_", ",", "thetaneg_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dat2", "=", 
        RowBox[{"dat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "stoptime", ",", 
       "sleft", ",", "sright", ",", "xleft", ",", "xright", ",", "thetamid"}],
       "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"thetamid", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"thetapos", "+", "thetaneg"}], ")"}], "/", "2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sleft", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", 
            RowBox[{"\[Pi]", "/", "2"}]}], ",", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", 
            RowBox[{"2", "\[Pi]"}]}]}], "]"}], "-", "thetamid"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"sright", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{
         RowBox[{"-", "thetamid"}], "-", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}], ">", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2"}]}], ",", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}], "+", 
            RowBox[{"2", "\[Pi]"}]}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ">", "0"}], ",", 
          RowBox[{
           RowBox[{"stoptime", "=", "i"}], ";", 
           RowBox[{"Break", "[", "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "2"}], ",", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "Print", "[", "\"\<soliton at chain left end\>\"", "]"}], ";"}],
              "*)"}], 
            RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{
           RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
        RowBox[{"xleft", "=", 
         RowBox[{"4", 
          RowBox[{"Abs", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"dat2", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
            
            RowBox[{"Abs", "[", 
             RowBox[{"thetapos", "-", "thetaneg"}], "]"}]}], "]"}]}]}], ",", 
        RowBox[{"xleft", "=", 
         RowBox[{"stoptime", "+", "1", "-", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"dat2", "[", 
               RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
             RowBox[{"Abs", "[", 
              RowBox[{"dat2", "[", 
               RowBox[{"[", 
                RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}]}], 
            ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "i"}], "]"}], "]"}], "<", "0"}], ",", 
          RowBox[{
           RowBox[{"stoptime", "=", "i"}], ";", 
           RowBox[{"Break", "[", "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "2"}], ",", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "Print", "[", "\"\<Solition at chain right end\>\"", "]"}], 
              ";"}], "*)"}], 
            RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{
           RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
        RowBox[{"xright", "=", 
         RowBox[{"4", 
          RowBox[{"Abs", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"dat2", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
            "/", 
            RowBox[{"Abs", "[", 
             RowBox[{"thetapos", "-", "thetaneg"}], "]"}]}], "]"}]}]}], ",", 
        RowBox[{"xright", "=", 
         RowBox[{"stoptime", "+", "1", "-", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}], 
           "/", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"dat2", "[", 
               RowBox[{"[", 
                RowBox[{"-", "stoptime"}], "]"}], "]"}], "]"}], "+", 
             RowBox[{"Abs", "[", 
              RowBox[{"dat2", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}]}],
             ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"sleft", "*", "xleft"}], ",", 
        RowBox[{"sright", "*", "xright"}]}], "}"}]}]}], "\[IndentingNewLine]",
     "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FindCrossingDual3", "[", 
   RowBox[{"dat_", ",", "thetapos_", ",", "thetaneg_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dat2", "=", 
       RowBox[{"dat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "stoptime", ",", 
      "sleft", ",", "sright", ",", "xleft", ",", "xright", ",", "thetamid"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetamid", ":=", 
      RowBox[{"-", 
       RowBox[{"ArcSin", "[", 
        FractionBox[
         RowBox[{
          SuperscriptBox["a", "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], "2"], "-", 
          SuperscriptBox["r", "2"]}], 
         RowBox[{"2", "a", " ", 
          RowBox[{"(", 
           RowBox[{"lzero", "-", "r"}], ")"}]}]], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sleft", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", 
           RowBox[{"\[Pi]", "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "-", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}], "-", "thetamid"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"sright", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"-", "thetamid"}], "-", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], ">", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "1"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], "+", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ">", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<soliton at chain left end\>\"", "]"}],
              ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", "\[IndentingNewLine]", 
       RowBox[{"xleft", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ">", "0"}], 
          ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"xleft", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"stoptime", "\[Equal]", 
            RowBox[{
             RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"1", "-", 
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"ArcTanh", "[", 
               FractionBox[
                RowBox[{" ", 
                 RowBox[{"Sin", "@", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"dat2", "[", 
                    RowBox[{"[", "stoptime", "]"}], "]"}], "<", 
                    RowBox[{"th0", "-", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "15"}]]}]}], ",", 
                    RowBox[{
                    "dat2", "\[LeftDoubleBracket]", "stoptime", 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"th0", "-", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "15"}]]}]}], "]"}]}]}], 
                RowBox[{"Sin", "@", "th0"}]], "]"}], " ", 
              FractionBox[
               SuperscriptBox["a", "2"], 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "@", "th0"}]}]]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"dat2", "[", 
                RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}]}], 
             ")"}]}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "i"}], "]"}], "]"}], "<", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "Print", "[", "\"\<Solition at chain right end\>\"", "]"}], 
             ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", "\[IndentingNewLine]", 
       RowBox[{"xright", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], "<", "0"}],
           ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"xright", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"stoptime", "==", 
            RowBox[{
             RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"1", "-", 
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"ArcTanh", "[", 
               FractionBox[
                RowBox[{" ", 
                 RowBox[{"Sin", "@", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"dat2", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "stoptime"}], "]"}], "]"}]}], "<", 
                    RowBox[{"th0", "-", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "15"}]]}]}], ",", 
                    RowBox[{"-", 
                    RowBox[{"dat2", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "stoptime"}], "\[RightDoubleBracket]"}]}], 
                    ",", 
                    RowBox[{"th0", "-", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "15"}]]}]}], "]"}]}]}], 
                RowBox[{"Sin", "@", "th0"}]], "]"}], " ", 
              FractionBox[
               SuperscriptBox["a", "2"], 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "@", "th0"}]}]]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}], 
            "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "stoptime"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], 
               "]"}]}], ")"}]}]}], "]"}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"sleft", "*", "xleft"}], ",", 
       RowBox[{"sright", "*", "xright"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FindCrossingDual3Original", "[", 
   RowBox[{"dat_", ",", "thetapos_", ",", "thetaneg_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dat2", "=", 
       RowBox[{"dat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "stoptime", ",", 
      "sleft", ",", "sright", ",", "xleft", ",", "xright", ",", "thetamid"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetamid", ":=", 
      RowBox[{"-", 
       RowBox[{"ArcSin", "[", 
        FractionBox[
         RowBox[{
          SuperscriptBox["a", "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], "2"], "-", 
          SuperscriptBox["r", "2"]}], 
         RowBox[{"2", "a", " ", 
          RowBox[{"(", 
           RowBox[{"lzero", "-", "r"}], ")"}]}]], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sleft", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", 
           RowBox[{"\[Pi]", "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "-", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}], "-", "thetamid"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"sright", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"-", "thetamid"}], "-", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], ">", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "1"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], "+", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ">", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<soliton at chain left end\>\"", "]"}],
              ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
       RowBox[{"xleft", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ">", "0"}], 
          ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"xleft", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}]}], 
           ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "i"}], "]"}], "]"}], "<", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "Print", "[", "\"\<Solition at chain right end\>\"", "]"}], 
             ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
       RowBox[{"xright", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], "<", "0"}],
           ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"xright", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"-", "stoptime"}], "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}]}], 
           ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"sleft", "*", "xleft"}], ",", 
       RowBox[{"sright", "*", "xright"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FindCrossing", "[", 
   RowBox[{"dat_", ",", "thetapos_", ",", "thetaneg_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dat2", "=", 
       RowBox[{"dat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", "stoptime", ",", 
      "sleft", ",", "sright", ",", "xleft", ",", "xright", ",", "thetamid"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetamid", ":=", 
      RowBox[{"-", 
       RowBox[{"ArcSin", "[", 
        FractionBox[
         RowBox[{
          SuperscriptBox["a", "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], "2"], "-", 
          SuperscriptBox["r", "2"]}], 
         RowBox[{"2", "a", " ", 
          RowBox[{"(", 
           RowBox[{"lzero", "-", "r"}], ")"}]}]], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sleft", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", 
           RowBox[{"\[Pi]", "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "-", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}], "-", "thetamid"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"sright", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"-", "thetamid"}], "-", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], ">", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "/", "2"}]}], ",", 
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "1"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], "+", 
           RowBox[{"2", "\[Pi]"}]}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ">", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<soliton at chain left end\>\"", "]"}],
              ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "dat2", "]"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
       RowBox[{"xleft", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ">", "0"}], 
          ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "-", "thetamid"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"xleft", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", "stoptime", "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"stoptime", "+", "1"}], "]"}], "]"}], "]"}]}], 
           ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"stoptime", "=", "1.99"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dat2", "[", 
           RowBox[{"[", 
            RowBox[{"-", "i"}], "]"}], "]"}], "<", "0"}], ",", 
         RowBox[{
          RowBox[{"stoptime", "=", "i"}], ";", 
          RowBox[{"Break", "[", "]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "2"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "Print", "[", "\"\<Solition at chain right end\>\"", "]"}], 
             ";"}], "*)"}], 
           RowBox[{"Return", "[", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "dat2", "]"}], "/", "2"}], ",", "2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"stoptime", "\[Equal]", "1.99"}], ",", 
       RowBox[{"xright", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dat2", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], "<", "0"}],
           ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetapos", "-", "thetamid"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"dat2", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "+", "thetamid"}], ")"}], 
             "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"thetaneg", "-", "thetamid"}], "]"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"xright", "=", 
        RowBox[{"stoptime", "+", "1", "-", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"dat2", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{"-", "stoptime"}], "]"}], "]"}], "]"}], "+", 
            RowBox[{"Abs", "[", 
             RowBox[{"dat2", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "stoptime"}], "-", "1"}], "]"}], "]"}], "]"}]}], 
           ")"}]}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"sleft", ",", "sright", ",", "xleft"}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pe", "[", 
   RowBox[{
   "a_", ",", "r_", ",", "l_", ",", "\[Theta]_", ",", "\[Phi]_", ",", "i_"}], 
   "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"kk", "[", "i", "]"}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "+", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Cos", "[", "\[Theta]", "]"}], "+", " ", 
              RowBox[{"Cos", "[", "\[Phi]", "]"}]}], ")"}]}], ")"}], "2"]}], 
        ")"}], 
       FractionBox["1", "2"]], "-", "l"}], ")"}], "2"]}]}]}], "Input",
 CellChangeTimes->{{3.618150538987588*^9, 3.618150547169888*^9}, {
   3.618150779637478*^9, 3.618150832279482*^9}, {3.618150932245859*^9, 
   3.61815097596342*^9}, {3.61815104373564*^9, 3.618151060436997*^9}, {
   3.6181514145632267`*^9, 3.618151414954941*^9}, {3.618151484123447*^9, 
   3.618151515046277*^9}, {3.6182271607461357`*^9, 3.618227216472021*^9}, {
   3.618227265295611*^9, 3.618227265849666*^9}, {3.6182280764987803`*^9, 
   3.618228081401866*^9}, {3.618228113923439*^9, 3.6182281193606577`*^9}, {
   3.6182281803271503`*^9, 3.618228249300583*^9}, {3.618228342726098*^9, 
   3.6182283435898247`*^9}, {3.6182284741107187`*^9, 3.618228474241713*^9}, 
   3.6182285734116287`*^9, {3.618228654639407*^9, 3.618228654745113*^9}, {
   3.61856261599337*^9, 3.6185626195306787`*^9}, {3.618571365841371*^9, 
   3.618571367549428*^9}, 3.618571418811494*^9, {3.618571448846992*^9, 
   3.618571493234602*^9}, {3.618571575841247*^9, 3.618571903339575*^9}, {
   3.6185721369645777`*^9, 3.618572148227907*^9}, {3.618647114038393*^9, 
   3.618647116731336*^9}, {3.618647324321237*^9, 3.6186473466247187`*^9}, {
   3.618647817599999*^9, 3.61864786323519*^9}, {3.6186480056050034`*^9, 
   3.6186480077363033`*^9}, {3.618648068705531*^9, 3.618648083755763*^9}, {
   3.618648195170536*^9, 3.61864821051621*^9}, {3.618649157248595*^9, 
   3.618649157976111*^9}, {3.6186497991829357`*^9, 3.618649819780326*^9}, 
   3.6187569485390368`*^9, 3.6187573278434277`*^9, 3.618834677692775*^9, {
   3.623069441682617*^9, 3.623069467916896*^9}, {3.623070045627194*^9, 
   3.623070061087813*^9}, {3.6230700971705437`*^9, 3.6230701673260717`*^9}, {
   3.623073904287218*^9, 3.6230739099103003`*^9}, {3.624289365803486*^9, 
   3.6242894417539053`*^9}, {3.6242895136375647`*^9, 3.624289513945546*^9}, 
   3.624289963925722*^9, {3.624290040568718*^9, 3.624290053264291*^9}, {
   3.624292193400117*^9, 3.624292198593955*^9}, {3.624294596977466*^9, 
   3.624294720195092*^9}, {3.6242948237127447`*^9, 3.624294932608865*^9}, {
   3.624294963984165*^9, 3.62429522657948*^9}, {3.624295272703333*^9, 
   3.6242952830205793`*^9}, 3.633074870875313*^9, {3.633088325821828*^9, 
   3.63308833085747*^9}, {3.633088368404194*^9, 3.6330883906255293`*^9}, {
   3.633088573539197*^9, 3.633088624563891*^9}, {3.633088659921361*^9, 
   3.633088705283955*^9}, 3.633088800455364*^9, {3.633088864220337*^9, 
   3.6330888698302507`*^9}, 3.633088911091866*^9, {3.633089094481065*^9, 
   3.6330891003475533`*^9}, {3.633089161898232*^9, 3.633089193065423*^9}, {
   3.63308923233589*^9, 3.63308929830764*^9}, 3.633089333216228*^9, {
   3.633100412976595*^9, 3.633100463898243*^9}, {3.633100519029953*^9, 
   3.633100526529237*^9}, {3.633101299955513*^9, 3.633101300392415*^9}, {
   3.6331018137843447`*^9, 3.633101813958029*^9}, {3.633101871660501*^9, 
   3.6331018719629183`*^9}, {3.633101917846643*^9, 3.633101943701149*^9}, {
   3.633102027415921*^9, 3.633102028840218*^9}, {3.633102120427668*^9, 
   3.633102121123929*^9}, 3.633102232639926*^9, {3.64094746299193*^9, 
   3.640947463364471*^9}, {3.640947564495137*^9, 3.6409475741238813`*^9}, 
   3.640951379758491*^9, {3.6452727825849333`*^9, 3.645272822920856*^9}, {
   3.645272878021719*^9, 3.6452728802936974`*^9}, {3.645273004698082*^9, 
   3.645273010602849*^9}, {3.645273984643609*^9, 3.645274078303241*^9}, 
   3.645274148630378*^9, {3.645274773844715*^9, 3.645274837966695*^9}, 
   3.645274869770154*^9, {3.645274902136812*^9, 3.645274959583123*^9}, {
   3.645274998605528*^9, 3.64527503187894*^9}, {3.645275067538681*^9, 
   3.64527507619352*^9}, {3.645275250296976*^9, 3.645275294734951*^9}, {
   3.645275589488284*^9, 3.645275652785528*^9}, {3.645275882975909*^9, 
   3.645275909678774*^9}, {3.645275970406087*^9, 3.64527605790648*^9}, {
   3.645276111268532*^9, 3.645276201812639*^9}, {3.645276267475964*^9, 
   3.645276326590911*^9}, {3.645276392976386*^9, 3.645276436943709*^9}, {
   3.64527646846441*^9, 3.645276506374337*^9}, {3.6452765640552883`*^9, 
   3.645276565912219*^9}, {3.6452773561520348`*^9, 3.645277368666152*^9}, {
   3.646400497002018*^9, 3.6464004976593513`*^9}, {3.646400553551332*^9, 
   3.646400554073206*^9}, {3.64664062186617*^9, 3.646640637228178*^9}, 
   3.6466412045257053`*^9, {3.647175899283684*^9, 3.647176012386387*^9}, {
   3.647176148206756*^9, 3.647176163175846*^9}, 3.6477733675605497`*^9, {
   3.651387603949565*^9, 3.6513876048374166`*^9}, {3.651387691413843*^9, 
   3.651387701388337*^9}, {3.651387842571313*^9, 3.651387845902524*^9}, {
   3.651387970043507*^9, 3.6513879757588663`*^9}, {3.651390783531636*^9, 
   3.651390792802196*^9}, {3.651390902564404*^9, 3.651390921145104*^9}, {
   3.6513912138769073`*^9, 3.651391215610052*^9}, {3.651393119992619*^9, 
   3.651393133431178*^9}, {3.651393919139061*^9, 3.651393920072609*^9}, {
   3.651490944742693*^9, 3.651491017134418*^9}, 3.651559934192185*^9, {
   3.651560542279643*^9, 3.651560553850471*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Velocity and energy function", "Subsubsection",
 CellChangeTimes->{{3.639376519383624*^9, 3.639376524943553*^9}, {
   3.640431936960897*^9, 3.6404319405607967`*^9}, 3.646639710530096*^9, {
   3.646903320984642*^9, 3.646903331515069*^9}, 3.6469033761819267`*^9, 
   3.646904184461405*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lefttimeAt", "[", "pos_", "]"}], ":=", 
  RowBox[{"leftsolitab", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"leftsolitab", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{"x_", "/;", 
        RowBox[{"x", "<", "pos"}]}], ",", "1", ",", "1"}], "]"}], "]"}], ",", 
    "1"}], "\[RightDoubleBracket]"}]}], "\n", 
 RowBox[{
  RowBox[{"vleft", "[", 
   RowBox[{"pos1_", ",", "pos2_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"pos1", "-", "pos2"}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"lefttimeAt", "[", "pos2", "]"}], "-", 
     RowBox[{"lefttimeAt", "[", "pos1", "]"}]}], ")"}]}]}], "\n", 
 RowBox[{
  RowBox[{"rightIntimeAt", "[", "pos_", "]"}], ":=", 
  RowBox[{"rightsolitab", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"rightsolitab", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{"x_", "/;", 
        RowBox[{"x", ">", "pos"}]}], ",", "1", ",", "1"}], "]"}], "]"}], ",", 
    "1"}], "\[RightDoubleBracket]"}]}], "\n", 
 RowBox[{
  RowBox[{"vrightIn", "[", 
   RowBox[{"pos1_", ",", "pos2_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"pos2", "-", "pos1"}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rightIntimeAt", "[", "pos2", "]"}], "-", 
     RowBox[{"rightIntimeAt", "[", "pos1", "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rightOuttimeAt", "[", "pos_", "]"}], ":=", 
  RowBox[{"rightsolitab", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"rightsolitab", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"x_", "/;", 
         RowBox[{"x", ">", "pos"}]}], ",", "1", ",", "1"}], "]"}], "+", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"rightsolitab", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"Position", "[", 
                RowBox[{
                 RowBox[{"rightsolitab", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
                 RowBox[{"x_", "/;", 
                  RowBox[{"x", ">", "pos"}]}], ",", "1", ",", "1"}], "]"}], 
               "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "+", "1"}], ";;"}], ",", "2"}], 
          "]"}], "]"}], ",", 
        RowBox[{"x_", "/;", 
         RowBox[{"(", 
          RowBox[{"x", "<", "pos"}], ")"}]}], ",", "1", ",", "1"}], "]"}]}], 
     "]"}], ",", "1"}], "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrightOut", "[", 
   RowBox[{"pos1_", ",", "pos2_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"pos1", "-", "pos2"}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rightOuttimeAt", "[", "pos2", "]"}], "-", 
     RowBox[{"rightOuttimeAt", "[", "pos1", "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eright", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", 
      RowBox[{
       FractionBox["num", "2"], "+", "1"}]}], "num"], 
    RowBox[{
     FractionBox[
      RowBox[{"M", "[", "i", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"r", " ", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ans", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
         "]"}]}], ")"}], "2"]}]}], "/.", 
   RowBox[{"tt", "\[Rule]", "t"}]}]}], "\n", 
 RowBox[{
  RowBox[{"eleft", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", "1"}], 
     FractionBox["num", "2"]], 
    RowBox[{
     FractionBox[
      RowBox[{"M", "[", "i", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"r", " ", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ans", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
         "]"}]}], ")"}], "2"]}]}], "/.", 
   RowBox[{"tt", "\[Rule]", "t"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"espring", "[", 
   RowBox[{"t_", ",", "i_"}], "]"}], ":=", 
  RowBox[{
   FractionBox[
    RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "-", 
           RowBox[{"r", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Sin", "[", 
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], "-", 
              "  ", 
              RowBox[{"Sin", "[", 
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
               "]"}]}], ")"}]}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", " ", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{
               RowBox[{"ans", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], "-", 
             " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
               RowBox[{"ans", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
              "]"}]}], ")"}]}], ")"}], "2"]}], "]"}], "-", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", 
         SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], ")"}],
     "2"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"espringold", "[", "i_", "]"}], ":=", 
  RowBox[{
   FractionBox[
    RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "-", 
           RowBox[{"r", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{
               "initialold", "\[LeftDoubleBracket]", "i", 
                "\[RightDoubleBracket]"}], "]"}], "-", "  ", 
              RowBox[{"Cos", "[", 
               RowBox[{"initialold", "\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
             ")"}]}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", " ", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{
              "initialold", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}], "-", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"initialold", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            ")"}]}], ")"}], "2"]}], "]"}], "-", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", 
         SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], ")"}],
     "2"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"espringold2", "[", "i_", "]"}], ":=", 
  RowBox[{
   FractionBox[
    RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "-", 
           RowBox[{"r", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{
               "initialold", "\[LeftDoubleBracket]", "i", 
                "\[RightDoubleBracket]"}], "]"}], "-", "  ", 
              RowBox[{"Cos", "[", 
               RowBox[{"initialold", "\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
             ")"}]}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", " ", 
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{
              "initialold", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}], "-", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"initialold", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            ")"}]}], ")"}], "2"]}], "]"}], "-", 
      RowBox[{"Sqrt", "[", "lzerosq", "]"}]}], ")"}], 
    "2"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lconf", "[", 
   RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_", ",", 
    RowBox[{"a_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "-", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "+", 
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"width", ":=", 
  FractionBox[
   SuperscriptBox["a", "2"], 
   RowBox[{"2", "r", " ", 
    RowBox[{"Sin", "[", "th0", "]"}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"ClearAll", "[", "tht", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tht", "[", 
    RowBox[{"i_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{"\[Pi]", "-", 
        RowBox[{
         RowBox[{"ans", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
       RowBox[{"2", " ", "\[Pi]"}], ",", 
       RowBox[{"-", "\[Pi]"}]}], "]"}], ",", 
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ans", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
       RowBox[{"2", " ", "\[Pi]"}], ",", 
       RowBox[{"-", "\[Pi]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fbond", "[", 
   RowBox[{"n_", ",", "x_", ",", 
    RowBox[{"th0_:", "th0"}], ",", 
    RowBox[{"a_:", "a"}], ",", 
    RowBox[{"r_:", "r"}]}], "]"}], ":=", 
  RowBox[{"16", " ", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r", " ", 
       RowBox[{"Sin", "[", "th0", "]"}]}], ")"}], "4"], "/", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"Sech", "[", 
     FractionBox[
      RowBox[{
       RowBox[{"n", " ", "a"}], " ", "-", "x"}], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["a", "2"], "/", 
        RowBox[{"(", 
         RowBox[{"2", " ", "r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}], ")"}]], "]"}], "4"], 
   " ", 
   RowBox[{"(*", 
    RowBox[{"divided", " ", 
     RowBox[{"1", "/", "2"}], " ", "k", " ", "already"}], 
    "*)"}]}]}]}], "Input",
 CellChangeTimes->{{3.639375604587484*^9, 3.639375629119108*^9}, {
   3.639375703934767*^9, 3.639375759553006*^9}, {3.6393757987053127`*^9, 
   3.639375830736499*^9}, {3.639376629781764*^9, 3.6393766318130713`*^9}, 
   3.639399348122182*^9, {3.640427158345471*^9, 3.6404271648678417`*^9}, {
   3.64103441813673*^9, 3.641034460985071*^9}, {3.646400558119089*^9, 
   3.646400566826592*^9}, {3.646640612252253*^9, 3.646640616173869*^9}, {
   3.650207643764222*^9, 3.6502076447394867`*^9}, {3.651835932879539*^9, 
   3.651835937695834*^9}, {3.6518360032513657`*^9, 3.651836105476632*^9}, {
   3.658488756948163*^9, 3.6584887572679653`*^9}, {3.658492447212039*^9, 
   3.658492464522808*^9}, {3.658494335256815*^9, 3.658494360680788*^9}, {
   3.6682539909862013`*^9, 3.668253991308889*^9}, {3.668338350480555*^9, 
   3.668338350773258*^9}, {3.678450482934205*^9, 3.678450494919376*^9}, {
   3.6784505430154533`*^9, 3.6784505552233953`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["configuration parameters", "Subsubsection",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, {
   3.633107849053135*^9, 3.633107856688933*^9}, 3.643794417833037*^9, 
   3.6452693052181473`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{
      RowBox[{"N", "[", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"a", "/", 
         RowBox[{"(", 
          RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.1"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ldef", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<ldef_critical=\>\"", ",", 
    RowBox[{"ldefcritical", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"2", " ", "r", " ", 
            RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "2"], "+", 
        RowBox[{"4", 
         SuperscriptBox["r", "2"], 
         SuperscriptBox[
          RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ldeftest", "=", "lzero"}], ";"}], "\n", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"th", "[", "num", "]"}], "=", 
    RowBox[{"thinit", "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"h", ":=", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], 
           RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
         RowBox[{
          RowBox[{
           SqrtBox[
            RowBox[{
             SuperscriptBox["r", "2"], "-", 
             SuperscriptBox["h", "2"]}]], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"lzero", "-", "r"}], ")"}], 
            RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], ",",
         "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
      "\[RightDoubleBracket]"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numdef", "=", 
    RowBox[{
     RowBox[{"IntegerPart", "[", 
      RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
    " ", "defect", " ", "spring", " ", "is"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numx", "=", 
    RowBox[{"IntegerPart", "[", 
     RowBox[{"num", "/", "2"}], "]"}]}], " ", ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
    "starts"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"th", "[", "numx", "]"}], "=", "0."}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "-", "1"}]}], ",", 
    RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
    RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaright", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "+", "1"}]}], ",", 
    RowBox[{"i", "\[LessEqual]", "num"}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaleft", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaright", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaright", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initial", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"True", ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "+", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"initialold", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Pi]", "/", "2"}], "-", 
       RowBox[{"initial", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wsol", "=", 
   FractionBox[
    SuperscriptBox["a", "2"], 
    RowBox[{"2", "r", " ", 
     RowBox[{"Sin", "[", "th0", "]"}]}]]}], ";"}]}], "Input",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, 
   3.633107849053135*^9, 3.640431453500654*^9, {3.64051900108724*^9, 
   3.640519032020152*^9}, 3.640519091131611*^9, {3.640519133617816*^9, 
   3.640519141505741*^9}, {3.640954072866503*^9, 3.6409540747819967`*^9}, {
   3.641909159215695*^9, 3.641909159525496*^9}, 3.641912707881154*^9, 
   3.641917750582572*^9, {3.6419178971559*^9, 3.6419178996323137`*^9}, {
   3.641917958539505*^9, 3.64191796617002*^9}, {3.641918356310309*^9, 
   3.641918379507525*^9}, {3.6419189956698933`*^9, 3.6419189991983833`*^9}, {
   3.641919048197426*^9, 3.641919124621357*^9}, {3.641919197938994*^9, 
   3.641919199487707*^9}, {3.641922766846982*^9, 3.641922804886376*^9}, {
   3.646104424310775*^9, 3.646104442671603*^9}, {3.646104587111969*^9, 
   3.6461046159606256`*^9}, {3.6461046716573467`*^9, 3.646104711473505*^9}, {
   3.646104747902801*^9, 3.646104770938389*^9}, {3.646105039927987*^9, 
   3.6461050526437807`*^9}, {3.646105241779292*^9, 3.64610524828834*^9}, 
   3.64657454254104*^9, 3.646574926373436*^9, {3.646575156952662*^9, 
   3.646575211778639*^9}, {3.6465752734950867`*^9, 3.646575299836241*^9}, {
   3.646575392760343*^9, 3.6465753946374187`*^9}, {3.646575428315222*^9, 
   3.646575441770688*^9}, {3.646575609117782*^9, 3.646575615181638*^9}, 
   3.6465765989702463`*^9, {3.6465768466645*^9, 3.646576865245425*^9}, {
   3.6465769577152767`*^9, 3.646576964901911*^9}, {3.646577054378533*^9, 
   3.646577073452345*^9}, 3.6465777468589687`*^9, {3.646577904437048*^9, 
   3.646578000197854*^9}, {3.6465782033019648`*^9, 3.646578211875195*^9}, {
   3.646578259584546*^9, 3.646578286691248*^9}, 3.646578338599728*^9, 
   3.646579236372817*^9, {3.646579298451799*^9, 3.646579298688532*^9}, 
   3.646579513818447*^9, {3.6466390153689423`*^9, 3.646639018163767*^9}, {
   3.6466390998376513`*^9, 3.646639142690577*^9}, {3.64663918754981*^9, 
   3.64663921854774*^9}, {3.646639252383985*^9, 3.646639260834017*^9}, {
   3.646639293869635*^9, 3.646639440141055*^9}, {3.646639716119461*^9, 
   3.6466397238122263`*^9}, {3.646639842015164*^9, 3.64663985218678*^9}, {
   3.6466399508603*^9, 3.646639953754033*^9}, 3.646640036683301*^9, {
   3.646640131679122*^9, 3.646640136174921*^9}, {3.64664223331671*^9, 
   3.6466422986313667`*^9}, 3.646643708276936*^9, {3.646647242328764*^9, 
   3.646647242451543*^9}, {3.6466475237143173`*^9, 3.6466475238777514`*^9}, 
   3.646907468331355*^9, {3.646907716530814*^9, 3.6469077165737762`*^9}, {
   3.647843279540071*^9, 3.647843303685266*^9}, {3.6478438299757433`*^9, 
   3.647843832321661*^9}, 3.647843902752071*^9, {3.647843971144924*^9, 
   3.647843973606101*^9}, 3.647844160902772*^9, {3.647844232216487*^9, 
   3.6478442561524982`*^9}, {3.64784429670004*^9, 3.647844382648075*^9}, {
   3.647850348894267*^9, 3.647850390139988*^9}, 3.647850563797996*^9, 
   3.6478533800149097`*^9, 3.647856461634306*^9, 3.6478617850774508`*^9, {
   3.647863035588881*^9, 3.647863035761806*^9}, 3.647863142117786*^9, {
   3.6478632038191357`*^9, 3.647863232935384*^9}, {3.647863371312625*^9, 
   3.647863378941893*^9}, 3.647863491869536*^9, 3.6478636880676622`*^9, {
   3.64786371904622*^9, 3.647863720018546*^9}, {3.647865122887711*^9, 
   3.647865123587791*^9}, {3.6489769382099*^9, 3.6489769387202272`*^9}, {
   3.649396849109943*^9, 3.649396860790847*^9}, {3.649596589582354*^9, 
   3.64959660282757*^9}, {3.656936323705352*^9, 3.656936342929282*^9}, {
   3.656936390778535*^9, 3.656936444828434*^9}, {3.657280930692526*^9, 
   3.657280930731408*^9}, 3.657281702774507*^9, {3.657282204242875*^9, 
   3.657282229444261*^9}, {3.657450754460813*^9, 3.657450763794889*^9}, {
   3.657621161697871*^9, 3.657621173793253*^9}, {3.657621225125066*^9, 
   3.657621229027203*^9}, {3.6576212940552273`*^9, 3.6576212950762873`*^9}, {
   3.657621624653295*^9, 3.657621635084713*^9}, {3.6576217427855864`*^9, 
   3.6576217628839827`*^9}, {3.657622399620167*^9, 3.657622415936246*^9}, 
   3.657622558082868*^9, {3.657622755209448*^9, 3.657622757989699*^9}, {
   3.657622831599257*^9, 3.657622833630106*^9}, {3.657622978766416*^9, 
   3.65762299169058*^9}}],

Cell["kink run simu animation", "Text",
 CellChangeTimes->{{3.664030231244994*^9, 3.664030236844513*^9}, {
  3.6640302846860237`*^9, 3.6640302852446213`*^9}, {3.664105843059526*^9, 
  3.664105845510912*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", "\[Equal]", "1"}], "||", 
          RowBox[{"i", "==", "num"}]}], ",", "1.", ",", "1."}], "]"}]}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kpos", "=", "0.65"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"modenum", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0"}], ";"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, {3.650367826499136*^9, 3.650367851219644*^9}, {
   3.6503679372860622`*^9, 3.6503679756384087`*^9}, {3.65036809583464*^9, 
   3.650368096573086*^9}, {3.65036836843544*^9, 3.6503683691946993`*^9}, {
   3.65036929701457*^9, 3.6503692977331142`*^9}, {3.650369535195619*^9, 
   3.650369536018444*^9}, {3.6505300688521433`*^9, 3.6505300695586357`*^9}, {
   3.650546400520092*^9, 3.650546401432098*^9}, {3.6505465894377537`*^9, 
   3.650546589868441*^9}, {3.650646555599687*^9, 3.650646556591234*^9}, {
   3.6506468167904987`*^9, 3.650646817477148*^9}, {3.658753652709051*^9, 
   3.658753653684366*^9}, {3.6587538218658457`*^9, 3.658753822056353*^9}, {
   3.6640424962242413`*^9, 3.664042496303115*^9}, 3.664042616055335*^9, 
   3.664042713205374*^9, {3.6640428853054867`*^9, 3.664042895465214*^9}}],

Cell[BoxData[
 RowBox[{"vAtablekinkmov1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tfinal", "=", 
      RowBox[{
       RowBox[{"3.", "/", "v0"}], "+", "3.5"}]}], ";", 
     RowBox[{"tinterval", "=", 
      RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"ldef", ",", 
      RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"v0", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"thnumx", ",", 
      RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"kkdef", ",", 
      RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Mdef", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.664042292588078*^9, 3.6640423081709347`*^9}, 
   3.664042924058928*^9, {3.6640912531328287`*^9, 3.664091256688162*^9}, 
   3.664091320447093*^9, 3.6641038055731153`*^9, {3.6641052661197157`*^9, 
   3.664105273254784*^9}, 3.664105707282063*^9}],

Cell[BoxData[
 RowBox[{"vAtablekinkmov1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tfinal", "=", 
      RowBox[{
       RowBox[{"3.", "/", "v0"}], "+", "50.5"}]}], ";", 
     RowBox[{"tinterval", "=", 
      RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"ldef", ",", 
      RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"v0", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"thnumx", ",", 
      RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"kkdef", ",", 
      RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Mdef", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.664042292588078*^9, 3.6640423081709347`*^9}, 
   3.664042924058928*^9, {3.6640912531328287`*^9, 3.664091256688162*^9}, 
   3.664091320447093*^9, 3.6641038055731153`*^9, {3.6641052661197157`*^9, 
   3.664105273254784*^9}, 3.664105707282063*^9, {3.678457840761606*^9, 
   3.678457843769828*^9}, {3.678457928829072*^9, 3.6784579300111303`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["configuration parameters anti kink", "Subsubsection",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, {
   3.633107849053135*^9, 3.633107856688933*^9}, 3.643794417833037*^9, 
   3.6452693052181473`*^9, {3.647865837474368*^9, 3.647865839957879*^9}}],

Cell["Just use the inverse function of 4 - bar linkage", "Text",
 CellChangeTimes->{{3.647856474522455*^9, 3.647856475087174*^9}, {
  3.6478658810938377`*^9, 3.647865938501302*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<th0=\>\"", ",", 
     RowBox[{"th0", "=", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"a", "/", 
          RowBox[{"(", 
           RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.1"}]}]}], "]"}],
    ";"}], 
  RowBox[{"(*", 
   RowBox[{"The", " ", "1", "st", " ", "angle", " ", "choice"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<th0=\>\"", ",", 
      RowBox[{"th0", "=", 
       RowBox[{
        RowBox[{"N", "[", 
         RowBox[{"ArcSin", "[", 
          RowBox[{"a", "/", 
           RowBox[{"(", 
            RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.6"}]}]}], 
     "]"}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ldef", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<ldef_critical=\>\"", ",", 
      RowBox[{"ldefcritical", "=", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"2", " ", "r", " ", 
              RowBox[{"Abs", "@", 
               RowBox[{"Sin", "[", 
                RowBox[{"th", "[", 
                 RowBox[{"numdef", "+", "1"}], "]"}], "]"}]}]}]}], ")"}], 
           "2"], "+", 
          RowBox[{"4", 
           SuperscriptBox["r", "2"], 
           SuperscriptBox[
            RowBox[{"Cos", "[", 
             RowBox[{"th", "[", 
              RowBox[{"numdef", "+", "1"}], "]"}], "]"}], "2"]}]}], ")"}], 
        RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ldeftest", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"th", "[", "16", "]"}], "=", 
    RowBox[{"thinit", "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"h", ":=", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], 
           RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
         RowBox[{
          RowBox[{
           SqrtBox[
            RowBox[{
             SuperscriptBox["r", "2"], "-", 
             SuperscriptBox["h", "2"]}]], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"lzero", "-", "r"}], ")"}], 
            RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], ",",
         "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
      "\[RightDoubleBracket]"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numdef", "=", 
    RowBox[{
     RowBox[{"IntegerPart", "[", 
      RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
    " ", "defect", " ", "spring", " ", "is"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numx", "=", 
    RowBox[{"IntegerPart", "[", 
     RowBox[{"num", "/", "2"}], "]"}]}], "  ", ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
    "starts"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"th", "[", "numx", "]"}], "=", 
    RowBox[{"thmidx", "/.", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", "thmidx", "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", "thmidx", "]"}]}], "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"]}], "\[Equal]", 
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         RowBox[{"4", 
          SuperscriptBox["r", "2"], 
          SuperscriptBox[
           RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
       "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"thmidx", ",", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "numx", "]"}], "=", 
     RowBox[{"-", "0.238969"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"for", " ", "th0"}], "=", 
     RowBox[{"0.575", ".."}]}], "*)"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"th", "[", "numx", "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "-", "1"}]}], ",", 
    RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
    RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaleft", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaright", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaright", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "+", "1"}]}], ",", 
    RowBox[{"i", "\[LessEqual]", "num"}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaright", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1", "+", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Quiet", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "num", "]"}], "=", 
     RowBox[{"thinit", "/.", 
      RowBox[{
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"h", ":=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"lzero", "-", "r"}], ")"}], 
            RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
          RowBox[{
           RowBox[{
            SqrtBox[
             RowBox[{
              SuperscriptBox["r", "2"], "-", 
              SuperscriptBox["h", "2"]}]], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"lzero", "-", "r"}], ")"}], 
             RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
         ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"th", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"-", "thinit"}], "/.", 
      RowBox[{
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"h", ":=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"lzero", "-", "r"}], ")"}], 
            RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
          RowBox[{
           RowBox[{
            SqrtBox[
             RowBox[{
              SuperscriptBox["r", "2"], "-", 
              SuperscriptBox["h", "2"]}]], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"lzero", "-", "r"}], ")"}], 
             RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
         ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}]}]}], ";"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initial", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"True", ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "+", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"initialold", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Pi]", "/", "2"}], "-", 
       RowBox[{"initial", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wsol", "=", 
   FractionBox[
    SuperscriptBox["a", "2"], 
    RowBox[{"2", "r", " ", 
     RowBox[{"Sin", "[", "th0", "]"}]}]]}], ";"}]}], "Input",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, 
   3.633107849053135*^9, 3.640431453500654*^9, {3.64051900108724*^9, 
   3.640519032020152*^9}, 3.640519091131611*^9, {3.640519133617816*^9, 
   3.640519141505741*^9}, {3.640954072866503*^9, 3.6409540747819967`*^9}, {
   3.641909159215695*^9, 3.641909159525496*^9}, 3.641912707881154*^9, 
   3.641917750582572*^9, {3.6419178971559*^9, 3.6419178996323137`*^9}, {
   3.641917958539505*^9, 3.64191796617002*^9}, {3.641918356310309*^9, 
   3.641918379507525*^9}, {3.6419189956698933`*^9, 3.6419189991983833`*^9}, {
   3.641919048197426*^9, 3.641919124621357*^9}, {3.641919197938994*^9, 
   3.641919199487707*^9}, {3.641922766846982*^9, 3.641922804886376*^9}, {
   3.646104424310775*^9, 3.646104442671603*^9}, {3.646104587111969*^9, 
   3.6461046159606256`*^9}, {3.6461046716573467`*^9, 3.646104711473505*^9}, {
   3.646104747902801*^9, 3.646104770938389*^9}, {3.646105039927987*^9, 
   3.6461050526437807`*^9}, {3.646105241779292*^9, 3.64610524828834*^9}, 
   3.64657454254104*^9, 3.646574926373436*^9, {3.646575156952662*^9, 
   3.646575211778639*^9}, {3.6465752734950867`*^9, 3.646575299836241*^9}, {
   3.646575392760343*^9, 3.6465753946374187`*^9}, {3.646575428315222*^9, 
   3.646575441770688*^9}, {3.646575609117782*^9, 3.646575615181638*^9}, 
   3.6465765989702463`*^9, {3.6465768466645*^9, 3.646576865245425*^9}, {
   3.6465769577152767`*^9, 3.646576964901911*^9}, {3.646577054378533*^9, 
   3.646577073452345*^9}, 3.6465777468589687`*^9, {3.646577904437048*^9, 
   3.646578000197854*^9}, {3.6465782033019648`*^9, 3.646578211875195*^9}, {
   3.646578259584546*^9, 3.646578286691248*^9}, 3.646578338599728*^9, 
   3.646579236372817*^9, {3.646579298451799*^9, 3.646579298688532*^9}, 
   3.646579513818447*^9, {3.6466390153689423`*^9, 3.646639018163767*^9}, {
   3.6466390998376513`*^9, 3.646639142690577*^9}, {3.64663918754981*^9, 
   3.64663921854774*^9}, {3.646639252383985*^9, 3.646639260834017*^9}, {
   3.646639293869635*^9, 3.646639440141055*^9}, {3.646639716119461*^9, 
   3.6466397238122263`*^9}, {3.646639842015164*^9, 3.64663985218678*^9}, {
   3.6466399508603*^9, 3.646639953754033*^9}, 3.646640036683301*^9, {
   3.646640131679122*^9, 3.646640136174921*^9}, {3.64664223331671*^9, 
   3.6466422986313667`*^9}, 3.646643708276936*^9, {3.646647242328764*^9, 
   3.646647242451543*^9}, {3.6466475237143173`*^9, 3.6466475238777514`*^9}, 
   3.646907468331355*^9, {3.646907716530814*^9, 3.6469077165737762`*^9}, {
   3.647843279540071*^9, 3.647843303685266*^9}, {3.6478438299757433`*^9, 
   3.647843832321661*^9}, 3.647843902752071*^9, {3.647843971144924*^9, 
   3.647843973606101*^9}, 3.647844160902772*^9, {3.647844232216487*^9, 
   3.6478442561524982`*^9}, {3.64784429670004*^9, 3.647844382648075*^9}, {
   3.647850348894267*^9, 3.647850390139988*^9}, 3.647850563797996*^9, 
   3.6478533800149097`*^9, 3.647856461634306*^9, 3.6478617850774508`*^9, {
   3.647863035588881*^9, 3.647863035761806*^9}, 3.647863142117786*^9, {
   3.6478632038191357`*^9, 3.647863232935384*^9}, {3.647863371312625*^9, 
   3.647863378941893*^9}, 3.647863491869536*^9, 3.6478636880676622`*^9, {
   3.64786371904622*^9, 3.647863720018546*^9}, {3.647865122887711*^9, 
   3.647865123587791*^9}, {3.647865446588835*^9, 3.64786544738625*^9}, {
   3.647865515871541*^9, 3.647865552621176*^9}, {3.6478655975247183`*^9, 
   3.647865597611209*^9}, {3.6478656591403627`*^9, 3.64786566054836*^9}, 
   3.647865704055502*^9, {3.64786637850098*^9, 3.647866380803048*^9}, 
   3.647866497127502*^9, 3.647866574882429*^9, {3.647866608414258*^9, 
   3.647866608599741*^9}, {3.647866866606606*^9, 3.647866867021512*^9}, {
   3.647867063798667*^9, 3.6478670670433807`*^9}, {3.647867155280249*^9, 
   3.647867183049902*^9}, 3.647867446593346*^9, {3.6478675697326527`*^9, 
   3.647867569841147*^9}, 3.6478676214125566`*^9, 3.647867877160533*^9, {
   3.647868067742684*^9, 3.64786806935541*^9}, 3.647868144445256*^9, {
   3.6478682106778917`*^9, 3.647868212035141*^9}, {3.648976721650756*^9, 
   3.6489767246412363`*^9}, {3.648976943265038*^9, 3.648976943649185*^9}, {
   3.649075992470459*^9, 3.649075997237792*^9}, {3.649076500567992*^9, 
   3.649076502192602*^9}, {3.649171870374464*^9, 3.64917187583945*^9}, {
   3.64917197677919*^9, 3.6491719987659683`*^9}, 3.6491724590924788`*^9, {
   3.6491729999705772`*^9, 3.649173014993458*^9}, {3.649396871957219*^9, 
   3.6493968770958567`*^9}, {3.651921189728344*^9, 3.6519212198966293`*^9}, {
   3.651927362944475*^9, 3.651927375023594*^9}, 3.6564062669371853`*^9, {
   3.656406451789065*^9, 3.656406457516768*^9}, 3.656406589608224*^9, 
   3.656406663711671*^9, 3.6564101567611*^9, 3.656412335338065*^9, 
   3.6564125714716663`*^9, 3.656412801876087*^9, 3.6566573873683453`*^9, {
   3.656935848348751*^9, 3.656935861118534*^9}, {3.6572838225203657`*^9, 
   3.6572838226241407`*^9}, {3.6576209956944857`*^9, 3.657620996082245*^9}, {
   3.6576210434720907`*^9, 3.657621053336095*^9}, {3.657621639724885*^9, 
   3.657621641741132*^9}, {3.657621775792904*^9, 3.657621802206545*^9}, {
   3.6576219861695967`*^9, 3.657622012157132*^9}, {3.657622129706727*^9, 
   3.657622145337562*^9}, {3.657622462626728*^9, 3.657622518425068*^9}, {
   3.6576230202559767`*^9, 3.657623062015273*^9}, 3.6576233464569817`*^9, {
   3.65762342063665*^9, 3.657623421241233*^9}, 3.657623598189003*^9, {
   3.657623659517655*^9, 3.657623675102*^9}, {3.657623709502474*^9, 
   3.657623738255693*^9}, {3.657623773394779*^9, 3.6576237971196136`*^9}, {
   3.657969558006403*^9, 3.657969574281332*^9}, {3.657969676363311*^9, 
   3.657969770412017*^9}, {3.657970356744315*^9, 3.65797035832295*^9}, {
   3.657970432332963*^9, 3.657970435168293*^9}, {3.6682537672753887`*^9, 
   3.668253782583117*^9}, {3.668340146220409*^9, 3.668340161165051*^9}, {
   3.668340250973672*^9, 3.668340260367218*^9}, {3.668340508406052*^9, 
   3.668340616793458*^9}, {3.66843695388198*^9, 3.66843696354951*^9}, 
   3.6684382034725857`*^9, 3.668439789055575*^9, {3.668440029673463*^9, 
   3.668440034576572*^9}, {3.668935621561748*^9, 3.668935621639969*^9}, {
   3.668935699341648*^9, 3.6689357063959007`*^9}, 3.674817924946918*^9, {
   3.6748185569793453`*^9, 3.674818569337915*^9}, 3.67481870762217*^9}],

Cell[BoxData[
 RowBox[{"th$middle$symmetrical", "=", 
  RowBox[{"thetaright", "/.", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"r", " ", 
           RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
          RowBox[{"r", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"-", "thetaright"}], "]"}]}]}], ")"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"r", " ", 
           RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
          RowBox[{"r", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"-", "thetaright"}], "]"}]}]}], ")"}], "2"]}], "\[Equal]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", "\[Equal]", 
         RowBox[{"numdef", "-", "1"}]}], ",", 
        RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"thetaright", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "To", " ", "find", " ", "symmetrical", " ", "angle", " ", "of", " ", 
      "the", " ", "middle", " ", "rotor"}], ",", " ", 
     RowBox[{"to", " ", "plug", " ", "back", " ", "above"}]}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.658491614598687*^9, 3.658491708352745*^9}, {
  3.664028981888459*^9, 3.664028987136402*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"th", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, 
   3.633107849053135*^9, 3.640431453500654*^9, {3.64051900108724*^9, 
   3.640519032020152*^9}, 3.640519091131611*^9, {3.640519133617816*^9, 
   3.640519141505741*^9}, {3.640954072866503*^9, 3.6409540747819967`*^9}, {
   3.641909159215695*^9, 3.641909159525496*^9}, 3.641912707881154*^9, 
   3.641917750582572*^9, {3.6419178971559*^9, 3.6419178996323137`*^9}, {
   3.641917958539505*^9, 3.64191796617002*^9}, {3.641918356310309*^9, 
   3.641918379507525*^9}, {3.6419189956698933`*^9, 3.6419189991983833`*^9}, {
   3.641919048197426*^9, 3.641919124621357*^9}, {3.641919197938994*^9, 
   3.641919199487707*^9}, {3.641922766846982*^9, 3.641922804886376*^9}, {
   3.646104424310775*^9, 3.646104442671603*^9}, {3.646104587111969*^9, 
   3.6461046159606256`*^9}, {3.6461046716573467`*^9, 3.646104711473505*^9}, {
   3.646104747902801*^9, 3.646104770938389*^9}, {3.646105039927987*^9, 
   3.6461050526437807`*^9}, {3.646105241779292*^9, 3.64610524828834*^9}, 
   3.64657454254104*^9, 3.646574926373436*^9, {3.646575156952662*^9, 
   3.646575211778639*^9}, {3.6465752734950867`*^9, 3.646575299836241*^9}, {
   3.646575392760343*^9, 3.6465753946374187`*^9}, {3.646575428315222*^9, 
   3.646575441770688*^9}, {3.646575609117782*^9, 3.646575615181638*^9}, 
   3.6465765989702463`*^9, {3.6465768466645*^9, 3.646576865245425*^9}, {
   3.6465769577152767`*^9, 3.646576964901911*^9}, {3.646577054378533*^9, 
   3.646577073452345*^9}, 3.6465777468589687`*^9, {3.646577904437048*^9, 
   3.646578000197854*^9}, {3.6465782033019648`*^9, 3.646578211875195*^9}, {
   3.646578259584546*^9, 3.646578286691248*^9}, 3.646578338599728*^9, 
   3.646579236372817*^9, {3.646579298451799*^9, 3.646579298688532*^9}, 
   3.646579513818447*^9, {3.6466390153689423`*^9, 3.646639018163767*^9}, {
   3.6466390998376513`*^9, 3.646639142690577*^9}, {3.64663918754981*^9, 
   3.64663921854774*^9}, {3.646639252383985*^9, 3.646639260834017*^9}, {
   3.646639293869635*^9, 3.646639440141055*^9}, {3.646639716119461*^9, 
   3.6466397238122263`*^9}, {3.646639842015164*^9, 3.64663985218678*^9}, {
   3.6466399508603*^9, 3.646639953754033*^9}, 3.646640036683301*^9, {
   3.646640131679122*^9, 3.646640136174921*^9}, {3.64664223331671*^9, 
   3.6466422986313667`*^9}, 3.646643708276936*^9, {3.646647242328764*^9, 
   3.646647242451543*^9}, {3.6466475237143173`*^9, 3.6466475238777514`*^9}, 
   3.646907468331355*^9, {3.646907716530814*^9, 3.6469077165737762`*^9}, {
   3.647843279540071*^9, 3.647843303685266*^9}, {3.6478438299757433`*^9, 
   3.647843832321661*^9}, 3.647843902752071*^9, {3.647843971144924*^9, 
   3.647843973606101*^9}, 3.647844160902772*^9, {3.647844232216487*^9, 
   3.6478442561524982`*^9}, {3.64784429670004*^9, 3.647844382648075*^9}, {
   3.647850348894267*^9, 3.647850390139988*^9}, 3.647850563797996*^9, 
   3.6478533800149097`*^9, 3.647856461634306*^9, 3.6478617850774508`*^9, {
   3.647863035588881*^9, 3.647863035761806*^9}, 3.647863142117786*^9, {
   3.6478632038191357`*^9, 3.647863232935384*^9}, {3.647863371312625*^9, 
   3.647863378941893*^9}, 3.647863491869536*^9, 3.6478636880676622`*^9, {
   3.64786371904622*^9, 3.647863720018546*^9}, {3.647865122887711*^9, 
   3.647865123587791*^9}, {3.647865446588835*^9, 3.64786544738625*^9}, {
   3.647865515871541*^9, 3.647865552621176*^9}, {3.6478655975247183`*^9, 
   3.647865597611209*^9}, {3.6478656591403627`*^9, 3.64786566054836*^9}, 
   3.647865704055502*^9, {3.64786637850098*^9, 3.647866380803048*^9}, 
   3.647866497127502*^9, 3.647866574882429*^9, {3.647866608414258*^9, 
   3.647866608599741*^9}, {3.647866866606606*^9, 3.647866867021512*^9}, {
   3.647867063798667*^9, 3.6478670670433807`*^9}, {3.647867155280249*^9, 
   3.647867183049902*^9}, 3.647867446593346*^9, {3.6478675697326527`*^9, 
   3.647867569841147*^9}, 3.6478676214125566`*^9, 3.647867877160533*^9, {
   3.647868067742684*^9, 3.64786806935541*^9}, 3.647868144445256*^9, {
   3.6478682106778917`*^9, 3.647868212035141*^9}, {3.648976721650756*^9, 
   3.6489767246412363`*^9}, {3.648976943265038*^9, 3.648976943649185*^9}, {
   3.649075992470459*^9, 3.649075997237792*^9}, {3.649076500567992*^9, 
   3.649076502192602*^9}, {3.649171870374464*^9, 3.64917187583945*^9}, {
   3.64917197677919*^9, 3.6491719987659683`*^9}, 3.6491724590924788`*^9, {
   3.6491729999705772`*^9, 3.649173014993458*^9}, {3.649396871957219*^9, 
   3.6493968770958567`*^9}, {3.651921189728344*^9, 3.6519212198966293`*^9}, {
   3.651927362944475*^9, 3.651927375023594*^9}, 3.6564062669371853`*^9, {
   3.656406451789065*^9, 3.656406457516768*^9}, 3.656406589608224*^9, 
   3.656406663711671*^9, 3.6564101567611*^9, 3.656412335338065*^9, 
   3.6564125714716663`*^9, 3.656412801876087*^9, 3.6566573873683453`*^9, {
   3.656935848348751*^9, 3.656935861118534*^9}, {3.6572838225203657`*^9, 
   3.6572838226241407`*^9}, {3.6576209956944857`*^9, 3.657620996082245*^9}, {
   3.6576210434720907`*^9, 3.657621053336095*^9}, {3.657621639724885*^9, 
   3.657621641741132*^9}, {3.657621775792904*^9, 3.657621802206545*^9}, {
   3.6576219861695967`*^9, 3.657622012157132*^9}, {3.657622129706727*^9, 
   3.657622145337562*^9}, {3.657622462626728*^9, 3.657622518425068*^9}, {
   3.6576230202559767`*^9, 3.657623062015273*^9}, 3.6576233464569817`*^9, {
   3.65762342063665*^9, 3.657623421241233*^9}, 3.657623598189003*^9, {
   3.657623659517655*^9, 3.657623675102*^9}, {3.657623709502474*^9, 
   3.657623738255693*^9}, {3.657623773394779*^9, 3.6576237971196136`*^9}, {
   3.657969558006403*^9, 3.657969574281332*^9}, {3.657969676363311*^9, 
   3.657969770412017*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"\[Pi]", "-", 
      RowBox[{
       RowBox[{"ans$antikink$initial", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", "8", "]"}]}], ",", 
     RowBox[{
      RowBox[{"ans$antikink$initial", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", "8", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "num"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.668426252090749*^9, 3.668426329324957*^9}}],

Cell["relax short simu", "Text",
 CellChangeTimes->{{3.6640288551506853`*^9, 3.664028877614036*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tfinal", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", "10000."}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", "1."}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vzero", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ans$antikink$initial", "=", 
   RowBox[{"klchainmd2", "[", 
    RowBox[{
    "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
     "initial", ",", "vzero"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{
         RowBox[{"ans$antikink$initial", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
       RowBox[{
        RowBox[{"ans$antikink$initial", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"initialold", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Pi]", "/", "2"}], "-", 
      RowBox[{
       RowBox[{"ans$antikink$initial", "[", 
        RowBox[{"[", "j", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.657291514694365*^9, 3.6572915802799473`*^9}, 
   3.657621077987754*^9, 3.657621347828589*^9, 3.657621417989902*^9, {
   3.657622164314877*^9, 3.6576221744419003`*^9}, {3.657622855688302*^9, 
   3.6576228673506327`*^9}, 3.657623094960688*^9, 3.657969778807598*^9, {
   3.657969810490794*^9, 3.657969821562417*^9}, {3.65796999388789*^9, 
   3.657970011726841*^9}, {3.657970371798065*^9, 3.657970371925386*^9}, {
   3.657972636539753*^9, 3.657972656589568*^9}, 3.657972800285955*^9, {
   3.657972878368795*^9, 3.6579728788224897`*^9}, 3.664028760955024*^9, {
   3.664028793131826*^9, 3.664028811837049*^9}, {3.66833734589682*^9, 
   3.66833734722367*^9}, {3.66833742202491*^9, 3.6683374234970016`*^9}, {
   3.668337459018956*^9, 3.668337460282485*^9}, {3.668337500236549*^9, 
   3.668337505883215*^9}, 3.668338431233903*^9, {3.668338553828871*^9, 
   3.6683385538663588`*^9}, 3.6683386955434237`*^9, {3.66833874639296*^9, 
   3.668338752104617*^9}, {3.6683401682027807`*^9, 3.668340168297999*^9}, {
   3.668438196604603*^9, 3.668438209943922*^9}, 3.674818611764793*^9}],

Cell["Antikink energy - th0", "Text",
 CellChangeTimes->{{3.666533930319384*^9, 3.6665339416474*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Akernergy$numericdata", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tstart", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"num", "=", "16"}], ";", "\[IndentingNewLine]", 
      RowBox[{"a", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"r", "=", "0.8"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<th0=\>\"", ",", 
          RowBox[{"th0", "=", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"ArcSin", "[", 
              RowBox[{"a", "/", 
               RowBox[{"(", 
                RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.4"}]}]}], 
         "]"}], ";"}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{"The", " ", "1", "st", " ", "angle", " ", "choice"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<th0=\>\"", ",", 
          RowBox[{"th0", "=", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"ArcSin", "[", 
              RowBox[{"a", "/", 
               RowBox[{"(", 
                RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.1"}]}]}], 
         "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"lzerosq", "=", 
       RowBox[{
        SuperscriptBox["a", "2"], "+", 
        RowBox[{"4", 
         SuperscriptBox["r", "2"], 
         SuperscriptBox[
          RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<lzero=\>\"", ",", 
        RowBox[{"lzero", "=", 
         SuperscriptBox["lzerosq", 
          RowBox[{"1", "/", "2"}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"ldef", "=", "lzero"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ldef_critical=\>\"", ",", 
          RowBox[{"ldefcritical", "=", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"2", " ", "r", " ", 
                  RowBox[{"Abs", "@", 
                   RowBox[{"Sin", "[", 
                    RowBox[{"th", "[", 
                    RowBox[{"numdef", "+", "1"}], "]"}], "]"}]}]}]}], ")"}], 
               "2"], "+", 
              RowBox[{"4", 
               SuperscriptBox["r", "2"], 
               SuperscriptBox[
                RowBox[{"Cos", "[", 
                 RowBox[{"th", "[", 
                  RowBox[{"numdef", "+", "1"}], "]"}], "]"}], "2"]}]}], ")"}], 
            RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"ldeftest", "=", "lzero"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"th", "[", "16", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"numdef", "=", 
       RowBox[{
        RowBox[{"IntegerPart", "[", 
         RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the",
         " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"numx", "=", 
       RowBox[{"IntegerPart", "[", 
        RowBox[{"num", "/", "2"}], "]"}]}], "  ", ";", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"th", "[", "numx", "]"}], "=", 
       RowBox[{"-", "0."}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "[", "numx", "]"}], "=", 
         RowBox[{"-", "0.238969"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"numx", "-", "1"}]}], ",", 
        RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
        RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"thetaleft", "=", 
          RowBox[{"th", "[", 
           RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"th", "[", "i", "]"}], "=", 
          RowBox[{"thetaright", "/.", 
           RowBox[{"FindRoot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"a", "+", 
                  RowBox[{"r", " ", 
                   RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                  RowBox[{"r", " ", 
                   RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
               "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"r", " ", 
                   RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                  RowBox[{"r", " ", 
                   RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
              "\[Equal]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[Equal]", 
                 RowBox[{"numdef", "-", "1"}]}], ",", 
                RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
             "\[IndentingNewLine]", ",", 
             RowBox[{"{", 
              RowBox[{"thetaright", ",", 
               RowBox[{"-", "1"}], ",", 
               RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"numx", "+", "1"}]}], ",", 
        RowBox[{"i", "\[LessEqual]", "num"}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"thetaright", "=", 
          RowBox[{"th", "[", 
           RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"th", "[", "i", "]"}], "=", 
          RowBox[{"thetaleft", "/.", 
           RowBox[{"FindRoot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"a", "+", 
                  RowBox[{"r", " ", 
                   RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                  RowBox[{"r", " ", 
                   RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
               "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"r", " ", 
                   RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                  RowBox[{"r", " ", 
                   RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
              "\[Equal]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[Equal]", 
                 RowBox[{"numdef", "-", "1", "+", "1"}]}], ",", 
                RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
             "\[IndentingNewLine]", ",", 
             RowBox[{"{", 
              RowBox[{"thetaleft", ",", "1", ",", 
               RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"th", "[", "num", "]"}], "=", 
       RowBox[{"thinit", "/.", 
        RowBox[{
         RowBox[{"Solve", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"h", ":=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"lzero", "-", "r"}], ")"}], 
              RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
            RowBox[{
             RowBox[{
              SqrtBox[
               RowBox[{
                SuperscriptBox["r", "2"], "-", 
                SuperscriptBox["h", "2"]}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
           ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
         "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"th", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"-", "thinit"}], "/.", 
        RowBox[{
         RowBox[{"Solve", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"h", ":=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"lzero", "-", "r"}], ")"}], 
              RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
            RowBox[{
             RowBox[{
              SqrtBox[
               RowBox[{
                SuperscriptBox["r", "2"], "-", 
                SuperscriptBox["h", "2"]}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
           ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
         "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"initial", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{"True", ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{"\[Pi]", "-", 
              RowBox[{"th", "[", "i", "]"}]}], ",", 
             RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Pi]"}], "+", 
              RowBox[{"th", "[", "i", "]"}]}], ",", 
             RowBox[{"-", 
              RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"initialold", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Pi]", "/", "2"}], "-", 
          RowBox[{"initial", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"wsol", "=", 
       FractionBox[
        SuperscriptBox["a", "2"], 
        RowBox[{"2", "r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}]}]]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"tfinal", "=", "10"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"kk", "[", "i", "]"}], "=", "10000."}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", "i", "]"}], "=", "1."}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"vzero", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ans$antikink$initial", "=", 
       RowBox[{"klchainmd2", "[", 
        RowBox[{
        "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
         "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{
             RowBox[{"ans$antikink$initial", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
           RowBox[{
            RowBox[{"ans$antikink$initial", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ";", "\n", 
      RowBox[{"initialold", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Pi]", "/", "2"}], "-", 
          RowBox[{
           RowBox[{"ans$antikink$initial", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"th0", ",", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"espringold2", "[", "i", "]"}], "/", 
           RowBox[{"kk", "[", "i", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"th0", ",", "0.05", ",", "0.95", ",", "0.05"}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.666533893983658*^9, 3.666533926736146*^9}, {
   3.666534013811726*^9, 3.666534040504315*^9}, {3.6665341743472433`*^9, 
   3.666534260477104*^9}, 3.666535114644602*^9, {3.666535159706615*^9, 
   3.666535174897727*^9}, {3.666535406842416*^9, 3.6665354270019836`*^9}, {
   3.666535615262486*^9, 3.666535616093395*^9}, {3.666535666670847*^9, 
   3.666535668860779*^9}, {3.666536377122967*^9, 3.666536378942292*^9}, {
   3.666536476482223*^9, 3.666536477521347*^9}, 3.66765079263769*^9, {
   3.674818279811779*^9, 3.6748182799073753`*^9}}],

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"Tanh", "[", "x", "]"}], "^", "2"}]}], ")"}], "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Infinity]"}], ",", 
     RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.666535244966154*^9, 3.666535429284288*^9}, {
   3.666535633321309*^9, 3.6665356610179377`*^9}, 3.6665356932272253`*^9}],

Cell[BoxData[
 RowBox[{"akenergy$plot", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r", "=", "0.8"}], ",", 
          RowBox[{"a", "=", "1"}]}], "}"}], ",", 
        FractionBox[
         RowBox[{"16", "  ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["r", "a"], 
             RowBox[{"Sin", "[", "th", "]"}]}], ")"}], "3"]}], 
         RowBox[{"3", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["r", "a"], ")"}], "2"], 
             SuperscriptBox[
              RowBox[{"Cos", "[", "th", "]"}], "2"]}]}], ")"}]}]]}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "0", ",", "0.95"}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", " ", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "All"}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<\!\(\*OverscriptBox[\(\[Theta]\), \(_\)]\)\>\"", ",", 
         "\"\<\!\(\*SubscriptBox[\(V\), \
\(antikink\)]\)/(\!\(\*SuperscriptBox[\(ka\), \(2\)]\))\>\""}], "}"}]}], ",", 
      " ", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
      RowBox[{"FrameTicksStyle", "\[Rule]", "Thick"}], ",", 
      RowBox[{"PlotLegends", "\[Rule]", 
       RowBox[{"Placed", "[", 
        RowBox[{
         RowBox[{"LineLegend", "[", 
          RowBox[{
           RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.25", ",", "0.5"}], "}"}]}], "]"}]}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"Akernergy$numericdata", ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "20"}], "}"}]}], ",", 
      RowBox[{"PlotLegends", "\[Rule]", 
       RowBox[{"Placed", "[", 
        RowBox[{
         RowBox[{"LineLegend", "[", 
          RowBox[{
           RowBox[{"{", "\"\<Discrete model\>\"", "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.25", ",", "0.5"}], "}"}]}], "]"}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.666535244966154*^9, 3.666535429284288*^9}, {
   3.666535633321309*^9, 3.6665356610179377`*^9}, {3.6665356932272253`*^9, 
   3.666535710507256*^9}, {3.666535764239324*^9, 3.666535787997281*^9}, {
   3.666535823887415*^9, 3.666535949520234*^9}, {3.6665359816960897`*^9, 
   3.666535988528405*^9}, {3.666536053204907*^9, 3.666536071363401*^9}, {
   3.666536123837442*^9, 3.6665361734936123`*^9}, {3.666536208855823*^9, 
   3.666536290168748*^9}, {3.666536323706737*^9, 3.666536360026916*^9}, 
   3.666536410080145*^9, {3.666536662386278*^9, 3.6665366671696053`*^9}, {
   3.6665367943893557`*^9, 3.666536876374683*^9}, {3.6665385393607817`*^9, 
   3.666538542830468*^9}, {3.666538578031927*^9, 3.66653858342428*^9}, {
   3.66653875597289*^9, 3.666538758816799*^9}, {3.6665388990015793`*^9, 
   3.666538924743729*^9}, {3.666596290068412*^9, 3.6665963467078543`*^9}, {
   3.66765311380898*^9, 3.667653149126052*^9}, {3.6748183089999104`*^9, 
   3.674818350093397*^9}, {3.674818382509755*^9, 3.674818387231015*^9}}],

Cell[BoxData[
 RowBox[{"akenergy$logplot", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"LogPlot", "[", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r", "=", "0.8"}], ",", 
          RowBox[{"a", "=", "1"}]}], "}"}], ",", 
        FractionBox[
         RowBox[{"16", "  ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["r", "a"], 
             RowBox[{"Sin", "[", "th", "]"}]}], ")"}], "3"]}], 
         RowBox[{"3", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["r", "a"], ")"}], "2"], 
             SuperscriptBox[
              RowBox[{"Cos", "[", "th", "]"}], "2"]}]}], ")"}]}]]}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "0", ",", "0.95"}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", " ", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{"0.001", ",", "100"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<\!\(\*OverscriptBox[\(\[Theta]\), \(_\)]\)\>\"", ",", 
         "\"\<\!\(\*SubscriptBox[\(V\), \
\(antikink\)]\)/(\!\(\*SuperscriptBox[\(ka\), \(2\)]\))\>\""}], "}"}]}], ",", 
      " ", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
      RowBox[{"FrameTicksStyle", "\[Rule]", "Thick"}], ",", 
      RowBox[{"PlotLegends", "\[Rule]", 
       RowBox[{"Placed", "[", 
        RowBox[{
         RowBox[{"LineLegend", "[", 
          RowBox[{
           RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.25", ",", "0.5"}], "}"}]}], "]"}]}]}], "]"}], ",", 
    RowBox[{"ListLogPlot", "[", 
     RowBox[{"Akernergy$numericdata", ",", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "5"}], "}"}]}], ",", 
      RowBox[{"PlotLegends", "\[Rule]", 
       RowBox[{"Placed", "[", 
        RowBox[{
         RowBox[{"LineLegend", "[", 
          RowBox[{
           RowBox[{"{", "\"\<Discrete model\>\"", "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.25", ",", "0.5"}], "}"}]}], "]"}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "Confirm", " ", "that", " ", "the", " ", "low", " ", "\[Theta]", " ", 
    "end", " ", "fits", " ", "well"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.666535244966154*^9, 3.666535429284288*^9}, {
   3.666535633321309*^9, 3.6665356610179377`*^9}, {3.6665356932272253`*^9, 
   3.666535710507256*^9}, {3.666535764239324*^9, 3.666535787997281*^9}, {
   3.666535823887415*^9, 3.666535949520234*^9}, {3.6665359816960897`*^9, 
   3.666535988528405*^9}, {3.666536053204907*^9, 3.666536071363401*^9}, {
   3.666536123837442*^9, 3.6665361734936123`*^9}, {3.666536208855823*^9, 
   3.666536290168748*^9}, {3.666536323706737*^9, 3.666536360026916*^9}, 
   3.666536410080145*^9, {3.666536662386278*^9, 3.6665366671696053`*^9}, {
   3.6665367943893557`*^9, 3.666536876374683*^9}, {3.6665385393607817`*^9, 
   3.666538542830468*^9}, {3.666538578031927*^9, 3.66653858342428*^9}, {
   3.66653875597289*^9, 3.666538758816799*^9}, {3.6665388990015793`*^9, 
   3.666538924743729*^9}, {3.666596290068412*^9, 3.6665963467078543`*^9}, {
   3.667650616440832*^9, 3.667650623835284*^9}, {3.667650657500516*^9, 
   3.6676506581186657`*^9}, {3.667650692092435*^9, 3.667650703743258*^9}, {
   3.667652615086041*^9, 3.6676526484929733`*^9}, {3.6676530869612837`*^9, 
   3.667653105158101*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akenergy.pdf\>\"", ",", "akenergy$plot", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.656936088017592*^9, 3.656936093552821*^9}, 
   3.656936176387632*^9, {3.65693660684559*^9, 3.656936615470303*^9}, 
   3.656936685935628*^9, {3.656952102651569*^9, 3.656952103371085*^9}, {
   3.6665367688511047`*^9, 3.66653677628751*^9}}],

Cell[TextData[{
 "wobbler transition point ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Theta]", "wobbler"], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.6665366764478827`*^9, 3.666536701618094*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"ArcSin", "[", 
  RowBox[{"a", "/", 
   RowBox[{"(", 
    RowBox[{"2", "r"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.666536618682302*^9, 3.666536625039064*^9}}],

Cell["antikink simu animation (for gif?)", "Text",
 CellChangeTimes->{{3.6640288551506853`*^9, 3.664028877614036*^9}, {
  3.664105831204741*^9, 3.664105839513752*^9}, {3.6682542060938997`*^9, 
  3.6682542224782047`*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{
        RowBox[{"i", "\[Equal]", "1"}], "||", 
        RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True", 
       ",", "1."}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akpos", "=", "0.65"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vdirection", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0."}], ";"}]}], "Input",
 CellChangeTimes->{{3.650348591794373*^9, 3.650348615469857*^9}, {
   3.6503488211922817`*^9, 3.6503488224798594`*^9}, {3.6503493116672907`*^9, 
   3.650349312606909*^9}, {3.6503496016567917`*^9, 3.650349606311892*^9}, {
   3.650349805613688*^9, 3.650349806403479*^9}, {3.650349896655484*^9, 
   3.650349897471259*^9}, {3.650652326568606*^9, 3.650652327447179*^9}, {
   3.650656432233664*^9, 3.650656432803163*^9}, {3.650695801770853*^9, 
   3.650695814855343*^9}, {3.650695856763914*^9, 3.650695856795198*^9}, {
   3.6506959143507338`*^9, 3.650695914441492*^9}, {3.650696326659938*^9, 
   3.650696331622074*^9}, {3.650717170628542*^9, 3.650717230098461*^9}, 
   3.650717474628593*^9, {3.6507175700346518`*^9, 3.650717571509801*^9}, {
   3.650866494597803*^9, 3.6508665528379307`*^9}, {3.650868885487459*^9, 
   3.650868911070134*^9}, {3.6508689828648567`*^9, 3.650868983679718*^9}, {
   3.650869195605877*^9, 3.650869254378772*^9}, {3.650890054936273*^9, 
   3.650890055036913*^9}, {3.6508901453221483`*^9, 3.650890146200918*^9}, {
   3.650890221371496*^9, 3.6508902214704742`*^9}, {3.65156759021988*^9, 
   3.651567621259502*^9}, {3.651568016743775*^9, 3.6515680171097183`*^9}, 
   3.651568074104039*^9, {3.651568956539568*^9, 3.651568957163229*^9}, {
   3.6515690518561497`*^9, 3.651569052289019*^9}, {3.6580514897691383`*^9, 
   3.6580514987755117`*^9}, {3.658051533338551*^9, 3.658051543113666*^9}, {
   3.658052021221784*^9, 3.65805205698139*^9}, {3.6580565450709343`*^9, 
   3.658056546957734*^9}, {3.6641058941654463`*^9, 3.664105896920508*^9}, {
   3.664105932054614*^9, 3.664105934938901*^9}, 3.664106981248489*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "0.5"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "10.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490808337229233`*^9, 3.649080840443883*^9}, {3.649080898509109*^9, 
   3.649081035697353*^9}, {3.649081066480082*^9, 3.649081066585156*^9}, {
   3.649419799424335*^9, 3.649419816685089*^9}, {3.6494205496355667`*^9, 
   3.649420580162203*^9}, {3.6494206852713547`*^9, 3.6494206868914957`*^9}, {
   3.649420791256592*^9, 3.6494208004235067`*^9}, {3.649420841497678*^9, 
   3.649420858521541*^9}, {3.649420960110087*^9, 3.6494209659816427`*^9}, {
   3.649421000462985*^9, 3.6494210267665358`*^9}, {3.649421107345009*^9, 
   3.64942112457437*^9}, {3.649421163041647*^9, 3.64942117212182*^9}, {
   3.6496572744163847`*^9, 3.6496573426677227`*^9}, {3.649657398080855*^9, 
   3.6496574060747957`*^9}, {3.649657478748437*^9, 3.6496574984617443`*^9}, {
   3.6496576187341757`*^9, 3.649657688622156*^9}, {3.649657723408523*^9, 
   3.64965772774376*^9}, {3.649657763328312*^9, 3.649657767856086*^9}, {
   3.6496578222405357`*^9, 3.649657836738044*^9}, {3.6496579413170347`*^9, 
   3.649657948388825*^9}, 3.649658194122944*^9, 3.6496582865390797`*^9, {
   3.649658719671151*^9, 3.649658722756599*^9}, {3.649658776231144*^9, 
   3.6496587763092537`*^9}, {3.6496589585073557`*^9, 3.64965898505567*^9}, {
   3.650196578354272*^9, 3.6501965861443253`*^9}, {3.650200170632333*^9, 
   3.650200214598452*^9}, {3.6502010123133907`*^9, 3.650201013351956*^9}, {
   3.650206554714987*^9, 3.650206567133321*^9}, 3.6502068682902727`*^9, {
   3.6503448873524933`*^9, 3.650344903320059*^9}, 3.6506247704825087`*^9, {
   3.650648947161413*^9, 3.6506489478962317`*^9}, {3.650652009071665*^9, 
   3.650652014095744*^9}, 3.650652779270048*^9, {3.650653373700645*^9, 
   3.650653373973507*^9}, {3.6506564484613733`*^9, 3.650656471385913*^9}, 
   3.650656686229624*^9, {3.6506886933702*^9, 3.650688696937594*^9}, {
   3.650689260826091*^9, 3.6506892625512333`*^9}, {3.6515696763224297`*^9, 
   3.6515696900622873`*^9}, {3.664105992427371*^9, 3.664106001687701*^9}, {
   3.6641064559386597`*^9, 3.6641064647251453`*^9}, {3.66410694323146*^9, 
   3.66410694505562*^9}, {3.66410703390746*^9, 3.664107037990028*^9}, {
   3.6641074675954657`*^9, 3.664107468204978*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2.5"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "10.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490808337229233`*^9, 3.649080840443883*^9}, {3.649080898509109*^9, 
   3.649081035697353*^9}, {3.649081066480082*^9, 3.649081066585156*^9}, {
   3.649419799424335*^9, 3.649419816685089*^9}, {3.6494205496355667`*^9, 
   3.649420580162203*^9}, {3.6494206852713547`*^9, 3.6494206868914957`*^9}, {
   3.649420791256592*^9, 3.6494208004235067`*^9}, {3.649420841497678*^9, 
   3.649420858521541*^9}, {3.649420960110087*^9, 3.6494209659816427`*^9}, {
   3.649421000462985*^9, 3.6494210267665358`*^9}, {3.649421107345009*^9, 
   3.64942112457437*^9}, {3.649421163041647*^9, 3.64942117212182*^9}, {
   3.6496572744163847`*^9, 3.6496573426677227`*^9}, {3.649657398080855*^9, 
   3.6496574060747957`*^9}, {3.649657478748437*^9, 3.6496574984617443`*^9}, {
   3.6496576187341757`*^9, 3.649657688622156*^9}, {3.649657723408523*^9, 
   3.64965772774376*^9}, {3.649657763328312*^9, 3.649657767856086*^9}, {
   3.6496578222405357`*^9, 3.649657836738044*^9}, {3.6496579413170347`*^9, 
   3.649657948388825*^9}, 3.649658194122944*^9, 3.6496582865390797`*^9, {
   3.649658719671151*^9, 3.649658722756599*^9}, {3.649658776231144*^9, 
   3.6496587763092537`*^9}, {3.6496589585073557`*^9, 3.64965898505567*^9}, {
   3.650196578354272*^9, 3.6501965861443253`*^9}, {3.650200170632333*^9, 
   3.650200214598452*^9}, {3.6502010123133907`*^9, 3.650201013351956*^9}, {
   3.650206554714987*^9, 3.650206567133321*^9}, 3.6502068682902727`*^9, {
   3.6503448873524933`*^9, 3.650344903320059*^9}, 3.6506247704825087`*^9, {
   3.650648947161413*^9, 3.6506489478962317`*^9}, {3.650652009071665*^9, 
   3.650652014095744*^9}, 3.650652779270048*^9, {3.650653373700645*^9, 
   3.650653373973507*^9}, {3.6506564484613733`*^9, 3.650656471385913*^9}, 
   3.650656686229624*^9, {3.6506886933702*^9, 3.650688696937594*^9}, {
   3.650689260826091*^9, 3.6506892625512333`*^9}, {3.6515696763224297`*^9, 
   3.6515696900622873`*^9}, {3.664105992427371*^9, 3.664106001687701*^9}, {
   3.6641064559386597`*^9, 3.6641064647251453`*^9}, {3.66410694323146*^9, 
   3.66410694505562*^9}, {3.66410703390746*^9, 3.664107037990028*^9}, {
   3.6641074675954657`*^9, 3.664107468204978*^9}, {3.678458154945208*^9, 
   3.67845815774559*^9}, 3.678462072322112*^9, 3.678462110787319*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["configuration parameters spinner", "Subsubsection",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, {
   3.633107849053135*^9, 3.633107856688933*^9}, 3.643794417833037*^9, 
   3.6452693052181473`*^9, {3.678442398784514*^9, 3.678442400075594*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{"3", 
      RowBox[{"\[Pi]", "/", "8"}]}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ldef", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<ldef_critical=\>\"", ",", 
    RowBox[{"ldefcritical", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"2", " ", "r", " ", 
            RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "2"], "+", 
        RowBox[{"4", 
         SuperscriptBox["r", "2"], 
         SuperscriptBox[
          RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ldeftest", "=", "lzero"}], ";"}], "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"th", "[", "num", "]"}], "=", 
    RowBox[{"thinit", "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"h", ":=", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], 
           RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
         RowBox[{
          RowBox[{
           SqrtBox[
            RowBox[{
             SuperscriptBox["r", "2"], "-", 
             SuperscriptBox["h", "2"]}]], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"lzero", "-", "r"}], ")"}], 
            RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], ",",
         "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
      "\[RightDoubleBracket]"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numdef", "=", 
    RowBox[{
     RowBox[{"IntegerPart", "[", 
      RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
    " ", "defect", " ", "spring", " ", "is"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numx", "=", 
    RowBox[{"IntegerPart", "[", 
     RowBox[{"num", "/", "2"}], "]"}]}], " ", ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
    "starts"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"th", "[", "numx", "]"}], "=", "0."}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "-", "1"}]}], ",", 
    RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
    RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaright", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "+", "1"}]}], ",", 
    RowBox[{"i", "\[LessEqual]", 
     RowBox[{"num", "+", "2"}]}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaleft", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaright", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaright", ",", "2", ",", "0", ",", "\[Pi]"}], "}"}]}], 
        "]"}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "+", "2"}]}], ",", 
    RowBox[{"i", "\[LessEqual]", "num"}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaleft", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaright", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaright", ",", 
           RowBox[{"-", "2.5"}], ",", 
           RowBox[{"-", "\[Pi]"}], ",", 
           RowBox[{"-", "0"}]}], "}"}]}], "]"}]}]}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initial", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"True", ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "+", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"initialold", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Pi]", "/", "2"}], "-", 
       RowBox[{"initial", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wsol", "=", 
   FractionBox[
    SuperscriptBox["a", "2"], 
    RowBox[{"2", "r", " ", 
     RowBox[{"Sin", "[", "th0", "]"}]}]]}], ";"}]}], "Input",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, 
   3.633107849053135*^9, 3.640431453500654*^9, {3.64051900108724*^9, 
   3.640519032020152*^9}, 3.640519091131611*^9, {3.640519133617816*^9, 
   3.640519141505741*^9}, {3.640954072866503*^9, 3.6409540747819967`*^9}, {
   3.641909159215695*^9, 3.641909159525496*^9}, 3.641912707881154*^9, 
   3.641917750582572*^9, {3.6419178971559*^9, 3.6419178996323137`*^9}, {
   3.641917958539505*^9, 3.64191796617002*^9}, {3.641918356310309*^9, 
   3.641918379507525*^9}, {3.6419189956698933`*^9, 3.6419189991983833`*^9}, {
   3.641919048197426*^9, 3.641919124621357*^9}, {3.641919197938994*^9, 
   3.641919199487707*^9}, {3.641922766846982*^9, 3.641922804886376*^9}, {
   3.646104424310775*^9, 3.646104442671603*^9}, {3.646104587111969*^9, 
   3.6461046159606256`*^9}, {3.6461046716573467`*^9, 3.646104711473505*^9}, {
   3.646104747902801*^9, 3.646104770938389*^9}, {3.646105039927987*^9, 
   3.6461050526437807`*^9}, {3.646105241779292*^9, 3.64610524828834*^9}, 
   3.64657454254104*^9, 3.646574926373436*^9, {3.646575156952662*^9, 
   3.646575211778639*^9}, {3.6465752734950867`*^9, 3.646575299836241*^9}, {
   3.646575392760343*^9, 3.6465753946374187`*^9}, {3.646575428315222*^9, 
   3.646575441770688*^9}, {3.646575609117782*^9, 3.646575615181638*^9}, 
   3.6465765989702463`*^9, {3.6465768466645*^9, 3.646576865245425*^9}, {
   3.6465769577152767`*^9, 3.646576964901911*^9}, {3.646577054378533*^9, 
   3.646577073452345*^9}, 3.6465777468589687`*^9, {3.646577904437048*^9, 
   3.646578000197854*^9}, {3.6465782033019648`*^9, 3.646578211875195*^9}, {
   3.646578259584546*^9, 3.646578286691248*^9}, 3.646578338599728*^9, 
   3.646579236372817*^9, {3.646579298451799*^9, 3.646579298688532*^9}, 
   3.646579513818447*^9, {3.6466390153689423`*^9, 3.646639018163767*^9}, {
   3.6466390998376513`*^9, 3.646639142690577*^9}, {3.64663918754981*^9, 
   3.64663921854774*^9}, {3.646639252383985*^9, 3.646639260834017*^9}, {
   3.646639293869635*^9, 3.646639440141055*^9}, {3.646639716119461*^9, 
   3.6466397238122263`*^9}, {3.646639842015164*^9, 3.64663985218678*^9}, {
   3.6466399508603*^9, 3.646639953754033*^9}, 3.646640036683301*^9, {
   3.646640131679122*^9, 3.646640136174921*^9}, {3.64664223331671*^9, 
   3.6466422986313667`*^9}, 3.646643708276936*^9, {3.646647242328764*^9, 
   3.646647242451543*^9}, {3.6466475237143173`*^9, 3.6466475238777514`*^9}, 
   3.646907468331355*^9, {3.646907716530814*^9, 3.6469077165737762`*^9}, {
   3.647843279540071*^9, 3.647843303685266*^9}, {3.6478438299757433`*^9, 
   3.647843832321661*^9}, 3.647843902752071*^9, {3.647843971144924*^9, 
   3.647843973606101*^9}, 3.647844160902772*^9, {3.647844232216487*^9, 
   3.6478442561524982`*^9}, {3.64784429670004*^9, 3.647844382648075*^9}, {
   3.647850348894267*^9, 3.647850390139988*^9}, 3.647850563797996*^9, 
   3.6478533800149097`*^9, 3.647856461634306*^9, 3.6478617850774508`*^9, {
   3.647863035588881*^9, 3.647863035761806*^9}, 3.647863142117786*^9, {
   3.6478632038191357`*^9, 3.647863232935384*^9}, {3.647863371312625*^9, 
   3.647863378941893*^9}, 3.647863491869536*^9, 3.6478636880676622`*^9, {
   3.64786371904622*^9, 3.647863720018546*^9}, {3.647865122887711*^9, 
   3.647865123587791*^9}, {3.6489769382099*^9, 3.6489769387202272`*^9}, {
   3.649396849109943*^9, 3.649396860790847*^9}, {3.649596589582354*^9, 
   3.64959660282757*^9}, {3.656936323705352*^9, 3.656936342929282*^9}, {
   3.656936390778535*^9, 3.656936444828434*^9}, {3.657280930692526*^9, 
   3.657280930731408*^9}, 3.657281702774507*^9, {3.657282204242875*^9, 
   3.657282229444261*^9}, {3.657450754460813*^9, 3.657450763794889*^9}, {
   3.657621161697871*^9, 3.657621173793253*^9}, {3.657621225125066*^9, 
   3.657621229027203*^9}, {3.6576212940552273`*^9, 3.6576212950762873`*^9}, {
   3.657621624653295*^9, 3.657621635084713*^9}, {3.6576217427855864`*^9, 
   3.6576217628839827`*^9}, {3.657622399620167*^9, 3.657622415936246*^9}, 
   3.657622558082868*^9, {3.657622755209448*^9, 3.657622757989699*^9}, {
   3.657622831599257*^9, 3.657622833630106*^9}, {3.657622978766416*^9, 
   3.65762299169058*^9}, {3.678442485391696*^9, 3.678442489042012*^9}, {
   3.678444656521785*^9, 3.678444659013823*^9}, {3.678444692360135*^9, 
   3.678444693487135*^9}, 3.678444893295586*^9, {3.678444994943656*^9, 
   3.678445044295405*^9}, {3.678448807068644*^9, 3.6784488272949533`*^9}, 
   3.6784489019678297`*^9, {3.678449167396989*^9, 3.678449167507721*^9}, {
   3.678449205190805*^9, 3.678449205255348*^9}, {3.678449872679493*^9, 
   3.678449903639264*^9}, 3.678450037947549*^9}],

Cell["spinner run simu animation", "Text",
 CellChangeTimes->{{3.664030231244994*^9, 3.664030236844513*^9}, {
  3.6640302846860237`*^9, 3.6640302852446213`*^9}, {3.664105843059526*^9, 
  3.664105845510912*^9}, {3.678442504782364*^9, 3.678442505038571*^9}, {
  3.678449229203727*^9, 3.678449231843843*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", "\[Equal]", "1"}], "||", 
          RowBox[{"i", "==", "num"}]}], ",", "1.", ",", "1."}], "]"}]}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kpos", "=", "0.65"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"modenum", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0"}], ";"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, {3.650367826499136*^9, 3.650367851219644*^9}, {
   3.6503679372860622`*^9, 3.6503679756384087`*^9}, {3.65036809583464*^9, 
   3.650368096573086*^9}, {3.65036836843544*^9, 3.6503683691946993`*^9}, {
   3.65036929701457*^9, 3.6503692977331142`*^9}, {3.650369535195619*^9, 
   3.650369536018444*^9}, {3.6505300688521433`*^9, 3.6505300695586357`*^9}, {
   3.650546400520092*^9, 3.650546401432098*^9}, {3.6505465894377537`*^9, 
   3.650546589868441*^9}, {3.650646555599687*^9, 3.650646556591234*^9}, {
   3.6506468167904987`*^9, 3.650646817477148*^9}, {3.658753652709051*^9, 
   3.658753653684366*^9}, {3.6587538218658457`*^9, 3.658753822056353*^9}, {
   3.6640424962242413`*^9, 3.664042496303115*^9}, 3.664042616055335*^9, 
   3.664042713205374*^9, {3.6640428853054867`*^9, 3.664042895465214*^9}, {
   3.678449423564137*^9, 3.678449448922649*^9}, 3.6784506464240847`*^9}],

Cell[BoxData[
 RowBox[{"vAtablekinkmov1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tfinal", "=", 
      RowBox[{
       RowBox[{"3.", "/", "v0"}], "+", "38.5"}]}], ";", 
     RowBox[{"tinterval", "=", 
      RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent6", ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"ldef", ",", 
      RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"v0", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"thnumx", ",", 
      RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"kkdef", ",", 
      RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Mdef", ",", 
      RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.664042292588078*^9, 3.6640423081709347`*^9}, 
   3.664042924058928*^9, {3.6640912531328287`*^9, 3.664091256688162*^9}, 
   3.664091320447093*^9, 3.6641038055731153`*^9, {3.6641052661197157`*^9, 
   3.664105273254784*^9}, 3.664105707282063*^9, {3.678444387102219*^9, 
   3.678444434606688*^9}, 3.6784492265974407`*^9, 3.678450649015038*^9, {
   3.678457008084729*^9, 3.6784570082512817`*^9}, {3.678457208938181*^9, 
   3.6784572162979116`*^9}, {3.678457916907091*^9, 3.6784579169867077`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["cobweb movie kink", "Subsubsection",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107770228497*^9}, {3.647865677998992*^9, 
   3.647865679725851*^9}, {3.65693629122158*^9, 3.656936293957926*^9}, {
   3.657621905057027*^9, 3.6576219072960987`*^9}, {3.67844216178447*^9, 
   3.678442172294354*^9}, {3.678442208887315*^9, 3.678442210407269*^9}, {
   3.678458086430255*^9, 3.678458087430031*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"kcobweb2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ContourPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s", "2"]}], ",", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]1", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"ContourStyle", "->", 
             RowBox[{"{", 
              RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
            RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"Epilog", "->", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(7\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(8\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "7", "]"}], "+", "0.2"}], ",", 
                   RowBox[{"th", "[", "8", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(8\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(8\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "-", "0.2"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "+", "0.05"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(8\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(9\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "+", "0.2"}], ",", 
                   RowBox[{"th", "[", "9", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(9\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(9\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "-", "0.2"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "+", "0.05"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(9\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(10\)]\))\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "+", "0.1"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "10", "]"}], "-", "0.1"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<(...)\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "1", "]"}], "+", "0.1"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "1", "]"}], "-", "0.1"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<(...)\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "num", "]"}], "+", "0.05"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "num", "]"}], "-", "0.1"}]}], "}"}]}], 
                "]"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
             "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "2"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                 "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"i", "\[NotEqual]", 
                    RowBox[{
                    RowBox[{"num", "/", "2"}], "-", "2"}]}], ",", 
                   RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                   "]"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"i", "\[NotEqual]", 
                    RowBox[{
                    RowBox[{"num", "/", "2"}], "+", "1"}]}], ",", 
                   RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "2"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                   "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{
                  RowBox[{"num", "/", "2"}], "-", "2"}], ",", 
                 RowBox[{
                  RowBox[{"num", "/", "2"}], "+", "1"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"th", "[", "numdef", "]"}], ",", 
                RowBox[{"th", "[", 
                 RowBox[{"numdef", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"th", "[", "i", "]"}], ",", 
                   RowBox[{"th", "[", "i", "]"}]}], "}"}], "]"}], "}"}], ",", 
               
               RowBox[{"{", 
                RowBox[{"i", ",", "7", ",", "10"}], "}"}]}], "]"}]}], "}"}], 
           "]"}], ",", "\[IndentingNewLine]", "    ", "\[IndentingNewLine]", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
             "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], ",", 
       RowBox[{"kinitConfig2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"MakeSSHpicvec", "[", 
           RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]}], "}"}], 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"p", ",", "a", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "r", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "ldeftest", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s2", ",", "lzero", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"offset", ",", "0", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tx1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ty1", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030566589162*^9}, {
   3.6784428058520803`*^9, 3.67844283132975*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "=", "a"}], ",", 
     RowBox[{"b", "=", "r"}], ",", 
     RowBox[{"s", "=", "ldeftest"}], ",", 
     RowBox[{"s2", "=", "lzero"}], ",", 
     RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"kinkmov1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"kinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"kcobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"numdef", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"numdef", "+", "1"}], ",", "time"}], "]"}]}], "}"}
                   ], "]"}], ",", 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"time", ",", "0", ",", "tfinal", ",", "0.01"}], "}"}]}], 
      "]"}]}], ";"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", "a"}], ",", 
      RowBox[{"b", "=", "r"}], ",", 
      RowBox[{"s", "=", "ldeftest"}], ",", 
      RowBox[{"s2", "=", "lzero"}], ",", 
      RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"kinkmov1", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"plot\[Theta]range", "=", "\[Pi]"}], ";", 
         RowBox[{"Column", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"kinitConfig2", "=", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"MakeSSHpicvec", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[Pi]", "/", "2"}], "-", 
                    RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                 "0"}], "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                    RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                    RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
            ",", 
            RowBox[{"kcobweb2", "=", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"ContourPlot", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                     "\[Equal]", 
                    SuperscriptBox["s", "2"]}], ",", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                     "\[Equal]", 
                    SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Theta]1", ",", 
                   RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Theta]2", ",", 
                   RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                 RowBox[{"ContourStyle", "->", 
                  RowBox[{"{", 
                   RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                 RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                 RowBox[{"LabelStyle", "\[Rule]", 
                  RowBox[{"Directive", "[", 
                   RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                 RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                 RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                 RowBox[{"PlotRange", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Theta]2", ",", 
                   RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                 RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
               RowBox[{"Graphics", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                  "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                  ",", 
                  RowBox[{"Line", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                   "]"}], ",", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                  RowBox[{"Line", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Point", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], "]"}], ",", 
                  
                  RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                 "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
               "\[IndentingNewLine]", 
               RowBox[{"FrameLabel", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                  "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                 "}"}]}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"time", ",", "0", ",", "45.87", ",", "0.3"}], "}"}]}], 
       "]"}]}], ";"}]}], "]"}], 
  RowBox[{"(*", "Long", "*)"}]}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}, {3.6784580158858957`*^9, 3.678458058203847*^9}, {
   3.6784583395461617`*^9, 3.678458339882617*^9}, {3.678458657810738*^9, 
   3.678458657943781*^9}, {3.678458811674231*^9, 3.678458814953175*^9}, 
   3.67845904241229*^9, 3.678459245389998*^9, {3.678459406578618*^9, 
   3.678459406674158*^9}, 3.678459448148787*^9, 3.678461798066164*^9, {
   3.678461832578237*^9, 3.678461833040689*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", "a"}], ",", 
      RowBox[{"b", "=", "r"}], ",", 
      RowBox[{"s", "=", "ldeftest"}], ",", 
      RowBox[{"s2", "=", "lzero"}], ",", 
      RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
    RowBox[{"kinkmov1", "=", 
     RowBox[{"Manipulate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"kinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"kcobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"numdef", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"numdef", "+", "1"}], ",", "time"}], "]"}]}], "}"}
                   ], "]"}], ",", 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"time", ",", "0", ",", "46", ",", "0.2"}], "}"}]}], "]"}]}]}],
    "]"}], 
  RowBox[{"(*", "Long", "*)"}]}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}, {3.6784580158858957`*^9, 3.678458058203847*^9}, {
   3.6784583395461617`*^9, 3.678458339882617*^9}, {3.678458537776194*^9, 
   3.678458543307687*^9}, 3.678458649486236*^9, {3.6784592928500643`*^9, 
   3.678459310209003*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kinkmov1.gif\>\"", ",", "kinkmov1"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kinkmov_long.gif\>\"", ",", "kinkmov1", ",", 
    RowBox[{"\"\<DispjlayDurations\>\"", "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"1", "/", "15"}], ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "kinkmov1", "]"}], "}"}]}], "]"}]}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678458037165209*^9, 3.678458040077323*^9}, {
   3.678459806809276*^9, 3.6784598097050858`*^9}, 3.6784618441365767`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kinkmov_long_zoomin.gif\>\"", ",", "kinkmov1", ",", 
    RowBox[{"\"\<DispjlayDurations\>\"", "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"1", "/", "15"}], ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "kinkmov1", "]"}], "}"}]}], "]"}]}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678458037165209*^9, 3.678458040077323*^9}, {
   3.678459046167407*^9, 3.67845905091847*^9}, {3.67845979451746*^9, 
   3.6784597974740973`*^9}, 3.678461262511203*^9, {3.6784614736917763`*^9, 
   3.678461483122798*^9}, {3.6784615321167*^9, 3.6784615345480337`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Cobweb movie Antikink", "Subsubsection",
 CellChangeTimes->{{3.657281716068532*^9, 3.657281723857732*^9}, {
  3.657281920010376*^9, 3.657281928058456*^9}, {3.678458101518785*^9, 
  3.678458105582514*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"akcobweb2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ContourPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s", "2"]}], ",", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]1", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"ContourStyle", "->", 
             RowBox[{"{", 
              RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
            RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"Epilog", "->", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(7\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(7\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "7", "]"}], "+", "0.2"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "7", "]"}], "+", "0.02"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(7\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(8\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "7", "]"}], "-", "0.2"}], ",", 
                   RowBox[{"th", "[", "8", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(8\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(8\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "+", "0.1"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "-", "0.1"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(8\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(9\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "8", "]"}], "-", "0.2"}], ",", 
                   RowBox[{"th", "[", "9", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(9\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(9\)]\))\>\"", ",", "Italic", ",", 
                   
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "-", "0.05"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "-", "0.1"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<(\!\(\*SubscriptBox[\(\[Theta]\), \
\(9\)]\),\!\(\*SubscriptBox[\(\[Theta]\), \(10\)]\))\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "9", "]"}], "-", "0.2"}], ",", 
                   RowBox[{"th", "[", "10", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<(...)\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "1", "]"}], "-", "0.1"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "1", "]"}], "+", "0.05"}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<(...)\>\"", ",", "Italic", ",", 
                   RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"th", "[", "num", "]"}], "-", "0.02"}], ",", 
                   RowBox[{
                    RowBox[{"th", "[", "num", "]"}], "+", "0.1"}]}], "}"}]}], 
                "]"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
             "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "2"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                 "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"th", "[", 
                 RowBox[{"num", "-", "1"}], "]"}], ",", 
                RowBox[{"th", "[", "num", "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"th", "[", "i", "]"}], ",", 
                   RowBox[{"th", "[", "i", "]"}]}], "}"}], "]"}], "}"}], ",", 
               
               RowBox[{"{", 
                RowBox[{"i", ",", "6", ",", "10"}], "}"}]}], "]"}]}], "}"}], 
           "]"}], ",", "\[IndentingNewLine]", "    ", "\[IndentingNewLine]", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
             "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], ",", 
       RowBox[{"akinitConfig2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"MakeSSHpicvec", "[", 
           RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]}], "}"}], 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"p", ",", "a", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "r", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "ldeftest", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s2", ",", "lzero", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"offset", ",", "0", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tx1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ty1", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6572896550105877`*^9, 3.657289668803527*^9}, {
   3.6572897437705183`*^9, 3.6572900499823647`*^9}, {3.6572908679349403`*^9, 
   3.657290869080655*^9}, {3.6572916117531652`*^9, 3.657291702593728*^9}, {
   3.657623187316506*^9, 3.657623192680388*^9}, {3.657623264231443*^9, 
   3.657623274937737*^9}, {3.6576238579578943`*^9, 3.657623883094636*^9}, {
   3.6576239508893843`*^9, 3.65762401219715*^9}, 3.657624360657699*^9}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"akinitConfig2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"MakeSSHpicvec", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Pi]", "/", "2"}], "-", 
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
            "0"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], ",", 
       RowBox[{"akcobweb2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ContourPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s", "2"]}], ",", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]1", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"ContourStyle", "->", 
             RowBox[{"{", 
              RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
            RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
             "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"tht", "[", 
                   RowBox[{"1", ",", "t"}], "]"}], ",", 
                  RowBox[{"tht", "[", 
                   RowBox[{"1", ",", "t"}], "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"tht", "[", 
                   RowBox[{"1", ",", "t"}], "]"}], ",", 
                  RowBox[{"tht", "[", 
                   RowBox[{"2", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}]}], 
                   "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "t"}], "]"}]}], "}"}]}], 
                   "}"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"tht", "[", 
                   RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                  RowBox[{"tht", "[", 
                   RowBox[{"num", ",", "t"}], "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"tht", "[", 
                   RowBox[{"num", ",", "t"}], "]"}], ",", 
                  RowBox[{"tht", "[", 
                   RowBox[{"num", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tht", "[", 
                 RowBox[{
                  RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                RowBox[{"tht", "[", 
                 RowBox[{"num", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                   RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}]}], "}"}], "]"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
           "]"}], ",", "\[IndentingNewLine]", "    ", "\[IndentingNewLine]", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
             "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"p", ",", "a", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "r", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "ldeftest", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s2", ",", "lzero", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"offset", ",", "0", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6572896550105877`*^9, 3.657289668803527*^9}, {
   3.6572897437705183`*^9, 3.6572900499823647`*^9}, {3.6572908679349403`*^9, 
   3.657290869080655*^9}, {3.6572916117531652`*^9, 3.657291702593728*^9}, {
   3.657623187316506*^9, 3.657623192680388*^9}, {3.657623264231443*^9, 
   3.657623274937737*^9}, {3.6576238579578943`*^9, 3.657623883094636*^9}, {
   3.6576239508893843`*^9, 3.65762401219715*^9}, 3.657624360657699*^9, {
   3.664106494590523*^9, 3.66410651724611*^9}, {3.664106718507778*^9, 
   3.664106781692574*^9}, {3.664106820515832*^9, 3.6641068352785378`*^9}, {
   3.664107114631337*^9, 3.6641071170284433`*^9}, {3.664107147085693*^9, 
   3.6641071507085342`*^9}, {3.664107196405554*^9, 3.664107239033543*^9}, 
   3.664107348860626*^9, {3.664108433043251*^9, 3.664108433429378*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", "a"}], ",", 
      RowBox[{"b", "=", "r"}], ",", 
      RowBox[{"s", "=", "ldeftest"}], ",", 
      RowBox[{"s2", "=", "lzero"}], ",", 
      RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
    RowBox[{"antikinkmov1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"akinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"akcobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}],
                  ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "tfinal", ",", "0.001"}], "}"}]}], 
      "]"}]}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6572896550105877`*^9, 3.657289668803527*^9}, {
   3.6572897437705183`*^9, 3.6572900499823647`*^9}, {3.6572908679349403`*^9, 
   3.657290869080655*^9}, {3.6572916117531652`*^9, 3.657291702593728*^9}, {
   3.657623187316506*^9, 3.657623192680388*^9}, {3.657623264231443*^9, 
   3.657623274937737*^9}, {3.6576238579578943`*^9, 3.657623883094636*^9}, {
   3.6576239508893843`*^9, 3.65762401219715*^9}, 3.657624360657699*^9, {
   3.664106494590523*^9, 3.66410651724611*^9}, {3.664106718507778*^9, 
   3.664106781692574*^9}, {3.664106820515832*^9, 3.6641068352785378`*^9}, {
   3.664107114631337*^9, 3.6641071170284433`*^9}, {3.664107147085693*^9, 
   3.6641071507085342`*^9}, {3.664107196405554*^9, 3.664107239033543*^9}, 
   3.664107348860626*^9, {3.664107475404118*^9, 3.664107550240026*^9}, {
   3.66410759867632*^9, 3.664107612150538*^9}, {3.664107823511326*^9, 
   3.664107843996356*^9}, 3.664107877706051*^9, 3.664107937387454*^9, {
   3.664108447343614*^9, 3.664108447623323*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", "a"}], ",", 
      RowBox[{"b", "=", "r"}], ",", 
      RowBox[{"s", "=", "ldeftest"}], ",", 
      RowBox[{"s2", "=", "lzero"}], ",", 
      RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
    RowBox[{"antikinkmov1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"akinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"akcobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}],
                  ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "1.85", ",", "0.01"}], "}"}]}], "]"}]}]}],
    "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6572896550105877`*^9, 3.657289668803527*^9}, {
   3.6572897437705183`*^9, 3.6572900499823647`*^9}, {3.6572908679349403`*^9, 
   3.657290869080655*^9}, {3.6572916117531652`*^9, 3.657291702593728*^9}, {
   3.657623187316506*^9, 3.657623192680388*^9}, {3.657623264231443*^9, 
   3.657623274937737*^9}, {3.6576238579578943`*^9, 3.657623883094636*^9}, {
   3.6576239508893843`*^9, 3.65762401219715*^9}, 3.657624360657699*^9, {
   3.664106494590523*^9, 3.66410651724611*^9}, {3.664106718507778*^9, 
   3.664106781692574*^9}, {3.664106820515832*^9, 3.6641068352785378`*^9}, {
   3.664107114631337*^9, 3.6641071170284433`*^9}, {3.664107147085693*^9, 
   3.6641071507085342`*^9}, {3.664107196405554*^9, 3.664107239033543*^9}, 
   3.664107348860626*^9, {3.664107475404118*^9, 3.664107550240026*^9}, {
   3.66410759867632*^9, 3.664107612150538*^9}, {3.664107823511326*^9, 
   3.664107843996356*^9}, 3.664107877706051*^9, 3.664107937387454*^9, {
   3.664108447343614*^9, 3.664108447623323*^9}, {3.678462239061021*^9, 
   3.678462246970367*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "=", "a"}], ",", 
     RowBox[{"b", "=", "r"}], ",", 
     RowBox[{"s", "=", "ldeftest"}], ",", 
     RowBox[{"s2", "=", "lzero"}], ",", 
     RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
   RowBox[{"antikinkmov1", "=", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"plot\[Theta]range", "=", "1"}], ";", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"akinitConfig2", "=", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"MakeSSHpicvec", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[Pi]", "/", "2"}], "-", 
                  RowBox[{
                   RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "t", "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
               "0"}], "]"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "r"}], "-", ".2"}], ",", 
                  RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "r"}], "-", ".2"}], ",", 
                  RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
          ",", 
          RowBox[{"akcobweb2", "=", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"ContourPlot", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                   "\[Equal]", 
                  SuperscriptBox["s", "2"]}], ",", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                   "\[Equal]", 
                  SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]1", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]2", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"ContourStyle", "->", 
                RowBox[{"{", 
                 RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
               RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                RowBox[{"Directive", "[", 
                 RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
               RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
               RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Plot", "[", 
              RowBox[{
               RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]2", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
             RowBox[{"Graphics", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "t"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}]}], "}"}], "]"}],
                 ",", "\[IndentingNewLine]", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "t"}], "]"}], ",", 
                   RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
                RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "t"}], "]"}]}], "}"}], "]"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
               "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
             "\[IndentingNewLine]", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
               "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
        "]"}]}], "\[IndentingNewLine]", ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tfinal", ",", "0.01"}], "}"}]}], 
     "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6572896550105877`*^9, 3.657289668803527*^9}, {
   3.6572897437705183`*^9, 3.6572900499823647`*^9}, {3.6572908679349403`*^9, 
   3.657290869080655*^9}, {3.6572916117531652`*^9, 3.657291702593728*^9}, {
   3.657623187316506*^9, 3.657623192680388*^9}, {3.657623264231443*^9, 
   3.657623274937737*^9}, {3.6576238579578943`*^9, 3.657623883094636*^9}, {
   3.6576239508893843`*^9, 3.65762401219715*^9}, 3.657624360657699*^9, {
   3.664106494590523*^9, 3.66410651724611*^9}, {3.664106718507778*^9, 
   3.664106781692574*^9}, {3.664106820515832*^9, 3.6641068352785378`*^9}, {
   3.664107114631337*^9, 3.6641071170284433`*^9}, {3.664107147085693*^9, 
   3.6641071507085342`*^9}, {3.664107196405554*^9, 3.664107239033543*^9}, 
   3.664107348860626*^9, {3.664107475404118*^9, 3.664107550240026*^9}, {
   3.66410759867632*^9, 3.664107612150538*^9}, {3.664107823511326*^9, 
   3.664107843996356*^9}, 3.664107877706051*^9, 3.664107937387454*^9, {
   3.664108447343614*^9, 3.664108447623323*^9}, {3.678458166129463*^9, 
   3.678458175396944*^9}, 3.678462093596233*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<antikinkmov1.gif\>\"", ",", "antikinkmov1"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664107606541801*^9, 3.6641076151015663`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<antikinkmov1_long.gif\>\"", ",", "antikinkmov1"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664107606541801*^9, 3.6641076151015663`*^9}, {
  3.678462253893524*^9, 3.678462256469112*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Cobweb movie Spinner", "Subsubsection",
 CellChangeTimes->{{3.678442238775709*^9, 3.678442239607526*^9}, {
  3.678458112974783*^9, 3.678458115471175*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"plot\[Theta]range", "=", "\[Pi]"}], ";", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"spinnercobweb2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ContourPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s", "2"]}], ",", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"p", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                   RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"offset", "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                   RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                "\[Equal]", 
               SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]1", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"ContourStyle", "->", 
             RowBox[{"{", 
              RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
            RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "plot\[Theta]range"}], ",", 
                 "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]2", ",", 
              RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
             "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "2"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                 "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"th", "[", 
                   RowBox[{"num", "-", "1"}], "]"}], ",", 
                  RowBox[{"th", "[", "num", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"th", "[", "num", "]"}], ",", 
                  RowBox[{"th", "[", "num", "]"}]}], "}"}]}], "}"}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"th", "[", "numdef", "]"}], ",", 
                RowBox[{"th", "[", 
                 RowBox[{"numdef", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"th", "[", "i", "]"}], ",", 
                   RowBox[{"th", "[", "i", "]"}]}], "}"}], "]"}], "}"}], ",", 
               
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "16"}], "}"}]}], "]"}]}], "}"}], 
           "]"}], ",", "\[IndentingNewLine]", "    ", "\[IndentingNewLine]", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
             "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], ",", 
       RowBox[{"spinnerinitConfig2", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"MakeSSHpicvec", "[", 
           RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]}], "}"}], 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"p", ",", "a", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "r", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "ldeftest", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s2", ",", "lzero", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"offset", ",", "0", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tx1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ty1", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030566589162*^9}, {
   3.6784428058520803`*^9, 3.678442806281868*^9}, {3.6784430890589848`*^9, 
   3.6784431385580273`*^9}, {3.678443174673523*^9, 3.678443184000086*^9}, 
   3.678443368043583*^9, {3.678448936517064*^9, 3.678448938108254*^9}, {
   3.678451452401128*^9, 3.67845146225054*^9}, {3.678451568148141*^9, 
   3.67845160420846*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "=", "a"}], ",", 
     RowBox[{"b", "=", "r"}], ",", 
     RowBox[{"s", "=", "ldeftest"}], ",", 
     RowBox[{"s2", "=", "lzero"}], ",", 
     RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
   RowBox[{"spinnermov1", "=", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"plot\[Theta]range", "=", "\[Pi]"}], ";", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"spinnerinitConfig2", "=", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"MakeSSHpicvec", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[Pi]", "/", "2"}], "-", 
                  RowBox[{
                   RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
               "0"}], "]"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "r"}], "-", ".2"}], ",", 
                  RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "r"}], "-", ".2"}], ",", 
                  RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
          ",", 
          RowBox[{"spinnercobweb2", "=", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"ContourPlot", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                   "\[Equal]", 
                  SuperscriptBox["s", "2"]}], ",", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                   "\[Equal]", 
                  SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]1", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]2", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"ContourStyle", "->", 
                RowBox[{"{", 
                 RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
               RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                RowBox[{"Directive", "[", 
                 RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
               RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
               RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Plot", "[", 
              RowBox[{
               RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]2", ",", 
                 RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
               RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
             RowBox[{"Graphics", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                 "]"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                   RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], "]"}], ",", 
                
                RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
               "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
             "\[IndentingNewLine]", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
               "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
        "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"time", ",", "0", ",", "tfinal", ",", "0.05"}], "}"}]}], 
     "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}, 3.678443213160219*^9, {3.678443246790071*^9, 
   3.678443264995304*^9}, 3.678444364607957*^9, {3.6784494697756042`*^9, 
   3.678449469991518*^9}, {3.678450672333453*^9, 3.678450682636773*^9}, {
   3.678457168525358*^9, 3.678457178557231*^9}, {3.678462795865703*^9, 
   3.678462799043668*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "=", "a"}], ",", 
     RowBox[{"b", "=", "r"}], ",", 
     RowBox[{"s", "=", "ldeftest"}], ",", 
     RowBox[{"s2", "=", "lzero"}], ",", 
     RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"spinnermov1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "\[Pi]"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"spinnerinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"spinnercobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], "]"}], ",", 
                 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"time", ",", "0", ",", "39.6", ",", "0.3"}], "}"}]}], "]"}]}],
     ";"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}, 3.678443213160219*^9, {3.678443246790071*^9, 
   3.678443264995304*^9}, 3.678444364607957*^9, {3.6784494697756042`*^9, 
   3.678449469991518*^9}, {3.678450672333453*^9, 3.678450682636773*^9}, 
   3.6784571569523897`*^9, {3.678457400789865*^9, 3.6784574387229223`*^9}, 
   3.678462820313891*^9}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "=", "a"}], ",", 
     RowBox[{"b", "=", "r"}], ",", 
     RowBox[{"s", "=", "ldeftest"}], ",", 
     RowBox[{"s2", "=", "lzero"}], ",", 
     RowBox[{"offset", "=", "0"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"spinnermov1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"plot\[Theta]range", "=", "\[Pi]"}], ";", 
        RowBox[{"Column", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"spinnerinitConfig2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"MakeSSHpicvec", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Pi]", "/", "2"}], "-", 
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", "time", "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "num"}], "}"}]}], "]"}], ",", "r", ",", 
                "0"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"num", "+", "r", "+", ".2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "r"}], "-", ".2"}], ",", 
                   RowBox[{"r", "+", ".2"}]}], "}"}]}], "}"}]}]}], "]"}]}], 
           ",", 
           RowBox[{"spinnercobweb2", "=", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ContourPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s", "2"]}], ",", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"p", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                    RowBox[{"b", " ", 
                    RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"offset", "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                    RowBox[{"b", " ", 
                    RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}],
                    "\[Equal]", 
                   SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]1", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"ContourStyle", "->", 
                 RowBox[{"{", 
                  RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
                RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
                RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"Directive", "[", 
                  RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
                RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "plot\[Theta]range"}], ",", 
                    "plot\[Theta]range"}], "}"}]}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]2", ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", "Gray"}]}], "]"}], ",", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", 
                 "\[IndentingNewLine]", "Red", ",", "Dashed", ",", "Thick", 
                 ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"1", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"2", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "2"}], ",", "time"}], "]"}]}], "}"}]}], 
                    "}"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}]}], "}"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Point", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{
                    RowBox[{"num", "-", "1"}], ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"num", ",", "time"}], "]"}]}], "}"}], "]"}], ",", 
                 
                 RowBox[{"PointSize", "\[Rule]", "0.025"}], ",", "Blue", ",", 
                 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}], ",", 
                    RowBox[{"tht", "[", 
                    RowBox[{"i", ",", "time"}], "]"}]}], "}"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", "    ", 
              "\[IndentingNewLine]", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}]}], "}"}], 
         "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"time", ",", "0", ",", "1.2", ",", "0.01"}], "}"}]}], "]"}]}],
     ";"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.6419181924336042`*^9, 3.641918192795745*^9}, {
   3.641918224315197*^9, 3.641918245611887*^9}, 3.6419184228516273`*^9, {
   3.641918454868475*^9, 3.641918516374988*^9}, {3.641918564654211*^9, 
   3.6419185802969933`*^9}, {3.641918767906793*^9, 3.641918773418565*^9}, {
   3.641918844085845*^9, 3.641918845652803*^9}, {3.641918949550062*^9, 
   3.641918970959014*^9}, {3.641919006543298*^9, 3.6419190080642757`*^9}, 
   3.641919436458825*^9, {3.6429289471753063`*^9, 3.6429289855379744`*^9}, {
   3.646104469915996*^9, 3.6461044711109*^9}, {3.646104995235682*^9, 
   3.646104996586787*^9}, {3.6461051024999857`*^9, 3.646105104615291*^9}, {
   3.6461052672259912`*^9, 3.646105277859005*^9}, {3.646639691829754*^9, 
   3.646639703782104*^9}, {3.646639877979995*^9, 3.6466399139952393`*^9}, {
   3.646640139854476*^9, 3.6466401402690973`*^9}, {3.647865081380682*^9, 
   3.6478650829482517`*^9}, {3.647865693400537*^9, 3.647865693687845*^9}, {
   3.656936307865756*^9, 3.656936309016161*^9}, {3.65693646841236*^9, 
   3.6569365230538187`*^9}, {3.656936580607272*^9, 3.656936584334684*^9}, {
   3.6570369474097137`*^9, 3.657036948155251*^9}, {3.657036986830844*^9, 
   3.657036987277878*^9}, {3.657037074893056*^9, 3.657037084132267*^9}, {
   3.657037324455056*^9, 3.657037324775618*^9}, {3.657280965572711*^9, 
   3.657280967695822*^9}, {3.6572810457077*^9, 3.657281096363072*^9}, {
   3.657281217837921*^9, 3.6572812660579987`*^9}, {3.657281340596857*^9, 
   3.657281341041098*^9}, {3.65728137508187*^9, 3.657281416910913*^9}, {
   3.657281592101734*^9, 3.657281693445806*^9}, {3.6572819785782347`*^9, 
   3.657282003677493*^9}, {3.6572820673442087`*^9, 3.657282089026183*^9}, {
   3.657282121939183*^9, 3.6572821836186857`*^9}, {3.657282216500307*^9, 
   3.6572822166477613`*^9}, {3.6572822847625227`*^9, 
   3.6572823018540077`*^9}, {3.657282550217635*^9, 3.657282561518539*^9}, {
   3.657282603995636*^9, 3.6572828366368856`*^9}, {3.6572828740996304`*^9, 
   3.657282891971119*^9}, {3.657282963109695*^9, 3.657282984250083*^9}, {
   3.6572830914662237`*^9, 3.657283160729658*^9}, 3.657283200811064*^9, {
   3.657283274085322*^9, 3.657283287676269*^9}, {3.6572833204005213`*^9, 
   3.657283408398909*^9}, {3.657283483906308*^9, 3.657283494258847*^9}, {
   3.6572835852386227`*^9, 3.657283617412428*^9}, {3.65728368186524*^9, 
   3.657283694044734*^9}, {3.657283804013336*^9, 3.657283804187613*^9}, {
   3.657283901376614*^9, 3.657283926098329*^9}, {3.6572847019699583`*^9, 
   3.657284773982967*^9}, {3.65728486894088*^9, 3.657284889265271*^9}, {
   3.657284952292535*^9, 3.6572849823679028`*^9}, {3.6572850495567913`*^9, 
   3.6572852751299887`*^9}, {3.657285329088572*^9, 3.657285381042334*^9}, {
   3.657285427957659*^9, 3.657285448537669*^9}, {3.657285527785368*^9, 
   3.657285531697549*^9}, {3.6572855830152082`*^9, 3.657285642929261*^9}, 
   3.6572857331597557`*^9, {3.6640305609229517`*^9, 3.664030611387021*^9}, {
   3.664030660669182*^9, 3.6640306889396563`*^9}, {3.6640314352295628`*^9, 
   3.66403146649331*^9}, {3.6640322060173264`*^9, 3.664032256754158*^9}, {
   3.664035454678248*^9, 3.664035467260676*^9}, {3.664036883423864*^9, 
   3.664036886420992*^9}, {3.664036957633388*^9, 3.6640369727189283`*^9}, {
   3.664037394078307*^9, 3.664037408938485*^9}, {3.66403744482803*^9, 
   3.6640374968464613`*^9}, {3.664038688828669*^9, 3.6640386907289248`*^9}, {
   3.664038777332349*^9, 3.664038795259967*^9}, {3.6640388259458303`*^9, 
   3.664038881934807*^9}, {3.66403952756002*^9, 3.664039583836638*^9}, {
   3.664039616112369*^9, 3.6640396381096888`*^9}, {3.6640397012631617`*^9, 
   3.664039702550508*^9}, {3.664039803253636*^9, 3.664039805295443*^9}, {
   3.664041934679146*^9, 3.664041974203926*^9}, 3.664042030630123*^9, 
   3.664042661969695*^9, 3.664103834558689*^9, {3.6682527351686068`*^9, 
   3.6682527369125338`*^9}, 3.678443213160219*^9, {3.678443246790071*^9, 
   3.678443264995304*^9}, 3.678444364607957*^9, {3.6784494697756042`*^9, 
   3.678449469991518*^9}, {3.678450672333453*^9, 3.678450682636773*^9}, 
   3.6784571569523897`*^9, {3.678457400789865*^9, 3.6784574387229223`*^9}, 
   3.678462820313891*^9, 3.678462928988612*^9, {3.678462962683676*^9, 
   3.678462980875421*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<spinnermov_fast.gif\>\"", ",", "spinnermov1"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678443233696797*^9, 3.678443238448937*^9}, {
   3.678451230726532*^9, 3.67845124571772*^9}, {3.678457457806644*^9, 
   3.678457474175613*^9}, {3.67846284984196*^9, 3.6784628505644703`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<spinnermov_slow.gif\>\"", ",", "spinnermov1"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678443233696797*^9, 3.678443238448937*^9}, {
   3.678451230726532*^9, 3.67845124571772*^9}, {3.678457457806644*^9, 
   3.678457474175613*^9}, {3.67846284984196*^9, 3.6784628505644703`*^9}, {
   3.678462913173724*^9, 3.678462916486129*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<spinner_cobweb.pdf\>\"", ",", "spinnercobweb2"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678443233696797*^9, 3.678443238448937*^9}, {
   3.678443371146327*^9, 3.6784433951409683`*^9}, {3.678451281964787*^9, 
   3.678451283372718*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<spinner_conf.pdf\>\"", ",", "spinnerinitConfig2"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.664038900413718*^9, 3.664038930138418*^9}, {
   3.664039792354463*^9, 3.664039796207074*^9}, 3.664039841048921*^9, {
   3.664041987093017*^9, 3.664042003331444*^9}, {3.66404304646071*^9, 
   3.6640430467001038`*^9}, {3.678443233696797*^9, 3.678443238448937*^9}, {
   3.678443371146327*^9, 3.6784433951409683`*^9}, {3.6784512760364437`*^9, 
   3.678451287686808*^9}, 3.67845132306505*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Cobweb initial configuration", "Subsubsection",
 CellChangeTimes->{{3.6784422187794743`*^9, 3.6784422276553783`*^9}}],

Cell["ak profile plot", "Text",
 CellChangeTimes->{{3.668253832612967*^9, 3.668253841397224*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"X", "=", 
     RowBox[{"num", "/", "2"}]}], "}"}], ",", 
   RowBox[{"akprofile", "=", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"th", "[", "i", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Rotor index i\>\"", ",", 
           "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\""}], "}"}]}], 
        ",", 
        RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Directive", "[", 
           RowBox[{"Black", ",", 
            RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}], "}"}]}], ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "16", ",", "1"}], "}"}]}], "]"}], 
             ",", "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "600"}], ",", " ", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
        RowBox[{"FrameTicksStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"PointLegend", "[", 
            RowBox[{
             RowBox[{"{", "Black", "}"}], ",", 
             RowBox[{"{", "\"\<Discrete model\>\"", "}"}], ",", 
             RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"ArcSin", "[", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}], " ", 
          RowBox[{
           RowBox[{"Tanh", "[", 
            FractionBox[
             RowBox[{
              RowBox[{"n", " ", "a"}], " ", "-", " ", "X"}], 
             RowBox[{
              SuperscriptBox["a", "2"], "/", 
              RowBox[{"(", 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
           "r"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "0", ",", 
          RowBox[{"num", "+", "1"}]}], "}"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"LineLegend", "[", 
            RowBox[{
             RowBox[{"{", "Black", "}"}], ",", 
             RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "11"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.73", ",", "0.15"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directive", "[", "Black", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "4", "]"}]}], "}"}]}]}], "]"}]}],
      "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6682543188576317`*^9, 3.668254319473012*^9}, {
   3.668254396130886*^9, 3.6682545481671133`*^9}, {3.668254600441723*^9, 
   3.668254604856963*^9}, {3.66825464535389*^9, 3.6682547551324167`*^9}, {
   3.6682547883512297`*^9, 3.668254793602044*^9}, {3.6682548248784513`*^9, 
   3.668254839598712*^9}, {3.6682548856645927`*^9, 3.668254926208233*^9}, {
   3.668255046947856*^9, 3.668255083821601*^9}, {3.66825513762227*^9, 
   3.668255402704722*^9}, {3.668255520185114*^9, 3.6682555682028303`*^9}, {
   3.668255629539115*^9, 3.668255656036435*^9}, {3.668259169238269*^9, 
   3.668259197782448*^9}, {3.668264092983522*^9, 3.668264095125304*^9}, {
   3.668264125657189*^9, 3.668264169910407*^9}, {3.668264629462946*^9, 
   3.668264633045822*^9}, {3.66826483896979*^9, 3.668264839493454*^9}, {
   3.6683320642522173`*^9, 3.668332065449905*^9}, {3.668337368827119*^9, 
   3.6683373693869658`*^9}, {3.668340306083166*^9, 3.6683403093908367`*^9}, 
   3.66843717000922*^9, {3.674818750327927*^9, 3.674818801382846*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab$deviation$max", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "-", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}], " ", 
          RowBox[{
           RowBox[{"Tanh", "[", 
            FractionBox[
             RowBox[{"  ", 
              RowBox[{
               RowBox[{"i", " ", "a"}], " ", "-", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"num", "/", "2"}], "+", "0.5"}], ")"}]}]}], 
             RowBox[{
              SuperscriptBox["a", "2"], "/", 
              RowBox[{"(", 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
           "r"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6684371023552094`*^9, 3.6684371378912067`*^9}, {
  3.6684397473139277`*^9, 3.668439752784981*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab$deviation$min", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "-", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}], " ", 
          RowBox[{
           RowBox[{"Tanh", "[", 
            FractionBox[
             RowBox[{"  ", 
              RowBox[{
               RowBox[{"i", " ", "a"}], " ", "-", " ", 
               RowBox[{"(", 
                RowBox[{"num", "/", "2"}], ")"}]}]}], 
             RowBox[{
              SuperscriptBox["a", "2"], "/", 
              RowBox[{"(", 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
           "r"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6684371023552094`*^9, 3.66843714332451*^9}, 
   3.668437174612055*^9, {3.668439758801094*^9, 3.668439761648802*^9}}],

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{
   RowBox[{"tab$deviation$max", "\[LeftDoubleBracket]", 
    RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "^", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.668437633294342*^9, 3.668437649806642*^9}}],

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{
   RowBox[{"tab$deviation$min", "\[LeftDoubleBracket]", 
    RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "^", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.668437633294342*^9, 3.6684376578396177`*^9}}],

Cell[BoxData[
 RowBox[{"fig$deviationth06", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tab$deviation$max", ",", "tab$deviation$min"}], "}"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Rotor index i\>\"", ",", 
       "\"\<\!\(\*SubscriptBox[\(\[CapitalDelta]\[Theta]\), \(i\)]\)\>\""}], 
      "}"}]}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "16", ",", "1"}], "}"}]}], "]"}], ",",
          "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", " ", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"Placed", "[", 
      RowBox[{
       RowBox[{"PointLegend", "[", 
        RowBox[{"Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Peak of \!\(\*SubscriptBox[\(V\), \(PN\)]\)\>\"", ",", 
           "\"\<Valley of \!\(\*SubscriptBox[\(V\), \(PN\)]\)\>\""}], "}"}], 
         ",", 
         RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6684369939547653`*^9, 3.668436995825079*^9}, {
  3.668437034033144*^9, 3.668437065329885*^9}, {3.668437179940012*^9, 
  3.668437182725465*^9}, {3.6684383666101093`*^9, 3.668438375282552*^9}, {
  3.668438406578536*^9, 3.668438543841548*^9}, {3.66843982651584*^9, 
  3.668439844699543*^9}, {3.6684399643595753`*^9, 3.668439994391013*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<figDeviation_th=0.575.pdf\>\"", ",", "fig$deviationth06", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.668439954997221*^9, 3.66844001351488*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{
       RowBox[{"th", "[", "i", "]"}], "-", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}], " ", 
         RowBox[{
          RowBox[{"Tanh", "[", 
           FractionBox[
            RowBox[{"  ", 
             RowBox[{
              RowBox[{"i", " ", "a"}], " ", "-", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"num", "/", "2"}], "+", "0.5"}], ")"}]}]}], 
            RowBox[{
             SuperscriptBox["a", "2"], "/", 
             RowBox[{"(", 
              RowBox[{"2", "r", " ", 
               RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
          "r"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6684369939547653`*^9, 3.668436995825079*^9}, {
  3.668437034033144*^9, 3.668437075249748*^9}}],

Cell["trial", "Text",
 CellChangeTimes->{{3.6683382964449883`*^9, 3.66833829799683*^9}},
 FontColor->RGBColor[0, 1, 0]],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"X", "=", 
      RowBox[{
       RowBox[{"num", "/", "2"}], "+", "0.5"}]}], ",", 
     RowBox[{"tt", "=", "0"}]}], "}"}], ",", 
   RowBox[{"akprofile", "=", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Mod", "[", 
                  RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
                RowBox[{"\[Pi]", "-", 
                 RowBox[{
                  RowBox[{"ans$antikink$initial", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], ",", 
                RowBox[{
                 RowBox[{"ans$antikink$initial", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], "]"}]}],
              "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Mod", "[", 
                  RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
                RowBox[{"\[Pi]", "-", 
                 RowBox[{
                  RowBox[{"ans$antikink$initial", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"tt", "+", "2"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"ans$antikink$initial", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"tt", "+", "2"}], "]"}]}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Rotor index i\>\"", ",", 
           "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\""}], "}"}]}], 
        ",", 
        RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"{", "Blue", "}"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"{", "Green", "}"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.001"}]}], "]"}]}], "}"}]}], 
        ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "16", ",", "1"}], "}"}]}], "]"}], 
             ",", "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "600"}], ",", " ", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
        RowBox[{"FrameTicksStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"PointLegend", "[", 
            RowBox[{
             RowBox[{"{", "Blue", "}"}], ",", 
             RowBox[{"{", "\"\<Discrete model\>\"", "}"}], ",", 
             RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"ArcSin", "[", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}], " ", 
          RowBox[{
           RowBox[{"Tanh", "[", 
            FractionBox[
             RowBox[{
              RowBox[{"n", " ", "a"}], " ", "-", " ", "X"}], 
             RowBox[{
              SuperscriptBox["a", "2"], "/", 
              RowBox[{"(", 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
           "r"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "0", ",", 
          RowBox[{"num", "+", "1"}]}], "}"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"LineLegend", "[", 
            RowBox[{
             RowBox[{"{", "Red", "}"}], ",", 
             RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "11"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.71", ",", "0.15"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directive", "[", "Red", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "0.1", "]"}]}], "}"}]}]}], 
       "]"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQvaPw9tnFIa8dXym9B9MWBi3XQfS/iNZXIHqGEt9H
EG2XMxtMCwav/gaiD9mksCwB0m623Rwg+pOzMSeYLyPDC6KXaXzmA9ERLltF
QPSNlcckQfS1kHsaILrPq0oXRC9+aWwCokV7w0JBdMkb1hQQPa2WLQtE5zls
LATRVVqMpSD62Xx1nWVA+gLnTn0QzVw5f/IKIF3H9ARMb2TfOh1E8ynZzgXR
JRfWXQPRCeWK10F0K8f9D2D+qfdgWkuI48hJID0/VQ9MHyqXij4DpNmSdMD0
k8fXckG0Cw9TGYiewl5fDaJt52S1gWgAhT2hEg==
  "]],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"X", "=", 
      RowBox[{
       RowBox[{"num", "/", "2"}], "+", "0.5"}]}], ",", 
     RowBox[{"tt", "=", "10"}]}], "}"}], ",", 
   RowBox[{"akprofile", "=", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
               RowBox[{"\[Pi]", "-", 
                RowBox[{
                 RowBox[{"ans$antikink$initial", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], ",", 
               RowBox[{
                RowBox[{"ans$antikink$initial", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], "]"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "}"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Rotor index i\>\"", ",", 
           "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\""}], "}"}]}], 
        ",", 
        RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"{", "Blue", "}"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"{", "Green", "}"}], ",", 
             RowBox[{"PointSize", "\[Rule]", "0.001"}]}], "]"}]}], "}"}]}], 
        ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "16", ",", "1"}], "}"}]}], "]"}], 
             ",", "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "600"}], ",", " ", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
        RowBox[{"FrameTicksStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"PointLegend", "[", 
            RowBox[{
             RowBox[{"{", "Blue", "}"}], ",", 
             RowBox[{"{", "\"\<Discrete model\>\"", "}"}], ",", 
             RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"ArcSin", "[", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "th0", "]"}], " ", 
          RowBox[{
           RowBox[{"Tanh", "[", 
            FractionBox[
             RowBox[{
              RowBox[{"n", " ", "a"}], " ", "-", " ", "X"}], 
             RowBox[{
              SuperscriptBox["a", "2"], "/", 
              RowBox[{"(", 
               RowBox[{"2", "r", " ", 
                RowBox[{"Sin", "[", "th0", "]"}]}], ")"}]}]], "]"}], "/", 
           "r"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "0", ",", 
          RowBox[{"num", "+", "1"}]}], "}"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"LineLegend", "[", 
            RowBox[{
             RowBox[{"{", "Red", "}"}], ",", 
             RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"Graphics", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "11"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.71", ",", "0.15"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directive", "[", "Red", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "0.1", "]"}]}], "}"}]}]}], 
       "]"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQvaPw9tnFIa8dXym9B9MWBi3XQfS/iNZXIHqGEt9H
EG2XMxtMCwav/gaiD9mksCwB0m623Rwg+pOzMSeYLyPDC6KXaXzmA9ERLltF
QPSNlcckQfS1kHsaILrPq0oXRC9+aWwCokV7w0JBdMkb1hQQPa2WLQtE5zls
LATRVVqMpSD62Xx1nWVA+gLnTn0QzVw5f/IKIF3H9ARMb2TfOh1E8ynZzgXR
JRfWXQPRCeWK10F0K8f9D2D+qfdgWkuI48hJID0/VQ9MHyqXij4DpNmSdMD0
k8fXckG0Cw9TGYiewl5fDaJt52S1gegr/Cu7QHRMvX8viPb2ynt6Dki3eLeB
aQDBjrI3
  "]],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{{{}, {{}, 
       {RGBColor[0, 0, 1], PointSize[0.001], AbsoluteThickness[1.6], 
        PointBox[CompressedData["
1:eJw9k11IU2EYx5d9IBXuRAYixqZELGlxsrlWaftvTrfpFtqFF4UUZhcSIngl
g2AYXdRVCBlZpt1sGnQTDXex8ixEsA/NFVgiZFDkbsqr6so+zvN/z4HD4Xd+
h/e87/P8n+ru/rOXS2w2W8O/+/9Trg1/ZdoxUvvs2wxfILJjyB1zLZNLER5z
b1u88Y6sIdtxZdPTWSCXo7rsTcnOL0vkCtxantlnzyqugtsx1PM5pdgJZ9o3
WDOhuAaHhsPriTHFBzC4cCnUf1/xQczPdS1ut9iFbCbtXb2nuBb5Xk/mlcWH
UTHtK85afARr8eDVvMU6LnbsDjy3+ChK9fd61uI6/Na8qSmLj6FYuFl+3WIP
Jj8t9bosrsfL9QedjaOKvdDX5rTiHcXHkXOcn9wyrNiH5M/Ru3uuKT6BiafR
wkCX4pPAx+6v83/ekk/hhf12j32/4ga0T638+O55TW5EKHXuwmr9LPk0jK25
fN+vx2Q/KkdM9rO9SBrm98JJID1trkcfgLbX/B99AOMr5n7og3BlzP3SB5GT
89A34YOcl74JdVIP+hAMqRd9CA+lnvTN2JB60zdjU/pB3wJN+kXfovpJH1b9
pg9jl+SBPgJD8kIfwSPJE30UhuSNPoqE5JG+Fbrklb4VVZJn+jY4Je/0bUjI
PNDHoMm80MfwROaJPg7IvNHHEZR5pD8Dn8yr/y/O9idk
         "]]}, {}}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[0.1], Opacity[1.], 
       LineBox[CompressedData["
1:eJwt23c81d//AHDJSBMVGRUpe+/9fl13UUgbDZmFJCsjRBEZEZkNpbLJTpKr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        "]]}}}, {InsetBox[
      TemplateBox[{"\"Discrete model\""},
       "PointLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"PointLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              InterpretationBox[
               ButtonBox[
                TooltipBox[
                 GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                  True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                  FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[0, 0, 1]"], Appearance -> 
                None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                DefaultBaseStyle -> {}, ButtonFunction :> 
                With[{Typeset`box$ = EvaluationBox[]}, 
                  If[
                   Not[
                    AbsoluteCurrentValue["Deployed"]], 
                   SelectionMove[Typeset`box$, All, Expression]; 
                   FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                   FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                   FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                   MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                Automatic, Method -> "Preemptive"], 
               RGBColor[0, 0, 1], Editable -> False, Selectable -> False], 
              "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"Joined", "\[Rule]", 
              RowBox[{"{", "False", "}"}]}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"{", 
                  RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
            RowBox[{"LegendMarkerSize", "\[Rule]", "30"}]}], "]"}]& )], 
      Scaled[{0.7, 0.25}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm], InsetBox[
      TemplateBox[{"\"Continuum theory\""},
       "LineLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {
                    InsetBox[
                    GraphicsBox[{
                    AbsoluteThickness[4], 
                    LineBox[{{-11, 0}, {11, 0}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 10},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              InterpretationBox[
               ButtonBox[
                TooltipBox[
                 GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                  True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                  FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "RGBColor[1, 0, 0]"], Appearance -> 
                None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                DefaultBaseStyle -> {}, ButtonFunction :> 
                With[{Typeset`box$ = EvaluationBox[]}, 
                  If[
                   Not[
                    AbsoluteCurrentValue["Deployed"]], 
                   SelectionMove[Typeset`box$, All, Expression]; 
                   FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                   FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                   FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                   MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                Automatic, Method -> "Preemptive"], 
               RGBColor[1, 0, 0], Editable -> False, Selectable -> False], 
              "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              GraphicsBox[{
                AbsoluteThickness[4], 
                LineBox[{{-11, 0}, {11, 0}}]}]}]}], "]"}]& )], 
      Scaled[{0.71, 0.15}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox[
      "\"\\!\\(\\*SubscriptBox[\\(\[Theta]\\), \\(i\\)]\\)\"", 
       TraditionalForm], None}, {
      FormBox["\"Rotor index i\"", TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->{{Automatic, None}, {{{1, 
        FormBox["1", TraditionalForm]}, {2, 
        FormBox["2", TraditionalForm]}, {3, 
        FormBox["3", TraditionalForm]}, {4, 
        FormBox["4", TraditionalForm]}, {5, 
        FormBox["5", TraditionalForm]}, {6, 
        FormBox["6", TraditionalForm]}, {7, 
        FormBox["7", TraditionalForm]}, {8, 
        FormBox["8", TraditionalForm]}, {9, 
        FormBox["9", TraditionalForm]}, {10, 
        FormBox["10", TraditionalForm]}, {11, 
        FormBox["11", TraditionalForm]}, {12, 
        FormBox["12", TraditionalForm]}, {13, 
        FormBox["13", TraditionalForm]}, {14, 
        FormBox["14", TraditionalForm]}, {15, 
        FormBox["15", TraditionalForm]}, {16, 
        FormBox["16", TraditionalForm]}}, None}},
   FrameTicksStyle->Directive[FontSize -> Large],
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->600,
   LabelStyle->Directive[FontSize -> Large],
   Method->{},
   PlotRange->{{0, 60.}, {-0.7418415958502209, 0.7418415958502242}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   RotateLabel->False,
   Ticks->{Automatic, Automatic}],
  InterpretTemplate[Legended[
    Graphics[{{{}, {{{}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           PointSize[0.011000000000000001`], 
           AbsoluteThickness[1.6], 
           RGBColor[0, 0, 1], PointSize -> 0.001], 
          Point[CompressedData["
1:eJw9k11IU2EYx5d9IBXuRAYixqZELGlxsrlWaftvTrfpFtqFF4UUZhcSIngl
g2AYXdRVCBlZpt1sGnQTDXex8ixEsA/NFVgiZFDkbsqr6so+zvN/z4HD4Xd+
h/e87/P8n+ru/rOXS2w2W8O/+/9Trg1/ZdoxUvvs2wxfILJjyB1zLZNLER5z
b1u88Y6sIdtxZdPTWSCXo7rsTcnOL0vkCtxantlnzyqugtsx1PM5pdgJZ9o3
WDOhuAaHhsPriTHFBzC4cCnUf1/xQczPdS1ut9iFbCbtXb2nuBb5Xk/mlcWH
UTHtK85afARr8eDVvMU6LnbsDjy3+ChK9fd61uI6/Na8qSmLj6FYuFl+3WIP
Jj8t9bosrsfL9QedjaOKvdDX5rTiHcXHkXOcn9wyrNiH5M/Ru3uuKT6BiafR
wkCX4pPAx+6v83/ekk/hhf12j32/4ga0T638+O55TW5EKHXuwmr9LPk0jK25
fN+vx2Q/KkdM9rO9SBrm98JJID1trkcfgLbX/B99AOMr5n7og3BlzP3SB5GT
89A34YOcl74JdVIP+hAMqRd9CA+lnvTN2JB60zdjU/pB3wJN+kXfovpJH1b9
pg9jl+SBPgJD8kIfwSPJE30UhuSNPoqE5JG+Fbrklb4VVZJn+jY4Je/0bUjI
PNDHoMm80MfwROaJPg7IvNHHEZR5pD8Dn8yr/y/O9idk
           
           "]]}, {}}}, {}}, {{{}, {}, {
         Directive[
          Opacity[1.], 
          RGBColor[1, 0, 0], 
          AbsoluteThickness[0.1]], 
         Line[CompressedData["
1:eJwt23c81d//AHDJSBMVGRUpe+/9fl13UUgbDZmFJCsjRBEZEZkNpbLJTpKr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          "]]}}}}, {
     DisplayFunction -> Identity, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, AxesOrigin -> {0, 0}, 
      PlotRange -> {{0, 60.}, {-0.7418415958502209, 0.7418415958502242}}, 
      DisplayFunction -> Identity, AspectRatio -> GoldenRatio^(-1), 
      Axes -> {True, True}, AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
      DisplayFunction :> Identity, Frame -> {{True, True}, {True, True}}, 
      FrameLabel -> {{"\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)", None}, {
        "Rotor index i", None}}, FrameStyle -> Thickness[Large], 
      FrameTicks -> {{
        Automatic, None}, {{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
          16}, None}}, FrameTicksStyle -> Directive[FontSize -> Large], 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
      Directive[FontSize -> Large], Method -> {}, 
      PlotRange -> {{0, 60.}, {-0.7418415958502209, 0.7418415958502242}}, 
      PlotRangeClipping -> True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, RotateLabel -> False, 
      Ticks -> {Automatic, Automatic}}], 
    Placed[
     Unevaluated[
      Unevaluated[
       LineLegend[{
         RGBColor[1, 0, 0]}, {"Continuum theory"}, LabelStyle -> 
        Directive[FontSize -> Large], LegendLayout -> "Column", LegendMarkers -> 
        Graphics[{
           AbsoluteThickness[4], 
           Line[{{-11, 0}, {11, 0}}]}]]]], {0.71, 0.15}, Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Input",
 CellChangeTimes->{3.668342588930719*^9}],

Cell["spring stretch plot", "Text",
 CellChangeTimes->{{3.668253846661188*^9, 3.668253858357335*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"ak$springstretch", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"lconf", "[", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], ",", 
         RowBox[{"th", "[", 
          RowBox[{"i", "+", "1"}], "]"}], ",", "r", ",", "a"}], "]"}], "-", 
       "lzero"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "20"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"Directive", "[", " ", 
      RowBox[{
       RowBox[{"Thickness", "[", "0.01", "]"}], ",", "Black"}], "]"}]}], ",", 
    " ", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "0.3", ",", "0.1"}], "}"}]}], "]"}], 
         ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "15", ",", "1"}], "}"}]}], "]"}], ",",
          "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<Spring index i\>\"", ",", "\"\<Spring stretching \!\(\*
StyleBox[SubscriptBox[
StyleBox[\"l\",
FontFamily->\"Times New Roman\",
FontSize->20,
FontWeight->\"Plain\",
FontSlant->\"Italic\"], 
RowBox[{\"i\", \",\", 
RowBox[{\"i\", \"+\", \"1\"}]}]],
FontFamily->\"Times New Roman\",
FontSize->20,
FontWeight->\"Plain\"]\)\!\(\*
StyleBox[\"-\",
FontFamily->\"Times New Roman\",
FontSize->20,
FontWeight->\"Plain\"]\)\!\(\*
StyleBox[OverscriptBox[\"l\", \"_\"],
FontFamily->\"Times New Roman\",
FontSize->20,
FontWeight->\"Plain\"]\)\>\""}], "}"}]}], ",", " ", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "Thick"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.657292845808055*^9, 3.657292847843989*^9}, {
   3.657292879636819*^9, 3.657292933901325*^9}, {3.657293041789467*^9, 
   3.657293093513582*^9}, {3.657293127726243*^9, 3.657293211710026*^9}, {
   3.657968354307075*^9, 3.657968520848226*^9}, 3.657968551742188*^9, {
   3.657969038200721*^9, 3.657969046145557*^9}, {3.6579690779979267`*^9, 
   3.657969082847416*^9}, {3.6611491384546556`*^9, 3.6611491386263*^9}, {
   3.6611492144697657`*^9, 3.661149214708304*^9}, {3.665486112101255*^9, 
   3.6654861230618*^9}, {3.665486398364087*^9, 3.665486400252779*^9}, {
   3.668264191222838*^9, 3.668264219446351*^9}, {3.6682642613686857`*^9, 
   3.668264275688025*^9}, {3.668264313627906*^9, 3.668264322745894*^9}, {
   3.668264352778265*^9, 3.668264358074779*^9}, {3.668264416220954*^9, 
   3.668264418059754*^9}, {3.66826446153493*^9, 3.668264505518257*^9}, {
   3.6682649242663097`*^9, 3.66826492961087*^9}, {3.6748188612567797`*^9, 
   3.674818862061391*^9}}],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "-", 
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Sin", "[", 
                 RowBox[{
                  RowBox[{"ans$antikink$initial", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], 
                "-", "  ", 
                RowBox[{"Sin", "[", 
                 RowBox[{
                  RowBox[{"ans$antikink$initial", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
                 "]"}]}], ")"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", " ", 
            RowBox[{"r", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"ans$antikink$initial", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], "-",
                " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"ans$antikink$initial", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
                "]"}]}], ")"}]}], ")"}], "2"]}], "]"}], "-", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"numdef", "-", "1"}]}], ",", 
           SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], 
       ")"}], "2"]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "\[Rule]", "tfinal"}], ",", 
      RowBox[{"ldef", "\[Rule]", "lzero"}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", 
     RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.657970327734157*^9, 3.657970338676621*^9}}],

Cell[BoxData[
 RowBox[{"akconfigpn1", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
    RowBox[{"Epilog", "->", 
     RowBox[{"{", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<P.E.= 1359.15\>\"", ",", "Italic", ",", 
          RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"8.5", ",", "1.5"}], "}"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"PlotRangePadding", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1.1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6579724258784533`*^9, 3.6579724762302933`*^9}, {
   3.6579725123763323`*^9, 3.657972605577079*^9}, 3.657972645402557*^9, {
   3.657972705796606*^9, 3.6579727155875883`*^9}, 3.657972793363867*^9, {
   3.6579728581765947`*^9, 3.65797285834376*^9}}],

Cell[BoxData[
 RowBox[{"akconfigpn2", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
    RowBox[{"Epilog", "->", 
     RowBox[{"{", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<P.E.= 1359.75\>\"", ",", "Italic", ",", 
          RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"8.5", ",", "1.5"}], "}"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"PlotRangePadding", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1.1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6579724258784533`*^9, 3.6579724762302933`*^9}, {
   3.6579725123763323`*^9, 3.657972647082361*^9}, {3.657972717590213*^9, 
   3.657972719227909*^9}, 3.6579727965366583`*^9, {3.657972860653509*^9, 
   3.657972860822506*^9}}],

Cell[BoxData["lzero"], "Input",
 CellChangeTimes->{{3.657970720677039*^9, 3.65797072113356*^9}}],

Cell[BoxData["1359.1499126335589`"], "Input",
 CellChangeTimes->{3.657970479271294*^9}],

Cell[BoxData["1359.7522411379723`"], "Input",
 CellChangeTimes->{3.657970343334717*^9}],

Cell["Compare f(n) with numerical spring potential", "Text",
 CellChangeTimes->{{3.668257963799405*^9, 3.66825797983078*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"bond$potential", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"fbond", "[", 
           RowBox[{"i", ",", 
            RowBox[{"num", "/", "2"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"lconf", "[", 
            RowBox[{
             RowBox[{"th", "[", "i", "]"}], ",", 
             RowBox[{"th", "[", 
              RowBox[{"i", "+", "1"}], "]"}], ",", "r", ",", "a"}], "]"}], 
           "-", "lzero"}], ")"}], "2"], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<i\>\"", ",", "\"\<Bond potential / (1/2 k)\>\""}], "}"}]}],
     ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Green", ",", 
         RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", " ", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"Placed", "[", 
      RowBox[{
       RowBox[{"PointLegend", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Blue", ",", "Green"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<f(n,X=7.5)\>\"", ",", "\"\<Simulation\>\""}], "}"}], 
         ",", 
         RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.668257987850662*^9, {3.668258295295579*^9, 3.668258493267973*^9}, {
   3.668258630423683*^9, 3.668258661057325*^9}, {3.668258691593136*^9, 
   3.668258766696454*^9}, {3.6682588012779493`*^9, 3.668258908797905*^9}, {
   3.668258945537957*^9, 3.6682589895867643`*^9}, {3.668259055202539*^9, 
   3.668259130548533*^9}, 3.668259212565796*^9, {3.66826084396791*^9, 
   3.6682608557637863`*^9}, {3.668265586457344*^9, 3.668265610471121*^9}, 
   3.668338456307807*^9, 3.668338527750162*^9, {3.668338561941741*^9, 
   3.668338562517068*^9}, {3.668340640056136*^9, 3.6683406410694447`*^9}}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{{}, {{{}, {}, 
       {RGBColor[0, 0, 1], PointSize[0.03], AbsoluteThickness[1.6], 
        LineBox[CompressedData["
1:eJxTTMoPSmViYGCwBmIQDQEf7Kc57RQKfGJpDRVwEKtn9EjJSoLyORw23KrO
tTTqgvIFHBSYFbaeXbgJyhdxWMY115in8RaUL+HQNPvFnbs3mWwgfBkHw3Px
KmcuaEH5Cg6SZ6o2ThMKhvKVHHQ+BPytVqyG8lUcdKMeS/7yXgzlqzncajrt
JVd8GsrXcDDbWLKQs+0zlK/lsHKFRtiWo9K2EL6OA3uM4vIjB5yhfD0He+8/
f8wlc6B8A4c993xeyf6ZDOUbOizUeGxdkbsHyjdy4M+5lLzf/AmUb+wwN6xd
zvcgjx2Eb+LQaLHZfkOhCZRv6tBYU67EzBcL5Zs5ZH7T7Zg6rwXKN3cQkOve
6aS7Fsq3cFjAULvFsO4KlG/psPjptY+93n+gfCuHfkcHzkWHlOwhfGuHoAPh
hfzr3KB8G4f5CbWMJflpUL6tQ5h027tTAnVQvp1Dw5a7l303tEL59mjyDqj6
GxzQzHdEtb/BEc19Tqjub3BC858zqv8bnNHCxwU1/Bpc0MLXFTX8G1zR4scN
Nf4a3NDi1x01/hvc0dKHB2r6afBAS1+eqOmvwRMtfXqhpt8GL7T07Y2a/hu8
0fKHD2r+afBBy1++qPmvwdcBlj8BDuH1aw==
         "]]}, 
       {RGBColor[0, 1, 0], PointSize[0.03], AbsoluteThickness[1.6], 
        LineBox[CompressedData["
1:eJxTTMoPSmViYGCwBmIQDQEf7EFkyvtrVlABByCe4K4uYg3hcoD4Qu3tLlC+
AJDvsO0KRxGULwLkC0g/Y58H5UuA1DMp1J+A8mWA/J9MOy59hvIVHBgcnNhr
f8vbQPhKDg037DpXHvGE8lUcHGK2fo0+UALlqzmcMIpZ5b51AZSv4XCnKN3X
9vkpKF/LIVPnRtWOFV+hfB0Hs4Nu/tfzFW0hfD0HvZCfbz2EfaB8A4df0cL+
CrPKoHxDBxb/hfV8RougfCMHrlUf/03yPgvlGzvU7rU8v23KdyjfxEEySIdR
4ZeSHYRv6tArYjPrWZsflG/mMPXA9hWbWyqgfHMHNz6PUN35i6F8C4eHUfEb
K+TPQ/mWDvMk9y5pVvwB5Vs57CrYdUhvq6I9hG/tsG2bt/K8p25Qvo3Di5IL
GuqX06B8W4d3W982L9CrhfLtHJreWixYFdsC5ds7BLQiyzs41Bsg6W9wcAiM
Qzbf0UFGBcn+BkeHnrV7kNzn5HDwShzC/Q1ODpO3uSP5z9lBSQnJ/w3ODs1S
1kjh44Iafg0uDgtn2CGFr6tDI9MrRPg3uKLFj5vDO6/jfvD4a3BDi1931Phv
cHdIeaBdi0gfHqjpp8HD4dPz11sR6cvTgUFzhl0MLP01eKKlTy8HhieBc6th
6bcByJ9wz2YXPH17OzA0PGBUh6X/BiCfweGTIAcsf/gA+QwrJTih+acBzFcI
6YDlL18Q/0maBjT/NYD5DD9/XLMCAI8T7CY=
         "]]}}, {
       {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCwBmJGIGZigIEP9tOcdgoFPrG0hgo4iNUzeqRkJUH5HA4b
blXnWhp1QfkCDgrMClvPLtwE5Ys4LOOaa8zTeAvKl3Bomv3izt2bTDYQvoyD
4bl4lTMXtKB8BQfJM1UbpwkFQ/lKDjofAv5WK1ZD+SoOulGPJX95L4by1Rxu
NZ32kis+DeVrOJhtLFnI2fYZytdyWLlCI2zLUWlbCF/HgT1GcfmRA85Qvp6D
vfefP+aSOVC+gcOeez6vZP9MhvINHRZqPLauyN0D5Rs58OdcSt5v/gTKN3aY
G9Yu53uQxw7CN3FotNhsv6HQBMo3dWisKVdi5ouF8s0cMr/pdkyd1wLlmzsI
yHXvdNJdC+VbOCxgqN1iWHcFyrd0WPz02sde7z9QvpVDv6MD56JDSvYQvrVD
0IHwQv51blC+jcP8hFrGkvw0KN/WIUy67d0pgToo386hYcvdy74bWqF8ezR5
B1T9DQ5o5jui2t/giOY+J1T3Nzih+c8Z1f8Nzmjh44Iafg0uaOHrihr+Da5o
8eOGGn8Nbmjx644a/w3uaOnDAzX9NHigpS9P1PTX4ImWPr1Q02+DF1r69kZN
/w3eaPnDBzX/NPig5S9f1PzX4OsAy58AHfX1bQ==
         "]]}, 
       {RGBColor[0, 1, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledSquare]\"\>",
           StripOnInput->False,
           FontSize->8.96], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGCwBmJGIGZigIEP9iAy5f01K6iAAxBPcFcXsYZwOUB8ofZ2
FyhfAMh32HaFowjKFwHyBaSfsc+D8iVA6pkU6k9A+TJA/k+mHZc+Q/kKDgwO
Tuy1v+VtIHwlh4Ybdp0rj3hC+SoODjFbv0YfKIHy1RxOGMWsct+6AMrXcLhT
lO5r+/wUlK/lkKlzo2rHiq9Qvo6D2UE3/+v5irYQvp6DXsjPtx7CPlC+gcOv
aGF/hVllUL6hA4v/wno+o0VQvpED16qP/yZ5n4XyjR1q91qe3zblO5Rv4iAZ
pMOo8EvJDsI3degVsZn1rM0PyjdzmHpg+4rNLRVQvrmDG59HqO78xVC+hcPD
qPiNFfLnoXxLh3mSe5c0K/6A8q0cdhXsOqS3VdEewrd22LbNW3neUzco38bh
RckFDfXLaVC+rcO7rW+bF+jVQvl2Dk1vLRasim2B8u0dAlqR5R0c6g2Q9Dc4
OATGIZvv6CCjgmR/g6NDz9o9SO5zcjh4JQ7h/gYnh8nb3JH85+ygpITk/wZn
h2Ypa6TwcUENvwYXh4Uz7JDC19WhkekVIvwbXNHix83hnddxP3j8Nbihxa87
avw3uDukPNCuRaQPD9T00+Dh8On5662I9OXpwKA5wy4Glv4aPNHSp5cDw5PA
udWw9NsA5E+4Z7MLnr69HRgaHjCqw9J/A5DP4PBJkAOWP3yAfIaVEpzQ/NMA
5iuEdMDyly+I/yRNA5r/GsB8hp8/rlkBAJ4n7Cg=
         "]]}, {}}}, {}}, InsetBox[
     TemplateBox[{"\"f(n,X=7.5)\"","\"Simulation\""},
      "PointLegend",
      DisplayFunction->(FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], {
                    LineBox[{{0, 30}, {30, 30}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], FontSize -> 8.96, Plain, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #}, {
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 1, 0]], {
                    LineBox[{{0, 30}, {30, 30}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 1, 0]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 1, 0]], FontSize -> 8.96, Plain, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]& ),
      Editable->True,
      InterpretationFunction:>(RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                ButtonBox[
                 TooltipBox[
                  GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                   True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                   FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                   Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  "RGBColor[0, 0, 1]"], Appearance -> None, BaseStyle -> {}, 
                 BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                 ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                   If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                 Automatic, Method -> "Preemptive"], 
                RGBColor[0, 0, 1], Editable -> False, Selectable -> False], 
               ",", 
               InterpretationBox[
                ButtonBox[
                 TooltipBox[
                  GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 1, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                   True, FrameStyle -> RGBColor[0., 0.6666666666666666, 0.], 
                   FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                   Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  "RGBColor[0, 1, 0]"], Appearance -> None, BaseStyle -> {}, 
                 BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                 ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                   If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 1, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                 Automatic, Method -> "Preemptive"], 
                RGBColor[0, 1, 0], Editable -> False, Selectable -> False]}], 
             "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledCircle]\"", ",", "8.96`"}], "}"}], ",", 
                 
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledSquare]\"", ",", "8.96`"}], "}"}]}], 
               "}"}]}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "30"}]}], "]"}]& )], 
     Scaled[{0.7, 0.25}], ImageScaled[{0.5, 0.5}],
     BaseStyle->{FontSize -> Larger},
     FormatType->StandardForm]},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox["\"Bond potential / (1/2 k)\"", TraditionalForm], None}, {
      FormBox["\"i\"", TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   FrameTicksStyle->Directive[FontSize -> Large],
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->600,
   LabelStyle->Directive[FontSize -> Large],
   Method->{},
   PlotRange->{{0, 59.}, {0, 0.010590179470194139`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  InterpretTemplate[Legended[
    Graphics[{{}, {{{}, {}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          PointSize[0.009166666666666668], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 0, 1], PointSize -> 0.03], 
         Line[CompressedData["
1:eJxTTMoPSmViYGCwBmIQDQEf7Kc57RQKfGJpDRVwEKtn9EjJSoLyORw23KrO
tTTqgvIFHBSYFbaeXbgJyhdxWMY115in8RaUL+HQNPvFnbs3mWwgfBkHw3Px
KmcuaEH5Cg6SZ6o2ThMKhvKVHHQ+BPytVqyG8lUcdKMeS/7yXgzlqzncajrt
JVd8GsrXcDDbWLKQs+0zlK/lsHKFRtiWo9K2EL6OA3uM4vIjB5yhfD0He+8/
f8wlc6B8A4c993xeyf6ZDOUbOizUeGxdkbsHyjdy4M+5lLzf/AmUb+wwN6xd
zvcgjx2Eb+LQaLHZfkOhCZRv6tBYU67EzBcL5Zs5ZH7T7Zg6rwXKN3cQkOve
6aS7Fsq3cFjAULvFsO4KlG/psPjptY+93n+gfCuHfkcHzkWHlOwhfGuHoAPh
hfzr3KB8G4f5CbWMJflpUL6tQ5h027tTAnVQvp1Dw5a7l303tEL59mjyDqj6
GxzQzHdEtb/BEc19Tqjub3BC858zqv8bnNHCxwU1/Bpc0MLXFTX8G1zR4scN
Nf4a3NDi1x01/hvc0dKHB2r6afBAS1+eqOmvwRMtfXqhpt8GL7T07Y2a/hu8
0fKHD2r+afBBy1++qPmvwdcBlj8BDuH1aw==
          "]]}, {
         Hue[0.9060679774997897, 0.6, 0.6], 
         Directive[
          PointSize[0.009166666666666668], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 1, 0], PointSize -> 0.03], 
         Line[CompressedData["
1:eJxTTMoPSmViYGCwBmIQDQEf7EFkyvtrVlABByCe4K4uYg3hcoD4Qu3tLlC+
AJDvsO0KRxGULwLkC0g/Y58H5UuA1DMp1J+A8mWA/J9MOy59hvIVHBgcnNhr
f8vbQPhKDg037DpXHvGE8lUcHGK2fo0+UALlqzmcMIpZ5b51AZSv4XCnKN3X
9vkpKF/LIVPnRtWOFV+hfB0Hs4Nu/tfzFW0hfD0HvZCfbz2EfaB8A4df0cL+
CrPKoHxDBxb/hfV8RougfCMHrlUf/03yPgvlGzvU7rU8v23KdyjfxEEySIdR
4ZeSHYRv6tArYjPrWZsflG/mMPXA9hWbWyqgfHMHNz6PUN35i6F8C4eHUfEb
K+TPQ/mWDvMk9y5pVvwB5Vs57CrYdUhvq6I9hG/tsG2bt/K8p25Qvo3Di5IL
GuqX06B8W4d3W982L9CrhfLtHJreWixYFdsC5ds7BLQiyzs41Bsg6W9wcAiM
Qzbf0UFGBcn+BkeHnrV7kNzn5HDwShzC/Q1ODpO3uSP5z9lBSQnJ/w3ODs1S
1kjh44Iafg0uDgtn2CGFr6tDI9MrRPg3uKLFj5vDO6/jfvD4a3BDi1931Phv
cHdIeaBdi0gfHqjpp8HD4dPz11sR6cvTgUFzhl0MLP01eKKlTy8HhieBc6th
6bcByJ9wz2YXPH17OzA0PGBUh6X/BiCfweGTIAcsf/gA+QwrJTih+acBzFcI
6YDlL18Q/0maBjT/NYD5DD9/XLMCAI8T7CY=
          "]]}}, {{
         Directive[
          PointSize[0.009166666666666668], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 0, 1], PointSize -> 0.03, 
          AbsolutePointSize[6]], 
         GeometricTransformation[
          Inset[
           Style["\[FilledCircle]", FontSize -> 8.96], {0., 
           0.}], CompressedData["
1:eJxTTMoPSmVmYGCwBmJGIGZigIEP9tOcdgoFPrG0hgo4iNUzeqRkJUH5HA4b
blXnWhp1QfkCDgrMClvPLtwE5Ys4LOOaa8zTeAvKl3Bomv3izt2bTDYQvoyD
4bl4lTMXtKB8BQfJM1UbpwkFQ/lKDjofAv5WK1ZD+SoOulGPJX95L4by1Rxu
NZ32kis+DeVrOJhtLFnI2fYZytdyWLlCI2zLUWlbCF/HgT1GcfmRA85Qvp6D
vfefP+aSOVC+gcOeez6vZP9MhvINHRZqPLauyN0D5Rs58OdcSt5v/gTKN3aY
G9Yu53uQxw7CN3FotNhsv6HQBMo3dWisKVdi5ouF8s0cMr/pdkyd1wLlmzsI
yHXvdNJdC+VbOCxgqN1iWHcFyrd0WPz02sde7z9QvpVDv6MD56JDSvYQvrVD
0IHwQv51blC+jcP8hFrGkvw0KN/WIUy67d0pgToo386hYcvdy74bWqF8ezR5
B1T9DQ5o5jui2t/giOY+J1T3Nzih+c8Z1f8Nzmjh44Iafg0uaOHrihr+Da5o
8eOGGn8Nbmjx644a/w3uaOnDAzX9NHigpS9P1PTX4ImWPr1Q02+DF1r69kZN
/w3eaPnDBzX/NPig5S9f1PzX4OsAy58AHfX1bQ==
          "]]}, {
         Directive[
          PointSize[0.009166666666666668], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 1, 0], PointSize -> 0.03, 
          AbsolutePointSize[6]], 
         GeometricTransformation[
          Inset[
           Style["\[FilledSquare]", FontSize -> 8.96], {0., 
           0.}], CompressedData["
1:eJxTTMoPSmVmYGCwBmJGIGZigIEP9iAy5f01K6iAAxBPcFcXsYZwOUB8ofZ2
FyhfAMh32HaFowjKFwHyBaSfsc+D8iVA6pkU6k9A+TJA/k+mHZc+Q/kKDgwO
Tuy1v+VtIHwlh4Ybdp0rj3hC+SoODjFbv0YfKIHy1RxOGMWsct+6AMrXcLhT
lO5r+/wUlK/lkKlzo2rHiq9Qvo6D2UE3/+v5irYQvp6DXsjPtx7CPlC+gcOv
aGF/hVllUL6hA4v/wno+o0VQvpED16qP/yZ5n4XyjR1q91qe3zblO5Rv4iAZ
pMOo8EvJDsI3degVsZn1rM0PyjdzmHpg+4rNLRVQvrmDG59HqO78xVC+hcPD
qPiNFfLnoXxLh3mSe5c0K/6A8q0cdhXsOqS3VdEewrd22LbNW3neUzco38bh
RckFDfXLaVC+rcO7rW+bF+jVQvl2Dk1vLRasim2B8u0dAlqR5R0c6g2Q9Dc4
OATGIZvv6CCjgmR/g6NDz9o9SO5zcjh4JQ7h/gYnh8nb3JH85+ygpITk/wZn
h2Ypa6TwcUENvwYXh4Uz7JDC19WhkekVIvwbXNHix83hnddxP3j8Nbihxa87
avw3uDukPNCuRaQPD9T00+Dh8On5662I9OXpwKA5wy4Glv4aPNHSp5cDw5PA
udWw9NsA5E+4Z7MLnr69HRgaHjCqw9J/A5DP4PBJkAOWP3yAfIaVEpzQ/NMA
5iuEdMDyly+I/yRNA5r/GsB8hp8/rlkBAJ4n7Cg=
          "]]}, {}}}, {}}, {
     DisplayFunction -> Identity, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}}, AxesOrigin -> {0, 0}, 
      PlotRange -> {{0, 59.}, {0, 0.010590179470194139`}}, DisplayFunction -> 
      Identity, AspectRatio -> GoldenRatio^(-1), Axes -> {True, True}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
      Identity, Frame -> {{True, True}, {True, True}}, 
      FrameLabel -> {{"Bond potential / (1/2 k)", None}, {"i", None}}, 
      FrameStyle -> Thickness[Large], 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      FrameTicksStyle -> Directive[FontSize -> Large], 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
      Directive[FontSize -> Large], Method -> {}, 
      PlotRange -> {{0, 59.}, {0, 0.010590179470194139`}}, PlotRangeClipping -> 
      True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], 
    Placed[
     Unevaluated[
      PointLegend[{
        RGBColor[0, 0, 1], 
        RGBColor[0, 1, 0]}, {"f(n,X=7.5)", "Simulation"}, 
       Joined -> {True, True}, LabelStyle -> Directive[FontSize -> Large], 
       LegendLayout -> "Column", 
       LegendMarkers -> {{"\[FilledCircle]", 8.96}, {
         "\[FilledSquare]", 8.96}}, LegendMarkerSize -> 30]], {0.7, 0.25}, 
     Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Input",
 CellChangeTimes->{3.668342603394938*^9}],

Cell["trial", "Text",
 CellChangeTimes->{{3.66833862709263*^9, 3.668338627972443*^9}},
 FontColor->RGBColor[0, 1, 0]],

Cell[BoxData[
 RowBox[{"bond$potential$log", "=", 
  RowBox[{"ListLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"fbond", "[", 
           RowBox[{"i", ",", "7.5"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"lconf", "[", 
            RowBox[{
             RowBox[{"th", "[", "i", "]"}], ",", 
             RowBox[{"th", "[", 
              RowBox[{"i", "+", "1"}], "]"}], ",", "r", ",", "a"}], "]"}], 
           "-", "lzero"}], ")"}], "2"], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<i\>\"", ",", "\"\<Bond potential / (1/2 k)\>\""}], "}"}]}],
     ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Green", ",", 
         RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", " ", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"Placed", "[", 
      RowBox[{
       RowBox[{"PointLegend", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Blue", ",", "Green"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<f(n,X=7.5)\>\"", ",", "\"\<Simulation\>\""}], "}"}], 
         ",", 
         RowBox[{"LegendMarkerSize", "\[Rule]", "30"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "Giving", " ", "a", " ", "wrong", " ", "impression", " ", "of", " ", 
    "edge", " ", "spring", " ", "contributing", " ", "more"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{
  3.668257987850662*^9, {3.668258295295579*^9, 3.668258493267973*^9}, {
   3.668258630423683*^9, 3.668258661057325*^9}, {3.668258691593136*^9, 
   3.668258766696454*^9}, {3.6682588012779493`*^9, 3.668258908797905*^9}, {
   3.668258945537957*^9, 3.6682589895867643`*^9}, {3.668259055202539*^9, 
   3.668259130548533*^9}, 3.668259212565796*^9, {3.66826084396791*^9, 
   3.6682608557637863`*^9}, {3.668265586457344*^9, 3.6682656227227297`*^9}, {
   3.6682657144902554`*^9, 3.668265741952063*^9}, {3.668338532028132*^9, 
   3.668338532772311*^9}}],

Cell["Export", "Text",
 CellChangeTimes->{{3.668257983398855*^9, 3.668257985702919*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kcobweb.pdf\>\"", ",", "kcobweb", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.656936088017592*^9, 3.656936093552821*^9}, 
   3.656936176387632*^9, {3.65693660684559*^9, 3.656936615470303*^9}, 
   3.656936685935628*^9, {3.656952102651569*^9, 3.656952103371085*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kconfig.pdf\>\"", ",", "kinitConfig", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.656936088017592*^9, 3.656936093552821*^9}, 
   3.656936176387632*^9, {3.656936604589052*^9, 3.656936619853451*^9}, 
   3.656936686319365*^9, 3.656952112145083*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kcobweb2.pdf\>\"", ",", "kcobweb2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.656936088017592*^9, 3.656936093552821*^9}, 
   3.656936176387632*^9, {3.656936604589052*^9, 3.656936619853451*^9}, 
   3.656936686319365*^9, 3.656952112145083*^9, {3.657283210246746*^9, 
   3.657283228342071*^9}, 3.657284491605307*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kconfig2.pdf\>\"", ",", "kinitConfig2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.656936088017592*^9, 3.656936093552821*^9}, 
   3.656936176387632*^9, {3.656936604589052*^9, 3.656936619853451*^9}, 
   3.656936686319365*^9, 3.656952112145083*^9, {3.657283210246746*^9, 
   3.65728322495133*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akcobweb.pdf\>\"", ",", "akcobweb", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936625022431*^9, 3.6569366329101877`*^9}, 
   3.6569366869756107`*^9, 3.6569521126489077`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akcobweb2.pdf\>\"", ",", "akcobweb2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936625022431*^9, 3.6569366329101877`*^9}, 
   3.6569366869756107`*^9, 3.6569521126489077`*^9, {3.657291777790593*^9, 
   3.6572917836911592`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akconfig.pdf\>\"", ",", "akinitConfig", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936596317356*^9, 3.656936597154888*^9}, {
   3.6569366358549957`*^9, 3.6569366362073936`*^9}, 3.656936687807905*^9, 
   3.6569521133302517`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akconfig2.pdf\>\"", ",", "akinitConfig2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936596317356*^9, 3.656936597154888*^9}, {
   3.6569366358549957`*^9, 3.6569366362073936`*^9}, 3.656936687807905*^9, 
   3.6569521133302517`*^9, {3.65729177910247*^9, 3.657291786089039*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akspringstretch.pdf\>\"", ",", "ak$springstretch", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936596317356*^9, 3.656936597154888*^9}, {
   3.6569366358549957`*^9, 3.6569366362073936`*^9}, 3.656936687807905*^9, 
   3.6569521133302517`*^9, {3.65729177910247*^9, 3.657291786089039*^9}, {
   3.657293214849086*^9, 3.657293236157598*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akconfigpn1.pdf\>\"", ",", "akconfigpn1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936596317356*^9, 3.656936597154888*^9}, {
   3.6569366358549957`*^9, 3.6569366362073936`*^9}, 3.656936687807905*^9, 
   3.6569521133302517`*^9, {3.65729177910247*^9, 3.657291786089039*^9}, {
   3.657293214849086*^9, 3.657293236157598*^9}, {3.657972671324627*^9, 
   3.657972681844853*^9}, {3.657972721348198*^9, 3.657972730035997*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akconfigpn2.pdf\>\"", ",", "akconfigpn2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.6569360834414463`*^9, 3.6569361064332247`*^9}, 
   3.656936179250939*^9, {3.656936596317356*^9, 3.656936597154888*^9}, {
   3.6569366358549957`*^9, 3.6569366362073936`*^9}, 3.656936687807905*^9, 
   3.6569521133302517`*^9, {3.65729177910247*^9, 3.657291786089039*^9}, {
   3.657293214849086*^9, 3.657293236157598*^9}, {3.657972671324627*^9, 
   3.657972735708219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<bondpotential.pdf\>\"", ",", "bond$potential", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.668259134607964*^9, 3.668259152803267*^9}, {
  3.6682592049172173`*^9, 3.6682592078115463`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<akprofile.pdf\>\"", ",", "akprofile", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.668259134607964*^9, 3.668259152803267*^9}, {
  3.668259188245276*^9, 3.668259202868917*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Plot initial old", "Subsubsection",
 CellChangeTimes->{{3.656936567452032*^9, 3.656936571227952*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kcobweb", "=", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"ContourPlot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"p", "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                  RowBox[{"b", " ", 
                   RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
               "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"offset", "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}], 
              "\[Equal]", 
              SuperscriptBox["s", "2"]}], ",", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"p", "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Sin", "[", "\[Theta]2", "]"}]}], "-", 
                  RowBox[{"b", " ", 
                   RowBox[{"Sin", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"], 
               "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"offset", "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Cos", "[", "\[Theta]2", "]"}]}], "+", 
                  RowBox[{"b", " ", 
                   RowBox[{"Cos", "[", "\[Theta]1", "]"}]}]}], ")"}], "2"]}], 
              "\[Equal]", 
              SuperscriptBox["s2", "2"]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]1", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]2", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
           RowBox[{"ContourStyle", "->", 
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Black"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"\[Theta]1", "=", "\[Theta]2"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]2", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"PointSize", "\[Rule]", "Medium"}], ",", 
            "\[IndentingNewLine]", "Green", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"th", "[", "i", "]"}], ",", 
                   RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}], 
                ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "2"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "numdef"}], "}"}]}], "]"}], ",", 
            RowBox[{"(*", "left", "*)"}], "\[IndentingNewLine]", "Orange", 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"th", "[", "i", "]"}], ",", 
                   RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}], "]"}], ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", 
                    RowBox[{"i", "-", "1"}], "]"}], ",", 
                    RowBox[{"th", "[", "i", "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", "i", "]"}]}], "}"}]}], "}"}], "]"}], 
                ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", "i", "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"th", "[", "i", "]"}], ",", 
                    RowBox[{"th", "[", 
                    RowBox[{"i", "+", "1"}], "]"}]}], "}"}]}], "}"}], "]"}]}],
                "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{"numdef", "+", "1"}], ",", 
                RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"(*", "right", "*)"}], "\[IndentingNewLine]", "Blue", ",", 
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"th", "[", "numdef", "]"}], ",", 
               RowBox[{"th", "[", 
                RowBox[{"numdef", "+", "1"}], "]"}]}], "}"}], "]"}]}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", "    ", "\[IndentingNewLine]", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i\)]\)\>\"", ",", 
            "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(i + 1\)]\)\>\""}], 
           "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}], ",", 
      RowBox[{"kinitConfig", "=", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"MakeSSHpicvec", "[", 
          RowBox[{"initialold", ",", "r", ",", "0"}], "]"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]}], "}"}], "]"}], 
   ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"p", ",", "a", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "r", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "ldeftest", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s2", ",", "lzero", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"offset", ",", "0", ",", "20"}], "}"}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Parameters:", "Subsubsection",
 CellChangeTimes->{{3.640424371251751*^9, 3.6404243733638983`*^9}, 
   3.643794424649222*^9}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Set", " ", "spring", " ", "constant"}], ",", " ", 
      RowBox[{"the", " ", "middle", " ", "one", 
       RowBox[{"(", 
        RowBox[{"numdef", "-"}], ")"}], " ", "is", " ", "defect"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "numdef"}], ",", "1.", ",", "1"}], "]"}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{
  3.640424653270735*^9, {3.640426039006236*^9, 3.64042603948577*^9}, {
   3.640427607970706*^9, 3.64042760827555*^9}, 3.640518715638544*^9, {
   3.6411144338996477`*^9, 3.641114434089059*^9}, {3.6419090520188227`*^9, 
   3.641909052174922*^9}, {3.641914205159912*^9, 3.641914205647525*^9}, 
   3.641917919912653*^9, {3.641918141658436*^9, 3.6419181463688593`*^9}, {
   3.641919158027295*^9, 3.641919158572529*^9}, {3.6419194615780563`*^9, 
   3.6419194816179953`*^9}, {3.641921084220599*^9, 3.6419210843760157`*^9}, {
   3.641921128058433*^9, 3.641921131196067*^9}, 3.641923295376092*^9, 
   3.641923669366274*^9, {3.642827750493176*^9, 3.6428277509708643`*^9}, {
   3.6428282142806683`*^9, 3.642828221910026*^9}, {3.6428282690182657`*^9, 
   3.6428282783118553`*^9}, {3.6428284530940943`*^9, 3.642828467213619*^9}, 
   3.6428300960548487`*^9, {3.643435300003549*^9, 3.643435316528255*^9}, 
   3.643444213301071*^9, {3.6464003956266823`*^9, 3.646400429658367*^9}, 
   3.646400735334195*^9, {3.646635298509819*^9, 3.646635306480156*^9}, 
   3.646635451152596*^9, {3.646635658117671*^9, 3.6466356800368*^9}, 
   3.6466359962444677`*^9, {3.6466360632184753`*^9, 3.646636075839163*^9}, {
   3.646640582488885*^9, 3.646640600391419*^9}, {3.6469010356381807`*^9, 
   3.64690104629418*^9}, {3.646901111750577*^9, 3.646901114701926*^9}, 
   3.6489769284798193`*^9}],

Cell[BoxData["ldefcritical"], "Input",
 CellChangeTimes->{{3.6431076480555563`*^9, 3.643107653342964*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["1", "Subsubsection",
 CellChangeTimes->{
  3.641010577364818*^9, {3.641912764853805*^9, 3.6419127654179068`*^9}}],

Cell[BoxData[
 RowBox[{"tableContent", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ldef", ">", "ldefcritical"}], ",", 
       RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "15"}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"thetaright", "=", 
         RowBox[{"th", "[", 
          RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"thetaleft", "/.", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
              "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
             "\[Equal]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", "8"}], ",", 
               SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}]}], 
            "\[IndentingNewLine]", ",", 
            RowBox[{"{", 
             RowBox[{"thetaleft", ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[GreaterEqual]", "9"}], ",", "1", ",", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"i", "\[GreaterEqual]", "8"}], ",", "0.5", ",", 
                  "1"}], "]"}]}], "]"}], ",", 
              RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"initial", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"True", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "+", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"initialold", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Pi]", "/", "2"}], "-", 
         RowBox[{"initial", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"R", "=", 
        RowBox[{"MakeSSHrig", "[", 
         RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
         "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"e", "=", 
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"v", "=", 
          RowBox[{"v0", " ", 
           RowBox[{"e", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"e", "[", "modenum_", "]"}], ":=", 
        RowBox[{
         RowBox[{"Eigensystem", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", 
           RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
       RowBox[{"(*", 
        RowBox[{"+", 
         RowBox[{
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"modenum", "=", "0"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"thetapos", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"thetaneg", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"KEnergy", ">", "pEmin"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
        "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"v", ":=", 
      RowBox[{"v0", "  ", 
       RowBox[{"Normal", "[", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{"klchainmd2", "[", 
       RowBox[{
       "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
        "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DualSolPos", ":=", 
      RowBox[{"FindCrossingDual3", "[", 
       RowBox[{
        RowBox[{"GetDat", "[", 
         RowBox[{"ans", ",", "t"}], "]"}], ",", "thetapos", ",", "thetaneg"}],
        "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "version2", " ", "use", " ", "mid", " ", "point", " ", "of", " ", 
        "\[Theta]pos", " ", "and", " ", "\[Theta]neg", " ", "as", " ", "0"}], 
       ",", 
       RowBox[{
       "version3", " ", "use", " ", "sss", " ", "point", " ", "as", " ", 
        "0"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"leftsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rightsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<ldef=\>\"", ",", "ldef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
       "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tpEmin=\>\"", ",", 
       RowBox[{"pEmin", "=", 
        RowBox[{"0.5", "*", 
         RowBox[{"kk", "[", "8", "]"}], "*", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"ldef", "-", "ldefcritical"}], ")"}], "2"]}]}], ",", 
       "\"\<\\tkE=\>\"", ",", 
       RowBox[{"kEnergy", "=", 
        RowBox[{"0.5", " ", 
         RowBox[{"M", "[", "num", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
       "\"\<\\ttime1=\>\"", ",", 
       RowBox[{"time1", "=", 
        RowBox[{"lefttimeAt", "[", "3", "]"}]}], ",", "\"\<\\tesprings=\>\"", 
       ",", 
       RowBox[{
        RowBox[{"espring", "[", 
         RowBox[{"time1", ",", "8"}], "]"}], "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"espring", "[", 
           RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthety", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthetx", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"conftab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              RowBox[{"ans", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tablength", "=", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
        "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tabstart", "=", "1"}], ";", 
     RowBox[{"tabfinal", "=", "tablength"}], ";", 
     RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"jpstart", "=", "tabstart"}], ";", 
     RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
     RowBox[{"jpinterval", "=", "tabinterval"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "ldef"}], ",", 
    RowBox[{
     RowBox[{"eright", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"eleft", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"espring", "[", 
      RowBox[{"time1", ",", "8"}], "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{"eright", "[", "0", "]"}], ",", "pEmin", ",", 
    RowBox[{"leftsolitab", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], ",", "v0", ",", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"espring", "[", 
        RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6435208266409273`*^9, 
   3.643520837693817*^9}, {3.645277963641089*^9, 3.645278002147551*^9}, {
   3.6464005775561867`*^9, 3.646400632604178*^9}, 3.65729116946198*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 : measure at tfinal", "Subsubsection",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109799773177*^9}, {3.6431100663235197`*^9, 3.643110120164934*^9}, {
   3.647084590325815*^9, 3.647084593926147*^9}}],

Cell[BoxData[
 RowBox[{"tableContent2", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ldef", ">", "ldefcritical"}], ",", 
       RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"numdef", "=", 
      RowBox[{
       RowBox[{"IntegerPart", "[", 
        RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
      "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
       " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"numx", "=", "num"}], ";", 
        RowBox[{
         RowBox[{"th", "[", "numx", "]"}], "=", 
         RowBox[{"thinit", "/.", 
          RowBox[{
           RowBox[{"Solve", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"h", ":=", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
              RowBox[{
               RowBox[{
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r", "2"], "-", 
                  SuperscriptBox["h", "2"]}]], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"lzero", "-", "r"}], ")"}], 
                 RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}],
              ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
       RowBox[{"(*", 
        RowBox[{
        "where", " ", "the", " ", "configuration", " ", "initialization", " ",
          "starts"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"numx", "=", 
         RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"numx", "-", "1"}]}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"thetaright", "=", 
         RowBox[{"th", "[", 
          RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"thetaleft", "/.", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
              "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
             "\[Equal]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", 
                RowBox[{"numdef", "-", "1"}]}], ",", 
               RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
            "\[IndentingNewLine]", ",", 
            RowBox[{"{", 
             RowBox[{"thetaleft", ",", "1", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"numx", "+", "1"}]}], ",", 
       RowBox[{"i", "\[LessEqual]", "num"}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"thetaleft", "=", 
         RowBox[{"th", "[", 
          RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"thetaright", "/.", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
              "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
             "\[Equal]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", 
                RowBox[{"numdef", "-", "1"}]}], ",", 
               RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
            "\[IndentingNewLine]", ",", 
            RowBox[{"{", 
             RowBox[{"thetaright", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"initial", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"True", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "+", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"initialold", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Pi]", "/", "2"}], "-", 
         RowBox[{"initial", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"R", "=", 
        RowBox[{"MakeSSHrig", "[", 
         RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
         "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"e", "=", 
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"v", "=", 
          RowBox[{"v0", " ", 
           RowBox[{"e", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"e", "[", "modenum_", "]"}], ":=", 
        RowBox[{
         RowBox[{"Eigensystem", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", 
           RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
       RowBox[{"(*", 
        RowBox[{"+", 
         RowBox[{
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"modenum", "=", "0"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"thetapos", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"thetaneg", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"KEnergy", ">", "pEmin"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
        "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"rerunConfigQ", "==", "True"}], ",", 
       RowBox[{
        RowBox[{"initialold", "=", "reanstab"}], ";", 
        RowBox[{"initial", "=", "reinitialtab"}], ";"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"R", "=", 
      RowBox[{"MakeSSHrig", "[", 
       RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
       "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"kMatrix", "=", 
      RowBox[{"Normal", "[", 
       RowBox[{"SparseArray", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", 
           RowBox[{"kk", "[", "i", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"es", "=", 
      RowBox[{"Eigensystem", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", "R", "]"}], ".", "kMatrix", ".", "R"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"e", "[", "modenum_", "]"}], ":=", 
      RowBox[{"es", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", 
         RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
     RowBox[{"(*", 
      RowBox[{"+", 
       RowBox[{
        RowBox[{"Eigensystem", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", 
          RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"v", "=", 
      RowBox[{"v0", " ", 
       RowBox[{"e", "[", "modenum", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"mixmodeQ", "\[Equal]", "True"}], ",", 
       RowBox[{
        RowBox[{"v", "=", 
         RowBox[{"v0", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"e", "[", "modenum1", "]"}], "+", 
            RowBox[{"e", "[", "modenum2", "]"}]}], ")"}]}]}], ";"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"v", ":=", 
        RowBox[{"v0", "  ", 
         RowBox[{"Normal", "[", 
          RowBox[{"SparseArray", "[", 
           RowBox[{
            RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
       ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"rerunVelQ", ",", 
       RowBox[{
        RowBox[{"v", "=", "reveltab"}], ";"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{"klchainmd2", "[", 
       RowBox[{
       "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
        "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DualSolPos", ":=", 
      RowBox[{"FindCrossingDual3", "[", 
       RowBox[{
        RowBox[{"GetDat", "[", 
         RowBox[{"ans", ",", "t"}], "]"}], ",", "thetapos", ",", "thetaneg"}],
        "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "version2", " ", "use", " ", "mid", " ", "point", " ", "of", " ", 
        "\[Theta]pos", " ", "and", " ", "\[Theta]neg", " ", "as", " ", "0"}], 
       ",", 
       RowBox[{
       "version3", " ", "use", " ", "sss", " ", "point", " ", "as", " ", 
        "0"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"leftsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rightsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<ldef=\>\"", ",", "ldef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
       "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tpEmin=\>\"", ",", 
       RowBox[{"pEmin", "=", 
        RowBox[{"0.5", "*", 
         RowBox[{"kk", "[", 
          RowBox[{"numdef", "-", "1"}], "]"}], "*", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"ldef", "-", "ldefcritical"}], ")"}], "2"]}]}], ",", 
       "\"\<\\tkE=\>\"", ",", 
       RowBox[{"kEnergy", "=", 
        RowBox[{"0.5", " ", 
         RowBox[{"M", "[", "num", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
       "\"\<\\ttime1=\>\"", ",", 
       RowBox[{"time1", "=", 
        RowBox[{"{", "tfinal", "}"}]}], ",", "\"\<\\tesprings=\>\"", ",", 
       RowBox[{
        RowBox[{"espring", "[", 
         RowBox[{"time1", ",", 
          RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"espring", "[", 
           RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthety", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthetx", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"conftab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              RowBox[{"ans", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tablength", "=", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
        "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tabstart", "=", "1"}], ";", 
     RowBox[{"tabfinal", "=", "tablength"}], ";", 
     RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"jpstart", "=", "tabstart"}], ";", 
     RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
     RowBox[{"jpinterval", "=", "tabinterval"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "ldef"}], ",", 
    RowBox[{
     RowBox[{"eright", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"eleft", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"espring", "[", 
      RowBox[{"time1", ",", 
       RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{"eright", "[", "0", "]"}], ",", "pEmin", ",", 
    RowBox[{"leftsolitab", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], ",", "v0", ",", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"espring", "[", 
        RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109767599832*^9}, 3.643435101387239*^9, 3.6435208578161383`*^9, {
   3.6464006561085863`*^9, 3.6464006578013277`*^9}, {3.646638869342173*^9, 
   3.646638932988068*^9}, 3.6466391137957277`*^9, {3.646640088288583*^9, 
   3.6466400969878273`*^9}, {3.646640184207391*^9, 3.646640207463784*^9}, {
   3.646640422940943*^9, 3.6466404385466623`*^9}, {3.6466406697006607`*^9, 
   3.646640671195651*^9}, {3.646643151111965*^9, 3.646643325407386*^9}, {
   3.646643381972577*^9, 3.646643382038714*^9}, {3.64664342582504*^9, 
   3.646643502470538*^9}, 3.6466437198842373`*^9, 3.6466474962975693`*^9, {
   3.646647540965953*^9, 3.6466475410718727`*^9}, {3.646648410254504*^9, 
   3.646648420638062*^9}, {3.646649058686038*^9, 3.646649157386436*^9}, {
   3.646649191981741*^9, 3.6466492527592773`*^9}, {3.646649644247415*^9, 
   3.646649676440136*^9}, 3.646907573751183*^9, {3.646911293119287*^9, 
   3.646911294298976*^9}, {3.6471774691806192`*^9, 3.647177527196322*^9}, {
   3.647178477621952*^9, 3.647178513754067*^9}, {3.647256614011697*^9, 
   3.6472567031712523`*^9}, 3.64725697104585*^9, {3.647257091145218*^9, 
   3.64725716332209*^9}, {3.6472572008579597`*^9, 3.647257258455936*^9}, 
   3.6472573811527863`*^9, 3.64725780084163*^9, {3.6472579049493017`*^9, 
   3.647257906155842*^9}, 3.647769201355101*^9, {3.647785022529758*^9, 
   3.6477850865416307`*^9}, {3.647835682883335*^9, 3.6478356834591923`*^9}, {
   3.647865772123517*^9, 3.647865776872213*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["3 : bulk separate ", "Subsubsection",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109799773177*^9}, {3.6431100663235197`*^9, 3.643110120164934*^9}, {
   3.647084590325815*^9, 3.647084593926147*^9}, {3.647091646855192*^9, 
   3.647091655379676*^9}}],

Cell[BoxData[
 RowBox[{"tableContent3", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ldef", ">", "ldefcritical"}], ",", 
       RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"numdef", "=", 
      RowBox[{
       RowBox[{"IntegerPart", "[", 
        RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
      "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
       " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"numx", "=", "num"}], ";", 
        RowBox[{
         RowBox[{"th", "[", "numx", "]"}], "=", 
         RowBox[{"thinit", "/.", 
          RowBox[{
           RowBox[{"Solve", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"h", ":=", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
              RowBox[{
               RowBox[{
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r", "2"], "-", 
                  SuperscriptBox["h", "2"]}]], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"lzero", "-", "r"}], ")"}], 
                 RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}],
              ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
       RowBox[{"(*", 
        RowBox[{
        "where", " ", "the", " ", "configuration", " ", "initialization", " ",
          "starts"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"numx", "=", 
         RowBox[{"num", " ", "kpos"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"numx", "-", "1"}]}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"thetaright", "=", 
         RowBox[{"th", "[", 
          RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"thetaleft", "/.", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
              "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
             "\[Equal]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", 
                RowBox[{"numdef", "-", "1"}]}], ",", 
               RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
            "\[IndentingNewLine]", ",", 
            RowBox[{"{", 
             RowBox[{"thetaleft", ",", "1", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"numx", "+", "1"}]}], ",", 
       RowBox[{"i", "\[LessEqual]", "num"}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"thetaleft", "=", 
         RowBox[{"th", "[", 
          RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"th", "[", "i", "]"}], "=", 
         RowBox[{"thetaright", "/.", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"a", "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                 RowBox[{"r", " ", 
                  RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], 
              "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
             "\[Equal]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", 
                RowBox[{"numdef", "-", "1"}]}], ",", 
               RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
            "\[IndentingNewLine]", ",", 
            RowBox[{"{", 
             RowBox[{"thetaright", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"initial", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"True", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "+", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"initialold", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Pi]", "/", "2"}], "-", 
         RowBox[{"initial", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"R", "=", 
        RowBox[{"MakeSSHrig", "[", 
         RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
         "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"e", "=", 
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"v", "=", 
          RowBox[{"v0", " ", 
           RowBox[{"e", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"e", "[", "modenum_", "]"}], ":=", 
        RowBox[{
         RowBox[{"Eigensystem", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", 
           RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
       RowBox[{"(*", 
        RowBox[{"+", 
         RowBox[{
          RowBox[{"Eigensystem", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"modenum", "=", "0"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"thetapos", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"thetaneg", "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "0", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "0", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"KEnergy", ">", "pEmin"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
        "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"e3", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Normal", "@", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"IntegerPart", "[", 
                RowBox[{"num", "/", "2"}], "]"}], ",", "1"}], "}"}], 
             "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"antipush", "\[Equal]", "1"}], ",", "1", ",", "0"}], 
              "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"IntegerPart", "[", 
                RowBox[{
                 RowBox[{"num", "/", "2"}], "+", "1"}], "]"}], ",", "1"}], 
              "}"}], "\[Rule]", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"num", ",", "1"}], "}"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"v", "=", 
      RowBox[{"v0", " ", "e3"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"v", ":=", 
        RowBox[{"v0", "  ", 
         RowBox[{"Normal", "[", 
          RowBox[{"SparseArray", "[", 
           RowBox[{
            RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
       ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{"klchainmd2", "[", 
       RowBox[{
       "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
        "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DualSolPos", ":=", 
      RowBox[{"FindCrossingDual3", "[", 
       RowBox[{
        RowBox[{"GetDat", "[", 
         RowBox[{"ans", ",", "t"}], "]"}], ",", "thetapos", ",", "thetaneg"}],
        "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "version2", " ", "use", " ", "mid", " ", "point", " ", "of", " ", 
        "\[Theta]pos", " ", "and", " ", "\[Theta]neg", " ", "as", " ", "0"}], 
       ",", 
       RowBox[{
       "version3", " ", "use", " ", "sss", " ", "point", " ", "as", " ", 
        "0"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"leftsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rightsolitab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"DualSolPos", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<ldef=\>\"", ",", "ldef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
       "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tpEmin=\>\"", ",", 
       RowBox[{"pEmin", "=", 
        RowBox[{"0.5", "*", 
         RowBox[{"kk", "[", 
          RowBox[{"numdef", "-", "1"}], "]"}], "*", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"ldef", "-", "ldefcritical"}], ")"}], "2"]}]}], ",", 
       "\"\<\\tkE=\>\"", ",", 
       RowBox[{"kEnergy", "=", 
        RowBox[{"0.5", " ", 
         RowBox[{"M", "[", "num", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
       "\"\<\\ttime1=\>\"", ",", 
       RowBox[{"time1", "=", 
        RowBox[{"{", "tfinal", "}"}]}], ",", "\"\<\\tesprings=\>\"", ",", 
       RowBox[{
        RowBox[{"espring", "[", 
         RowBox[{"time1", ",", 
          RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"espring", "[", 
           RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthety", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthetx", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"conftab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              RowBox[{"ans", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tablength", "=", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
        "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tabstart", "=", "1"}], ";", 
     RowBox[{"tabfinal", "=", "tablength"}], ";", 
     RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"jpstart", "=", "tabstart"}], ";", 
     RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
     RowBox[{"jpinterval", "=", "tabinterval"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "ldef"}], ",", 
    RowBox[{
     RowBox[{"eright", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"eleft", "[", "time1", "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{
     RowBox[{"espring", "[", 
      RowBox[{"time1", ",", 
       RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}], ",", 
    RowBox[{"eright", "[", "0", "]"}], ",", "pEmin", ",", 
    RowBox[{"leftsolitab", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], ",", "v0", ",", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"espring", "[", 
        RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109767599832*^9}, 3.643435101387239*^9, 3.6435208578161383`*^9, {
   3.6464006561085863`*^9, 3.6464006578013277`*^9}, {3.646638869342173*^9, 
   3.646638932988068*^9}, 3.6466391137957277`*^9, {3.646640088288583*^9, 
   3.6466400969878273`*^9}, {3.646640184207391*^9, 3.646640207463784*^9}, {
   3.646640422940943*^9, 3.6466404385466623`*^9}, {3.6466406697006607`*^9, 
   3.646640671195651*^9}, {3.646643151111965*^9, 3.646643325407386*^9}, {
   3.646643381972577*^9, 3.646643382038714*^9}, {3.64664342582504*^9, 
   3.646643502470538*^9}, 3.6466437198842373`*^9, 3.6466474962975693`*^9, {
   3.646647540965953*^9, 3.6466475410718727`*^9}, {3.646648410254504*^9, 
   3.646648420638062*^9}, {3.646649058686038*^9, 3.646649157386436*^9}, {
   3.646649191981741*^9, 3.6466492527592773`*^9}, {3.646649644247415*^9, 
   3.646649676440136*^9}, 3.646907573751183*^9, {3.646911293119287*^9, 
   3.646911294298976*^9}, {3.647091658615889*^9, 3.647091658694935*^9}, {
   3.647091698618347*^9, 3.6470917305612593`*^9}, {3.647091847280841*^9, 
   3.647091955971171*^9}, 3.647092019046671*^9, 3.647092359216652*^9, {
   3.647092883549415*^9, 3.64709289488692*^9}, {3.64709337258529*^9, 
   3.6470933739105177`*^9}, {3.64959675590987*^9, 3.649596757938243*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["5 : normal kink ", "Subsubsection",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109799773177*^9}, {3.6431100663235197`*^9, 3.643110120164934*^9}, {
   3.647084590325815*^9, 3.647084593926147*^9}, {3.647091646855192*^9, 
   3.647091655379676*^9}, 3.649596937842533*^9, {3.650288009008955*^9, 
   3.6502880120323057`*^9}, {3.655472306683299*^9, 3.655472309226905*^9}}],

Cell[BoxData[
 RowBox[{"tableContent5", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"kk", "[", 
      RowBox[{"numdef", "-", "1"}], "]"}], "=", "kkdef"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"M", "[", "numdef", "]"}], "=", "Mdef"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"IntegerPart", "[", 
         RowBox[{"num", " ", "kpos"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"R", "=", 
     RowBox[{"MakeSSHrig", "[", 
      RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
      "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"e", "=", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", "  ", 
      RowBox[{"(*", " ", 
       RowBox[{"find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"v", "=", 
       RowBox[{"v0", " ", 
        RowBox[{"e", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e", "[", "modenum_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Eigensystem", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", 
        RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"+", 
      RowBox[{
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", 
         RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"modenum", "=", "0"}], ";", 
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"e", "[", "modenum", "]"}], "\[LeftDoubleBracket]", "i", 
            "\[RightDoubleBracket]"}], ")"}], "2"], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], "}"}]}], 
        "]"}], "<", "0.5"}], ",", 
      RowBox[{"modenum", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"thetapos", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", "1", ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"thetaneg", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"KEnergy", ">", "pEmin"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
       "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"v", "=", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Sign", "[", "initialold", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}], "\[Equal]", 
         RowBox[{
          RowBox[{"Sign", "[", 
           RowBox[{"e", "[", "modenum", "]"}], "]"}], "\[LeftDoubleBracket]", 
          
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}]}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"kgoleft", ",", 
          RowBox[{"-", "1"}], ",", "1"}], "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"kgoleft", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "]"}]}], "]"}], "v0", " ", 
      RowBox[{"e", "[", "modenum", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"v", ":=", 
       RowBox[{"v0", "  ", 
        RowBox[{"Normal", "[", 
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
      ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ans", "=", 
     RowBox[{"klchainmd2", "[", 
      RowBox[{
      "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
       "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"DualSolPos", ":=", 
     RowBox[{"FindCrossingDual3", "[", 
      RowBox[{
       RowBox[{"GetDat", "[", 
        RowBox[{"ans", ",", "t"}], "]"}], ",", "thetapos", ",", "thetaneg"}], 
      "]"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "version2", " ", "use", " ", "mid", " ", "point", " ", "of", " ", 
       "\[Theta]pos", " ", "and", " ", "\[Theta]neg", " ", "as", " ", "0"}], 
      ",", 
      RowBox[{
      "version3", " ", "use", " ", "sss", " ", "point", " ", "as", " ", 
       "0"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"leftsolitab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{"DualSolPos", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
        "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"rightsolitab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{"DualSolPos", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
        "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Mute", "\[NotEqual]", "True"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<ldef=\>\"", ",", "ldef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
        "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tpEmin=\>\"", ",", 
        RowBox[{"pEmin", "=", 
         RowBox[{"0.5", "*", 
          RowBox[{"kk", "[", 
           RowBox[{"numdef", "-", "1"}], "]"}], "*", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"ldef", "-", "ldefcritical"}], ")"}], "2"]}]}], ",", 
        "\"\<\\tkE=\>\"", ",", 
        RowBox[{"kEnergy", "=", 
         RowBox[{"0.5", " ", 
          RowBox[{"M", "[", "num", "]"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
        "\"\<\\ttime1=\>\"", ",", 
        RowBox[{"time1", "=", 
         RowBox[{"{", "tfinal", "}"}]}], ",", "\"\<\\tesprings=\>\"", ",", 
        RowBox[{
         RowBox[{"espring", "[", 
          RowBox[{"time1", ",", 
           RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1",
          "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"espring", "[", 
            RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"minthety", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"minthetx", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"conftab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Pi]", "-", 
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tablength", "=", 
     RowBox[{"Round", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
       "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tabstart", "=", "1"}], ";", 
    RowBox[{"tabfinal", "=", "tablength"}], ";", 
    RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"jpstart", "=", "tabstart"}], ";", 
    RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
    RowBox[{"jpinterval", "=", "tabinterval"}], ";"}], "\[IndentingNewLine]", 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109767599832*^9}, 3.643435101387239*^9, 3.6435208578161383`*^9, {
   3.6464006561085863`*^9, 3.6464006578013277`*^9}, {3.646638869342173*^9, 
   3.646638932988068*^9}, 3.6466391137957277`*^9, {3.646640088288583*^9, 
   3.6466400969878273`*^9}, {3.646640184207391*^9, 3.646640207463784*^9}, {
   3.646640422940943*^9, 3.6466404385466623`*^9}, {3.6466406697006607`*^9, 
   3.646640671195651*^9}, {3.646643151111965*^9, 3.646643325407386*^9}, {
   3.646643381972577*^9, 3.646643382038714*^9}, {3.64664342582504*^9, 
   3.646643502470538*^9}, 3.6466437198842373`*^9, 3.6466474962975693`*^9, {
   3.646647540965953*^9, 3.6466475410718727`*^9}, {3.646648410254504*^9, 
   3.646648420638062*^9}, {3.646649058686038*^9, 3.646649157386436*^9}, {
   3.646649191981741*^9, 3.6466492527592773`*^9}, {3.646649644247415*^9, 
   3.646649676440136*^9}, 3.646907573751183*^9, {3.646911293119287*^9, 
   3.646911294298976*^9}, {3.647091658615889*^9, 3.647091658694935*^9}, {
   3.647091698618347*^9, 3.6470917305612593`*^9}, {3.647091847280841*^9, 
   3.647091955971171*^9}, 3.647092019046671*^9, 3.647092359216652*^9, {
   3.647092883549415*^9, 3.64709289488692*^9}, {3.64709337258529*^9, 
   3.6470933739105177`*^9}, {3.64959675590987*^9, 3.649596757938243*^9}, {
   3.649596939382811*^9, 3.649596972773609*^9}, {3.650367724761037*^9, 
   3.650367744553431*^9}, {3.65036777513377*^9, 3.650367802729437*^9}, {
   3.650367891952703*^9, 3.650367925696*^9}, {3.650368041219019*^9, 
   3.650368061313776*^9}, {3.6505435396124887`*^9, 3.6505435408654747`*^9}, {
   3.65875363970874*^9, 3.6587536451319532`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["4 : antikink generator", "Subsubsection",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109799773177*^9}, {3.6431100663235197`*^9, 3.643110120164934*^9}, {
   3.647084590325815*^9, 3.647084593926147*^9}, {3.6478658054306507`*^9, 
   3.647865828129787*^9}, {3.651559180627071*^9, 3.651559183187036*^9}}],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "tableContent4", "]"}]], "Input",
 CellChangeTimes->{{3.6515675575539217`*^9, 3.651567565120929*^9}}],

Cell[BoxData[
 RowBox[{"tableContent4", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"lzerosq", "=", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ldef", "=", 
     RowBox[{"Sqrt", "[", "lzerosq", "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"kk", "[", 
      RowBox[{"numdef", "-", "1"}], "]"}], "=", "kkdef"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"M", "[", "numdef", "]"}], "=", "Mdef"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"numx", "=", 
     RowBox[{"IntegerPart", "[", 
      RowBox[{"num", " ", "akpos"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Here", " ", "the", " ", "terms", " ", "left", " ", "and", " ", "right",
        " ", "are", " ", "opposite"}], ",", " ", 
      RowBox[{
      "just", " ", "copying", " ", "the", " ", "code", " ", "from", " ", 
       "normal", " ", "kink", " ", "without", " ", "switching", " ", "two", 
       " ", "variable"}], ",", " ", 
      RowBox[{
      "flipping", " ", "the", " ", "evaluated", " ", "varaible", " ", "to", 
       " ", "get", " ", "inverse", " ", "function"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"R", "=", 
       RowBox[{"MakeSSHrig", "[", 
        RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
        "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"e", "=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", 
        "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"v", "=", 
         RowBox[{"v0", " ", 
          RowBox[{"e", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"e", "[", "modenum_", "]"}], ":=", 
       RowBox[{
        RowBox[{"Eigensystem", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", 
          RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
      RowBox[{"(*", 
       RowBox[{"+", 
        RowBox[{
         RowBox[{"Eigensystem", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", 
           RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"modenum", "=", "0"}], ";"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"thetapos", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", "1", ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"thetaneg", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"KEnergy", ">", "pEmin"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
       "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"rerunConfigQ", "==", "True"}], ",", 
      RowBox[{
       RowBox[{"initialold", "=", "reanstab"}], ";", 
       RowBox[{"initial", "=", "reinitialtab"}], ";"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"R", "=", 
       RowBox[{"MakeSSHrig", "[", 
        RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
        "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"kMatrix", "=", 
       RowBox[{"Normal", "[", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", 
            RowBox[{"kk", "[", "i", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"es", "=", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "R", "]"}], ".", "kMatrix", ".", "R"}], 
        "]"}]}], ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
    
    RowBox[{"es", "=", 
     RowBox[{"Eigensystem", "[", 
      RowBox[{"DMat", "[", "initialold", "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e", "[", "modenum_", "]"}], ":=", 
     RowBox[{"es", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", 
        RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"modenum", "=", "0"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"e", "[", "modenum", "]"}], "\[LeftDoubleBracket]", "i", 
            "\[RightDoubleBracket]"}], ")"}], "2"], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "-", "4"}], "]"}], ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "+", "4"}], "]"}]}], "}"}]}], 
        "]"}], "<", "0.5"}], ",", 
      RowBox[{"modenum", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"v", "=", 
       RowBox[{"vdirection", " ", "v0", "  ", 
        RowBox[{"e", "[", "modenum", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"mixmodeQ", "\[Equal]", "True"}], ",", 
        RowBox[{
         RowBox[{"v", "=", 
          RowBox[{"vdirection", " ", "v0", "  ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"e", "[", "modenum1", "]"}], "+", 
             RowBox[{"e", "[", "modenum2", "]"}]}], ")"}]}]}], ";"}]}], "]"}],
       ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"v", ":=", 
       RowBox[{"v0", "  ", 
        RowBox[{"Normal", "[", 
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
      ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"v", "=", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Sign", "[", "initialold", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}], "\[Equal]", 
         RowBox[{
          RowBox[{"Sign", "[", 
           RowBox[{"e", "[", "modenum", "]"}], "]"}], "\[LeftDoubleBracket]", 
          
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "akpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}]}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"akgoleft", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"akgoleft", ",", 
          RowBox[{"-", "1"}], ",", "1"}], "]"}]}], "]"}], "   ", 
      RowBox[{"e", "[", "modenum", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"v", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "=",
      "0."}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"v", "\[LeftDoubleBracket]", 
      RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "=", "0."}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"v", "=", 
     RowBox[{"v0", " ", 
      RowBox[{"v", "/", 
       RowBox[{"Norm", "[", "v", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"mixmodeQ", "\[Equal]", "True"}], ",", 
      RowBox[{
       RowBox[{"v", "=", 
        RowBox[{"vdirection", " ", "v0", "  ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"e", "[", "modenum1", "]"}], "+", 
           RowBox[{"e", "[", "modenum2", "]"}]}], ")"}]}]}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{"rerunVelQ", ",", 
      RowBox[{
       RowBox[{"v", "=", "reveltab"}], ";"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ans", "=", 
     RowBox[{"klchainmd2", "[", 
      RowBox[{
      "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
       "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Mute", "\[NotEqual]", "True"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<k=\>\"", ",", "kkdef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
        "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tkE=\>\"", ",", 
        RowBox[{"kEnergy", "=", 
         RowBox[{"0.5", " ", 
          RowBox[{"M", "[", 
           RowBox[{"num", "-", "1"}], "]"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
        "\"\<\\ttime1=\>\"", ",", 
        RowBox[{"time1", "=", 
         RowBox[{"{", "tfinal", "}"}]}], ",", "\"\<\\tesprings=\>\"", ",", 
        RowBox[{
         RowBox[{"espring", "[", 
          RowBox[{"time1", ",", 
           RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1",
          "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"espring", "[", 
            RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"minthety", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"minthetx", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"conftab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Pi]", "-", 
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tablength", "=", 
     RowBox[{"Round", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
       "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tabstart", "=", "1"}], ";", 
    RowBox[{"tabfinal", "=", "tablength"}], ";", 
    RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"jpstart", "=", "tabstart"}], ";", 
    RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
    RowBox[{"jpinterval", "=", "tabinterval"}], ";"}], "\[IndentingNewLine]", 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109767599832*^9}, 3.643435101387239*^9, 3.6435208578161383`*^9, {
   3.6464006561085863`*^9, 3.6464006578013277`*^9}, {3.646638869342173*^9, 
   3.646638932988068*^9}, 3.6466391137957277`*^9, {3.646640088288583*^9, 
   3.6466400969878273`*^9}, {3.646640184207391*^9, 3.646640207463784*^9}, {
   3.646640422940943*^9, 3.6466404385466623`*^9}, {3.6466406697006607`*^9, 
   3.646640671195651*^9}, {3.646643151111965*^9, 3.646643325407386*^9}, {
   3.646643381972577*^9, 3.646643382038714*^9}, {3.64664342582504*^9, 
   3.646643502470538*^9}, 3.6466437198842373`*^9, 3.6466474962975693`*^9, {
   3.646647540965953*^9, 3.6466475410718727`*^9}, {3.646648410254504*^9, 
   3.646648420638062*^9}, {3.646649058686038*^9, 3.646649157386436*^9}, {
   3.646649191981741*^9, 3.6466492527592773`*^9}, {3.646649644247415*^9, 
   3.646649676440136*^9}, 3.646907573751183*^9, {3.646911293119287*^9, 
   3.646911294298976*^9}, {3.6471774691806192`*^9, 3.647177527196322*^9}, {
   3.647178477621952*^9, 3.647178513754067*^9}, {3.647256614011697*^9, 
   3.6472567031712523`*^9}, 3.64725697104585*^9, {3.647257091145218*^9, 
   3.64725716332209*^9}, {3.6472572008579597`*^9, 3.647257258455936*^9}, 
   3.6472573811527863`*^9, 3.64725780084163*^9, {3.6472579049493017`*^9, 
   3.647257906155842*^9}, 3.647769201355101*^9, {3.647785022529758*^9, 
   3.6477850865416307`*^9}, {3.647835682883335*^9, 3.6478356834591923`*^9}, {
   3.647865772123517*^9, 3.6478658036714*^9}, {3.647865853333067*^9, 
   3.647865870557398*^9}, {3.6490760746049128`*^9, 3.649076096447781*^9}, {
   3.649076268982458*^9, 3.64907627860725*^9}, {3.6490770143926773`*^9, 
   3.6490770197973537`*^9}, {3.64907800305099*^9, 3.6490780225402107`*^9}, {
   3.6490781383820257`*^9, 3.649078164034307*^9}, {3.6490782159217863`*^9, 
   3.649078250882218*^9}, {3.649078538022114*^9, 3.649078538358222*^9}, {
   3.649078619422573*^9, 3.649078631583435*^9}, {3.6490790554839373`*^9, 
   3.649079060455639*^9}, {3.6491695995846167`*^9, 3.649169601578124*^9}, {
   3.649171110063106*^9, 3.6491711320504103`*^9}, {3.649171674650647*^9, 
   3.649171680212475*^9}, {3.649171720477874*^9, 3.649171721917108*^9}, {
   3.649396386572743*^9, 3.649396405643228*^9}, 3.649420832031287*^9, {
   3.649420948184342*^9, 3.649420979347537*^9}, {3.65018882487049*^9, 
   3.650188835777583*^9}, {3.650283185062252*^9, 3.650283278600477*^9}, {
   3.650283590292918*^9, 3.650283592606297*^9}, {3.6502837755498047`*^9, 
   3.650283780798943*^9}, {3.650283942930458*^9, 3.650284019251333*^9}, {
   3.650284065559944*^9, 3.650284067753215*^9}, {3.650284422283189*^9, 
   3.650284427058505*^9}, {3.650285185236246*^9, 3.650285260252405*^9}, {
   3.650344804336376*^9, 3.650344808313445*^9}, {3.650346521972494*^9, 
   3.650346538323638*^9}, {3.650348802144451*^9, 3.650348804142664*^9}, {
   3.650349647285808*^9, 3.65034966623947*^9}, {3.6503497486693087`*^9, 
   3.65034979760643*^9}, {3.650349857369485*^9, 3.6503498574601517`*^9}, 
   3.651386460901369*^9, {3.651386650632375*^9, 3.651386651400388*^9}, {
   3.6515568379887753`*^9, 3.651556939182481*^9}, {3.6515587627182627`*^9, 
   3.651558812735289*^9}, {3.651558931943972*^9, 3.651558942953425*^9}, {
   3.65155915321308*^9, 3.6515591752586117`*^9}, {3.651559236719099*^9, 
   3.651559331536518*^9}, {3.651560587660474*^9, 3.651560591917777*^9}, {
   3.651567486372254*^9, 3.651567546961728*^9}, {3.651839767537838*^9, 
   3.651839786651272*^9}, {3.6518400486599407`*^9, 3.651840056418791*^9}, {
   3.65184010335585*^9, 3.6518401045350122`*^9}, {3.651840294718603*^9, 
   3.651840301661763*^9}, {3.651840624980391*^9, 3.651840631460556*^9}, {
   3.651840670117962*^9, 3.651840673110497*^9}, {3.6518407038499613`*^9, 
   3.651840716642634*^9}, {3.6518407963650913`*^9, 3.651840796858575*^9}, {
   3.651840846986383*^9, 3.651840862953742*^9}, {3.651840920202462*^9, 
   3.6518409257577763`*^9}, {3.651841084464862*^9, 3.6518410995680428`*^9}, 
   3.6518413896096897`*^9, {3.6518446616543837`*^9, 3.651844667013319*^9}, 
   3.651922582837419*^9, {3.6519250852529783`*^9, 3.651925098692319*^9}, {
   3.651925324780058*^9, 3.6519253274482183`*^9}, {3.6533711063698673`*^9, 
   3.653371107440592*^9}, {3.653371148438945*^9, 3.653371150897381*^9}, {
   3.65546411680167*^9, 3.655464122945508*^9}, {3.655464998537469*^9, 
   3.6554650200434227`*^9}, {3.6554650967035723`*^9, 
   3.6554651057491007`*^9}, {3.6554651597310143`*^9, 3.655465162053464*^9}, {
   3.655465346751989*^9, 3.6554653620642242`*^9}, {3.655465403922059*^9, 
   3.6554654345628777`*^9}, {3.655465528853229*^9, 3.655465575062129*^9}, {
   3.655465797785098*^9, 3.6554658008264723`*^9}, {3.655465931758116*^9, 
   3.655465941888258*^9}, {3.655466075651269*^9, 3.655466182999259*^9}, {
   3.655467603690159*^9, 3.655467618919026*^9}, {3.655467660970715*^9, 
   3.6554677021887302`*^9}, {3.65546796162643*^9, 3.6554679783990307`*^9}, {
   3.655468075858529*^9, 3.6554680798400183`*^9}, {3.6554681243535423`*^9, 
   3.655468124882944*^9}, {3.655468508332535*^9, 3.655468526176609*^9}, {
   3.655468570606*^9, 3.655468578205514*^9}, {3.65546860822635*^9, 
   3.6554687224322*^9}, {3.655468839813282*^9, 3.655468876800088*^9}, {
   3.655472539336732*^9, 3.6554727033595657`*^9}, {3.655535294096731*^9, 
   3.655535352567236*^9}, {3.658496365120289*^9, 3.6584963997588387`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["6 : spinner", "Subsubsection",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109799773177*^9}, {3.6431100663235197`*^9, 3.643110120164934*^9}, {
   3.647084590325815*^9, 3.647084593926147*^9}, {3.647091646855192*^9, 
   3.647091655379676*^9}, 3.649596937842533*^9, {3.650288009008955*^9, 
   3.6502880120323057`*^9}, {3.655472306683299*^9, 3.655472309226905*^9}, {
   3.678449135659247*^9, 3.6784491408651733`*^9}}],

Cell[BoxData[
 RowBox[{"tableContent6", ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"kk", "[", 
      RowBox[{"numdef", "-", "1"}], "]"}], "=", "kkdef"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"M", "[", "numdef", "]"}], "=", "Mdef"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"IntegerPart", "[", 
         RowBox[{"num", " ", "kpos"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"num", "+", "2"}]}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", "2", ",", "0", ",", "\[Pi]"}], "}"}]}],
           "]"}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "2"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "2.5"}], ",", 
             RowBox[{"-", "\[Pi]"}], ",", 
             RowBox[{"-", "0"}]}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"R", "=", 
     RowBox[{"MakeSSHrig", "[", 
      RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
      "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"e", "=", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}]}], ";", "  ", 
      RowBox[{"(*", " ", 
       RowBox[{"find", " ", "eigenvalues", " ", "and", " ", "eigenvectors"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"v", "=", 
       RowBox[{"v0", " ", 
        RowBox[{"e", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "num"}], "]"}], "]"}]}]}], ";"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e", "[", "modenum_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Eigensystem", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", 
        RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"+", 
      RowBox[{
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "R", "]"}], ".", "R"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", 
         RowBox[{"num", "-", "1"}]}], "]"}], "]"}]}], "*)"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"modenum", "=", "0"}], ";", 
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"e", "[", "modenum", "]"}], "\[LeftDoubleBracket]", "i", 
            "\[RightDoubleBracket]"}], ")"}], "2"], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ",", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], "}"}]}], 
        "]"}], "<", "0.5"}], ",", 
      RowBox[{"modenum", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"thetapos", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", "1", ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"thetaneg", "=", 
     RowBox[{"thetaleft", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "0", "]"}]}], "-", 
             RowBox[{"r", " ", 
              RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "0", "]"}]}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
         "\[Equal]", "lzerosq"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"thetaleft", ",", 
          RowBox[{"-", "2"}], ",", 
          RowBox[{"-", "3."}], ",", "3."}], "}"}]}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"KEnergy", ">", "pEmin"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<kE>pE\>\"", "]"}], ";", "Break"}]}], 
       "]"}], ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"v", "=", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Sign", "[", "initialold", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}], "\[Equal]", 
         RowBox[{
          RowBox[{"Sign", "[", 
           RowBox[{"e", "[", "modenum", "]"}], "]"}], "\[LeftDoubleBracket]", 
          
          RowBox[{
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "-", "4"}], "]"}], ";;", 
           RowBox[{"IntegerPart", "[", 
            RowBox[{
             RowBox[{"num", " ", "kpos"}], "+", "4"}], "]"}]}], 
          "\[RightDoubleBracket]"}]}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"kgoleft", ",", 
          RowBox[{"-", "1"}], ",", "1"}], "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"kgoleft", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "]"}]}], "]"}], "v0", " ", 
      RowBox[{"e", "[", "modenum", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"v", ":=", 
       RowBox[{"v0", "  ", 
        RowBox[{"Normal", "[", 
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{"num", "\[Rule]", "1"}], ",", "num"}], "]"}], "]"}]}]}], 
      ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ans", "=", 
     RowBox[{"klchainmd2", "[", 
      RowBox[{
      "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",", 
       "initial", ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"DualSolPos", ":=", 
     RowBox[{"FindCrossingDual3", "[", 
      RowBox[{
       RowBox[{"GetDat", "[", 
        RowBox[{"ans", ",", "t"}], "]"}], ",", "thetapos", ",", "thetaneg"}], 
      "]"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "version2", " ", "use", " ", "mid", " ", "point", " ", "of", " ", 
       "\[Theta]pos", " ", "and", " ", "\[Theta]neg", " ", "as", " ", "0"}], 
      ",", 
      RowBox[{
      "version3", " ", "use", " ", "sss", " ", "point", " ", "as", " ", 
       "0"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"leftsolitab", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"DualSolPos", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
          "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rightsolitab", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"DualSolPos", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], 
          "}"}]}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Mute", "\[NotEqual]", "True"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<ldef=\>\"", ",", "ldef", ",", "\"\<\\tv0=\>\"", ",", "v0", ",", 
        "\"\<\\ttfinal=\>\"", ",", "tfinal", ",", "\"\<\\tpEmin=\>\"", ",", 
        RowBox[{"pEmin", "=", 
         RowBox[{"0.5", "*", 
          RowBox[{"kk", "[", 
           RowBox[{"numdef", "-", "1"}], "]"}], "*", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"ldef", "-", "ldefcritical"}], ")"}], "2"]}]}], ",", 
        "\"\<\\tkE=\>\"", ",", 
        RowBox[{"kEnergy", "=", 
         RowBox[{"0.5", " ", 
          RowBox[{"M", "[", "num", "]"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"r", " ", "v0"}], ")"}], "2"]}]}], ",", 
        "\"\<\\ttime1=\>\"", ",", 
        RowBox[{"time1", "=", 
         RowBox[{"{", "tfinal", "}"}]}], ",", "\"\<\\tesprings=\>\"", ",", 
        RowBox[{
         RowBox[{"espring", "[", 
          RowBox[{"time1", ",", 
           RowBox[{"numdef", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", "1",
          "\[RightDoubleBracket]"}], ",", "\"\</\>\"", ",", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"espring", "[", 
            RowBox[{"time1", ",", "i"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"v0label", "=", "v0"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"minthety", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"minthetx", "=", 
     RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"conftab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Pi]", "-", 
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tablength", "=", 
     RowBox[{"Round", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "+", 
       "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tabstart", "=", "1"}], ";", 
    RowBox[{"tabfinal", "=", "tablength"}], ";", 
    RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"jpstart", "=", "tabstart"}], ";", 
    RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
    RowBox[{"jpinterval", "=", "tabinterval"}], ";"}], "\[IndentingNewLine]", 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.639399747517334*^9, 3.639399863736434*^9}, {
   3.639399920797901*^9, 3.639400179366879*^9}, {3.639401063497343*^9, 
   3.639401074455329*^9}, 3.639401186140904*^9, {3.639401510772743*^9, 
   3.639401517074074*^9}, {3.639401586282084*^9, 3.639401631722599*^9}, {
   3.639401775695467*^9, 3.639401777864669*^9}, {3.639402565518993*^9, 
   3.63940260532157*^9}, {3.639403933087511*^9, 3.6394039666374683`*^9}, {
   3.639404009032262*^9, 3.639404009764016*^9}, 3.639404148262268*^9, {
   3.639404609309239*^9, 3.6394046098537693`*^9}, {3.639404769845202*^9, 
   3.6394047701406603`*^9}, {3.63940498181496*^9, 3.639404994535932*^9}, {
   3.6404099704899797`*^9, 3.640410008235209*^9}, {3.6404240754060707`*^9, 
   3.640424075648679*^9}, {3.640424126144064*^9, 3.6404241313720827`*^9}, {
   3.640424168280517*^9, 3.640424203356411*^9}, {3.6404258381819553`*^9, 
   3.6404258556676702`*^9}, {3.640432762033079*^9, 3.640432772578578*^9}, {
   3.6404334617308483`*^9, 3.640433471955071*^9}, {3.640433903652959*^9, 
   3.640433906715889*^9}, {3.6405182890529346`*^9, 3.640518289339682*^9}, {
   3.640946119602957*^9, 3.640946132227578*^9}, {3.641028865118153*^9, 
   3.641028868897181*^9}, {3.641029105904063*^9, 3.641029183750264*^9}, {
   3.64103000990569*^9, 3.6410300295275793`*^9}, {3.641030178736333*^9, 
   3.641030184795849*^9}, {3.6410344977802362`*^9, 3.6410344997202797`*^9}, {
   3.641035164727994*^9, 3.641035165539104*^9}, {3.641113258435157*^9, 
   3.641113262491248*^9}, {3.64112643969667*^9, 3.641126439956493*^9}, {
   3.641908955080958*^9, 3.641909034011938*^9}, {3.6419091051103573`*^9, 
   3.6419091157488213`*^9}, {3.6419091544176683`*^9, 3.641909154825329*^9}, 
   3.641912702876154*^9, {3.6419127491360893`*^9, 3.641912846839841*^9}, {
   3.641912882590148*^9, 3.641912896604266*^9}, {3.641912956433505*^9, 
   3.641913026609498*^9}, {3.641913421123107*^9, 3.641913592122669*^9}, {
   3.6419136473324327`*^9, 3.641913651457534*^9}, 3.641913850730276*^9, {
   3.641913962436998*^9, 3.641913964568766*^9}, {3.6419142276614428`*^9, 
   3.641914233560351*^9}, {3.6419144939532537`*^9, 3.6419145055976477`*^9}, {
   3.6419146322844677`*^9, 3.641914646251863*^9}, {3.641914984373474*^9, 
   3.6419149854601*^9}, {3.6419152343432207`*^9, 3.641915274836927*^9}, {
   3.641916294496958*^9, 3.641916297504427*^9}, {3.641916367406167*^9, 
   3.641916425924011*^9}, {3.641916457470438*^9, 3.6419164640974607`*^9}, {
   3.641917932869171*^9, 3.641917934135192*^9}, {3.6419181266797037`*^9, 
   3.641918144068392*^9}, {3.641921663602878*^9, 3.641921667278193*^9}, {
   3.641921708503373*^9, 3.64192171793465*^9}, {3.6419217538498383`*^9, 
   3.641921757198696*^9}, 3.6419236754216013`*^9, {3.6419238669211884`*^9, 
   3.641923869148617*^9}, {3.642738162310978*^9, 3.6427381626831827`*^9}, {
   3.6427382813765078`*^9, 3.6427382893717413`*^9}, {3.642738453581531*^9, 
   3.642738453774798*^9}, {3.6427399297050457`*^9, 3.642739936854081*^9}, {
   3.642744654760977*^9, 3.6427446554877*^9}, {3.642827161852694*^9, 
   3.642827176166*^9}, 3.642827395985263*^9, {3.6428274631355267`*^9, 
   3.642827477489149*^9}, {3.642827564829884*^9, 3.642827589404566*^9}, {
   3.642827682247171*^9, 3.642827689392848*^9}, 3.6428289871090603`*^9, 
   3.642829079297469*^9, {3.643107697493163*^9, 3.643107755356545*^9}, {
   3.643107811203609*^9, 3.643107873280476*^9}, {3.6431093317796*^9, 
   3.6431093349554243`*^9}, {3.643109516742908*^9, 3.643109552169368*^9}, {
   3.643109603595183*^9, 3.643109612966878*^9}, {3.643109753508951*^9, 
   3.643109767599832*^9}, 3.643435101387239*^9, 3.6435208578161383`*^9, {
   3.6464006561085863`*^9, 3.6464006578013277`*^9}, {3.646638869342173*^9, 
   3.646638932988068*^9}, 3.6466391137957277`*^9, {3.646640088288583*^9, 
   3.6466400969878273`*^9}, {3.646640184207391*^9, 3.646640207463784*^9}, {
   3.646640422940943*^9, 3.6466404385466623`*^9}, {3.6466406697006607`*^9, 
   3.646640671195651*^9}, {3.646643151111965*^9, 3.646643325407386*^9}, {
   3.646643381972577*^9, 3.646643382038714*^9}, {3.64664342582504*^9, 
   3.646643502470538*^9}, 3.6466437198842373`*^9, 3.6466474962975693`*^9, {
   3.646647540965953*^9, 3.6466475410718727`*^9}, {3.646648410254504*^9, 
   3.646648420638062*^9}, {3.646649058686038*^9, 3.646649157386436*^9}, {
   3.646649191981741*^9, 3.6466492527592773`*^9}, {3.646649644247415*^9, 
   3.646649676440136*^9}, 3.646907573751183*^9, {3.646911293119287*^9, 
   3.646911294298976*^9}, {3.647091658615889*^9, 3.647091658694935*^9}, {
   3.647091698618347*^9, 3.6470917305612593`*^9}, {3.647091847280841*^9, 
   3.647091955971171*^9}, 3.647092019046671*^9, 3.647092359216652*^9, {
   3.647092883549415*^9, 3.64709289488692*^9}, {3.64709337258529*^9, 
   3.6470933739105177`*^9}, {3.64959675590987*^9, 3.649596757938243*^9}, {
   3.649596939382811*^9, 3.649596972773609*^9}, {3.650367724761037*^9, 
   3.650367744553431*^9}, {3.65036777513377*^9, 3.650367802729437*^9}, {
   3.650367891952703*^9, 3.650367925696*^9}, {3.650368041219019*^9, 
   3.650368061313776*^9}, {3.6505435396124887`*^9, 3.6505435408654747`*^9}, {
   3.65875363970874*^9, 3.6587536451319532`*^9}, 3.6784491493367023`*^9, {
   3.678449238676208*^9, 3.678449252152619*^9}, 3.678450061673255*^9, {
   3.678457045402062*^9, 3.678457132016473*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Analysis Function", "Section",
 CellChangeTimes->{{3.646907513381963*^9, 3.646907516409437*^9}, {
  3.65020766302665*^9, 3.650207664514332*^9}}],

Cell[CellGroupData[{

Cell["profile calculate function", "Subsubsection",
 CellChangeTimes->{{3.656402199520746*^9, 3.6564022250145197`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Calpts", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"minthety", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"minthetx", "=", 
      RowBox[{"-", "\[Pi]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"conftab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              RowBox[{"ans", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthety"}], "]"}], ",", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", "minthetx"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tablength", "=", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "tinterval"}], "-", 
        "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tabstart", "=", "1"}], ";", 
     RowBox[{"tabfinal", "=", "tablength"}], ";", 
     RowBox[{"tabinterval", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"jpstart", "=", "tabstart"}], ";", 
     RowBox[{"jpfinal", "=", "tabfinal"}], ";", 
     RowBox[{"jpinterval", "=", "tabinterval"}], ";", "\[IndentingNewLine]", 
     RowBox[{"anstab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         FractionBox["\[Pi]", "2"], "-", 
         RowBox[{
          RowBox[{"ans", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", "tfinal", ",", "tinterval"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"vout", ":=", 
      RowBox[{"r", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", "t"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}]}], ";", "\n", 
     "\[IndentingNewLine]", 
     RowBox[{"pts", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"jp", "*", "tinterval"}], ",", 
          RowBox[{"r", " ", 
           RowBox[{"Sin", "@", 
            RowBox[{"conftab", "\[LeftDoubleBracket]", 
             RowBox[{"jp", ",", "i"}], "\[RightDoubleBracket]"}]}]}]}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"jp", ",", "jpstart", ",", "jpfinal", ",", "jpinterval"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"vtab", "=", " ", 
      RowBox[{"Table", "[", " ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"jp", "*", "tinterval"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", "2"}], "]"}]], "r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"conftab", "\[LeftDoubleBracket]", 
               RowBox[{"jp", ",", "i"}], "\[RightDoubleBracket]"}], "]"}], 
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", "t"}], 
              "]"}]}], ")"}], "/.", 
           RowBox[{"t", "\[Rule]", 
            RowBox[{"tinterval", "*", 
             RowBox[{"(", 
              RowBox[{"jp", "-", "jpstart"}], ")"}]}]}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"jp", ",", "jpstart", ",", "jpfinal", ",", "jpinterval"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
    "}"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"KShowpts", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"pts3d", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"pts", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "10"}], "}"}]}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
       "Sample", " ", "every", " ", "10", " ", "points", " ", "inverval"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Kconf3dplot", "[", 
        RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"ListPointPlot3D", "[", 
          RowBox[{"pts3d", ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"PointSize", "\[Rule]", "0.00"}], "]"}]}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"FontSize", "\[Rule]", "20"}], ",", "Bold", ",", 
              RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}]}],
           "]"}], ",", 
         RowBox[{"Graphics3D", "@", 
          RowBox[{"Line", "@", "pts3d"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
         RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<n\>\"", ",", "\"\<t\>\"", ",", "\"\<u\>\""}], "}"}]}],
          ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<v\>\"", ",", "v0", ",", "\"\<kkdef\>\"", ",", 
            RowBox[{"kk", "[", 
             RowBox[{"numdef", "-", "1"}], "]"}], ",", "\"\<Mdef\>\"", ",", 
            RowBox[{"M", "[", "numdef", "]"}], ",", "\"\<ldef\>\"", ",", 
            "ldef"}], "}"}]}]}], "]"}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AKShowpts", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"pts3d", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"pts", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "10"}], "}"}]}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
       "Sample", " ", "every", " ", "10", " ", "points", " ", "inverval"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"AKconf3dplot", "[", 
        RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"ListPointPlot3D", "[", 
          RowBox[{"pts3d", ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"PointSize", "\[Rule]", "0.00"}], "]"}]}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"FontSize", "\[Rule]", "20"}], ",", "Bold", ",", 
              RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}]}],
           "]"}], ",", 
         RowBox[{"Graphics3D", "@", 
          RowBox[{"Line", "@", "pts3d"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
         RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<n\>\"", ",", "\"\<t\>\"", ",", "\"\<u\>\""}], "}"}]}],
          ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<v\>\"", ",", "v0", ",", "\"\<kkdef\>\"", ",", 
            RowBox[{"kk", "[", 
             RowBox[{"numdef", "-", "1"}], "]"}], ",", "\"\<Mdef\>\"", ",", 
            RowBox[{"M", "[", "numdef", "]"}], ",", "\"\<ldef\>\"", ",", 
            "ldef"}], "}"}]}]}], "]"}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"K", ":=", 
   RowBox[{"{", "\[IndentingNewLine]", "    ", 
    RowBox[{
     RowBox[{"signtab", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{"conftab", "\[LeftDoubleBracket]", 
        RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", "\n", 
     "\t", 
     RowBox[{"kaktab", "=", 
      RowBox[{"{", "}"}]}], ";", "\n", "\t", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
          "signtab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "!=", 
          RowBox[{"signtab", "\[LeftDoubleBracket]", 
           RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], 
         RowBox[{"(*", "antikink", "*)"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"kaktab", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"signtab", "\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], "}"}]}],
             "]"}], ";"}], "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2", ",", 
         RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"kkvconfplot", "[", 
       RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"conftab", "\[LeftDoubleBracket]", 
         RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"kaktab", "\[NotEqual]", 
        RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", "\"\<\>\""}], ";", 
        RowBox[{
         RowBox[{"ktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
         RowBox[{
          RowBox[{"ktag", "[", 
           RowBox[{"kkdef", ",", "v0"}], "]"}], "<>", "\"\<k\>\"", "<>", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "kaktab", "]"}], "\[Equal]", "3"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                  RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}], "-", 
                 RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ">", 
                "3"}], "&&", 
               RowBox[{
                RowBox[{
                 RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                  RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], "-", 
                 RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                  RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]}], ">", 
                "3"}]}], ",", "\"\<sp\>\"", ",", "\"\<tm\>\""}], "]"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], ",", 
                RowBox[{"Length", "[", "kaktab", "]"}]}], "]"}], ",", 
              "\"\<tm\>\"", ",", "\"\<x\>\""}], "]"}]}], "]"}]}]}], ";"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", "\"\<\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
         RowBox[{
          RowBox[{"ktag", "[", 
           RowBox[{"kkdef", ",", "v0"}], "]"}], "<>", "\"\<ktm\>\""}]}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Mute", "\[NotEqual]", "True"}], ",", 
       RowBox[{"Print", "[", 
        RowBox[{"ktag", "[", 
         RowBox[{"kkdef", ",", "v0"}], "]"}], "]"}]}], "]"}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AK", ":=", 
   RowBox[{"{", 
    RowBox[{"(*", 
     RowBox[{"need", " ", "modify"}], "*)"}], "\[IndentingNewLine]", "    ", 
    RowBox[{
     RowBox[{"signtab", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{"conftab", "\[LeftDoubleBracket]", 
        RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", "\n", 
     "\t", 
     RowBox[{"kaktab", "=", 
      RowBox[{"{", "}"}]}], ";", "\n", "\t", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
          "signtab", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "!=", 
          RowBox[{"signtab", "\[LeftDoubleBracket]", 
           RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], 
         RowBox[{"(*", "antikink", "*)"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"kaktab", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"signtab", "\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], "}"}]}],
             "]"}], ";"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2", ",", 
         RowBox[{"num", "-", "2"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"akkvconfplot", "[", 
       RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"conftab", "\[LeftDoubleBracket]", 
         RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"kaktab", "\[NotEqual]", 
        RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"aktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", "\"\<\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"aktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
         RowBox[{
          RowBox[{"aktag", "[", 
           RowBox[{"kkdef", ",", "v0"}], "]"}], "<>", "\"\<ak\>\"", "<>", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "kaktab", "]"}], "\[Equal]", "3"}], ",", 
            "\[IndentingNewLine]", "\"\<sp\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "kaktab", "]"}], "\[Equal]", "1"}], ",",
               "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "<", 
                 RowBox[{"numdef", "-", "3"}]}], ",", "\[IndentingNewLine]", 
                "\"\<tm\>\"", ",", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"kaktab", "\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ">", 
                   RowBox[{"numdef", "+", "3"}]}], ",", 
                  "\[IndentingNewLine]", "\"\<rf\>\"", ",", 
                  "\[IndentingNewLine]", "\"\<tr\>\""}], 
                 "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}],
               ",", "\[IndentingNewLine]", "\"\<x\>\""}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}],
         ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Mute", "\[NotEqual]", "True"}], ",", 
          RowBox[{"Print", "[", 
           RowBox[{"aktag", "[", 
            RowBox[{"kkdef", ",", "v0"}], "]"}], "]"}]}], "]"}], ";"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"aktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", "\"\<\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"aktag", "[", 
          RowBox[{"kkdef", ",", "v0"}], "]"}], "=", 
         RowBox[{
          RowBox[{"aktag", "[", 
           RowBox[{"kkdef", ",", "v0"}], "]"}], "<>", "\"\<aktm\>\""}]}], 
        ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "a_Symbol", "]"}], ":=", 
   RowBox[{
    RowBox[{"DownValues", "[", "a", "]"}], "/.", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"HoldPattern", "[", 
        RowBox[{"_", "[", 
         RowBox[{"_", "[", "x__", "]"}], "]"}], "]"}], "\[RuleDelayed]", 
       "z_"}], ")"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "x", "}"}], ",", "z"}], "}"}]}]}]}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"why", " ", "is", " ", "there", " ", 
     RowBox[{"3", " ", "[", "]"}]}], ",", " ", 
    RowBox[{
     RowBox[{"shouldn", "'"}], "t", " ", "two", " ", "be", " ", 
     RowBox[{"enough", "?"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gg", "[", "a_Symbol", "]"}], ":=", 
  RowBox[{
   RowBox[{"DownValues", "[", "a", "]"}], "/.", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{"_", "[", "x__", "]"}], "]"}], "\[RuleDelayed]", "z_"}], ")"}],
     "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "x", "}"}], ",", "z"}], "}"}], " ", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"why", " ", "is", " ", "there", " ", 
       RowBox[{"3", " ", "[", "]"}]}], ",", " ", 
      RowBox[{
       RowBox[{"shouldn", "'"}], "t", " ", "two", " ", "be", " ", 
       RowBox[{"enough", "?"}]}]}], "*)"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.6501895677977867`*^9, 3.650189572512136*^9}, {
   3.650189811668088*^9, 3.6501898678529577`*^9}, {3.650189912056347*^9, 
   3.6501899136853228`*^9}, {3.6501901586512403`*^9, 3.650190220404559*^9}, {
   3.650190336920356*^9, 3.65019037496264*^9}, {3.6501910811732693`*^9, 
   3.650191209397669*^9}, 3.6501914334010477`*^9, {3.6501929820970097`*^9, 
   3.6501930268817577`*^9}, 3.650193158306428*^9, {3.650196432224533*^9, 
   3.6501964334554377`*^9}, {3.6501968480430803`*^9, 3.650196893523711*^9}, 
   3.650196944155637*^9, {3.650197096271813*^9, 3.650197117709876*^9}, {
   3.6501971672808867`*^9, 3.650197187056217*^9}, {3.6501972740542917`*^9, 
   3.6501973249021053`*^9}, {3.650197400871193*^9, 3.650197400950602*^9}, {
   3.650197537994763*^9, 3.650197598016718*^9}, {3.650197640130019*^9, 
   3.650197667760006*^9}, {3.650207589845462*^9, 3.650207655174746*^9}, 
   3.6502088124033737`*^9, {3.6503465628673058`*^9, 3.65034657080906*^9}, {
   3.650348692650642*^9, 3.650348695656618*^9}, {3.650360721010112*^9, 
   3.650360745760111*^9}, {3.650365984508679*^9, 3.6503659859651814`*^9}, {
   3.650366075107531*^9, 3.6503660768915977`*^9}, {3.650366108364149*^9, 
   3.650366117213331*^9}, 3.650368400043688*^9, {3.650368454983818*^9, 
   3.650368488423636*^9}, {3.650368655416813*^9, 3.6503686565676823`*^9}, {
   3.650368702572443*^9, 3.650368765215671*^9}, {3.650368813585926*^9, 
   3.650368814284574*^9}, {3.650368848529523*^9, 3.650368852549123*^9}, {
   3.650369110921205*^9, 3.6503691210462027`*^9}, {3.650369216374736*^9, 
   3.6503692387137547`*^9}, {3.65064585717349*^9, 3.6506458613969707`*^9}, {
   3.6506459029347153`*^9, 3.650645916531104*^9}, {3.650646242324135*^9, 
   3.650646243006319*^9}, {3.650650306421419*^9, 3.650650339048609*^9}, {
   3.650650515593767*^9, 3.6506505822773447`*^9}, {3.6506506464707527`*^9, 
   3.650650649547826*^9}, {3.650650681108803*^9, 3.650650695559828*^9}, 
   3.6506508627983837`*^9, {3.650651865168508*^9, 3.650651896149474*^9}, {
   3.6506519363698263`*^9, 3.650651982768667*^9}, 3.6506526225807447`*^9, {
   3.65065433220776*^9, 3.650654383811257*^9}, {3.65068840495648*^9, 
   3.65068840791361*^9}, {3.650695211557798*^9, 3.650695222483303*^9}, {
   3.6506955314487543`*^9, 3.650695531736198*^9}, {3.6567557657423697`*^9, 
   3.6567557665404463`*^9}, {3.658754088230153*^9, 3.658754170916177*^9}, {
   3.658754245882008*^9, 3.6587542598310223`*^9}, 3.658754298543293*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["use Analysis Function", "Subsubsection",
 CellChangeTimes->{{3.650207672901601*^9, 3.6502076752856293`*^9}, {
   3.6508749916127033`*^9, 3.650874991964766*^9}, 3.6580564657075233`*^9}],

Cell[BoxData[{"ldefcritical", "\[IndentingNewLine]", "lzero"}], "Input",
 CellChangeTimes->{{3.6428485109249477`*^9, 3.6428485135669403`*^9}, {
   3.643433256799293*^9, 3.643433265188655*^9}, {3.646903378505726*^9, 
   3.646903428107706*^9}, {3.6469175820884113`*^9, 3.646917600342284*^9}, {
   3.64691766556472*^9, 3.646917673787084*^9}, 3.65805499999724*^9, {
   3.658488745521304*^9, 3.65848874974643*^9}}],

Cell[BoxData[
 RowBox[{"Calpts", ";"}]], "Input",
 CellChangeTimes->{{3.6472581429890738`*^9, 3.6472581682325172`*^9}, 
   3.6472582218481207`*^9, 3.6476801786316843`*^9}],

Cell[BoxData[
 RowBox[{"Showpts", "\[LeftDoubleBracket]", "1", 
  "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.6472581429890738`*^9, 3.6472581682325172`*^9}, 
   3.6472582218481207`*^9, 3.6476801786316843`*^9}],

Cell[BoxData[
 RowBox[{"configplot", "=", 
  RowBox[{"Manipulate", "[", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"pts", "\[LeftDoubleBracket]", 
       RowBox[{"jp", " ", ",", "All", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"num", "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<n\>\"", ",", "\"\<u\>\""}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"PointSize", "\[Rule]", "0.01"}], "]"}]}], ",", 
      RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"animrate", ",", "3"}], "}"}], ",", "1", ",", "100"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jp", ",", "jpstart"}], "}"}], ",", "jpstart", ",", "jpfinal", 
      ",", "jpinterval", ",", 
      RowBox[{"AnimationRate", "\[Rule]", "animrate"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6452789844416428`*^9, 3.645279005920822*^9}, {
   3.6452790725958567`*^9, 3.64527922001153*^9}, {3.64527929011331*^9, 
   3.6452793140619*^9}, {3.6465687915622177`*^9, 3.6465687929647713`*^9}, 
   3.646641779029295*^9, 3.6466418632064867`*^9, 3.646641923464685*^9, {
   3.646644242877079*^9, 3.6466442610520678`*^9}, {3.6466442926376667`*^9, 
   3.646644325902964*^9}, {3.646644700599557*^9, 3.646644760539188*^9}, {
   3.6466447917778883`*^9, 3.646644804941998*^9}, 3.646644836432431*^9, {
   3.6466449310132647`*^9, 3.6466451488684053`*^9}, {3.6466453475022383`*^9, 
   3.646645357368576*^9}, 3.646647080659285*^9, 3.6466474658673677`*^9, 
   3.646647556307538*^9, {3.646647704566368*^9, 3.646647718178053*^9}, {
   3.6466487694481497`*^9, 3.6466487714954348`*^9}, {3.646649766626109*^9, 
   3.646649773089204*^9}, 3.646650252507649*^9, {3.6466503069272823`*^9, 
   3.646650397396801*^9}, {3.646650811017777*^9, 3.646650858498097*^9}, {
   3.646651091896206*^9, 3.646651133105136*^9}, {3.646652009816388*^9, 
   3.6466520299137917`*^9}, {3.6466521977725887`*^9, 3.64665222886267*^9}, {
   3.6466522963544683`*^9, 3.646652350912005*^9}, {3.6466523875535707`*^9, 
   3.64665246139065*^9}, {3.646652684830247*^9, 3.646652687124411*^9}, 
   3.6466527601840467`*^9, 3.646652920795434*^9, {3.646652976303632*^9, 
   3.646653033537969*^9}, {3.646657272708499*^9, 3.646657276067953*^9}, {
   3.646657415864051*^9, 3.646657478264082*^9}, {3.64665751697976*^9, 
   3.646657542379497*^9}, {3.646658001956719*^9, 3.6466580488677883`*^9}, {
   3.646658102040172*^9, 3.646658114004826*^9}, {3.646658864792631*^9, 
   3.646658867192387*^9}, {3.646658975930893*^9, 3.646659123473825*^9}, 
   3.6466591557750387`*^9, {3.646659267634873*^9, 3.64665937342733*^9}, {
   3.646896120302943*^9, 3.646896137710627*^9}, {3.646896182319322*^9, 
   3.646896195598576*^9}, {3.646896340831846*^9, 3.646896341119218*^9}, {
   3.646896372483898*^9, 3.646896411408967*^9}, {3.6468967693036947`*^9, 
   3.646896770591124*^9}, {3.646896982274434*^9, 3.646897127415161*^9}, {
   3.6468972752639933`*^9, 3.646897313766405*^9}, {3.6468973786005907`*^9, 
   3.64689739883495*^9}, {3.646901135032833*^9, 3.646901135769092*^9}, {
   3.646901182489997*^9, 3.646901227388386*^9}, {3.646904106686473*^9, 
   3.646904107500409*^9}, {3.6469042522427473`*^9, 3.646904263633902*^9}, {
   3.646904849327939*^9, 3.646904862225377*^9}, {3.646904892741418*^9, 
   3.646904939905841*^9}, {3.6469050221630573`*^9, 3.646905045851945*^9}, {
   3.6469050830432663`*^9, 3.646905108723321*^9}, {3.646905213417679*^9, 
   3.6469052380822687`*^9}, {3.6469052906867456`*^9, 3.646905330335538*^9}, {
   3.646905432366349*^9, 3.646905564236979*^9}, {3.646905671860877*^9, 
   3.6469056919740343`*^9}, {3.646905776009431*^9, 3.646905776223037*^9}, 
   3.646905900136922*^9, 3.646905933094803*^9, {3.646906121615878*^9, 
   3.646906121875287*^9}, {3.6469061532430964`*^9, 3.646906194656624*^9}, 
   3.6469062260088577`*^9, {3.646906281526923*^9, 3.646906316914672*^9}, {
   3.6469063517014837`*^9, 3.6469063518582697`*^9}, {3.646908691515107*^9, 
   3.646908694666355*^9}, {3.6469087959668837`*^9, 3.646908808470928*^9}, {
   3.646908885022937*^9, 3.646908885421467*^9}, {3.6469089277437468`*^9, 
   3.646908998863081*^9}, {3.646995249985838*^9, 3.6469952521622143`*^9}, {
   3.6469954106995087`*^9, 3.646995424293898*^9}, {3.647092394714768*^9, 
   3.647092397591257*^9}, 3.647092451415654*^9}],

Cell[BoxData[
 RowBox[{"vplot", "=", 
  RowBox[{"Manipulate", "[", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"vtab", "\[LeftDoubleBracket]", 
       RowBox[{"jp", " ", ",", "All", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"num", "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "15"}], ",", "15"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<n\>\"", ",", "\"\<u\>\""}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"PointSize", "\[Rule]", "0.01"}], "]"}]}], ",", 
      RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"animrate", ",", "3"}], "}"}], ",", "1", ",", "100"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jp", ",", "jpstart"}], "}"}], ",", "jpstart", ",", "jpfinal", 
      ",", "jpinterval", ",", 
      RowBox[{"AnimationRate", "\[Rule]", "animrate"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6452789844416428`*^9, 3.645279005920822*^9}, {
   3.6452790725958567`*^9, 3.64527922001153*^9}, {3.64527929011331*^9, 
   3.6452793140619*^9}, {3.6465687915622177`*^9, 3.6465687929647713`*^9}, 
   3.646641779029295*^9, 3.6466418632064867`*^9, 3.646641923464685*^9, {
   3.646644242877079*^9, 3.6466442610520678`*^9}, {3.6466442926376667`*^9, 
   3.646644325902964*^9}, {3.646644700599557*^9, 3.646644760539188*^9}, {
   3.6466447917778883`*^9, 3.646644804941998*^9}, 3.646644836432431*^9, {
   3.6466449310132647`*^9, 3.6466451488684053`*^9}, {3.6466453475022383`*^9, 
   3.646645357368576*^9}, 3.646647080659285*^9, 3.6466474658673677`*^9, 
   3.646647556307538*^9, {3.646647704566368*^9, 3.646647718178053*^9}, {
   3.6466487694481497`*^9, 3.6466487714954348`*^9}, {3.646649766626109*^9, 
   3.646649773089204*^9}, 3.646650252507649*^9, {3.6466503069272823`*^9, 
   3.646650397396801*^9}, {3.646650811017777*^9, 3.646650858498097*^9}, {
   3.646651091896206*^9, 3.646651133105136*^9}, {3.646652009816388*^9, 
   3.6466520299137917`*^9}, {3.6466521977725887`*^9, 3.64665222886267*^9}, {
   3.6466522963544683`*^9, 3.646652350912005*^9}, {3.6466523875535707`*^9, 
   3.64665246139065*^9}, {3.646652684830247*^9, 3.646652687124411*^9}, 
   3.6466527601840467`*^9, 3.646652920795434*^9, {3.646652976303632*^9, 
   3.646653033537969*^9}, {3.646657272708499*^9, 3.646657276067953*^9}, {
   3.646657415864051*^9, 3.646657478264082*^9}, {3.64665751697976*^9, 
   3.646657542379497*^9}, {3.646658001956719*^9, 3.6466580488677883`*^9}, {
   3.646658102040172*^9, 3.646658114004826*^9}, {3.646658864792631*^9, 
   3.646658867192387*^9}, {3.646658975930893*^9, 3.646659123473825*^9}, 
   3.6466591557750387`*^9, {3.646659267634873*^9, 3.64665937342733*^9}, {
   3.646896120302943*^9, 3.646896137710627*^9}, {3.646896182319322*^9, 
   3.646896195598576*^9}, {3.646896340831846*^9, 3.646896341119218*^9}, {
   3.646896372483898*^9, 3.646896411408967*^9}, {3.6468967693036947`*^9, 
   3.646896770591124*^9}, {3.646896982274434*^9, 3.646897127415161*^9}, {
   3.6468972752639933`*^9, 3.646897313766405*^9}, {3.6468973786005907`*^9, 
   3.64689739883495*^9}, {3.646901135032833*^9, 3.646901135769092*^9}, {
   3.646901182489997*^9, 3.646901227388386*^9}, {3.646904106686473*^9, 
   3.646904107500409*^9}, {3.6469042522427473`*^9, 3.646904263633902*^9}, {
   3.646904849327939*^9, 3.646904862225377*^9}, {3.646904892741418*^9, 
   3.646904939905841*^9}, {3.6469050221630573`*^9, 3.646905045851945*^9}, {
   3.6469050830432663`*^9, 3.646905108723321*^9}, {3.646905213417679*^9, 
   3.6469052380822687`*^9}, {3.6469052906867456`*^9, 3.646905330335538*^9}, {
   3.646905432366349*^9, 3.646905564236979*^9}, {3.646905671860877*^9, 
   3.6469056919740343`*^9}, {3.646905776009431*^9, 3.646905776223037*^9}, 
   3.646905900136922*^9, 3.646905933094803*^9, {3.646906121615878*^9, 
   3.646906121875287*^9}, {3.6469061532430964`*^9, 3.646906194656624*^9}, 
   3.6469062260088577`*^9, {3.646906281526923*^9, 3.646906316914672*^9}, {
   3.6469063517014837`*^9, 3.6469063518582697`*^9}, {3.646908691515107*^9, 
   3.646908694666355*^9}, {3.6469087959668837`*^9, 3.646908808470928*^9}, {
   3.646908885022937*^9, 3.646908885421467*^9}, {3.6469089277437468`*^9, 
   3.646908998863081*^9}, {3.646995249985838*^9, 3.6469952521622143`*^9}, {
   3.6469954106995087`*^9, 3.646995424293898*^9}, {3.647002265650885*^9, 
   3.647002268148157*^9}, 3.6470758999596453`*^9, {3.647078698537344*^9, 
   3.647078731303688*^9}, {3.647092383934289*^9, 3.647092401016872*^9}, 
   3.647092449095871*^9}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Row", "[", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"MakeSSHpicvec2", "[", 
          RowBox[{
           RowBox[{"anstab", "[", 
            RowBox[{"[", "jp", "]"}], "]"}], ",", "r", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "vector"}], " ", "vout"}], "/.", 
            RowBox[{"t", "\[Rule]", 
             RowBox[{"tinterval", "*", 
              RowBox[{"(", 
               RowBox[{"jp", "-", "jpstart"}], ")"}]}]}]}]}], "]"}], "}"}], 
        ",", 
        RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "r"}], ",", 
             RowBox[{"num", "+", "r"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "r"}], "-", "0.5"}], ",", 
             RowBox[{"r", "+", "0.5"}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"pts", "\[LeftDoubleBracket]", 
         RowBox[{"jp", ",", "All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", 
             RowBox[{"num", "+", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<n\>\"", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(n\)]\)\>\""}], 
          "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"PointSize", "\[Rule]", "0.01"}], "]"}]}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<t=\>\"", ",", 
           RowBox[{"jp", "*", "tinterval"}]}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Show", "[", 
       RowBox[{"p1", ",", "p2", ",", 
        RowBox[{"ListPointPlot3D", "[", 
         RowBox[{
          RowBox[{"pts", "\[LeftDoubleBracket]", 
           RowBox[{"jp", ",", "All", ",", "All"}], "\[RightDoubleBracket]"}], 
          ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"Directive", "[", 
            RowBox[{"Red", ",", 
             RowBox[{"PointSize", "\[Rule]", "0.01"}]}], "]"}]}]}], "]"}], 
        ",", 
        RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"animrate", ",", "3"}], "}"}], ",", "1", ",", "100"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"jp", ",", "jpstart"}], "}"}], ",", "jpstart", ",", "jpfinal", 
     ",", "jpinterval", ",", 
     RowBox[{"AnimationRate", "\[Rule]", "animrate"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vector", ",", "0.1"}], "}"}], ",", "0.00", ",", "0.1", ",", 
     "0.01"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"pts3d", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"pts", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "10"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p1", "=", 
       RowBox[{"ListPointPlot3D", "[", 
        RowBox[{
         RowBox[{"pts3d", "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", "All", ",", "All"}], 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"AxesLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<n\>\"", ",", "\"\<time\>\"", ",", "\"\<u\>\""}], 
           "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"PointSize", "\[Rule]", "0.00"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p2", "=", 
       RowBox[{"Graphics3D", "[", 
        RowBox[{"Line", "@", "pts3d"}], "]"}]}], ";"}], "\[IndentingNewLine]",
      ")"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.6452789844416428`*^9, 3.645279005920822*^9}, {
   3.6452790725958567`*^9, 3.64527922001153*^9}, {3.64527929011331*^9, 
   3.6452793140619*^9}, {3.6465687915622177`*^9, 3.6465687929647713`*^9}, 
   3.646641779029295*^9, 3.6466418632064867`*^9, 3.646641923464685*^9, {
   3.646644242877079*^9, 3.6466442610520678`*^9}, {3.6466442926376667`*^9, 
   3.646644325902964*^9}, {3.646644700599557*^9, 3.646644760539188*^9}, {
   3.6466447917778883`*^9, 3.646644804941998*^9}, 3.646644836432431*^9, {
   3.6466449310132647`*^9, 3.6466451488684053`*^9}, {3.6466453475022383`*^9, 
   3.646645357368576*^9}, 3.646647080659285*^9, 3.6466474658673677`*^9, 
   3.646647556307538*^9, {3.646647704566368*^9, 3.646647718178053*^9}, {
   3.6466487694481497`*^9, 3.6466487714954348`*^9}, {3.646649766626109*^9, 
   3.646649773089204*^9}, 3.646650252507649*^9, {3.6466503069272823`*^9, 
   3.646650397396801*^9}, {3.646650811017777*^9, 3.646650858498097*^9}, {
   3.646651091896206*^9, 3.646651133105136*^9}, {3.646652009816388*^9, 
   3.6466520299137917`*^9}, {3.6466521977725887`*^9, 3.64665222886267*^9}, {
   3.6466522963544683`*^9, 3.646652350912005*^9}, {3.6466523875535707`*^9, 
   3.64665246139065*^9}, {3.646652684830247*^9, 3.646652687124411*^9}, 
   3.6466527601840467`*^9, 3.646652920795434*^9, {3.646652976303632*^9, 
   3.646653033537969*^9}, {3.646657272708499*^9, 3.646657276067953*^9}, {
   3.646657415864051*^9, 3.646657478264082*^9}, {3.64665751697976*^9, 
   3.646657542379497*^9}, {3.646658001956719*^9, 3.6466580488677883`*^9}, {
   3.646658102040172*^9, 3.646658114004826*^9}, {3.646658864792631*^9, 
   3.646658867192387*^9}, {3.646658975930893*^9, 3.646659123473825*^9}, 
   3.6466591557750387`*^9, {3.646659267634873*^9, 3.64665937342733*^9}, {
   3.646896120302943*^9, 3.646896137710627*^9}, {3.646896182319322*^9, 
   3.646896195598576*^9}, {3.646896340831846*^9, 3.646896341119218*^9}, {
   3.646896372483898*^9, 3.646896411408967*^9}, {3.6468967693036947`*^9, 
   3.646896770591124*^9}, {3.646896982274434*^9, 3.646897127415161*^9}, {
   3.6468972752639933`*^9, 3.646897313766405*^9}, {3.6468973786005907`*^9, 
   3.64689739883495*^9}, {3.646901135032833*^9, 3.646901135769092*^9}, {
   3.646901182489997*^9, 3.646901227388386*^9}, {3.646904106686473*^9, 
   3.646904107500409*^9}, {3.6469042522427473`*^9, 3.646904263633902*^9}, {
   3.646904849327939*^9, 3.646904862225377*^9}, {3.646904892741418*^9, 
   3.646904939905841*^9}, {3.6469050221630573`*^9, 3.646905045851945*^9}, {
   3.6469050830432663`*^9, 3.646905108723321*^9}, {3.646905213417679*^9, 
   3.6469052380822687`*^9}, {3.6469052906867456`*^9, 3.646905330335538*^9}, {
   3.646905432366349*^9, 3.646905564236979*^9}, {3.646905671860877*^9, 
   3.6469056919740343`*^9}, {3.646905776009431*^9, 3.646905776223037*^9}, 
   3.646905900136922*^9, 3.646905933094803*^9, {3.646906121615878*^9, 
   3.646906121875287*^9}, {3.6469061532430964`*^9, 3.646906194656624*^9}, 
   3.6469062260088577`*^9, {3.646906281526923*^9, 3.646906316914672*^9}, {
   3.6469063517014837`*^9, 3.6469063518582697`*^9}, {3.646908691515107*^9, 
   3.646908694666355*^9}, 3.6469087809918633`*^9, {3.64707648469786*^9, 
   3.647076485015636*^9}, {3.647077141430675*^9, 3.647077143799917*^9}, 
   3.647092442091791*^9, {3.647180848727179*^9, 3.647180849141246*^9}, {
   3.647758709793805*^9, 3.647758722858757*^9}, {3.647763155661893*^9, 
   3.647763180861333*^9}, {3.647853631711152*^9, 3.647853633886648*^9}, {
   3.6493959387175837`*^9, 3.649395938930336*^9}, {3.649411831378113*^9, 
   3.649411832914825*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["profile analysis", "Subsubsection",
 CellChangeTimes->{{3.6490788835155487`*^9, 3.649078906393634*^9}, 
   3.6493959385145884`*^9}],

Cell["velocity profile, if initial single kink, fit its shape mode", "Text",
 CellChangeTimes->{{3.647761996749021*^9, 3.647762066351623*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Table", "[", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", "2"}], "]"}]], "r", " ", 
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ans", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], ",", "t"}], 
              "]"}]}], "/.", 
            RowBox[{"t", "\[Rule]", "0"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"modenum", "==", "1"}], ",", 
          RowBox[{"-", "A"}], ",", "0"}], "]"}], " ", 
        RowBox[{"Tanh", "[", 
         FractionBox[
          RowBox[{"x", "-", "x0"}], "w"], "]"}], 
        RowBox[{"Sech", "[", 
         FractionBox[
          RowBox[{"x", "-", "x0"}], "w"], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "1", ",", "num"}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "15"}], "}"}], ",", "0", ",", "20", ",", "1"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x0", ",", 
       RowBox[{"num", "/", "2"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"num", "/", "2"}], "-", "10"}], ",", 
     RowBox[{
      RowBox[{"num", "/", "2"}], "+", "10"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"w", ",", "width"}], "}"}], ",", "0.5", ",", "3"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.647081665807398*^9, 3.647081855326325*^9}, {
   3.647082015959004*^9, 3.647082042023601*^9}, {3.647082538004055*^9, 
   3.647082567780491*^9}, {3.647082692884061*^9, 3.6470827009688377`*^9}, 
   3.6470827762165823`*^9, {3.647082855001883*^9, 3.647082940234852*^9}, {
   3.647085435619135*^9, 3.647085515799077*^9}}],

Cell["Potential Plot", "Text",
 CellChangeTimes->{{3.6477594567661457`*^9, 3.6477594618866177`*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPointPlot3D", "[", 
    RowBox[{
     RowBox[{"petab", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "t", ",", 
            RowBox[{
             RowBox[{"espring", "[", 
              RowBox[{"t", ",", "i"}], "]"}], "/.", 
             RowBox[{"ldef", "\[Rule]", "lzero"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "tstart", ",", "tfinal", ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "50"}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
     ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"Directive", "[", 
       RowBox[{"PointSize", "\[Rule]", "Small"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{"Line", "@", "petab"}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647758486298566*^9, 3.647758588981019*^9}, {
  3.6477586301910954`*^9, 3.647758677084528*^9}, {3.6477588975253563`*^9, 
  3.6477591792895803`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"kk", "[", "i", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"a", "-", 
               RowBox[{"r", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sin", "[", 
                   RowBox[{
                    RowBox[{"ans$antikink$initial", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], 
                  "-", "  ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{
                    RowBox[{"ans$antikink$initial", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
                   "]"}]}], ")"}]}]}], ")"}], "2"], "+", 
            SuperscriptBox[
             RowBox[{"(", " ", 
              RowBox[{"r", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{
                   RowBox[{"ans$antikink$initial", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", "t", "]"}], "]"}], 
                 "-", " ", 
                 RowBox[{"Cos", "[", 
                  RowBox[{
                   RowBox[{"ans$antikink$initial", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", "t", "]"}], 
                  "]"}]}], ")"}]}], ")"}], "2"]}], "]"}], "-", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", 
              RowBox[{"numdef", "-", "1"}]}], ",", 
             SuperscriptBox["ldef", "2"], ",", "lzerosq"}], "]"}], "]"}]}], 
         ")"}], "2"]}], "/.", 
      RowBox[{"{", 
       RowBox[{"ldef", "\[Rule]", "lzero"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", "tfinal"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6579700702393217`*^9, 3.657970076126938*^9}, {
  3.657970155139814*^9, 3.657970276164238*^9}, {3.657970383432893*^9, 
  3.657970399832868*^9}, {3.657970445596429*^9, 3.657970454424465*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"espring", "[", 
       RowBox[{"t", ",", "i"}], "]"}], "/.", 
      RowBox[{"ldef", "\[Rule]", "lzero"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", "0.5"}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Time\>\"", ",", "\"\<P.E.\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"600", ",", "300"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Full"}], ",", 
   RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
   RowBox[{"LabelStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
   RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
   RowBox[{"PlotRangePadding", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0.04"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
   RowBox[{"FrameTicks", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Automatic"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647762420439283*^9, 3.647762421575417*^9}, {
  3.64776402820831*^9, 3.6477641038816032`*^9}, {3.651926132181176*^9, 
  3.651926134161272*^9}, {3.65192616798691*^9, 3.651926176514304*^9}, {
  3.651926243222693*^9, 3.651926265880575*^9}, {3.657962770908724*^9, 
  3.6579629806828413`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwcXHk4ll8Ttu9k39d3UyiRUMozVCplSelX9qSEZK0QEi0qJLKrlDUppSIV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     "]]}},
  AspectRatio->Full,
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 1359.15},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"PE\"", TraditionalForm], None}, {
     FormBox["\"t\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->{1500, 300},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Input",
 CellChangeTimes->{
  3.6519276137158537`*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"espring", "[", 
       RowBox[{"t", ",", "i"}], "]"}], "/.", 
      RowBox[{"ldef", "\[Rule]", "lzero"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", 
     RowBox[{"(", 
      RowBox[{"tfinal", "-", "tstart"}], ")"}]}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<PE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647762265264645*^9, 3.647762308555954*^9}, 
   3.6477625163949757`*^9, {3.647764154195804*^9, 3.6477641576344843`*^9}, 
   3.649658156648604*^9, 3.649658211309451*^9, {3.649658301116672*^9, 
   3.649658301355448*^9}, {3.649658350254241*^9, 3.649658364029686*^9}, 
   3.6496587391101637`*^9, {3.649658782906077*^9, 3.649658807799485*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"espring", "[", 
       RowBox[{"t", ",", "i"}], "]"}], "/.", 
      RowBox[{"ldef", "\[Rule]", "lzero"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"num", "/", "2"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "10"}]}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<PE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647762265264645*^9, 3.647762308555954*^9}, 
   3.6477625163949757`*^9, {3.64776325182029*^9, 3.647763273063159*^9}, {
   3.6477641681293173`*^9, 3.647764170755908*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"espring", "[", 
       RowBox[{"t", ",", "i"}], "]"}], "/.", 
      RowBox[{"ldef", "\[Rule]", "lzero"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"num", "/", "2"}], "+", "1"}], ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "10"}]}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<PE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647762265264645*^9, 3.647762308555954*^9}, 
   3.6477625163949757`*^9, {3.64776325182029*^9, 3.647763292475328*^9}, 
   3.647764176852331*^9}],

Cell["Kinetic Plot", "Text",
 CellChangeTimes->{{3.6477594659924793`*^9, 3.647759481967993*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPointPlot3D", "[", 
    RowBox[{
     RowBox[{"ketab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "t", ",", 
          RowBox[{
           RowBox[{
            FractionBox[
             RowBox[{"M", "[", "i", "]"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"r", " ", 
               RowBox[{"D", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ans", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", 
                 "tt"}], "]"}]}], ")"}], "2"]}], "/.", 
           RowBox[{"tt", "\[Rule]", "t"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tstart", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "1"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "100"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"Directive", "[", 
       RowBox[{"PointSize", "\[Rule]", "Small"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{"Line", "@", "ketab"}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647758486298566*^9, 3.647758588981019*^9}, {
   3.6477586301910954`*^9, 3.647758677084528*^9}, {3.6477588975253563`*^9, 
   3.6477591792895803`*^9}, {3.647764313334214*^9, 3.647764483705454*^9}, 
   3.647764532415625*^9, 3.6477645754079113`*^9}],

Cell[BoxData[
 RowBox[{"ke$time$plot1", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        UnderoverscriptBox["\[Sum]", 
         RowBox[{"i", "=", "1"}], "num"], 
        RowBox[{
         FractionBox[
          RowBox[{"M", "[", "i", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"kans", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}],
              "]"}]}], ")"}], "2"]}]}], "/.", 
       RowBox[{"tt", "\[Rule]", "t"}]}], ",", 
      RowBox[{
       RowBox[{
        UnderoverscriptBox["\[Sum]", 
         RowBox[{"i", "=", "1"}], "num"], 
        RowBox[{
         FractionBox[
          RowBox[{"M", "[", "i", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"akans", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}],
              "]"}]}], ")"}], "2"]}]}], "/.", 
       RowBox[{"tt", "\[Rule]", "t"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "tstart", ",", "0.6"}], "}"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<Time\>\"", ",", "\"\<K.E.\>\""}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", 
       RowBox[{"{", 
        RowBox[{"2.2", ",", "3.0"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", " ", 
         RowBox[{"Thickness", "[", "0.01", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", " ", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"2", ",", "12"}], "}"}], "]"}], ",", 
         RowBox[{"Thickness", "[", "0.01", "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Full"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"PlotRangePadding", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "Automatic"}], "}"}]}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "2.2", ",", "3.0", ",", "0.2"}], "}"}]}], "]"}],
          ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "0.5", ",", "0.1"}], "}"}]}], "]"}], 
         ",", "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"Placed", "[", 
      RowBox[{
       RowBox[{"LineLegend", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Kink\>\"", ",", "\"\<Antikink\>\""}], "}"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.4", ",", "0.2"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6477624420733633`*^9, 3.647762475799799*^9}, {
   3.647764184277792*^9, 3.6477641874901743`*^9}, {3.651926295992682*^9, 
   3.651926296330428*^9}, {3.657962188672924*^9, 3.6579621889871902`*^9}, {
   3.6579625169147253`*^9, 3.657962521009245*^9}, {3.6579625623561077`*^9, 
   3.6579626434122477`*^9}, {3.657962686822132*^9, 3.6579627431100483`*^9}, {
   3.6579630123650713`*^9, 3.65796307382132*^9}, {3.657963125504121*^9, 
   3.657963152623982*^9}, {3.657963199552943*^9, 3.657963213109096*^9}, {
   3.657963648750362*^9, 3.657963659212097*^9}, {3.657963864390531*^9, 
   3.65796390782472*^9}, {3.657964274618257*^9, 3.657964353709549*^9}, {
   3.657964396112092*^9, 3.6579644124572563`*^9}, {3.657964534017128*^9, 
   3.6579645938090677`*^9}, {3.6579647521671743`*^9, 3.657964765235977*^9}, 
   3.657964813527896*^9, {3.657964848330439*^9, 3.6579649000726843`*^9}, {
   3.657965090783434*^9, 3.6579651524180117`*^9}, {3.657965229683763*^9, 
   3.65796523398534*^9}, {3.657965273844288*^9, 3.657965316274247*^9}, {
   3.6579653583746634`*^9, 3.6579653672683496`*^9}, {3.657965416231921*^9, 
   3.657965453269268*^9}, {3.65796803193828*^9, 3.6579680322797003`*^9}, {
   3.657968702562098*^9, 3.6579687232011433`*^9}, {3.657968764189588*^9, 
   3.6579687919596043`*^9}, 3.657968825428227*^9, {3.657968996441936*^9, 
   3.657968996537376*^9}, {3.6611503497318573`*^9, 3.661150354691299*^9}, {
   3.665486205784618*^9, 3.665486230720689*^9}, {3.66548638970936*^9, 
   3.665486390736045*^9}, {3.674823839394679*^9, 3.674823873814454*^9}, 
   3.6748240619610987`*^9, {3.674824178637062*^9, 3.674824207019128*^9}}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{{}, {}, 
     {GrayLevel[0], Thickness[0.01], Opacity[1.], LineBox[CompressedData["
1:eJwc3Hk8VO0XAHCJIW0qIUSIJKVURHLG0ia8LZRkjUrIFkUiWxKSJUtIyi5k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       "]]}, 
     {GrayLevel[0], Thickness[0.01], Opacity[1.], AbsoluteDashing[{2, 12}], 
      LineBox[CompressedData["
1:eJwV2nk4lN8XAHC9Y2aUsiUpIkKKKKSVcy1Jiq+IkEqoVEJIsiWhSLIniqwh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       "]]}}, InsetBox[
     TemplateBox[{"\"Kink\"","\"Antikink\""},
      "LineLegend",
      DisplayFunction->(FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.09]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.09]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    AbsoluteDashing[{2, 12}], 
                    Thickness[0.09]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    AbsoluteDashing[{2, 12}], 
                    Thickness[0.09]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> 20], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]& ),
      Editable->True,
      InterpretationFunction:>(RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                   ",", 
                   RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                   ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "12"}], "}"}], "]"}], ",", 
                   RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}]}], "}"}],
            ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& )], 
     Scaled[{0.4, 0.2}], ImageScaled[{0.5, 0.5}],
     BaseStyle->{FontSize -> Larger},
     FormatType->StandardForm]},
   AspectRatio->Full,
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 2.2},
   DisplayFunction->Identity,
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox["\"K.E.\"", TraditionalForm], None}, {
      FormBox["\"Time\"", TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->{{{{2.2, 
        FormBox["2.2`", TraditionalForm]}, {2.4000000000000004`, 
        FormBox["2.4000000000000004`", TraditionalForm]}, {2.6, 
        FormBox["2.6`", TraditionalForm]}, {2.8000000000000003`, 
        FormBox["2.8000000000000003`", TraditionalForm]}, {3., 
        FormBox["3.`", TraditionalForm]}}, None}, {{{0., 
        FormBox["0.`", TraditionalForm]}, {0.1, 
        FormBox["0.1`", TraditionalForm]}, {0.2, 
        FormBox["0.2`", TraditionalForm]}, {0.30000000000000004`, 
        FormBox["0.30000000000000004`", TraditionalForm]}, {0.4, 
        FormBox["0.4`", TraditionalForm]}, {0.5, 
        FormBox["0.5`", TraditionalForm]}}, None}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->600,
   LabelStyle->Directive[FontSize -> Large],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0., 0.599999987755102}, {2.2, 3.}},
   PlotRangeClipping->True,
   PlotRangePadding->{{0, 0}, {0, 0}},
   Ticks->{Automatic, Automatic}],
  InterpretTemplate[Legended[
    Graphics[{{{}, {}, {
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         Thickness[0.01]], 
        Line[CompressedData["
1:eJwc3Hk8VO0XAHCJIW0qIUSIJKVURHLG0ia8LZRkjUrIFkUiWxKSJUtIyi5k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         "]]}, {
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         AbsoluteDashing[{2, 12}], 
         Thickness[0.01]], 
        Line[CompressedData["
1:eJwV2nk4lN8XAHC9Y2aUsiUpIkKKKKSVcy1Jiq+IkEqoVEJIsiWhSLIniqwh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         "]]}}}, {
     DisplayFunction -> Identity, AspectRatio -> Full, Axes -> {True, True}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0, 2.2}, DisplayFunction :> 
      Identity, Frame -> {{True, True}, {True, True}}, 
      FrameLabel -> {{"K.E.", None}, {"Time", None}}, FrameStyle -> 
      Thickness[Large], 
      FrameTicks -> {{{2.2, 2.4000000000000004`, 2.6, 2.8000000000000003`, 
         3.}, None}, {{0., 0.1, 0.2, 0.30000000000000004`, 0.4, 0.5}, None}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
      Directive[FontSize -> Large], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None}, 
      PlotRange -> {{0., 0.599999987755102}, {2.2, 3.}}, PlotRangeClipping -> 
      True, PlotRangePadding -> {{0, 0}, {0, 0}}, 
      Ticks -> {Automatic, Automatic}}], 
    Placed[
     Unevaluated[
      LineLegend[{
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         Thickness[0.01]], 
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         AbsoluteDashing[{2, 12}], 
         Thickness[0.01]]}, {"Kink", "Antikink"}, LegendMarkers -> None, 
       LabelStyle -> Directive[FontSize -> 20], LegendLayout -> "Column"]], {
     0.4, 0.2}, Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Input",
 CellChangeTimes->{3.674824219804837*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<ketimeplot1.pdf\>\"", ",", "ke$time$plot1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.657963664459078*^9, 3.657963716027713*^9}, {
   3.657963870400231*^9, 3.657963894192504*^9}, 3.657965206638426*^9, 
   3.657966217365295*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUWnc4ln8Xt/fe2+MhFZJUkso5VJKErH7JDmlJRiJJSBIqKbLKrCQJEdl7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     "]]}},
  AspectRatio->Full,
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"KE\"", TraditionalForm], None}, {
     FormBox["\"t\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->{1500, 300},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Input",
 CellChangeTimes->{
  3.651927611603183*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", "1"}], "num"], 
     RowBox[{
      FractionBox[
       RowBox[{"M", "[", "i", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"r", " ", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
          "]"}]}], ")"}], "2"]}]}], "/.", 
    RowBox[{"tt", "\[Rule]", "t"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "10"}]}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<KE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647762328833684*^9, 3.647762349814266*^9}, 
   3.64776238090371*^9, {3.6477642002464447`*^9, 3.647764216546767*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"i", "=", "1"}], "num"], 
       RowBox[{
        FractionBox[
         RowBox[{"M", "[", "i", "]"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"r", " ", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"ans", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
            "]"}]}], ")"}], "2"]}]}], "/.", 
      RowBox[{"tt", "\[Rule]", "t"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "tstart", ",", "tfinal", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "200"}]}], "}"}]}], 
    "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6580522227957172`*^9, 3.658052241133047*^9}, {
   3.6580522762351007`*^9, 3.658052276313854*^9}, {3.658052318204174*^9, 
   3.6580524089894857`*^9}, 3.658052523539301*^9}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", 
       RowBox[{"num", "/", "2"}]}], "num"], 
     RowBox[{
      FractionBox[
       RowBox[{"M", "[", "i", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"r", " ", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
          "]"}]}], ")"}], "2"]}]}], " ", "/.", " ", 
    RowBox[{"tt", " ", "->", " ", "t"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", " ", "-", " ", "tstart"}], ")"}], "/", "10"}]}], 
    "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<KE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6477629848388968`*^9, 3.647763005930882*^9}, {
  3.6477642069700117`*^9, 3.647764231974946*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", "1"}], 
      RowBox[{"num", "/", "2"}]], 
     RowBox[{
      FractionBox[
       RowBox[{"M", "[", "i", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"r", " ", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
          "]"}]}], ")"}], "2"]}]}], " ", "/.", " ", 
    RowBox[{"tt", " ", "->", " ", "t"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", " ", "-", " ", "tstart"}], ")"}], "/", "10"}]}], 
    "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<KE\>\""}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6477629848388968`*^9, 3.647763005930882*^9}, {
   3.6477630471905823`*^9, 3.647763053954668*^9}, {3.6477642346816673`*^9, 
   3.647764238002861*^9}, 3.647767780920885*^9}],

Cell["All", "Text",
 CellChangeTimes->{{3.6477677849673347`*^9, 3.647767790742866*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Show", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Mod", "[", 
                   RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
                 RowBox[{"Mod", "[", 
                  RowBox[{
                   RowBox[{"\[Pi]", "-", 
                    RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], ",", 
                   RowBox[{"2", "\[Pi]"}], ",", 
                   RowBox[{"-", "\[Pi]"}]}], "]"}], ",", 
                 RowBox[{"Mod", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", 
                   RowBox[{"2", "\[Pi]"}], ",", 
                   RowBox[{"-", "\[Pi]"}]}], "]"}]}], "]"}], "/.", 
               RowBox[{"tt", "\[Rule]", "t"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "Large"}], ",", "Blue"}], 
            "]"}]}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"num", "+", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"PlotLegends", "\[Rule]", 
           RowBox[{"{", "\"\<\[Theta]\>\"", "}"}]}]}], "]"}], ",", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"ck", 
                 FractionBox[
                  RowBox[{"M", "[", "i", "]"}], "2"], 
                 SuperscriptBox[
                  RowBox[{"(", " ", 
                   RowBox[{"r", " ", 
                    RowBox[{"D", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ans", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", 
                    "tt"}], "]"}]}], ")"}], "2"]}], ")"}], "/.", 
               RowBox[{"tt", "\[Rule]", "t"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "Large"}], ",", "Green"}], 
            "]"}]}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"num", "+", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "ymax"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"PlotLegends", "\[Rule]", 
           RowBox[{"{", "\"\<KE\>\"", "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"i", "+", "0.5"}], ",", 
              RowBox[{
               RowBox[{"cp", " ", 
                RowBox[{"espring", "[", 
                 RowBox[{"t", ",", "i"}], "]"}]}], "/.", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ldef", "\[Rule]", "lzero"}], ",", 
                 RowBox[{"tt", "\[Rule]", "t"}]}], "}"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"Directive", "[", 
            RowBox[{
             RowBox[{"PointSize", "\[Rule]", "Large"}], ",", "Red"}], "]"}]}],
           ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"num", "+", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "ymax"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"PlotLegends", "\[Rule]", 
           RowBox[{"{", "\"\<PE\>\"", "}"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tstart", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "1."}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "10000."}], ",", 
     RowBox[{"AnimationRate", "\[Rule]", "animrate"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"animrate", ",", "0.01"}], "}"}], ",", "0.01", ",", "0.1", ",", 
     "0.01"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ymax", ",", "1.2"}], "}"}], ",", "0.5", ",", "200"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ck", ",", "0.1"}], "}"}], ",", "0.001", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"cp", ",", "0.0005"}], "}"}], ",", "0.0001", ",", "1"}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.647764607356595*^9, 3.64776480165131*^9}, {
   3.647764841944377*^9, 3.647764845506493*^9}, {3.647764963241126*^9, 
   3.6477649634629917`*^9}, {3.647765213950116*^9, 3.647765269822658*^9}, {
   3.647765389648649*^9, 3.647765407857047*^9}, 3.647765496627489*^9, {
   3.647765629003302*^9, 3.6477656488388643`*^9}, 3.647765706602849*^9, {
   3.6477657779453897`*^9, 3.647765849643024*^9}, {3.6477659302566767`*^9, 
   3.647766069904869*^9}, {3.6477661056228323`*^9, 3.647766167634963*^9}, {
   3.6477664283160543`*^9, 3.647766446117036*^9}, {3.6477665363352337`*^9, 
   3.647766539769103*^9}, {3.647766621151196*^9, 3.647766691790526*^9}, {
   3.64776673267408*^9, 3.6477667436498947`*^9}, 3.6477668658644753`*^9, 
   3.647766901557211*^9, {3.647768025684895*^9, 3.647768049505389*^9}, {
   3.6477681309002867`*^9, 3.647768153363578*^9}, {3.647768325874352*^9, 
   3.6477683689832897`*^9}, {3.6477697042163353`*^9, 3.647769705338149*^9}, {
   3.647773607966098*^9, 3.6477736388871098`*^9}, {3.647773718335981*^9, 
   3.6477737459457293`*^9}, {3.647773787226741*^9, 3.647773904623423*^9}, {
   3.647773947507063*^9, 3.6477739979046803`*^9}, {3.647863532400722*^9, 
   3.647863570623081*^9}, {3.647868160273264*^9, 3.647868184098139*^9}, {
   3.649659951383789*^9, 3.649659953028984*^9}, {3.651926374795788*^9, 
   3.65192641437899*^9}, 3.651926498604272*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"kinkconftab", "[", "t_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Pi]", "-", 
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}]}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}], ",", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ans", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}]}], "]"}], "/.", 
       RowBox[{"tt", "\[Rule]", "t"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6496598817118187`*^9, 3.64965990587681*^9}, {
   3.649660043220428*^9, 3.649660082005136*^9}, 3.6496601167584667`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"theta0left", "=", 
   RowBox[{
    RowBox[{"kinkconftab", "[", "0", "]"}], "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.649660021746708*^9, 3.64966003378232*^9}, {
  3.649660085444854*^9, 3.6496601328812513`*^9}}],

Cell[BoxData[
 RowBox[{"theta0right", "=", 
  RowBox[{
   RowBox[{"kinkconftab", "[", "0", "]"}], "\[LeftDoubleBracket]", 
   RowBox[{"num", ",", "2"}], "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{{3.649660021746708*^9, 3.64966003378232*^9}, {
  3.649660085444854*^9, 3.649660150149899*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.649660225937869*^9, 3.649660237864601*^9}, {
  3.649744260276244*^9, 3.6497442608725452`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["v mode display kink", "Subsection",
 CellChangeTimes->{{3.6466486423109837`*^9, 3.646648644962531*^9}, {
  3.6469068204711514`*^9, 3.6469068216735363`*^9}, {3.646911387317358*^9, 
  3.6469113907626247`*^9}, {3.646913034544911*^9, 3.646913056619774*^9}, {
  3.646913375545557*^9, 3.64691338937993*^9}, {3.646914500399425*^9, 
  3.64691450252918*^9}, {3.646917268565242*^9, 3.646917270162532*^9}, {
  3.646917980466864*^9, 3.646917981474946*^9}, {3.647079969717678*^9, 
  3.647079984852559*^9}, {3.647084277272216*^9, 3.6470842781981916`*^9}, {
  3.647086552980399*^9, 3.647086554185987*^9}, {3.657035131533537*^9, 
  3.6570351320778637`*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"num", "=", "24"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<\[Theta]wobbler=\>\"", ",", 
      RowBox[{"thwob", "=", 
       RowBox[{"N", "[", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"a", "/", 
          RowBox[{"(", 
           RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<\[Theta]spinner=\>\"", ",", 
      RowBox[{"thspin", "=", 
       RowBox[{"N", "[", 
        RowBox[{"ArcSin", "[", 
         SqrtBox[
          RowBox[{"a", "/", "r"}]], "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<th0=\>\"", ",", 
      RowBox[{"th0", "=", 
       RowBox[{
        RowBox[{"Re", "@", "thwob"}], "-", "0.2"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lzerosq", "=", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<lzero=\>\"", ",", 
      RowBox[{"lzero", "=", 
       SuperscriptBox["lzerosq", 
        RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"kdef", "=", "10000."}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Mdef", "=", "1."}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", "kdef", ",", "10000."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "numdef"}], ",", "Mdef", ",", "1."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ldef", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
     " ", "defect", " ", "spring", " ", "is"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"thnumx", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"runreansQ", "=", "False"}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "Whether", " ", "analysis", " ", "simulation", " ", "data", " ", "or", 
     " ", "independent"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"runreansQ", "==", "True"}], ",", 
      RowBox[{
       RowBox[{"initialold", "=", "reanstab"}], ";"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"R", "=", 
     RowBox[{"MakeSSHrig", "[", 
      RowBox[{"initialold", ",", "r"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
     "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"kMatrix", "=", 
     RowBox[{"Normal", "[", 
      RowBox[{"SparseArray", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", 
          RowBox[{"kk", "[", "i", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], "]"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"es", "=", 
     RowBox[{"Eigensystem", "[", 
      RowBox[{"DMat", "[", "initialold", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"e", "[", "modenum_", "]"}], ":=", 
     RowBox[{"es", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", 
        RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";"}]}]}]], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, {3.651491213558509*^9, 
   3.651491280503687*^9}, {3.651491320806761*^9, 3.6514913261523113`*^9}, {
   3.657034338839798*^9, 3.657034338949518*^9}, {3.657034426065905*^9, 
   3.6570344339372063`*^9}, 3.657034464882382*^9, {3.657035134323656*^9, 
   3.657035134497733*^9}, {3.6574503666944923`*^9, 3.65745050270922*^9}, {
   3.657450532904983*^9, 3.657450649323237*^9}, {3.657450770347843*^9, 
   3.657450770666935*^9}, {3.657450801682762*^9, 3.657450801730831*^9}, {
   3.6574508604010878`*^9, 3.657450898484126*^9}, {3.65745099068983*^9, 
   3.6574510178752604`*^9}, {3.657451086307335*^9, 3.657451162646514*^9}, {
   3.657451196487183*^9, 3.657451204380588*^9}, {3.657451250215177*^9, 
   3.657451375224823*^9}, {3.6574514335803623`*^9, 3.6574514473091373`*^9}, {
   3.657542336785095*^9, 3.6575423375504313`*^9}, {3.657542401423752*^9, 
   3.657542404319759*^9}, {3.657542461272785*^9, 3.657542513857498*^9}, {
   3.657624542004088*^9, 3.657624542149674*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kinkconf1", "=", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"MakeSSHpicvec", "[", 
          RowBox[{"initialold", ",", "r", ",", 
           RowBox[{
            RowBox[{"-", "3"}], 
            RowBox[{"e", "[", "moden", "]"}]}]}], 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
            "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
             "sign"}], ",", " ", 
            RowBox[{"use", " ", "-", " ", 
             RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              FractionBox[
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], 
                RowBox[{"Mod", "[", 
                 RowBox[{"i", ",", "2"}], "]"}]], 
               SqrtBox[
                RowBox[{"M", "[", "i", "]"}]]], 
              RowBox[{
               RowBox[{"e", "[", "moden", "]"}], "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}], ",", 
           RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Sort", "[", 
            RowBox[{
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{
                RowBox[{"-", "10"}], ";;", 
                RowBox[{"-", "1"}]}]}], "\[RightDoubleBracket]"}], ",", 
             "Less"}], "]"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}]}], "}"}], 
       "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"moden", ",", "1"}], "}"}], ",", "0", ",", 
     RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, {3.651491213558509*^9, 
   3.651491280503687*^9}, {3.651491320806761*^9, 3.6514913261523113`*^9}, {
   3.657034338839798*^9, 3.657034338949518*^9}, {3.657034426065905*^9, 
   3.6570344339372063`*^9}, 3.657034464882382*^9, {3.657035134323656*^9, 
   3.657035134497733*^9}, {3.6574503666944923`*^9, 3.65745050270922*^9}, {
   3.657450532904983*^9, 3.657450602327118*^9}}],

Cell[BoxData[
 RowBox[{"kinkconf1", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{
       RowBox[{"-", "2"}], 
       RowBox[{"e", "[", "0", "]"}]}]}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
        "sign"}], ",", " ", 
       RowBox[{"use", " ", "-", " ", 
        RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.657034451037397*^9, 3.657034452333498*^9}, {
  3.657034514161083*^9, 3.657034534954727*^9}, {3.6570354191097393`*^9, 
  3.6570354348698587`*^9}}],

Cell[BoxData[
 RowBox[{"kinkconf2", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{"e", "[", "1", "]"}]}]}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
        "sign"}], ",", " ", 
       RowBox[{"use", " ", "-", " ", 
        RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.657034517807513*^9, 3.657034538831727*^9}, {
   3.657035426181684*^9, 3.6570354358459272`*^9}, 3.6576245584308767`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kinkconft.pdf\>\"", ",", "kinkconf1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.657034567872712*^9, 3.6570345883210373`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<kinkconfs.pdf\>\"", ",", "kinkconf2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.657034567872712*^9, 3.657034603345389*^9}}],

Cell[CellGroupData[{

Cell["Change th0", "Subsubsection",
 CellChangeTimes->{{3.656669276538365*^9, 3.656669281866658*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "th0", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "tableContentx2", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.656669735231163*^9, 3.656669739989785*^9}, {
   3.656669806359185*^9, 3.6566698125833*^9}, 3.6570318884505463`*^9}],

Cell[BoxData[
 RowBox[{"tableContentx2", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"num", "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"th0", "<", "0.03"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"th0", "<", "0.02"}], ",", "1000", ",", "200"}], "]"}], ",", 
       "80"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"a", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"r", "=", "0.8"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<th0=\>\"", ",", 
        RowBox[{"th0", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"ArcSin", "[", 
            RowBox[{"a", "/", 
             RowBox[{"(", 
              RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.4"}]}]}], 
       "]"}], ";"}], "*)"}], 
    RowBox[{"(*", 
     RowBox[{"The", " ", "1", "st", " ", "angle", " ", "choice"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"lzerosq", "=", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ldef", "=", "lzero"}], ";", "\[IndentingNewLine]", 
    RowBox[{"v0", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"thnumx", "=", 
     RowBox[{"th0", "/", "2"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"kdef", "=", "10000"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Mdef", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"tfinal", "=", "20"}], ";", "\[IndentingNewLine]", 
    RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
    RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", "kdef", ",", "10000."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "numdef"}], ",", "Mdef", ",", "1."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"vzero", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.65666929786712*^9, 3.65666931628401*^9}, {
   3.656669376910492*^9, 3.656669406095714*^9}, {3.65666945464213*^9, 
   3.656669477441822*^9}, {3.656669788489408*^9, 3.656669794025712*^9}, {
   3.656669870108878*^9, 3.656669892795402*^9}, {3.656672428169249*^9, 
   3.656672428527495*^9}, {3.65667265145405*^9, 3.65667265422815*^9}, {
   3.656672774383713*^9, 3.6566727801431713`*^9}, {3.656672829968874*^9, 
   3.6566728319547367`*^9}, {3.656673243435261*^9, 3.656673243501075*^9}, {
   3.656673285788288*^9, 3.656673290123436*^9}, {3.656673447295023*^9, 
   3.65667344879904*^9}, {3.6566751551920347`*^9, 3.656675172648347*^9}, 
   3.656675759014419*^9, {3.656675818968787*^9, 3.6566758251380777`*^9}, {
   3.6567606609761953`*^9, 3.656760667423883*^9}, {3.6567609211583157`*^9, 
   3.656760934389842*^9}, 3.656761745146143*^9, {3.656761813930787*^9, 
   3.656761828298792*^9}, 3.656762151331251*^9, {3.656762636190547*^9, 
   3.6567626505901823`*^9}, {3.656762747745262*^9, 3.6567627479835987`*^9}, {
   3.6567628435558968`*^9, 3.656762870691722*^9}, {3.6567630495121117`*^9, 
   3.656763053208007*^9}, {3.65676343505767*^9, 3.656763456161418*^9}, {
   3.6567643002455873`*^9, 3.6567643003410597`*^9}, {3.656764401784218*^9, 
   3.656764405815176*^9}, 3.6567661204326267`*^9, {3.65676615251401*^9, 
   3.656766194337891*^9}, {3.656767576627673*^9, 3.656767576656006*^9}, {
   3.656767618357977*^9, 3.6567676184681063`*^9}, 3.656953122806341*^9, {
   3.6569541981927834`*^9, 3.6569541982866507`*^9}, 3.657013852826365*^9, 
   3.6570148166044607`*^9, {3.657015208123817*^9, 3.657015209911688*^9}, 
   3.657015288476904*^9, 3.657015750359911*^9, {3.657015965421185*^9, 
   3.657015993224568*^9}, {3.657016094290036*^9, 3.657016094381547*^9}, {
   3.657016330389214*^9, 3.657016330628049*^9}, 3.65701759289994*^9, 
   3.6570178125775623`*^9, {3.657018526237067*^9, 3.6570185521217003`*^9}, {
   3.657020619835622*^9, 3.657020628250204*^9}, {3.657031876066127*^9, 
   3.6570318811591787`*^9}, {3.67482278407366*^9, 3.674822786220393*^9}, {
   3.674822841662024*^9, 3.674822872698332*^9}, {3.6748229240805473`*^9, 
   3.6748229460969133`*^9}, 3.674823241104773*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "eval", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "ee", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "finalconfold", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.656669632186666*^9, 3.656669652419685*^9}, {
  3.656670564299076*^9, 3.656670569440065*^9}}],

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"kinktab1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tableContentx2", ";", "\[IndentingNewLine]", 
        RowBox[{"ans", "=", 
         RowBox[{"klchainmd2", "[", 
          RowBox[{
          "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",",
            "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
        RowBox[{
         RowBox[{"finalconfold", "[", 
          RowBox[{"Round", "[", 
           RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"es", ":=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"DMat", "[", 
           RowBox[{"finalconfold", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"e", "[", "modenum_", "]"}], ":=", 
         RowBox[{"es", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ee", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "[", "i", 
              "]"}], "=", 
             RowBox[{"e", "[", "i", "]"}]}], ",", 
            RowBox[{
             RowBox[{"eval", "[", "i", "]"}], "=", 
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{"num", "-", "i"}]}], "\[RightDoubleBracket]"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"th0", ",", 
          RowBox[{"eval", "[", "0", "]"}], ",", 
          RowBox[{"eval", "[", "1", "]"}], ",", 
          RowBox[{"eval", "[", "2", "]"}], ",", 
          RowBox[{"eval", "[", "3", "]"}], ",", 
          RowBox[{"eval", "[", "4", "]"}], ",", 
          RowBox[{"eval", "[", "5", "]"}], ",", 
          RowBox[{"eval", "[", "6", "]"}], ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espring", "[", 
             RowBox[{"tfinal", ",", "i"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", "num"}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"th0", ",", 
         RowBox[{"{", 
          RowBox[{
          "0.004", ",", "0.006", ",", "0.008", ",", "0.01", ",", "0.02", ",", 
           "0.04", ",", "0.06", ",", "0.08", ",", "0.1", ",", "0.15", ",", 
           "0.2", ",", "0.25", ",", "0.3", ",", "0.4", ",", "0.6"}], "}"}]}], 
        "}"}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "num", ",", 
     RowBox[{"IntegerPart", "[", 
      FractionBox[
       SuperscriptBox["a", "2"], 
       RowBox[{"2", "r", " ", 
        RowBox[{"Sin", "[", "th0", "]"}]}]], "]"}]}], "}"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657701392399*^9}, {3.656657734476067*^9, 3.656657783773448*^9}, {
   3.656657817982214*^9, 3.656657917136283*^9}, {3.656659467413381*^9, 
   3.656659520343019*^9}, {3.656659629737068*^9, 3.656659631208724*^9}, {
   3.656659665514223*^9, 3.656659677387182*^9}, 3.656659757180534*^9, {
   3.6566600692034616`*^9, 3.656660073459321*^9}, {3.6566606313303556`*^9, 
   3.656660654961069*^9}, {3.656661533158155*^9, 3.656661536549663*^9}, {
   3.656661616344326*^9, 3.65666164288934*^9}, {3.6566662400044117`*^9, 
   3.656666241684531*^9}, 3.6566665436764517`*^9, {3.656669425455266*^9, 
   3.656669436510957*^9}, {3.656669482736566*^9, 3.656669507968567*^9}, {
   3.656669583939533*^9, 3.6566696107877617`*^9}, {3.656669700326128*^9, 
   3.6566697046133957`*^9}, {3.656670442252367*^9, 3.656670442440941*^9}, {
   3.656670490760507*^9, 3.656670495751841*^9}, {3.656670552121344*^9, 
   3.656670553242096*^9}, {3.656671907178177*^9, 3.656671910505083*^9}, 
   3.6566720148463717`*^9, {3.656672409398641*^9, 3.656672413429017*^9}, {
   3.6566730184213047`*^9, 3.6566730241825438`*^9}, {3.6566758491110077`*^9, 
   3.656675849208012*^9}, {3.656760680719138*^9, 3.656760684174295*^9}, {
   3.656760942197298*^9, 3.6567609602286787`*^9}, {3.656761432498522*^9, 
   3.6567614691207523`*^9}, {3.656761682903078*^9, 3.656761713318776*^9}, {
   3.656761954700656*^9, 3.656762006685521*^9}, 3.656762668420135*^9, {
   3.656762756320385*^9, 3.656762757487*^9}, {3.656762920500139*^9, 
   3.656762925138739*^9}, {3.656763044951136*^9, 3.656763044997644*^9}, {
   3.6567631784101887`*^9, 3.656763199129426*^9}, 3.656763259021325*^9, {
   3.656763292300775*^9, 3.6567634100323772`*^9}, {3.6567643094772882`*^9, 
   3.656764449303768*^9}, {3.656764527690135*^9, 3.656764537338587*^9}, 
   3.6567645723947268`*^9, {3.656764623564048*^9, 3.656764637931774*^9}, {
   3.6567646787974253`*^9, 3.656764732719985*^9}, 3.656767629330832*^9, {
   3.656767672148302*^9, 3.656767677396078*^9}, {3.6567679099153233`*^9, 
   3.656767949290926*^9}, {3.657014851977071*^9, 3.657014855567672*^9}, {
   3.6570160163333893`*^9, 3.657016017676333*^9}, {3.6570160485244303`*^9, 
   3.657016049308105*^9}, {3.657017532176194*^9, 3.657017536048012*^9}, {
   3.6570319465486803`*^9, 3.657031965845158*^9}, 3.657032039144759*^9, 
   3.6748228863781757`*^9, 3.674822955790827*^9}],

Cell[BoxData[
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Abs", "@", 
      RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
       RowBox[{"All", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}]}], "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}]}], "}"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<th0\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656765102758151*^9, 3.656765156441532*^9}, {3.6567651919286118`*^9, 
   3.6567651957201*^9}, {3.6567653022680597`*^9, 3.65676530597885*^9}, {
   3.6567653540443707`*^9, 3.656765437502102*^9}, {3.656765477601519*^9, 
   3.656765487360772*^9}, {3.65676632990842*^9, 3.656766334403561*^9}, {
   3.6567679828431664`*^9, 3.656767986794736*^9}, {3.65676893259431*^9, 
   3.6567689390296383`*^9}, {3.6568320066732283`*^9, 3.6568320136799507`*^9}, 
   3.656950081532312*^9, {3.656952839501794*^9, 3.656952841720868*^9}, {
   3.656953230791391*^9, 3.656953232613826*^9}, {3.6569541058701563`*^9, 
   3.656954149291991*^9}, 3.6569542419345922`*^9, {3.6570137381831427`*^9, 
   3.657013739873043*^9}, {3.657013873127995*^9, 3.657013880887575*^9}, {
   3.6570226721220493`*^9, 3.6570227142017717`*^9}, {3.657022757308713*^9, 
   3.6570227583995743`*^9}, {3.6570325553468647`*^9, 3.657032588835013*^9}, {
   3.657032620280303*^9, 3.6570326249636393`*^9}, {3.657033603484337*^9, 
   3.657033608683509*^9}, {3.657033664317898*^9, 3.657033665675825*^9}}],

Cell[BoxData[
 RowBox[{"plot\[Omega]s\[Theta]k1", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Transpose", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{
            RowBox[{"Sqrt", "@", 
             RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", "/", "a"}], 
              SqrtBox[
               FractionBox[
                RowBox[{"12", " ", "10000"}], "1"]]}], ")"}]}]}], "}"}]}], 
        RowBox[{"(*", 
         RowBox[{",", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
             RowBox[{
              RowBox[{"Sqrt", "@", 
               RowBox[{"Abs", "@", 
                RowBox[{"kinktab1", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}]}], 
              "/", 
              RowBox[{"(", 
               RowBox[{"r", 
                SqrtBox[
                 FractionBox[
                  RowBox[{"3", " ", "10000"}], "1"]]}], ")"}]}]}], "}"}]}]}], 
         "*)"}], "}"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Black", ",", "Thick", ",", 
             RowBox[{"Disk", "[", "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "20"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<\!\(\*OverscriptBox[\(\[Theta]\), \(_\)]\)\>\"", ",", 
          "\"\<\!\(\*FractionBox[\(\[Omega]\), \(\((r/a)\) \*SqrtBox[\(12\\\ \
k/M\)]\)]\)\>\""}], "}"}]}], ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", " ", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
       RowBox[{"FrameTicksStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
       RowBox[{"PlotLegends", "\[Rule]", 
        RowBox[{"Placed", "[", 
         RowBox[{
          RowBox[{"PointLegend", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", "Green"}], "}"}], ",", 
            RowBox[{"{", "\"\<Kink shape mode\>\"", 
             RowBox[{"(*", 
              RowBox[{",", "\"\<Kink translation mode\>\""}], "*)"}], "}"}], 
            ",", 
            RowBox[{"LegendMarkerSize", "\[Rule]", "20"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.7", ",", "0.25"}], "}"}]}], "]"}]}]}], "]"}], ",", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Sqrt", "[", "  ", 
         RowBox[{
          RowBox[{
           RowBox[{"(", " ", 
            RowBox[{"Sin", "[", "th", "]"}], ")"}], "^", "2"}], " ", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"1", "^", "2"}], "+", 
            RowBox[{"4", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"r", "/", "a"}], ")"}], "^", "2"}], 
             RowBox[{
              RowBox[{"Cos", "[", "th", "]"}], "^", "2"}]}]}], ")"}]}], "]"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "0.0001", ",", "0.8"}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
       RowBox[{"PlotLegends", "\[Rule]", 
        RowBox[{"Placed", "[", 
         RowBox[{
          RowBox[{"LineLegend", "[", 
           RowBox[{
            RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.7", ",", "0.1"}], "}"}]}], "]"}]}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656765102758151*^9, 3.656765156441532*^9}, {3.6567651919286118`*^9, 
   3.6567651957201*^9}, {3.6567653022680597`*^9, 3.65676530597885*^9}, {
   3.6567653540443707`*^9, 3.656765437502102*^9}, {3.656765477601519*^9, 
   3.656765487360772*^9}, {3.6567660209083776`*^9, 3.656766086733609*^9}, 
   3.6567676500512247`*^9, {3.6567677807097692`*^9, 3.65676787490403*^9}, {
   3.656768020908862*^9, 3.656768021563938*^9}, {3.656832061653616*^9, 
   3.656832105080014*^9}, {3.656945612804636*^9, 3.656945803657277*^9}, {
   3.6569458572444983`*^9, 3.656945877609315*^9}, {3.656945933275282*^9, 
   3.656946024823887*^9}, {3.656946083808*^9, 3.656946144895925*^9}, {
   3.656946285164662*^9, 3.656946381302005*^9}, {3.656946436280367*^9, 
   3.656946450918902*^9}, {3.656946561226376*^9, 3.6569466383949013`*^9}, {
   3.6569467312624693`*^9, 3.656946731757284*^9}, {3.6569468562161617`*^9, 
   3.6569468842253227`*^9}, {3.6569469489973087`*^9, 3.65694703663244*^9}, {
   3.6569483722999067`*^9, 3.656948449398196*^9}, {3.656948562463431*^9, 
   3.656948606249894*^9}, {3.6569487183819847`*^9, 3.656948722328537*^9}, {
   3.656948760718019*^9, 3.656948762933073*^9}, {3.656949116246266*^9, 
   3.656949133461769*^9}, {3.656949177351143*^9, 3.656949203543754*^9}, 
   3.6569495053286457`*^9, {3.656950160049124*^9, 3.656950221071413*^9}, {
   3.656950494070318*^9, 3.656950504678388*^9}, {3.656950544023883*^9, 
   3.656950666986248*^9}, {3.65695071820612*^9, 3.6569507685564137`*^9}, {
   3.656950995539798*^9, 3.656951014098878*^9}, {3.65695118107999*^9, 
   3.656951257463808*^9}, {3.656951316764263*^9, 3.656951333198036*^9}, {
   3.656951407038913*^9, 3.656951434828754*^9}, {3.656951869117178*^9, 
   3.656951891070277*^9}, {3.656951987721792*^9, 3.656951992461629*^9}, {
   3.657023437949201*^9, 3.657023814489038*^9}, {3.6570239108488483`*^9, 
   3.657023944199758*^9}, {3.65702399877886*^9, 3.657024060862905*^9}, {
   3.6570241603292847`*^9, 3.6570242103824673`*^9}, {3.65702427158552*^9, 
   3.65702432812179*^9}, {3.6570326497985487`*^9, 3.657032749031444*^9}, {
   3.657033761279355*^9, 3.657033775439245*^9}, {3.657038334063167*^9, 
   3.657038334396544*^9}, {3.657295777465193*^9, 3.657295895479698*^9}, {
   3.657295941726159*^9, 3.657296063518303*^9}, {3.6572961079936047`*^9, 
   3.657296135678487*^9}, {3.657296178769802*^9, 3.657296196472473*^9}, {
   3.657296264565929*^9, 3.657296313409116*^9}, {3.657296349222456*^9, 
   3.657296355685288*^9}, {3.657296396974553*^9, 3.657296443767963*^9}, {
   3.657296832347596*^9, 3.657296844225603*^9}, {3.657452777028109*^9, 
   3.657452786538598*^9}, {3.657540792473834*^9, 3.657540841035035*^9}, {
   3.6611497847090607`*^9, 3.6611498070730677`*^9}, {3.6615214623130817`*^9, 
   3.661521470522808*^9}, {3.66152161966255*^9, 3.661521685408937*^9}, {
   3.661521738787861*^9, 3.661521765364277*^9}, 3.66152183882126*^9, {
   3.6615220721077213`*^9, 3.661522103641774*^9}, {3.6617752637571573`*^9, 
   3.661775264437438*^9}, {3.674823028474818*^9, 3.674823063944701*^9}, {
   3.674823093983432*^9, 3.674823120911152*^9}, {3.674823171571783*^9, 
   3.674823171778322*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<w-th-k.pdf\>\"", ",", "plot\[Omega]s\[Theta]k1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "800"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.656949172807863*^9, 3.656949174486961*^9}, {
   3.656949214024951*^9, 3.656949310394067*^9}, {3.656949348602672*^9, 
   3.656949348875595*^9}, {3.656949501358549*^9, 3.656949503070437*^9}, 
   3.656950852991365*^9, {3.656950981649123*^9, 3.656951006673263*^9}, {
   3.656951975800939*^9, 3.6569519760243187`*^9}, {3.656952077354991*^9, 
   3.656952077914336*^9}, 3.657024368561398*^9, {3.657032651747962*^9, 
   3.657032654996066*^9}, {3.661149816417781*^9, 3.661149827203638*^9}, 
   3.661775118566752*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["v mode display antikink", "Subsection",
 CellChangeTimes->{{3.6466486423109837`*^9, 3.646648644962531*^9}, {
  3.6469068204711514`*^9, 3.6469068216735363`*^9}, {3.646911387317358*^9, 
  3.6469113907626247`*^9}, {3.646913034544911*^9, 3.646913056619774*^9}, {
  3.646913375545557*^9, 3.64691338937993*^9}, {3.646914500399425*^9, 
  3.64691450252918*^9}, {3.646917268565242*^9, 3.646917270162532*^9}, {
  3.646917980466864*^9, 3.646917981474946*^9}, {3.647079969717678*^9, 
  3.647079984852559*^9}, {3.647084277272216*^9, 3.6470842781981916`*^9}, {
  3.647086552980399*^9, 3.647086554185987*^9}, {3.647866774681383*^9, 
  3.6478667762973022`*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"num", "=", "60"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"if", " ", "rerunansQ"}], "=", "True"}], ",", " ", 
      RowBox[{"set", " ", "here", " ", "same", " ", "as", " ", 
       RowBox[{"simulation", "'"}], "s"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", "kdef", ",", "10000."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "numdef"}], ",", "Mdef", ",", "1."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldeftest", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"runreansQ", "=", "False"}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "Whether", " ", "analysis", " ", "simulation", " ", "data", " ", "or", 
      " ", "independent"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"runreansQ", "==", "True"}], ",", 
      RowBox[{
       RowBox[{"initialold", "=", "reanstab"}], ";"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"R", "=", 
     RowBox[{"MakeSSHrig", "[", 
      RowBox[{"initialold", ",", "r"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"make", " ", "rigidity", " ", "matrix", " ", "R"}], "=", 
      "\"\<Q\>\""}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"kMatrix", "=", 
     RowBox[{"Normal", "[", 
      RowBox[{"SparseArray", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", 
          RowBox[{"kk", "[", "i", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"es", "=", 
     RowBox[{"Eigensystem", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", "R", "]"}], ".", "kMatrix", ".", "R"}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e", "[", "modenum_", "]"}], ":=", 
     RowBox[{"es", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", 
        RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"MakeSSHpicvec", "[", 
          RowBox[{"initialold", ",", "r", ",", 
           RowBox[{"3", 
            RowBox[{"e", "[", "moden", "]"}]}]}], 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
            "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
             "sign"}], ",", " ", 
            RowBox[{"use", " ", "-", " ", 
             RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"-", "1"}], ")"}], 
                 RowBox[{"Mod", "[", 
                  RowBox[{"i", ",", "2"}], "]"}]], 
                SqrtBox[
                 RowBox[{"M", "[", "i", "]"}]]], 
               RowBox[{
                RowBox[{"e", "[", "moden", "]"}], "\[LeftDoubleBracket]", "i",
                 "\[RightDoubleBracket]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}], ",", 
            RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{"es", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", 
                RowBox[{
                 RowBox[{"-", "10"}], ";;", 
                 RowBox[{"-", "1"}]}]}], "\[RightDoubleBracket]"}], ",", 
              "Less"}], "]"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}]}], "}"}], 
        "]"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"moden", ",", "1"}], "}"}], ",", "0", ",", 
     RowBox[{"num", "-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ldef", ",", 
     RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"v0", ",", 
     RowBox[{"{", "24", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"thnumx", ",", "0.07"}], "}"}], ",", "0.0", ",", "th0", ",", 
     "0.1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"kdef", ",", "10000"}], "}"}], ",", "1", ",", "100000", ",", 
     "1000"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Mdef", ",", "1"}], "}"}], ",", "0.01", ",", "100"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["v mode display antikink Prestress", "Subsection",
 CellChangeTimes->{{3.6466486423109837`*^9, 3.646648644962531*^9}, {
  3.6469068204711514`*^9, 3.6469068216735363`*^9}, {3.646911387317358*^9, 
  3.6469113907626247`*^9}, {3.646913034544911*^9, 3.646913056619774*^9}, {
  3.646913375545557*^9, 3.64691338937993*^9}, {3.646914500399425*^9, 
  3.64691450252918*^9}, {3.646917268565242*^9, 3.646917270162532*^9}, {
  3.646917980466864*^9, 3.646917981474946*^9}, {3.647079969717678*^9, 
  3.647079984852559*^9}, {3.647084277272216*^9, 3.6470842781981916`*^9}, {
  3.647086552980399*^9, 3.647086554185987*^9}, {3.647866774681383*^9, 
  3.6478667762973022`*^9}, {3.651490433804615*^9, 3.651490443004784*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{
      RowBox[{"N", "[", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"a", "/", 
         RowBox[{"(", 
          RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.4"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzero", "=", 
   SuperscriptBox["lzerosq", 
    RowBox[{"1", "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ldef", "=", "lzero"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v0", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thnumx", "=", "0."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kdef", "=", "10000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdef", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tfinal", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"num", "=", "24"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"if", " ", "rerunansQ"}], "=", "True"}], ",", " ", 
    RowBox[{"set", " ", "here", " ", "same", " ", "as", " ", 
     RowBox[{"simulation", "'"}], "s"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "kdef", ",", "10000."}], "]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], ",", "Mdef", ",", "1."}], "]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"ldef", ">", "ldefcritical"}], ",", 
     RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numdef", "=", 
    RowBox[{
     RowBox[{"IntegerPart", "[", 
      RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
    " ", "defect", " ", "spring", " ", "is"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"numx", "=", "num"}], ";", 
      RowBox[{
       RowBox[{"th", "[", "numx", "]"}], "=", 
       RowBox[{"thinit", "/.", 
        RowBox[{
         RowBox[{"Solve", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"h", ":=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"lzero", "-", "r"}], ")"}], 
              RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
            RowBox[{
             RowBox[{
              SqrtBox[
               RowBox[{
                SuperscriptBox["r", "2"], "-", 
                SuperscriptBox["h", "2"]}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
           ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
         "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
     RowBox[{"(*", 
      RowBox[{
      "where", " ", "the", " ", "configueration", " ", "initialization", " ", 
       "starts"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"numx", "=", 
       RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "-", "1"}]}], ",", 
    RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
    RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaleft", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaright", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaright", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", 
     RowBox[{"numx", "+", "1"}]}], ",", 
    RowBox[{"i", "\[LessEqual]", "num"}], ",", 
    RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"thetaright", "=", 
      RowBox[{"th", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"th", "[", "i", "]"}], "=", 
      RowBox[{"thetaleft", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
              RowBox[{"r", " ", 
               RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
              RowBox[{"r", " ", 
               RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
          "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", 
            RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"thetaleft", ",", "1", ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"th", "[", "num", "]"}], "=", 
   RowBox[{"thinit", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"h", ":=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"lzero", "-", "r"}], ")"}], 
          RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
        RowBox[{
         RowBox[{
          SqrtBox[
           RowBox[{
            SuperscriptBox["r", "2"], "-", 
            SuperscriptBox["h", "2"]}]], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], 
           RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], ",", 
       "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"th", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"-", "thinit"}], "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"h", ":=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"lzero", "-", "r"}], ")"}], 
          RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
        RowBox[{
         RowBox[{
          SqrtBox[
           RowBox[{
            SuperscriptBox["r", "2"], "-", 
            SuperscriptBox["h", "2"]}]], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"lzero", "-", "r"}], ")"}], 
           RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], ",", 
       "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
     "\[RightDoubleBracket]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initial", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"True", ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "+", 
          RowBox[{"th", "[", "i", "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initialold", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Pi]", "/", "2"}], "-", 
      RowBox[{"initial", "[", 
       RowBox[{"[", "j", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vzero", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657689581395*^9}, 3.656660917145009*^9, {3.656672254642058*^9, 
   3.6566722816051188`*^9}, {3.656672666139454*^9, 3.656672668635634*^9}, {
   3.656672809343203*^9, 3.656672818350959*^9}, {3.656673423341731*^9, 
   3.656673436189139*^9}, {3.6566752631138287`*^9, 3.6566752669693813`*^9}, {
   3.6566753548283033`*^9, 3.656675356365465*^9}, {3.656675636354692*^9, 
   3.656675642321443*^9}, {3.656675727587905*^9, 3.656675750549695*^9}, {
   3.656943827164454*^9, 3.6569438313870897`*^9}, {3.65703463739738*^9, 
   3.657034637523415*^9}, {3.657034788728114*^9, 3.6570347889350147`*^9}, 
   3.657619503929528*^9, {3.6576246206442842`*^9, 3.657624620900997*^9}, 
   3.6576263809578047`*^9, {3.65762641110588*^9, 3.657626441997574*^9}}],

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"kkevaltab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"kk", "[", 
          RowBox[{"numdef", "-", "1"}], "]"}], "=", "kdumb"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ans", "=", 
         RowBox[{"klchainmd2", "[", 
          RowBox[{
          "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",",
            "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
        RowBox[{
         RowBox[{"finalconfold", "[", "kdumb", "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"es", ":=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"DMat", "[", "initialold", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"e", "[", "modenum_", "]"}], ":=", 
         RowBox[{"es", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ee", "[", "kdumb", "]"}], "[", "i", "]"}], "=", 
             RowBox[{"e", "[", "i", "]"}]}], ",", 
            RowBox[{
             RowBox[{"eval", "[", "i", "]"}], "=", 
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{"num", "-", "i"}]}], "\[RightDoubleBracket]"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"kk", "[", 
           RowBox[{"numdef", "-", "1"}], "]"}], ",", 
          RowBox[{"eval", "[", "0", "]"}], ",", 
          RowBox[{"eval", "[", "1", "]"}], ",", 
          RowBox[{"eval", "[", "2", "]"}], ",", 
          RowBox[{"eval", "[", "3", "]"}], ",", 
          RowBox[{"eval", "[", "4", "]"}], ",", 
          RowBox[{"eval", "[", "5", "]"}], ",", 
          RowBox[{"eval", "[", "6", "]"}], ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espring", "[", 
             RowBox[{"tfinal", ",", "i"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"kdumb", ",", 
         RowBox[{"{", "10000", "}"}]}], "}"}]}], "]"}]}], ";"}], ",", 
   "kdumb"}], "]"}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657701392399*^9}, {3.656657734476067*^9, 3.656657783773448*^9}, {
   3.656657817982214*^9, 3.656657917136283*^9}, {3.656659467413381*^9, 
   3.656659520343019*^9}, {3.656659629737068*^9, 3.656659631208724*^9}, {
   3.656659665514223*^9, 3.656659677387182*^9}, 3.656659757180534*^9, {
   3.6566600692034616`*^9, 3.656660073459321*^9}, {3.6566606313303556`*^9, 
   3.656660654961069*^9}, {3.656661533158155*^9, 3.656661536549663*^9}, {
   3.656661616344326*^9, 3.65666164288934*^9}, {3.6566662400044117`*^9, 
   3.656666241684531*^9}, 3.6566665436764517`*^9, 3.656672033550809*^9, {
   3.6566723791585493`*^9, 3.656672383940795*^9}, {3.6566752840732822`*^9, 
   3.6566752864569407`*^9}, {3.656675502798074*^9, 3.65667550820604*^9}, {
   3.6566755417911777`*^9, 3.656675549230595*^9}, 3.656675800678369*^9, {
   3.657034691109159*^9, 3.657034692756365*^9}, {3.657034724454095*^9, 
   3.657034725221366*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"MakeSSHpicvec", "[", 
         RowBox[{"initialold", ",", "r", ",", 
          RowBox[{"3", 
           RowBox[{
            RowBox[{"ee", "[", "kdumb", "]"}], "[", 
            RowBox[{"imax", "-", "2"}], "]"}]}]}], 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
            "sign"}], ",", " ", 
           RowBox[{"use", " ", "-", " ", 
            RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1500"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "r"}], "-", "1"}], ",", 
             RowBox[{"num", "+", "r", "+", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "r"}], "-", "1.1"}], ",", 
             RowBox[{"r", "+", "1.1"}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "i"}], "}"}]}], "\[RightDoubleBracket]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "2", ",", "imax"}], "}"}]}], "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "9"}], "}"}]}], "\[RightDoubleBracket]"}], 
           ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], "}"}], "]"}]}],
      "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"imax", ",", "2", ",", "8", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"kdumb", ",", "1000", ",", "15000", ",", "1000"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656675311338735*^9, 
   3.656675313913165*^9}, {3.6566755575187674`*^9, 3.656675561198798*^9}, 
   3.656675799350103*^9, 3.65703468326961*^9}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"MakeSSHpicvec", "[", 
         RowBox[{"initialold", ",", "r", ",", 
          RowBox[{"3", 
           RowBox[{"ee", "[", "moden", "]"}]}]}], 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
            "sign"}], ",", " ", 
           RowBox[{"use", " ", "-", " ", 
            RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              FractionBox[
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], 
                RowBox[{"Mod", "[", 
                 RowBox[{"i", ",", "2"}], "]"}]], 
               SqrtBox[
                RowBox[{"M", "[", "i", "]"}]]], 
              RowBox[{
               RowBox[{"ee", "[", "moden", "]"}], "\[LeftDoubleBracket]", "i",
                "\[RightDoubleBracket]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}], ",", 
           RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"PlotLabel", "\[Rule]", 
            RowBox[{"eval", "[", "moden", "]"}]}]}], "]"}], ",", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"eval", "[", "i", "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}]}], "}"}], 
       "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"moden", ",", "0", ",", "10", ",", "1"}], "}"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, 3.656402370700955*^9, {3.656402782292348*^9, 
   3.656402821733247*^9}, {3.656403055839357*^9, 3.6564030723634453`*^9}, {
   3.656403121756495*^9, 3.6564031219538794`*^9}, {3.656405685864725*^9, 
   3.656405704056481*^9}, {3.656405782380456*^9, 3.65640582076505*^9}, {
   3.65640591921609*^9, 3.65640597115167*^9}}],

Cell[BoxData[
 RowBox[{"antikinkconf1", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"1.5", 
       RowBox[{
        RowBox[{"ee", "[", "10000", "]"}], "[", "0", "]"}]}]}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
        "sign"}], ",", " ", 
       RowBox[{"use", " ", "-", " ", 
        RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.65703474595715*^9, 3.657034805910961*^9}, {
  3.657035247249505*^9, 3.657035247472555*^9}, {3.6570353220195208`*^9, 
  3.6570353231230373`*^9}, {3.657624733221437*^9, 3.657624736163291*^9}}],

Cell[BoxData[
 RowBox[{"antikinkconf2", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicvec", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{
        RowBox[{"ee", "[", "10000", "]"}], "[", "3", "]"}]}]}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
        "sign"}], ",", " ", 
       RowBox[{"use", " ", "-", " ", 
        RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1500"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.65703474595715*^9, 3.657034833208737*^9}, {
   3.657035250241259*^9, 3.657035250448895*^9}, {3.657035325028262*^9, 
   3.6570353252981052`*^9}, {3.657035386359769*^9, 3.657035386916003*^9}, 
   3.657626472491824*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<antikinkconft.pdf\>\"", ",", "antikinkconf1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.657034567872712*^9, 3.6570345883210373`*^9}, {
  3.6570348523917*^9, 3.657034856951231*^9}, {3.661149847506518*^9, 
  3.661149847762022*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<antikinkconfs.pdf\>\"", ",", "antikinkconf2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.657034567872712*^9, 3.657034603345389*^9}, {
  3.6570348591916037`*^9, 3.657034862871583*^9}}],

Cell[CellGroupData[{

Cell["Change th0", "Subsubsection",
 CellChangeTimes->{{3.656669276538365*^9, 3.656669281866658*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "th0", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "tableContentx1", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.656669735231163*^9, 3.656669739989785*^9}, {
  3.656669806359185*^9, 3.6566698125833*^9}}],

Cell[BoxData[
 RowBox[{"tableContentx1", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"num", "=", 
     RowBox[{"Max", "[", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"IntegerPart", "[", 
           FractionBox[
            SuperscriptBox["a", "2"], 
            RowBox[{"2", "r", " ", 
             RowBox[{"Sin", "[", "th0", "]"}]}]], "]"}], "*", "200"}], ",", 
         "1000"}], "]"}], ",", "80"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"a", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"r", "=", "0.8"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<th0=\>\"", ",", 
        RowBox[{"th0", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"ArcSin", "[", 
            RowBox[{"a", "/", 
             RowBox[{"(", 
              RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}], "-", "0.4"}]}]}], 
       "]"}], ";"}], "*)"}], 
    RowBox[{"(*", 
     RowBox[{"The", " ", "1", "st", " ", "angle", " ", "choice"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"lzerosq", "=", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ldef", "=", "lzero"}], ";", "\[IndentingNewLine]", 
    RowBox[{"v0", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"thnumx", "=", 
     RowBox[{"th0", "/", "2"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"kdef", "=", "10000"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Mdef", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"tfinal", "=", "20"}], ";", "\[IndentingNewLine]", 
    RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
    RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", 
          RowBox[{"numdef", "-", "1"}]}], ",", "kdef", ",", "10000."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", "i", "]"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "numdef"}], ",", "Mdef", ",", "1."}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ldef", ">", "ldefcritical"}], ",", 
      RowBox[{"Print", "[", "\"\<ldef > ldefcritical\>\"", "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"numdef", "=", 
     RowBox[{
      RowBox[{"IntegerPart", "[", 
       RowBox[{"num", "/", "2"}], "]"}], "+", "1"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "where", " ", "the", " ", "right", " ", "rotor", " ", "of", " ", "the", 
      " ", "defect", " ", "spring", " ", "is"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"endstart", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", "num"}], ";", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", 
        RowBox[{"thinit", "/.", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"h", ":=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lzero", "-", "r"}], ")"}], 
               RowBox[{"Cos", "[", "thinit", "]"}]}]}], ";", 
             RowBox[{
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r", "2"], "-", 
                 SuperscriptBox["h", "2"]}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lzero", "-", "r"}], ")"}], 
                RowBox[{"Sin", "[", "thinit", "]"}]}]}], "\[Equal]", "a"}]}], 
            ",", "thinit"}], "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}]}], ";"}], ",", 
      RowBox[{"(*", 
       RowBox[{
       "where", " ", "the", " ", "configuration", " ", "initialization", " ", 
        "starts"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"numx", "=", 
        RowBox[{"num", "/", "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "numx", "]"}], "=", "thnumx"}], ";"}]}], "]"}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "-", "1"}]}], ",", 
      RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
      RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaleft", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaright", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaright", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", 
       RowBox[{"numx", "+", "1"}]}], ",", 
      RowBox[{"i", "\[LessEqual]", "num"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"thetaright", "=", 
        RowBox[{"th", "[", 
         RowBox[{"i", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"th", "[", "i", "]"}], "=", 
        RowBox[{"thetaleft", "/.", 
         RowBox[{"FindRoot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaright", "]"}]}], "-", 
                RowBox[{"r", " ", 
                 RowBox[{"Sin", "[", "thetaleft", "]"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaright", "]"}]}], "+", 
                RowBox[{"r", " ", 
                 RowBox[{"Cos", "[", "thetaleft", "]"}]}]}], ")"}], "2"]}], 
            "\[Equal]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", 
               RowBox[{"numdef", "-", "1"}]}], ",", 
              RowBox[{"ldef", "^", "2"}], ",", "lzerosq"}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"thetaleft", ",", "1", ",", 
             RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
       ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"initial", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", ",",
          "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"th", "[", "i", "]"}]}], ",", 
           RowBox[{"-", 
            RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"initialold", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Pi]", "/", "2"}], "-", 
        RowBox[{"initial", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"vzero", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}]}], ";"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.65666929786712*^9, 3.65666931628401*^9}, {
   3.656669376910492*^9, 3.656669406095714*^9}, {3.65666945464213*^9, 
   3.656669477441822*^9}, {3.656669788489408*^9, 3.656669794025712*^9}, {
   3.656669870108878*^9, 3.656669892795402*^9}, {3.656672428169249*^9, 
   3.656672428527495*^9}, {3.65667265145405*^9, 3.65667265422815*^9}, {
   3.656672774383713*^9, 3.6566727801431713`*^9}, {3.656672829968874*^9, 
   3.6566728319547367`*^9}, {3.656673243435261*^9, 3.656673243501075*^9}, {
   3.656673285788288*^9, 3.656673290123436*^9}, {3.656673447295023*^9, 
   3.65667344879904*^9}, {3.6566751551920347`*^9, 3.656675172648347*^9}, 
   3.656675759014419*^9, {3.656675818968787*^9, 3.6566758251380777`*^9}, {
   3.6567606609761953`*^9, 3.656760667423883*^9}, {3.6567609211583157`*^9, 
   3.656760934389842*^9}, 3.656761745146143*^9, {3.656761813930787*^9, 
   3.656761828298792*^9}, 3.656762151331251*^9, {3.656762636190547*^9, 
   3.6567626505901823`*^9}, {3.656762747745262*^9, 3.6567627479835987`*^9}, {
   3.6567628435558968`*^9, 3.656762870691722*^9}, {3.6567630495121117`*^9, 
   3.656763053208007*^9}, {3.65676343505767*^9, 3.656763456161418*^9}, {
   3.6567643002455873`*^9, 3.6567643003410597`*^9}, {3.656764401784218*^9, 
   3.656764405815176*^9}, 3.6567661204326267`*^9, {3.65676615251401*^9, 
   3.656766194337891*^9}, {3.656767576627673*^9, 3.656767576656006*^9}, {
   3.656767618357977*^9, 3.6567676184681063`*^9}, 3.656953122806341*^9, {
   3.6569541981927834`*^9, 3.6569541982866507`*^9}, 3.657013852826365*^9, 
   3.6570148166044607`*^9, {3.657015208123817*^9, 3.657015209911688*^9}, 
   3.657015288476904*^9, 3.657015750359911*^9, {3.657015965421185*^9, 
   3.657015993224568*^9}, {3.657016094290036*^9, 3.657016094381547*^9}, {
   3.657016330389214*^9, 3.657016330628049*^9}, 3.65701759289994*^9, 
   3.6570178125775623`*^9, {3.657018526237067*^9, 3.6570185521217003`*^9}, {
   3.657020619835622*^9, 3.657020628250204*^9}, {3.674819722867391*^9, 
   3.674819750846694*^9}, {3.6748200088395767`*^9, 3.674820008986004*^9}, {
   3.674986339473064*^9, 3.674986343373063*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "eval", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "ee", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "finalconfold", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.656669632186666*^9, 3.656669652419685*^9}, {
  3.656670564299076*^9, 3.656670569440065*^9}}],

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"kkevaltab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tableContentx1", ";", "\[IndentingNewLine]", 
        RowBox[{"ans", "=", 
         RowBox[{"klchainmd2", "[", 
          RowBox[{
          "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",",
            "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
        RowBox[{
         RowBox[{"finalconfold", "[", 
          RowBox[{"Round", "[", 
           RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"es", ":=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"DMat", "[", 
           RowBox[{"finalconfold", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"e", "[", "modenum_", "]"}], ":=", 
         RowBox[{"es", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ee", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "[", "i", 
              "]"}], "=", 
             RowBox[{"e", "[", "i", "]"}]}], ",", 
            RowBox[{
             RowBox[{"eval", "[", "i", "]"}], "=", 
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{"num", "-", "i"}]}], "\[RightDoubleBracket]"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"th0", ",", 
          RowBox[{"eval", "[", "0", "]"}], ",", 
          RowBox[{"eval", "[", "1", "]"}], ",", 
          RowBox[{"eval", "[", "2", "]"}], ",", 
          RowBox[{"eval", "[", "3", "]"}], ",", 
          RowBox[{"eval", "[", "4", "]"}], ",", 
          RowBox[{"eval", "[", "5", "]"}], ",", 
          RowBox[{"eval", "[", "6", "]"}], ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espring", "[", 
             RowBox[{"tfinal", ",", "i"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", "num"}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"th0", ",", 
         RowBox[{"{", 
          RowBox[{
          "0.004", ",", "0.006", ",", "0.008", ",", "0.01", ",", "0.02", ",", 
           "0.04", ",", "0.06", ",", "0.08", ",", "0.1", ",", "0.15", ",", 
           "0.2", ",", "0.4", ",", "0.6"}], "}"}]}], "}"}]}], "]"}]}], ";"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "num", ",", 
     RowBox[{"IntegerPart", "[", 
      FractionBox[
       SuperscriptBox["a", "2"], 
       RowBox[{"2", "r", " ", 
        RowBox[{"Sin", "[", "th0", "]"}]}]], "]"}]}], "}"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657701392399*^9}, {3.656657734476067*^9, 3.656657783773448*^9}, {
   3.656657817982214*^9, 3.656657917136283*^9}, {3.656659467413381*^9, 
   3.656659520343019*^9}, {3.656659629737068*^9, 3.656659631208724*^9}, {
   3.656659665514223*^9, 3.656659677387182*^9}, 3.656659757180534*^9, {
   3.6566600692034616`*^9, 3.656660073459321*^9}, {3.6566606313303556`*^9, 
   3.656660654961069*^9}, {3.656661533158155*^9, 3.656661536549663*^9}, {
   3.656661616344326*^9, 3.65666164288934*^9}, {3.6566662400044117`*^9, 
   3.656666241684531*^9}, 3.6566665436764517`*^9, {3.656669425455266*^9, 
   3.656669436510957*^9}, {3.656669482736566*^9, 3.656669507968567*^9}, {
   3.656669583939533*^9, 3.6566696107877617`*^9}, {3.656669700326128*^9, 
   3.6566697046133957`*^9}, {3.656670442252367*^9, 3.656670442440941*^9}, {
   3.656670490760507*^9, 3.656670495751841*^9}, {3.656670552121344*^9, 
   3.656670553242096*^9}, {3.656671907178177*^9, 3.656671910505083*^9}, 
   3.6566720148463717`*^9, {3.656672409398641*^9, 3.656672413429017*^9}, {
   3.6566730184213047`*^9, 3.6566730241825438`*^9}, {3.6566758491110077`*^9, 
   3.656675849208012*^9}, {3.656760680719138*^9, 3.656760684174295*^9}, {
   3.656760942197298*^9, 3.6567609602286787`*^9}, {3.656761432498522*^9, 
   3.6567614691207523`*^9}, {3.656761682903078*^9, 3.656761713318776*^9}, {
   3.656761954700656*^9, 3.656762006685521*^9}, 3.656762668420135*^9, {
   3.656762756320385*^9, 3.656762757487*^9}, {3.656762920500139*^9, 
   3.656762925138739*^9}, {3.656763044951136*^9, 3.656763044997644*^9}, {
   3.6567631784101887`*^9, 3.656763199129426*^9}, 3.656763259021325*^9, {
   3.656763292300775*^9, 3.6567634100323772`*^9}, {3.6567643094772882`*^9, 
   3.656764449303768*^9}, {3.656764527690135*^9, 3.656764537338587*^9}, 
   3.6567645723947268`*^9, {3.656764623564048*^9, 3.656764637931774*^9}, {
   3.6567646787974253`*^9, 3.656764732719985*^9}, 3.656767629330832*^9, {
   3.656767672148302*^9, 3.656767677396078*^9}, {3.6567679099153233`*^9, 
   3.656767949290926*^9}, {3.657014851977071*^9, 3.657014855567672*^9}, {
   3.6570160163333893`*^9, 3.657016017676333*^9}, {3.6570160485244303`*^9, 
   3.657016049308105*^9}, {3.657017532176194*^9, 3.657017536048012*^9}, 
   3.674820020677245*^9, 3.674820129316277*^9}],

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"kkevaltab2", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tableContentx1", ";", "\[IndentingNewLine]", 
        RowBox[{"ans", "=", 
         RowBox[{"klchainmd2", "[", 
          RowBox[{
          "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",",
            "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
        RowBox[{
         RowBox[{"finalconfold", "[", 
          RowBox[{"Round", "[", 
           RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"es", ":=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"DMat", "[", 
           RowBox[{"finalconfold", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"e", "[", "modenum_", "]"}], ":=", 
         RowBox[{"es", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ee", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "[", "i", 
              "]"}], "=", 
             RowBox[{"e", "[", "i", "]"}]}], ",", 
            RowBox[{
             RowBox[{"eval", "[", "i", "]"}], "=", 
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{"num", "-", "i"}]}], "\[RightDoubleBracket]"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"th0", ",", 
          RowBox[{"eval", "[", "0", "]"}], ",", 
          RowBox[{"eval", "[", "1", "]"}], ",", 
          RowBox[{"eval", "[", "2", "]"}], ",", 
          RowBox[{"eval", "[", "3", "]"}], ",", 
          RowBox[{"eval", "[", "4", "]"}], ",", 
          RowBox[{"eval", "[", "5", "]"}], ",", 
          RowBox[{"eval", "[", "6", "]"}], ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espring", "[", 
             RowBox[{"tfinal", ",", "i"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", "num"}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"th0", ",", 
         RowBox[{"{", 
          RowBox[{
          "0.1", ",", "0.15", ",", "0.2", ",", "0.25", ",", "0.3", ",", "0.4",
            ",", "0.6"}], "}"}]}], "}"}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "num", ",", 
     RowBox[{"IntegerPart", "[", 
      FractionBox[
       SuperscriptBox["a", "2"], 
       RowBox[{"2", "r", " ", 
        RowBox[{"Sin", "[", "th0", "]"}]}]], "]"}]}], "}"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657701392399*^9}, {3.656657734476067*^9, 3.656657783773448*^9}, {
   3.656657817982214*^9, 3.656657917136283*^9}, {3.656659467413381*^9, 
   3.656659520343019*^9}, {3.656659629737068*^9, 3.656659631208724*^9}, {
   3.656659665514223*^9, 3.656659677387182*^9}, 3.656659757180534*^9, {
   3.6566600692034616`*^9, 3.656660073459321*^9}, {3.6566606313303556`*^9, 
   3.656660654961069*^9}, {3.656661533158155*^9, 3.656661536549663*^9}, {
   3.656661616344326*^9, 3.65666164288934*^9}, {3.6566662400044117`*^9, 
   3.656666241684531*^9}, 3.6566665436764517`*^9, {3.656669425455266*^9, 
   3.656669436510957*^9}, {3.656669482736566*^9, 3.656669507968567*^9}, {
   3.656669583939533*^9, 3.6566696107877617`*^9}, {3.656669700326128*^9, 
   3.6566697046133957`*^9}, {3.656670442252367*^9, 3.656670442440941*^9}, {
   3.656670490760507*^9, 3.656670495751841*^9}, {3.656670552121344*^9, 
   3.656670553242096*^9}, {3.656671907178177*^9, 3.656671910505083*^9}, 
   3.6566720148463717`*^9, {3.656672409398641*^9, 3.656672413429017*^9}, {
   3.6566730184213047`*^9, 3.6566730241825438`*^9}, {3.6566758491110077`*^9, 
   3.656675849208012*^9}, {3.656760680719138*^9, 3.656760684174295*^9}, {
   3.656760942197298*^9, 3.6567609602286787`*^9}, {3.656761432498522*^9, 
   3.6567614691207523`*^9}, {3.656761682903078*^9, 3.656761713318776*^9}, {
   3.656761954700656*^9, 3.656762006685521*^9}, 3.656762668420135*^9, {
   3.656762756320385*^9, 3.656762757487*^9}, {3.656762920500139*^9, 
   3.656762925138739*^9}, {3.656763044951136*^9, 3.656763044997644*^9}, {
   3.6567631784101887`*^9, 3.656763199129426*^9}, 3.656763259021325*^9, {
   3.656763292300775*^9, 3.6567634100323772`*^9}, {3.6567643094772882`*^9, 
   3.656764449303768*^9}, {3.656764527690135*^9, 3.656764537338587*^9}, 
   3.6567645723947268`*^9, {3.656764623564048*^9, 3.656764637931774*^9}, {
   3.6567646787974253`*^9, 3.656764732719985*^9}, 3.656767629330832*^9, {
   3.656767672148302*^9, 3.656767677396078*^9}, {3.6567679099153233`*^9, 
   3.656767949290926*^9}, {3.657014851977071*^9, 3.657014855567672*^9}, {
   3.6570160163333893`*^9, 3.657016017676333*^9}, {3.6570160485244303`*^9, 
   3.657016049308105*^9}, {3.657017532176194*^9, 3.657017575440878*^9}}],

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"kkevaltab3", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tableContentx1", ";", "\[IndentingNewLine]", 
        RowBox[{"ans", "=", 
         RowBox[{"klchainmd2", "[", 
          RowBox[{
          "num", ",", "tfinal", ",", "M", ",", "kk", ",", "r", ",", "th", ",",
            "initial", ",", "vzero"}], "]"}]}], ";", "\n", 
        RowBox[{
         RowBox[{"finalconfold", "[", 
          RowBox[{"Round", "[", 
           RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"es", ":=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"DMat", "[", 
           RowBox[{"finalconfold", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"e", "[", "modenum_", "]"}], ":=", 
         RowBox[{"es", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", 
            RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ee", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"th0", ",", "0.00001"}], "]"}], "]"}], "[", "i", 
              "]"}], "=", 
             RowBox[{"e", "[", "i", "]"}]}], ",", 
            RowBox[{
             RowBox[{"eval", "[", "i", "]"}], "=", 
             RowBox[{"es", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", 
               RowBox[{"num", "-", "i"}]}], "\[RightDoubleBracket]"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"th0", ",", 
          RowBox[{"eval", "[", "0", "]"}], ",", 
          RowBox[{"eval", "[", "1", "]"}], ",", 
          RowBox[{"eval", "[", "2", "]"}], ",", 
          RowBox[{"eval", "[", "3", "]"}], ",", 
          RowBox[{"eval", "[", "4", "]"}], ",", 
          RowBox[{"eval", "[", "5", "]"}], ",", 
          RowBox[{"eval", "[", "6", "]"}], ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espring", "[", 
             RowBox[{"tfinal", ",", "i"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", "num", ",", 
          "tfinal"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"th0", ",", 
         RowBox[{"{", "0.15", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nummulti", ",", 
         RowBox[{"{", 
          RowBox[{
          "150", ",", "200", ",", "250", ",", "300", ",", "350", ",", "400"}],
           "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"tfinal", ",", 
         RowBox[{"{", "20", "}"}]}], "}"}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "num", ",", 
     RowBox[{"IntegerPart", "[", 
      FractionBox[
       SuperscriptBox["a", "2"], 
       RowBox[{"2", "r", " ", 
        RowBox[{"Sin", "[", "th0", "]"}]}]], "]"}], ",", "tfinal"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.646911395334697*^9, 
   3.646911410727256*^9}, {3.6469115443636303`*^9, 3.6469115747213*^9}, {
   3.6469117138215723`*^9, 3.6469117506569357`*^9}, 3.646911794404086*^9, {
   3.646912848489254*^9, 3.646912849576247*^9}, 3.6469128885662327`*^9, 
   3.646913118084057*^9, {3.646917120015016*^9, 3.646917120038603*^9}, {
   3.647079932025281*^9, 3.647080016793221*^9}, {3.647080048349214*^9, 
   3.647080056813081*^9}, {3.647080112601049*^9, 3.647080175339944*^9}, 
   3.6470802660953617`*^9, {3.647080496626368*^9, 3.647080546009677*^9}, {
   3.647080682150028*^9, 3.647080716775126*^9}, {3.647080889404969*^9, 
   3.647080911212055*^9}, {3.647080948669024*^9, 3.6470809492534027`*^9}, {
   3.647080989315256*^9, 3.647080991121725*^9}, {3.647081043269012*^9, 
   3.6470810459220753`*^9}, {3.6470810788831673`*^9, 3.647081118755176*^9}, {
   3.647081163992598*^9, 3.647081190147707*^9}, 3.6470857170067577`*^9, {
   3.647085752672873*^9, 3.647085872749632*^9}, {3.6470859661928043`*^9, 
   3.647085967558242*^9}, {3.6470860083610973`*^9, 3.647086016186883*^9}, {
   3.647086046733411*^9, 3.647086093072098*^9}, {3.647086217464842*^9, 
   3.64708621759971*^9}, 3.647086264813744*^9, {3.6470865771192923`*^9, 
   3.647086581490555*^9}, {3.647086692069536*^9, 3.647086752212488*^9}, {
   3.647086905067988*^9, 3.647086921463338*^9}, {3.6470887926302853`*^9, 
   3.647088822194174*^9}, {3.647183525942354*^9, 3.647183538693912*^9}, {
   3.6471835712375298`*^9, 3.647183678022662*^9}, {3.6471840722198267`*^9, 
   3.647184094197853*^9}, {3.647236361167687*^9, 3.647236388990959*^9}, 
   3.647247165298609*^9, {3.6476792665477047`*^9, 3.647679270439857*^9}, {
   3.6476793116464577`*^9, 3.6476793590738897`*^9}, 3.647679404601694*^9, {
   3.647679774838318*^9, 3.6476798042370157`*^9}, {3.647680879440208*^9, 
   3.647680941843813*^9}, {3.6476809781499577`*^9, 3.647680984017907*^9}, {
   3.647681015988845*^9, 3.647681057090715*^9}, {3.647681826922838*^9, 
   3.647681833776705*^9}, {3.6476820482852707`*^9, 3.647682062871512*^9}, {
   3.647683445327132*^9, 3.647683463283166*^9}, {3.647693128026389*^9, 
   3.6476931289525146`*^9}, {3.647843851732229*^9, 3.647843871203693*^9}, {
   3.647844037686181*^9, 3.647844057718403*^9}, 3.647849255899581*^9, {
   3.647849784297915*^9, 3.6478497966426563`*^9}, 3.6478498738746653`*^9, {
   3.647850605026978*^9, 3.64785060529723*^9}, {3.6478631025966377`*^9, 
   3.6478631127806797`*^9}, 3.647863425127433*^9, 3.647866796119927*^9, {
   3.647866891321251*^9, 3.647866891823267*^9}, {3.647867092715435*^9, 
   3.6478670934688673`*^9}, 3.6514905213175077`*^9, {3.651490558404907*^9, 
   3.651490560763176*^9}, {3.6514906528274307`*^9, 3.651490687997509*^9}, {
   3.651491057488501*^9, 3.651491059694785*^9}, 3.6514911238260717`*^9, {
   3.6518347086146584`*^9, 3.6518347191603537`*^9}, {3.6518348031443577`*^9, 
   3.651834866567919*^9}, {3.6546006932596073`*^9, 3.6546006973178167`*^9}, 
   3.656401459629127*^9, {3.656401692910487*^9, 3.6564017299509773`*^9}, {
   3.6564018272502832`*^9, 3.65640182797087*^9}, {3.656401875986664*^9, 
   3.6564018902941437`*^9}, {3.656401933396899*^9, 3.6564019349010077`*^9}, {
   3.656402068639777*^9, 3.6564021535266047`*^9}, {3.656402251465837*^9, 
   3.656402283193837*^9}, {3.656402370700955*^9, 3.656402387725072*^9}, 
   3.656402426652648*^9, {3.656402770724924*^9, 3.656402770932995*^9}, {
   3.656403147182097*^9, 3.656403168171042*^9}, {3.6564054966444902`*^9, 
   3.656405521941568*^9}, 3.6564055691429567`*^9, {3.656405868382628*^9, 
   3.656405868461746*^9}, 3.656406053235236*^9, 3.656406286429153*^9, {
   3.656406333483541*^9, 3.6564063344255257`*^9}, 3.6564065537913027`*^9, 
   3.656411109915728*^9, 3.6564111858866253`*^9, {3.6564123645623283`*^9, 
   3.656412390349476*^9}, 3.656412578990839*^9, 3.656412640451745*^9, 
   3.656413027785677*^9, {3.6564131090507393`*^9, 3.656413109144257*^9}, {
   3.6566574141179533`*^9, 3.6566574142102423`*^9}, {3.656657665404397*^9, 
   3.656657701392399*^9}, {3.656657734476067*^9, 3.656657783773448*^9}, {
   3.656657817982214*^9, 3.656657917136283*^9}, {3.656659467413381*^9, 
   3.656659520343019*^9}, {3.656659629737068*^9, 3.656659631208724*^9}, {
   3.656659665514223*^9, 3.656659677387182*^9}, 3.656659757180534*^9, {
   3.6566600692034616`*^9, 3.656660073459321*^9}, {3.6566606313303556`*^9, 
   3.656660654961069*^9}, {3.656661533158155*^9, 3.656661536549663*^9}, {
   3.656661616344326*^9, 3.65666164288934*^9}, {3.6566662400044117`*^9, 
   3.656666241684531*^9}, 3.6566665436764517`*^9, {3.656669425455266*^9, 
   3.656669436510957*^9}, {3.656669482736566*^9, 3.656669507968567*^9}, {
   3.656669583939533*^9, 3.6566696107877617`*^9}, {3.656669700326128*^9, 
   3.6566697046133957`*^9}, {3.656670442252367*^9, 3.656670442440941*^9}, {
   3.656670490760507*^9, 3.656670495751841*^9}, {3.656670552121344*^9, 
   3.656670553242096*^9}, {3.656671907178177*^9, 3.656671910505083*^9}, 
   3.6566720148463717`*^9, {3.656672409398641*^9, 3.656672413429017*^9}, {
   3.6566730184213047`*^9, 3.6566730241825438`*^9}, {3.6566758491110077`*^9, 
   3.656675849208012*^9}, {3.656760680719138*^9, 3.656760684174295*^9}, {
   3.656760942197298*^9, 3.6567609602286787`*^9}, {3.656761432498522*^9, 
   3.6567614691207523`*^9}, {3.656761682903078*^9, 3.656761713318776*^9}, {
   3.656761954700656*^9, 3.656762006685521*^9}, 3.656762668420135*^9, {
   3.656762756320385*^9, 3.656762757487*^9}, {3.656762920500139*^9, 
   3.656762925138739*^9}, {3.656763044951136*^9, 3.656763044997644*^9}, {
   3.6567631784101887`*^9, 3.656763199129426*^9}, 3.656763259021325*^9, {
   3.656763292300775*^9, 3.656763421326479*^9}, {3.6570139156577806`*^9, 
   3.657013915753539*^9}, {3.657014383076974*^9, 3.657014411653234*^9}, {
   3.657014869104145*^9, 3.657014906290889*^9}, {3.6570150233962097`*^9, 
   3.657015067204398*^9}, {3.657015231898015*^9, 3.657015245544862*^9}, {
   3.657015329036256*^9, 3.657015329229816*^9}, {3.6570154082697487`*^9, 
   3.657015408652999*^9}, {3.657015449134838*^9, 3.6570154728464317`*^9}, {
   3.6570155612660027`*^9, 3.657015564406973*^9}, {3.6570184697190733`*^9, 
   3.6570184698144817`*^9}, {3.657018505752434*^9, 3.657018509655138*^9}, {
   3.657018541096738*^9, 3.657018558858692*^9}, {3.6570190889023314`*^9, 
   3.657019095077004*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"MakeSSHpicvec", "[", 
         RowBox[{
          RowBox[{"finalconfold", "[", 
           RowBox[{"Round", "[", 
            RowBox[{"th0", ",", "0.001"}], "]"}], "]"}], ",", "r", ",", 
          RowBox[{"3", 
           RowBox[{
            RowBox[{"ee", "[", 
             RowBox[{"Round", "[", 
              RowBox[{"th0", ",", "0.001"}], "]"}], "]"}], "[", 
            RowBox[{"imax", "-", "2"}], "]"}]}]}], 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
            "sign"}], ",", " ", 
           RowBox[{"use", " ", "-", " ", 
            RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1500"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "r"}], "-", "1"}], ",", 
             RowBox[{"num", "+", "r", "+", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "r"}], "-", "1.1"}], ",", 
             RowBox[{"r", "+", "1.1"}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "i"}], "}"}]}], "\[RightDoubleBracket]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "imax", ",", "imax"}], "}"}]}], "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<th0\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], 
             "}"}]}]}], "]"}], ",", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "9"}], "}"}]}], "\[RightDoubleBracket]"}], 
           ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<th0\>\"", ",", "\"\<Spring Energy\>\""}], "}"}]}]}],
           "]"}], ",", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
            RowBox[{"orderOfth0", ",", 
             RowBox[{"2", ";;", "8"}]}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
           RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<mode(order of th0)\>\"", ",", "\"\<omega^2\>\""}], 
             "}"}]}]}], "]"}]}], "}"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"imax", ",", "2", ",", "8", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "0.02", ",", "0.1", ",", "0.02"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"orderOfth0", ",", "1", ",", "5", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.656760710001561*^9, 
   3.656760717888281*^9}}],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Abs", "@", 
         RowBox[{"kkevaltab2", "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "6"}], ";;", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}]}], "\[RightDoubleBracket]"}]}], 
        ",", 
        RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5"}], "}"}]}], "\[RightDoubleBracket]"}]}], 
       "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<th0\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], 
        "}"}]}]}], "]"}], ",", 
    RowBox[{"LogLogPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", " ", "10000", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"r", " ", 
           RowBox[{"Sin", "[", "th", "]"}]}], ")"}], "2"], " ", "*", 
        RowBox[{"3", "/", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "0.001", ",", "0.6"}], "}"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656765102758151*^9, 3.656765156441532*^9}, {3.6567651919286118`*^9, 
   3.6567651957201*^9}, {3.6567653022680597`*^9, 3.65676530597885*^9}, {
   3.6567653540443707`*^9, 3.656765437502102*^9}, {3.656765477601519*^9, 
   3.656765487360772*^9}, {3.65676632990842*^9, 3.656766334403561*^9}, {
   3.6567679828431664`*^9, 3.656767986794736*^9}, {3.65676893259431*^9, 
   3.6567689390296383`*^9}, {3.6568320066732283`*^9, 3.6568320136799507`*^9}, 
   3.656950081532312*^9, {3.656952839501794*^9, 3.656952841720868*^9}, {
   3.656953230791391*^9, 3.656953232613826*^9}, {3.6569541058701563`*^9, 
   3.656954149291991*^9}, 3.6569542419345922`*^9, {3.6570137381831427`*^9, 
   3.657013739873043*^9}, {3.657013873127995*^9, 3.657013880887575*^9}, {
   3.6570226721220493`*^9, 3.6570227142017717`*^9}, {3.657022757308713*^9, 
   3.6570227583995743`*^9}}],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"kkevaltab2", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
        RowBox[{"kkevaltab2", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5"}], "}"}]}], "\[RightDoubleBracket]"}]}], 
       "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<th0\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], 
        "}"}]}]}], "]"}], ",", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", " ", "10000", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"r", " ", 
           RowBox[{"Sin", "[", "th", "]"}]}], ")"}], "2"], " ", "*", 
        RowBox[{"3", "/", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "0.001", ",", "0.6"}], "}"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656765102758151*^9, 3.656765156441532*^9}, {3.6567651919286118`*^9, 
   3.6567651957201*^9}, {3.6567653022680597`*^9, 3.65676530597885*^9}, {
   3.6567653540443707`*^9, 3.656765437502102*^9}, {3.656765477601519*^9, 
   3.656765487360772*^9}, {3.65676632990842*^9, 3.656766334403561*^9}, {
   3.6567679828431664`*^9, 3.656767986794736*^9}, {3.65676893259431*^9, 
   3.6567689390296383`*^9}, {3.6568320066732283`*^9, 3.6568320136799507`*^9}, 
   3.656950081532312*^9, {3.656952839501794*^9, 3.656952841720868*^9}, {
   3.656953230791391*^9, 3.656953232613826*^9}, {3.6569541058701563`*^9, 
   3.656954149291991*^9}, 3.6569542419345922`*^9, {3.6570137381831427`*^9, 
   3.657013739873043*^9}, {3.657013873127995*^9, 3.657013880887575*^9}, {
   3.657013965259557*^9, 3.657013975114238*^9}, {3.657017263643949*^9, 
   3.657017265194784*^9}, {3.657017303313764*^9, 3.657017304649597*^9}, {
   3.657017706755793*^9, 3.6570177201161537`*^9}, {3.657018479689352*^9, 
   3.657018479877749*^9}}],

Cell[BoxData[
 RowBox[{"LogLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Sqrt", "[", "  ", 
     RowBox[{
      RowBox[{"(", " ", 
       RowBox[{"Sin", "[", "th", "]"}], ")"}], "^", "2"}], " ", "]"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "0.0001", ",", "0.8"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", "\"\<Continuum theory\>\""}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"plot\[Omega]s\[Theta]ak1", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Transpose", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{
             RowBox[{"Sqrt", "@", 
              RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
               RowBox[{"All", ",", "5"}], "\[RightDoubleBracket]"}]}], "/", 
             RowBox[{"(", 
              RowBox[{"r", 
               RowBox[{
                SqrtBox[
                 FractionBox[
                  RowBox[{"12", " ", "10000"}], "1"]], "/", "a"}]}], 
              ")"}]}]}], "}"}]}], ",", 
         RowBox[{"Transpose", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"kkevaltab2", "\[LeftDoubleBracket]", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "6"}], ";;", 
               RowBox[{"-", "1"}]}], ",", "1"}], "\[RightDoubleBracket]"}], 
            ",", 
            RowBox[{
             RowBox[{"Sqrt", "@", 
              RowBox[{"Abs", "@", 
               RowBox[{"kkevaltab2", "\[LeftDoubleBracket]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "6"}], ";;", 
                  RowBox[{"-", "1"}]}], ",", "4"}], 
                "\[RightDoubleBracket]"}]}]}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"r", "/", "a"}], 
               SqrtBox[
                FractionBox[
                 RowBox[{"12", " ", "10000"}], "1"]]}], ")"}]}]}], "}"}]}]}], 
        "}"}], ",", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"PlotTheme", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<OpenMarkersThick\>\"", ",", "\"\<PlotMarkers\>\""}], 
           "}"}]}], ","}], "*)"}], " ", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Graphics", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", "Thick", ",", 
              RowBox[{"Disk", "[", "]"}]}], "}"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "20"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", "Thick", ",", 
              RowBox[{"Circle", "[", "]"}]}], "}"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "20"}]}], "]"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Directive", "[", 
           RowBox[{"Black", ",", 
            RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}], ",", 
          RowBox[{"Directive", "[", 
           RowBox[{"Black", ",", 
            RowBox[{"PointSize", "\[Rule]", "0.03"}]}], "]"}]}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<\!\(\*OverscriptBox[\(\[Theta]\), \(_\)]\)\>\"", ",", 
          "\"\<\!\(\*FractionBox[\(\[Omega]\), \(\((r/a)\) \*SqrtBox[\(12\\\ \
k/M\)]\)]\)\>\""}], "}"}]}], ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", " ", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
       RowBox[{"FrameTicksStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
       RowBox[{"PlotLegends", "\[Rule]", 
        RowBox[{"Placed", "[", 
         RowBox[{
          RowBox[{"PointLegend", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", "Black"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Antikink shape mode\>\"", ",", 
              "\"\<Antikink translation mode\>\""}], "}"}], ",", 
            RowBox[{"LegendMarkerSize", "\[Rule]", "20"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.38", ",", "0.35"}], "}"}]}], "]"}]}]}], "]"}], ",", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Sqrt", "[", "  ", 
         RowBox[{
          RowBox[{
           RowBox[{"(", " ", 
            RowBox[{"Sin", "[", "th", "]"}], ")"}], "^", "2"}], " ", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"1", "^", "2"}], "+", 
            RowBox[{"4", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"r", "/", "a"}], ")"}], "^", "2"}], 
             RowBox[{
              RowBox[{"Cos", "[", "th", "]"}], "^", "2"}]}]}], ")"}]}], " ", 
         "]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "0.0001", ",", "0.8"}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
       RowBox[{"PlotLegends", "->", 
        RowBox[{"Placed", "[", 
         RowBox[{
          RowBox[{"LineLegend", "[", 
           RowBox[{
            RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.32", ",", "0.2"}], "}"}]}], "]"}]}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656765102758151*^9, 3.656765156441532*^9}, {3.6567651919286118`*^9, 
   3.6567651957201*^9}, {3.6567653022680597`*^9, 3.65676530597885*^9}, {
   3.6567653540443707`*^9, 3.656765437502102*^9}, {3.656765477601519*^9, 
   3.656765487360772*^9}, {3.6567660209083776`*^9, 3.656766086733609*^9}, 
   3.6567676500512247`*^9, {3.6567677807097692`*^9, 3.65676787490403*^9}, {
   3.656768020908862*^9, 3.656768021563938*^9}, {3.656832061653616*^9, 
   3.656832105080014*^9}, {3.656945612804636*^9, 3.656945803657277*^9}, {
   3.6569458572444983`*^9, 3.656945877609315*^9}, {3.656945933275282*^9, 
   3.656946024823887*^9}, {3.656946083808*^9, 3.656946144895925*^9}, {
   3.656946285164662*^9, 3.656946381302005*^9}, {3.656946436280367*^9, 
   3.656946450918902*^9}, {3.656946561226376*^9, 3.6569466383949013`*^9}, {
   3.6569467312624693`*^9, 3.656946731757284*^9}, {3.6569468562161617`*^9, 
   3.6569468842253227`*^9}, {3.6569469489973087`*^9, 3.65694703663244*^9}, {
   3.6569483722999067`*^9, 3.656948449398196*^9}, {3.656948562463431*^9, 
   3.656948606249894*^9}, {3.6569487183819847`*^9, 3.656948722328537*^9}, {
   3.656948760718019*^9, 3.656948762933073*^9}, {3.656949116246266*^9, 
   3.656949133461769*^9}, {3.656949177351143*^9, 3.656949203543754*^9}, 
   3.6569495053286457`*^9, {3.656950160049124*^9, 3.656950221071413*^9}, {
   3.656950494070318*^9, 3.656950504678388*^9}, {3.656950544023883*^9, 
   3.656950666986248*^9}, {3.65695071820612*^9, 3.6569507685564137`*^9}, {
   3.656950995539798*^9, 3.656951014098878*^9}, {3.65695118107999*^9, 
   3.656951257463808*^9}, {3.656951316764263*^9, 3.656951333198036*^9}, {
   3.656951407038913*^9, 3.656951434828754*^9}, {3.656951869117178*^9, 
   3.656951891070277*^9}, {3.656951987721792*^9, 3.656951992461629*^9}, {
   3.657023437949201*^9, 3.657023814489038*^9}, {3.6570239108488483`*^9, 
   3.657023944199758*^9}, {3.65702399877886*^9, 3.657024060862905*^9}, {
   3.6570241603292847`*^9, 3.6570242103824673`*^9}, {3.65702427158552*^9, 
   3.65702432812179*^9}, {3.657033947523987*^9, 3.6570339647716637`*^9}, {
   3.65703835044547*^9, 3.657038350652501*^9}, {3.6572964998597307`*^9, 
   3.6572965675716867`*^9}, {3.657296646121257*^9, 3.657296685449561*^9}, {
   3.6572967661370373`*^9, 3.657296808034307*^9}, {3.6572968941477833`*^9, 
   3.657296945778665*^9}, {3.657297239028019*^9, 3.657297244347404*^9}, {
   3.657540526469639*^9, 3.657540607303154*^9}, {3.657540644473068*^9, 
   3.657540762955531*^9}, {3.661149554461631*^9, 3.661149601166499*^9}, {
   3.661149697986245*^9, 3.661149731071537*^9}, {3.6615218043092823`*^9, 
   3.661521819251636*^9}, {3.661521851987412*^9, 3.661521863750434*^9}, {
   3.661522009786174*^9, 3.66152205792728*^9}, {3.661522093099278*^9, 
   3.6615220932345963`*^9}, {3.661775086968255*^9, 3.661775087537241*^9}, {
   3.6748204758316307`*^9, 3.674820476747077*^9}, {3.6748206484358673`*^9, 
   3.67482074989921*^9}, {3.674820791674213*^9, 3.674820803767417*^9}, {
   3.6748213434160967`*^9, 3.674821374317643*^9}, {3.674821404663741*^9, 
   3.674821407493761*^9}, {3.6748226144193773`*^9, 3.674822715078762*^9}}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{{{}, {
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          GraphicsBox[
           {GrayLevel[0], AbsolutePointSize[6], Thickness[Large], 
            DiskBox[{0, 0}]},
           
           ImageSize->
            20], {0., 0.}], {{{-5.521460917862246, -6.124740084416248}}, \
{{-5.115995809754082, -5.749531385575699}}, {{-4.8283137373023015`, \
-5.46316895858838}}, {{-4.605170185988091, -5.240096518129448}}, \
{{-3.912023005428146, -4.5470975339038855`}}, {{-3.2188758248682006`, \
-3.8545333160952184`}}, {{-2.8134107167600364`, -3.4500404461405627`}}, \
{{-2.5257286443082556`, -3.163720842157301}}, {{-2.3025850929940455`, \
-2.942331327290267}}, {{-1.8971199848858813`, -2.5429767015469595`}}, \
{{-1.6094379124341003`, -2.263902086525968}}, {{-0.916290731874155, \
-1.6318027383788782`}}, {{-0.5108256237659907, -1.351163694506648}}}]}, 
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          GraphicsBox[
           {GrayLevel[0], AbsolutePointSize[6], Thickness[Large], 
            CircleBox[{0, 0}]},
           
           ImageSize->
            20], {0., 0.}], {{{-1.8971199848858813`, -18.43507011099968}}, \
{{-1.6094379124341003`, -13.611923808606198`}}, {{-1.3862943611198906`, \
-10.096358948800173`}}, {{-1.2039728043259361`, -8.329680092800674}}, \
{{-0.916290731874155, -5.785992355329554}}, {{-0.5108256237659907, \
-3.5047615105425223`}}}]}, {}}, {}}, {{}, {}, 
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVy3k0FAgcwHEy7nscgzHMofXs0ovkKlOh2ka0zlovq7UMhpjkEU9LjvCW
tnOMIpSRdU2horz3+21yzCImR0XLyuaY2cZR5Fq2/eP7Pn99aaFxvuHb5OTk
vL70v3FDBQ8fRNNx2T66Fe8zkC9uO/0th461xuUJx4UMxN7V7eORdDywOWwt
q2OgTkc4T4NNR8VOtxJyDQPvP3JNijhFx5VAk58TBQycL/zgRAmgYxBXtM/6
JgPjg7xac5l0rM+xbCvMZGDiuEZbiC4dc/dOimIDGbjuPS1NENLwgbBhMfMT
HW34rxyV/WnYR7/ONCyi4waTVRG2RkWu3mL12X10POJpZG1VRMX9T0vtnMZo
6Ga7McxhUrFZ8cSfyZk0TFhNdLFsNsf0d7536TQa3vZcU9b+bIYyt4Y8HlKR
6vMbecHNDMMmFK/lsKlYStNml6dRcJTJeTxOoGKSoGzZU2SKhv1O/0b5mWPe
3w5d+YamqKnR0V1dZoaFssz+W/5kHHrp39cyRsHNmg0zQakJZk3EkNqsKPij
vXVF6qgxdvgVX70ZboqbSac4EhNjDBImsVQEZPwUi4m+EUY4JSp25y6Y4NTO
Vy25FSQ0zCiOrNxhgraVxu4tMkOkOAaIhs8ZY/IUUaHZyhDtOqqODDUa4fqE
DsEr0gBvLNvMRS2ScOiyi+fbRn0Mmk17uuJKwlo1ssh5Xg/tV2fOBaQY4qij
ZcEVZz08bWDpXNtmgB5Up6tpF4nIl68b4OsYYPXAVu+e57r4VeDt177e+hjl
8vHYopYuBkcNhSgV6aFFTIlKEksHq3Qk0RcHiWjXwCdY6Gljcl2r8KYeEXsX
vbK8azSxdCl4rjJEF0NF3DMG2zUwTZ3vnVr85VOSSvqb1dA9Jo50qUcbQ5/E
TjX7qWL0wSvkAxFaaEA4dcy1XxnzufXP4yc1MLmpyuMRWwnHRq9npCar4/Da
D/e6xwjIChHkT86r4vt7MbwhrgJmeN1ZkM9QwYjuTGUNtW0YpHXo7JyxMk5m
qUyNZckhu5DRAFcVkcoSlR/dtQlhag0rYgsCxjw66atPXQdHdeNLS7xtWKat
oLybvAL5363PRGnJo4PDiUEmawmkh0teJ+zZAsjNTb2wdxHizM/nyOlvgL9P
X0pQuwxCK9odk0irsMZpJITtmAUWMewhj7wM2W+9PMYpk0BUce4e61yEKvEv
nO8lIxBQf7ZGSJmDqMKsz32PR2BPNqfTXW4Ovg4+n3UoewTcpreE4ncyqJmJ
vb2LOgIpwn+6Ru7JoH7L56Vm4Bv4q6XgcLmtDJpsjFye/f4KbKtOzq+4fwDI
q1D9pmgQOqULE6U/SSH9WAmvnD0IIbwQ/5CDUthvwGMY2Q9CXru4jmQphWdl
Oa6KfQOAJNWNeIkE2h9zzowTBiCcNR4wwJVA9/udb65xxXC8jNa1O3UW8mus
2GpMMVwKsxlID56Fo2foH9PVxdDz7lrkc+YsvNjQ04yt7IcyAdF8t/ws3LGU
Xbjc3Ac9uOzSmj0DFo3jt8779UHADbJRN3sGBEzxQ47sBTQo8U++PDwDVQFN
sx4WL8DNiKj5h+oMWE0IFOygF5q6XOOfSKahOqaQYh7UC+oOVNu73dNgvZLr
qLHUAx9Nuw5l1U5DXWaKz+qvPfB5IfF+cME0/AdErH87
        "]]}}}, {InsetBox[
      TemplateBox[{"\"Antikink shape mode\"","\"Antikink translation mode\""},
       
       "PointLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #}, {
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"PointLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 ButtonBox[
                  TooltipBox[
                   GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                  Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                  Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                  With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                  Automatic, Method -> "Preemptive"], 
                 GrayLevel[0], Editable -> False, Selectable -> False], ",", 
                InterpretationBox[
                 ButtonBox[
                  TooltipBox[
                   GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                  Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                  Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                  With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                  Automatic, Method -> "Preemptive"], 
                 GrayLevel[0], Editable -> False, Selectable -> False]}], 
              "}"}], ",", 
            RowBox[{"{", 
              RowBox[{#, ",", #2}], "}"}], ",", 
            RowBox[{"Joined", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"False", ",", "False"}], "}"}]}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"\"Column\"", ",", 
                  RowBox[{"{", 
                    RowBox[{"Automatic", ",", "5"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                    "}"}]}], "}"}]}], ",", 
            RowBox[{"LegendMarkerSize", "\[Rule]", "20"}]}], "]"}]& )], 
      Scaled[{0.38, 0.35}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm], InsetBox[
      TemplateBox[{"\"Continuum theory\""},
       "LineLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{"Directive", "[", 
                RowBox[{
                  RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                  RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                  InterpretationBox[
                   ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                   GrayLevel[0], Editable -> False, Selectable -> False]}], 
                "]"}], "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& )], 
      Scaled[{0.32, 0.2}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{-5.705771395802637, -19.675031060583855`},
   CoordinatesToolOptions:>{"DisplayFunction" -> ({
       Exp[
        Part[#, 1]], 
       Exp[
        Part[#, 2]]}& ), "CopiedValueFunction" -> ({
       Exp[
        Part[#, 1]], 
       Exp[
        Part[#, 2]]}& )},
   DisplayFunction->Identity,
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox[
      "\"\\!\\(\\*FractionBox[\\(\[Omega]\\), \\(\\((r/a)\\) \\*SqrtBox[\\(12\
\\\\ k/M\\)]\\)]\\)\"", TraditionalForm], None}, {
      FormBox[
      "\"\\!\\(\\*OverscriptBox[\\(\[Theta]\\), \\(_\\)]\\)\"", 
       TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->FrontEndValueCache[{{
       Charting`ScaledTicks[{Log, Exp}], 
       Charting`ScaledFrameTicks[{Log, Exp}]}, {
       Charting`ScaledTicks[{Log, Exp}], 
       Charting`ScaledFrameTicks[{Log, Exp}]}}, {{{{-16.11809565095832, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "7"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.907755278982137, 
         FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-20.72326583694641, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-9.210340371976182, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          InterpretationBox[
           StyleBox[
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0., 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.302585092994046, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}, {{-16.11809565095832, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.907755278982137, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-20.72326583694641, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-9.210340371976182, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0., 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.302585092994046, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}}, {{{-5.298317366548036, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.995732273553991, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.907755278982137, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.214608098422191, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.809142990314028, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.521460917862246, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.115995809754082, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.961845129926823, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.710530701645918, 
         FormBox[
          InterpretationBox[
           StyleBox[
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.912023005428146, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.506557897319982, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.659260036932778, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.916290731874155, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0., 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.09531017980432493, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.1823215567939546, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.26236426446749106`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.3364722366212129, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.4054651081081644, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.47000362924573563`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}, {{-5.298317366548036, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.995732273553991, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.907755278982137, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-6.214608098422191, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.809142990314028, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.521460917862246, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-5.115995809754082, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.961845129926823, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.710530701645918, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.912023005428146, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.506557897319982, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.659260036932778, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.916290731874155, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0., 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.09531017980432493, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.1823215567939546, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.26236426446749106`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.3364722366212129, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.4054651081081644, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0.47000362924573563`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}}}],
   FrameTicksStyle->Directive[FontSize -> Large],
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->800,
   LabelStyle->Directive[FontSize -> Large],
   Method->{},
   PlotRange->{{-5.625849153155919, -0.5108256237659907}, \
{-19.38417602302707, -1.351163694506648}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{
     Charting`ScaledTicks[{Log, Exp}], 
     Charting`ScaledTicks[{Log, Exp}]}],
  InterpretTemplate[Legended[
    Graphics[{{{}, {{{
          Directive[
           PointSize[0.012833333333333334`], 
           AbsoluteThickness[1.6], 
           GrayLevel[0], PointSize -> 0.03, 
           AbsolutePointSize[6]], 
          GeometricTransformation[
           Inset[
            Graphics[{
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               GrayLevel[0], PointSize -> 0.03, 
               AbsolutePointSize[6]], 
              GrayLevel[0], 
              Thickness[Large], 
              Disk[{0, 0}]}, ImageSize -> 20], {0., 
            0.}], {{{-5.521460917862246, -6.124740084416248}}, \
{{-5.115995809754082, -5.749531385575699}}, {{-4.8283137373023015`, \
-5.46316895858838}}, {{-4.605170185988091, -5.240096518129448}}, \
{{-3.912023005428146, -4.5470975339038855`}}, {{-3.2188758248682006`, \
-3.8545333160952184`}}, {{-2.8134107167600364`, -3.4500404461405627`}}, \
{{-2.5257286443082556`, -3.163720842157301}}, {{-2.3025850929940455`, \
-2.942331327290267}}, {{-1.8971199848858813`, -2.5429767015469595`}}, \
{{-1.6094379124341003`, -2.263902086525968}}, {{-0.916290731874155, \
-1.6318027383788782`}}, {{-0.5108256237659907, -1.351163694506648}}}]}, {
          Directive[
           PointSize[0.012833333333333334`], 
           AbsoluteThickness[1.6], 
           GrayLevel[0], PointSize -> 0.03, 
           AbsolutePointSize[6]], 
          GeometricTransformation[
           Inset[
            Graphics[{
              Directive[
               PointSize[0.012833333333333334`], 
               AbsoluteThickness[1.6], 
               GrayLevel[0], PointSize -> 0.03, 
               AbsolutePointSize[6]], 
              GrayLevel[0], 
              Thickness[Large], 
              Circle[{0, 0}]}, ImageSize -> 20], {0., 
            0.}], {{{-1.8971199848858813`, -18.43507011099968}}, \
{{-1.6094379124341003`, -13.611923808606198`}}, {{-1.3862943611198906`, \
-10.096358948800173`}}, {{-1.2039728043259361`, -8.329680092800674}}, \
{{-0.916290731874155, -5.785992355329554}}, {{-0.5108256237659907, \
-3.5047615105425223`}}}]}, {}}}, {}}, {{{}, {}, {
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          GrayLevel[0]], 
         Line[CompressedData["
1:eJwVy3k0FAgcwHEy7nscgzHMofXs0ovkKlOh2ka0zlovq7UMhpjkEU9LjvCW
tnOMIpSRdU2horz3+21yzCImR0XLyuaY2cZR5Fq2/eP7Pn99aaFxvuHb5OTk
vL70v3FDBQ8fRNNx2T66Fe8zkC9uO/0th461xuUJx4UMxN7V7eORdDywOWwt
q2OgTkc4T4NNR8VOtxJyDQPvP3JNijhFx5VAk58TBQycL/zgRAmgYxBXtM/6
JgPjg7xac5l0rM+xbCvMZGDiuEZbiC4dc/dOimIDGbjuPS1NENLwgbBhMfMT
HW34rxyV/WnYR7/ONCyi4waTVRG2RkWu3mL12X10POJpZG1VRMX9T0vtnMZo
6Ga7McxhUrFZ8cSfyZk0TFhNdLFsNsf0d7536TQa3vZcU9b+bIYyt4Y8HlKR
6vMbecHNDMMmFK/lsKlYStNml6dRcJTJeTxOoGKSoGzZU2SKhv1O/0b5mWPe
3w5d+YamqKnR0V1dZoaFssz+W/5kHHrp39cyRsHNmg0zQakJZk3EkNqsKPij
vXVF6qgxdvgVX70ZboqbSac4EhNjDBImsVQEZPwUi4m+EUY4JSp25y6Y4NTO
Vy25FSQ0zCiOrNxhgraVxu4tMkOkOAaIhs8ZY/IUUaHZyhDtOqqODDUa4fqE
DsEr0gBvLNvMRS2ScOiyi+fbRn0Mmk17uuJKwlo1ssh5Xg/tV2fOBaQY4qij
ZcEVZz08bWDpXNtmgB5Up6tpF4nIl68b4OsYYPXAVu+e57r4VeDt177e+hjl
8vHYopYuBkcNhSgV6aFFTIlKEksHq3Qk0RcHiWjXwCdY6Gljcl2r8KYeEXsX
vbK8azSxdCl4rjJEF0NF3DMG2zUwTZ3vnVr85VOSSvqb1dA9Jo50qUcbQ5/E
TjX7qWL0wSvkAxFaaEA4dcy1XxnzufXP4yc1MLmpyuMRWwnHRq9npCar4/Da
D/e6xwjIChHkT86r4vt7MbwhrgJmeN1ZkM9QwYjuTGUNtW0YpHXo7JyxMk5m
qUyNZckhu5DRAFcVkcoSlR/dtQlhag0rYgsCxjw66atPXQdHdeNLS7xtWKat
oLybvAL5363PRGnJo4PDiUEmawmkh0teJ+zZAsjNTb2wdxHizM/nyOlvgL9P
X0pQuwxCK9odk0irsMZpJITtmAUWMewhj7wM2W+9PMYpk0BUce4e61yEKvEv
nO8lIxBQf7ZGSJmDqMKsz32PR2BPNqfTXW4Ovg4+n3UoewTcpreE4ncyqJmJ
vb2LOgIpwn+6Ru7JoH7L56Vm4Bv4q6XgcLmtDJpsjFye/f4KbKtOzq+4fwDI
q1D9pmgQOqULE6U/SSH9WAmvnD0IIbwQ/5CDUthvwGMY2Q9CXru4jmQphWdl
Oa6KfQOAJNWNeIkE2h9zzowTBiCcNR4wwJVA9/udb65xxXC8jNa1O3UW8mus
2GpMMVwKsxlID56Fo2foH9PVxdDz7lrkc+YsvNjQ04yt7IcyAdF8t/ws3LGU
Xbjc3Ac9uOzSmj0DFo3jt8779UHADbJRN3sGBEzxQ47sBTQo8U++PDwDVQFN
sx4WL8DNiKj5h+oMWE0IFOygF5q6XOOfSKahOqaQYh7UC+oOVNu73dNgvZLr
qLHUAx9Nuw5l1U5DXWaKz+qvPfB5IfF+cME0/AdErH87
          "]]}}}}, {
     DisplayFunction -> Identity, GridLines -> {None, None}, DisplayFunction -> 
      Identity, DisplayFunction -> Identity, DisplayFunction -> Identity, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}}, 
      AxesOrigin -> {-5.705771395802637, -19.675031060583855`}, 
      PlotRange -> {{-5.625849153155919, -0.5108256237659907}, \
{-19.38417602302707, -1.351163694506648}}, DisplayFunction -> Identity, 
      AspectRatio -> GoldenRatio^(-1), Axes -> {True, True}, 
      AxesLabel -> {None, None}, 
      AxesOrigin -> {-5.705771395802637, -19.675031060583855`}, 
      CoordinatesToolOptions -> {"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )}, DisplayFunction :> Identity, 
      Frame -> {{True, True}, {True, True}}, 
      FrameLabel -> {{
        "\!\(\*FractionBox[\(\[Omega]\), \(\((r/a)\) \*SqrtBox[\(12\\ \
k/M\)]\)]\)", None}, {"\!\(\*OverscriptBox[\(\[Theta]\), \(_\)]\)", None}}, 
      FrameStyle -> Thickness[Large], FrameTicks -> {{
         Charting`ScaledTicks[{Log, Exp}], 
         Charting`ScaledFrameTicks[{Log, Exp}]}, {
         Charting`ScaledTicks[{Log, Exp}], 
         Charting`ScaledFrameTicks[{Log, Exp}]}}, FrameTicksStyle -> 
      Directive[FontSize -> Large], GridLines -> {None, None}, GridLinesStyle -> 
      Directive[
        GrayLevel[0.5, 0.4]], ImageSize -> 800, LabelStyle -> 
      Directive[FontSize -> Large], Method -> {}, 
      PlotRange -> {{-5.625849153155919, -0.5108256237659907}, \
{-19.38417602302707, -1.351163694506648}}, PlotRangeClipping -> True, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.05]}}, Ticks -> {
        Charting`ScaledTicks[{Log, Exp}], 
        Charting`ScaledTicks[{Log, Exp}]}}], 
    Placed[
     Unevaluated[
      Unevaluated[
       LineLegend[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          GrayLevel[0]]}, {"Continuum theory"}, LegendMarkers -> None, 
        LabelStyle -> Directive[FontSize -> Large], LegendLayout -> 
        "Column"]]], {0.32, 0.2}, Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Input",
 CellChangeTimes->{3.674832917199136*^9}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ticks1", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"FrameTicks", "\[Rule]", "x_"}], ")"}], "\[RuleDelayed]", 
     RowBox[{"(", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"N", "@", 
                RowBox[{"Log", "@", "#"}]}], ",", "#"}], "}"}], "&"}], "/@", 
            RowBox[{"{", 
             RowBox[{"1", ",", "5", ",", "10", ",", "50"}], "}"}]}], ",", 
           "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"N", "@", 
                RowBox[{"Log", "@", "#"}]}], ",", "#"}], "}"}], "&"}], "/@", 
            RowBox[{"{", 
             RowBox[{
             "0.005", ",", "0.01", ",", "0.05", ",", "0.1", ",", "0.5"}], 
             "}"}]}], ",", "None"}], "}"}]}], "}"}]}], ")"}]}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.6569468351430283`*^9, 3.656946845301896*^9}, {
   3.656946917170232*^9, 3.656946917409988*^9}, {3.656948736957361*^9, 
   3.656948749164907*^9}, 3.6569488592476807`*^9, {3.656949102646027*^9, 
   3.65694910680472*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<w-th-ak.pdf\>\"", ",", "plot\[Omega]s\[Theta]ak1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "800"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.656949172807863*^9, 3.656949174486961*^9}, {
   3.656949214024951*^9, 3.656949310394067*^9}, {3.656949348602672*^9, 
   3.656949348875595*^9}, {3.656949501358549*^9, 3.656949503070437*^9}, 
   3.656950852991365*^9, {3.656950981649123*^9, 3.656951006673263*^9}, {
   3.656951975800939*^9, 3.6569519760243187`*^9}, {3.656952077354991*^9, 
   3.656952077914336*^9}, 3.657024368561398*^9, {3.661149862339472*^9, 
   3.661149864690956*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"kkevaltab", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "2"}], ",", "i"}], "}"}]}], 
             "\[RightDoubleBracket]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "imax", ",", "imax"}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "4"}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<num (multi width)\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"2", " ", "10000", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"r", " ", 
            RowBox[{"Sin", "[", "th0", "]"}]}], ")"}], "2"], " ", "*", 
         RowBox[{"3", "/", "2"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"th0", ",", "0.001", ",", "0.8"}], "}"}]}], "]"}]}], "}"}], 
    "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"imax", ",", "2", ",", "8", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656763498881675*^9, 3.656763563761545*^9}, {3.656764022285798*^9, 
   3.6567640722377234`*^9}, {3.6567641385755663`*^9, 3.656764169505045*^9}, {
   3.656768051021558*^9, 3.6567681158860693`*^9}, {3.657018306226276*^9, 
   3.6570183207868233`*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{"{", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"kkevaltab3", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "All", ",", "All", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "2"}], ",", "i"}], "}"}]}], 
            "\[RightDoubleBracket]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "imax", ",", "imax"}], "}"}]}], "]"}], ",", 
         "2"}], "]"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "5"}], " ", 
           RowBox[{"10", "^", 
            RowBox[{"-", "11"}]}]}], ",", 
          RowBox[{"5", " ", 
           RowBox[{"10", "^", 
            RowBox[{"-", "11"}]}]}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<num\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], 
         "}"}]}]}], "]"}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"imax", ",", "2", ",", "8", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656659822588427*^9, 3.656659868606267*^9}, {
   3.6566600199376287`*^9, 3.6566600238095407`*^9}, {3.656660082868354*^9, 
   3.6566601001799107`*^9}, {3.656660198441248*^9, 3.6566602975285597`*^9}, 
   3.656660342218131*^9, {3.656660520493788*^9, 3.656660540862773*^9}, {
   3.656660704737803*^9, 3.65666075792381*^9}, {3.656661305888837*^9, 
   3.6566613994984007`*^9}, {3.6566615582028522`*^9, 3.656661576008003*^9}, 
   3.6566616340744963`*^9, {3.656661722283216*^9, 3.6566617232264423`*^9}, {
   3.656661946063757*^9, 3.656661948270748*^9}, {3.6566621387729893`*^9, 
   3.6566621421863813`*^9}, {3.656662265560371*^9, 3.656662283255166*^9}, 
   3.656664239765699*^9, {3.656664487099196*^9, 3.656664507660406*^9}, {
   3.656666290678088*^9, 3.656666421720305*^9}, {3.656666455097412*^9, 
   3.6566664634979477`*^9}, 3.656666557279931*^9, {3.656669524466077*^9, 
   3.656669532224903*^9}, {3.656669618579876*^9, 3.656669622275511*^9}, {
   3.65667188666568*^9, 3.656671890152079*^9}, 3.656673027348681*^9, {
   3.656674634599676*^9, 3.656674635181087*^9}, {3.656674703851719*^9, 
   3.656674704187172*^9}, {3.6566747636610518`*^9, 3.656674828990264*^9}, {
   3.65667615081364*^9, 3.656676163562245*^9}, {3.6566763024493723`*^9, 
   3.656676425539966*^9}, 3.656676461093787*^9, {3.6567604462493267`*^9, 
   3.6567606313403893`*^9}, {3.656761256700198*^9, 3.656761283037958*^9}, {
   3.6567613182535343`*^9, 3.656761318415782*^9}, 3.656761863130072*^9, {
   3.6567622203228903`*^9, 3.6567622388507357`*^9}, 3.6567628961305656`*^9, {
   3.65676307274284*^9, 3.656763079078537*^9}, 3.65676316122435*^9, {
   3.656763498881675*^9, 3.656763563761545*^9}, {3.656764022285798*^9, 
   3.6567640722377234`*^9}, {3.6567641385755663`*^9, 3.656764169505045*^9}, {
   3.656768051021558*^9, 3.6567681158860693`*^9}, {3.6567689941640253`*^9, 
   3.656769094421114*^9}, {3.656769125590663*^9, 3.656769147238937*^9}, {
   3.657014620794468*^9, 3.6570146386316833`*^9}, {3.657014934913113*^9, 
   3.6570149557291107`*^9}, {3.6570183452506113`*^9, 3.65701842823665*^9}, {
   3.6570189626899977`*^9, 3.6570189668929996`*^9}, {3.6570203093929453`*^9, 
   3.657020439753717*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"kkevaltab3", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "4"}], "}"}]}], "\[RightDoubleBracket]"}], 
     ",", "2"}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "5"}], "  ", 
       RowBox[{"10", "^", 
        RowBox[{"-", "11"}]}]}], ",", 
      RowBox[{"5", " ", 
       RowBox[{"10", "^", 
        RowBox[{"-", "11"}]}]}]}], "}"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<num\>\"", ",", "\"\<omega^2 (mode imax)\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6570224726462727`*^9, 3.657022486004836*^9}, {
  3.6576261886611347`*^9, 3.657626224916698*^9}}],

Cell[BoxData[
 RowBox[{"kkevaltab3", "\[LeftDoubleBracket]", 
  RowBox[{"All", ",", "All", ",", "All", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "4"}], "}"}]}], 
  "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.657015003665708*^9, 3.6570150090258636`*^9}, {
   3.657015176310462*^9, 3.657015191975572*^9}, {3.6570153833888273`*^9, 
   3.6570153899798317`*^9}, {3.6570155273107023`*^9, 3.6570155279666033`*^9}, 
   3.6570184430773897`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Normal kink", "Section",
 CellChangeTimes->{{3.647767685413319*^9, 3.6477676891578608`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]wobbler=\>\"", ",", 
    RowBox[{"thwob", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"a", "/", 
        RowBox[{"(", 
         RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]spinner=\>\"", ",", 
    RowBox[{"thspin", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       SqrtBox[
        RowBox[{"a", "/", "r"}]], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{
      RowBox[{"Re", "@", "thwob"}], "-", "0.1"}]}]}], "]"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "0.1"}], " ", "for", " ", "kans"}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "0.4"}], " ", "for"}], " ", "..."}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<width=\>\"", ",", "width"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.65805486939037*^9, 3.658054870407029*^9}, {
   3.658054930541768*^9, 3.6580549502179747`*^9}, {3.658055018123505*^9, 
   3.658055056288397*^9}, {3.658055358339574*^9, 3.658055359442484*^9}, {
   3.65848445766775*^9, 3.65848445825845*^9}, 3.6587643420633507`*^9, 
   3.66115029355128*^9, 3.661151432296154*^9, {3.674823752688033*^9, 
   3.6748237676992073`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "60"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", "\[Equal]", "1"}], "||", 
          RowBox[{"i", "==", "num"}]}], ",", "10000.", ",", "1."}], "]"}]}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kpos", "=", "0.85"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"modenum", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0"}], ";"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, {3.650367826499136*^9, 3.650367851219644*^9}, {
   3.6503679372860622`*^9, 3.6503679756384087`*^9}, {3.65036809583464*^9, 
   3.650368096573086*^9}, {3.65036836843544*^9, 3.6503683691946993`*^9}, {
   3.65036929701457*^9, 3.6503692977331142`*^9}, {3.650369535195619*^9, 
   3.650369536018444*^9}, {3.6505300688521433`*^9, 3.6505300695586357`*^9}, {
   3.650546400520092*^9, 3.650546401432098*^9}, {3.6505465894377537`*^9, 
   3.650546589868441*^9}, {3.650646555599687*^9, 3.650646556591234*^9}, {
   3.6506468167904987`*^9, 3.650646817477148*^9}, {3.658753652709051*^9, 
   3.658753653684366*^9}, {3.6587538218658457`*^9, 3.658753822056353*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"3.", "/", "v0"}], "+", "1.5"}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";", "Calpts",
       ";", "K", ";", 
      RowBox[{
      "KShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "3.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{"ketime", " ", "plot", " ", "on", " ", "this"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kans", "=", "ans"}], ";"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, 3.650367826499136*^9, {3.650368008761181*^9, 
   3.650368012951644*^9}, {3.650368077609385*^9, 3.650368103594091*^9}, {
   3.650368144157481*^9, 3.65036834283071*^9}, {3.650369288613162*^9, 
   3.650369344949712*^9}, {3.650369544315989*^9, 3.650369573469228*^9}, {
   3.6506462790683317`*^9, 3.650646490594308*^9}, {3.6506467720371532`*^9, 
   3.650646790069803*^9}, {3.6506508728539343`*^9, 3.650650873061809*^9}, 
   3.65065275784886*^9, 3.650654403081502*^9, {3.650694909737213*^9, 
   3.650694917033266*^9}, {3.6506950341199837`*^9, 3.650695034665513*^9}, {
   3.65069605058239*^9, 3.6506960772980833`*^9}, {3.650696217747418*^9, 
   3.650696275675215*^9}, {3.6579639736184683`*^9, 3.65796398712289*^9}, {
   3.6579640223405743`*^9, 3.6579640264436398`*^9}, {3.657964220329693*^9, 
   3.657964220551999*^9}, 3.65796473627703*^9, {3.657965073804927*^9, 
   3.6579650772272387`*^9}}],

Cell[BoxData[{
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vAtable1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tfinal", "=", 
         RowBox[{
          RowBox[{"14.", "/", "v0"}], "+", "1.5"}]}], ";", 
        RowBox[{"tinterval", "=", 
         RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";", 
        "Calpts", ";", "K", ";", 
        RowBox[{
        "KShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ";"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"ldef", ",", 
         RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"v0", ",", "5.", ",", "80.", ",", "5."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thnumx", ",", 
         RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"kkdef", ",", "100.", ",", "2000.", ",", "200."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Mdef", ",", 
         RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"v0", ",", "kkdef"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, 3.650367826499136*^9, {3.650368008761181*^9, 
   3.650368012951644*^9}, {3.650368077609385*^9, 3.650368103594091*^9}, {
   3.650368144157481*^9, 3.6503683653267517`*^9}, {3.650543486564007*^9, 
   3.65054350391494*^9}, {3.650543932207713*^9, 3.650543936877412*^9}, 
   3.6506459329758453`*^9, {3.6506481692716846`*^9, 3.650648260744062*^9}, 
   3.650648453072363*^9, {3.650648865706971*^9, 3.6506489031284237`*^9}, {
   3.650648952153096*^9, 3.650648957066135*^9}, {3.650650871622944*^9, 
   3.650650871829845*^9}, 3.65065276029391*^9, 3.650654417612135*^9, 
   3.650654460491041*^9, {3.658751758617841*^9, 3.6587517669520617`*^9}}],

Cell[BoxData[{
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vAtable1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tfinal", "=", 
         RowBox[{
          RowBox[{"12.", "/", "v0"}], "+", "1.5"}]}], ";", 
        RowBox[{"tinterval", "=", 
         RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";", 
        "Calpts", ";", "K", ";", 
        RowBox[{
        "KShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ";"}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"ldef", ",", 
         RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"v0", ",", "1.", ",", "20.", ",", "1."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thnumx", ",", 
         RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"kkdef", ",", 
         RowBox[{"{", "50.", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Mdef", ",", 
         RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"v0", ",", "kkdef"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, {
   3.649596506835799*^9, 3.649596538453498*^9}, {3.6495967057411222`*^9, 
   3.649596726280738*^9}, {3.649596769755097*^9, 3.649596796347262*^9}, {
   3.649596841230296*^9, 3.6495968780169153`*^9}, {3.649596981747072*^9, 
   3.649596985438973*^9}, {3.649597042069368*^9, 3.6495970937895927`*^9}, 
   3.6501874769613733`*^9, 3.65018754244792*^9, {3.650278503707355*^9, 
   3.650278520113451*^9}, 3.650367826499136*^9, {3.650368008761181*^9, 
   3.650368012951644*^9}, {3.650368077609385*^9, 3.650368103594091*^9}, {
   3.650368144157481*^9, 3.6503683653267517`*^9}, {3.650543486564007*^9, 
   3.65054350391494*^9}, {3.650543932207713*^9, 3.650543936877412*^9}, 
   3.6506459329758453`*^9, {3.6506481692716846`*^9, 3.650648260744062*^9}, 
   3.650648453072363*^9, {3.650648865706971*^9, 3.6506489031284237`*^9}, {
   3.650648952153096*^9, 3.650648957066135*^9}, {3.650650871622944*^9, 
   3.650650871829845*^9}, 3.65065276029391*^9, 3.650654417612135*^9, 
   3.650654460491041*^9, {3.658750899414794*^9, 3.658750935043943*^9}, {
   3.65875096835882*^9, 3.658751036230472*^9}, {3.6587523821215153`*^9, 
   3.6587523987271357`*^9}, {3.658752432008944*^9, 3.658752446857377*^9}, {
   3.658753470561646*^9, 3.658753472497636*^9}, 3.6587548536655197`*^9, {
   3.6587551224260693`*^9, 3.658755136535059*^9}, {3.65875657092062*^9, 
   3.6587566114183826`*^9}, {3.658757365403597*^9, 3.65875737280582*^9}}],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"MakeSSHpicvec2", "[", 
    RowBox[{"initialold", ",", "r", ",", 
     RowBox[{
      RowBox[{"-", "0.3"}], "v"}]}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
       "sign"}], ",", " ", 
      RowBox[{"use", " ", "-", " ", 
       RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6478661458207817`*^9, 3.6478661507956038`*^9}, {
  3.65875110663247*^9, 3.6587511260253696`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable1", "\[LeftDoubleBracket]", 
   RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
   "\[RightDoubleBracket]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"PlotLabel", "\[Rule]", "None"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.65069507507869*^9, 3.650695081383031*^9}, {
  3.6506951737220173`*^9, 3.650695175257904*^9}, {3.650695237372136*^9, 
  3.6506952583469048`*^9}}],

Cell[CellGroupData[{

Cell["profile plot: transmit", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}, {3.658763892179221*^9, 3.6587638935230007`*^9}, {
   3.658764223851069*^9, 3.658764227754445*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2."}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";", "Calpts",
       ";", "K", ";", 
      RowBox[{
      "KShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "5.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "1000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.651568985549329*^9, 3.651568985964411*^9}, {
   3.651569100834303*^9, 3.651569117857082*^9}, {3.6587627315776978`*^9, 
   3.6587627372107553`*^9}, {3.658762820475995*^9, 3.658762844955386*^9}, 
   3.6587628909758472`*^9, {3.658762928033031*^9, 3.658762930851038*^9}, 
   3.658763101485449*^9, {3.658763633104371*^9, 3.658763659665091*^9}, {
   3.6587642344927883`*^9, 3.658764240171351*^9}, {3.658764310688342*^9, 
   3.6587643321293907`*^9}, 3.658764447731525*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vpk", "=", 
   RowBox[{"{", 
    RowBox[{"1.1781970048450143`", ",", 
     RowBox[{"-", "1.7668485006007881`"}], ",", "2.634406611307181`"}], 
    "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.658763710071368*^9, 3.658763728640568*^9}, 
   3.658764142426567*^9, {3.6587646069806643`*^9, 3.658764656282075*^9}, {
   3.658764827244616*^9, 3.65876482807259*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vp", "=", 
   RowBox[{
    RowBox[{"Options", "[", 
     RowBox[{"ListPointPlot3D", ",", "ViewPoint"}], "]"}], 
    "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pts3d", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"k$transmit$profile", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{"pts3d", ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "19"}], "]"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "0", ",", "0.2"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Impurity\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.2", ",", "2.3"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2.1", ",", "2."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1.8", ",", "1.55"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Incident kink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.5"}], ",", 
             RowBox[{"-", "3.35"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.3", ",", 
              RowBox[{"-", "3.05"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", 
              RowBox[{"-", "2.35"}]}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Transmitted kink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.1", ",", "3.25"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1.0", ",", "3.05"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.7", ",", "2.35"}], "}"}]}], "}"}], "]"}]}], "}"}]}]}],
      "]"}], ",", 
    RowBox[{"Graphics3D", "@", 
     RowBox[{"Line", "@", "pts3d"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", "vpk"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.6587628514394293`*^9, 
   3.658762851772561*^9}, {3.658763734963511*^9, 3.658763784546248*^9}, 
   3.658763923590782*^9, {3.658764084635284*^9, 3.658764092491371*^9}, {
   3.658764199966485*^9, 3.6587642007973957`*^9}, 3.6587642865736094`*^9, {
   3.658764556886454*^9, 3.6587645600191317`*^9}, {3.658764664618174*^9, 
   3.658764665062415*^9}, {3.6587648340575333`*^9, 3.658764834344833*^9}, {
   3.65876493137728*^9, 3.658764932391618*^9}, {3.661151444521315*^9, 
   3.661151450424057*^9}, {3.66410914268073*^9, 3.6641093300271997`*^9}, {
   3.6641094138263597`*^9, 3.664109455851001*^9}, {3.664109663873576*^9, 
   3.6641099429175863`*^9}, {3.66411006872255*^9, 3.6641101285604343`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<k-transmit-utn.pdf\>\"", ",", "k$transmit$profile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9, {
   3.6587637948023863`*^9, 3.658763814508936*^9}, {3.65876427945471*^9, 
   3.658764285071579*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["split", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}, {3.658763892179221*^9, 3.6587638935230007`*^9}, {
   3.658764257963505*^9, 3.6587642596299562`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2."}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent5", ";", "Calpts",
       ";", "K", ";", 
      RowBox[{
      "KShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "12.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "100.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.651568985549329*^9, 3.651568985964411*^9}, {
   3.651569100834303*^9, 3.651569117857082*^9}, {3.6587627315776978`*^9, 
   3.6587627372107553`*^9}, {3.658762820475995*^9, 3.658762844955386*^9}, 
   3.6587628909758472`*^9, {3.658762928033031*^9, 3.658762930851038*^9}, 
   3.658763101485449*^9, {3.658763633104371*^9, 3.658763659665091*^9}, {
   3.6587642370042877`*^9, 3.658764244204216*^9}, {3.658764679717317*^9, 
   3.658764715161663*^9}, 3.65876485262251*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vp", "=", 
   RowBox[{
    RowBox[{"Options", "[", 
     RowBox[{"ListPointPlot3D", ",", "ViewPoint"}], "]"}], 
    "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pts3d", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"k$split$profile", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{"pts3d", ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "19"}], "]"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "0", ",", "0.2"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Impurity, Trapped antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.4", ",", "2.4"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1.8", ",", "2.25"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1.5", ",", "1.95"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Incident kink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", 
             RowBox[{"-", "1.75"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.7", ",", 
              RowBox[{"-", "1.65"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.55", ",", 
              RowBox[{"-", "1.15"}]}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Transmitted kink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.2"}], ",", "2.55"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", "2.35"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.3", ",", "1.85"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Reflected kink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.7", ",", "1.85"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2.7", ",", "1.65"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1.9", ",", "0.95"}], "}"}]}], "}"}], "]"}]}], "}"}]}]}],
      "]"}], ",", 
    RowBox[{"Graphics3D", "@", 
     RowBox[{"Line", "@", "pts3d"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", "vpk"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.6587628514394293`*^9, 
   3.658762851772561*^9}, {3.658763734963511*^9, 3.658763784546248*^9}, 
   3.658763923590782*^9, {3.658764084635284*^9, 3.658764092491371*^9}, {
   3.658764199966485*^9, 3.6587642007973957`*^9}, {3.658764262621437*^9, 
   3.658764266204206*^9}, {3.658764767820959*^9, 3.6587647719610767`*^9}, {
   3.658764818877326*^9, 3.6587648193058*^9}, {3.6587649163652267`*^9, 
   3.658764917429495*^9}, {3.6611514691609383`*^9, 3.661151469255952*^9}, {
   3.6641738953515778`*^9, 3.664174444338114*^9}, {3.66418298865259*^9, 
   3.664182998840136*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<k-split-utn.pdf\>\"", ",", "k$split$profile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "800"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9, {
   3.6587637948023863`*^9, 3.658763814508936*^9}, {3.65876426148454*^9, 
   3.6587642769876328`*^9}, {3.661149830177545*^9, 3.661149830561977*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Anti-kink generator", "Section",
 CellChangeTimes->{{3.647767685413319*^9, 3.6477676891578608`*^9}, {
   3.647866037288169*^9, 3.647866046199132*^9}, 3.664183297822527*^9}],

Cell[CellGroupData[{

Cell["Setting", "Subsubsection",
 CellChangeTimes->{{3.650348394011422*^9, 3.650348394939036*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]wobbler=\>\"", ",", 
    RowBox[{"thwob", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"a", "/", 
        RowBox[{"(", 
         RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]spinner=\>\"", ",", 
    RowBox[{"thspin", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       SqrtBox[
        RowBox[{"a", "/", "r"}]], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{
      RowBox[{"Re", "@", "thwob"}], "-", "0.1"}]}]}], "]"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "0.1"}], " ", "for", " ", "akans"}], ",", " ", 
    RowBox[{
     RowBox[{"-", "0.4"}], " ", "for"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<width=\>\"", ",", "width"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.65805486939037*^9, 3.658054870407029*^9}, {
   3.658054930541768*^9, 3.6580549502179747`*^9}, {3.658055018123505*^9, 
   3.658055056288397*^9}, {3.658055358339574*^9, 3.658055359442484*^9}, {
   3.65848445766775*^9, 3.65848445825845*^9}, 3.658763614814432*^9, 
   3.661150312724345*^9, 3.66115121430634*^9, {3.664183683300119*^9, 
   3.6641837083747272`*^9}, {3.674823777008156*^9, 3.6748237863358917`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.65805495487577*^9, 3.658054955368101*^9}, 
   3.65805502333799*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"theta", "[", "lz_", "]"}], ":=", 
  RowBox[{"ArcCos", "[", 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"lz", "^", "2"}], "-", 
       RowBox[{"a", "^", "2"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"4", 
       RowBox[{"r", "^", "2"}]}], ")"}]}]], "]"}]}]], "Input",
 CellChangeTimes->{{3.6587631658252163`*^9, 3.658763232294694*^9}}],

Cell[BoxData[
 RowBox[{"theta", "[", "1.83604", "]"}]], "Input",
 CellChangeTimes->{{3.658763235645595*^9, 3.658763259173573*^9}, 
   3.658763365062991*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "60"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{
        RowBox[{"i", "\[Equal]", "1"}], "||", 
        RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True", 
       ",", "1."}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akpos", "=", 
   RowBox[{"80", "/", "100"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vdirection", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0."}], ";"}]}], "Input",
 CellChangeTimes->{{3.650348591794373*^9, 3.650348615469857*^9}, {
   3.6503488211922817`*^9, 3.6503488224798594`*^9}, {3.6503493116672907`*^9, 
   3.650349312606909*^9}, {3.6503496016567917`*^9, 3.650349606311892*^9}, {
   3.650349805613688*^9, 3.650349806403479*^9}, {3.650349896655484*^9, 
   3.650349897471259*^9}, {3.650652326568606*^9, 3.650652327447179*^9}, {
   3.650656432233664*^9, 3.650656432803163*^9}, {3.650695801770853*^9, 
   3.650695814855343*^9}, {3.650695856763914*^9, 3.650695856795198*^9}, {
   3.6506959143507338`*^9, 3.650695914441492*^9}, {3.650696326659938*^9, 
   3.650696331622074*^9}, {3.650717170628542*^9, 3.650717230098461*^9}, 
   3.650717474628593*^9, {3.6507175700346518`*^9, 3.650717571509801*^9}, {
   3.650866494597803*^9, 3.6508665528379307`*^9}, {3.650868885487459*^9, 
   3.650868911070134*^9}, {3.6508689828648567`*^9, 3.650868983679718*^9}, {
   3.650869195605877*^9, 3.650869254378772*^9}, {3.650890054936273*^9, 
   3.650890055036913*^9}, {3.6508901453221483`*^9, 3.650890146200918*^9}, {
   3.650890221371496*^9, 3.6508902214704742`*^9}, {3.65156759021988*^9, 
   3.651567621259502*^9}, {3.651568016743775*^9, 3.6515680171097183`*^9}, 
   3.651568074104039*^9, {3.651568956539568*^9, 3.651568957163229*^9}, {
   3.6515690518561497`*^9, 3.651569052289019*^9}, {3.6580514897691383`*^9, 
   3.6580514987755117`*^9}, {3.658051533338551*^9, 3.658051543113666*^9}, {
   3.658052021221784*^9, 3.65805205698139*^9}, {3.6580565450709343`*^9, 
   3.658056546957734*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["test1", "Subsubsection",
 CellChangeTimes->{{3.650873247603793*^9, 3.65087324941016*^9}, 
   3.658051460694345*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1.0"}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "400"}]}], ";", "tableContent4", ";", "Calpts", 
      ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "3.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{"ketime", " ", "plot", " ", "on", " ", "this"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akans", "=", "ans"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490808337229233`*^9, 3.649080840443883*^9}, {3.649080898509109*^9, 
   3.649081035697353*^9}, {3.649081066480082*^9, 3.649081066585156*^9}, {
   3.649419799424335*^9, 3.649419816685089*^9}, {3.6494205496355667`*^9, 
   3.649420580162203*^9}, {3.6494206852713547`*^9, 3.6494206868914957`*^9}, {
   3.649420791256592*^9, 3.6494208004235067`*^9}, {3.649420841497678*^9, 
   3.649420858521541*^9}, {3.649420960110087*^9, 3.6494209659816427`*^9}, {
   3.649421000462985*^9, 3.6494210267665358`*^9}, {3.649421107345009*^9, 
   3.64942112457437*^9}, {3.649421163041647*^9, 3.64942117212182*^9}, {
   3.6496572744163847`*^9, 3.6496573426677227`*^9}, {3.649657398080855*^9, 
   3.6496574060747957`*^9}, {3.649657478748437*^9, 3.6496574984617443`*^9}, {
   3.6496576187341757`*^9, 3.649657688622156*^9}, {3.649657723408523*^9, 
   3.64965772774376*^9}, {3.649657763328312*^9, 3.649657767856086*^9}, {
   3.6496578222405357`*^9, 3.649657836738044*^9}, {3.6496579413170347`*^9, 
   3.649657948388825*^9}, 3.649658194122944*^9, 3.6496582865390797`*^9, {
   3.649658719671151*^9, 3.649658722756599*^9}, {3.649658776231144*^9, 
   3.6496587763092537`*^9}, {3.6496589585073557`*^9, 3.64965898505567*^9}, {
   3.650196578354272*^9, 3.6501965861443253`*^9}, {3.650200170632333*^9, 
   3.650200214598452*^9}, {3.6502010123133907`*^9, 3.650201013351956*^9}, {
   3.650206554714987*^9, 3.650206567133321*^9}, 3.6502068682902727`*^9, {
   3.6503448873524933`*^9, 3.650344903320059*^9}, 3.6506247704825087`*^9, {
   3.650648947161413*^9, 3.6506489478962317`*^9}, {3.650652009071665*^9, 
   3.650652014095744*^9}, 3.650652779270048*^9, {3.650653373700645*^9, 
   3.650653373973507*^9}, {3.6506564484613733`*^9, 3.650656471385913*^9}, 
   3.650656686229624*^9, {3.6506886933702*^9, 3.650688696937594*^9}, {
   3.650689260826091*^9, 3.6506892625512333`*^9}, {3.650695541011499*^9, 
   3.65069556254792*^9}, 3.650695618437995*^9, {3.6506958639461403`*^9, 
   3.650695864649091*^9}, {3.650696013294015*^9, 3.6506960302935123`*^9}, {
   3.650696313502487*^9, 3.650696339753173*^9}, 3.650717176829062*^9, {
   3.650717266835062*^9, 3.650717285376308*^9}, {3.6508665661087513`*^9, 
   3.650866585235654*^9}, {3.650868888399592*^9, 3.650868893821947*^9}, {
   3.6508689887331667`*^9, 3.650869018498541*^9}, {3.650869088015077*^9, 
   3.650869098819944*^9}, {3.650873288454797*^9, 3.650873327702129*^9}, {
   3.650873576239091*^9, 3.650873579899695*^9}, 3.650873956726375*^9, {
   3.65089006338419*^9, 3.6508901013093443`*^9}, 3.65089016623668*^9, {
   3.650890210684455*^9, 3.650890217626141*^9}, {3.650892671224133*^9, 
   3.650892704182242*^9}, {3.651558136175522*^9, 3.651558150402191*^9}, {
   3.651558186304216*^9, 3.6515581880317917`*^9}, {3.6515582727085342`*^9, 
   3.651558296245757*^9}, {3.651558384836454*^9, 3.651558402434572*^9}, {
   3.651558491140912*^9, 3.651558492868479*^9}, {3.6515585229178677`*^9, 
   3.651558524052744*^9}, {3.651558574279922*^9, 3.6515585777020893`*^9}, {
   3.651559105028664*^9, 3.651559126003091*^9}, {3.651560601862566*^9, 
   3.651560617958995*^9}, {3.65156742192775*^9, 3.651567422099751*^9}, {
   3.651567579675009*^9, 3.651567581771307*^9}, 3.6515696757019873`*^9, 
   3.657962147177065*^9, {3.6579640020991297`*^9, 3.65796401765158*^9}, {
   3.657964629539805*^9, 3.657964629745384*^9}, 3.657964711238708*^9, {
   3.657965046891326*^9, 3.657965056779372*^9}}],

Cell[BoxData[
 RowBox[{"vAtable1", "/.", 
  RowBox[{"PlotLabel", "\[Rule]", "None"}]}]], "Input",
 CellChangeTimes->{{3.650695669692007*^9, 3.650695683315943*^9}, 
   3.6580514425867662`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["test2 long auto-dissipate trap", "Subsubsection",
 CellChangeTimes->{{3.650873247603793*^9, 3.65087324941016*^9}, {
   3.658051460694345*^9, 3.658051477097578*^9}, 3.658056821091488*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]wobbler=\>\"", ",", 
    RowBox[{"thwob", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"a", "/", 
        RowBox[{"(", 
         RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Theta]spinner=\>\"", ",", 
    RowBox[{"thspin", "=", 
     RowBox[{"N", "[", 
      RowBox[{"ArcSin", "[", 
       SqrtBox[
        RowBox[{"a", "/", "r"}]], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<th0=\>\"", ",", 
    RowBox[{"th0", "=", 
     RowBox[{
      RowBox[{"Re", "@", "thwob"}], "-", "0.1"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lzerosq", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<lzero=\>\"", ",", 
    RowBox[{"lzero", "=", 
     SuperscriptBox["lzerosq", 
      RowBox[{"1", "/", "2"}]]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<width=\>\"", ",", "width"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.65805486939037*^9, 3.658054870407029*^9}, {
   3.658054930541768*^9, 3.6580549502179747`*^9}, {3.658055018123505*^9, 
   3.658055056288397*^9}, {3.658055358339574*^9, 3.658055359442484*^9}, {
   3.6584844764318027`*^9, 3.658484477041028*^9}, 3.658500164750927*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "60"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"endstart", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"kk", "[", "i", "]"}], "=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", "i", "]"}], "=", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
       RowBox[{
        RowBox[{"i", "\[Equal]", "1"}], "||", 
        RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True", 
       ",", "1."}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akpos", "=", 
   RowBox[{"80", "/", "100"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vdirection", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akgoleft", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mute", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunVelQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixmodeQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Eta]", "=", "0."}], ";"}]}], "Input",
 CellChangeTimes->{{3.650348591794373*^9, 3.650348615469857*^9}, {
   3.6503488211922817`*^9, 3.6503488224798594`*^9}, {3.6503493116672907`*^9, 
   3.650349312606909*^9}, {3.6503496016567917`*^9, 3.650349606311892*^9}, {
   3.650349805613688*^9, 3.650349806403479*^9}, {3.650349896655484*^9, 
   3.650349897471259*^9}, {3.650652326568606*^9, 3.650652327447179*^9}, {
   3.650656432233664*^9, 3.650656432803163*^9}, {3.650695801770853*^9, 
   3.650695814855343*^9}, {3.650695856763914*^9, 3.650695856795198*^9}, {
   3.6506959143507338`*^9, 3.650695914441492*^9}, {3.650696326659938*^9, 
   3.650696331622074*^9}, {3.650717170628542*^9, 3.650717230098461*^9}, 
   3.650717474628593*^9, {3.6507175700346518`*^9, 3.650717571509801*^9}, {
   3.650866494597803*^9, 3.6508665528379307`*^9}, {3.650868885487459*^9, 
   3.650868911070134*^9}, {3.6508689828648567`*^9, 3.650868983679718*^9}, {
   3.650869195605877*^9, 3.650869254378772*^9}, {3.650890054936273*^9, 
   3.650890055036913*^9}, {3.6508901453221483`*^9, 3.650890146200918*^9}, {
   3.650890221371496*^9, 3.6508902214704742`*^9}, {3.65156759021988*^9, 
   3.651567621259502*^9}, {3.651568016743775*^9, 3.6515680171097183`*^9}, 
   3.651568074104039*^9, {3.651568956539568*^9, 3.651568957163229*^9}, {
   3.6515690518561497`*^9, 3.651569052289019*^9}, {3.6580514897691383`*^9, 
   3.6580514987755117`*^9}, {3.658051533338551*^9, 3.658051543113666*^9}, {
   3.658052021221784*^9, 3.65805205698139*^9}, {3.6580565450709343`*^9, 
   3.658056546957734*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vAtable1", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tfinal", "=", "1"}], ";", 
       RowBox[{"tinterval", "=", 
        RowBox[{"tfinal", "/", "2"}]}], ";", "tableContent4", ";"}], ",", 
      RowBox[{"{", 
       RowBox[{"ldef", ",", 
        RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"v0", ",", 
        RowBox[{"{", "0", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"thnumx", ",", 
        RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"kkdef", ",", 
        RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdef", ",", 
        RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", "Relax", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rerunConfigQ", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"reinitialtab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ans", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"reanstab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      FractionBox["\[Pi]", "2"], "-", 
      RowBox[{
       RowBox[{"ans", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "50"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "400"}]}], ";", "tableContent4", ";", "Calpts", 
      ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      ";"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "1.36928", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490808337229233`*^9, 3.649080840443883*^9}, {3.649080898509109*^9, 
   3.649081035697353*^9}, {3.649081066480082*^9, 3.649081066585156*^9}, {
   3.649419799424335*^9, 3.649419816685089*^9}, {3.6494205496355667`*^9, 
   3.649420580162203*^9}, {3.6494206852713547`*^9, 3.6494206868914957`*^9}, {
   3.649420791256592*^9, 3.6494208004235067`*^9}, {3.649420841497678*^9, 
   3.649420858521541*^9}, {3.649420960110087*^9, 3.6494209659816427`*^9}, {
   3.649421000462985*^9, 3.6494210267665358`*^9}, {3.649421107345009*^9, 
   3.64942112457437*^9}, {3.649421163041647*^9, 3.64942117212182*^9}, {
   3.6496572744163847`*^9, 3.6496573426677227`*^9}, {3.649657398080855*^9, 
   3.6496574060747957`*^9}, {3.649657478748437*^9, 3.6496574984617443`*^9}, {
   3.6496576187341757`*^9, 3.649657688622156*^9}, {3.649657723408523*^9, 
   3.64965772774376*^9}, {3.649657763328312*^9, 3.649657767856086*^9}, {
   3.6496578222405357`*^9, 3.649657836738044*^9}, {3.6496579413170347`*^9, 
   3.649657948388825*^9}, 3.649658194122944*^9, 3.6496582865390797`*^9, {
   3.649658719671151*^9, 3.649658722756599*^9}, {3.649658776231144*^9, 
   3.6496587763092537`*^9}, {3.6496589585073557`*^9, 3.64965898505567*^9}, {
   3.650196578354272*^9, 3.6501965861443253`*^9}, {3.650200170632333*^9, 
   3.650200214598452*^9}, {3.6502010123133907`*^9, 3.650201013351956*^9}, {
   3.650206554714987*^9, 3.650206567133321*^9}, 3.6502068682902727`*^9, {
   3.6503448873524933`*^9, 3.650344903320059*^9}, 3.6506247704825087`*^9, {
   3.650648947161413*^9, 3.6506489478962317`*^9}, {3.650652009071665*^9, 
   3.650652014095744*^9}, 3.650652779270048*^9, {3.650653373700645*^9, 
   3.650653373973507*^9}, {3.6506564484613733`*^9, 3.650656471385913*^9}, 
   3.650656686229624*^9, {3.6506886933702*^9, 3.650688696937594*^9}, {
   3.650689260826091*^9, 3.6506892625512333`*^9}, {3.650695541011499*^9, 
   3.65069556254792*^9}, 3.650695618437995*^9, {3.6506958639461403`*^9, 
   3.650695864649091*^9}, {3.650696013294015*^9, 3.6506960302935123`*^9}, {
   3.650696313502487*^9, 3.650696339753173*^9}, 3.650717176829062*^9, {
   3.650717266835062*^9, 3.650717285376308*^9}, {3.6508665661087513`*^9, 
   3.650866585235654*^9}, {3.650868888399592*^9, 3.650868893821947*^9}, {
   3.6508689887331667`*^9, 3.650869018498541*^9}, {3.650869088015077*^9, 
   3.650869098819944*^9}, {3.650873288454797*^9, 3.650873327702129*^9}, {
   3.650873576239091*^9, 3.650873579899695*^9}, 3.650873956726375*^9, {
   3.65089006338419*^9, 3.6508901013093443`*^9}, 3.65089016623668*^9, {
   3.650890210684455*^9, 3.650890217626141*^9}, {3.650892671224133*^9, 
   3.650892704182242*^9}, {3.651558136175522*^9, 3.651558150402191*^9}, {
   3.651558186304216*^9, 3.6515581880317917`*^9}, {3.6515582727085342`*^9, 
   3.651558296245757*^9}, {3.651558384836454*^9, 3.651558402434572*^9}, {
   3.651558491140912*^9, 3.651558492868479*^9}, {3.6515585229178677`*^9, 
   3.651558524052744*^9}, {3.651558574279922*^9, 3.6515585777020893`*^9}, {
   3.651559105028664*^9, 3.651559126003091*^9}, {3.651560601862566*^9, 
   3.651560617958995*^9}, {3.65156742192775*^9, 3.651567422099751*^9}, {
   3.651567579675009*^9, 3.651567581771307*^9}, 3.6515696757019873`*^9, 
   3.657962147177065*^9, {3.6579640020991297`*^9, 3.65796401765158*^9}, {
   3.657964629539805*^9, 3.657964629745384*^9}, 3.657964711238708*^9, {
   3.657965046891326*^9, 3.657965056779372*^9}, {3.658051508920384*^9, 
   3.658051522233437*^9}, {3.6580520366463003`*^9, 3.6580520799579067`*^9}, {
   3.658055298739154*^9, 3.658055343073621*^9}, {3.65805538005439*^9, 
   3.6580554023116083`*^9}, {3.6580554348569183`*^9, 3.658055459416142*^9}, {
   3.658056003570568*^9, 3.65805604166831*^9}, {3.65805620584746*^9, 
   3.658056215894538*^9}, {3.658056289048057*^9, 3.6580563436116753`*^9}, 
   3.658056376635812*^9, {3.658056529089264*^9, 3.658056534577986*^9}, {
   3.658056568242919*^9, 3.658056807862569*^9}, {3.6580568574484386`*^9, 
   3.6580568731897*^9}, {3.6580569119621153`*^9, 3.6580569590684*^9}, 
   3.6641852820630217`*^9}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"i", "=", "1"}], "num"], 
      RowBox[{
       FractionBox[
        RowBox[{"M", "[", "i", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"r", " ", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ans", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", "tt", "]"}], ",", "tt"}], 
           "]"}]}], ")"}], "2"]}]}], "/.", 
     RowBox[{"tt", "\[Rule]", "t"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "tstart", ",", "tfinal", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"tfinal", "-", "tstart"}], ")"}], "/", "60"}]}], "}"}]}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6580516676501837`*^9, 3.658051695196238*^9}, {
  3.6580517655339727`*^9, 3.6580518132332783`*^9}, {3.6580555014664793`*^9, 
  3.658055521925866*^9}, {3.658483779296362*^9, 3.658483838351985*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vpx", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.026091153387754907`"}], ",", 
     RowBox[{"-", "2.459782585412843`"}], ",", "2.323529402485496`"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pts3d", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"akpntrapprofile", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{"pts3d", ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.3"}], ",", "0", ",", "0.3"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Trapped antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.4"}], ",", "4.4"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2.4"}], ",", "3.4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1.5", ",", "1.95"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Incident antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"5.5", ",", 
             RowBox[{"-", "6.65"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"5.5", ",", 
              RowBox[{"-", "6.05"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4.25", ",", 
              RowBox[{"-", "3.55"}]}], "}"}]}], "}"}], "]"}]}], "}"}]}]}], 
     "]"}], ",", 
    RowBox[{"Graphics3D", "@", 
     RowBox[{"Line", "@", "pts3d"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", 
     RowBox[{"Dynamic", "[", "vpx", "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.661151153441835*^9, 
   3.66115117821338*^9}, {3.6641833553159018`*^9, 3.6641833731495647`*^9}, {
   3.66418340981291*^9, 3.664183567699946*^9}, 3.664184220040557*^9, {
   3.6641844040151863`*^9, 3.664184407911476*^9}, 3.6641852630277653`*^9, {
   3.664185298083921*^9, 3.664185298188208*^9}, {3.67888655230394*^9, 
   3.678886553648004*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<akpntrapprofile.pdf\>\"", ",", "akpntrapprofile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["1 perfect k10000", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.6490767358664427`*^9}, {
  3.650201328048716*^9, 3.650201332558324*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1.0"}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      ";"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "10000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490808337229233`*^9, 3.649080840443883*^9}, {3.649080898509109*^9, 
   3.649081035697353*^9}, {3.649081066480082*^9, 3.649081066585156*^9}, {
   3.649419799424335*^9, 3.649419816685089*^9}, {3.6494205496355667`*^9, 
   3.649420580162203*^9}, {3.6494206852713547`*^9, 3.6494206868914957`*^9}, {
   3.649420791256592*^9, 3.6494208004235067`*^9}, {3.649420841497678*^9, 
   3.649420858521541*^9}, {3.649420960110087*^9, 3.6494209659816427`*^9}, {
   3.649421000462985*^9, 3.6494210267665358`*^9}, {3.649421107345009*^9, 
   3.64942112457437*^9}, {3.649421163041647*^9, 3.64942117212182*^9}, {
   3.6496572744163847`*^9, 3.6496573426677227`*^9}, {3.649657398080855*^9, 
   3.6496574060747957`*^9}, {3.649657478748437*^9, 3.6496574984617443`*^9}, {
   3.6496576187341757`*^9, 3.649657688622156*^9}, {3.649657723408523*^9, 
   3.64965772774376*^9}, {3.649657763328312*^9, 3.649657767856086*^9}, {
   3.6496578222405357`*^9, 3.649657836738044*^9}, {3.6496579413170347`*^9, 
   3.649657948388825*^9}, 3.649658194122944*^9, 3.6496582865390797`*^9, {
   3.649658719671151*^9, 3.649658722756599*^9}, {3.649658776231144*^9, 
   3.6496587763092537`*^9}, {3.6496589585073557`*^9, 3.64965898505567*^9}, {
   3.650196578354272*^9, 3.6501965861443253`*^9}, {3.650200170632333*^9, 
   3.650200214598452*^9}, {3.6502010123133907`*^9, 3.650201013351956*^9}, {
   3.650206554714987*^9, 3.650206567133321*^9}, 3.6502068682902727`*^9, {
   3.6503448873524933`*^9, 3.650344903320059*^9}, 3.6506247704825087`*^9, {
   3.650648947161413*^9, 3.6506489478962317`*^9}, {3.650652009071665*^9, 
   3.650652014095744*^9}, 3.650652779270048*^9, {3.650653373700645*^9, 
   3.650653373973507*^9}, {3.6506564484613733`*^9, 3.650656471385913*^9}, 
   3.650656686229624*^9, {3.6506886933702*^9, 3.650688696937594*^9}, {
   3.650689260826091*^9, 3.6506892625512333`*^9}, {3.6515696763224297`*^9, 
   3.6515696900622873`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 soft trap-transmit k 1000", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1.0"}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", "1000.", ",", "9500.", ",", "500."}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.6515696766167297`*^9, 3.651569690772366*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 soft split-reflect k 100", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
  3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
  3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
  3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
  3.649079911522851*^9}, {3.6490816736774*^9, 3.649081693472603*^9}, {
  3.650202115488916*^9, 3.650202119280695*^9}, {3.650202459193636*^9, 
  3.65020245963958*^9}, {3.6502043023081512`*^9, 3.6502043062918997`*^9}, {
  3.650205453294743*^9, 3.650205455774644*^9}, {3.65020564865897*^9, 
  3.6502056618914633`*^9}, {3.6502855911294403`*^9, 3.650285591353159*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1."}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", "100.", ",", "950.", ",", "50."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.650202195123844*^9, 3.65020220288372*^9}, {
   3.650202236010707*^9, 3.650202312119381*^9}, {3.650202451162476*^9, 
   3.650202452968227*^9}, 3.650202652737317*^9, 3.650202745907751*^9, {
   3.650203015767577*^9, 3.650203045750763*^9}, {3.650203157196183*^9, 
   3.650203157304628*^9}, 3.6502032102363987`*^9, {3.6502040064790087`*^9, 
   3.650204096968755*^9}, {3.650204143989497*^9, 3.650204181915056*^9}, 
   3.650204244231349*^9, {3.650204288294277*^9, 3.650204291732313*^9}, {
   3.65020561707563*^9, 3.650205624659175*^9}, {3.6502854722152853`*^9, 
   3.6502854750627003`*^9}, {3.650344941961801*^9, 3.650344949754835*^9}, {
   3.650348826056932*^9, 3.650348837334083*^9}, {3.6503488694487267`*^9, 
   3.650348876600704*^9}, {3.650364022494327*^9, 3.650364057334236*^9}, {
   3.650365998361485*^9, 3.650365998456653*^9}, {3.650624760453076*^9, 
   3.65062476243889*^9}, {3.650656565743433*^9, 3.6506565844600267`*^9}, 
   3.650656682590334*^9, {3.650688718827244*^9, 3.650688722185074*^9}, {
   3.65068926819864*^9, 3.650689270742064*^9}, {3.651569676940757*^9, 
   3.651569692189456*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 soft split-reflect k 10", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
  3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
  3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
  3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
  3.649079911522851*^9}, {3.6490816736774*^9, 3.649081693472603*^9}, {
  3.650202115488916*^9, 3.650202119280695*^9}, {3.650202459193636*^9, 
  3.65020245963958*^9}, {3.6502043023081512`*^9, 3.6502043062918997`*^9}, {
  3.650348526686695*^9, 3.650348527118202*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1."}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", "10.", ",", "95.", ",", "5."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.650202195123844*^9, 3.65020220288372*^9}, {
   3.650202236010707*^9, 3.650202312119381*^9}, {3.650202451162476*^9, 
   3.650202452968227*^9}, 3.650202652737317*^9, 3.650202745907751*^9, {
   3.650203015767577*^9, 3.650203045750763*^9}, {3.650203157196183*^9, 
   3.650203157304628*^9}, 3.6502032102363987`*^9, {3.6502040064790087`*^9, 
   3.650204096968755*^9}, {3.650204143989497*^9, 3.650204181915056*^9}, 
   3.650204244231349*^9, {3.650204288294277*^9, 3.650204291732313*^9}, {
   3.650285534857697*^9, 3.650285537160707*^9}, {3.650344966713826*^9, 
   3.650344974505488*^9}, {3.650348856191451*^9, 3.650348889708857*^9}, 
   3.650364026284926*^9, {3.65036407107069*^9, 3.650364071308758*^9}, {
   3.650365995850173*^9, 3.6503659959510403`*^9}, {3.650624757444004*^9, 
   3.6506247591531887`*^9}, {3.650656593118937*^9, 3.650656607052342*^9}, 
   3.650656678623043*^9, {3.65068872522696*^9, 3.650688728217697*^9}, {
   3.650689272086933*^9, 3.650689273466213*^9}, {3.6515696772987003`*^9, 
   3.651569693394108*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 hard k 11000 -20000", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
  3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
  3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
  3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
  3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
  3.649083840305128*^9, 3.64908384080063*^9}, {3.649411685261795*^9, 
  3.649411687436283*^9}, {3.6495030497213287`*^9, 3.649503051344366*^9}, {
  3.650204983667178*^9, 3.6502050015881357`*^9}, {3.650348540751251*^9, 
  3.65034854148705*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1."}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", "10500.", ",", "20000.", ",", "500."}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.6494117688642273`*^9}, {3.649412124105123*^9, 3.649412125255411*^9}, {
   3.649503055246015*^9, 3.6495030858116693`*^9}, {3.649503116453212*^9, 
   3.649503122082449*^9}, {3.649503194230105*^9, 3.6495032290138083`*^9}, {
   3.649503423036805*^9, 3.6495034441099033`*^9}, {3.649503488172037*^9, 
   3.649503518208927*^9}, {3.6495035548831167`*^9, 3.6495037191192713`*^9}, {
   3.650197848621665*^9, 3.650197849357566*^9}, {3.6502045741896544`*^9, 
   3.650204655853051*^9}, {3.650204756120175*^9, 3.650204774047934*^9}, 
   3.650205045134036*^9, 3.650285637533422*^9, {3.650344989996035*^9, 
   3.6503450207784147`*^9}, {3.650348971725443*^9, 3.6503489746021214`*^9}, {
   3.650360139266899*^9, 3.6503601393669767`*^9}, {3.65036017336304*^9, 
   3.650360175344088*^9}, {3.650364087007544*^9, 3.650364087709889*^9}, {
   3.650624753315489*^9, 3.65062475582812*^9}, {3.650656618668866*^9, 
   3.6506566379339533`*^9}, {3.650656672335799*^9, 3.650656708848927*^9}, {
   3.650688732442937*^9, 3.650688736284669*^9}, {3.650689275350377*^9, 
   3.6506892766943903`*^9}, {3.6515696776169357`*^9, 3.651569695003543*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 hard k 20000 -23000", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.649411685261795*^9, 
   3.649411687436283*^9}, {3.6495030497213287`*^9, 3.649503051344366*^9}, {
   3.650204983667178*^9, 3.6502050015881357`*^9}, {3.650348540751251*^9, 
   3.65034854148705*^9}, {3.65157579345048*^9, 3.651575793561912*^9}, 
   3.651576580906221*^9, {3.6515767707792253`*^9, 3.6515767708004713`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1."}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "1.0", ",", "15", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", "20500.", ",", "23000.", ",", "500."}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.6494117688642273`*^9}, {3.649412124105123*^9, 3.649412125255411*^9}, {
   3.649503055246015*^9, 3.6495030858116693`*^9}, {3.649503116453212*^9, 
   3.649503122082449*^9}, {3.649503194230105*^9, 3.6495032290138083`*^9}, {
   3.649503423036805*^9, 3.6495034441099033`*^9}, {3.649503488172037*^9, 
   3.649503518208927*^9}, {3.6495035548831167`*^9, 3.6495037191192713`*^9}, {
   3.650197848621665*^9, 3.650197849357566*^9}, {3.6502045741896544`*^9, 
   3.650204655853051*^9}, {3.650204756120175*^9, 3.650204774047934*^9}, 
   3.650205045134036*^9, 3.650285637533422*^9, {3.650344989996035*^9, 
   3.6503450207784147`*^9}, {3.650348971725443*^9, 3.6503489746021214`*^9}, {
   3.650360139266899*^9, 3.6503601393669767`*^9}, {3.65036017336304*^9, 
   3.650360175344088*^9}, {3.650364087007544*^9, 3.650364087709889*^9}, {
   3.650624753315489*^9, 3.65062475582812*^9}, {3.650656618668866*^9, 
   3.6506566379339533`*^9}, {3.650656672335799*^9, 3.650656708848927*^9}, {
   3.650688732442937*^9, 3.650688736284669*^9}, {3.650689275350377*^9, 
   3.6506892766943903`*^9}, {3.6515696776169357`*^9, 3.651569695003543*^9}, {
   3.651575800944311*^9, 3.651575840238658*^9}, {3.6515767428207808`*^9, 
   3.6515767531164207`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["2 hard k 7500 resonance", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.649411685261795*^9, 
   3.649411687436283*^9}, {3.6495030497213287`*^9, 3.649503051344366*^9}, {
   3.650204983667178*^9, 3.6502050015881357`*^9}, {3.650348540751251*^9, 
   3.65034854148705*^9}, {3.65157579345048*^9, 3.651575793561912*^9}, 
   3.651576580906221*^9, {3.6515767707792253`*^9, 3.6515767708004713`*^9}, {
   3.6515771253249693`*^9, 3.651577128411367*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", 
       RowBox[{
        RowBox[{"2.", "/", 
         RowBox[{"(", 
          RowBox[{"v0", "-", "0.7"}], ")"}]}], "+", "1."}]}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", "4", ",", "5.5", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "7500.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.6494117688642273`*^9}, {3.649412124105123*^9, 3.649412125255411*^9}, {
   3.649503055246015*^9, 3.6495030858116693`*^9}, {3.649503116453212*^9, 
   3.649503122082449*^9}, {3.649503194230105*^9, 3.6495032290138083`*^9}, {
   3.649503423036805*^9, 3.6495034441099033`*^9}, {3.649503488172037*^9, 
   3.649503518208927*^9}, {3.6495035548831167`*^9, 3.6495037191192713`*^9}, {
   3.650197848621665*^9, 3.650197849357566*^9}, {3.6502045741896544`*^9, 
   3.650204655853051*^9}, {3.650204756120175*^9, 3.650204774047934*^9}, 
   3.650205045134036*^9, 3.650285637533422*^9, {3.650344989996035*^9, 
   3.6503450207784147`*^9}, {3.650348971725443*^9, 3.6503489746021214`*^9}, {
   3.650360139266899*^9, 3.6503601393669767`*^9}, {3.65036017336304*^9, 
   3.650360175344088*^9}, {3.650364087007544*^9, 3.650364087709889*^9}, {
   3.650624753315489*^9, 3.65062475582812*^9}, {3.650656618668866*^9, 
   3.6506566379339533`*^9}, {3.650656672335799*^9, 3.650656708848927*^9}, {
   3.650688732442937*^9, 3.650688736284669*^9}, {3.650689275350377*^9, 
   3.6506892766943903`*^9}, {3.6515696776169357`*^9, 3.651569695003543*^9}, {
   3.651575800944311*^9, 3.651575840238658*^9}, {3.6515767428207808`*^9, 
   3.6515767531164207`*^9}, {3.651577132827943*^9, 3.65157716919707*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Show initial configuration", "Subsubsection",
 CellChangeTimes->{{3.650348576448269*^9, 3.6503485828792257`*^9}}],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"MakeSSHpicvec", "[", 
    RowBox[{"initialold", ",", "r", ",", 
     RowBox[{
      RowBox[{"-", " ", "3"}], "v"}]}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "drawing", " ", "mistakenly", " ", "has", " ", "opposite", " ", 
       "sign"}], ",", " ", 
      RowBox[{"use", " ", "-", " ", 
       RowBox[{"to", " ", "compensate"}]}]}], "*)"}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6478661458207817`*^9, 3.6478661507956038`*^9}, {
   3.647866707728194*^9, 3.647866713658167*^9}, 3.647867980394093*^9, {
   3.649076846265272*^9, 3.649076855400558*^9}, 3.6490769472422743`*^9, {
   3.6490770378379374`*^9, 3.6490770458537283`*^9}, {3.650652427166644*^9, 
   3.650652431475335*^9}, 3.650652475964445*^9, {3.6506957841860313`*^9, 
   3.6506957900251703`*^9}, {3.650875123589871*^9, 3.650875127910881*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Plot 3D profile examples", "Subsection",
 CellChangeTimes->{{3.651567663292235*^9, 3.6515676694356823`*^9}, {
  3.6587627613859053`*^9, 3.65876278784943*^9}}],

Cell["run the above parameter cell in setting", "Text",
 CellChangeTimes->{{3.664183726867511*^9, 3.664183742500063*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell["transmit", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}, {3.658763892179221*^9, 3.6587638935230007`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2."}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "5.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "8000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.651568985549329*^9, 3.651568985964411*^9}, {
   3.651569100834303*^9, 3.651569117857082*^9}, {3.6587627315776978`*^9, 
   3.6587627372107553`*^9}, {3.658762820475995*^9, 3.658762844955386*^9}, 
   3.6587628909758472`*^9, {3.658762928033031*^9, 3.658762930851038*^9}, 
   3.658763101485449*^9, {3.658763633104371*^9, 3.658763659665091*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"vpx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.026091153387754907`"}], ",", 
      RowBox[{"-", "2.459782585412843`"}], ",", "2.323529402485496`"}], 
     "}"}]}], ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.658763710071368*^9, 3.658763728640568*^9}, 
   3.658764142426567*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"vp", "=", 
     RowBox[{
      RowBox[{"Options", "[", 
       RowBox[{"ListPointPlot3D", ",", "ViewPoint"}], "]"}], 
      "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"pts3d", "=", 
     RowBox[{"Take", "[", 
      RowBox[{"pts", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ak$transmit$profile", "=", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListPointPlot3D", "[", 
       RowBox[{"pts3d", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{
           RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}],
         ",", 
        RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
        RowBox[{"Ticks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "Automatic", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.2"}], ",", "0", ",", "0.2"}], "}"}]}], "}"}]}], 
        ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
        RowBox[{"Epilog", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Impurity\>\"", ",", 
               RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1.4"}], ",", 
               RowBox[{"+", "2.1"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arrow", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "0.65"}], ",", "2.0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0.1", ",", "0.45"}], "}"}]}], "}"}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Incident antikink\>\"", ",", 
               RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.5", ",", 
               RowBox[{"-", "3.1"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arrow", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0.5", ",", 
                RowBox[{"-", "2.85"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0.4", ",", 
                RowBox[{"-", "1.95"}]}], "}"}]}], "}"}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Transmitted antikink\>\"", ",", 
               RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"2.4", ",", "3.5"}], "}"}]}], "]"}], ",", 
           RowBox[{"Arrow", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"2.4", ",", "3.30"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1.02", ",", "2.85"}], "}"}]}], "}"}], "]"}]}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"Graphics3D", "@", 
       RowBox[{"Line", "@", "pts3d"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
      RowBox[{"ViewPoint", "\[Rule]", 
       RowBox[{"Dynamic", "[", "vpk", "]"}]}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.6587628514394293`*^9, 
   3.658762851772561*^9}, {3.658763734963511*^9, 3.658763784546248*^9}, 
   3.658763923590782*^9, {3.658764084635284*^9, 3.658764092491371*^9}, {
   3.658764199966485*^9, 3.6587642007973957`*^9}, {3.658764962860241*^9, 
   3.6587649660847607`*^9}, {3.661151269621688*^9, 3.661151298196699*^9}, {
   3.664183775695147*^9, 3.66418388021875*^9}, {3.6641839124931583`*^9, 
   3.6641839137558603`*^9}, {3.664183982658999*^9, 3.6641840248466187`*^9}, {
   3.664184055765297*^9, 3.6641840667045183`*^9}, {3.664184126476851*^9, 
   3.664184192633782*^9}, {3.664184279484529*^9, 3.664184325758151*^9}, 
   3.664184637261928*^9, {3.6641846776053333`*^9, 3.664184684828539*^9}, {
   3.6641848427280073`*^9, 3.664184871928049*^9}, {3.664185152303464*^9, 
   3.6641851613372*^9}, {3.664185196881322*^9, 3.664185197065611*^9}, {
   3.6641853543124657`*^9, 3.664185386592108*^9}, {3.664185417061854*^9, 
   3.6641857213851957`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<ak-transmit-utn.pdf\>\"", ",", "ak$transmit$profile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9, {
   3.6587637948023863`*^9, 3.658763814508936*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["trap", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}, {3.658763896082597*^9, 3.658763896611149*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2."}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "5.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "7000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.651568985549329*^9, 3.651568985964411*^9}, {
   3.651569100834303*^9, 3.651569117857082*^9}, {3.6587627315776978`*^9, 
   3.6587627372107553`*^9}, {3.658762820475995*^9, 3.658762844955386*^9}, 
   3.6587628909758472`*^9, {3.658762928033031*^9, 3.658762930851038*^9}, 
   3.658763101485449*^9, {3.658763633104371*^9, 3.658763659665091*^9}, 
   3.65876389951033*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts3d", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ak$trap$profile", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{"pts3d", ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "19"}], "]"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "0", ",", "0.2"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Impurity\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.4"}], ",", 
             RowBox[{"+", "2.1"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "0.65"}], ",", "2.0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.1", ",", "0.45"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Incident antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", 
             RowBox[{"-", "2.9"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.5", ",", 
              RowBox[{"-", "2.85"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.4", ",", 
              RowBox[{"-", "1.95"}]}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Trapped antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.4", ",", "3.5"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2.4", ",", "3.30"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1.82", ",", "2.35"}], "}"}]}], "}"}], "]"}]}], 
        "}"}]}]}], "]"}], ",", 
    RowBox[{"Graphics3D", "@", 
     RowBox[{"Line", "@", "pts3d"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", "vpk"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.6587628514394293`*^9, 
   3.658762851772561*^9}, {3.658763734963511*^9, 3.658763784546248*^9}, {
   3.658763915686454*^9, 3.658763939097343*^9}, {3.658764966748382*^9, 
   3.658764967110466*^9}, {3.6611512605976887`*^9, 3.661151261273841*^9}, {
   3.661151335462674*^9, 3.661151335626465*^9}, {3.664184488362385*^9, 
   3.6641844886643553`*^9}, {3.664185203425201*^9, 3.664185203577651*^9}, {
   3.664185759155239*^9, 3.664185830266077*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<ak-trap-utn.pdf\>\"", ",", "ak$trap$profile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9, {
   3.6587637948023863`*^9, 3.658763814508936*^9}, {3.658763962934395*^9, 
   3.658763966405313*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["reflect", "Subsubsection",
 CellChangeTimes->{{3.649076702756084*^9, 3.649076741396984*^9}, {
   3.64907693340639*^9, 3.649076933849443*^9}, {3.649077411573435*^9, 
   3.649077412485465*^9}, {3.649077483479673*^9, 3.6490774872632723`*^9}, {
   3.6490775222482243`*^9, 3.6490775244399643`*^9}, {3.6490799099141703`*^9, 
   3.649079911522851*^9}, {3.649081681581805*^9, 3.649081687500813*^9}, {
   3.649083840305128*^9, 3.64908384080063*^9}, {3.6502013356943007`*^9, 
   3.650201340446495*^9}, 3.650201532803041*^9, {3.650285599417471*^9, 
   3.650285604793462*^9}, {3.658763896082597*^9, 3.658763896611149*^9}, {
   3.658763984026861*^9, 3.658763985124995*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtable2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tfinal", "=", "2."}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "200."}]}], ";", "tableContent4", ";", "Calpts",
       ";", "AK", ";", 
      RowBox[{
      "AKShowpts", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ldef", ",", 
       RowBox[{"{", "lzero", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v0", ",", 
       RowBox[{"{", "6.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"{", "0.0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kkdef", ",", 
       RowBox[{"{", "2000.", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Mdef", ",", 
       RowBox[{"{", "1.", "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Finish\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.641920079190845*^9, 3.641920134833934*^9}, 
   3.641923405522558*^9, 3.6419237634368668`*^9, 3.641924175478697*^9, {
   3.6427385829106007`*^9, 3.6427386036757812`*^9}, 3.642743584533999*^9, {
   3.642743643782406*^9, 3.642743683910739*^9}, 3.642743940195367*^9, {
   3.642753081124539*^9, 3.6427531124057903`*^9}, {3.642760881991643*^9, 
   3.64276089574089*^9}, {3.6427620907188263`*^9, 3.642762180406446*^9}, {
   3.642762212331176*^9, 3.642762319548657*^9}, {3.642830115651079*^9, 
   3.642830115989848*^9}, 3.642848491845394*^9, {3.642848522932369*^9, 
   3.642848575176092*^9}, {3.642850554550701*^9, 3.6428505564382563`*^9}, {
   3.642850787157167*^9, 3.642850787324141*^9}, {3.64285116495107*^9, 
   3.642851173600712*^9}, {3.642851524308316*^9, 3.6428515399629993`*^9}, {
   3.642858302487464*^9, 3.642858331149975*^9}, {3.643006673356886*^9, 
   3.6430067621358213`*^9}, {3.643006803867524*^9, 3.6430068040022383`*^9}, {
   3.6430114114690733`*^9, 3.643011507380108*^9}, {3.643011689176992*^9, 
   3.643011693564152*^9}, {3.6430123991885653`*^9, 3.643012403385703*^9}, 
   3.64337360401372*^9, 3.643373702338346*^9, {3.6434308063126907`*^9, 
   3.6434308067274723`*^9}, 3.643520105584703*^9, {3.643608208382139*^9, 
   3.6436082459371223`*^9}, {3.643608313379262*^9, 3.6436083135356493`*^9}, 
   3.64360863316403*^9, 3.643609550854701*^9, {3.6436096856551456`*^9, 
   3.643609744708619*^9}, {3.6436097878147583`*^9, 3.643609797294876*^9}, {
   3.6436098338171673`*^9, 3.6436098665163803`*^9}, {3.643610051925527*^9, 
   3.643610052118104*^9}, {3.643610255661064*^9, 3.643610268315345*^9}, {
   3.643610302175989*^9, 3.643610302269322*^9}, {3.643610372721732*^9, 
   3.643610418753913*^9}, {3.643610501318985*^9, 3.643610501710824*^9}, {
   3.643610652743431*^9, 3.643610652932096*^9}, 3.643610700313931*^9, {
   3.643610834349654*^9, 3.6436108366193457`*^9}, {3.643610870315473*^9, 
   3.643610890763895*^9}, {3.643610981825838*^9, 3.6436109855318623`*^9}, {
   3.643612058842889*^9, 3.6436121133675327`*^9}, {3.643639561895588*^9, 
   3.6436395622219*^9}, 3.643639766686303*^9, {3.643695612459963*^9, 
   3.64369564864207*^9}, {3.643706748656477*^9, 3.643706753010243*^9}, {
   3.64370826003369*^9, 3.643708292065467*^9}, {3.643708352072307*^9, 
   3.643708368396043*^9}, 3.643708885346285*^9, {3.6437091329408283`*^9, 
   3.643709149538219*^9}, {3.643709529184291*^9, 3.6437095335625677`*^9}, {
   3.643709828332204*^9, 3.643709834875579*^9}, {3.6437107382598133`*^9, 
   3.6437107652066*^9}, {3.6437109293999*^9, 3.643711025774221*^9}, {
   3.643711711194724*^9, 3.643711722286889*^9}, {3.643947674138091*^9, 
   3.643947695836051*^9}, {3.64394860888056*^9, 3.6439486126878853`*^9}, 
   3.643948798327949*^9, {3.644212234398267*^9, 3.6442122346366863`*^9}, 
   3.644212303346887*^9, {3.644212384939858*^9, 3.6442123850225973`*^9}, 
   3.644212472074185*^9, {3.644212523452282*^9, 3.644212541318701*^9}, {
   3.644214700192009*^9, 3.6442147089279747`*^9}, {3.644214770483225*^9, 
   3.644214811364081*^9}, 3.644214891740329*^9, {3.64421629994867*^9, 
   3.644216300035523*^9}, {3.644575864210948*^9, 3.644575867172077*^9}, {
   3.644575922466069*^9, 3.6445759335718803`*^9}, {3.644575987646888*^9, 
   3.6445760021520977`*^9}, {3.64459328162969*^9, 3.644593281702643*^9}, {
   3.644593532725493*^9, 3.644593533391878*^9}, 3.645524997567799*^9, {
   3.6461051635115*^9, 3.646105164923913*^9}, {3.646105228734593*^9, 
   3.646105229229085*^9}, {3.646400941743641*^9, 3.646400950297793*^9}, {
   3.646401174126298*^9, 3.646401183282043*^9}, {3.646401275367161*^9, 
   3.64640129070399*^9}, 3.6464014703212*^9, {3.646401517865632*^9, 
   3.646401517923134*^9}, {3.646401623159148*^9, 3.646401664822385*^9}, 
   3.646572817217465*^9, 3.6466403141283073`*^9, {3.646640368631908*^9, 
   3.6466403900346518`*^9}, {3.646641434623526*^9, 3.6466414474992867`*^9}, {
   3.646641942489719*^9, 3.646641942548983*^9}, 3.646642164288677*^9, {
   3.646642344736833*^9, 3.646642374569508*^9}, {3.6466424491713257`*^9, 
   3.646642449413587*^9}, {3.646642498662896*^9, 3.646642517750436*^9}, {
   3.646643657542042*^9, 3.646643678317087*^9}, {3.6466437487374973`*^9, 
   3.6466437776491423`*^9}, 3.646643809747932*^9, 3.646643845795721*^9, {
   3.6466452697982817`*^9, 3.64664530301556*^9}, {3.6466484335717688`*^9, 
   3.646648468594103*^9}, {3.646648504180518*^9, 3.646648508748459*^9}, {
   3.646649414106473*^9, 3.6466494158146143`*^9}, {3.6466510570101*^9, 
   3.646651068751149*^9}, {3.646907942761619*^9, 3.6469079593657913`*^9}, 
   3.6469081909050417`*^9, 3.646908277629517*^9, {3.646908426601143*^9, 
   3.646908517926104*^9}, {3.646908561513122*^9, 3.6469085638011417`*^9}, 
   3.64690866183016*^9, 3.646908733129806*^9, 3.6469094254275417`*^9, {
   3.6469110389647627`*^9, 3.646911040462387*^9}, 3.646911146546691*^9, {
   3.6469113045342484`*^9, 3.64691133938095*^9}, {3.64691161865653*^9, 
   3.6469116997255163`*^9}, {3.646913072049293*^9, 3.646913072590904*^9}, {
   3.647177267677367*^9, 3.647177270077272*^9}, {3.647177319153203*^9, 
   3.647177319520061*^9}, {3.6471788676197777`*^9, 3.647178878243819*^9}, {
   3.647179244750073*^9, 3.6471792489563007`*^9}, {3.647257269162767*^9, 
   3.647257272178269*^9}, {3.6477677400880747`*^9, 3.647767755479804*^9}, 
   3.6478660540267363`*^9, {3.647866163325692*^9, 3.6478661708774977`*^9}, 
   3.647866232062792*^9, 3.6478663714744368`*^9, 3.64786646440963*^9, {
   3.647866679515326*^9, 3.647866749385188*^9}, 3.647867943928186*^9, 
   3.647868034777577*^9, {3.649076127943409*^9, 3.649076134280315*^9}, {
   3.6490767818176537`*^9, 3.649076836138585*^9}, 3.6490769357253227`*^9, {
   3.649076969547452*^9, 3.64907699547187*^9}, 3.649077032414524*^9, 
   3.64907724158552*^9, 3.6490773048380833`*^9, {3.649077415183301*^9, 
   3.6490774224073544`*^9}, {3.6490775094740753`*^9, 3.64907750955079*^9}, 
   3.6490775780152407`*^9, 3.649077671869467*^9, {3.649077716894964*^9, 
   3.649077742774001*^9}, {3.6490777880970993`*^9, 3.649077788560233*^9}, {
   3.649077876513729*^9, 3.64907790006564*^9}, 3.649078043190222*^9, {
   3.649078240333571*^9, 3.6490782904463577`*^9}, {3.649078436415552*^9, 
   3.6490784709756327`*^9}, {3.649078673925664*^9, 3.64907870357546*^9}, {
   3.649078939565318*^9, 3.649079023774934*^9}, {3.649079073791112*^9, 
   3.649079154633919*^9}, {3.649079201460004*^9, 3.649079213505391*^9}, {
   3.649079498099997*^9, 3.649079511807227*^9}, 3.649079662543172*^9, 
   3.649079888071618*^9, {3.649080883532721*^9, 3.649080893114848*^9}, 
   3.6490810512632217`*^9, {3.649083597491013*^9, 3.649083603918545*^9}, {
   3.649083745715016*^9, 3.649083750831218*^9}, {3.6494110176604958`*^9, 
   3.649411019056096*^9}, {3.6494110665782013`*^9, 3.649411101825822*^9}, {
   3.649411208966485*^9, 3.64941126893106*^9}, {3.649411326459243*^9, 
   3.6494113284459963`*^9}, {3.649411366374714*^9, 3.649411372965623*^9}, {
   3.649411591743428*^9, 3.649411600188796*^9}, {3.649411671985773*^9, 
   3.649411673501598*^9}, {3.650196635234651*^9, 3.650196636689315*^9}, 
   3.65019666760641*^9, {3.650200238343087*^9, 3.650200404075124*^9}, {
   3.650200622594282*^9, 3.650200636575341*^9}, {3.6502006901933804`*^9, 
   3.650200709348926*^9}, {3.650200755587103*^9, 3.6502007649780607`*^9}, {
   3.650200965224587*^9, 3.6502009793678226`*^9}, 3.650201528084306*^9, {
   3.650206958707058*^9, 3.650206960258687*^9}, {3.650285421565941*^9, 
   3.650285429382146*^9}, {3.650285479621888*^9, 3.650285481256382*^9}, {
   3.650344922456534*^9, 3.650344930090837*^9}, {3.650363189466566*^9, 
   3.6503631984557333`*^9}, 3.650364012901289*^9, 3.6503659705547743`*^9, {
   3.6506247644186287`*^9, 3.6506247664487953`*^9}, {3.650648938888565*^9, 
   3.650648940089322*^9}, {3.650656490155051*^9, 3.650656550093918*^9}, 
   3.650656684160198*^9, {3.6506887010348787`*^9, 3.650688708218728*^9}, {
   3.650689263975128*^9, 3.650689265847122*^9}, 3.6508936330532618`*^9, 
   3.651560686519637*^9, {3.651568985549329*^9, 3.651568985964411*^9}, {
   3.651569100834303*^9, 3.651569117857082*^9}, {3.6587627315776978`*^9, 
   3.6587627372107553`*^9}, {3.658762820475995*^9, 3.658762844955386*^9}, 
   3.6587628909758472`*^9, {3.658762928033031*^9, 3.658762930851038*^9}, 
   3.658763101485449*^9, {3.658763633104371*^9, 3.658763659665091*^9}, 
   3.65876389951033*^9, {3.6587640130223913`*^9, 3.65876401519179*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts3d", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ak$reflect$profile", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{"pts3d", ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"PointSize", "\[Rule]", "0.005"}], ",", "Black"}], "]"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", "Full"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"FontSize", "\[Rule]", "19"}], "]"}]}], ",", 
      RowBox[{"Ticks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "0", ",", "0.2"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Rotor index \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<Time\>\"", ",", "\"\<\!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\) Sin \!\(\*
StyleBox[SubscriptBox[\"\[Theta]\", \"i\"],
FontSlant->\"Italic\"]\)\>\""}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Impurity\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.4"}], ",", 
             RowBox[{"+", "2.1"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "0.65"}], ",", "2.0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.1", ",", "0.45"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Incident antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", 
             RowBox[{"-", "2.5"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.5", ",", 
              RowBox[{"-", "2.35"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.4", ",", 
              RowBox[{"-", "1.75"}]}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Reflected antikink\>\"", ",", 
             RowBox[{"FontSize", "\[Rule]", "24"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.4", ",", "2.5"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2.4", ",", "2.30"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2.82", ",", "1.35"}], "}"}]}], "}"}], "]"}]}], 
        "}"}]}]}], "]"}], ",", 
    RowBox[{"Graphics3D", "@", 
     RowBox[{"Line", "@", "pts3d"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", "vpk"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.658484910555708*^9, 3.658485178976001*^9}, 
   3.65848526721795*^9, {3.658485320604553*^9, 3.658485334665141*^9}, 
   3.6584853731907454`*^9, {3.658485423351213*^9, 3.6584854626142273`*^9}, {
   3.658485496472336*^9, 3.658485532698155*^9}, {3.658485664572081*^9, 
   3.658485758668723*^9}, {3.658486300555583*^9, 3.658486305563188*^9}, {
   3.6584864051811457`*^9, 3.658486405549984*^9}, {3.65848648763066*^9, 
   3.65848648851402*^9}, {3.658486536293953*^9, 3.6584865474916267`*^9}, {
   3.658487068813292*^9, 3.658487069543667*^9}, {3.6587628514394293`*^9, 
   3.658762851772561*^9}, {3.658763734963511*^9, 3.658763784546248*^9}, {
   3.658763915686454*^9, 3.658763939097343*^9}, {3.6587639887923393`*^9, 
   3.658763990551321*^9}, {3.658764967525516*^9, 3.658764967786425*^9}, {
   3.661151368902594*^9, 3.661151369012308*^9}, {3.664184500928204*^9, 
   3.664184501208371*^9}, {3.664184556896255*^9, 3.6641845924741087`*^9}, {
   3.664185223667758*^9, 3.664185231522674*^9}, {3.6641859480167027`*^9, 
   3.664186016442556*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<ak-reflect-utn.pdf\>\"", ",", "ak$reflect$profile", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584858690614367`*^9, 3.6584858709915867`*^9}, {
   3.6584863744114313`*^9, 3.658486375195249*^9}, 3.658486509177574*^9, {
   3.6587637948023863`*^9, 3.658763814508936*^9}, {3.658763962934395*^9, 
   3.6587640005343857`*^9}}]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data Storage", "Section",
 CellChangeTimes->{{3.646648609649028*^9, 3.646648616065979*^9}, 
   3.649396114146687*^9, {3.650281928055987*^9, 3.650281931812982*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"datasaveFolder", "=", 
   RowBox[{"FileNameJoin", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", 
      RowBox[{"FileBaseName", "[", 
       RowBox[{"NotebookFileName", "[", "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"!", 
    RowBox[{"DirectoryQ", "[", "datasaveFolder", "]"}]}], ",", 
   RowBox[{"CreateDirectory", "[", "datasaveFolder", "]"}]}], "]"}]}], "Input",\

 CellChangeTimes->{{3.643624356395129*^9, 3.643624371665863*^9}, {
   3.6436250872976933`*^9, 3.643625107062193*^9}, {3.643625173701395*^9, 
   3.6436252007372637`*^9}, {3.6436252719212713`*^9, 3.643625340115155*^9}, 
   3.64362539847865*^9, {3.6436254628489017`*^9, 3.6436254818818703`*^9}, 
   3.643625577311511*^9, {3.643625611228292*^9, 3.6436256194067993`*^9}, {
   3.64362568167048*^9, 3.643625699682732*^9}, {3.6436257421185703`*^9, 
   3.6436258947572403`*^9}}],

Cell[BoxData["datasaveFolder"], "Input",
 CellChangeTimes->{{3.6748196476907578`*^9, 3.674819650729072*^9}}],

Cell[CellGroupData[{

Cell["DumpSave", "Subsubsection",
 CellChangeTimes->{{3.6436363891973352`*^9, 3.643636420327619*^9}, {
  3.6436388128293133`*^9, 3.643638825770398*^9}, {3.674826417392188*^9, 
  3.674826418447853*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{"datasaveFolder", ",", "\"\<data1.mx\>\""}], "}"}], "]"}], ",",
      "kkvtab"}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Forget", " ", "why", " ", "use", " ", "Export", " ", "instead", " ", 
     "of", " ", "DumpSave"}], ",", " ", 
    RowBox[{"maybe", " ", "data", " ", "format", " ", 
     RowBox[{"issue", "?"}]}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368933611888*^9}, 3.650368978861516*^9, {3.653388809547022*^9, 
   3.6533888099942713`*^9}, {3.653388888396769*^9, 3.653388905707925*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data2.mx\>\""}], "}"}], "]"}], ",", 
    "akkvtab"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368934542179*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data3.mx\>\""}], "}"}], "]"}], ",", 
    "kkvconfplot"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368935452169*^9}, 3.6503689817896757`*^9, {3.650546132779323*^9, 
   3.650546132798024*^9}, 3.6505463824817953`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data4.mx\>\""}], "}"}], "]"}], ",", 
    "akkvconfplot"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368935452169*^9}, 3.6503689817896757`*^9, {3.650546132779323*^9, 
   3.650546132798024*^9}, 3.6505463824817953`*^9, {3.650546557276342*^9, 
   3.6505465596273413`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data5.mx\>\""}], "}"}], "]"}], ",", 
    "Kconf3dplot"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368935452169*^9}, 3.6503689817896757`*^9, {3.650546132779323*^9, 
   3.650546132798024*^9}, 3.6505463824817953`*^9, {3.650654839906877*^9, 
   3.650654849715427*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data6.mx\>\""}], "}"}], "]"}], ",", 
    "AKconf3dplot"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.643636311573175*^9, 3.643636380471178*^9}, {
   3.643695674728263*^9, 3.643695688538212*^9}, {3.643709913209218*^9, 
   3.643709913711948*^9}, 3.643713415422739*^9, 3.643794793395653*^9, {
   3.643968240419744*^9, 3.643968240497974*^9}, 3.6440370023039837`*^9, 
   3.644123967020934*^9, {3.6441367800036087`*^9, 3.6441367808037024`*^9}, 
   3.6441488849930487`*^9, {3.644150163512253*^9, 3.644150163589869*^9}, 
   3.644580356969*^9, 3.646400806071457*^9, {3.6502058756576557`*^9, 
   3.6502058762971287`*^9}, {3.650278781744822*^9, 3.650278785950459*^9}, {
   3.650344716355205*^9, 3.650344722276414*^9}, {3.6503689084432592`*^9, 
   3.650368935452169*^9}, 3.6503689817896757`*^9, {3.650546132779323*^9, 
   3.650546132798024*^9}, 3.6505463824817953`*^9, {3.650546557276342*^9, 
   3.6505465596273413`*^9}, {3.6506548421151857`*^9, 3.650654862883772*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data7.mx\>\""}], "}"}], "]"}], ",", 
    "pethnumxrelax2"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6533887617859383`*^9, 3.653388774231928*^9}, 
   3.6584993857078247`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data8.mx\>\""}], "}"}], "]"}], ",", 
    "pethnumxrelax3"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6533887617859383`*^9, 3.653388774231928*^9}, {
  3.6554749623464622`*^9, 3.6554749689060917`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data9.mx\>\""}], "}"}], "]"}], ",", 
    "kkevaltab"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6533887617859383`*^9, 3.653388774231928*^9}, {
  3.6554749623464622`*^9, 3.6554749689060917`*^9}, {3.6567663736216516`*^9, 
  3.656766379467971*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data10.mx\>\""}], "}"}], "]"}], ",",
     "kkevaltab2"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6533887617859383`*^9, 3.653388774231928*^9}, {
  3.6554749623464622`*^9, 3.6554749689060917`*^9}, {3.6567663736216516`*^9, 
  3.656766379467971*^9}, {3.657297061126411*^9, 3.6572970650267487`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DumpSave", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data11.mx\>\""}], "}"}], "]"}], ",",
     "kinktab1"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6533887617859383`*^9, 3.653388774231928*^9}, {
  3.6554749623464622`*^9, 3.6554749689060917`*^9}, {3.6567663736216516`*^9, 
  3.656766379467971*^9}, {3.657297061126411*^9, 3.6572970650267487`*^9}, {
  3.657297272655658*^9, 3.657297275420197*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Data Load", "Subsubsection",
 CellChangeTimes->{{3.650205907209633*^9, 3.650205910537401*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"kkvtab", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data1.mx\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6436363561537933`*^9, 3.643636368474702*^9}, {
  3.643636435160811*^9, 3.643636467366653*^9}, {3.650344717348692*^9, 
  3.650344730932778*^9}, {3.6505459518971357`*^9, 3.650545956158683*^9}, {
  3.650546309381975*^9, 3.650546312150352*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"akkvtab", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data2.mx\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6436363561537933`*^9, 3.643636368474702*^9}, {
  3.643636435160811*^9, 3.643636467366653*^9}, {3.650344717348692*^9, 
  3.650344730932778*^9}, {3.6505459518971357`*^9, 3.650545956158683*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data3.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"For", " ", "kkvconfplot"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.650205896158471*^9, 3.650205901705626*^9}, 
   3.650205938394631*^9, {3.650545960543268*^9, 3.650545967534622*^9}, 
   3.650546163603386*^9, {3.650546310359429*^9, 3.650546322854286*^9}, {
   3.650546517195956*^9, 3.650546534139118*^9}, 3.6505466185567913`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data4.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"For", " ", "akkvconfplot"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.650205896158471*^9, 3.650205901705626*^9}, 
   3.650205938394631*^9, {3.650545960543268*^9, 3.650545967534622*^9}, 
   3.650546163603386*^9, {3.650546522923621*^9, 3.650546540155802*^9}, 
   3.650546621885516*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data5.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"For", " ", "Kconf3dplot"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.650205896158471*^9, 3.650205901705626*^9}, 
   3.650205938394631*^9, {3.650545960543268*^9, 3.650545967534622*^9}, 
   3.650546163603386*^9, {3.650546310359429*^9, 3.650546322854286*^9}, {
   3.650546517195956*^9, 3.650546534139118*^9}, 3.6505466185567913`*^9, {
   3.650656334406427*^9, 3.6506563413816767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data6.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"For", " ", "AKconf3dplot"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.650205896158471*^9, 3.650205901705626*^9}, 
   3.650205938394631*^9, {3.650545960543268*^9, 3.650545967534622*^9}, 
   3.650546163603386*^9, {3.650546522923621*^9, 3.650546540155802*^9}, 
   3.650546621885516*^9, {3.650656335593739*^9, 3.650656344758951*^9}, {
   3.6533889159370527`*^9, 3.653388920128886*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data7.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Vpn", " ", "-", " ", 
    RowBox[{"th0", " ", "plot"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.653388924798562*^9, 3.653388930285306*^9}, {
  3.654335768108767*^9, 3.6543357808361683`*^9}, {3.655474996346642*^9, 
  3.655474998506452*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data8.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Vpn", " ", "-", " ", 
    RowBox[{"num", " ", "plot"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.653388924798562*^9, 3.653388930285306*^9}, {
  3.654335768108767*^9, 3.6543357808361683`*^9}, {3.6554749782994413`*^9, 
  3.655474994170116*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data9.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", "kkevaltab", "*)"}]}]], "Input",
 CellChangeTimes->{{3.6567663921644287`*^9, 3.656766428885006*^9}, 
   3.657452697078128*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data10.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", "kkevaltab2", "*)"}]}]], "Input",
 CellChangeTimes->{{3.6567663921644287`*^9, 3.656766428885006*^9}, {
  3.657297086764138*^9, 3.65729709035502*^9}, {3.657452701222193*^9, 
  3.657452701621512*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DumpGet", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"datasaveFolder", ",", "\"\<data11.mx\>\""}], "}"}], "]"}], 
    "]"}], ";"}], 
  RowBox[{"(*", "kinktab1", "*)"}]}]], "Input",
 CellChangeTimes->{{3.6567663921644287`*^9, 3.656766428885006*^9}, {
  3.657297086764138*^9, 3.65729709035502*^9}, {3.657297278730652*^9, 
  3.657297280503804*^9}, {3.65745270488666*^9, 3.657452705925619*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualization", "Section",
 CellChangeTimes->{{3.645275367590557*^9, 3.645275383830442*^9}, {
  3.650281935269412*^9, 3.650281938644552*^9}}],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
 CellChangeTimes->{{3.65020738300566*^9, 3.6502073842677717`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"kkvtab", "=", 
   RowBox[{"g", "[", "ktag", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.650198644688711*^9, 3.650198646400914*^9}, 
   3.650206705117269*^9, 3.65036898950247*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"akkvtab", "=", 
   RowBox[{"g", "[", "aktag", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.650198644688711*^9, 3.650198646400914*^9}, 
   3.650206705117269*^9, 3.65036898950247*^9, {3.650369022398382*^9, 
   3.6503690255345383`*^9}, {3.650532880744124*^9, 3.650532884119212*^9}, {
   3.65054683896255*^9, 3.650546840322555*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"akkvtabAppending", "=", 
   RowBox[{"g", "[", "aktag", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6515769466516123`*^9, 3.651576960231913*^9}, {
  3.6515770690608873`*^9, 3.651577069242601*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"akkvtabAppended", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"akkvtab", ",", "akkvtabAppending"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.651576920425544*^9, 3.65157701248945*^9}, {
  3.6515770492612543`*^9, 3.651577071866864*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"akkvtab", "=", "akkvtabAppended"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Sure", " ", "to", " ", "save", " ", 
    RowBox[{"append", "?"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.651577056566087*^9, 3.651577076926458*^9}, {
  3.65157721087814*^9, 3.65157722388695*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"kvtab", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"kvtab", ",", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"MemberQ", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "104", ",", "116", ",", "118"}], "}"}],
           ",", 
          RowBox[{"#", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], 
       "&"}]}], "]"}]}], ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.650206020874742*^9, 3.650206077409568*^9}, {
   3.650206153423923*^9, 3.6502061982410927`*^9}, {3.650206250403384*^9, 
   3.650206303588378*^9}, {3.650206345432193*^9, 3.650206380007463*^9}, {
   3.650206411175988*^9, 3.650206480999756*^9}, 3.650206611243207*^9}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Select", "[", 
   RowBox[{"kvtab", ",", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"{", "6", "}"}], ",", 
       RowBox[{"#", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}], "&"}]}], 
   "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.650206020874742*^9, 3.650206077409568*^9}, {
  3.650206153423923*^9, 3.6502061982410927`*^9}, {3.650206250403384*^9, 
  3.650206303588378*^9}, {3.650206345432193*^9, 3.650206380007463*^9}, {
  3.650206411175988*^9, 3.650206480999756*^9}, {3.6502065110818777`*^9, 
  3.650206524954734*^9}, {3.650206756911068*^9, 3.6502067758727694`*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"kvtab", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"kvtab", ",", 
      RowBox[{
       RowBox[{"IntegerQ", "[", 
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], "&"}]}], 
     "]"}]}], ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.650206020874742*^9, 3.650206077409568*^9}, {
   3.650206153423923*^9, 3.6502061982410927`*^9}, {3.650206250403384*^9, 
   3.650206303588378*^9}, {3.650206345432193*^9, 3.650206380007463*^9}, {
   3.650206411175988*^9, 3.650206480999756*^9}, {3.6502065110818777`*^9, 
   3.650206524954734*^9}, {3.650206756911068*^9, 3.6502067758727694`*^9}, {
   3.65020683294529*^9, 3.650206908501532*^9}, 3.6503490382990923`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Clear", "Subsubsection",
 CellChangeTimes->{{3.650648795219614*^9, 3.6506487961314697`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "ktag", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "kkvconfplot", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "kkvtab", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "Kconf3dplot", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.650648800235752*^9, 3.650648846309058*^9}, {
  3.650654435275133*^9, 3.6506544426199503`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "aktag", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "akkvconfplot", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "akkvtab", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClearAll", "[", "AKconf3dplot", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.650648800235752*^9, 3.650648846309058*^9}, {
   3.650653146191049*^9, 3.6506531496582127`*^9}, {3.6506544486339617`*^9, 
   3.650654451177719*^9}, 3.650892930107778*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Plot setting", "Subsubsection",
 CellChangeTimes->{{3.6502073747636757`*^9, 3.6502073881402807`*^9}, {
  3.650646888230262*^9, 3.6506468887100782`*^9}, {3.650647159741242*^9, 
  3.6506471600583887`*^9}}],

Cell[BoxData[
 RowBox[{"plotsetting", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotRangeClipping", "->", "False"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "40"}], "]"}]}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
    RowBox[{"FrameTicksStyle", "->", 
     RowBox[{"Directive", "[", 
      RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, 3.650375193390513*^9, {3.65062878008888*^9, 
   3.650628780631318*^9}, 3.650646631698621*^9, {3.6506515414938517`*^9, 
   3.650651554089396*^9}, {3.6587580253583097`*^9, 3.6587580362993727`*^9}, {
   3.658758083453608*^9, 3.65875812074916*^9}, {3.65875910827732*^9, 
   3.658759112854782*^9}, {3.661150741911594*^9, 3.66115075591936*^9}, {
   3.6611508738187933`*^9, 3.6611508793068666`*^9}, {3.661150930651662*^9, 
   3.661150931611994*^9}, {3.661774625052656*^9, 3.661774651053103*^9}, 
   3.661774847073408*^9}],

Cell["kink", "Text",
 CellChangeTimes->{{3.650647135835945*^9, 3.6506471372597837`*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kkvplottab", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"kkvtab", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        "\[Equal]", "x"}], ")"}], "&"}]}], "]"}], "\[LeftDoubleBracket]", 
   RowBox[{"All", ",", "1", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}]}], 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kknmvplottab", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"kkvplottab", "[", "x", "]"}], "//", "Transpose"}], ")"}], "*", 
     RowBox[{"{", 
      RowBox[{"0.8", ",", 
       FractionBox["1", "10000."]}], "}"}]}], ")"}], "//", "Transpose", 
   RowBox[{"(*", 
    RowBox[{"Kink", ",", " ", 
     RowBox[{
      SubscriptBox["k", "i"], " ", "NorMalized"}], ",", " ", 
     RowBox[{
     "v", " ", "divided", " ", "by", " ", "r", " ", "to", " ", "get", " ", 
      "real", " ", "v"}]}], "*)"}]}]}]}], "Input",
 CellChangeTimes->{{3.650198665310856*^9, 3.650198708305464*^9}, {
   3.650198740437126*^9, 3.650198744435356*^9}, {3.650198890983597*^9, 
   3.6501989519601793`*^9}, {3.6501990315124273`*^9, 3.650199059658133*^9}, {
   3.650199142353533*^9, 3.65019922918552*^9}, {3.6501992938740177`*^9, 
   3.650199403379006*^9}, {3.6501994381030912`*^9, 3.65019944248333*^9}, {
   3.650199652554343*^9, 3.65019965898352*^9}, {3.6502089160802298`*^9, 
   3.650209008835268*^9}, {3.6502090403196917`*^9, 3.650209137509234*^9}, {
   3.6503693822959948`*^9, 3.6503694678335457`*^9}, {3.650375224036973*^9, 
   3.65037522993557*^9}, 3.650544045831965*^9, {3.650544197924881*^9, 
   3.650544214264208*^9}, {3.665488728743163*^9, 3.6654887853965807`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PlotContent1", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tooltip", "@", 
      RowBox[{"(", 
       RowBox[{"kknmvplottab", "/@", 
        RowBox[{"{", 
         RowBox[{"\"\<ktm\>\"", ",", "\"\<ksp\>\""}], "}"}]}], ")"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(v\), \(0\)]\)\>\"", ",", 
        "\"\<\!\(\*FractionBox[SubscriptBox[\(k\), \(i\)], \(k\)]\)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"PointLegend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Transmission\>\"", ",", "\"\<Splitting\>\""}], "}"}], 
        ",", 
        RowBox[{"LegendLabel", "\[Rule]", "\"\<Kink\>\""}], ",", 
        RowBox[{"LegendMarkerSize", "\[Rule]", "15"}], ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}]}]}], 
    "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, 3.650375193390513*^9, {3.650375245695302*^9, 
   3.650375245891757*^9}, 3.650375320738759*^9, {3.650532917848729*^9, 
   3.6505329357234*^9}, {3.650545749466939*^9, 3.650545753851*^9}, {
   3.6505457870232363`*^9, 3.650545802427836*^9}, 3.65054586282865*^9, {
   3.650647030795495*^9, 3.6506470333111057`*^9}, 3.650647126835231*^9, {
   3.650648557968957*^9, 3.6506485604631653`*^9}, {3.65065139081924*^9, 
   3.650651399857532*^9}, {3.6506516071305027`*^9, 3.65065161031218*^9}, {
   3.650651696365337*^9, 3.650651698616891*^9}, {3.650651750912426*^9, 
   3.650651770090386*^9}, 3.650655751786463*^9, 3.658666292176839*^9, {
   3.658754559038632*^9, 3.6587545642019453`*^9}, {3.661152830044386*^9, 
   3.661152841592334*^9}, {3.661774824417638*^9, 3.661774835216978*^9}, {
   3.662900103954493*^9, 3.662900114705368*^9}, {3.666523327840929*^9, 
   3.666523340017415*^9}, {3.666523449699419*^9, 3.666523459508376*^9}, {
   3.6665239448433228`*^9, 3.666523944929661*^9}, {3.66652398639362*^9, 
   3.666523998034852*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kpopupGraph1", "[", "pt_", "]"}], ":=", 
  RowBox[{"kkvconfplot", "@@", 
   RowBox[{"(", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"pt", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
          "*", "10000"}], ",", "0.1"}], "]"}], ",", 
      RowBox[{"pt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "}"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ktoolRule1", "=", 
   RowBox[{
    RowBox[{"Tooltip", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"PopupWindow", "[", 
     RowBox[{
      RowBox[{"Tooltip", "[", "x", "]"}], ",", 
      RowBox[{"kpopupGraph1", "@", 
       RowBox[{"Last", "@", 
        RowBox[{"{", "x", "}"}]}]}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, 3.650375193390513*^9, {3.650375245695302*^9, 
   3.650375245891757*^9}, 3.650375320738759*^9, {3.650532917848729*^9, 
   3.6505329357234*^9}, {3.650545749466939*^9, 3.650545753851*^9}, {
   3.6505457870232363`*^9, 3.650545802427836*^9}, 3.65054586282865*^9, {
   3.650647030795495*^9, 3.6506470333111057`*^9}, 3.650647126835231*^9, {
   3.650648557968957*^9, 3.6506485604631653`*^9}, {3.65065139081924*^9, 
   3.650651399857532*^9}, {3.6506516071305027`*^9, 3.65065161031218*^9}, {
   3.650651696365337*^9, 3.650651698616891*^9}, {3.650651750912426*^9, 
   3.650651770090386*^9}, {3.650655751786463*^9, 3.650655763058099*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kpopupGraph2", "[", "pt_", "]"}], ":=", 
  RowBox[{"Kconf3dplot", "@@", 
   RowBox[{"(", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"pt", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
          "*", "10000"}], ",", "0.1"}], "]"}], ",", 
      RowBox[{"pt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "}"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ktoolRule2", "=", 
   RowBox[{
    RowBox[{"Tooltip", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"PopupWindow", "[", 
     RowBox[{
      RowBox[{"Tooltip", "[", "x", "]"}], ",", 
      RowBox[{"kpopupGraph2", "@", 
       RowBox[{"Last", "@", 
        RowBox[{"{", "x", "}"}]}]}], ",", 
      RowBox[{"WindowSize", "\[Rule]", "All"}]}], "]"}]}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, 3.650375193390513*^9, {3.650375245695302*^9, 
   3.650375245891757*^9}, 3.650375320738759*^9, {3.650532917848729*^9, 
   3.6505329357234*^9}, {3.650545749466939*^9, 3.650545753851*^9}, {
   3.6505457870232363`*^9, 3.650545802427836*^9}, 3.65054586282865*^9, {
   3.650647030795495*^9, 3.6506470333111057`*^9}, 3.650647126835231*^9, {
   3.650648557968957*^9, 3.6506485604631653`*^9}, {3.65065139081924*^9, 
   3.650651399857532*^9}, {3.6506516071305027`*^9, 3.65065161031218*^9}, {
   3.650651696365337*^9, 3.650651698616891*^9}, {3.650651750912426*^9, 
   3.650651770090386*^9}, {3.650655751786463*^9, 3.650655779178515*^9}, {
   3.650655831194932*^9, 3.650655831420562*^9}}],

Cell["antikink", "Text",
 CellChangeTimes->{{3.6506471306389933`*^9, 3.65064714112017*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"akkvplottab", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"akkvtab", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
         "\[Equal]", "x"}], "&&", 
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ">=", "500"}]}],
        ")"}], "&"}]}], "]"}], "\[LeftDoubleBracket]", 
   RowBox[{"All", ",", "1", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}]}], 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"akknmvplottab", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"akkvplottab", "[", "x", "]"}], "//", "Transpose"}], ")"}], 
     "*", 
     RowBox[{"{", 
      RowBox[{"0.8", ",", 
       FractionBox["1", "10000."]}], "}"}]}], ")"}], "//", "Transpose", 
   RowBox[{"(*", 
    RowBox[{"Antikink", ",", " ", 
     RowBox[{
      SubscriptBox["k", "i"], " ", "NorMalized"}], ",", " ", 
     RowBox[{
     "v", " ", "divided", " ", "by", " ", "r", " ", "to", " ", "get", " ", 
      "real", " ", "v"}]}], "*)"}]}]}]}], "Input",
 CellChangeTimes->{{3.650198665310856*^9, 3.650198708305464*^9}, {
   3.650198740437126*^9, 3.650198744435356*^9}, {3.650198890983597*^9, 
   3.6501989519601793`*^9}, {3.6501990315124273`*^9, 3.650199059658133*^9}, {
   3.650199142353533*^9, 3.65019922918552*^9}, {3.6501992938740177`*^9, 
   3.650199403379006*^9}, {3.6501994381030912`*^9, 3.65019944248333*^9}, {
   3.650199652554343*^9, 3.65019965898352*^9}, {3.6502089160802298`*^9, 
   3.650209008835268*^9}, {3.6502090403196917`*^9, 3.650209137509234*^9}, {
   3.6503693822959948`*^9, 3.6503694678335457`*^9}, 3.650544198611999*^9, {
   3.658758740381105*^9, 3.658758768380231*^9}, {3.658758807774988*^9, 
   3.65875887798538*^9}, {3.658758911249152*^9, 3.658758939648737*^9}, {
   3.6654887484529533`*^9, 3.665488795509447*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PlotContent2", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tooltip", "@", 
      RowBox[{"(", 
       RowBox[{"akknmvplottab", "/@", 
        RowBox[{"{", 
         RowBox[{
         "\"\<aktm\>\"", ",", "\"\<akrf\>\"", ",", "\"\<aktr\>\"", ",", 
          "\"\<aksp\>\""}], "}"}]}], ")"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(v\), \(0\)]\)\>\"", ",", 
        "\"\<\!\(\*FractionBox[SubscriptBox[\(k\), \(i\)], \(k\)]\)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Transmission\>\"", ",", "\"\<Reflection\>\"", ",", 
        "\"\<Trapping\>\"", ",", "\"\<Splitting\>\""}], "}"}]}], ",", 
     RowBox[{"LegendLabel", "\[Rule]", 
      RowBox[{"Placed", "[", 
       RowBox[{"\"\<Antikink\>\"", ",", "Above"}], "]"}]}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, {3.650375191150148*^9, 3.6503751987349157`*^9}, {
   3.650375249569188*^9, 3.6503752500379763`*^9}, 3.6505439944637213`*^9, {
   3.6505459357607727`*^9, 3.650545939965679*^9}, 3.650647002781519*^9, {
   3.650647036571714*^9, 3.65064703676304*^9}, {3.65156666898253*^9, 
   3.651566702550806*^9}, {3.651569318340563*^9, 3.6515693212353163`*^9}, 
   3.658666288898985*^9, {3.6611524579359217`*^9, 3.661152476767898*^9}, {
   3.661774873842868*^9, 3.6617749052815857`*^9}, {3.662900071458145*^9, 
   3.6629001279380293`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PlotContent3", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tooltip", "@", 
      RowBox[{"(", 
       RowBox[{"akknmvplottab", "/@", 
        RowBox[{"{", 
         RowBox[{"\"\<aktm\>\"", ",", "\"\<akrf\>\"", ",", "\"\<aktr\>\""}], 
         "}"}]}], ")"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(v\), \(0\)]\)\>\"", ",", 
        "\"\<\!\(\*FractionBox[SubscriptBox[\(k\), \(i\)], \(k\)]\)\>\""}], 
       "}"}]}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"PointLegend", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "\"\<Transmission\>\"", ",", "\"\<Reflection\>\"", ",", 
          "\"\<Trapping\>\"", ",", "\"\<Splitting\>\""}], "}"}], ",", 
        RowBox[{"LegendLabel", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{"\"\<Antikink\>\"", ",", "Above"}], "]"}]}], ",", 
        RowBox[{"LegendMarkerSize", "\[Rule]", "20"}], ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}]}]}], 
    "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650207051863559*^9, 
   3.650207073445633*^9}, {3.650207156232417*^9, 3.6502073452116127`*^9}, {
   3.650207417327835*^9, 3.650207450126341*^9}, {3.650209140070634*^9, 
   3.650209157733542*^9}, {3.650209230331192*^9, 3.650209256680822*^9}, 
   3.650209303387782*^9, {3.650209392312949*^9, 3.6502094578046017`*^9}, {
   3.650349955459722*^9, 3.650349958514963*^9}, {3.650369422313946*^9, 
   3.6503694223757772`*^9}, {3.650375191150148*^9, 3.6503751987349157`*^9}, {
   3.650375249569188*^9, 3.6503752500379763`*^9}, 3.6505439944637213`*^9, {
   3.6505459357607727`*^9, 3.650545939965679*^9}, 3.650647002781519*^9, {
   3.650647036571714*^9, 3.65064703676304*^9}, {3.65156666898253*^9, 
   3.651566702550806*^9}, {3.651569318340563*^9, 3.6515693212353163`*^9}, 
   3.658666288898985*^9, {3.658758309697757*^9, 3.6587583162728252`*^9}, 
   3.65875836438829*^9, {3.661152481296709*^9, 3.661152481856646*^9}, {
   3.661152611779821*^9, 3.661152661476089*^9}, {3.6611527118330307`*^9, 
   3.661152749689035*^9}, {3.661152785911887*^9, 3.661152789287345*^9}, 
   3.661774926196506*^9, {3.662900140498741*^9, 3.662900149458297*^9}, 
   3.6665240486901827`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"akpopupGraph1", "[", "pt_", "]"}], ":=", 
  RowBox[{"akkvconfplot", "@@", 
   RowBox[{"(", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"pt", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
          "*", "10000"}], ",", "0.1"}], "]"}], ",", 
      RowBox[{"pt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "}"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aktoolRule1", "=", 
   RowBox[{
    RowBox[{"Tooltip", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"PopupWindow", "[", 
     RowBox[{
      RowBox[{"Tooltip", "[", "x", "]"}], ",", 
      RowBox[{"akpopupGraph1", "@", 
       RowBox[{"Last", "@", 
        RowBox[{"{", "x", "}"}]}]}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.650542872172657*^9, 3.650542891221785*^9}, {
   3.6505429912284403`*^9, 3.6505429956829863`*^9}, {3.650543318063691*^9, 
   3.6505433182759037`*^9}, {3.650543639000567*^9, 3.650543641291944*^9}, 
   3.650543718649445*^9, {3.65054376544765*^9, 3.6505438489887753`*^9}, {
   3.6505439033452063`*^9, 3.650543904350047*^9}, 3.6505447422030983`*^9, {
   3.650545071611758*^9, 3.650545142738098*^9}, 3.650545177965914*^9, {
   3.650545454044064*^9, 3.650545464578726*^9}, {3.65054554656952*^9, 
   3.6505456119588223`*^9}, {3.650545646345921*^9, 3.650545646552425*^9}, {
   3.6505456981382093`*^9, 3.6505457206475353`*^9}, 3.650545756265128*^9, {
   3.650545867708852*^9, 3.650545908653254*^9}, 3.650624467185493*^9, {
   3.65062478526792*^9, 3.650624798354414*^9}, {3.650628734503687*^9, 
   3.650628735542631*^9}, {3.650651672367495*^9, 3.650651691865274*^9}, {
   3.6506531679478703`*^9, 3.6506532033436737`*^9}, {3.650653239164942*^9, 
   3.650653252989925*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"akpopupGraph2", "[", "pt_", "]"}], ":=", 
  RowBox[{"AKconf3dplot", "@@", 
   RowBox[{"(", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"pt", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
          "*", "10000"}], ",", "0.1"}], "]"}], ",", 
      RowBox[{"pt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "}"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aktoolRule2", "=", 
   RowBox[{
    RowBox[{"Tooltip", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"PopupWindow", "[", 
     RowBox[{
      RowBox[{"Tooltip", "[", "x", "]"}], ",", 
      RowBox[{"akpopupGraph2", "@", 
       RowBox[{"Last", "@", 
        RowBox[{"{", "x", "}"}]}]}], ",", 
      RowBox[{"WindowSize", "\[Rule]", "All"}]}], "]"}]}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.650542872172657*^9, 3.650542891221785*^9}, {
   3.6505429912284403`*^9, 3.6505429956829863`*^9}, {3.650543318063691*^9, 
   3.6505433182759037`*^9}, {3.650543639000567*^9, 3.650543641291944*^9}, 
   3.650543718649445*^9, {3.65054376544765*^9, 3.6505438489887753`*^9}, {
   3.6505439033452063`*^9, 3.650543904350047*^9}, 3.6505447422030983`*^9, {
   3.650545071611758*^9, 3.650545142738098*^9}, 3.650545177965914*^9, {
   3.650545454044064*^9, 3.650545464578726*^9}, {3.65054554656952*^9, 
   3.6505456119588223`*^9}, {3.650545646345921*^9, 3.650545646552425*^9}, {
   3.6505456981382093`*^9, 3.6505457206475353`*^9}, 3.650545756265128*^9, {
   3.650545867708852*^9, 3.650545908653254*^9}, 3.650624467185493*^9, {
   3.65062478526792*^9, 3.650624798354414*^9}, {3.650628734503687*^9, 
   3.650628735542631*^9}, {3.650651672367495*^9, 3.650651691865274*^9}, {
   3.6506531679478703`*^9, 3.650653264481757*^9}, {3.650654271478572*^9, 
   3.6506542772828417`*^9}, {3.650655782955661*^9, 3.650655783226962*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"akpopupGraph3", "[", "pt_", "]"}], ":=", 
  RowBox[{"AKconf3dplot", "@@", 
   RowBox[{"(", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
          "pt", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}],
          "*", "10000"}], ",", "0.1"}], "]"}], ",", 
      RowBox[{"pt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
     "}"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aktoolRule3", "=", 
   RowBox[{
    RowBox[{"Tooltip", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"PopupWindow", "[", 
     RowBox[{
      RowBox[{"Tooltip", "[", "x", "]"}], ",", 
      RowBox[{"akpopupGraph3", "@", 
       RowBox[{"Last", "@", 
        RowBox[{"{", "x", "}"}]}]}], ",", 
      RowBox[{"WindowSize", "\[Rule]", "All"}]}], "]"}]}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.650542872172657*^9, 3.650542891221785*^9}, {
   3.6505429912284403`*^9, 3.6505429956829863`*^9}, {3.650543318063691*^9, 
   3.6505433182759037`*^9}, {3.650543639000567*^9, 3.650543641291944*^9}, 
   3.650543718649445*^9, {3.65054376544765*^9, 3.6505438489887753`*^9}, {
   3.6505439033452063`*^9, 3.650543904350047*^9}, 3.6505447422030983`*^9, {
   3.650545071611758*^9, 3.650545142738098*^9}, 3.650545177965914*^9, {
   3.650545454044064*^9, 3.650545464578726*^9}, {3.65054554656952*^9, 
   3.6505456119588223`*^9}, {3.650545646345921*^9, 3.650545646552425*^9}, {
   3.6505456981382093`*^9, 3.6505457206475353`*^9}, 3.650545756265128*^9, {
   3.650545867708852*^9, 3.650545908653254*^9}, 3.650624467185493*^9, {
   3.65062478526792*^9, 3.650624798354414*^9}, {3.650628734503687*^9, 
   3.650628735542631*^9}, {3.650651672367495*^9, 3.650651691865274*^9}, {
   3.6506531679478703`*^9, 3.650653264481757*^9}, {3.650654271478572*^9, 
   3.6506542772828417`*^9}, {3.650655782955661*^9, 3.650655783226962*^9}, {
   3.651574171559752*^9, 3.651574202681203*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["plot", "Subsubsection",
 CellChangeTimes->{{3.650646879878034*^9, 3.650646886341642*^9}}],

Cell["kink", "Text",
 CellChangeTimes->{{3.658758286625122*^9, 3.658758287104062*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"pd1", "=", 
  RowBox[{"ListPlot", "@@", 
   RowBox[{"Join", "[", 
    RowBox[{"PlotContent1", ",", " ", 
     RowBox[{"{", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Large"}], "}"}]}], "}"}], ",", 
     "plotsetting", ",", 
     RowBox[{"{", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, 3.650545873500393*^9, 
   3.6506457105739193`*^9, 3.65064664272902*^9, {3.6506515646353807`*^9, 
   3.650651596389538*^9}, 3.6506557426875*^9, {3.650694729308786*^9, 
   3.650694734910963*^9}, 3.658757802935075*^9, {3.658758010765539*^9, 
   3.658758016652473*^9}, {3.658758047373497*^9, 3.658758068524641*^9}, {
   3.658765187315174*^9, 3.65876522179289*^9}, {3.658765479034423*^9, 
   3.658765514243589*^9}, {3.6587655597227697`*^9, 3.6587655985090227`*^9}, 
   3.6587657491401253`*^9, {3.66115088777076*^9, 3.66115094678798*^9}, 
   3.666523978064706*^9, 3.666524009185421*^9, {3.6665240666267147`*^9, 
   3.666524066805653*^9}}],

Cell[BoxData[
 RowBox[{"pd1", "=", 
  RowBox[{"ListPlot", "@@", 
   RowBox[{"Join", "[", 
    RowBox[{"PlotContent1", ",", " ", 
     RowBox[{"{", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Blue", ",", "Thick", ",", 
             RowBox[{"Circle", "[", "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "20"}]}], "]"}], ",", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Orange", ",", "Thick", ",", 
             RowBox[{"Disk", "[", "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "20"}]}], "]"}]}], "}"}]}], "}"}], 
     ",", "plotsetting", ",", 
     RowBox[{"{", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, 3.650545873500393*^9, 
   3.6506457105739193`*^9, 3.65064664272902*^9, {3.6506515646353807`*^9, 
   3.650651596389538*^9}, 3.6506557426875*^9, {3.650694729308786*^9, 
   3.650694734910963*^9}, 3.658757802935075*^9, {3.658758010765539*^9, 
   3.658758016652473*^9}, {3.658758047373497*^9, 3.658758068524641*^9}, {
   3.658765187315174*^9, 3.65876522179289*^9}, {3.658765479034423*^9, 
   3.658765514243589*^9}, {3.6587655597227697`*^9, 3.6587655985090227`*^9}, 
   3.6587657491401253`*^9, {3.66115088777076*^9, 3.66115094678798*^9}, 
   3.666523978064706*^9, 3.666524009185421*^9, {3.6665240666267147`*^9, 
   3.666524066805653*^9}, {3.6748329384814*^9, 3.674832942066818*^9}, {
   3.6748330824205217`*^9, 3.674833086435533*^9}, {3.67896611485441*^9, 
   3.678966119205801*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.009166666666666668], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            RGBColor[0, 0, 1], 
            Thickness[Large], 
            CircleBox[{0, 0}]}, ImageSize -> 20], {0., 0.}], CompressedData["
1:eJxdlTGI1UAQhp9eFW0OIkJAJCEhJCSEgLaS66zP2upALbWw0ja22mxzFgvi
gizI1md7tdbWVwZtLex8T52B+QKP47/d+Wb3Z/i3Onv+6MnRbre73P+u7X/X
97/354dvW17fSg+vXr1c/unfqu/fO3xHJ3Y9U737+x2f2P256mdPD99t1Eu/
Ff1W9FvRb0W/Ff1W9JP6QvW3r4fvDta35cvdNz9OL97qeUTLeex6plrOY/fn
quU8tr5QLeexvBL7K/BrrIufDn46+Ongp4OfDn46+Ongp4OfTs9v91fg16hv
0K9F/fb/77neT7Tcz65nquV+dn+uWu5n6wvVcj/LK7G/Ar9GfYN+LXgdeD20
zKfHfHrMp8d8esynx3x6zKfHfHrMp8d8esynx3x6vb/t14LXgdeDN2B9W36e
Xuz/80H9EC1+2PVMtfhh9+eqxQ9bX6gWPyyvxP4K/Br1Dfq14HXg9eAN4I3g
TaiXfAjIh4B8CMiHgHwIyIeAfAjIh4B8CMiHgHwIyIeAfAjIh6B+WV4P3gDe
CN4E3gzettz8/vHFgxuf1D/R4p9dz1SLf3Z/rlr8s/WFavHP8krsr8CvUd+g
XwteB14P3gDeCN4E3gye5HdEfkfkd0R+R+R3RH5H5HdEfkfkd0R+R+R3RH5H
5HdEfkfkd0R+R/XP8kbwJvBm8Lalf/zu8lf3Wf0TLf7Z9Uy1+Gf356rFP1tf
qBb/LK/E/gr8GvUN+rXgdeD14A3gjeBN4M3gyfuZ8H4mvJ9J/RNt38+E9zPh
/Uzqn2j7fia8n0n9s/wa9Q36teB14PXgDeCN4E3gzar/AO7lOfw=
         "]]}, {
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.009166666666666668], 
             RGBColor[0.880722, 0.611041, 0.142051], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            RGBColor[1, 0.5, 0], 
            Thickness[Large], 
            DiskBox[{0, 0}]}, ImageSize -> 20], {0., 0.}], CompressedData["
1:eJx1jzEOAUEYhQdX0EhEbIgQMtmEfnXqdQQJSo2K9teqplnFJi6gXnfgEGoO
YcbkzcYTf/IXbzL/e9+LFpv5sqaU0nYrdqt2T5mbxnRfv8weu21yv7lpBq0+
0w7a/4+CnozddOi+G/R65aZHfn3yG5DfkPxG5KfJL/7DK8QrxCvEK8QrxCvE
K8QrxCvEK8Rb5l9bh2daHEM+NPKhkQ+NfGjkf/tp8ot//D2PoX6G+hnqZ6if
oX7lvffNwj007qFxz/89b059cupT6lda2Jdz8gbQiivW
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {0.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {1.6, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {3.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {0.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {1.6, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {3.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {6.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {7.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], 
        Annotation[#, {9.600000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {0.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {1.6, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {3.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {6.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {7.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {10.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {0.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {1.6, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {3.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {6.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {7.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {10.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {4., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {0.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {1.6, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {3.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {6.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {7.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {10.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {14.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {0.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {1.6, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {3.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {6.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {7.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {10.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {14.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {16., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.045000000000000005`"}], "}"}
          ]], 
        Annotation[#, {15.200000000000001`, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {0.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {14.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {16., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {14.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {16., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], 
        Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {6.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {7.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {10.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {14.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {16., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {10.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {14.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {16., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {14.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {16., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {14.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {16., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {14.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {16., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {14.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {16., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {16., 0.035}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.5625, 0}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, DisplayFunction -> 
     Identity, AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.5625, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, 
     PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"Transmission\"", "\"Splitting\""}, "PointLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox["\"Kink\"", {
                 Directive[FontSize -> Large], FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    RGBColor[0, 0, 1], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {15, 15},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    RGBColor[1, 0.5, 0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {15, 15},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline)], #2}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    RGBColor[0, 0, 1], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    RGBColor[1, 0.5, 0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                   "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Kink\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "15"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.6789661444087343`*^9}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.009166666666666668], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            GrayLevel[0], 
            Thickness[Large], 
            CircleBox[{0, 0}]}, ImageSize -> 20], {0., 0.}], CompressedData["
1:eJxdlTGI1UAQhp9eFW0OIkJAJCEhJCSEgLaS66zP2upALbWw0ja22mxzFgvi
gizI1md7tdbWVwZtLex8T52B+QKP47/d+Wb3Z/i3Onv+6MnRbre73P+u7X/X
97/354dvW17fSg+vXr1c/unfqu/fO3xHJ3Y9U737+x2f2P256mdPD99t1Eu/
Ff1W9FvRb0W/Ff1W9JP6QvW3r4fvDta35cvdNz9OL97qeUTLeex6plrOY/fn
quU8tr5QLeexvBL7K/BrrIufDn46+Ongp4OfDn46+Ongp4OfTs9v91fg16hv
0K9F/fb/77neT7Tcz65nquV+dn+uWu5n6wvVcj/LK7G/Ar9GfYN+LXgdeD20
zKfHfHrMp8d8esynx3x6zKfHfHrMp8d8esynx3x6vb/t14LXgdeDN2B9W36e
Xuz/80H9EC1+2PVMtfhh9+eqxQ9bX6gWPyyvxP4K/Br1Dfq14HXg9eAN4I3g
TaiXfAjIh4B8CMiHgHwIyIeAfAjIh4B8CMiHgHwIyIeAfAjIh6B+WV4P3gDe
CN4E3gzettz8/vHFgxuf1D/R4p9dz1SLf3Z/rlr8s/WFavHP8krsr8CvUd+g
XwteB14P3gDeCN4E3gye5HdEfkfkd0R+R+R3RH5H5HdEfkfkd0R+R+R3RH5H
5HdEfkfkd0R+R/XP8kbwJvBm8Lalf/zu8lf3Wf0TLf7Z9Uy1+Gf356rFP1tf
qBb/LK/E/gr8GvUN+rXgdeD14A3gjeBN4M3gyfuZ8H4mvJ9J/RNt38+E9zPh
/Uzqn2j7fia8n0n9s/wa9Q36teB14PXgDeCN4E3gzar/AO7lOfw=
         "]]}, {
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.009166666666666668], 
             RGBColor[0.880722, 0.611041, 0.142051], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            GrayLevel[0], 
            Thickness[Large], 
            DiskBox[{0, 0}]}, ImageSize -> 20], {0., 0.}], CompressedData["
1:eJx1jzEOAUEYhQdX0EhEbIgQMtmEfnXqdQQJSo2K9teqplnFJi6gXnfgEGoO
YcbkzcYTf/IXbzL/e9+LFpv5sqaU0nYrdqt2T5mbxnRfv8weu21yv7lpBq0+
0w7a/4+CnozddOi+G/R65aZHfn3yG5DfkPxG5KfJL/7DK8QrxCvEK8QrxCvE
K8QrxCvEK8Rb5l9bh2daHEM+NPKhkQ+NfGjkf/tp8ot//D2PoX6G+hnqZ6if
oX7lvffNwj007qFxz/89b059cupT6lda2Jdz8gbQiivW
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {0.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {1.6, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {3.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {0.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {1.6, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {3.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {6.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {7.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], 
        Annotation[#, {9.600000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {0.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {1.6, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {3.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {6.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {7.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {10.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {0.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {1.6, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {3.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {6.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {7.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {10.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {4., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {0.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {1.6, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {3.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {6.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {7.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {10.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {14.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {0.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {1.6, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {3.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {6.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {7.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {10.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {14.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {16., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.045000000000000005`"}], "}"}
          ]], 
        Annotation[#, {15.200000000000001`, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {0.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {14.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {16., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {14.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {16., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], 
        Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {6.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {7.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {10.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {14.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {16., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {10.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {14.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {16., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {14.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {16., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {14.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {16., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {14.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {16., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {14.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {16., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {16., 0.035}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.5625, 0}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, DisplayFunction -> 
     Identity, AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.5625, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, 
     PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"Transmission\"", "\"Splitting\""}, "PointLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox["\"Kink\"", {
                 Directive[FontSize -> Large], FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {15, 15},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.22000000000000003`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 20}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {15, 15},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.23333333333333334`] -> 
                    Baseline)], #2}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    DiskBox[{0, 0}]}, ImageSize -> 20], ",", "Automatic"}], 
                   "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Kink\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "15"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.674833095331798*^9}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          BoxData[
           FormBox[
            StyleBox[
            "\"\[FilledCircle]\"", FontSize -> Large, StripOnInput -> False], 
            TraditionalForm]], {0., 0.}], CompressedData["
1:eJxdlTGI1UAQhp9eFW0OIkJAJCEhJCSEgLaS66zP2upALbWw0ja22mxzFgvi
gizI1md7tdbWVwZtLex8T52B+QKP47/d+Wb3Z/i3Onv+6MnRbre73P+u7X/X
97/354dvW17fSg+vXr1c/unfqu/fO3xHJ3Y9U737+x2f2P256mdPD99t1Eu/
Ff1W9FvRb0W/Ff1W9JP6QvW3r4fvDta35cvdNz9OL97qeUTLeex6plrOY/fn
quU8tr5QLeexvBL7K/BrrIufDn46+Ongp4OfDn46+Ongp4OfTs9v91fg16hv
0K9F/fb/77neT7Tcz65nquV+dn+uWu5n6wvVcj/LK7G/Ar9GfYN+LXgdeD20
zKfHfHrMp8d8esynx3x6zKfHfHrMp8d8esynx3x6vb/t14LXgdeDN2B9W36e
Xuz/80H9EC1+2PVMtfhh9+eqxQ9bX6gWPyyvxP4K/Br1Dfq14HXg9eAN4I3g
TaiXfAjIh4B8CMiHgHwIyIeAfAjIh4B8CMiHgHwIyIeAfAjIh6B+WV4P3gDe
CN4E3gzettz8/vHFgxuf1D/R4p9dz1SLf3Z/rlr8s/WFavHP8krsr8CvUd+g
XwteB14P3gDeCN4E3gye5HdEfkfkd0R+R+R3RH5H5HdEfkfkd0R+R+R3RH5H
5HdEfkfkd0R+R/XP8kbwJvBm8Lalf/zu8lf3Wf0TLf7Z9Uy1+Gf356rFP1tf
qBb/LK/E/gr8GvUN+rXgdeD14A3gjeBN4M3gyfuZ8H4mvJ9J/RNt38+E9zPh
/Uzqn2j7fia8n0n9s/wa9Q36teB14PXgDeCN4E3gzar/AO7lOfw=
         "]]}, {
        Directive[
         PointSize[0.009166666666666668], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          BoxData[
           FormBox[
            StyleBox[
            "\"\[FilledSquare]\"", FontSize -> Large, StripOnInput -> False], 
            TraditionalForm]], {0., 0.}], CompressedData["
1:eJx1jzEOAUEYhQdX0EhEbIgQMtmEfnXqdQQJSo2K9teqplnFJi6gXnfgEGoO
YcbkzcYTf/IXbzL/e9+LFpv5sqaU0nYrdqt2T5mbxnRfv8weu21yv7lpBq0+
0w7a/4+CnozddOi+G/R65aZHfn3yG5DfkPxG5KfJL/7DK8QrxCvEK8QrxCvE
K8QrxCvEK8Rb5l9bh2daHEM+NPKhkQ+NfGjkf/tp8ot//D2PoX6G+hnqZ6if
oX7lvffNwj007qFxz/89b059cupT6lda2Jdz8gbQiivW
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {0.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {1.6, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {3.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {0.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {1.6, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {3.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {6.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {7.2, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {0.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {1.6, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {3.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {6.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {7.2, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {8.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {10.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {0.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {1.6, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {3.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {6.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {7.2, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {8.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {10.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {12.8, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {4., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.030000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {12.8, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {0.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {1.6, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {3.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {6.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {7.2, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {8.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {10.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12., 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {12.8, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {14.4, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.035}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {0.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {1.6, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {3.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {6.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {7.2, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {8.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {10.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {12.8, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {14.4, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.04}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.04`"}], "}"}]], 
        Annotation[#, {16., 0.04}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.045000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.045000000000000005`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.045000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.045000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.045000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.045000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {0.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {14.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {16., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {14.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {16., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {14.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {16., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {6.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {7.2, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {8.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {10.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {12.8, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {14.4, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.005}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.005`"}], "}"}]], 
        Annotation[#, {16., 0.005}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {8.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {10.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {12.8, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {14.4, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.01}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.01`"}], "}"}]], 
        Annotation[#, {16., 0.01}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {12.8, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.015000000000000001`"}], 
           "}"}]], Annotation[#, {13.600000000000001`, 0.015000000000000001`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {14.4, 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.015000000000000001`"}], "}"}
          ]], 
        Annotation[#, {15.200000000000001`, 0.015000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.015000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.015000000000000001`"}], "}"}]], 
        Annotation[#, {16., 0.015000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12.8, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"12.8`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {12.8, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {14.4, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.02}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.02`"}], "}"}]], 
        Annotation[#, {16., 0.02}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{13.600000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"13.600000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {13.600000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {14.4, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {15.200000000000001`, 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.025}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.025`"}], "}"}]], 
        Annotation[#, {16., 0.025}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{14.4, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"14.4`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {14.4, 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{15.200000000000001`, 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"15.200000000000001`", ",", "0.030000000000000002`"}], 
           "}"}]], Annotation[#, {15.200000000000001`, 0.030000000000000002`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.030000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.030000000000000002`"}], "}"}]], 
        Annotation[#, {16., 0.030000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{16., 0.035}]}}, 
         RowBox[{"{", 
           RowBox[{"16.`", ",", "0.035`"}], "}"}]], 
        Annotation[#, {16., 0.035}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.5625, 0}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, DisplayFunction -> 
     Identity, AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.5625, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 16.}, {0, 0.060000000000000005`}}, 
     PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"Transmission\"", "\"Splitting\""}, "PointLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox["\"Kink\"", {
                 Directive[FontSize -> Large], FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.11000000000000001`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.11000000000000001`], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], FontSize -> 15, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.11000000000000001`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.11000000000000001`], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], FontSize -> 15, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #2}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.009166666666666668`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledCircle]\"", ",", "Large"}], "}"}], ",", 
                 
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledSquare]\"", ",", "Large"}], "}"}]}], 
               "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Kink\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "30"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.665488822533165*^9}],

Cell[BoxData[
 RowBox[{"pd1", "=", 
  RowBox[{
   RowBox[{"ListPlot", "@@", 
    RowBox[{"Join", "[", 
     RowBox[{"PlotContent1", ",", "plotsetting", ",", 
      RowBox[{"{", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], "}"}]}], "]"}]}], "/.", 
   "ktoolRule1"}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, 3.650545873500393*^9, 
   3.6506457105739193`*^9, 3.65064664272902*^9, {3.6506515646353807`*^9, 
   3.650651596389538*^9}, 3.6506557426875*^9, {3.650694729308786*^9, 
   3.65069473153533*^9}}],

Cell[BoxData[
 RowBox[{"pd1", "=", 
  RowBox[{
   RowBox[{"ListPlot", "@@", 
    RowBox[{"Join", "[", 
     RowBox[{"PlotContent1", ",", "plotsetting", ",", 
      RowBox[{"{", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], "}"}]}], "]"}]}], "/.", 
   "ktoolRule2"}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, 3.650545873500393*^9, 
   3.6506457105739193`*^9, 3.65064664272902*^9, {3.6506515646353807`*^9, 
   3.650651596389538*^9}, {3.6506557426875*^9, 3.65065574618863*^9}}],

Cell["antikink", "Text",
 CellChangeTimes->{{3.658758277584001*^9, 3.658758279519985*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"pd2", "=", 
  RowBox[{"ListPlot", "@@", 
   RowBox[{"Join", "[", 
    RowBox[{"PlotContent3", ",", 
     RowBox[{"{", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Medium"}], "}"}]}], "}"}], ",", 
     "plotsetting", ",", 
     RowBox[{"{", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, {3.650375268105143*^9, 
   3.650375274015318*^9}, {3.650545916542509*^9, 3.650545918030056*^9}, 
   3.6506457072835703`*^9, {3.650653098235167*^9, 3.650653104876114*^9}, 
   3.650653180347351*^9, 3.650653348464078*^9, {3.650654252200468*^9, 
   3.6506542524368267`*^9}, 3.65069465508596*^9, 3.658758453110383*^9, {
   3.658759019123575*^9, 3.658759026948634*^9}, {3.6587654144412107`*^9, 
   3.65876545791781*^9}, {3.6587656106493053`*^9, 3.658765682352654*^9}, 
   3.658765741302019*^9, {3.6611509567500467`*^9, 3.661150960172236*^9}, 
   3.6665240298142548`*^9, 3.6665240622419662`*^9}],

Cell[BoxData[
 RowBox[{"pd2", "=", 
  RowBox[{"ListPlot", "@@", 
   RowBox[{"Join", "[", 
    RowBox[{"PlotContent3", ",", 
     RowBox[{"{", 
      RowBox[{"PlotMarkers", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Blue", ",", 
             RowBox[{"Thickness", "[", "0.05", "]"}], ",", 
             RowBox[{"Circle", "[", "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "8"}]}], "]"}], ",", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Red", ",", "Thick", ",", 
             RowBox[{"Polygon", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "6"}]}], "]"}], ",", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Green", ",", "Thick", ",", 
             RowBox[{"Polygon", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"Sqrt", "[", "3", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], "]"}]}], 
            "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "8"}]}], "]"}]}], "}"}]}], "}"}], 
     ",", "plotsetting", ",", 
     RowBox[{"{", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, {3.650375268105143*^9, 
   3.650375274015318*^9}, {3.650545916542509*^9, 3.650545918030056*^9}, 
   3.6506457072835703`*^9, {3.650653098235167*^9, 3.650653104876114*^9}, 
   3.650653180347351*^9, 3.650653348464078*^9, {3.650654252200468*^9, 
   3.6506542524368267`*^9}, 3.65069465508596*^9, 3.658758453110383*^9, {
   3.658759019123575*^9, 3.658759026948634*^9}, {3.6587654144412107`*^9, 
   3.65876545791781*^9}, {3.6587656106493053`*^9, 3.658765682352654*^9}, 
   3.658765741302019*^9, {3.6611509567500467`*^9, 3.661150960172236*^9}, 
   3.6665240298142548`*^9, 3.6665240622419662`*^9, {3.674832962704143*^9, 
   3.674832977809985*^9}, {3.6748330341030273`*^9, 3.674833044499234*^9}, {
   3.674833075433982*^9, 3.674833077698985*^9}, {3.674833125653009*^9, 
   3.674833130473074*^9}, {3.674833298186182*^9, 3.674833345051359*^9}, {
   3.674833448539529*^9, 3.674833454272068*^9}, {3.678965978211752*^9, 
   3.678966086374404*^9}, {3.678966212617764*^9, 3.678966213114667*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            RGBColor[0, 0, 1], 
            Thickness[0.05], 
            CircleBox[{0, 0}]}, ImageSize -> 8], {0., 0.}], CompressedData["
1:eJxl2N9u40QYhvFAJaRKHLRqVTVKFDmJ8+d8Od9eA5eABBxyPXBNcM45CIFA
aGrGrpM4Cdt1Zir/NtqV9TUzjxXPfM878vybH77+9mo0Gv362Wj04d/o8w//
v3r3+tk8fby8++396ONnS108/fLz6+f39/31rf7px9fPPNfff/f6WeS65y9z
3fNKeCW8Fbw1vA28LeMfnvrrH5fvH3Pd88e57nmTXPecaa776wxewfgC/pz5
C+63hFfCK+Gt4K3hbeBt4X351P/9zwvvNtf9/Ltc9+Pvc52eZ6rT8xzyxvAm
8KbwZvAKxr/V6XkO5y+43xJeCa+Et4K3hreBt+X7q6ee89dl/he57q/XuU7P
P9U954bxt7lO6zGcf8/9HuA9whvDm8CbwpvBKxhfwJ8zf8H9lvBKeCW8Fbw1
vA28Ld//d7n+feHtct2PHz2lOq1fqtP6Dedf5zqt35B3w/hb+HfMv+d+D/Ae
4Y3hTeBN4c3gFYwv4M+Zv+B+S3glvBLeCt4a3gbelvlpX/yT1zPVaT1TndZz
OP4q12k9h/Ovc53Wc8i7Yfwt/Dvm33O/B3iP8MbwJvCm8GbwCsYX8OfMX3C/
JbwSXglvBW8NbwNvy/zUx//m9Ux1Ws9Up/Ucjr/KdVrP4fzrXKf1HPJuGH8L
/47599zvAd4jvDG8CbwpvBm8gvEF/DnzF9xvCa+EV8JbwVvD28DbMj95N+T1
THVaz1Sn9RyOv8p1Ws/h/OtcD88rIa/ncPxtrofnl8D5JXB+CZxfAueXwPkl
cH4JnF8C55fA+SVwfgmcXwLnl8D5JXB+CZxfAueXwPklcH4J+DLgy4AvA74M
+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M
+PLteffXZ86Lz5wXnzkvPnNefM7PO9XD8+Jzft5D3hjeBN4U3gxewfgC/pz5
C+63hFfCK+Gt4K3hbeBtP3me/byKfKjIh4p8qMiHinyoyIeKfKjIh4p8qMiH
inyoyIeKfKjIh4p8qMiHinyoyIeKfKjIh7fn9+6SC+n5pTo9v1Sn55fq9PxS
nZ7fkDeBN4U3g1cwvoA/Z/6C+y3hlfBKeCt4a3gbeNtPnk//90heRfIqkleR
vIrkVSSvInkVyatIXkXyKpJXkbyK5FUkryJ5FcmrSF5F8iOSH5H8iORHJD8i
+RHJj0h+RPIjkh+R/IjkRyQ/IvkRyY9IfkTyI5IfEb/X+L3G7zV+r/F7jd9r
/F7j9xq/1/i9xu81fq/xe43fa/xe4/cav9f4t8G/Df5t8G+Dfxv82+DfBv82
+LfBvw3+bfBvg38b/Nvg37ff119feD/wwvuBF94PvOTfl+rh+4GX/PtSPXw/
8JJ/35BXwlvBW8PbwNvyffJbi99a/Nbitxa/tfitxW8tfmvxW4vfWvzW4rcW
v7X4rcVHLT5q8VGLj1p81OKjFh+1+KjFRy0+avFRi49afNTijx3+2OGPHf7Y
4Y8d/tjhjx3+2OGPHf7Y4Y8d/tjhgz0+2OODPT7Y44M9Ptjjgz0+2OODPT7Y
44M9PtjT3wf6+0B/H+jvA/19oL8P9PeB/j7Q3wf6+0B/H+jPjv7s6M+O/uzo
z47+7OjPjv7s6M+O/uzor47+6uivjv7q6K+O/uror47+6uivjv440h9H+uNI
fxzpjyP9caQ/jvTHkf19Yn+f2N8n9veJ/X1if5/Y3yf294n9eWZ/ntmfZ/bn
mf15Zn+e2Z9n9ld67/xWD/dXeo+5zvVwf6X3Yttc/w/GeaUf
         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.880722, 0.611041, 0.142051], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            RGBColor[1, 0, 0], 
            Thickness[Large], 
            PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, ImageSize -> 6], {
          0., 0.}], CompressedData["
1:eJxlmD2M41QUhQMjrRSgiGUrsmXLenacxNTQoklHvVtTIQEl1FBTUyJolwYJ
rUCA2GlJZQkkpCm2phxBwZJJsOM/ZjZz3uh9myY643u/6+d733meZO9//OiD
s8lk8uWrk8krN983X5O337r97M6//ur28+3dd2P15PTZSJ/iz6z+6MPbz4ON
mz+1+vffbj9vbFzeDPEe+D7yA9SbgxeCF4EXg5eAl4JnEG/Az5Cfo94CvAK8
ArwleCvw1uCVuL47f/O9L37dl9/Z/kmrf9Lqn7T65+ZPrVb/XN4M8R74PvID
1JuDF4IXgReDl4CXgmcQb8DPkJ+j3gK8ArwCvCV4K/DW4JUb9usi/fyvh0+f
2H5Jq1/S6pe0+iWtfrm8GeI98H3kB6g3By8ELwIvBi8BLwXPIN6AnyE/R70F
eAV4BXhL8FbgrcErcX13/s0n77z27PH3tn/S6p+0+iet/rn5U6vVP5c3Q7wH
vo/8APXm4IXgReDF4CXgpeAZxBvwM+TnqLcArwCvAG8J3gq8NXglru/O/374
9KajP9j+Sat/0uqftPrn5k+tVv9c3gzxHvg+8gPUm4MXgheBF4OXgJeCZxBv
wM+Qn6PeArwCvAK8JXgr8Nbglbi+O3/x9daPtn/S6p+0+iet/rn5U6vVP5c3
Q7wHvo/8APXm4IXgReDF4CXgpeAZxBvwM+TnqLcArwCvAG8J3gq8NXgl8pvz
z4In7/756U+2X9Lql7T6Ja1+SatfLm+GeA98H/kB6s3BC8GLwIvBS8BLwTOI
N+BnyM9RbwFeAV4B3hK8FXhr8MoN+7PdlzdvLD/b/kirP9Lqj7T6I63+uPEe
+D7yA9SbgxeCF4EXg5eAl4JnEG/Az5Cfo94CvAK8ArwleCvw1uCVyG/OX3/2
+OaE+8X2S1r9kla/pNUvafXL5c0Q74HvIz9AvTl4IXgReDF4CXgpeAbxBvwM
+TnqLcArwCvAW4K3Am8NXrlhfx49ffFCafsjrf5Iqz/S6o+0+uPGe+D7yA9Q
bw5eCF4EXgxeAl4KnkG8AT9Dfo56C/AK8ArwluCtwFuDV0Lr944L/N5xgd87
LvB7xwV+77jA7x0Xtj8u30d+gHpz8ELwIvBi8BLwUvAM4g34GfJz1FuAV4BX
gLcEbwXeGrzyped/ep/Y4v1ti/e3Ld7ftnh/2+L9bYv3ty3e37b2+bu8CLwY
vAS8FDyDeAN+hvwc9RbgFeAV4C3BW4G3Bq986fmdvivMb4X5rTC/Fea3wvxW
mN8K81thfivMb4X5rTC/Fea3wvxWmN8K81thfivMb4X5rTC/9+s9/f0Pu15p
rVda65XWet34e631uvk56i3AK8ArwFuCtwJvDV75Ev80P5eYx0vM4yXm8RLz
eIl5VP7VHfcf+/+htN6PpE/5k417/eru+7nNl1a+tPLd+DOr3fPhueWf/v6v
5UuLLy2+G39mtfhu/tRq+Z97/eru/+Md/n/e2frSqu/Gn1nt+u8O/ruD/+7g
vzt7P6e/X9v7kdb9SOt+3Pgzq3U/bv7Uat2Py5sh3gPfx3XN1zXm6xrzdY35
ur9fad2vmz+1Wvfr8maI98D3cV3zvMc87zHPe8zzHvO8xzzv7f1Ku+87e7zv
7O39unwf+QHitV8O2C8H7JcD9ssB++WA/XLAfjlgvxzs/bvxHvg+8gPUm4MX
gnd1x/nPrk9a65PW+tz4M6u1Pjd/arXW5/JmiPfA95EfoN4cvBC8CFr7vcZ+
r7Hfa+z3Gvu9xn6vsd9r7Pca+73Gfq+x32u7XrfeHLwQvAhaflHDL2r4RQ2/
qOEXNfyihl/U8IsaflHDL2r4xf163Xpz8ELwIvBiXL/CHO/gOw36Lv9p4D8N
/KeB/zTwnwb+08B/GvhPA/9p8L7a2PW7vAi8GLwE8fKzI/zsCD87ws+O8LMj
/OwIPzvCz47wsyP87Ag/O8LPjvCzI/zsaJ+Hy4vBSxAv/2vhfy3mpoX/tfC/
Fv7Xwv9a+F8L/2vhfy38r4X/tfC/Fv7Xwv9a+zxcXgJeinz5ZQe/7LBvOvhl
B7/s4Jcd/LKDX3bwyw5+2cEvO/hlB7/s4Jcd/LKzz8flJeCl4Bnw5Lcd/LaD
33bw2w5+28FvO/htB7/t4Lcd/LaD33bw2w5+28FvO/htB7+9f14uLwXPIN6A
L7/u4dc9/LqHX/fw6x5+3cOve/h1D7/u4dc9/LqHX/fw6x5+3cOve/h1D7/u
7fNzeQbxBvwMWn4/wO8H+P0Avx/g9wP8foDfD/D7AX4/wO8H+P0Avx/g9wP8
foDfD/D7AX4/2Ofp8gziDfgZtM6LEefFiPNixHkx4rwYcV6MOC9GnBcjzosR
58WI82LEeTHivBhxXow4L0acFyPOixHnxWifpxtvwM+Qn+P6FZ7bDvu8wTlz
/+2eN5rjBxs3f2q1e96IM0O8Z7V73ig/sNo9b8QLrXbPG/Fiq93zRrzUaj1f
N/5e6/m6+TnqLaz+H0K7a38=
         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.560181, 0.691569, 0.194885], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            RGBColor[0, 1, 0], 
            Thickness[Large], 
            PolygonBox[
             
             NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 0}, {
               0, 1.7320508075688772`}, {-1, 0}}]]}, ImageSize -> 8], {0., 
          0.}], CompressedData["
1:eJxdlj+IE1EQxlcDQtQiYZeQkBA2yeaP9dlK0lnf1VaCWmqttbW1tmcph6Li
XetVAQUh4LFgsUMeIcvZyRV2JneZkfktd4QvO/N7L2/g+17v4dODR5UoijrX
omjzF13f/L95vX3K6Z0Hr75eTN5NVZ90X57vHx9N7+5tnz+m9f3bZ/dunh2+
N/17/3hT8cH0ZdveR9MvkqP78vyT8ahPLyabHXze1f+FLqe3zg43K36xetX6
/uD4coP2XrXyvC53nydWr1rrvdbfc2r1qrVedXT1zHx9Zebrdf051p9j/bnx
fH3F9JPH2+fGzPdXTX//tn1uzzyvhvpy9/0P249q3Y9q3Y+vr5jW/fj+qmnd
j+fVUF8HP0Z/gvUa4DXB0/ktML8F5rfA/BaY38J+n++vmtbf53k11NfBj9Gf
YL0GeE3wWuC1weuA1wUvRX0Kfg/9faw3QH25q/tp561az1u1nrevr5jW8/b9
VdN63p5XQ30d/Bj9CdZrgNcErwVeG7wOeF3wUtSn4PfQ38d6A/Ay8DLwhuCN
wBuDN0G/+lUOv8rhVzn8Kodf5fCrHH6Vw69y+FVu8/T8GP0J1muA1wSvBV4b
vA54XfBS1Kfg99Dfx3oD8DLwMvCG4I3AG4M3QX+54/6yearWearWefr6immd
p++vmtZ5el4N9XXwY/QnWK8BXhO8Fnht8DrgdcFLUZ+C30N/H+sNwMvAy8Ab
gjcCbwzeBP2a3wXyu0B+F8jvAvldIL8Lm6dqn98F8ruweXp+jP7EtM/vAvld
2Dw9rw1eB7wueCnq/2udp+/vY70BeBl4GXhD8EbgjcGboF/9VuC3Ar8V+K3A
bwV+K/Bbgd8K/FbgtwK/FfitwG8FfivwW4HfCvxW4LcCvxX4rcBvBX4r8FuB
3wr8VuC3Ar8V+K3Ab8XmeXU/WuL+ucT9c4n759LmqdrfP5c2T9X+/rm0efr6
Ovgx+hOs1wCvCV4LvDZ4HfC64KWoT8Hvob+P9QbgZeBl4A3BG+G95mNAPgbk
Y0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4GO5+r71e4
369wv1/hfr+y81Ht7/crOx/V/n6/svPx9XXwY/QnqNe8XCMv18jLNfJyjbxc
Iy/Xtn/fX8P70j69v5fw9xL+zr7z6T/MUC2m
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {12., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {12., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {12., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {12., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.8500000000000001}, "Tooltip"]& ],
        
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {0.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {12., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {0.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {12., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {12., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {12., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], 
        Annotation[#, {11.600000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {12., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {12., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {12., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {12., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {12., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {12., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {12., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], 
        Annotation[#, {11.600000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {12., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {12., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {12., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {12., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {2., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {5.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {12., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {12., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {12., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {12., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {12., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {12., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {12., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {12., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {12., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {12., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {12., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {0.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {0.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {0.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {0.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {0.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {0.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {0.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {0.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {0.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {0.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {0.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {0.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9500000000000002`"}], 
           "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {0.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {0.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {0.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {0.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {0.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {0.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {0.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {0.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {0.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {0.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {0.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {0.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {1.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {2., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {5.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {7.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {12., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {0.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {12., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {0.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {12., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {0.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {12., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {0.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {12., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {0.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {0.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {0.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {0.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.8500000000000001}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.6250000000000001, 0}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, DisplayFunction -> Identity, 
     AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.6250000000000001, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
      "\"Transmission\"", "\"Reflection\"", "\"Trapping\"", "\"Splitting\""}, 
      "PointLegend", DisplayFunction -> (FormBox[
        TagBox[
         GridBox[{{
            StyleBox["\"Antikink\"", {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}, {
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    RGBColor[0, 0, 1], 
                    Thickness[0.05], 
                    CircleBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 8}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    RGBColor[1, 0, 0], 
                    Thickness[Large], 
                    PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 6}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #2}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    RGBColor[0, 1, 0], 
                    Thickness[Large], 
                    PolygonBox[
                    
                    NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 
                    0}, {0, 1.7320508075688772`}, {-1, 0}}]]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 8}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #3}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}}, 
          GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          GridBoxSpacings -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
        TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    RGBColor[0, 0, 1], 
                    Thickness[0.05], 
                    CircleBox[{0, 0}]}, ImageSize -> 8], ",", "Automatic"}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    RGBColor[1, 0, 0], 
                    Thickness[Large], 
                    PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, ImageSize -> 
                    6], ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    RGBColor[0, 1, 0], 
                    Thickness[Large], 
                    PolygonBox[
                    
                    NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 
                    0}, {0, 1.7320508075688772`}, {-1, 0}}]]}, ImageSize -> 
                    8], ",", "Automatic"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", 
             RowBox[{"Placed", "[", 
               RowBox[{"\"Antikink\"", ",", "Above"}], "]"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "20"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.678966217656109*^9}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            GrayLevel[0], 
            Thickness[Large], 
            CircleBox[{0, 0}]}, ImageSize -> 8], {0., 0.}], CompressedData["
1:eJxl2N9u40QYhvFAJaRKHLRqVTVKFDmJ8+d8Od9eA5eABBxyPXBNcM45CIFA
aGrGrpM4Cdt1Zir/NtqV9TUzjxXPfM878vybH77+9mo0Gv362Wj04d/o8w//
v3r3+tk8fby8++396ONnS108/fLz6+f39/31rf7px9fPPNfff/f6WeS65y9z
3fNKeCW8Fbw1vA28LeMfnvrrH5fvH3Pd88e57nmTXPecaa776wxewfgC/pz5
C+63hFfCK+Gt4K3hbeBt4X351P/9zwvvNtf9/Ltc9+Pvc52eZ6rT8xzyxvAm
8KbwZvAKxr/V6XkO5y+43xJeCa+Et4K3hreBt+X7q6ee89dl/he57q/XuU7P
P9U954bxt7lO6zGcf8/9HuA9whvDm8CbwpvBKxhfwJ8zf8H9lvBKeCW8Fbw1
vA28Ld//d7n+feHtct2PHz2lOq1fqtP6Dedf5zqt35B3w/hb+HfMv+d+D/Ae
4Y3hTeBN4c3gFYwv4M+Zv+B+S3glvBLeCt4a3gbelvlpX/yT1zPVaT1TndZz
OP4q12k9h/Ovc53Wc8i7Yfwt/Dvm33O/B3iP8MbwJvCm8GbwCsYX8OfMX3C/
JbwSXglvBW8NbwNvy/zUx//m9Ux1Ws9Up/Ucjr/KdVrP4fzrXKf1HPJuGH8L
/47599zvAd4jvDG8CbwpvBm8gvEF/DnzF9xvCa+EV8JbwVvD28DbMj95N+T1
THVaz1Sn9RyOv8p1Ws/h/OtcD88rIa/ncPxtrofnl8D5JXB+CZxfAueXwPkl
cH4JnF8C55fA+SVwfgmcXwLnl8D5JXB+CZxfAueXwPklcH4J+DLgy4AvA74M
+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M
+PLteffXZ86Lz5wXnzkvPnNefM7PO9XD8+Jzft5D3hjeBN4U3gxewfgC/pz5
C+63hFfCK+Gt4K3hbeBtP3me/byKfKjIh4p8qMiHinyoyIeKfKjIh4p8qMiH
inyoyIeKfKjIh4p8qMiHinyoyIeKfKjIh7fn9+6SC+n5pTo9v1Sn55fq9PxS
nZ7fkDeBN4U3g1cwvoA/Z/6C+y3hlfBKeCt4a3gbeNtPnk//90heRfIqkleR
vIrkVSSvInkVyatIXkXyKpJXkbyK5FUkryJ5FcmrSF5F8iOSH5H8iORHJD8i
+RHJj0h+RPIjkh+R/IjkRyQ/IvkRyY9IfkTyI5IfEb/X+L3G7zV+r/F7jd9r
/F7j9xq/1/i9xu81fq/xe43fa/xe4/cav9f4t8G/Df5t8G+Dfxv82+DfBv82
+LfBvw3+bfBvg38b/Nvg37ff119feD/wwvuBF94PvOTfl+rh+4GX/PtSPXw/
8JJ/35BXwlvBW8PbwNvyffJbi99a/Nbitxa/tfitxW8tfmvxW4vfWvzW4rcW
v7X4rcVHLT5q8VGLj1p81OKjFh+1+KjFRy0+avFRi49afNTijx3+2OGPHf7Y
4Y8d/tjhjx3+2OGPHf7Y4Y8d/tjhgz0+2OODPT7Y44M9Ptjjgz0+2OODPT7Y
44M9PtjT3wf6+0B/H+jvA/19oL8P9PeB/j7Q3wf6+0B/H+jPjv7s6M+O/uzo
z47+7OjPjv7s6M+O/uzor47+6uivjv7q6K+O/uror47+6uivjv440h9H+uNI
fxzpjyP9caQ/jvTHkf19Yn+f2N8n9veJ/X1if5/Y3yf294n9eWZ/ntmfZ/bn
mf15Zn+e2Z9n9ld67/xWD/dXeo+5zvVwf6X3Yttc/w/GeaUf
         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.880722, 0.611041, 0.142051], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            GrayLevel[0], 
            Thickness[Large], 
            PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, ImageSize -> 6], {
          0., 0.}], CompressedData["
1:eJxlmD2M41QUhQMjrRSgiGUrsmXLenacxNTQoklHvVtTIQEl1FBTUyJolwYJ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         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.004583333333333334], 
             RGBColor[0.560181, 0.691569, 0.194885], 
             AbsoluteThickness[1.6], 
             AbsolutePointSize[6]], 
            GrayLevel[0], 
            Thickness[Large], 
            PolygonBox[
             
             NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 0}, {
               0, 1.7320508075688772`}, {-1, 0}}]]}, ImageSize -> 8], {0., 
          0.}], CompressedData["
1:eJxdlj+IE1EQxlcDQtQiYZeQkBA2yeaP9dlK0lnf1VaCWmqttbW1tmcph6Li
XetVAQUh4LFgsUMeIcvZyRV2JneZkfktd4QvO/N7L2/g+17v4dODR5UoijrX
omjzF13f/L95vX3K6Z0Hr75eTN5NVZ90X57vHx9N7+5tnz+m9f3bZ/dunh2+
N/17/3hT8cH0ZdveR9MvkqP78vyT8ahPLyabHXze1f+FLqe3zg43K36xetX6
/uD4coP2XrXyvC53nydWr1rrvdbfc2r1qrVedXT1zHx9Zebrdf051p9j/bnx
fH3F9JPH2+fGzPdXTX//tn1uzzyvhvpy9/0P249q3Y9q3Y+vr5jW/fj+qmnd
j+fVUF8HP0Z/gvUa4DXB0/ktML8F5rfA/BaY38J+n++vmtbf53k11NfBj9Gf
YL0GeE3wWuC1weuA1wUvRX0Kfg/9faw3QH25q/tp561az1u1nrevr5jW8/b9
VdN63p5XQ30d/Bj9CdZrgNcErwVeG7wOeF3wUtSn4PfQ38d6A/Ay8DLwhuCN
wBuDN0G/+lUOv8rhVzn8Kodf5fCrHH6Vw69y+FVu8/T8GP0J1muA1wSvBV4b
vA54XfBS1Kfg99Dfx3oD8DLwMvCG4I3AG4M3QX+54/6yearWearWefr6immd
p++vmtZ5el4N9XXwY/QnWK8BXhO8Fnht8DrgdcFLUZ+C30N/H+sNwMvAy8Ab
gjcCbwzeBP2a3wXyu0B+F8jvAvldIL8Lm6dqn98F8ruweXp+jP7EtM/vAvld
2Dw9rw1eB7wueCnq/2udp+/vY70BeBl4GXhD8EbgjcGboF/9VuC3Ar8V+K3A
bwV+K/Bbgd8K/FbgtwK/FfitwG8FfivwW4HfCvxW4LcCvxX4rcBvBX4r8FuB
3wr8VuC3Ar8V+K3Ab8XmeXU/WuL+ucT9c4n759LmqdrfP5c2T9X+/rm0efr6
Ovgx+hOs1wCvCV4LvDZ4HfC64KWoT8Hvob+P9QbgZeBl4A3BG+G95mNAPgbk
Y0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4GO5+r71e4
369wv1/hfr+y81Ht7/crOx/V/n6/svPx9XXwY/QnqNe8XCMv18jLNfJyjbxc
Iy/Xtn/fX8P70j69v5fw9xL+zr7z6T/MUC2m
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {12., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {12., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {12., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {12., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.8500000000000001}, "Tooltip"]& ],
        
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {0.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {12., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {0.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {12., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {12., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {12., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], 
        Annotation[#, {11.600000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {12., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {12., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {12., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {12., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {12., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {12., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {12., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], 
        Annotation[#, {11.600000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {12., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {12., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {12., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {12., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {2., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {5.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {12., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {12., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {12., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {12., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {12., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {12., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {12., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {12., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {12., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {12., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {12., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {0.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {0.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {0.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {0.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {0.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {0.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {0.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {0.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {0.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {0.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {0.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {0.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9500000000000002`"}], 
           "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {0.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {0.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {0.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {0.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {0.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {0.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {0.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {0.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {0.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {0.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {0.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {0.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {1.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {2., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {5.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {7.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {12., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {0.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {12., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {0.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {12., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {0.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {12., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {0.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {12., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {0.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {0.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {0.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {0.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.8500000000000001}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.6250000000000001, 0}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, DisplayFunction -> Identity, 
     AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.6250000000000001, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
      "\"Transmission\"", "\"Reflection\"", "\"Trapping\"", "\"Splitting\""}, 
      "PointLegend", DisplayFunction -> (FormBox[
        TagBox[
         GridBox[{{
            StyleBox["\"Antikink\"", {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}, {
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 8}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 6}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #2}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    PolygonBox[
                    
                    NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 
                    0}, {0, 1.7320508075688772`}, {-1, 0}}]]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.08250000000000002], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]]}, ImageSize -> 8}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, ImageSize -> {20, 20},
                     PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.30000000000000004`] -> 
                    Baseline)], #3}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}}, 
          GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          GridBoxSpacings -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
        TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    CircleBox[{0, 0}]}, ImageSize -> 8], ",", "Automatic"}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    PolygonBox[{{1, 0}, {1, 1}, {0, 1}, {0, 0}}]}, ImageSize -> 
                    6], ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    GrayLevel[0], 
                    Thickness[Large], 
                    PolygonBox[
                    
                    NCache[{{1, 0}, {0, 3^Rational[1, 2]}, {-1, 0}}, {{1, 
                    0}, {0, 1.7320508075688772`}, {-1, 0}}]]}, ImageSize -> 
                    8], ",", "Automatic"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", 
             RowBox[{"Placed", "[", 
               RowBox[{"\"Antikink\"", ",", "Above"}], "]"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "20"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.674833466716593*^9}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          BoxData[
           FormBox[
            StyleBox[
            "\"\[FilledCircle]\"", FontSize -> Medium, StripOnInput -> False],
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxl2N9u40QYhvFAJaRKHLRqVTVKFDmJ8+d8Od9eA5eABBxyPXBNcM45CIFA
aGrGrpM4Cdt1Zir/NtqV9TUzjxXPfM878vybH77+9mo0Gv362Wj04d/o8w//
v3r3+tk8fby8++396ONnS108/fLz6+f39/31rf7px9fPPNfff/f6WeS65y9z
3fNKeCW8Fbw1vA28LeMfnvrrH5fvH3Pd88e57nmTXPecaa776wxewfgC/pz5
C+63hFfCK+Gt4K3hbeBt4X351P/9zwvvNtf9/Ltc9+Pvc52eZ6rT8xzyxvAm
8KbwZvAKxr/V6XkO5y+43xJeCa+Et4K3hreBt+X7q6ee89dl/he57q/XuU7P
P9U954bxt7lO6zGcf8/9HuA9whvDm8CbwpvBKxhfwJ8zf8H9lvBKeCW8Fbw1
vA28Ld//d7n+feHtct2PHz2lOq1fqtP6Dedf5zqt35B3w/hb+HfMv+d+D/Ae
4Y3hTeBN4c3gFYwv4M+Zv+B+S3glvBLeCt4a3gbelvlpX/yT1zPVaT1TndZz
OP4q12k9h/Ovc53Wc8i7Yfwt/Dvm33O/B3iP8MbwJvCm8GbwCsYX8OfMX3C/
JbwSXglvBW8NbwNvy/zUx//m9Ux1Ws9Up/Ucjr/KdVrP4fzrXKf1HPJuGH8L
/47599zvAd4jvDG8CbwpvBm8gvEF/DnzF9xvCa+EV8JbwVvD28DbMj95N+T1
THVaz1Sn9RyOv8p1Ws/h/OtcD88rIa/ncPxtrofnl8D5JXB+CZxfAueXwPkl
cH4JnF8C55fA+SVwfgmcXwLnl8D5JXB+CZxfAueXwPklcH4J+DLgy4AvA74M
+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M+DLgy4AvA74M
+PLteffXZ86Lz5wXnzkvPnNefM7PO9XD8+Jzft5D3hjeBN4U3gxewfgC/pz5
C+63hFfCK+Gt4K3hbeBtP3me/byKfKjIh4p8qMiHinyoyIeKfKjIh4p8qMiH
inyoyIeKfKjIh4p8qMiHinyoyIeKfKjIh7fn9+6SC+n5pTo9v1Sn55fq9PxS
nZ7fkDeBN4U3g1cwvoA/Z/6C+y3hlfBKeCt4a3gbeNtPnk//90heRfIqkleR
vIrkVSSvInkVyatIXkXyKpJXkbyK5FUkryJ5FcmrSF5F8iOSH5H8iORHJD8i
+RHJj0h+RPIjkh+R/IjkRyQ/IvkRyY9IfkTyI5IfEb/X+L3G7zV+r/F7jd9r
/F7j9xq/1/i9xu81fq/xe43fa/xe4/cav9f4t8G/Df5t8G+Dfxv82+DfBv82
+LfBvw3+bfBvg38b/Nvg37ff119feD/wwvuBF94PvOTfl+rh+4GX/PtSPXw/
8JJ/35BXwlvBW8PbwNvyffJbi99a/Nbitxa/tfitxW8tfmvxW4vfWvzW4rcW
v7X4rcVHLT5q8VGLj1p81OKjFh+1+KjFRy0+avFRi49afNTijx3+2OGPHf7Y
4Y8d/tjhjx3+2OGPHf7Y4Y8d/tjhgz0+2OODPT7Y44M9Ptjjgz0+2OODPT7Y
44M9PtjT3wf6+0B/H+jvA/19oL8P9PeB/j7Q3wf6+0B/H+jPjv7s6M+O/uzo
z47+7OjPjv7s6M+O/uzor47+6uivjv7q6K+O/uror47+6uivjv440h9H+uNI
fxzpjyP9caQ/jvTHkf19Yn+f2N8n9veJ/X1if5/Y3yf294n9eWZ/ntmfZ/bn
mf15Zn+e2Z9n9ld67/xWD/dXeo+5zvVwf6X3Yttc/w/GeaUf
         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          BoxData[
           FormBox[
            StyleBox[
            "\"\[FilledSquare]\"", FontSize -> Medium, StripOnInput -> False],
             TraditionalForm]], {0., 0.}], CompressedData["
1:eJxlmD2M41QUhQMjrRSgiGUrsmXLenacxNTQoklHvVtTIQEl1FBTUyJolwYJ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         "]]}, {
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          BoxData[
           FormBox[
            StyleBox[
            "\"\[FilledDiamond]\"", FontSize -> Medium, StripOnInput -> 
             False], TraditionalForm]], {0., 0.}], CompressedData["
1:eJxdlj+IE1EQxlcDQtQiYZeQkBA2yeaP9dlK0lnf1VaCWmqttbW1tmcph6Li
XetVAQUh4LFgsUMeIcvZyRV2JneZkfktd4QvO/N7L2/g+17v4dODR5UoijrX
omjzF13f/L95vX3K6Z0Hr75eTN5NVZ90X57vHx9N7+5tnz+m9f3bZ/dunh2+
N/17/3hT8cH0ZdveR9MvkqP78vyT8ahPLyabHXze1f+FLqe3zg43K36xetX6
/uD4coP2XrXyvC53nydWr1rrvdbfc2r1qrVedXT1zHx9Zebrdf051p9j/bnx
fH3F9JPH2+fGzPdXTX//tn1uzzyvhvpy9/0P249q3Y9q3Y+vr5jW/fj+qmnd
j+fVUF8HP0Z/gvUa4DXB0/ktML8F5rfA/BaY38J+n++vmtbf53k11NfBj9Gf
YL0GeE3wWuC1weuA1wUvRX0Kfg/9faw3QH25q/tp561az1u1nrevr5jW8/b9
VdN63p5XQ30d/Bj9CdZrgNcErwVeG7wOeF3wUtSn4PfQ38d6A/Ay8DLwhuCN
wBuDN0G/+lUOv8rhVzn8Kodf5fCrHH6Vw69y+FVu8/T8GP0J1muA1wSvBV4b
vA54XfBS1Kfg99Dfx3oD8DLwMvCG4I3AG4M3QX+54/6yearWearWefr6immd
p++vmtZ5el4N9XXwY/QnWK8BXhO8Fnht8DrgdcFLUZ+C30N/H+sNwMvAy8Ab
gjcCbwzeBP2a3wXyu0B+F8jvAvldIL8Lm6dqn98F8ruweXp+jP7EtM/vAvld
2Dw9rw1eB7wueCnq/2udp+/vY70BeBl4GXhD8EbgjcGboF/9VuC3Ar8V+K3A
bwV+K/Bbgd8K/FbgtwK/FfitwG8FfivwW4HfCvxW4LcCvxX4rcBvBX4r8FuB
3wr8VuC3Ar8V+K3Ab8XmeXU/WuL+ucT9c4n759LmqdrfP5c2T9X+/rm0efr6
Ovgx+hOs1wCvCV4LvDZ4HfC64KWoT8Hvob+P9QbgZeBl4A3BG+G95mNAPgbk
Y0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4G5GNAPgbkY0A+BuRjQD4GO5+r71e4
369wv1/hfr+y81Ht7/crOx/V/n6/svPx9XXwY/QnqNe8XCMv18jLNfJyjbxc
Iy/Xtn/fX8P70j69v5fw9xL+zr7z6T/MUC2m
         "]]}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {12., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {8.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {10.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {12., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {8.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.4, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {10.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {12., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {3.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.2, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {8.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.4, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {10.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {12., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.8500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.8500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.8500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.8500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {0.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {1.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {3.6, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.2, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {8.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.4, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {10.8, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9`"}], "}"}]], 
        Annotation[#, {12., 0.9}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.9500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.9500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.9500000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.9500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.9500000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.9500000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {0.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {1.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.`"}], "}"}]], 
        Annotation[#, {3.6, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.2, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {8.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.4, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.`"}], "}"}]], 
        Annotation[#, {10.8, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.`"}], "}"}]], 
        Annotation[#, {12., 1.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {3.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.2, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {8.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.4, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {10.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {12., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {3.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.2, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {8.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.4, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {10.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {12., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.1500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {8.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.4, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {10.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {12., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {8.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {10.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {12., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {8.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {10.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {12., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {8.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {10.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {12., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.4500000000000002`"}], 
           "}"}]], 
        Annotation[#, {11.600000000000001`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {8.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {10.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {12., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {8.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {10.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {12., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {8.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {10.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {12., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {10.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {12., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {10.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {12., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {10.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {12., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {12., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.600000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {10.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {12., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {10.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {12., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {1.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {3.6, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.2, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {8.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.4, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {10.8, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.05}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.05`"}], "}"}]], 
        Annotation[#, {12., 0.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {1.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {3.6, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.2, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {8.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.4, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {10.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {12., 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {1.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {2., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {3.6, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {4.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {5.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {6.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {7.2, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {8.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.060000000000000005`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.4, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {10.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {12., 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {1.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {3.6, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.2, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {8.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.4, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {10.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {12., 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {1.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {3.6, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.2, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {8.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.4, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {10.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {12., 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {1.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {3.6, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.2, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {8.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.4, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {10.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {12., 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {3.6, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.2, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {8.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.4, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {10.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {12., 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {3.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.2, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {8.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.4, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {10.8, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {12., 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], 
        Annotation[#, {6.800000000000001, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.4, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {10.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {12., 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {3.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.2, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {8.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.4, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {10.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {12., 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {3.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.2, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {8.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.4, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {10.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {12., 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {3.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.2, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {8.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.4, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {10.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {12., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {8.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.4, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {10.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {12., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {8.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {10.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {12., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {10.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {12., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {0.8, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {1.6, 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.05}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.05`"}], "}"}]], 
        Annotation[#, {2., 1.05}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {0.8, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {1.6, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2., 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.1500000000000001`"}], 
           "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.1500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.1500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.1500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.1500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.1500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {0.8, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {1.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.2, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {3.6, 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.2`"}], "}"}]], 
        Annotation[#, {4., 1.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {0.8, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {1.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.2, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {3.6, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4., 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.4, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {0.8, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {1.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.2, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {3.6, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4., 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.4, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {0.8, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {1.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {3.6, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4., 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.4, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.35}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.35`"}], "}"}]], 
        Annotation[#, {5.2, 1.35}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.4000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.4500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.4500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.4500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.4500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.4500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.4500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {0.8, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {1.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {3.6, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.2, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6., 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.5`"}], "}"}]], 
        Annotation[#, {6.4, 1.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {0.8, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {1.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {3.6, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.2, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6., 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.4, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {0.8, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {1.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {3.6, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6., 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.4, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6`"}], "}"}]], 
        Annotation[#, {7.2, 1.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.6500000000000001`"}], 
           "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.6500000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.6500000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.6500000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.6500000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.6500000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.6500000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.7000000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.7000000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.7000000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.7000000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.7000000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.7000000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {0.8, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {1.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {3.6, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.4, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.2, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.75}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.75`"}], "}"}]], 
        Annotation[#, {8., 1.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {0.8, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {1.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {3.6, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.2, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8., 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.8}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.8`"}], "}"}]], 
        Annotation[#, {8.4, 1.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {0.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {1.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {3.6, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.2, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8., 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.4, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.85}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.85`"}], "}"}]], 
        Annotation[#, {8.8, 1.85}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {2., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {6.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9000000000000001`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {7.2, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9000000000000001`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9000000000000001`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8., 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.4, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9000000000000001`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9000000000000001`"}], "}"}]], 
        Annotation[#, {8.8, 1.9000000000000001`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {0.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {1.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {2., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {3.6, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {4.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {4.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {5.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {6.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {6.800000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {7.2, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "1.9500000000000002`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8., 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.4, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "1.9500000000000002`"}], "}"}]], 
        Annotation[#, {8.8, 1.9500000000000002`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 1.9500000000000002`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "1.9500000000000002`"}], "}"}]],
         Annotation[#, {9.200000000000001, 1.9500000000000002`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {0.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {1.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "2.`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "2.`"}], "}"}]], 
        Annotation[#, {3.6, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.2, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "2.`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8., 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.4, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "2.`"}], "}"}]], 
        Annotation[#, {8.8, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 2.}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "2.`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 2.}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.055}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.055`"}], "}"}]], 
        Annotation[#, {0.8, 0.055}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.060000000000000005`"}], "}"}]], 
        Annotation[#, {0.8, 0.060000000000000005`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.060000000000000005`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.060000000000000005`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.060000000000000005`},
          "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.065}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.065`"}], "}"}]], 
        Annotation[#, {0.8, 0.065}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.07}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.07`"}], "}"}]], 
        Annotation[#, {0.8, 0.07}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.075}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.075`"}], "}"}]], 
        Annotation[#, {0.8, 0.075}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {0.8, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.08}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.08`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.08}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.085}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.085`"}], "}"}]], 
        Annotation[#, {1.6, 0.085}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.09000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.09000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.09000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.09000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.09000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {0.8, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.095}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.095`"}], "}"}]], 
        Annotation[#, {1.6, 0.095}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {0.8, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.1}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.1`"}], "}"}]], 
        Annotation[#, {1.6, 0.1}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {0.8, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {1.6, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2., 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.15}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.15`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.15}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {0.8, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {1.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.2, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {3.6, 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.2}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.2`"}], "}"}]], 
        Annotation[#, {4., 0.2}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {0.8, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {1.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {3.6, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.4, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.2, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.25}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.25`"}], "}"}]], 
        Annotation[#, {6., 0.25}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {0.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {1.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {3.6, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.2, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8., 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.4, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {8.8, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.3}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.3`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.3}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {0.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {1.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {2., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {3.6, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {4.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {4.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {5.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {5.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {6.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {6.800000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {7.2, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {7.6000000000000005`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {8.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.200000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {9.600000000000001, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.4, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {10.8, 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.200000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.35000000000000003`"}], 
           "}"}]], Annotation[#, {11.600000000000001`, 0.35000000000000003`}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.35000000000000003`}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.35000000000000003`"}], "}"}]], 
        Annotation[#, {12., 0.35000000000000003`}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {0.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {1.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {3.6, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.2, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {8.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.4, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {10.8, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.4}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.4`"}], "}"}]], 
        Annotation[#, {12., 0.4}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {0.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {1.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {3.6, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.2, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {8.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.4, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {10.8, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.45}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.45`"}], "}"}]], 
        Annotation[#, {12., 0.45}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {0.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {1.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {3.6, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.2, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {8.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.4, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {10.8, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.5}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.5`"}], "}"}]], 
        Annotation[#, {12., 0.5}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {0.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {1.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {3.6, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.2, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {8.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.4, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {10.8, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.600000000000001`, 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"11.600000000000001`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {11.600000000000001`, 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{12., 0.55}]}}, 
         RowBox[{"{", 
           RowBox[{"12.`", ",", "0.55`"}], "}"}]], 
        Annotation[#, {12., 0.55}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {0.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {1.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {3.6, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.2, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{8.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"8.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {8.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.200000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.200000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{9.600000000000001, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"9.600000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {9.600000000000001, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10., 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10., 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.4, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.4`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.4, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{10.8, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"10.8`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {10.8, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{11.200000000000001`, 0.6}]}}, 
         RowBox[{"{", 
           RowBox[{"11.200000000000001`", ",", "0.6`"}], "}"}]], 
        Annotation[#, {11.200000000000001`, 0.6}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {0.8, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {1.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {3.6, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {4.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"5.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {5.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6., 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6., 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.4, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.4`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.4, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{6.800000000000001, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"6.800000000000001`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {6.800000000000001, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.2, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.2`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.2, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{7.6000000000000005`, 0.65}]}}, 
         RowBox[{"{", 
           RowBox[{"7.6000000000000005`", ",", "0.65`"}], "}"}]], 
        Annotation[#, {7.6000000000000005`, 0.65}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {1.2000000000000002`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {1.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {2., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.4000000000000004`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.7000000000000001`"}], 
           "}"}]], Annotation[#, {2.8000000000000003`, 0.7000000000000001}, 
         "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.6, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"3.6`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {3.6, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4., 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.4, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.4`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {4.4, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4.800000000000001, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"4.800000000000001`", ",", "0.7000000000000001`"}], "}"}]],
         Annotation[#, {4.800000000000001, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{5.2, 0.7000000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"5.2`", ",", "0.7000000000000001`"}], "}"}]], 
        Annotation[#, {5.2, 0.7000000000000001}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {0.8, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {1.6, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.4000000000000004`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.4000000000000004`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.4000000000000004`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2.8000000000000003`, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"2.8000000000000003`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {2.8000000000000003`, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{3.2, 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"3.2`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {3.2, 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{4., 0.75}]}}, 
         RowBox[{"{", 
           RowBox[{"4.`", ",", "0.75`"}], "}"}]], 
        Annotation[#, {4., 0.75}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {0.8, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.2000000000000002`, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.2000000000000002`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.2000000000000002`, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{1.6, 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"1.6`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {1.6, 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{2., 0.8}]}}, 
         RowBox[{"{", 
           RowBox[{"2.`", ",", "0.8`"}], "}"}]], 
        Annotation[#, {2., 0.8}, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{0.8, 0.8500000000000001}]}}, 
         RowBox[{"{", 
           RowBox[{"0.8`", ",", "0.8500000000000001`"}], "}"}]], 
        Annotation[#, {0.8, 0.8500000000000001}, "Tooltip"]& ]}}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0.6250000000000001, 0}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, DisplayFunction -> Identity, 
     AspectRatio -> NCache[GoldenRatio^(-1), 0.6180339887498948], 
     Axes -> {True, True}, AxesLabel -> {None, None}, 
     AxesOrigin -> {0.6250000000000001, 0}, DisplayFunction :> Identity, 
     Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox[
        "\"\\!\\(\\*FractionBox[SubscriptBox[\\(k\\), \\(i\\)], \
\\(k\\)]\\)\"", TraditionalForm], None}, {
        FormBox[
        "\"\\!\\(\\*SubscriptBox[\\(v\\), \\(0\\)]\\)\"", TraditionalForm], 
        None}}, FrameStyle -> Thickness[Large], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> Directive[FontSize -> Large], 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 600, LabelStyle -> 
     Directive[FontSize -> 40], Method -> {}, 
     PlotRange -> {{0.8, 12.}, {0, 2.}}, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
      "\"Transmission\"", "\"Reflection\"", "\"Trapping\"", "\"Splitting\""}, 
      "PointLegend", DisplayFunction -> (FormBox[
        TagBox[
         GridBox[{{
            StyleBox["\"Antikink\"", {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}, {
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], FontSize -> 10, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledSquare]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], FontSize -> 10, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #2}, {
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledDiamond]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.05500000000000001], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], FontSize -> 10, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {30, 30}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.3666666666666667] -> 
                    Baseline)], #3}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
              Directive[FontSize -> Large], FontFamily -> "Arial"}, 
             Background -> Automatic, StripOnInput -> False]}}, 
          GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          GridBoxSpacings -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
        TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledCircle]\"", ",", "Medium"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledSquare]\"", ",", "Medium"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"\"\[FilledDiamond]\"", ",", "Medium"}], "}"}]}], 
               "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", 
             RowBox[{"Placed", "[", 
               RowBox[{"\"Antikink\"", ",", "Above"}], "]"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "30"}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Input",
 CellChangeTimes->{3.665488826868738*^9}],

Cell[BoxData[
 RowBox[{"pd2log", "=", 
  RowBox[{"ListLogPlot", "@@", 
   RowBox[{"Join", "[", 
    RowBox[{"PlotContent2", ",", "plotsetting", ",", 
     RowBox[{"{", 
      RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, {3.650375268105143*^9, 
   3.650375274015318*^9}, {3.650545916542509*^9, 3.650545918030056*^9}, 
   3.6506457072835703`*^9, {3.650653098235167*^9, 3.650653104876114*^9}, 
   3.650653180347351*^9, 3.650653348464078*^9, {3.650654252200468*^9, 
   3.6506542524368267`*^9}, 3.65069465508596*^9, {3.651574055746128*^9, 
   3.651574064456832*^9}, {3.6587583696207943`*^9, 3.658758370930629*^9}}],

Cell[BoxData[
 RowBox[{"pd2pick", "=", 
  RowBox[{
   RowBox[{"ListPlot", "@@", 
    RowBox[{"Join", "[", 
     RowBox[{"PlotContent2", ",", "plotsetting", ",", 
      RowBox[{"{", 
       RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}], "/.", 
   "aktoolRule2"}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, {3.650375268105143*^9, 
   3.650375274015318*^9}, {3.650545916542509*^9, 3.650545918030056*^9}, 
   3.6506457072835703`*^9, {3.650653098235167*^9, 3.650653104876114*^9}, 
   3.650653180347351*^9, 3.650653348464078*^9, {3.650654252200468*^9, 
   3.6506542524368267`*^9}, 3.650694651963376*^9, {3.6515741145191927`*^9, 
   3.651574114904561*^9}}],

Cell[BoxData[
 RowBox[{"pd2logpick", "=", 
  RowBox[{
   RowBox[{"ListLogPlot", "@@", 
    RowBox[{"Join", "[", 
     RowBox[{"PlotContent2", ",", "plotsetting", ",", 
      RowBox[{"{", 
       RowBox[{"ImageSize", "\[Rule]", "600"}], "}"}]}], "]"}]}], "/.", 
   "aktoolRule3"}]}]], "Input",
 CellChangeTimes->{{3.6501993736847363`*^9, 3.6501993784970207`*^9}, {
   3.65019950254881*^9, 3.6501996044068336`*^9}, {3.650199636106175*^9, 
   3.650199739886794*^9}, {3.650199797980329*^9, 3.650199798315448*^9}, {
   3.650199832397625*^9, 3.650199849840108*^9}, {3.650199919362401*^9, 
   3.650199970154408*^9}, 3.650200040706792*^9, {3.650205377345429*^9, 
   3.650205381245914*^9}, {3.650207080309681*^9, 3.650207088647419*^9}, {
   3.650207123257718*^9, 3.650207150615416*^9}, {3.650207983950708*^9, 
   3.650207992570798*^9}, 3.65020949174273*^9, {3.650375268105143*^9, 
   3.650375274015318*^9}, {3.650545916542509*^9, 3.650545918030056*^9}, 
   3.6506457072835703`*^9, {3.650653098235167*^9, 3.650653104876114*^9}, 
   3.650653180347351*^9, 3.650653348464078*^9, {3.650654252200468*^9, 
   3.6506542524368267`*^9}, 3.650694651963376*^9, {3.6515741145191927`*^9, 
   3.651574128214148*^9}, 3.651574164929028*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"confshow", "[", 
   RowBox[{"k_", ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Select", "[", 
    RowBox[{"kvconfplottab", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"k", ",", "v"}], "}"}]}], "&"}]}], "]"}], 
   "\[LeftDoubleBracket]", 
   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{{3.650278913166389*^9, 3.650279028516712*^9}, {
  3.650279075173092*^9, 3.650279136343644*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"pt", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Pi]", "/", "2"}], ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"ClickPane", "[", 
    RowBox[{
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"3", " ", 
        RowBox[{"Sin", "[", "x", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "6"}], ",", "6"}], "}"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Dynamic", "@", 
           RowBox[{"Arrow", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "5"}], "}"}], ",", "pt"}], "}"}], "]"}]}], 
          ",", 
          RowBox[{"Text", "[", 
           RowBox[{"\"\<Extremum\>\"", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "5"}], "}"}]}], "]"}]}], "}"}]}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "6"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "1"}], "/", "2"}], "+", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "/", "\[Pi]"}]}], "]"}]}], 
              "+", "1"}], ")"}], " ", 
            RowBox[{"\[Pi]", "/", "2"}]}]}], "}"}], ",", 
         RowBox[{"pt", "=", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"3", " ", 
             RowBox[{"Sin", "[", "x", "]"}]}]}], "}"}]}]}], "]"}], ")"}], 
      "&"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"confshow", "[", 
      RowBox[{"k", ",", "i"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "15"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "1000", ",", "10000", ",", "1000"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.650281375932745*^9, 3.6502814063943377`*^9}, {
  3.65028149486552*^9, 3.650281581230712*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<phasediagram-kink.pdf\>\"", ",", "pd1", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.650207999611129*^9, 3.650208005019311*^9}, {
   3.6502080845821047`*^9, 3.650208107817614*^9}, {3.650275025732313*^9, 
   3.65027502596942*^9}, {3.6506946673922358`*^9, 3.650694668194689*^9}, {
   3.6506947386394253`*^9, 3.650694750831414*^9}, 3.656952118408173*^9, {
   3.6587581910237713`*^9, 3.658758195982568*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<phasediagram-antikink.pdf\>\"", ",", "pd2", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}, {3.650207999611129*^9, 3.650208005019311*^9}, {
   3.6502080845821047`*^9, 3.650208107817614*^9}, {3.650275025732313*^9, 
   3.65027502596942*^9}, {3.6506946673922358`*^9, 3.650694668194689*^9}, {
   3.6506947386394253`*^9, 3.650694750831414*^9}, 3.656952118408173*^9, {
   3.658758187407688*^9, 3.658758203838807*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test", "Section",
 CellChangeTimes->{{3.650281944797*^9, 3.650281961813689*^9}}],

Cell[BoxData[
 RowBox[{"m2", "=", 
  RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"lm1", "=", 
      RowBox[{"leftsolitab", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lm1", "\[LeftDoubleBracket]", 
       RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "=", 
      RowBox[{
       RowBox[{"Abs", "@", 
        RowBox[{"lm1", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], "-", "8", 
       "+", "d1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rm1", "=", 
      RowBox[{"rightsolitab", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rm1", "\[LeftDoubleBracket]", 
       RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "=", 
      RowBox[{"9", "-", 
       RowBox[{"Abs", "@", 
        RowBox[{"rm1", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], "-", 
       "d1"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Column", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"MakeSSHpicvec2", "[", 
            RowBox[{
             RowBox[{"anstab", "[", 
              RowBox[{"[", "jp", "]"}], "]"}], ",", "r", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "vector"}], " ", "vout"}], "/.", 
              RowBox[{"t", "\[Rule]", 
               RowBox[{
                RowBox[{"tinterval", "*", 
                 RowBox[{"(", 
                  RowBox[{"jp", "-", "jpstart"}], ")"}]}], "+", 
                "tstart"}]}]}]}], "]"}], "}"}], "\[IndentingNewLine]", ",", 
          RowBox[{"ImageSize", "\[Rule]", "1500"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "r"}], ",", 
               RowBox[{"num", "+", "r"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "r"}], "-", "0.5"}], ",", 
               RowBox[{"r", "+", "0.5"}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"lm1", "\[LeftDoubleBracket]", 
             RowBox[{"1", ";;", "jp"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{"rm1", "\[LeftDoubleBracket]", 
             RowBox[{"1", ";;", "jp"}], "\[RightDoubleBracket]"}]}], "}"}], 
          ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"-", "num"}], "/", "2"}], "-", "1"}], ",", 
               RowBox[{
                RowBox[{"num", "/", "2"}], "+", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"jpstart", "-", "1"}], ")"}], "*", "tinterval"}], 
                "+", "tstart"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"jpfinal", "-", "1"}], ")"}], "*", "tinterval"}], 
                "+", "tstart"}]}], "}"}]}], "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
          RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
          RowBox[{"AxesLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<Soliton position\>\"", ",", "\"\<Time\>\""}], 
            "}"}]}], ",", 
          RowBox[{"PlotLegends", "->", 
           RowBox[{"{", 
            RowBox[{"\"\<left\>\"", ",", "\"\<right\>\""}], "}"}]}], ",", 
          RowBox[{"PlotLabel", "\[Rule]", 
           RowBox[{"StringForm", "[", 
            RowBox[{"\"\<v0=``\>\"", ",", "v0label"}], "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"PlotLabel", "\[Rule]", 
       RowBox[{
       "\"\<{r/a,\!\(\*SubscriptBox[\(\[Theta]\), \(0\)]\),s/a}=\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"{", 
          RowBox[{"r", ",", "th0", ",", 
           RowBox[{"N", "[", 
            RowBox[{"Sqrt", "[", "lzerosq", "]"}], "]"}]}], "}"}], "]"}]}]}], 
      "]"}], "*)"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"animrate", ",", "10"}], "}"}], ",", "1", ",", "100"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jp", ",", "jpfinal"}], "}"}], ",", "jpstart", ",", "jpfinal", 
      ",", "jpinterval", ",", 
      RowBox[{"AnimationRate", "\[Rule]", "animrate"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"erange", ",", "0.15"}], "}"}], ",", "0", ",", "1.5", ",", 
      "0.01"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"vector", ",", "0.001"}], "}"}], ",", "0.00", ",", "0.1", ",", 
      "0.01"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"d1", ",", "0"}], "}"}], ",", "0", ",", "1", ",", "0.1"}], 
     "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.633071604935116*^9, 3.6330716053250647`*^9}, {
   3.633071845064135*^9, 3.633071865861828*^9}, 3.633079492019987*^9, 
   3.6331079921853456`*^9, {3.639374130768869*^9, 3.639374133038507*^9}, {
   3.639740015537072*^9, 3.639740037800256*^9}, {3.640427292517874*^9, 
   3.640427316888631*^9}, {3.6404275364140987`*^9, 3.64042753948374*^9}, {
   3.640432341231155*^9, 3.640432344597911*^9}, {3.640432609339368*^9, 
   3.6404326133243227`*^9}, {3.640941517598531*^9, 3.640941527733102*^9}, {
   3.640945830384345*^9, 3.640945878418723*^9}, {3.6409460477600117`*^9, 
   3.640946099398844*^9}, {3.640946151124544*^9, 3.640946212399529*^9}, {
   3.64094626179073*^9, 3.640946262048092*^9}, {3.640946297411306*^9, 
   3.6409463066231623`*^9}, {3.6409489443840647`*^9, 3.640948948118515*^9}, {
   3.641894967613566*^9, 3.6418949906838207`*^9}, 3.642848247132598*^9, 
   3.644136869508914*^9, {3.6441479333673267`*^9, 3.644147933543418*^9}, 
   3.644212366817039*^9, 3.644214720233073*^9, {3.645269079471755*^9, 
   3.645269182233431*^9}, {3.6452692519343557`*^9, 3.645269267173697*^9}, {
   3.645269372989979*^9, 3.645269416914804*^9}, {3.645269453616583*^9, 
   3.645269464137249*^9}, {3.64526951013018*^9, 3.645269511375111*^9}, {
   3.6452698990002127`*^9, 3.645269900294485*^9}, {3.645269931722926*^9, 
   3.645269978442625*^9}, 3.645270066226079*^9, {3.6452702568348103`*^9, 
   3.64527027094692*^9}, {3.645270463211622*^9, 3.6452705255976343`*^9}, {
   3.645270570556993*^9, 3.645270571300336*^9}, {3.645270602432541*^9, 
   3.6452706259137497`*^9}, {3.645270658890945*^9, 3.6452707796074266`*^9}, {
   3.6452709221139708`*^9, 3.645270976942945*^9}, {3.6452710165076838`*^9, 
   3.645271045380023*^9}, 3.645271273914765*^9, 3.645271415430222*^9, {
   3.6452717567704144`*^9, 3.645271759771446*^9}, {3.645272112896503*^9, 
   3.645272118240609*^9}, {3.645272291370994*^9, 3.645272293241877*^9}, 
   3.645272325825096*^9, {3.645275124280792*^9, 3.645275125549734*^9}, {
   3.645277764932905*^9, 3.64527776551547*^9}, {3.6464013236427107`*^9, 
   3.64640132373029*^9}, {3.6464014220604753`*^9, 3.6464014235552263`*^9}, 
   3.65071741418889*^9}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"tencoef", "[", 
      RowBox[{"i", ",", 
       RowBox[{"i", "+", "1"}], ",", "initialold"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.651391244051733*^9, 3.651391291373231*^9}}],

Cell["Relax initial condition, potential", "Text",
 CellChangeTimes->{{3.651492453499393*^9, 3.651492458907402*^9}, {
  3.651910522434103*^9, 3.651910537086383*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"pethnumxrelax2", "=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ldef", "=", "lzero"}], ",", 
      RowBox[{"Mdef", "=", "1."}], ",", 
      RowBox[{"v0", "=", "0."}], ",", 
      RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
     RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"kk", "[", "i", "]"}], "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", 
           RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
         "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"M", "[", "i", "]"}], "=", 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], "||", 
           RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True", 
          ",", "1."}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"akpos", "=", 
      RowBox[{"80", "/", "100"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"vdirection", "=", 
      RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
     RowBox[{"tfinal", "=", "1"}], ";", 
     RowBox[{"tinterval", "=", 
      RowBox[{"tfinal", "/", "400"}]}], ";", "Calpts", ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tableContent4", ";", "\[IndentingNewLine]", 
        RowBox[{"initialold", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Pi]", "/", "2"}], "-", 
            RowBox[{
             RowBox[{
             "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "[", "tfinal", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"thnumx", ",", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{"espringold", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], 
         "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"thnumx", ",", 
         RowBox[{"{", "0.3", "}"}]}], "}"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, {
   3.651909340054309*^9, 3.651909344102255*^9}, {3.651909458394384*^9, 
   3.651909537867701*^9}, 3.651909780528471*^9, {3.651909868915522*^9, 
   3.651909883217781*^9}, {3.651909919781321*^9, 3.6519099863238087`*^9}, {
   3.6519100361511393`*^9, 3.651910039878894*^9}, {3.65191054376274*^9, 
   3.651910544863985*^9}, {3.651911705502371*^9, 3.651911712461906*^9}, {
   3.651911753938613*^9, 3.6519117657280693`*^9}, {3.6519119533489637`*^9, 
   3.651911957521689*^9}, {3.651912160601151*^9, 3.651912224809009*^9}, {
   3.651912382032323*^9, 3.6519124062700243`*^9}, {3.651912462322033*^9, 
   3.651912462879595*^9}, {3.651912500710968*^9, 3.651912509679676*^9}, 
   3.651913391915606*^9, {3.6519212573605347`*^9, 3.6519212575036287`*^9}, {
   3.6519214784411697`*^9, 3.651921499622264*^9}, {3.651921545692039*^9, 
   3.651921545774934*^9}, {3.6519217437546787`*^9, 3.65192175538684*^9}, {
   3.651921882752275*^9, 3.6519219150555267`*^9}, {3.651921968865625*^9, 
   3.651921972177422*^9}, {3.6519220564667053`*^9, 3.651922118309444*^9}, {
   3.651922150902673*^9, 3.651922295002178*^9}, {3.6519223506984386`*^9, 
   3.651922371723736*^9}, {3.651924746132086*^9, 3.6519247462967663`*^9}, {
   3.6519247975720453`*^9, 3.651924800291771*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"reanstab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      FractionBox["\[Pi]", "2"], "-", 
      RowBox[{
       RowBox[{"ans", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"reinitialtab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ans", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", "tfinal", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6519224293703537`*^9, 3.651922435034637*^9}, {
  3.6519224827175493`*^9, 3.65192249829954*^9}, {3.651925473027018*^9, 
  3.651925476835446*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pethnumxrelax2", "=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ldef", "=", "lzero"}], ",", 
       RowBox[{"Mdef", "=", "1."}], ",", 
       RowBox[{"v0", "=", "1.82"}], ",", 
       RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", 
     RowBox[{"(*", "Rerun", "  ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
      RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"kk", "[", "i", "]"}], "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", "i", "]"}], "=", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "1"}], "||", 
            RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True",
            ",", "1."}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"akpos", "=", 
       RowBox[{"80", "/", "100"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vdirection", "=", 
       RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunConfigQ", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Eta]", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"tfinal", "=", "30"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "400"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"tableContent4", ";", "Calpts", ";", "\[IndentingNewLine]", 
         RowBox[{"initialold", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"\[Pi]", "/", "2"}], "-", 
             RowBox[{
              RowBox[{
              "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
              "[", "tfinal", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"thnumx", ",", 
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{"espringold", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], 
          "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"thnumx", ",", 
          RowBox[{"{", "0.0", "}"}]}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, {
   3.651909340054309*^9, 3.651909344102255*^9}, {3.651909458394384*^9, 
   3.651909537867701*^9}, 3.651909780528471*^9, {3.651909868915522*^9, 
   3.651909883217781*^9}, {3.651909919781321*^9, 3.6519099863238087`*^9}, {
   3.6519100361511393`*^9, 3.651910039878894*^9}, {3.65191054376274*^9, 
   3.651910544863985*^9}, {3.651911705502371*^9, 3.651911712461906*^9}, {
   3.651911753938613*^9, 3.6519117657280693`*^9}, {3.6519119533489637`*^9, 
   3.651911957521689*^9}, {3.651912160601151*^9, 3.651912224809009*^9}, {
   3.651912382032323*^9, 3.6519124062700243`*^9}, {3.651912462322033*^9, 
   3.651912462879595*^9}, {3.651912500710968*^9, 3.651912509679676*^9}, 
   3.651913391915606*^9, {3.6519212573605347`*^9, 3.6519212575036287`*^9}, {
   3.6519214784411697`*^9, 3.651921499622264*^9}, {3.651921545692039*^9, 
   3.651921545774934*^9}, {3.6519217437546787`*^9, 3.65192175538684*^9}, {
   3.651921882752275*^9, 3.6519219150555267`*^9}, {3.651921968865625*^9, 
   3.651921972177422*^9}, {3.6519220564667053`*^9, 3.651922118309444*^9}, {
   3.651922150902673*^9, 3.651922295002178*^9}, {3.6519223370352707`*^9, 
   3.651922344120167*^9}, {3.651922608098422*^9, 3.651922663777793*^9}, 
   3.651922732818265*^9, 3.651922974219376*^9, {3.651923275058311*^9, 
   3.651923275970107*^9}, 3.651923342896641*^9, {3.6519233763571253`*^9, 
   3.651923400356202*^9}, {3.651923832350108*^9, 3.651923837021299*^9}, 
   3.651924350936852*^9, {3.651925177341257*^9, 3.65192517775633*^9}, {
   3.65192551317889*^9, 3.651925657513743*^9}, 3.651925701432128*^9, {
   3.6519260487696533`*^9, 3.651926095777884*^9}, {3.653370360250679*^9, 
   3.6533703709052267`*^9}}],

Cell[BoxData[
 RowBox[{"AKShowpts", "\[LeftDoubleBracket]", "1", 
  "\[RightDoubleBracket]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eleft", "[", "0", "]"}], "+", 
  RowBox[{"eright", "[", "0", "]"}]}]], "Input",
 CellChangeTimes->{{3.6519260345375032`*^9, 3.6519260392630987`*^9}, 
   3.658488123699728*^9}],

Cell["Vpn ~ \[Theta] and w", "Text",
 CellChangeTimes->{{3.658493093463797*^9, 3.6584930988084383`*^9}, {
  3.65849315863118*^9, 3.6584931594494677`*^9}, {3.658493470708941*^9, 
  3.658493473808598*^9}, {3.658497970217956*^9, 3.6584979732899837`*^9}, {
  3.668252187854416*^9, 3.668252193901968*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"pethnumxrelax2backupvisualization", "=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ldef", "=", "lzero"}], ",", 
      RowBox[{"Mdef", "=", "1."}], ",", 
      RowBox[{"v0", "=", "0"}], ",", 
      RowBox[{"kkdef", "=", "10000."}], ",", "tt"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
     RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"kk", "[", "i", "]"}], "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", 
           RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
         "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"M", "[", "i", "]"}], "=", 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], "||", 
           RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True", 
          ",", "1."}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"akpos", "=", "0.5"}], ";", "\[IndentingNewLine]", 
     RowBox[{"vdirection", "=", 
      RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
     RowBox[{"tfinal", "=", "10"}], ";", 
     RowBox[{"tinterval", "=", 
      RowBox[{"tfinal", "/", "10"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"tableContent4", ";", 
          RowBox[{"tt", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"th0", "<", "0.8"}], ",", "2", ",", "0.8"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"initialold", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Pi]", "/", "2"}], "-", 
              RowBox[{
               RowBox[{
               "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
               "[", "tt", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"th0", ",", "thnumx", ",", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"espringold", "[", "i", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              RowBox[{"ans", "\[LeftDoubleBracket]", 
               RowBox[{"num", "/", "2"}], "\[RightDoubleBracket]"}], "[", 
              "tt", "]"}]}], ",", 
            RowBox[{"ListPlot", "[", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Mod", "[", 
                   RowBox[{"j", ",", "2"}], "]"}], "\[NotEqual]", "0"}], ",", 
                 
                 RowBox[{
                  RowBox[{
                  "ans", "\[LeftDoubleBracket]", "j", 
                   "\[RightDoubleBracket]"}], "[", "tt", "]"}], ",", 
                 RowBox[{"\[Pi]", "-", 
                  RowBox[{
                   RowBox[{
                   "ans", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}], "[", "tt", "]"}]}]}], "]"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "num"}], "}"}]}], "]"}], "]"}], ",", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"initialold", "=", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"\[Pi]", "/", "2"}], "-", 
                    RowBox[{
                    RowBox[{
                    "ans", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}], "[", "t", "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
                 RowBox[{"{", 
                  RowBox[{"t", ",", "\[IndentingNewLine]", 
                   RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"espringold2", "[", "i", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], 
                  "}"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"t", ",", "tstart", ",", "tfinal", ",", 
                  RowBox[{"tinterval", "/", "10"}]}], "}"}]}], "]"}], ",", 
              RowBox[{"Joined", "->", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "}"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"th0", ",", 
           RowBox[{"{", 
            RowBox[{"0.2", ",", "0.57"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thnumx", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"thmidx", "/.", 
              RowBox[{"FindRoot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{"a", "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"Sin", "[", "thmidx", "]"}]}], "-", 
                    RowBox[{"r", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"r", " ", 
                    RowBox[{"Cos", "[", "thmidx", "]"}]}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"]}], 
                 "\[Equal]", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  RowBox[{"4", 
                   SuperscriptBox["r", "2"], 
                   SuperscriptBox[
                    RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
                "\[IndentingNewLine]", ",", 
                RowBox[{"{", 
                 RowBox[{"thmidx", ",", 
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}], 
            "}"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"th0", ",", "thnumx"}], "}"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, {
   3.651909340054309*^9, 3.651909344102255*^9}, {3.651909458394384*^9, 
   3.651909537867701*^9}, 3.651909780528471*^9, {3.651909868915522*^9, 
   3.651909883217781*^9}, {3.651909919781321*^9, 3.6519099863238087`*^9}, {
   3.6519100361511393`*^9, 3.651910039878894*^9}, {3.65191054376274*^9, 
   3.651910544863985*^9}, {3.651911705502371*^9, 3.651911712461906*^9}, {
   3.651911753938613*^9, 3.6519117657280693`*^9}, {3.6519119533489637`*^9, 
   3.651911957521689*^9}, {3.651912160601151*^9, 3.651912224809009*^9}, {
   3.651912382032323*^9, 3.6519124062700243`*^9}, {3.651912462322033*^9, 
   3.651912462879595*^9}, {3.651912500710968*^9, 3.651912509679676*^9}, 
   3.651913391915606*^9, {3.6519212573605347`*^9, 3.6519212575036287`*^9}, {
   3.6519214784411697`*^9, 3.651921499622264*^9}, {3.651921545692039*^9, 
   3.651921545774934*^9}, {3.6519217437546787`*^9, 3.65192175538684*^9}, {
   3.651921882752275*^9, 3.6519219150555267`*^9}, {3.651921968865625*^9, 
   3.651921972177422*^9}, {3.6519220564667053`*^9, 3.651922118309444*^9}, {
   3.651922150902673*^9, 3.651922295002178*^9}, {3.6519223370352707`*^9, 
   3.651922344120167*^9}, {3.651922608098422*^9, 3.651922663777793*^9}, 
   3.651922732818265*^9, 3.651922974219376*^9, {3.651923275058311*^9, 
   3.651923275970107*^9}, 3.651923342896641*^9, {3.6519233763571253`*^9, 
   3.651923400356202*^9}, {3.651923832350108*^9, 3.651923837021299*^9}, {
   3.651924081714369*^9, 3.651924143043405*^9}, 3.651924254551467*^9, {
   3.651924314008609*^9, 3.651924314744246*^9}, {3.6533711986205378`*^9, 
   3.653371288785438*^9}, {3.65337133693016*^9, 3.6533714087112417`*^9}, {
   3.653371452228241*^9, 3.653371519001683*^9}, {3.653371558555155*^9, 
   3.653371567798224*^9}, {3.653371619035027*^9, 3.653371637831663*^9}, {
   3.653371715769462*^9, 3.65337177532917*^9}, {3.6533718145253773`*^9, 
   3.65337185540697*^9}, {3.653373554664111*^9, 3.653373693174807*^9}, {
   3.653373724939109*^9, 3.6533738254994164`*^9}, {3.65337393436535*^9, 
   3.653373970654318*^9}, {3.6533740156332073`*^9, 3.653374233733612*^9}, {
   3.653374290617445*^9, 3.653374386973692*^9}, {3.6533855783375874`*^9, 
   3.653385593185493*^9}, 3.653387944824959*^9, {3.653388121357506*^9, 
   3.653388121485972*^9}, {3.655463108931476*^9, 3.655463109345581*^9}, {
   3.655475088514624*^9, 3.6554751208467493`*^9}, {3.6584880649835157`*^9, 
   3.658488065263351*^9}, 3.658488409933444*^9, 3.6584891063641167`*^9, {
   3.658489189533915*^9, 3.658489198110361*^9}, {3.658490332457281*^9, 
   3.658490361610836*^9}, {3.658490467772777*^9, 3.658490468172399*^9}, {
   3.658490683124332*^9, 3.658490687682267*^9}, 3.658490739857399*^9, {
   3.658491724666182*^9, 3.6584918238548*^9}, {3.6584919675545073`*^9, 
   3.658491973168519*^9}, 3.658492168541006*^9, 3.658492477470057*^9, {
   3.658492620097229*^9, 3.6584926224315367`*^9}, 3.658492742180097*^9, 
   3.658492782262096*^9, {3.6584928787269077`*^9, 3.658492879463056*^9}, {
   3.6584929991657743`*^9, 3.658493033549728*^9}, {3.6584934840211554`*^9, 
   3.658493484115244*^9}, {3.6584936332715693`*^9, 3.658493663785*^9}, {
   3.6584938058517113`*^9, 3.658493806060362*^9}, {3.658493880429925*^9, 
   3.6584938854048233`*^9}, 3.658493917632215*^9, {3.6584943792258587`*^9, 
   3.6584944136895113`*^9}, {3.658494479419427*^9, 3.6584945710692883`*^9}, {
   3.65849460684968*^9, 3.658494625582597*^9}, {3.658494672308535*^9, 
   3.6584946847203407`*^9}, {3.658494723666787*^9, 3.65849475267486*^9}, {
   3.65849481365259*^9, 3.6584948874757557`*^9}, {3.658494950678919*^9, 
   3.6584949727450933`*^9}, {3.658495008538146*^9, 3.658495057947399*^9}, {
   3.658495095644166*^9, 3.6584951249863853`*^9}, {3.6584951554553823`*^9, 
   3.658495218252742*^9}, {3.658495635784436*^9, 3.658495654241517*^9}, {
   3.658495707678808*^9, 3.658495723721089*^9}, {3.658495940472978*^9, 
   3.6584960417814627`*^9}, {3.658496084003586*^9, 3.658496096704918*^9}, {
   3.658496128837089*^9, 3.658496129799354*^9}, 3.658496418747533*^9, {
   3.6584964530010567`*^9, 3.658496510265503*^9}, {3.658496541293128*^9, 
   3.658496620605218*^9}, {3.658496705617445*^9, 3.658496717647923*^9}, {
   3.658496812594118*^9, 3.658496822803205*^9}, {3.658496980028163*^9, 
   3.658496994324553*^9}, {3.6584971028259697`*^9, 3.6584971617852097`*^9}, {
   3.658497694703722*^9, 3.658497701524228*^9}, {3.668331751030699*^9, 
   3.668331751588773*^9}, {3.6683318226322737`*^9, 3.668331822778185*^9}, 
   3.6683328654897738`*^9, {3.668332948210527*^9, 3.6683329497622747`*^9}, {
   3.668333260938191*^9, 3.668333320268016*^9}, {3.668333381344378*^9, 
   3.668333390362108*^9}, {3.668333440476522*^9, 3.668333475486161*^9}, {
   3.668333698915949*^9, 3.6683336989892807`*^9}, {3.668333804471057*^9, 
   3.6683338071755238`*^9}, {3.668334316020649*^9, 3.668334455974751*^9}, {
   3.6683344904087152`*^9, 3.6683345104864407`*^9}, {3.6683345905721483`*^9, 
   3.668334592475128*^9}, {3.668334732338161*^9, 3.668334778831514*^9}, {
   3.668335148904582*^9, 3.6683352048248577`*^9}, {3.668335442429933*^9, 
   3.668335446669918*^9}, {3.668335501391597*^9, 3.668335501997917*^9}, {
   3.6683362232147512`*^9, 3.668336260416183*^9}, {3.674830327508314*^9, 
   3.674830330526452*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pethnumxrelax2", "=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"ldef", "=", "lzero"}], ","}], "*)"}], 
      RowBox[{
       RowBox[{"Mdef", "=", "1."}], ",", 
       RowBox[{"v0", "=", "0"}], ",", 
       RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
      RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"tstart", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"kk", "[", "i", "]"}], "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", "i", "]"}], "=", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "1"}], "||", 
            RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True",
            ",", "1."}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"akpos", "=", "0.5"}], ";", "\[IndentingNewLine]", 
      RowBox[{"vdirection", "=", 
       RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
      RowBox[{"tfinal", "=", "10"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "10"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Monitor", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tableContent4", ";", "\[IndentingNewLine]", 
           RowBox[{"initialold", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Pi]", "/", "2"}], "-", 
               RowBox[{
                RowBox[{
                "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
                 "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"th0", "<", "0.8"}], ",", "2", ",", "0.8"}], 
                 RowBox[{"(*", 
                  RowBox[{"Sampling", " ", "time"}], "*)"}], "]"}], "]"}]}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"th0", ",", "thnumx", ",", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{"espringold2", "[", "i", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], 
            "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"th0", ",", "0.2", ",", "0.95", ",", "0.05"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"thnumx", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"thmidx", "/.", 
               RowBox[{"FindRoot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"a", "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"Sin", "[", "thmidx", "]"}]}], "-", 
                    RowBox[{"r", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"r", " ", 
                    RowBox[{"Cos", "[", "thmidx", "]"}]}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"-", "thmidx"}], "]"}]}]}], ")"}], "2"]}], 
                  "\[Equal]", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   RowBox[{"4", 
                    SuperscriptBox["r", "2"], 
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], 
                 "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"thmidx", ",", 
                   RowBox[{"-", "1"}], ",", 
                   RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}]}], "]"}]}]}],
              "}"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"th0", ",", "thnumx"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, {
   3.651909340054309*^9, 3.651909344102255*^9}, {3.651909458394384*^9, 
   3.651909537867701*^9}, 3.651909780528471*^9, {3.651909868915522*^9, 
   3.651909883217781*^9}, {3.651909919781321*^9, 3.6519099863238087`*^9}, {
   3.6519100361511393`*^9, 3.651910039878894*^9}, {3.65191054376274*^9, 
   3.651910544863985*^9}, {3.651911705502371*^9, 3.651911712461906*^9}, {
   3.651911753938613*^9, 3.6519117657280693`*^9}, {3.6519119533489637`*^9, 
   3.651911957521689*^9}, {3.651912160601151*^9, 3.651912224809009*^9}, {
   3.651912382032323*^9, 3.6519124062700243`*^9}, {3.651912462322033*^9, 
   3.651912462879595*^9}, {3.651912500710968*^9, 3.651912509679676*^9}, 
   3.651913391915606*^9, {3.6519212573605347`*^9, 3.6519212575036287`*^9}, {
   3.6519214784411697`*^9, 3.651921499622264*^9}, {3.651921545692039*^9, 
   3.651921545774934*^9}, {3.6519217437546787`*^9, 3.65192175538684*^9}, {
   3.651921882752275*^9, 3.6519219150555267`*^9}, {3.651921968865625*^9, 
   3.651921972177422*^9}, {3.6519220564667053`*^9, 3.651922118309444*^9}, {
   3.651922150902673*^9, 3.651922295002178*^9}, {3.6519223370352707`*^9, 
   3.651922344120167*^9}, {3.651922608098422*^9, 3.651922663777793*^9}, 
   3.651922732818265*^9, 3.651922974219376*^9, {3.651923275058311*^9, 
   3.651923275970107*^9}, 3.651923342896641*^9, {3.6519233763571253`*^9, 
   3.651923400356202*^9}, {3.651923832350108*^9, 3.651923837021299*^9}, {
   3.651924081714369*^9, 3.651924143043405*^9}, 3.651924254551467*^9, {
   3.651924314008609*^9, 3.651924314744246*^9}, {3.6533711986205378`*^9, 
   3.653371288785438*^9}, {3.65337133693016*^9, 3.6533714087112417`*^9}, {
   3.653371452228241*^9, 3.653371519001683*^9}, {3.653371558555155*^9, 
   3.653371567798224*^9}, {3.653371619035027*^9, 3.653371637831663*^9}, {
   3.653371715769462*^9, 3.65337177532917*^9}, {3.6533718145253773`*^9, 
   3.65337185540697*^9}, {3.653373554664111*^9, 3.653373693174807*^9}, {
   3.653373724939109*^9, 3.6533738254994164`*^9}, {3.65337393436535*^9, 
   3.653373970654318*^9}, {3.6533740156332073`*^9, 3.653374233733612*^9}, {
   3.653374290617445*^9, 3.653374386973692*^9}, {3.6533855783375874`*^9, 
   3.653385593185493*^9}, 3.653387944824959*^9, {3.653388121357506*^9, 
   3.653388121485972*^9}, {3.655463108931476*^9, 3.655463109345581*^9}, {
   3.655475088514624*^9, 3.6554751208467493`*^9}, {3.6584880649835157`*^9, 
   3.658488065263351*^9}, 3.658488409933444*^9, 3.6584891063641167`*^9, {
   3.658489189533915*^9, 3.658489198110361*^9}, {3.658490332457281*^9, 
   3.658490361610836*^9}, {3.658490467772777*^9, 3.658490468172399*^9}, {
   3.658490683124332*^9, 3.658490687682267*^9}, 3.658490739857399*^9, {
   3.658491724666182*^9, 3.6584918238548*^9}, {3.6584919675545073`*^9, 
   3.658491973168519*^9}, 3.658492168541006*^9, 3.658492477470057*^9, {
   3.658492620097229*^9, 3.6584926224315367`*^9}, 3.658492742180097*^9, 
   3.658492782262096*^9, {3.6584928787269077`*^9, 3.658492879463056*^9}, {
   3.6584929991657743`*^9, 3.658493033549728*^9}, {3.6584934840211554`*^9, 
   3.658493484115244*^9}, {3.6584936332715693`*^9, 3.658493663785*^9}, {
   3.6584938058517113`*^9, 3.658493806060362*^9}, {3.658493880429925*^9, 
   3.6584938854048233`*^9}, 3.658493917632215*^9, {3.6584943792258587`*^9, 
   3.6584944136895113`*^9}, {3.658494479419427*^9, 3.6584945710692883`*^9}, {
   3.65849460684968*^9, 3.658494625582597*^9}, {3.658494672308535*^9, 
   3.6584946847203407`*^9}, {3.658494723666787*^9, 3.65849475267486*^9}, {
   3.65849481365259*^9, 3.6584948874757557`*^9}, {3.658494950678919*^9, 
   3.6584949727450933`*^9}, {3.658495008538146*^9, 3.658495057947399*^9}, {
   3.658495095644166*^9, 3.6584951249863853`*^9}, {3.6584951554553823`*^9, 
   3.658495218252742*^9}, {3.658495635784436*^9, 3.658495654241517*^9}, {
   3.658495707678808*^9, 3.658495723721089*^9}, {3.658495940472978*^9, 
   3.6584960417814627`*^9}, {3.658496084003586*^9, 3.658496096704918*^9}, {
   3.658496128837089*^9, 3.658496129799354*^9}, 3.658496418747533*^9, {
   3.6584964530010567`*^9, 3.658496510265503*^9}, {3.658496541293128*^9, 
   3.658496620605218*^9}, {3.658496705617445*^9, 3.658496717647923*^9}, {
   3.658496812594118*^9, 3.658496822803205*^9}, {3.658496980028163*^9, 
   3.658497039685487*^9}, 3.658497169581127*^9, {3.658497209004122*^9, 
   3.6584972247794724`*^9}, {3.658497258268911*^9, 3.658497258715517*^9}, {
   3.6584973738531847`*^9, 3.6584973973432493`*^9}, {3.6584974900816*^9, 
   3.6584974901613913`*^9}, {3.658497529381311*^9, 3.6584975538453283`*^9}, 
   3.658497687687518*^9, {3.658497727975428*^9, 3.658497728094759*^9}, {
   3.668333125349023*^9, 3.668333135604035*^9}, 3.668335868747013*^9, 
   3.6683359576257753`*^9, 3.674829656616805*^9, 3.674830043567553*^9, 
   3.67483024639983*^9, 3.6748303334289227`*^9, {3.6749869165079107`*^9, 
   3.6749869194026957`*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"th0", ",", "width"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"th0", ",", "0.05", ",", "\[Pi]", ",", "0.04"}], "}"}]}], "]"}],
    ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "2"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.658488677968759*^9, 3.658488687873197*^9}, {
   3.658488767139035*^9, 3.6584887857015247`*^9}, {3.658489062351256*^9, 
   3.658489073569653*^9}, {3.668314426210904*^9, 3.668314443808241*^9}, 
   3.674829894008165*^9}],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"th0", "=", "0.2"}], "}"}], ",", "width"}], "]"}]], "Input",
 CellChangeTimes->{{3.668314512586782*^9, 3.668314613588348*^9}, {
   3.668314656039342*^9, 3.668314656694302*^9}, 3.6683362108834877`*^9, {
   3.6683362913753633`*^9, 3.668336291501807*^9}, 3.668336388432296*^9, 
   3.674826554420794*^9, 3.67483070889471*^9}],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"th0", "=", "0.57"}], "}"}], ",", "width"}], "]"}]], "Input",
 CellChangeTimes->{{3.668314512586782*^9, 3.668314613588348*^9}, {
   3.668314656039342*^9, 3.668314656694302*^9}, 3.6683362108834877`*^9, {
   3.6683362913753633`*^9, 3.668336291501807*^9}, {3.66833638668797*^9, 
   3.6683363911846313`*^9}}],

Cell[BoxData[
 RowBox[{"??", "width"}]], "Input",
 CellChangeTimes->{{3.66831455457797*^9, 3.668314562691864*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
        RowBox[{"i", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{
        RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "2", ",", "3"}], "\[RightDoubleBracket]"}], "-", 
        RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "1", ",", "3"}], "\[RightDoubleBracket]"}]}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "pethnumxrelax2", "]"}]}], "}"}]}], "]"}], ",", 
   
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<\!\(\*SubscriptBox[\(\[Theta]\), \(0\)]\)\>\"", ",", 
      "\"\<\!\(\*SubscriptBox[\(V\), \(PN\)]\)\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388330415928*^9, 3.6533883377675123`*^9}, {
   3.658491425587987*^9, 3.658491432314345*^9}, {3.658494648942257*^9, 
   3.658494653186729*^9}, {3.6584969409807673`*^9, 3.658496959862433*^9}}],

Cell[BoxData[
 RowBox[{"plot$logvpn$theta", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
          RowBox[{"i", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Log", "@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Max", "[", "#", "]"}], "-", 
             RowBox[{"Min", "[", "#", "]"}]}], ")"}]}], "&"}], "@", 
         RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
          RowBox[{"i", ",", "All", ",", "3"}], "\[RightDoubleBracket]"}]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "pethnumxrelax2", "]"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Axes", "\[Rule]", "None"}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<1/\!\(\*SubscriptBox[\(\[Theta]\), \(0\)]\)\>\"", ",", 
       "\"\<Ln \!\(\*SubscriptBox[\(V\), \(PN\)]\)\>\""}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "15.5"}], "}"}]}], ",", 
    RowBox[{"PlotRangeClipping", "->", "False"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"FontSize", "\[Rule]", "20"}], ",", "Bold", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
    RowBox[{"FrameTicksStyle", "->", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388024167973*^9, 3.653388036648466*^9}, {
   3.658497337468657*^9, 3.65849734162813*^9}, {3.658497454352202*^9, 
   3.658497454606485*^9}, {3.6584987376950703`*^9, 3.658498749358055*^9}, {
   3.658499266283284*^9, 3.658499286087482*^9}, {3.6584993170683317`*^9, 
   3.658499364268303*^9}, {3.6584994335830107`*^9, 3.658499451166374*^9}, {
   3.674829940816338*^9, 3.674829942599648*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Pi]", "^", "2"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.658506062247972*^9, 3.6585060658310337`*^9}, 
   3.6664231661497583`*^9, {3.666439543100684*^9, 3.6664395592605877`*^9}}],

Cell[TextData[{
 "- Integration of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "pn"], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.668252134077454*^9, 3.66825214995193*^9}, {
  3.668262482318009*^9, 3.668262482525977*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"k", ">", "0"}], "}"}], ",", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Sech", "[", 
        RowBox[{"n", " ", "k"}], "]"}], "^", "4"}], " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"2", "\[Pi]", " ", "I", " ", "n"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.668235877815617*^9, 3.668235959794528*^9}, 
   3.668236001333866*^9},
 FontColor->RGBColor[0, 0, 0]],

Cell[BoxData[
 FractionBox[
  RowBox[{"4", " ", 
   SuperscriptBox["\[Pi]", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["k", "2"], "+", 
     SuperscriptBox["\[Pi]", "2"]}], ")"}], " ", 
   RowBox[{"Csch", "[", 
    FractionBox[
     SuperscriptBox["\[Pi]", "2"], "k"], "]"}]}], 
  RowBox[{"3", " ", 
   SuperscriptBox["k", "4"]}]]], "Input",
 CellChangeTimes->{3.668252116684547*^9}],

Cell["- Plot", "Text",
 CellChangeTimes->{{3.668252175325983*^9, 3.668252175805703*^9}, {
  3.668262481182687*^9, 3.668262481374755*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData["pethnumxrelax2"], "Input"],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1"}], ",", 
     RowBox[{"r", "=", "0.8"}], ",", 
     RowBox[{"kkx", "=", "10000."}], ",", 
     RowBox[{"lgdx", "=", "0.65"}], ",", 
     RowBox[{"lgdy", "=", "0.9"}]}], "}"}], ",", 
   RowBox[{"plot$logvpn$width", "=", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"data1", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             SuperscriptBox["a", "2"], "/", 
             RowBox[{"(", 
              RowBox[{"2", " ", "a", " ", "r", " ", 
               RowBox[{"Sin", "@", 
                RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
                 RowBox[{"i", ",", "1", ",", "1"}], 
                 "\[RightDoubleBracket]"}]}]}], ")"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Log", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Max", "[", "#", "]"}], "-", 
                 RowBox[{"Min", "[", "#", "]"}]}], ")"}]}], "&"}], "@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
                RowBox[{"i", ",", "All", ",", "3"}], 
                "\[RightDoubleBracket]"}], "/", 
               RowBox[{"(", 
                RowBox[{"kkx", " ", 
                 SuperscriptBox["a", "2"]}], ")"}]}], ")"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "pethnumxrelax2", "]"}]}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ListPlot", "[", 
        RowBox[{"data1", ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"Axes", "\[Rule]", "None"}], ",", " ", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<w/a\>\"", ",", 
            "\"\<ln [\!\(\*SubscriptBox[\(V\), \
\(PNB\)]\)/(\!\(\*SuperscriptBox[\(ka\), \(2\)]\))]\>\""}], "}"}]}], ",", 
         RowBox[{"PlotMarkers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "15.5"}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
         RowBox[{"PlotRangeClipping", "->", "False"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "Large"}], " ", "]"}]}], ",", 
         RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
         RowBox[{"FrameTicksStyle", "->", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
         RowBox[{"PlotLegends", "\[Rule]", 
          RowBox[{"Placed", "[", 
           RowBox[{
            RowBox[{"LineLegend", "[", 
             RowBox[{
              RowBox[{"{", "\"\<Simulation\>\"", "}"}], ",", 
              RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"lgdx", ",", "lgdy"}], "}"}]}], "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"width", ",", 
              RowBox[{"Log", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"fbond", "[", 
                    RowBox[{"i", ",", "30", ",", "th0"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"60", "-", "1"}]}], "}"}]}], "]"}], "-", 
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"fbond", "[", 
                    RowBox[{"i", ",", "29.5", ",", "th0"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"60", "-", "1"}]}], "}"}]}], "]"}]}], ")"}], "/", 
                "4"}], 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"4", " ", "comes", " ", "from", " ", 
                  RowBox[{"f", "[", 
                   RowBox[{"n", ",", "X"}], "]"}], " ", "normalized", " ", 
                  "by", " ", 
                  RowBox[{"k", "/", "2"}]}], ",", " ", 
                 RowBox[{"and", " ", 
                  RowBox[{"(", 
                   RowBox[{"max", "-", "min"}], ")"}], " ", "is", " ", 
                  "double", " ", "of", " ", "amplitude"}]}], "*)"}], "]"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"th0", ",", "0.2", ",", "0.95", ",", "0.05"}], "}"}]}], 
           "]"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", "Blue"}], ",", 
          RowBox[{"PlotMarkers", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Automatic", ",", "12.5"}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"PlotLegends", "\[Rule]", 
           RowBox[{"Placed", "[", 
            RowBox[{
             RowBox[{"PointLegend", "[", 
              RowBox[{
               RowBox[{"{", "\"\<(Max-Min)f(n,X)\>\"", "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                RowBox[{"Directive", "[", 
                 RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"lgdx", "+", "0.07"}], ",", 
               RowBox[{"lgdy", "-", "0.2"}]}], "}"}]}], "]"}]}]}], "]"}], 
        ","}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fitRangeMin", "=", "1"}], ";", 
       RowBox[{"fitRangeMax", "=", "8"}], ";", 
       RowBox[{"lm1", "=", 
        RowBox[{"LinearModelFit", "[", 
         RowBox[{
          RowBox[{"data1", "\[LeftDoubleBracket]", 
           RowBox[{"fitRangeMin", ";;", "fitRangeMax"}], 
           "\[RightDoubleBracket]"}], ",", "x", ",", "x"}], "]"}]}], ";", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"lm1", "[", "x", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"data1", "\[LeftDoubleBracket]", 
            RowBox[{"fitRangeMin", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"data1", "\[LeftDoubleBracket]", 
            RowBox[{"fitRangeMax", ",", "1"}], "\[RightDoubleBracket]"}]}], 
          "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"2", ",", "6"}], "}"}], "]"}], ",", "Black"}], 
           "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"2", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"2", " ", "for", " ", "k"}], "=", 
             RowBox[{
              RowBox[{"1", " ", "and", " ", "k"}], "=", 
              RowBox[{"-", "1"}]}]}], "*)"}], "*", "8", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"a", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{"2", "w"}], ")"}]}], ")"}], "^", "4"}], 
            RowBox[{
             RowBox[{"a", "^", "2"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", 
                RowBox[{"r", "^", "2"}]}], "+", 
               RowBox[{"a", "^", "2"}], "-", 
               RowBox[{
                RowBox[{"a", "^", "4"}], "/", 
                RowBox[{"w", "^", "2"}]}]}], ")"}]}]], 
           FractionBox[
            RowBox[{"4", 
             RowBox[{"\[Pi]", "^", "2"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"a", "/", "w"}], ")"}], "^", "2"}], "+", 
               RowBox[{"\[Pi]", "^", "2"}]}], ")"}]}], 
            RowBox[{"3", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "/", "w"}], ")"}], "^", "4"}], " ", 
             RowBox[{"Sinh", "[", 
              RowBox[{
               RowBox[{"\[Pi]", "^", "2"}], 
               RowBox[{"w", "/", "a"}]}], "]"}]}]]}], "]"}], "-", 
         RowBox[{"Log", "[", "1", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"w", ",", "0.75", ",", "3.15"}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"LineLegend", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lgdx", "+", "0.075"}], ",", 
             RowBox[{"lgdy", "-", "0.1"}]}], "}"}]}], "]"}]}]}], "]"}]}], 
     "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388024167973*^9, 3.653388036648466*^9}, {
   3.658497337468657*^9, 3.65849734162813*^9}, {3.658497454352202*^9, 
   3.658497454606485*^9}, {3.6584987376950703`*^9, 3.658498749358055*^9}, {
   3.658499266283284*^9, 3.658499286087482*^9}, {3.6584993170683317`*^9, 
   3.658499364268303*^9}, {3.6584994335830107`*^9, 3.658499451166374*^9}, {
   3.658500173001019*^9, 3.658500197647552*^9}, {3.6585002404020967`*^9, 
   3.658500263173308*^9}, {3.6585010282771063`*^9, 3.6585010344709272`*^9}, {
   3.658501069253429*^9, 3.658501157687214*^9}, {3.658501196299857*^9, 
   3.658501275676812*^9}, {3.6585013141085978`*^9, 3.658501420479031*^9}, {
   3.658501452977528*^9, 3.6585015655694113`*^9}, {3.6585016264372177`*^9, 
   3.658501632964624*^9}, 3.6585016873022623`*^9, {3.658501804536255*^9, 
   3.658501915674531*^9}, {3.658502171776442*^9, 3.658502237299219*^9}, {
   3.658502271092514*^9, 3.6585022912712297`*^9}, {3.658502333014824*^9, 
   3.658502403351492*^9}, {3.658502433878934*^9, 3.658502460550202*^9}, {
   3.658502493201675*^9, 3.658502563597715*^9}, {3.658502879536305*^9, 
   3.65850288550399*^9}, {3.65850314950036*^9, 3.6585032461510763`*^9}, {
   3.658503278588587*^9, 3.658503294874992*^9}, {3.658503363579726*^9, 
   3.6585033772592793`*^9}, {3.661150464068974*^9, 3.661150507680456*^9}, {
   3.661150554838368*^9, 3.6611505550958548`*^9}, {3.6617753442375107`*^9, 
   3.661775382639185*^9}, {3.6663601431245327`*^9, 3.66636014533709*^9}, {
   3.666417787513179*^9, 3.6664177912102547`*^9}, {3.6664186502078857`*^9, 
   3.666418667903905*^9}, {3.666418699489655*^9, 3.6664187252156563`*^9}, {
   3.666439551887432*^9, 3.6664395537585163`*^9}, {3.668235242841613*^9, 
   3.668235257034198*^9}, {3.668245705178043*^9, 3.66824579541912*^9}, {
   3.6682460383552237`*^9, 3.668246038609*^9}, {3.6682461172838373`*^9, 
   3.668246121203053*^9}, 3.668246153669808*^9, {3.668246251686721*^9, 
   3.6682462586787567`*^9}, {3.668246829188892*^9, 3.668246842149939*^9}, {
   3.668247030234202*^9, 3.668247031640771*^9}, {3.668247065738409*^9, 
   3.6682471155671263`*^9}, {3.6682475252871103`*^9, 3.668247573669937*^9}, {
   3.66824770844355*^9, 3.668247721402143*^9}, {3.6682483188890057`*^9, 
   3.668248419162293*^9}, {3.668248457646833*^9, 3.668248626750795*^9}, {
   3.668248667474189*^9, 3.668248686608555*^9}, {3.668248861063117*^9, 
   3.668248883342417*^9}, {3.668314691132001*^9, 3.668314694010984*^9}, {
   3.668314729227193*^9, 3.668314806978801*^9}, {3.66831489718289*^9, 
   3.668314939687755*^9}, {3.6683149787373657`*^9, 3.668315016223803*^9}, {
   3.668315068086608*^9, 3.668315155301919*^9}, {3.6683282798610277`*^9, 
   3.668328289443941*^9}, {3.668328326824873*^9, 3.668328355379395*^9}, {
   3.668328389978828*^9, 3.668328401384403*^9}, {3.668328965588427*^9, 
   3.668328992373364*^9}, {3.6683291639970922`*^9, 3.668329298282498*^9}, {
   3.668329375524115*^9, 3.66832948806581*^9}, 3.668330116404389*^9, {
   3.6683303559262743`*^9, 3.668330357669279*^9}, {3.668335819017548*^9, 
   3.668335831206707*^9}, 3.668337826775909*^9, {3.668337858489921*^9, 
   3.66833790872895*^9}, 3.66834312377479*^9, {3.66893870874362*^9, 
   3.668938709045711*^9}, {3.668938743223517*^9, 3.6689387703937187`*^9}, {
   3.6689388304585323`*^9, 3.66893883538774*^9}, {3.668939183348536*^9, 
   3.668939241396283*^9}, {3.668939354376904*^9, 3.6689394358323727`*^9}, {
   3.6689398848407927`*^9, 3.668939916040819*^9}, {3.6748248292015142`*^9, 
   3.6748248533339453`*^9}, {3.674824902766995*^9, 3.6748249914569798`*^9}, {
   3.67482502881038*^9, 3.674825043693801*^9}, {3.674828575528556*^9, 
   3.674828608309545*^9}, {3.674828727991988*^9, 3.6748287571045837`*^9}, {
   3.674828793602789*^9, 3.6748288377131443`*^9}, 3.6749859809317513`*^9}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{{{}, {
       {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
        AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{
         3.145930967295215, -31.002195932578978`}}, {{
         2.526232813263169, -24.66146305139664}}, {{
         2.114914601140076, -20.383496664501337`}}, {{
         1.822700485132728, -17.285984074456255`}}, {{
         1.6049577847173642`, -14.927695105505844`}}, {{
         1.4368954571931065`, -13.063235623584132`}}, {{
         1.30364352683343, -11.545096916243065`}}, {{
         1.195743774491406, -10.279111584686943`}}, {{
         1.106895122929828, -9.202158462983254}}, {{
         1.0327396552139383`, -8.270123523888506}}, {{
         0.97016895434819, -7.450960336179478}}, {{
         0.9169079527968814, -6.720420058032602}}, {{
         0.8712548871178974, -6.059107730122711}}, {{
         0.8319130856118744, -5.450216651641318}}, {{
         0.7978788834118095, -4.876375633216176}}, {{
         0.7683649946675627, -4.31208316839933}}}]}, {}}, {}}, {{}, {
       {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->12.5], {0., 0.}], {{{
         3.145930967295215, -26.720126989888612`}}, {{
         2.526232813263169, -20.582165169185892`}}, {{
         2.114914601140076, -16.496123245568988`}}, {{
         1.822700485132728, -13.580961656544487`}}, {{
         1.6049577847173642`, -11.396263458573953`}}, {{
         1.4368954571931065`, -9.697452987448365}}, {{
         1.30364352683343, -8.337884097916062}}, {{
         1.195743774491406, -7.224336130013513}}, {{
         1.106895122929828, -6.294763806062669}}, {{
         1.0327396552139383`, -5.506319017844046}}, {{
         0.97016895434819, -4.828509547029901}}, {{
         0.9169079527968814, -4.239098622247664}}, {{
         0.8712548871178974, -3.72154748681991}}, {{
         0.8319130856118744, -3.2633670416648584`}}, {{
         0.7978788834118095, -2.8550265314896697`}}, {{
         0.7683649946675627, -2.489215504379729}}}]}, {}}, {}}, {{}, {}, 
      {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVxX8403kcAPCNzfbt0cmDMOVXNr/C/Bhrte/nw1K6QqxVlzNJfjwup6s8
N5TyqzBXyiVXsdxo5VzxeJ7T0+PyFk6F9twjpR9YKYXTyhaScXd/vJ6X0770
6EQjCoUS/p///z7RdGOnkw6NNjFsd392gakCysEgFx2KbAtXX1hwgQO1+kv1
HB263Vte+GTJBVJHX+jKPHXo3FuH6Z0mbEiK/10Zy9Oh4NX8HokFG6SxEcaz
YTqkKEo5JvZiQ4Sk7K77QR2Kibv/MiKeDV6hlsFn7ujQ36by+tD7bIiuTi4o
SdGjSsK/urGeA+kbP9qEMD6h5x0FaZ7HXEG86Vbdi18/IbMhcWjhVjeoan8g
U22dQazKzce/9XQHTbFFlff4DKpd8eZn0YI7FPWoGGPls4juqTK9NuwBcymZ
qSfWz6HdtWOlk62esFeca//kyRziPFe/I0vXgnfLIxtp7mf0sHnoqlmaF+iT
pftrHObR9Jbz+APpDXlH2Ne6b88jJnrw6qapD2TMB/nZJ3xB+oE1b/+Z9IH4
vhPLfSkLiHu+fHSVlAvNtlY+R+oXUFSZimak5kJv+1jYxSgDmhTMX38s9IWh
P943H50yIFGnk9C/zhd2sEMSz1QsolPVMbkRVn7QoelJlgYsoeJdqc0fj/lB
pVVNY+zIEpLFyyvEWj9g9T+dU4goeIQ1aaiV+sPr4MVg7VkKpjU7iHP+8of4
tLAbj8co2Opy0jcrgwIgps1LtCqQiscS8sIDrwQAv813R38+FXs/f9EVyuDB
veyYIudBKk5QbtFa/MiDR1LHN2qOEd75tdwkdYQH5YvLEq2OGmFeyMjDnO2B
ELjNMr5XbYRLx3+wy28LBAncKny52hgr059KzFyDwPVjXt/pQ8a4bpM4eM+F
IMgIeye82G6MExdqWF4UPqjCD3hYm9GwIt5Hpk3iQ6nZSsHaBBrutFafPPiY
D1Ozew4pmmj4WoMoP5NcB9Sqrr56EzqWnXvADb65Ds6m9ERZ7qRjxi5Ob5mN
AOivtFFaJR1/1QOT6uMCWGsjyNg3R8fUsrTWPq0A1Ecc2v03m+Bmf22WePd6
YJ/24FZdNsFRbvkTF+6vB6lkh53sgwlO6pUM9/A3gIXI1qeJZGBBpKHt1JUN
kD1lnJRXzsDzzi3RRuZC2HunuKvpFQNnDoT207KE4Cb0ronmMnF6kMXgjEYI
StmcQl7AxOKJ6Z9U20m4+Cy227mfiT9lq3w1t0iILaxozn3ExKfWbS5ruk2C
I1et0Awwsd3s2Pu8VhLqCrGsepCJ0SFOAxtIaOSucWcNM7E8pY7zXTcJ3Sff
lZiPM7GTRGk3M0CC3u9wBGWJicO9FXRTHQktQ78J4igEfjlJ7h/Sk5BV9Jpz
h0rgjOvDd2/MkLA0JFnKphH4Fxf7E1HzJCwr5jfOEgQeZVXNV1AROI4YzLWW
BM5kXNI6rUAwWhy4GL6SwMu7BBE6cwRXA9InGqwJrMh71tBpgcCzRHM3lUXg
LoNtarI1gkBex+ExBwKb6StfN9gj+DzyJS7UicDKJr4oxxFBa0nAtlpnAvPS
B2sinRGEaOpc9rEJHDNhHTfNRkCXD69o5xBYq2r5s8MVwT2etcHBjcC5ibtW
nXdHUKKJHM9xJ7DFmtmsJE8E4fKigSEPAqs0FU+DvBD8C7V7QbE=
        "]]}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVxXk4lHkcAPDxGmNebZNKGkKsOyqT+x3T72eKR4l1lGIkG/XUqmdkyqo0
1pHQNbI2pZZxzJaHtiQPbZqvrlVC2dTq8GzjGkxMDOXe3T8+z8ditzBkD0Gj
0QL+8/9ra/yNaTQlUo/6Lb5KEtDap/1Ql6FEmW6bm41NCThgdC9u0TdKJPc9
Z5LnRECF2LHBjK1E3EBGpWg7ATabFkbznJTIKyPi9HgZAWZdreXHopXojVq8
m460gcUM4YyDEonEBeU5QjoMC3b4DaYOoMKpEyPvHzLA5fVF8WarITQy0Hv1
askCSG0/tvxzhQq1rTTgY0IfaI3vNJ/sh9HHIt5An9ES0E0Tvo1+OoK6qz82
ToYYQM7u0MVnZWqUK2OvP7DTELYdzKovS/qMZB86D3ufYYPHoZn0ft9RlOuz
wGeqwhjM3R6kBOiOofsriE2aYhPwj5WmDL8ZQyF2b8ISG8zgaGj7zerLGsS0
OvIpO9wcgMunl4SPI/Z4Thkv0AK2nG0WPLebQGOq/ufSsG/hXZGsx2hwAs17
ZdbGb7GEqhWFh0r++ILqzCgBK8wKCiSt5mHZX1HtyjMawwhrOPUkVGv1pkmU
GlV9h9xiA/V7RnvXG00h0Y+jC1XBtjDyWDEtejeFairZE4M+drD/vGpZT9U0
SmyQMxUB9jAd7BqSkjyDig/2OVYErYLcjjY5jzeLWNv2tzZ5O0Dcg3SOO2sO
vbAsmB/0dQS/+OxXoS/n0Kn6FvNkajWg5a2XCiXzSMqddtC3XwP3lv7CWeRE
w11kXWaVw1oQzHxao5DQsDiHnx7HcoIrl0JutE/ScMEzzwCdXCf44fbr+39H
a2HZ29uRdos5UF+lvU8NWjgiMGe8MIsDFZG8PGt7AhtHDl1bprcOTFUrtx/I
IfBQkNnlnrR1YPLVorJpgMC9LRYRvpProKHOKZ0frI0dKKi8cdQZ/glXjrbc
0sZWlfH+CZ+dofz3yp5EYzpWKuQbvUQuoOo1EnKS6TjLVC6MVbmAvECWo/We
jlUTxslWMa7gQsN2Ixt0cMGgeHKw2xUc/NKihst0sI2UlbY00g0ebXxpuIDF
wKuCtnryu9xgoAFF844wMN/H7We9KHeQLN/OT+1g4OONWwmPDnfotD4uU/B0
cXtJ49m4MA8oM/Ar3Vaki2mdJ6/otHnAdIoLp2tOFwvkWa5ePp6gKVrtnbGX
iU/ovGpOeuwJwuK2Ae6fTCz4XtBjyqOA0f32yVATEws71GwXRMEV677SwmdM
rN7JDdjsTcGzipmd0y1MbDI/UpPoQ4HNHfv2u6+Y+Nyjzp/aAij48DT9rqeC
iWN2NOqlRlHgP+Z+2n2WiZsNhP3dKRQoXDfs659j4vbbrUumUilISgr0uUgj
cZ26l6efQYFsNnZ+QpvEp/K4eV5ZFBDMC6JaPRKv+u0klS+hoN5EJXBlk7gM
y477SikI2vXFo9eIxJkzWSWRpRT0SQnD/BUkvi6xeppQToGBrdELjRmJY85n
Liu6TkE8x3djjTWJh+lfK77cokD3cLBFrC2Jd0hL2xbWUPBrbeTcUnsSV99k
aixrKXjOFdWJHEmsf2SeG3SXghixON9yDYkTgnJ37b1HwRRkJ/y1lsQnht6n
Jd+nQKKd/106h8QB4YryC0CBrW+xo7MziWcrpU3XHlDwLwHeSCg=
        "]]}}}, {InsetBox[
      TemplateBox[{"\"Simulation\""},
       "LineLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.2980645161290323], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.2980645161290323], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], FontSize -> 15.5, Plain, 
                    StripOnInput -> False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {15.5, 15.5}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.24193548387096775`] -> 
                    Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{"Directive", "[", 
                RowBox[{
                  RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                  ",", 
                  InterpretationBox[
                   ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                   RGBColor[0.368417, 0.506779, 0.709798], Editable -> False, 
                   Selectable -> False], ",", 
                  RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
              "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"{", 
                  RowBox[{"\"\[FilledCircle]\"", ",", "15.5`"}], "}"}], 
                "}"}]}], ",", 
            RowBox[{"Joined", "\[Rule]", 
              RowBox[{"{", "False", "}"}]}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& )], 
      Scaled[{0.65, 0.9}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm], InsetBox[
      TemplateBox[{"\"(Max-Min)f(n,X)\""},
       "PointLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.36960000000000004`], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], {
                    InsetBox[
                    FormBox[
                    StyleBox["\"\[FilledCircle]\"", 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.36960000000000004`], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1]], FontSize -> 12.5, Plain, StripOnInput -> 
                    False], TraditionalForm], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]]]}}}, AspectRatio -> Full, 
                    ImageSize -> {12.5, 12.5}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.18000000000000002`] -> 
                    Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"PointLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{"Directive", "[", 
                RowBox[{
                  RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                  ",", 
                  RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                  InterpretationBox[
                   ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0, 1]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                   RGBColor[0, 0, 1], Editable -> False, Selectable -> 
                   False]}], "]"}], "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"{", 
                  RowBox[{"\"\[FilledCircle]\"", ",", "12.5`"}], "}"}], 
                "}"}]}], ",", 
            RowBox[{"Joined", "\[Rule]", 
              RowBox[{"{", "False", "}"}]}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", 
              RowBox[{"{", 
                RowBox[{"\"Column\"", ",", 
                  RowBox[{"{", 
                    RowBox[{"Automatic", ",", "5"}], "}"}]}], "}"}]}]}], 
          "]"}]& )], Scaled[{0.72, 0.7}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm], InsetBox[
      TemplateBox[{"\"Continuum theory\""},
       "LineLegend",
       DisplayFunction->(StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          Directive[FontSize -> Large], FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False]& ),
       Editable->True,
       InterpretationFunction:>(RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{"Directive", "[", 
                RowBox[{
                  RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                  RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                  InterpretationBox[
                   ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                   RGBColor[1, 0, 0], Editable -> False, Selectable -> 
                   False]}], "]"}], "}"}], ",", 
            RowBox[{"{", #, "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& )], 
      Scaled[{0.725, 0.8}], ImageScaled[{0.5, 0.5}],
      BaseStyle->{FontSize -> Larger},
      FormatType->StandardForm]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{False, False},
   AxesLabel->{None, None},
   AxesOrigin->{0.7312155263452557, 0},
   DisplayFunction->Identity,
   Epilog->{
     InsetBox[
      FormBox[
       StyleBox["\"y=2.2-10.6x\"", FontSize -> 24, 
        RGBColor[0, 1, 0], StripOnInput -> False], TraditionalForm], {
      1.9, -25}]},
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox[
      "\"Log[ \\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))]\"", 
       TraditionalForm], None}, {
      FormBox["\"w/a\"", TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   FrameTicksStyle->Directive[FontSize -> 20],
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->Large,
   LabelStyle->Directive[FontSize -> Large],
   Method->{},
   PlotRange->{{0.7683649946675627, 
     3.145930967295215}, {-31.002195932578978`, 0}},
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.02]}},
   Ticks->{Automatic, Automatic}],
  InterpretTemplate[Legended[
    Graphics[{{{}, {{{
          Directive[
           PointSize[0.012833333333333334`], 
           RGBColor[0.368417, 0.506779, 0.709798], 
           AbsoluteThickness[1.6], 
           AbsolutePointSize[6]], 
          GeometricTransformation[
           Inset[
            Style["\[FilledCircle]", FontSize -> 15.5], {0., 0.}], {{{
           3.145930967295215, -31.002195932578978`}}, {{
           2.526232813263169, -24.66146305139664}}, {{
           2.114914601140076, -20.383496664501337`}}, {{
           1.822700485132728, -17.285984074456255`}}, {{
           1.6049577847173642`, -14.927695105505844`}}, {{
           1.4368954571931065`, -13.063235623584132`}}, {{
           1.30364352683343, -11.545096916243065`}}, {{
           1.195743774491406, -10.279111584686943`}}, {{
           1.106895122929828, -9.202158462983254}}, {{
           1.0327396552139383`, -8.270123523888506}}, {{
           0.97016895434819, -7.450960336179478}}, {{
           0.9169079527968814, -6.720420058032602}}, {{
           0.8712548871178974, -6.059107730122711}}, {{
           0.8319130856118744, -5.450216651641318}}, {{
           0.7978788834118095, -4.876375633216176}}, {{
           0.7683649946675627, -4.31208316839933}}}]}, {}}}, {}}, {{}, {{{
          Directive[
           PointSize[0.012833333333333334`], 
           AbsoluteThickness[1.6], 
           RGBColor[0, 0, 1], 
           AbsolutePointSize[6]], 
          GeometricTransformation[
           Inset[
            Style["\[FilledCircle]", FontSize -> 12.5], {0., 0.}], {{{
           3.145930967295215, -26.720126989888612`}}, {{
           2.526232813263169, -20.582165169185892`}}, {{
           2.114914601140076, -16.496123245568988`}}, {{
           1.822700485132728, -13.580961656544487`}}, {{
           1.6049577847173642`, -11.396263458573953`}}, {{
           1.4368954571931065`, -9.697452987448365}}, {{
           1.30364352683343, -8.337884097916062}}, {{
           1.195743774491406, -7.224336130013513}}, {{
           1.106895122929828, -6.294763806062669}}, {{
           1.0327396552139383`, -5.506319017844046}}, {{
           0.97016895434819, -4.828509547029901}}, {{
           0.9169079527968814, -4.239098622247664}}, {{
           0.8712548871178974, -3.72154748681991}}, {{
           0.8319130856118744, -3.2633670416648584`}}, {{
           0.7978788834118095, -2.8550265314896697`}}, {{
           0.7683649946675627, -2.489215504379729}}}]}, {}}}, {}}, {{{}, {}, {
        
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 1, 0]], 
         Line[CompressedData["
1:eJwVxX8403kcAPCNzfbt0cmDMOVXNr/C/Bhrte/nw1K6QqxVlzNJfjwup6s8
N5TyqzBXyiVXsdxo5VzxeJ7T0+PyFk6F9twjpR9YKYXTyhaScXd/vJ6X0770
6EQjCoUS/p///z7RdGOnkw6NNjFsd392gakCysEgFx2KbAtXX1hwgQO1+kv1
HB263Vte+GTJBVJHX+jKPHXo3FuH6Z0mbEiK/10Zy9Oh4NX8HokFG6SxEcaz
YTqkKEo5JvZiQ4Sk7K77QR2Kibv/MiKeDV6hlsFn7ujQ36by+tD7bIiuTi4o
SdGjSsK/urGeA+kbP9qEMD6h5x0FaZ7HXEG86Vbdi18/IbMhcWjhVjeoan8g
U22dQazKzce/9XQHTbFFlff4DKpd8eZn0YI7FPWoGGPls4juqTK9NuwBcymZ
qSfWz6HdtWOlk62esFeca//kyRziPFe/I0vXgnfLIxtp7mf0sHnoqlmaF+iT
pftrHObR9Jbz+APpDXlH2Ne6b88jJnrw6qapD2TMB/nZJ3xB+oE1b/+Z9IH4
vhPLfSkLiHu+fHSVlAvNtlY+R+oXUFSZimak5kJv+1jYxSgDmhTMX38s9IWh
P943H50yIFGnk9C/zhd2sEMSz1QsolPVMbkRVn7QoelJlgYsoeJdqc0fj/lB
pVVNY+zIEpLFyyvEWj9g9T+dU4goeIQ1aaiV+sPr4MVg7VkKpjU7iHP+8of4
tLAbj8co2Opy0jcrgwIgps1LtCqQiscS8sIDrwQAv813R38+FXs/f9EVyuDB
veyYIudBKk5QbtFa/MiDR1LHN2qOEd75tdwkdYQH5YvLEq2OGmFeyMjDnO2B
ELjNMr5XbYRLx3+wy28LBAncKny52hgr059KzFyDwPVjXt/pQ8a4bpM4eM+F
IMgIeye82G6MExdqWF4UPqjCD3hYm9GwIt5Hpk3iQ6nZSsHaBBrutFafPPiY
D1Ozew4pmmj4WoMoP5NcB9Sqrr56EzqWnXvADb65Ds6m9ERZ7qRjxi5Ob5mN
AOivtFFaJR1/1QOT6uMCWGsjyNg3R8fUsrTWPq0A1Ecc2v03m+Bmf22WePd6
YJ/24FZdNsFRbvkTF+6vB6lkh53sgwlO6pUM9/A3gIXI1qeJZGBBpKHt1JUN
kD1lnJRXzsDzzi3RRuZC2HunuKvpFQNnDoT207KE4Cb0ronmMnF6kMXgjEYI
StmcQl7AxOKJ6Z9U20m4+Cy227mfiT9lq3w1t0iILaxozn3ExKfWbS5ruk2C
I1et0Awwsd3s2Pu8VhLqCrGsepCJ0SFOAxtIaOSucWcNM7E8pY7zXTcJ3Sff
lZiPM7GTRGk3M0CC3u9wBGWJicO9FXRTHQktQ78J4igEfjlJ7h/Sk5BV9Jpz
h0rgjOvDd2/MkLA0JFnKphH4Fxf7E1HzJCwr5jfOEgQeZVXNV1AROI4YzLWW
BM5kXNI6rUAwWhy4GL6SwMu7BBE6cwRXA9InGqwJrMh71tBpgcCzRHM3lUXg
LoNtarI1gkBex+ExBwKb6StfN9gj+DzyJS7UicDKJr4oxxFBa0nAtlpnAvPS
B2sinRGEaOpc9rEJHDNhHTfNRkCXD69o5xBYq2r5s8MVwT2etcHBjcC5ibtW
nXdHUKKJHM9xJ7DFmtmsJE8E4fKigSEPAqs0FU+DvBD8C7V7QbE=
          
          "]]}}}, {{{}, {}, {
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[1, 0, 0]], 
         Line[CompressedData["
1:eJwVxXk4lHkcAPDxGmNebZNKGkKsOyqT+x3T72eKR4l1lGIkG/XUqmdkyqo0
1pHQNbI2pZZxzJaHtiQPbZqvrlVC2dTq8GzjGkxMDOXe3T8+z8ditzBkD0Gj
0QL+8/9ra/yNaTQlUo/6Lb5KEtDap/1Ql6FEmW6bm41NCThgdC9u0TdKJPc9
Z5LnRECF2LHBjK1E3EBGpWg7ATabFkbznJTIKyPi9HgZAWZdreXHopXojVq8
m460gcUM4YyDEonEBeU5QjoMC3b4DaYOoMKpEyPvHzLA5fVF8WarITQy0Hv1
askCSG0/tvxzhQq1rTTgY0IfaI3vNJ/sh9HHIt5An9ES0E0Tvo1+OoK6qz82
ToYYQM7u0MVnZWqUK2OvP7DTELYdzKovS/qMZB86D3ufYYPHoZn0ft9RlOuz
wGeqwhjM3R6kBOiOofsriE2aYhPwj5WmDL8ZQyF2b8ISG8zgaGj7zerLGsS0
OvIpO9wcgMunl4SPI/Z4Thkv0AK2nG0WPLebQGOq/ufSsG/hXZGsx2hwAs17
ZdbGb7GEqhWFh0r++ILqzCgBK8wKCiSt5mHZX1HtyjMawwhrOPUkVGv1pkmU
GlV9h9xiA/V7RnvXG00h0Y+jC1XBtjDyWDEtejeFairZE4M+drD/vGpZT9U0
SmyQMxUB9jAd7BqSkjyDig/2OVYErYLcjjY5jzeLWNv2tzZ5O0Dcg3SOO2sO
vbAsmB/0dQS/+OxXoS/n0Kn6FvNkajWg5a2XCiXzSMqddtC3XwP3lv7CWeRE
w11kXWaVw1oQzHxao5DQsDiHnx7HcoIrl0JutE/ScMEzzwCdXCf44fbr+39H
a2HZ29uRdos5UF+lvU8NWjgiMGe8MIsDFZG8PGt7AhtHDl1bprcOTFUrtx/I
IfBQkNnlnrR1YPLVorJpgMC9LRYRvpProKHOKZ0frI0dKKi8cdQZ/glXjrbc
0sZWlfH+CZ+dofz3yp5EYzpWKuQbvUQuoOo1EnKS6TjLVC6MVbmAvECWo/We
jlUTxslWMa7gQsN2Ixt0cMGgeHKw2xUc/NKihst0sI2UlbY00g0ebXxpuIDF
wKuCtnryu9xgoAFF844wMN/H7We9KHeQLN/OT+1g4OONWwmPDnfotD4uU/B0
cXtJ49m4MA8oM/Ar3Vaki2mdJ6/otHnAdIoLp2tOFwvkWa5ePp6gKVrtnbGX
iU/ovGpOeuwJwuK2Ae6fTCz4XtBjyqOA0f32yVATEws71GwXRMEV677SwmdM
rN7JDdjsTcGzipmd0y1MbDI/UpPoQ4HNHfv2u6+Y+Nyjzp/aAij48DT9rqeC
iWN2NOqlRlHgP+Z+2n2WiZsNhP3dKRQoXDfs659j4vbbrUumUilISgr0uUgj
cZ26l6efQYFsNnZ+QpvEp/K4eV5ZFBDMC6JaPRKv+u0klS+hoN5EJXBlk7gM
y477SikI2vXFo9eIxJkzWSWRpRT0SQnD/BUkvi6xeppQToGBrdELjRmJY85n
Liu6TkE8x3djjTWJh+lfK77cokD3cLBFrC2Jd0hL2xbWUPBrbeTcUnsSV99k
aixrKXjOFdWJHEmsf2SeG3SXghixON9yDYkTgnJ37b1HwRRkJ/y1lsQnht6n
Jd+nQKKd/106h8QB4YryC0CBrW+xo7MziWcrpU3XHlDwLwHeSCg=
          "]]}}}}, {
     Epilog -> {
        Text[
         Style["y=2.2-10.6x", FontSize -> 24, 
          RGBColor[0, 1, 0]], {1.9, -25}]}, DisplayFunction -> Identity, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.02]}}, AxesOrigin -> {0.7312155263452557, 0}, 
      PlotRange -> {{0.7683649946675627, 
        3.145930967295215}, {-31.002195932578978`, 0}}, DisplayFunction -> 
      Identity, AspectRatio -> GoldenRatio^(-1), Axes -> {False, False}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0.7312155263452557, 0}, 
      DisplayFunction :> Identity, Frame -> {{True, True}, {True, True}}, 
      FrameLabel -> {{
        "Log[ \!\(\*SubscriptBox[\(V\), \(PNB\)]\)/(\!\(\*SuperscriptBox[\(ka\
\), \(2\)]\))]", None}, {"w/a", None}}, FrameStyle -> Thickness[Large], 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      FrameTicksStyle -> Directive[FontSize -> 20], GridLines -> {None, None},
       GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], ImageSize -> Large, LabelStyle -> 
      Directive[FontSize -> Large], Method -> {}, 
      PlotRange -> {{0.7683649946675627, 
        3.145930967295215}, {-31.002195932578978`, 0}}, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
    Placed[
     Unevaluated[
      Unevaluated[
       Unevaluated[
        LineLegend[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 0]]}, {"Continuum theory"}, LegendMarkers -> None, 
         LabelStyle -> Directive[FontSize -> Large], LegendLayout -> 
         "Column"]]]], {0.725, 0.8}, Identity]]& ],
  AutoDelete->True,
  Editable->True,
  SelectWithContents->False,
  Selectable->True]], "Input",
 CellChangeTimes->{3.668939905261743*^9}],

Cell["some trial", "Text",
 CellChangeTimes->{{3.668330600600526*^9, 3.668330601030611*^9}, {
  3.668330905551202*^9, 3.6683309103069468`*^9}},
 FontColor->RGBColor[0, 1, 0]],

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{"fbond", "[", 
           RowBox[{"i", ",", 
            RowBox[{"IntegerPart", "[", 
             RowBox[{"num", "/", "2"}], "]"}], ",", "th0"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "-", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{"fbond", "[", 
           RowBox[{"i", ",", 
            RowBox[{
             RowBox[{"IntegerPart", "[", 
              RowBox[{"num", "/", "2"}], "]"}], "-", "0.5"}], ",", "th0"}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ")"}], "]"}], "/", 
     "2"}], " ", "*", " ", "10000"}], ",", 
   RowBox[{"{", 
    RowBox[{"num", ",", "20", ",", "100"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6683298393654413`*^9, 3.668329842164939*^9}, {
  3.668329883477894*^9, 3.668329929815048*^9}, {3.668330373794492*^9, 
  3.668330477092042*^9}, {3.6683306112389603`*^9, 3.668330824572959*^9}}],

Cell[BoxData[
 RowBox[{"Transpose", "@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"data1", "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
    RowBox[{"10000", 
     RowBox[{"Exp", "[", 
      RowBox[{"data1", "\[LeftDoubleBracket]", 
       RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.6683305286811953`*^9, 3.668330580054447*^9}}],

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1"}], ",", 
     RowBox[{"r", "=", "0.8"}], ",", 
     RowBox[{"kkx", "=", "10000."}], ",", 
     RowBox[{"lgdx", "=", "0.65"}], ",", 
     RowBox[{"lgdy", "=", "0.9"}]}], "}"}], ",", 
   RowBox[{"plot$logvpn$width", "=", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"data1", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             SuperscriptBox["a", "2"], "/", 
             RowBox[{"(", 
              RowBox[{"2", " ", "a", " ", "r", " ", 
               RowBox[{"Sin", "@", 
                RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
                 RowBox[{"i", ",", "1", ",", "1"}], 
                 "\[RightDoubleBracket]"}]}]}], ")"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Max", "[", "#", "]"}], "-", 
                RowBox[{"Min", "[", "#", "]"}]}], ")"}], "&"}], "@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"pethnumxrelax2", "\[LeftDoubleBracket]", 
                RowBox[{"i", ",", "All", ",", "3"}], 
                "\[RightDoubleBracket]"}], "/", 
               RowBox[{"(", 
                RowBox[{"kkx", " ", 
                 SuperscriptBox["a", "2"]}], ")"}]}], ")"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "pethnumxrelax2", "]"}]}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ListPlot", "[", 
        RowBox[{"data1", ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"Axes", "\[Rule]", "None"}], ",", " ", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<w/a\>\"", ",", 
            "\"\<Log[ \!\(\*SubscriptBox[\(V\), \
\(PNB\)]\)/(\!\(\*SuperscriptBox[\(ka\), \(2\)]\))]\>\""}], "}"}]}], ",", 
         RowBox[{"PlotMarkers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "15.5"}], "}"}]}], ",", 
         RowBox[{"PlotRangeClipping", "->", "False"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
         RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
         RowBox[{"FrameTicksStyle", "->", 
          RowBox[{"Directive", "[", 
           RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
         RowBox[{"PlotLegends", "\[Rule]", 
          RowBox[{"Placed", "[", 
           RowBox[{
            RowBox[{"LineLegend", "[", 
             RowBox[{
              RowBox[{"{", "\"\<Simulation\>\"", "}"}], ",", 
              RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"Directive", "[", 
                RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"lgdx", ",", "lgdy"}], "}"}]}], "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"width", ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"fbond", "[", 
                  RowBox[{"i", ",", "30", ",", "th0"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", 
                   RowBox[{"60", "-", "1"}]}], "}"}]}], "]"}], "-", 
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"fbond", "[", 
                  RowBox[{"i", ",", "29.5"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", 
                   RowBox[{"60", "-", "1"}]}], "}"}]}], "]"}]}], ")"}], "/", 
             "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"th0", ",", "0.2", ",", "0.95", ",", "0.05"}], "}"}]}], 
         "]"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", "Blue"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"PointLegend", "[", 
            RowBox[{
             RowBox[{"{", "\"\<(Max-Min)f(n,X)\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lgdx", "+", "0.07"}], ",", 
             RowBox[{"lgdy", "-", "0.2"}]}], "}"}]}], "]"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fitRangeMin", "=", "1"}], ";", 
       RowBox[{"fitRangeMax", "=", "8"}], ";", 
       RowBox[{"lm1", "=", 
        RowBox[{"LinearModelFit", "[", 
         RowBox[{
          RowBox[{"data1", "\[LeftDoubleBracket]", 
           RowBox[{"fitRangeMin", ";;", "fitRangeMax"}], 
           "\[RightDoubleBracket]"}], ",", "x", ",", "x"}], "]"}]}], ";", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"lm1", "[", "x", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"data1", "\[LeftDoubleBracket]", 
            RowBox[{"fitRangeMin", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"data1", "\[LeftDoubleBracket]", 
            RowBox[{"fitRangeMax", ",", "1"}], "\[RightDoubleBracket]"}]}], 
          "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Green"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"2", " ", "8", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"a", "^", "2"}], "/", 
             RowBox[{"(", 
              RowBox[{"2", "w"}], ")"}]}], ")"}], "^", "4"}], 
          RowBox[{
           RowBox[{"a", "^", "2"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", 
              RowBox[{"r", "^", "2"}]}], "+", 
             RowBox[{"a", "^", "2"}], "-", 
             RowBox[{
              RowBox[{"a", "^", "4"}], "/", 
              RowBox[{"w", "^", "2"}]}]}], ")"}]}]], 
         FractionBox[
          RowBox[{"4", 
           RowBox[{"\[Pi]", "^", "2"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "/", "w"}], ")"}], "^", "2"}], "+", 
             RowBox[{"\[Pi]", "^", "2"}]}], ")"}]}], 
          RowBox[{"3", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "/", "w"}], ")"}], "^", "4"}], " ", 
           RowBox[{"Sinh", "[", 
            RowBox[{
             RowBox[{"\[Pi]", "^", "2"}], 
             RowBox[{"w", "/", "a"}]}], "]"}]}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"w", ",", "0.75", ",", "3.15"}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"Placed", "[", 
          RowBox[{
           RowBox[{"LineLegend", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Continuum theory\>\"", "}"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lgdx", "+", "0.075"}], ",", 
             RowBox[{"lgdy", "-", "0.1"}]}], "}"}]}], "]"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"\"\<y=\>\"", "<>", 
             RowBox[{"ToString", "@", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{"lm1", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2", ",", "1"}], "\[RightDoubleBracket]"}],
                 ",", "0.1"}], "]"}]}], "<>", 
             RowBox[{"ToString", "@", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{"lm1", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2", ",", "2"}], "\[RightDoubleBracket]"}],
                 ",", "0.1"}], "]"}]}], "<>", "\"\<x\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "24"}], ",", "Green"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"1.9", ",", 
            RowBox[{"-", "25"}]}], "}"}]}], "]"}], "}"}]}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388024167973*^9, 3.653388036648466*^9}, {
   3.658497337468657*^9, 3.65849734162813*^9}, {3.658497454352202*^9, 
   3.658497454606485*^9}, {3.6584987376950703`*^9, 3.658498749358055*^9}, {
   3.658499266283284*^9, 3.658499286087482*^9}, {3.6584993170683317`*^9, 
   3.658499364268303*^9}, {3.6584994335830107`*^9, 3.658499451166374*^9}, {
   3.658500173001019*^9, 3.658500197647552*^9}, {3.6585002404020967`*^9, 
   3.658500263173308*^9}, {3.6585010282771063`*^9, 3.6585010344709272`*^9}, {
   3.658501069253429*^9, 3.658501157687214*^9}, {3.658501196299857*^9, 
   3.658501275676812*^9}, {3.6585013141085978`*^9, 3.658501420479031*^9}, {
   3.658501452977528*^9, 3.6585015655694113`*^9}, {3.6585016264372177`*^9, 
   3.658501632964624*^9}, 3.6585016873022623`*^9, {3.658501804536255*^9, 
   3.658501915674531*^9}, {3.658502171776442*^9, 3.658502237299219*^9}, {
   3.658502271092514*^9, 3.6585022912712297`*^9}, {3.658502333014824*^9, 
   3.658502403351492*^9}, {3.658502433878934*^9, 3.658502460550202*^9}, {
   3.658502493201675*^9, 3.658502563597715*^9}, {3.658502879536305*^9, 
   3.65850288550399*^9}, {3.65850314950036*^9, 3.6585032461510763`*^9}, {
   3.658503278588587*^9, 3.658503294874992*^9}, {3.658503363579726*^9, 
   3.6585033772592793`*^9}, {3.661150464068974*^9, 3.661150507680456*^9}, {
   3.661150554838368*^9, 3.6611505550958548`*^9}, {3.6617753442375107`*^9, 
   3.661775382639185*^9}, {3.6663601431245327`*^9, 3.66636014533709*^9}, {
   3.666417787513179*^9, 3.6664177912102547`*^9}, {3.6664186502078857`*^9, 
   3.666418667903905*^9}, {3.666418699489655*^9, 3.6664187252156563`*^9}, {
   3.666439551887432*^9, 3.6664395537585163`*^9}, {3.668235242841613*^9, 
   3.668235257034198*^9}, {3.668245705178043*^9, 3.66824579541912*^9}, {
   3.6682460383552237`*^9, 3.668246038609*^9}, {3.6682461172838373`*^9, 
   3.668246121203053*^9}, 3.668246153669808*^9, {3.668246251686721*^9, 
   3.6682462586787567`*^9}, {3.668246829188892*^9, 3.668246842149939*^9}, {
   3.668247030234202*^9, 3.668247031640771*^9}, {3.668247065738409*^9, 
   3.6682471155671263`*^9}, {3.6682475252871103`*^9, 3.668247573669937*^9}, {
   3.66824770844355*^9, 3.668247721402143*^9}, {3.6682483188890057`*^9, 
   3.668248419162293*^9}, {3.668248457646833*^9, 3.668248626750795*^9}, {
   3.668248667474189*^9, 3.668248686608555*^9}, {3.668248861063117*^9, 
   3.668248883342417*^9}, {3.668314691132001*^9, 3.668314694010984*^9}, {
   3.668314729227193*^9, 3.668314806978801*^9}, {3.66831489718289*^9, 
   3.668314939687755*^9}, {3.6683149787373657`*^9, 3.668315016223803*^9}, {
   3.668315068086608*^9, 3.668315155301919*^9}, {3.6683282798610277`*^9, 
   3.668328289443941*^9}, {3.668328326824873*^9, 3.668328355379395*^9}, {
   3.668328389978828*^9, 3.668328401384403*^9}, {3.668328965588427*^9, 
   3.668328992373364*^9}, {3.6683291639970922`*^9, 3.668329298282498*^9}, {
   3.668329375524115*^9, 3.668329522854287*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<logvpn-theta.pdf\>\"", ",", "plot$logvpn$theta", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584994733266153`*^9, 3.658499524686902*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<logvpn-width.pdf\>\"", ",", "plot$logvpn$width", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584994733266153`*^9, 3.658499524686902*^9}, {
  3.658500252514083*^9, 3.658500267904419*^9}}],

Cell["Vpn ~ system size (haven\[CloseCurlyQuote]t use/updated)", "Text",
 CellChangeTimes->{{3.658497937465447*^9, 3.658497962425499*^9}, {
  3.658499403963952*^9, 3.6584994250682373`*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"th0", "=", "0.2"}], ",", " ", 
   RowBox[{"see", " ", "the", " ", "Table", " ", "option", " ", "down", " ", 
    RowBox[{"there", ".", " ", "The"}], " ", "old", " ", "is", " ", "0.1"}], 
   ",", " ", 
   RowBox[{
   "which", " ", "is", " ", "too", " ", "small", " ", "and", " ", "Vpn", " ", 
    "of", " ", "that", " ", "is", " ", "below", " ", "machine", " ", 
    "precision"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.6665206071979523`*^9, 3.6665206878074017`*^9}, {
  3.674830521362137*^9, 3.6748305412847967`*^9}, {3.674831297116825*^9, 
  3.674831301620819*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pethnumxrelax3", "=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Mdef", "=", "1."}], ",", 
       RowBox[{"v0", "=", "0"}], ",", 
       RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"kk", "[", "i", "]"}], "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", 
            RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", "i", "]"}], "=", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "1"}], "||", 
            RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", "True",
            ",", "1."}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"akpos", "=", 
       RowBox[{"50", "/", "100"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vdirection", "=", 
       RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
      RowBox[{"tfinal", "=", "0.0001"}], ";", 
      RowBox[{"tinterval", "=", 
       RowBox[{"tfinal", "/", "10"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Monitor", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tableContent4", ";", "\[IndentingNewLine]", 
           RowBox[{"initialold", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Pi]", "/", "2"}], "-", 
               RowBox[{
                RowBox[{
                "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
                 "[", "tfinal", "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"num", ",", "thnumx", ",", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{"espringold2", "[", "i", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"num", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], 
            "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"num", ",", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"i", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "10", ",", "28", ",", "2"}], "}"}]}], 
               "]"}], ",", 
              RowBox[{"{", "60", "}"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"th0", ",", 
            RowBox[{"{", "0.4", "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thnumx", ",", 
            RowBox[{"0", "*", "th0"}], ",", 
            RowBox[{"0.6", "*", "th0"}], ",", 
            RowBox[{"0.02", "*", "th0"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"num", ",", "thnumx"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, {
   3.651909340054309*^9, 3.651909344102255*^9}, {3.651909458394384*^9, 
   3.651909537867701*^9}, 3.651909780528471*^9, {3.651909868915522*^9, 
   3.651909883217781*^9}, {3.651909919781321*^9, 3.6519099863238087`*^9}, {
   3.6519100361511393`*^9, 3.651910039878894*^9}, {3.65191054376274*^9, 
   3.651910544863985*^9}, {3.651911705502371*^9, 3.651911712461906*^9}, {
   3.651911753938613*^9, 3.6519117657280693`*^9}, {3.6519119533489637`*^9, 
   3.651911957521689*^9}, {3.651912160601151*^9, 3.651912224809009*^9}, {
   3.651912382032323*^9, 3.6519124062700243`*^9}, {3.651912462322033*^9, 
   3.651912462879595*^9}, {3.651912500710968*^9, 3.651912509679676*^9}, 
   3.651913391915606*^9, {3.6519212573605347`*^9, 3.6519212575036287`*^9}, {
   3.6519214784411697`*^9, 3.651921499622264*^9}, {3.651921545692039*^9, 
   3.651921545774934*^9}, {3.6519217437546787`*^9, 3.65192175538684*^9}, {
   3.651921882752275*^9, 3.6519219150555267`*^9}, {3.651921968865625*^9, 
   3.651921972177422*^9}, {3.6519220564667053`*^9, 3.651922118309444*^9}, {
   3.651922150902673*^9, 3.651922295002178*^9}, {3.6519223370352707`*^9, 
   3.651922344120167*^9}, {3.651922608098422*^9, 3.651922663777793*^9}, 
   3.651922732818265*^9, 3.651922974219376*^9, {3.651923275058311*^9, 
   3.651923275970107*^9}, 3.651923342896641*^9, {3.6519233763571253`*^9, 
   3.651923400356202*^9}, {3.651923832350108*^9, 3.651923837021299*^9}, {
   3.651924081714369*^9, 3.651924143043405*^9}, 3.651924254551467*^9, {
   3.651924314008609*^9, 3.651924314744246*^9}, {3.6533711986205378`*^9, 
   3.653371288785438*^9}, {3.65337133693016*^9, 3.6533714087112417`*^9}, {
   3.653371452228241*^9, 3.653371519001683*^9}, {3.653371558555155*^9, 
   3.653371567798224*^9}, {3.653371619035027*^9, 3.653371637831663*^9}, {
   3.653371715769462*^9, 3.65337177532917*^9}, {3.6533718145253773`*^9, 
   3.65337185540697*^9}, {3.653373554664111*^9, 3.653373693174807*^9}, {
   3.653373724939109*^9, 3.6533738254994164`*^9}, {3.65337393436535*^9, 
   3.653373970654318*^9}, {3.6533740156332073`*^9, 3.653374233733612*^9}, {
   3.653374290617445*^9, 3.653374386973692*^9}, {3.6533855783375874`*^9, 
   3.6533855949428387`*^9}, {3.653385631346603*^9, 3.653385641151307*^9}, 
   3.653385758635344*^9, {3.653388346434064*^9, 3.65338834759011*^9}, {
   3.654601872126493*^9, 3.654601873568973*^9}, {3.65460191869086*^9, 
   3.654601923873577*^9}, {3.6546022342345457`*^9, 3.6546022347611313`*^9}, {
   3.655462768826234*^9, 3.6554627808604307`*^9}, {3.655462819819326*^9, 
   3.6554628443006763`*^9}, {3.655463167204597*^9, 3.655463214296052*^9}, {
   3.6554634043156357`*^9, 3.655463405066556*^9}, {3.655463592974753*^9, 
   3.655463646162717*^9}, 3.655464172109562*^9, {3.655465619009676*^9, 
   3.6554656375036287`*^9}, {3.655465760473085*^9, 3.655465770258636*^9}, {
   3.655467997200679*^9, 3.6554679973551807`*^9}, 3.6554683582923307`*^9, {
   3.6554689192953*^9, 3.655468925263113*^9}, {3.655469397181199*^9, 
   3.6554694058815002`*^9}, {3.655469442268322*^9, 3.655469448283115*^9}, {
   3.6554701067462797`*^9, 3.655470109820752*^9}, {3.6554708928134317`*^9, 
   3.655470892971377*^9}, {3.655471041922905*^9, 3.655471072736479*^9}, {
   3.6554714670984364`*^9, 3.655471494842107*^9}, 3.655472791003648*^9, 
   3.655473001377809*^9, 3.655475688784061*^9, {3.655475932930029*^9, 
   3.655475992099015*^9}, {3.655476089349688*^9, 3.655476092901472*^9}, {
   3.655476143752359*^9, 3.6554761439259*^9}, 3.6584980029886436`*^9, {
   3.674825242486685*^9, 3.674825295478442*^9}, {3.6748254635949697`*^9, 
   3.67482546418605*^9}, {3.674826151782666*^9, 3.674826161339759*^9}, {
   3.674826690793665*^9, 3.674826700543358*^9}, {3.674826885567503*^9, 
   3.674826885634967*^9}, {3.674827026274763*^9, 3.6748270795487747`*^9}, {
   3.6748271441014757`*^9, 3.67482716162004*^9}, {3.67482727444011*^9, 
   3.674827280421713*^9}, {3.674827642768379*^9, 3.674827650239806*^9}, {
   3.674828077727315*^9, 3.674828079273869*^9}, {3.674828271840683*^9, 
   3.674828287199189*^9}, 3.674829611521901*^9, 3.674830379537599*^9, {
   3.6748305776716623`*^9, 3.674830580195621*^9}, 3.6748306720744877`*^9, {
   3.674831269114749*^9, 3.674831309295789*^9}, {3.674831411902301*^9, 
   3.674831417420192*^9}, {3.674831549121005*^9, 3.674831555792289*^9}, {
   3.67483162294716*^9, 3.6748316230083513`*^9}, {3.674831658259694*^9, 
   3.674831663186048*^9}, {3.674831784101364*^9, 3.6748317855091352`*^9}, {
   3.674832021067622*^9, 3.6748320243801527`*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pethnumxrelax3", "\[LeftDoubleBracket]", 
        RowBox[{"i", ",", "1", ",", "1", ",", "1"}], 
        "\[RightDoubleBracket]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Log", "@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Max", "[", "#", "]"}], "-", 
            RowBox[{"Min", "[", "#", "]"}]}], ")"}]}], "&"}], "@", 
        RowBox[{"pethnumxrelax3", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "1", ",", "All", ",", "3"}], 
         "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "pethnumxrelax3", "]"}]}], "}"}]}], "]"}], ",", 
   
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Num\>\"", ",", "\"\<\!\(\*SubscriptBox[\(V\), \(PN\)]\)\>\""}], 
     "}"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388330415928*^9, 3.6533883377675123`*^9}, {
   3.655463535469248*^9, 3.65546356185183*^9}, {3.655471233079834*^9, 
   3.655471447208143*^9}, {3.6748272661346083`*^9, 3.674827266468347*^9}, {
   3.674829760481729*^9, 3.6748297638755827`*^9}, {3.6748320656586943`*^9, 
   3.67483206894751*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
        0.012833333333333334`], AbsoluteThickness[1.6], 
        LineBox[{{10., -0.6949554552809749}, {12., -3.4744255638544086`}, {
         14., -4.955402073765222}, {16., -5.1062464536111225`}, {
         18., -5.114469363229611}, {20., -5.114884086458608}, {
         22., -5.11487869635146}, {24., -5.114878405439409}, {
         26., -5.114878389938487}, {28., -5.114878388925911}, {
         60., -5.114878388878594}}]}}, {
       {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
        AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], {0., 0.}], {{{10., -0.6949554552809749}}, {{
         12., -3.4744255638544086`}}, {{14., -4.955402073765222}}, {{
         16., -5.1062464536111225`}}, {{18., -5.114469363229611}}, {{
         20., -5.114884086458608}}, {{22., -5.11487869635146}}, {{
         24., -5.114878405439409}}, {{26., -5.114878389938487}}, {{
         28., -5.114878388925911}}, {{60., -5.114878388878594}}}]}, {}}}, {}},
    
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{9.218750000000002, 0},
    DisplayFunction->Identity,
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(V\\), \\(PN\\)]\\)\"", TraditionalForm], 
       None}, {
       FormBox["\"Num\"", TraditionalForm], None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->Medium,
    Method->{},
    PlotRange->{{10., 60.}, {-5.114884086458608, 0}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.02]}},
    Ticks->{Automatic, Automatic}], "th0"}], "=", "0.4"}]], "Input",
 CellChangeTimes->{{3.674832085211081*^9, 3.6748320878750973`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
        0.012833333333333334`], AbsoluteThickness[1.6], 
        LineBox[{{10., -0.04153721007757633}, {12., -0.04115784923392185}, {
         14., -0.04115601395913648}, {16., -0.04115600510376404}, {
         18., -0.04115600506443421}, {20., -0.04115600506111724}, {
         60., -0.04115600506135417}}]}}, {
       {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
        AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], {0., 0.}], {{{10., -0.04153721007757633}}, {{
         12., -0.04115784923392185}}, {{14., -0.04115601395913648}}, {{
         16., -0.04115600510376404}}, {{18., -0.04115600506443421}}, {{
         20., -0.04115600506111724}}, {{
         60., -0.04115600506135417}}}]}, {}}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{9.218750000000002, -0.04113694481029429},
    DisplayFunction->Identity,
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(V\\), \\(PN\\)]\\)\"", TraditionalForm], 
       None}, {
       FormBox["\"Num\"", TraditionalForm], None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->{345.33333333333235`, Automatic},
    Method->{},
    PlotRange->{{10., 60.}, {-0.04153721007757633, -0.04115600506111724}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], " ", "th0"}], "=", "0.575"}]], "Input",
 CellChangeTimes->{{3.674831819908351*^9, 3.674831823336203*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
        0.012833333333333334`], AbsoluteThickness[1.6], 
        LineBox[{{10., 2.013096776981807}, {15., -0.024367713789409922`}, {
         20., -3.774315330952421}, {25., -6.3703095744165585`}, {
         30., -10.32464642834155}, {35., -12.946524257793197`}, {
         40., -16.912722635348587`}, {45., -19.433178324438984`}, {
         50., -21.034288243772195`}, {60., -21.093288620502314`}}]}}, {
       {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
        AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], {0., 0.}], {{{10., 2.013096776981807}}, {{
         15., -0.024367713789409922`}}, {{20., -3.774315330952421}}, {{
         25., -6.3703095744165585`}}, {{30., -10.32464642834155}}, {{
         35., -12.946524257793197`}}, {{40., -16.912722635348587`}}, {{
         45., -19.433178324438984`}}, {{50., -21.034288243772195`}}, {{
         60., -21.093288620502314`}}}]}, {}}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{9.218750000000002, 0},
    DisplayFunction->Identity,
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(V\\), \\(PN\\)]\\)\"", TraditionalForm], 
       None}, {
       FormBox["\"Num\"", TraditionalForm], None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->{367.99999999999915`, Automatic},
    Method->{},
    PlotRange->{{10., 60.}, {-21.093288620502314`, 2.013096776981807}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], " ", "th0"}], "=", "0.2"}]], "Text", "Input",
 CellChangeTimes->{
  3.674831062337775*^9, {3.674831687225645*^9, 3.674831698227666*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      LineBox[{{10., 899.5129976184762}, {12., 898.7179681752568}, {14., 
       898.7726262252254}, {16., 898.768865475784}, {18., 898.769124219998}, {
       20., 898.7691064180144}, {22., 898.7691076428164}, {24., 
       898.7691075585499}, {26., 898.7691075643379}, {28., 
       898.7691075639596}, {30., 898.7691075639668}, {36., 
       898.7691075639814}, {40., 898.7691075639959}, {50., 
       898.7691075639668}, {60., 898.7691075639741}}]}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
      AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->8.96], {0., 0.}], {{{10., 899.5129976184762}}, {{12., 
       898.7179681752568}}, {{14., 898.7726262252254}}, {{16., 
       898.768865475784}}, {{18., 898.769124219998}}, {{20., 
       898.7691064180144}}, {{22., 898.7691076428164}}, {{24., 
       898.7691075585499}}, {{26., 898.7691075643379}}, {{28., 
       898.7691075639596}}, {{30., 898.7691075639668}}, {{36., 
       898.7691075639814}}, {{40., 898.7691075639959}}, {{50., 
       898.7691075639668}}, {{60., 898.7691075639741}}}]}, {}}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{9.218750000000002, 898.6782167030959},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox[
     "\"\\!\\(\\*SubscriptBox[\\(V\\), \\(PN\\)]\\)\"", TraditionalForm], 
     None}, {
     FormBox["\"Num\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{10., 60.}, {898.7179681752568, 899.5129976184762}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Input",
 CellChangeTimes->{3.6664408434348392`*^9, 3.6748311129184637`*^9}],

Cell[BoxData[
 RowBox[{"plot$logvpn$size", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"data2", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"pethnumxrelax3", "\[LeftDoubleBracket]", 
           RowBox[{"i", ",", "1", ",", "1", ",", "1"}], 
           "\[RightDoubleBracket]"}], ",", 
          RowBox[{"Log", "[", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Max", "[", "#", "]"}], "-", 
                    RowBox[{"Min", "[", "#", "]"}]}], ")"}], "&"}], "@", 
                 RowBox[{"pethnumxrelax3", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "1", ",", "All", ",", "3"}], 
                  "\[RightDoubleBracket]"}]}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Max", "[", "#", "]"}], "-", 
                  RowBox[{"Min", "[", "#", "]"}]}], ")"}]}], "&"}], "@", 
              RowBox[{"pethnumxrelax3", "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"Length", "[", "pethnumxrelax3", "]"}], ",", "1", ",",
                 "All", ",", "3"}], "\[RightDoubleBracket]"}]}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"kk", "[", "1", "]"}], " ", 
               SuperscriptBox["a", "2"]}], ")"}], ")"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"Length", "[", "pethnumxrelax3", "]"}], "-", "1"}]}], 
         "}"}]}], "]"}]}], ";", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"data2", ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "40"}], ",", 
            RowBox[{"-", "5"}]}], "}"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<System size L (number of rotors)\>\"", ",", 
          "\"\<ln [\!\(\*SubscriptBox[\(\[CapitalDelta]V\), \
\(PNB\)]\)/(\!\(\*SuperscriptBox[\(ka\), \(2\)]\))]\>\""}], "}"}]}], ",", 
       RowBox[{"Axes", "\[Rule]", "None"}], ",", " ", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "15.5"}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "Large"}], "]"}]}], ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", "Thick"}], ",", 
       RowBox[{"FrameTicksStyle", "->", 
        RowBox[{"Directive", "[", 
         RowBox[{"FontSize", "\[Rule]", "20"}], "]"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"fitRangeMin", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"fitRangeMax", "=", 
      RowBox[{
       RowBox[{"Length", "[", "pethnumxrelax3", "]"}], "-", "1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"lm2", "=", 
      RowBox[{"LinearModelFit", "[", 
       RowBox[{
        RowBox[{"data2", "\[LeftDoubleBracket]", 
         RowBox[{"fitRangeMin", ";;", "fitRangeMax"}], 
         "\[RightDoubleBracket]"}], ",", "x", ",", "x"}], "]"}]}], ";", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"lm2", "[", "x", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"data2", "\[LeftDoubleBracket]", 
          RowBox[{"fitRangeMin", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"data2", "\[LeftDoubleBracket]", 
          RowBox[{"fitRangeMax", ",", "1"}], "\[RightDoubleBracket]"}]}], 
        "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"AbsoluteDashing", "[", 
           RowBox[{"{", 
            RowBox[{"2", ",", "6"}], "}"}], "]"}]}], "}"}]}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.653374842993126*^9, 3.6533748585762377`*^9}, {
   3.6533754351182203`*^9, 3.6533754555495234`*^9}, 3.653375489759788*^9, {
   3.653377601427297*^9, 3.653377670227386*^9}, {3.6533778300086803`*^9, 
   3.65337784154327*^9}, {3.653378009803691*^9, 3.65337801116299*^9}, {
   3.653378043600189*^9, 3.6533780463317747`*^9}, {3.653378107488449*^9, 
   3.653378172384747*^9}, {3.653378325269238*^9, 3.6533783618113337`*^9}, {
   3.6533784018457336`*^9, 3.653378452361334*^9}, {3.653380106017126*^9, 
   3.653380120525567*^9}, {3.65338016091171*^9, 3.6533802157016697`*^9}, {
   3.653380379652444*^9, 3.6533803799402437`*^9}, {3.6533808533309813`*^9, 
   3.65338085355237*^9}, {3.653388330415928*^9, 3.6533883377675123`*^9}, {
   3.655463535469248*^9, 3.65546356185183*^9}, {3.655471233079834*^9, 
   3.65547143460157*^9}, {3.655472069357194*^9, 3.6554720731431713`*^9}, {
   3.666440699625183*^9, 3.6664407063604507`*^9}, {3.6664407916596603`*^9, 
   3.6664408215320177`*^9}, {3.666517199747939*^9, 3.6665172720613003`*^9}, {
   3.666517386144238*^9, 3.6665174074084187`*^9}, {3.666518027121221*^9, 
   3.666518032367237*^9}, {3.666518075251132*^9, 3.666518109442957*^9}, {
   3.666518300343627*^9, 3.666518349079723*^9}, {3.6665187735497293`*^9, 
   3.6665188019059973`*^9}, {3.666518835651898*^9, 3.66651893279392*^9}, {
   3.6665189698982553`*^9, 3.666518989610417*^9}, {3.6665190226164827`*^9, 
   3.666519128108101*^9}, {3.666519178350498*^9, 3.666519191278315*^9}, {
   3.666519801020728*^9, 3.666519807182267*^9}, {3.668942341018229*^9, 
   3.668942344936699*^9}, {3.674825081872847*^9, 3.674825124055771*^9}, {
   3.674825368850494*^9, 3.674825389629945*^9}, {3.674826749965252*^9, 
   3.674826750445257*^9}, 3.674827132069416*^9, {3.674827412381312*^9, 
   3.674827460902156*^9}, {3.674827671697887*^9, 3.674827674224001*^9}, {
   3.6748280581088247`*^9, 3.674828058221923*^9}, 3.674828094766406*^9, {
   3.6748282222257757`*^9, 3.674828252880979*^9}, {3.674828867808571*^9, 
   3.67482887084692*^9}, {3.674829064054988*^9, 3.674829064309002*^9}, {
   3.6748306615653687`*^9, 3.674830686486662*^9}, 3.6748315993055143`*^9, {
   3.674831878236521*^9, 3.674831964450697*^9}, {3.674832101489142*^9, 
   3.674832122789834*^9}, {3.6749859915072107`*^9, 3.67498602912568*^9}, {
   3.674986978140091*^9, 3.674986984106409*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{{}, {
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{10., -9.917403995921665}}, {{
         12., -12.900303763079823`}}, {{14., -16.080280994540665`}}, {{
         16., -19.073186238815698`}}, {{18., -22.126746933497188`}}, {{
         20., -26.400690641891327`}}, {{22., -29.320097909723145`}}, {{
         24., -32.24144524969622}}, {{26., -34.99031744531868}}, {{
         28., -38.099378404179674`}}}]}, {}}, {}}, {{}, {}, 
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       AbsoluteDashing[{2, 6}], LineBox[CompressedData["
1:eJwVzHtUjHkcgPERarepUGS6bJnmTU0zTXPtMr8u35mXsVKhHGnkUopmKxmR
rLRWdLBi3bKniCUzq1WrtKHj5EulIRLiRG0uI2aqoXDQUdrdP57z+e9hJ2fF
ploxGIzo//rfnLw4OwaDgsXMrvzqcg4KOzSnH1hRUNh97qzgLAf7edvk+okU
XKrM7/izkoMru86lxTApcFng5aer42Ck3Lr5mDMF3Yc1D0sMHPT4fGlriD8F
qzw+83YMcLAl2+PtejUFWtG0x4ulFLLSzfd6aykoip8vGWmkUMOP77fa7A2K
bWUK7RdvrDo4bjxbOBP+uVm+W+nhgz9atezRG2fC/u/Wpq8gvvhxVsrqVJ0P
NEY76nXruJjKDwcq0Rcel2W6Rx7ww4JXbzNd2VzQ3j7dP/0WD7kVV5ibX3DB
c8LxRaJRPl53vKHvLPaDvxOjP+ncBMiM0R/NUvPg5oHO96rYAJwjaN5pM4UP
L7Ltj7DlQrRlfTXaNPGhjzN562yDELd2OBRHFPqDWMk4mJ8sQqMsUZVLBPBm
sLUx9Z0IhzU/R5rGBGCy3+mVvE+MxfprDYgBMPiXZ8wOHwk6zT7BipYLIe3F
keJFdRKsOXFzy8NSIcwoGGbKF0qxNcpxec9HIUTVBpfdeS7FUKOqb3uCCOri
Upfl5MtQ+3VX1dJ6EQhys82zWIHomWEeqp0qBpb/soPX9IHo3Sh7ejZHDLBA
mhZHB+GZjJPzPO+LoWf8a/WhjiA0lbAGDTwJFIZucR1ODsaCmrxwhyIJZBhH
rDeMBuNv7mPMjtcSMLiqJx8vCsGJ6zILZJFSSMFyVRdXjrLvzeLWCinY9rfP
jWiU49P1BUnPJ8jAS9epWRhL8Hnht/JDq2WQd/dOXa6FYKKl8kDzNRmodpfN
iMkPxdLOFWy+WyB4GBbEz7ULQ3HlqFqQFwiBGwfrE3RhqOy47FT9KBCwJp2w
AsOx4mVSzt3gINi1vMPUfy8c987xXbL2cBA0lbAuZK6KQFHAiFbxJgjsEsMj
p72LQAHjiuz8/GC41exro1EBnuGU5J6oCIYW75ObyvYBbhCmpPrZh0Bv6L78
nm5A6+tkjzkzBHY5W9KruQp01IkEXEMIpFy6vGapVoE52U55E/zkkDRldHjS
VQXGHXKau3KnHIrFVSWlNkr8EMSOGeyRQ6xzO7s+RomWZtdRNyAgqE6LMJYq
caVOzDOUEKCnZqUbjUpsk2baLjtG4GKrpY/qVSJp1JuHjhPgFmT8sPqVEp2f
uf/h9juBSe80GrNJibddbLyz9AS676aseWtRYkhRl4dzLYGNv6hXffmkRMcN
OxxT7hDQWamWOtnRuM3q6tDnNgIu9U1PFtnTaPl1uL2oncBeLa0udqDRULl2
/8UHBNY/gwSXKTT+9HqJHfMJgYgGEu/pTOOA2t+65hWBzs2iON4MGtXmNb0q
E4Eo0fn7GWwaWzadauoyE2gwCWKrvGg8dXh6wUQLgfJ4/kKRN41L2sYxEt4T
0Mp85gf50XgjMfSp5QOBlwNn2nJ5NEr6cxq2fyQQX07F1PNpdPhmIO/cMIEw
J6/osAAa84pnJiq+EDh/6+TtfCGNfVQSeTRCgNruGYWi//4XSl3TvxI4GlLW
Ok5CY7Pi0fDYGAHbIfd5tJTGfwF78C4G
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{False, False},
    AxesLabel->{None, None},
    AxesOrigin->{9.718750000000002, -5.175},
    DisplayFunction->Identity,
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"ln [\\!\\(\\*SubscriptBox[\\(\[CapitalDelta]V\\), \
\\(PNB\\)]\\)/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))]\"", 
        TraditionalForm], None}, {
       FormBox["\"System size L (number of rotors)\"", TraditionalForm], 
       None}},
    FrameStyle->Thickness[Large],
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    FrameTicksStyle->Directive[FontSize -> 20],
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->Large,
    LabelStyle->Directive[FontSize -> Large],
    Method->{},
    PlotRange->{{10., 28.}, {-40, -5}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], "th"}], "=", "0.4"}]], "Input",
 CellChangeTimes->{{3.6749870322824306`*^9, 3.6749870413429527`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{{}, {
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{10., -9.917403995921665}}, {{
         12., -12.900303763079823`}}, {{14., -16.080280994540665`}}, {{
         16., -19.073186238815698`}}, {{18., -22.126746933497188`}}, {{
         20., -26.400690641891327`}}, {{22., -29.320097909723145`}}, {{
         24., -32.24144524969622}}, {{26., -34.99031744531868}}, {{
         28., -38.099378404179674`}}}]}, {}}, {}}, {{}, {}, 
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       AbsoluteDashing[{2, 6}], LineBox[CompressedData["
1:eJwVzHtUjHkcgPERarepUGS6bJnmTU0zTXPtMr8u35mXsVKhHGnkUopmKxmR
rLRWdLBi3bKniCUzq1WrtKHj5EulIRLiRG0uI2aqoXDQUdrdP57z+e9hJ2fF
ploxGIzo//rfnLw4OwaDgsXMrvzqcg4KOzSnH1hRUNh97qzgLAf7edvk+okU
XKrM7/izkoMru86lxTApcFng5aer42Ck3Lr5mDMF3Yc1D0sMHPT4fGlriD8F
qzw+83YMcLAl2+PtejUFWtG0x4ulFLLSzfd6aykoip8vGWmkUMOP77fa7A2K
bWUK7RdvrDo4bjxbOBP+uVm+W+nhgz9atezRG2fC/u/Wpq8gvvhxVsrqVJ0P
NEY76nXruJjKDwcq0Rcel2W6Rx7ww4JXbzNd2VzQ3j7dP/0WD7kVV5ibX3DB
c8LxRaJRPl53vKHvLPaDvxOjP+ncBMiM0R/NUvPg5oHO96rYAJwjaN5pM4UP
L7Ltj7DlQrRlfTXaNPGhjzN562yDELd2OBRHFPqDWMk4mJ8sQqMsUZVLBPBm
sLUx9Z0IhzU/R5rGBGCy3+mVvE+MxfprDYgBMPiXZ8wOHwk6zT7BipYLIe3F
keJFdRKsOXFzy8NSIcwoGGbKF0qxNcpxec9HIUTVBpfdeS7FUKOqb3uCCOri
Upfl5MtQ+3VX1dJ6EQhys82zWIHomWEeqp0qBpb/soPX9IHo3Sh7ejZHDLBA
mhZHB+GZjJPzPO+LoWf8a/WhjiA0lbAGDTwJFIZucR1ODsaCmrxwhyIJZBhH
rDeMBuNv7mPMjtcSMLiqJx8vCsGJ6zILZJFSSMFyVRdXjrLvzeLWCinY9rfP
jWiU49P1BUnPJ8jAS9epWRhL8Hnht/JDq2WQd/dOXa6FYKKl8kDzNRmodpfN
iMkPxdLOFWy+WyB4GBbEz7ULQ3HlqFqQFwiBGwfrE3RhqOy47FT9KBCwJp2w
AsOx4mVSzt3gINi1vMPUfy8c987xXbL2cBA0lbAuZK6KQFHAiFbxJgjsEsMj
p72LQAHjiuz8/GC41exro1EBnuGU5J6oCIYW75ObyvYBbhCmpPrZh0Bv6L78
nm5A6+tkjzkzBHY5W9KruQp01IkEXEMIpFy6vGapVoE52U55E/zkkDRldHjS
VQXGHXKau3KnHIrFVSWlNkr8EMSOGeyRQ6xzO7s+RomWZtdRNyAgqE6LMJYq
caVOzDOUEKCnZqUbjUpsk2baLjtG4GKrpY/qVSJp1JuHjhPgFmT8sPqVEp2f
uf/h9juBSe80GrNJibddbLyz9AS676aseWtRYkhRl4dzLYGNv6hXffmkRMcN
OxxT7hDQWamWOtnRuM3q6tDnNgIu9U1PFtnTaPl1uL2oncBeLa0udqDRULl2
/8UHBNY/gwSXKTT+9HqJHfMJgYgGEu/pTOOA2t+65hWBzs2iON4MGtXmNb0q
E4Eo0fn7GWwaWzadauoyE2gwCWKrvGg8dXh6wUQLgfJ4/kKRN41L2sYxEt4T
0Mp85gf50XgjMfSp5QOBlwNn2nJ5NEr6cxq2fyQQX07F1PNpdPhmIO/cMIEw
J6/osAAa84pnJiq+EDh/6+TtfCGNfVQSeTRCgNruGYWi//4XSl3TvxI4GlLW
Ok5CY7Pi0fDYGAHbIfd5tJTGfwF78C4G
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{False, False},
    AxesLabel->{None, None},
    AxesOrigin->{9.718750000000002, -5.175},
    DisplayFunction->Identity,
    Epilog->{
      InsetBox[
       FormBox[
        StyleBox["\"y=6.06-1.59x\"", FontSize -> 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm], {22, -20}]},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"ln {[\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L)-\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L=60)]/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))}\"", 
        TraditionalForm], None}, {
       FormBox["\"System size L (number of rotors)\"", TraditionalForm], 
       None}},
    FrameStyle->Thickness[Large],
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    FrameTicksStyle->Directive[FontSize -> 20],
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->Large,
    LabelStyle->Directive[FontSize -> Large],
    Method->{},
    PlotRange->{{10., 28.}, {-40, -5}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], " ", "th"}], "=", "0.4"}]], "Input",
 CellChangeTimes->{{3.674832128123719*^9, 3.674832131377101*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{{}, {
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{10., -17.123860200731745`}}, {{
         12., -22.454977152989194`}}, {{14., -27.788960151373775`}}, {{
         16., -33.13513614965313}}, {{18., -35.75757259803235}}, {{
         20., -38.32252195549388}}}]}, {}}, {}}, {{}, {}, 
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       AbsoluteDashing[{2, 6}], LineBox[CompressedData["
1:eJwVx3s0lHkYwHEppiyOFlsuRXkNhmHm/U0NZphn5o0surBt6HJYGVbC2WVs
SkQHdcQWxum2rbSirGR3hVKejVxWOZQKW6HQhTaXlTHEtn98z/d81oTG+ss1
NTQ0Nn3q/8t0e7Q1NCioVrvar/ehselqnFbuIgrKRTGK1740evvpL6EWU1CU
dKH+zGYa/QuYRV7aFGTPs7Yt+NEYanl19kddCvZoPkpqCaTxiODImIUJBQY6
se07wmls3MXtldAURJpc/C4llUbP8tTylDAKTJ0/q2mpprGlzzc8rpOCsBFn
+hCXIHuuucVRaA3exiHdYWcJSl1NNo2csYZBnSIlxRJg77Lsl2YsNsgTpKCd
JMCtDdesjPaxIS2w9wuzNwLcoD+tONzDhsxrHb1+wetw6oDh23cbbAC6BqpC
Hq7DtM4+ltVlG8iPGa0rkqzH7Np24T1jW+hI3lapXbUeFVnRy90O2kKp1vXO
n9YK0TTlhW7Fc1sQBNLL9HKE6LbkgKnS2w5KLXUdz2s6ozjuz05ZhR1cD+5L
Do11xto4+7Nh5hz41cjglteQM04qozIyMzkQoNz5OSvIBXWKdpp9P8KB88cL
81SNLvizJOZOR4A93JuRaeq6uqJBM89wus4elM+en/MvccWFPuOEkxwH8BB2
UzdXibDMtFPtUOAAV3aNNsyeFKFAIrY7oXaAMtVMTuy8CEVTrZEREVzI05Fv
1IoX42ola5v2fS6syGu1bx8Q4+3tZiGXeI6w5ZWXTewmN3x62S/5xjlHiK60
NqDvuOGTYaFnwSInsJuYpWyd3HFrFVgOxzhBW6mTDRS7Y0axhbmw1wms7JOB
ZyLBe5In/TYWPDCmmtK/Spdg/lSFOOZrHrzPjao5pZagd2FI9MqjPOCL07OW
CgD7ds45NtTyoNkotOlaJCAJuTxT8p4HW0rfTb+5CKgIcjw9toYP7GlFvbgX
MOFsozQukA9jGuWHLI2lKH9A1wdl8YHV1N+5yleKxPT4fbjFB/XYBT4rTYp4
5cPgN5N86H+8/GhqnRRFPJfOYWsaDPcnxxtPSlExf7ypeBcNrl2nA1wdZZj9
rM1XnkuDqEDm6fOtDPMrX5QcbaQhy/D1X4rzMtzRrqM7rKah3Ufsye+RoX6/
jkcJl0CwJDtA24DBQs0P+pHBBFpPRcU3ezA4Hj0xEKYkYFOuyjQ5zCC/velY
YzOBrqQ0fvp1Bvs1cn8obiEQYu7N31/NYA7ZLc9oJTByczk/qobB0VOT4NVG
YPFsIc/vBoOX9liq2toJ8BPrnVbdZtB8JjH84SMCJxRz3Kq7DC6luMyLlwR8
YxI4Q10MVm9X8RoGCXTruXO6HzEYfqxh9S9DBMLKtThtjxls+CdILX9F4OBo
vl1lN4PJtRmVb94SKNv7u+2hpwz+u7nfYnycwLKIMbbxIIMXU8v0HkwQUGrX
sJcOMej/R8Lsb5ME1lxKYc9+coWJ3pP4KQLOQ/rsgVcM7h10yVGpCETs4VqX
jzC4coVWUs8MgQnNKapwlMHmLzsib6gJJBfVUXnvGKQqwj2S5ggUDPhQie8Z
fDjAJ7s/ElibakjtG2Mwzeijpfs8gauWf1sFjzPI29iib7FAwAWLrPwnGOxL
zJtb+OS7wXutPCYZ/A/jcjcp
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{False, False},
    AxesLabel->{None, None},
    AxesOrigin->{9.843750000000002, -15.125},
    DisplayFunction->Identity,
    Epilog->{
      InsetBox[
       FormBox[
        StyleBox["\"y=3.31-2.16x\"", FontSize -> 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm], {15, -20}]},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"ln {[\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L)-\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L=60)]/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))}\"", 
        TraditionalForm], None}, {
       FormBox["\"System size L (number of rotors)\"", TraditionalForm], 
       None}},
    FrameStyle->Thickness[Large],
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    FrameTicksStyle->Directive[FontSize -> 20],
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->Large,
    LabelStyle->Directive[FontSize -> Large],
    Method->{},
    PlotRange->{{10., 20.}, {-40, -15}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], " ", "th"}], "=", "0.575"}]], "Input",
 CellChangeTimes->{{3.674832035705552*^9, 3.6748320421085*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   GraphicsBox[{{{}, {
       {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
        GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{10., -7.197243595086638}}, {{
         15., -9.234708086473349}}, {{20., -12.984655733021603`}}, {{
         25., -15.580650349937333`}}, {{30., -19.535007849861593`}}, {{
         35., -22.157154342847754`}}, {{40., -26.13847095370681}}, {{
         45., -28.85438542930407}}, {{
         50., -33.10419521464234}}}]}, {}}, {}}, {{}, {}, 
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       AbsoluteDashing[{2, 6}], LineBox[CompressedData["
1:eJwVk2s01AkYh6eSMrU4cpkK6YR2MGbGXMwN74yZ8S8lxmm3UrkcoZIuI9VI
S0XJau3ONint7CGUUpyOFSm9NmlGotTEZjNsqcjIoSldlrUffuf58Hx7zvkt
jdup2DKTRCKtnt7/jPtFRiaR2JB8ouRvA5uK3+bQ5kbNZINjx+7NX/ypOHLA
wbLWgg24QNznJqSiKnZgRrIVGxx+M77YLqaimpH9qctu2lc5v50RRsXm9uY3
VR5sWGDQfKIlUtFznvRedCgbGpbkOeacoeLgEcnR2xo2WP2hDOdOUvHKGuVC
moADoY8O2x/r9kLRZ29aSycHHvbTmTGl3pjQVTYek8QFa2H1eX6yDz44GWmo
IPvDaHZKwiwZDafcczmuJf7gcLc1a62NL6acGqsGOQ96zfGm00O+uJ/nYox/
zYOYnZ1XnzXRcfWNjryaDD6oR1JeKmQMjHasjbzmJoAQrfoM4xoDRRHuZ3vq
BOBKzEnvdGJiTWOk2jJMCBGa+GOp6Uzcann9gvGdENY+72s4+ZqJgz4lgpc5
IjjoWum8Y5UfltOa3mi8AmDvOk3ZnXo/nIwpXhF6PwD03G3rF3mwcKnSiuod
Gwhgk8/n5LIwK7psWf2sIMjtaxfrzCys9NKf21MUBOOXo9OWRLGRnFRAMS0B
YOyyeTyiY+P8J843i3cB6Lsvbmhkc1BJN7kONwAcEf5srTjDwYl93/+U/40Y
bE4XDm2y5OKLqtm3m9eLoXF4ZIyWzEXnLHvdwVIx6F/5ek52cFEZdKs3zyyG
sr/ys+Qif6SbKmoYYgmcbxFaRRb7I/k4o9BHLQFl5dz6Lmsesm46ra14IYFi
7m31RhUPm4ySRw2+wfDuRvPZsl4epozOifLIDAZb3qA+IZSPmaO2pe5twaCo
2ugxXM3HvlxVS6mjFMZa6y/vthfgZttDH9ITpRBn5GzYmSlAcc7dgTfXpPDe
ROIwBwQYPFj+T6WFDNaZh/y3K4R4SdimtYyQQe+HZYlb64QYvVzB7i+SAZ6T
NyU6i5BF2tNlZ5LBXuHx4N7jIkzWGfjPeHIIfUIZo4yI8E7G44qJE3IY36LT
3Y8KwKQ25vjpHjl8LIptPXQvAPeQn3xp8wwBl7YVE2bvQCzi2Nqt3x8CDubw
sIHCQKSGF7xWNYeAL+XCw8LJQJxtsVvjYkNAqfFVxqq4ICSVvVU4xRAw8rss
cn97EMZwLrWXXybA58oBr5qFgAkzolgTlQREFnw9emoRYPKDeYUrrhKgUv5g
TFsMuG/LjtjhagJ0/Oxf+S6AJ08x3jNrCYhvKZhsdAO8aa5deAsJOGe80Klf
DkipvRP/2EDAfLunKiMH0PVwqt69iwCWeZ0BuYDuYR6+ad0EbOjuoU/fBOmv
cj5Segi4qO1/Gc8HlDuuPLG5jwCptylsSASYmvawanCIgINSi2XmYECVJMte
OEzA+eXHMp5KATOt/Q78aCKglUzuvj6dPa9cLaGPEkB5ZJOvCgEsefqdIdVM
QM2mxR+nVgJeLJkjaPlAQA9oI/pDAa+k1GmdJgiY6b608s9VgHWWi5JufCZg
zZBnbHYYYGNna9u8rwTse1DRkLAGsFmbztz0LwHaah9HIhywdZuP5uokAXfV
VbuoEYAd3Oefp6YIGE7zu09WAP4HjzhEKw==
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{False, False},
    AxesLabel->{None, None},
    AxesOrigin->{9.375000000000002, 0},
    DisplayFunction->Identity,
    Epilog->{
      InsetBox[
       FormBox[
        StyleBox["\"y=0.76-0.67x\"", FontSize -> 24, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm], {40, -15}]},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{
       FormBox[
       "\"ln {[\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L)-\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L=60)]/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))}\"", 
        TraditionalForm], None}, {
       FormBox["\"System size L (number of rotors)\"", TraditionalForm], 
       None}},
    FrameStyle->Thickness[Large],
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    FrameTicksStyle->Directive[FontSize -> 20],
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImageSize->Large,
    LabelStyle->Directive[FontSize -> Large],
    Method->{},
    PlotRange->{{10., 50.}, {-33.10419521464234, 0}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.02]}},
    Ticks->{Automatic, Automatic}], " ", "th"}], "=", "0.2"}]], "Input",
 CellChangeTimes->{
  3.674831201429133*^9, {3.6748320461243267`*^9, 3.674832048093617*^9}}],

Cell[BoxData[
 RowBox[{
  GraphicsBox[{{{}, {{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
        0.012833333333333334`], AbsoluteThickness[1.6], 
        LineBox[{{10., -9.50620240325204}, {12., -12.183540634290019`}, {
         14., -14.860015060028323`}, {16., -17.536548848126454`}, {
         18., -20.213078980451147`}, {20., -22.88960849005455}, {
         22., -25.56615684948917}, {24., -28.242730918489364`}, {
         26., -30.94476304726601}, {28., -34.163638872134214`}}]}}, {
       {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
        AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15.5], {0., 0.}], {{{10., -9.50620240325204}}, {{
         12., -12.183540634290019`}}, {{14., -14.860015060028323`}}, {{
         16., -17.536548848126454`}}, {{18., -20.213078980451147`}}, {{
         20., -22.88960849005455}}, {{22., -25.56615684948917}}, {{
         24., -28.242730918489364`}}, {{26., -30.94476304726601}}, {{
         28., -34.163638872134214`}}}]}, {}}}, {}}, {{}, {}, 
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVjn84FHYcx4+QME+jJJlyjhyH++HO3X25PkqSRaVf5xJnO5UHieoWsZR+
rNRTxuiJalh3JpqZPa0WPnKH8rPFUeqMEy6prB7L5sfsj/fz+uv1et6OXySG
xRhSKJSQ+f1Pedo2CwqFBofPtVa976Eisyu25IkhDYJ6qbea+qg45p4hVBrT
wGF1SklBPxWlfeX7Q81p0Khyzl03QsVgoYm60IYGdpTjR3Imqejw8bd0gQcN
auUsPmepEzYdcnibLKGBmSyvJjnMCW3j9I9fVtPgukjaPNHqhLGMXWOGKc4Q
vys9KktDw9vfGixwZLpAoPIWLavdGVMNm84rdS5g5md9rqLeBScDZHtjFKsh
mWeUGPdwNcYwRECLcIXhvSaZl+pcMXP4bYKdIx1m/8m23fyIjvSy++Ypg3Sg
dO8MYXW64QOrRmVvnhtYDDMqU1TuaB6qzE+UuEOt5ELunjYGbvBUn174KQNS
TWYUSpUHmtnO6haqGLDqo0K85I4npndZ5q054wHxIc+y7Gu9UMeNCDxKPGEg
/pJcHc7EqdgTwaNznqCVTe57pGVinrK+FtELOuemSqXRLLRef8M2RMiEIJ6J
gVsfC6tuPDzWXcCEbIee5f5RbGzZZBWpnWSCtLhyY9YzNvrqAl+dDGeBYW+o
0EnKwaTZb27vvseCK5XnUjfpOLgyXj9RvYQN1bS2x6V7vNG5gdv/o5wNxcHd
+rBBb7wZ//3nK/9gwzKLYVtmJBdHr9q+a3bnwPGDOfnXe7iYWZUmsrzIgbtn
jHsku3l4xX7OvGuEA6n8DI9gDQ+NDyZkcoO9wbKwLuDsbh/kBunZLWXe8F1x
wa0dWh/sT86MHjDiQklABn2XmI8DZxYJc/ZyIfMKfb/iOR8jxiuy1fVcGD3b
V+MqFmBBb5QjYwUP1tq5fen7WIDsihmJZxoPEiP9Hl7bLsS1XXetf9bwYJUo
PJDdIcSyoWh5B98HbnYITi3ZTvDCBlfxgVwf+Gma+pTeSZDlNZ3k/8YHyltL
0zs3+qIn5T63cjMfvg59P6hq88WbTleP3ijjQ1dcYNTrID88zJTFuH0igFlh
ZGF0ux+aPCDn9QkCsK+wou/fKkIrBcuT3iyA2nsdrUUtIpQfsk4zchMCL3Ur
i75lDW7Lsd4oPS0EZndfua5lDX7wcQx9pxXC5ViD+/lUwHG13cwKIJDk//cJ
mQxQqmC7N18lYLMv6cmjIsB27wSzPYUExhsXzDwvBiQNSv3ENQINLnkub0sA
bf60L11RNO8P30uxVgC2Ll/onKgk0BJjtCqiDFBwsc/BpprASVl+/HgVoNXh
U1ayNgJvomuMF6sAMwzrJj62E1DXb/aiquf/XJ7qvNhJoMBxUOzdCNhcceDS
nScEggZMysXNgMdHxBbmzwj8IN0SVtQK+FriYVI1TEASpbvO7gaU6Pe9DBwl
wKo70hygAWz6qljVpydgutL0r509gMW5yzKNxwn8qmWsP/YUUNxuQAl/T2Bx
pHys4QVgY4Rv//gHAiM1pks1WkDOmLz25CSBms8KRKP9gJamr9PKpwjEvajL
thgETMtzifD/l8Bav7DfHXSAr2jRRDNNYPm1oSHm0Hz/lwK7uFkC76bllute
Aqr9NVNzcwQaIxbxdwwD/gfW6z4Z
       "]]}}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{False, False},
   AxesLabel->{None, None},
   AxesOrigin->{9.718750000000002, -8.14},
   DisplayFunction->Identity,
   Epilog->{
     InsetBox[
      FormBox[
       StyleBox["\"y=4.12-1.35x\"", FontSize -> 24, 
        RGBColor[0, 1, 0], StripOnInput -> False], TraditionalForm], {
      25, -15}]},
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{
      FormBox[
      "\"Log{[\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L)-\\!\\(\\*SubscriptBox[\\(V\\), \
\\(PNB\\)]\\)(L=60)]/(\\!\\(\\*SuperscriptBox[\\(ka\\), \\(2\\)]\\))}\"", 
       TraditionalForm], None}, {
      FormBox["\"System size L (number of rotors)\"", TraditionalForm], None}},
   FrameStyle->Thickness[Large],
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   FrameTicksStyle->Directive[FontSize -> 20],
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImageSize->Large,
   LabelStyle->Directive[FontSize -> Large],
   Method->{},
   PlotRange->{{10., 28.}, {-36, -8}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {0, 0}},
   Ticks->{Automatic, Automatic}], " ", "old"}]], "Input",
 CellChangeTimes->{
  3.6689423542475653`*^9, {3.674832050972889*^9, 3.674832052107892*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<logvpn-size.pdf\>\"", ",", "plot$logvpn$size", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6584994733266153`*^9, 3.658499524686902*^9}, {
  3.658500252514083*^9, 3.658500267904419*^9}, {3.666517213518424*^9, 
  3.6665172149231987`*^9}, {3.6665174612985487`*^9, 3.666517461665008*^9}}],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   SuperscriptBox["\[Omega]", "2"], " ", "-", " ", "\[Theta]"}], 
  TraditionalForm]],
 FormatType->"TraditionalForm"]], "Text",
 CellChangeTimes->{{3.6584978816559258`*^9, 3.658497892041853*^9}},
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"omegathnumxrelax1", "=", 
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ldef", "=", "lzero"}], ",", 
        RowBox[{"Mdef", "=", "1."}], ",", 
        RowBox[{"v0", "=", "0"}], ",", 
        RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
       RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"kk", "[", "i", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", 
             RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", "10000."}], 
           "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"M", "[", "i", "]"}], "=", 
          RowBox[{"Which", "[", 
           RowBox[{
            RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "1"}], "||", 
             RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", 
            "True", ",", "1."}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"akpos", "=", 
        RowBox[{"50", "/", "100"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"vdirection", "=", 
        RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
       RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Eta]", "=", "10"}], ";", "\[IndentingNewLine]", 
       RowBox[{"tfinal", "=", "3"}], ";", 
       RowBox[{"tinterval", "=", 
        RowBox[{"tfinal", "/", "10"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"tableContent4", ";", 
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"initialold2", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[Pi]", "/", "2"}], "-", 
                 RowBox[{
                  RowBox[{
                  "ans", "\[LeftDoubleBracket]", "j", 
                   "\[RightDoubleBracket]"}], "[", "tt", "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"es2", ":=", 
              RowBox[{"Eigensystem", "[", 
               RowBox[{"DMat", "[", "initialold2", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"e2", "[", "modenum_", "]"}], ":=", 
              RowBox[{"es2", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", 
                 RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"es2", "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "3"}]}], "\[RightDoubleBracket]"}], ",", 
               RowBox[{"initialold2", "-", "initialold"}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"tt", ",", "0", ",", "tfinal", ",", "0.01"}], "}"}]}], 
           "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"thnumx", ",", "0", ",", "0.26", ",", "0.01"}], "}"}]}], 
        "]"}]}]}], "]"}]}], ";"}], "]"}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845723126327*^9}, {
   3.651845756008204*^9, 3.651845806248726*^9}, {3.6518459944760303`*^9, 
   3.651846028669318*^9}, {3.6518462883066807`*^9, 3.651846310485353*^9}, {
   3.651846378406427*^9, 3.6518463785002832`*^9}, 3.6518465818998747`*^9, {
   3.651846626476674*^9, 3.651846679564951*^9}, {3.651846722607635*^9, 
   3.65184673645573*^9}, {3.651846783712867*^9, 3.6518468296961517`*^9}, {
   3.651846877090221*^9, 3.6518469955887213`*^9}, {3.6518470682307262`*^9, 
   3.6518470705982122`*^9}, {3.651847117414239*^9, 3.6518471717516127`*^9}, {
   3.6518472039302588`*^9, 3.6518472933234463`*^9}, 3.65184732370774*^9, 
   3.651847485249617*^9, {3.6518475654268093`*^9, 3.651847594947063*^9}, 
   3.651847874010017*^9, {3.651847916026132*^9, 3.651847922202346*^9}, {
   3.65184795754793*^9, 3.6518479801563177`*^9}, {3.651848104656477*^9, 
   3.6518481512804337`*^9}, {3.651848410678267*^9, 3.651848412026523*^9}, {
   3.6518485919807663`*^9, 3.6518485947471952`*^9}, {3.651848854688417*^9, 
   3.651848865600699*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"GraphicsRow", "[", 
    RowBox[{"{", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"omegathnumxrelax1", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "t", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.01"}], ",", "0.01"}], "}"}]}]}], "]"}], "}"}], 
    "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "1", ",", "300", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.651845813061639*^9, 3.651845965243012*^9}, {
   3.6518460774542227`*^9, 3.651846116482768*^9}, {3.651846163536715*^9, 
   3.651846163794135*^9}, 3.6518461942275343`*^9, {3.651846484551403*^9, 
   3.651846598281028*^9}, {3.651847005044438*^9, 3.65184706698071*^9}, {
   3.6518472887317247`*^9, 3.651847300986532*^9}, 3.651847502476883*^9, {
   3.651847630403083*^9, 3.651847646563541*^9}, {3.651847694005825*^9, 
   3.651847802935223*^9}, {3.651847856184864*^9, 3.6518478773844976`*^9}, {
   3.651848024220944*^9, 3.651848077006054*^9}, 3.6518482786569443`*^9, {
   3.651848321465981*^9, 3.651848322774406*^9}, {3.651904867567729*^9, 
   3.651904867847699*^9}, {3.651904948256022*^9, 3.651904964216461*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"GraphicsRow", "[", 
    RowBox[{"{", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Abs", "@", 
        RowBox[{"omegathnumxrelax1", "\[LeftDoubleBracket]", 
         RowBox[{"n", ",", "t", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
       
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "1", ",", "300", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "1"}], "}"}], ",", "1", ",", "26", ",", "1"}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.651845813061639*^9, 3.651845965243012*^9}, {
   3.6518460774542227`*^9, 3.651846116482768*^9}, {3.651846163536715*^9, 
   3.651846163794135*^9}, 3.6518461942275343`*^9, {3.651846484551403*^9, 
   3.651846598281028*^9}, {3.651847005044438*^9, 3.65184706698071*^9}, {
   3.6518472887317247`*^9, 3.651847300986532*^9}, 3.651847502476883*^9, {
   3.651847630403083*^9, 3.651847646563541*^9}, {3.651847694005825*^9, 
   3.651847802935223*^9}, {3.651847856184864*^9, 3.6518478773844976`*^9}, {
   3.651848024220944*^9, 3.651848077006054*^9}, 3.651848231775737*^9, {
   3.651848270913187*^9, 3.651848351266054*^9}, {3.6518484444311953`*^9, 
   3.651848517831641*^9}, {3.6518485491455183`*^9, 3.651848572850038*^9}, {
   3.651905086627158*^9, 3.651905100868535*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"omegathnumxrelax", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"thnumx", ",", 
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ldef", "=", "lzero"}], ",", 
           RowBox[{"Mdef", "=", "1."}], ",", 
           RowBox[{"v0", "=", "0"}], ",", 
           RowBox[{"kkdef", "=", "10000."}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"num", "=", "60"}], ";", "\[IndentingNewLine]", 
          RowBox[{"endstart", "=", "0"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"kk", "[", "i", "]"}], "=", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", 
                RowBox[{"numdef", "-", "1"}]}], ",", "10000.", ",", 
               "10000."}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"M", "[", "i", "]"}], "=", 
             RowBox[{"Which", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", "numdef"}], " ", ",", "1.", ",", 
               RowBox[{
                RowBox[{"i", "\[Equal]", "1"}], "||", 
                RowBox[{"i", "\[Equal]", "num"}]}], ",", "10000000.", ",", 
               "True", ",", "1."}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "num"}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"akpos", "=", 
           RowBox[{"50", "/", "100"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"vdirection", "=", 
           RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"akgoleft", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Mute", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"rerunConfigQ", "=", "False"}], ";", "\[IndentingNewLine]", 
          
          RowBox[{"rerunVelQ", "=", "False"}], ";", "\[IndentingNewLine]", 
          RowBox[{"mixmodeQ", "=", "False"}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Eta]", "=", "10."}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"tfinal", "=", "2"}], ";"}], "*)"}], 
          RowBox[{"tinterval", "=", 
           RowBox[{"tfinal", "/", "10"}]}], ";", "tableContent4", ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"initialold2", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Pi]", "/", "2"}], "-", 
              RowBox[{
               RowBox[{
               "ans", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
               "[", "tfinal", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"es2", ":=", 
           RowBox[{"Eigensystem", "[", 
            RowBox[{"DMat", "[", "initialold2", "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"e2", "[", "modenum_", "]"}], ":=", 
           RowBox[{"es2", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", 
              RowBox[{"num", "-", "modenum"}]}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"es2", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", 
            RowBox[{"-", "3"}]}], "\[RightDoubleBracket]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thnumx", ",", "0", ",", "0.26", ",", "0.002"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"tfinal", ",", 
       RowBox[{"{", "3", "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.651835018092099*^9, 3.6518350546033497`*^9}, {
   3.651835330693239*^9, 3.6518353357956553`*^9}, {3.651835423989626*^9, 
   3.651835557064917*^9}, {3.651835641806285*^9, 3.651835649914701*^9}, {
   3.65183570239662*^9, 3.651835743883655*^9}, 3.6518369619977694`*^9, {
   3.651839093544382*^9, 3.651839097626252*^9}, {3.651839128908373*^9, 
   3.651839265820002*^9}, {3.651839364786188*^9, 3.651839389824997*^9}, {
   3.65183944852883*^9, 3.651839450529292*^9}, 3.65183949222895*^9, {
   3.651839550756501*^9, 3.6518395736842527`*^9}, {3.651839659798616*^9, 
   3.651839668198225*^9}, {3.65183999161701*^9, 3.6518400129935827`*^9}, {
   3.651840452218915*^9, 3.651840452424666*^9}, 3.651840530715878*^9, {
   3.65184057443163*^9, 3.651840576478067*^9}, 3.6518406373615227`*^9, {
   3.651840686785672*^9, 3.651840692640305*^9}, {3.651840736547194*^9, 
   3.6518407382099733`*^9}, 3.651840834294958*^9, 3.651840897398097*^9, {
   3.651841124042741*^9, 3.6518411244104958`*^9}, {3.6518412729251833`*^9, 
   3.6518412913266153`*^9}, {3.6518438239798927`*^9, 3.651843835338129*^9}, {
   3.65184455273282*^9, 3.65184459377324*^9}, {3.651844644222067*^9, 
   3.651844645612954*^9}, {3.6518446806235027`*^9, 3.6518447138219976`*^9}, {
   3.651844935507532*^9, 3.651844971063109*^9}, {3.6518450589715776`*^9, 
   3.651845063350629*^9}, 3.651845117084135*^9, 3.651845214875457*^9, {
   3.651845290749659*^9, 3.6518453653428717`*^9}, 3.651845409216929*^9, {
   3.6518454815548773`*^9, 3.651845490145595*^9}, {3.65184555293014*^9, 
   3.65184562022875*^9}, {3.6518457216556807`*^9, 3.651845741033074*^9}, {
   3.651847368892047*^9, 3.651847371069264*^9}, {3.651847432798208*^9, 
   3.651847451969351*^9}, {3.6519125762759047`*^9, 3.651912595794207*^9}, {
   3.65191392443613*^9, 3.65191392525142*^9}, 3.651914014133024*^9}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{"omegathnumxrelax", ",", "1"}], "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<\[Theta]\>\"", ",", 
      "\"\<\!\(\*SuperscriptBox[\(\[Omega]\), \(2\)]\)\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.651845010667933*^9, 3.651845025958489*^9}, {
  3.651845380703549*^9, 3.6518453906206617`*^9}, {3.651845516385036*^9, 
  3.6518455188258944`*^9}, {3.651845644388851*^9, 3.651845671847001*^9}, {
  3.651912556864524*^9, 3.651912565552809*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw1lQs41Pkax4WlsIWw2mpZWSm1KJ1K9HW3DdKYmf9o1a4UR6scHUoXW5xU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       "]]}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
      AbsoluteThickness[1.6], GeometricTransformationBox[InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->8.96], {0., 0.}], CompressedData["
1:eJxFlXs41Pkex92WwhbCaqtlZaXUonQq0dvdNkhjZn6jVbtSHK1ydChdbHFS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       "]]}, {}}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"\[Theta]\"", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SuperscriptBox[\\(\[Omega]\\), \\(2\\)]\\)\"", 
     TraditionalForm]},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{0, 0.26}, {-0.0014065541828649892`, 0.0014073945942110976`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Input",
 CellChangeTimes->{3.651912654258485*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.651927348670904*^9, 3.651927353470559*^9}}]
}, Open  ]]
},
WindowSize->{2552, 1373},
WindowMargins->{{Automatic, -3}, {Automatic, 0}},
TaggingRules->{"Salvaged" -> True},
CellContext->Notebook,
Magnification->1.5,
FontColor->RGBColor[0, 0, 0],
FrontEndVersion->"10.3 for Linux x86 (64-bit) (October 9, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 131, 1, 45, "Text"],
Cell[CellGroupData[{
Cell[714, 25, 157, 2, 53, "Subsubsection"],
Cell[874, 29, 142217, 3713, 9723, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[143128, 3747, 293, 4, 42, "Subsubsection"],
Cell[143424, 3753, 12849, 367, 954, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[156310, 4125, 1470, 20, 42, "Subsubsection"],
Cell[157783, 4147, 13587, 314, 1215, "Input"],
Cell[171373, 4463, 238, 4, 45, "Text"],
Cell[171614, 4469, 8166, 139, 365, "Input"],
Cell[179783, 4610, 1083, 29, 112, "Input"],
Cell[180869, 4641, 1182, 30, 112, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[182088, 4676, 1526, 20, 42, "Subsubsection"],
Cell[183617, 4698, 212, 3, 67, "Text"],
Cell[183832, 4703, 19701, 465, 2161, "Input"],
Cell[203536, 5170, 1497, 41, 135, "Input"],
Cell[205036, 5213, 7023, 99, 67, "Input"],
Cell[212062, 5314, 611, 17, 67, "Input"],
Cell[212676, 5333, 131, 2, 67, "Text"],
Cell[212810, 5337, 3138, 79, 373, "Input"],
Cell[215951, 5418, 132, 2, 67, "Text"],
Cell[216086, 5422, 15092, 385, 2545, "Input"],
Cell[231181, 5809, 487, 13, 79, "Input"],
Cell[231671, 5824, 4080, 93, 424, "Input"],
Cell[235754, 5919, 4293, 98, 480, "Input"],
Cell[240050, 6019, 1162, 18, 67, "Input"],
Cell[241215, 6039, 274, 8, 70, "Text"],
Cell[241492, 6049, 192, 5, 67, "Input"],
Cell[241687, 6056, 251, 4, 67, "Text"],
Cell[241941, 6062, 3306, 72, 547, "Input"],
Cell[245250, 6136, 8593, 131, 156, "Input"],
Cell[253846, 6269, 8686, 132, 156, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[262569, 6406, 1524, 20, 42, "Subsubsection"],
Cell[264096, 6428, 15534, 361, 1392, "Input"],
Cell[279633, 6791, 336, 5, 67, "Text"],
Cell[279972, 6798, 8240, 140, 547, "Input"],
Cell[288215, 6940, 1332, 32, 112, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[289584, 6977, 674, 9, 42, "Subsubsection"],
Cell[290261, 6988, 17459, 377, 586, "Input"],
Cell[307723, 7367, 15375, 318, 470, "Input"],
Cell[323101, 7687, 15911, 324, 500, "Input"],
Cell[339015, 8013, 15631, 322, 750, "Input"],
Cell[354649, 8337, 366, 7, 67, "Input"],
Cell[355018, 8346, 725, 15, 70, "Input"],
Cell[355746, 8363, 876, 17, 70, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[356659, 8385, 241, 4, 42, "Subsubsection"],
Cell[356903, 8391, 16183, 342, 792, "Input"],
Cell[373089, 8735, 13978, 296, 748, "Input"],
Cell[387070, 9033, 15348, 318, 705, "Input"],
Cell[402421, 9353, 15392, 319, 705, "Input"],
Cell[417816, 9674, 15241, 317, 705, "Input"],
Cell[433060, 9993, 206, 5, 67, "Input"],
Cell[433269, 10000, 260, 6, 70, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[433566, 10011, 191, 3, 42, "Subsubsection"],
Cell[433760, 10016, 11788, 245, 441, "Input"],
Cell[445551, 10263, 15507, 320, 470, "Input"],
Cell[461061, 10585, 15675, 322, 470, "Input"],
Cell[476739, 10909, 15747, 323, 705, "Input"],
Cell[492489, 11234, 571, 10, 70, "Input"],
Cell[493063, 11246, 621, 11, 70, "Input"],
Cell[493687, 11259, 529, 10, 70, "Input"],
Cell[494219, 11271, 554, 10, 70, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[494810, 11286, 123, 1, 42, "Subsubsection"],
Cell[494936, 11289, 128, 2, 100, "Text"],
Cell[495067, 11293, 5636, 130, 805, "Input"],
Cell[500706, 11425, 1122, 31, 211, "Input"],
Cell[501831, 11458, 1100, 30, 211, "Input"],
Cell[502934, 11490, 261, 6, 100, "Input"],
Cell[503198, 11498, 263, 6, 100, "Input"],
Cell[503464, 11506, 2466, 57, 298, "Input"],
Cell[505933, 11565, 391, 7, 105, "Input"],
Cell[506327, 11574, 1032, 29, 211, "Input"],
Cell[507362, 11605, 119, 2, 100, "Text"],
Cell[507484, 11609, 6748, 168, 936, "Input"],
Cell[514235, 11779, 5897, 148, 870, "Input"],
Cell[520135, 11929, 46240, 851, 1347, "Input"],
Cell[566378, 12782, 132, 2, 100, "Text"],
Cell[566513, 12786, 3398, 85, 325, "Input"],
Cell[569914, 12873, 2143, 59, 487, "Input"],
Cell[572060, 12934, 1021, 24, 100, "Input"],
Cell[573084, 12960, 998, 24, 100, "Input"],
Cell[574085, 12986, 96, 1, 100, "Input"],
Cell[574184, 12989, 87, 1, 100, "Input"],
Cell[574274, 12992, 87, 1, 100, "Input"],
Cell[574364, 12995, 156, 2, 100, "Text"],
Cell[574523, 12999, 3393, 81, 333, "Input"],
Cell[577919, 13082, 19799, 420, 1284, "Input"],
Cell[597721, 13504, 117, 2, 100, "Text"],
Cell[597841, 13508, 3503, 85, 465, "Input"],
Cell[601347, 13595, 119, 2, 100, "Text"],
Cell[601469, 13599, 1104, 17, 100, "Input"],
Cell[602576, 13618, 1085, 17, 100, "Input"],
Cell[603664, 13637, 1155, 18, 100, "Input"],
Cell[604822, 13657, 1136, 18, 100, "Input"],
Cell[605961, 13677, 1093, 17, 100, "Input"],
Cell[607057, 13696, 1147, 18, 100, "Input"],
Cell[608207, 13716, 1147, 18, 100, "Input"],
Cell[609357, 13736, 1194, 18, 100, "Input"],
Cell[610554, 13756, 1253, 19, 100, "Input"],
Cell[611810, 13777, 1340, 20, 100, "Input"],
Cell[613153, 13799, 1294, 20, 100, "Input"],
Cell[614450, 13821, 434, 8, 100, "Input"],
Cell[614887, 13831, 421, 8, 100, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[615345, 13844, 107, 1, 42, "Subsubsection"],
Cell[615455, 13847, 7886, 192, 927, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[623378, 14044, 130, 2, 42, "Subsubsection"],
Cell[623511, 14048, 2488, 54, 298, "Input"],
Cell[626002, 14104, 106, 1, 100, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[626145, 14110, 119, 2, 42, "Subsubsection"],
Cell[626267, 14114, 17404, 405, 1396630, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[643708, 14524, 3716, 50, 42, "Subsubsection"],
Cell[647427, 14576, 24872, 584, 25317166, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[672336, 15165, 3763, 51, 42, "Subsubsection"],
Cell[676102, 15218, 23272, 542, 23025102, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[699411, 15765, 3881, 52, 42, "Subsubsection"],
Cell[703295, 15819, 23463, 552, 3177, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[726795, 16376, 3815, 51, 42, "Subsubsection"],
Cell[730613, 16429, 141, 2, 45, "Input"],
Cell[730757, 16433, 28794, 644, 2562, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[759588, 17082, 3928, 53, 42, "Subsubsection"],
Cell[763519, 17137, 25515, 603, 3616, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[789071, 17745, 150, 2, 73, "Section"],
Cell[CellGroupData[{
Cell[789246, 17751, 119, 1, 53, "Subsubsection"],
Cell[789368, 17754, 21219, 513, 2180, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[810624, 18272, 190, 2, 42, "Subsubsection"],
Cell[810817, 18276, 409, 5, 378, "Input"],
Cell[811229, 18283, 171, 3, 225, "Input"],
Cell[811403, 18288, 224, 4, 225, "Input"],
Cell[811630, 18294, 4925, 87, 378, "Input"],
Cell[816558, 18383, 5039, 89, 378, "Input"],
Cell[821600, 18474, 8443, 176, 2431, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[830080, 18655, 137, 2, 42, "Subsubsection"],
Cell[830220, 18659, 173, 2, 225, "Text"],
Cell[830396, 18663, 2432, 68, 648, "Input"],
Cell[832831, 18733, 131, 2, 225, "Text"],
Cell[832965, 18737, 1356, 35, 378, "Input"],
Cell[834324, 18774, 2503, 64, 1338, "Input"],
Cell[836830, 18840, 1622, 39, 526, "Input"],
Cell[838455, 18881, 239292, 3939, 2389, 60682, 1009, "CachedBoxData", \
"BoxData", "Input"],
Cell[1077750, 22822, 1058, 25, 225, "Input"],
Cell[1078811, 22849, 918, 24, 225, "Input"],
Cell[1079732, 22875, 951, 26, 225, "Input"],
Cell[1080686, 22903, 127, 2, 225, "Text"],
Cell[1080816, 22907, 1748, 45, 657, "Input"],
Cell[1082567, 22954, 5296, 123, 1135, "Input"],
Cell[1087866, 23079, 111433, 1902, 3390, "Input"],
Cell[1199302, 24983, 425, 8, 225, "Input"],
Cell[1199730, 24993, 245002, 4033, 2389, 65369, 1086, "CachedBoxData", \
"BoxData", "Input"],
Cell[1444735, 29028, 1090, 31, 438, "Input"],
Cell[1445828, 29061, 1101, 31, 438, "Input"],
Cell[1446932, 29094, 1140, 33, 447, "Input"],
Cell[1448075, 29129, 1212, 34, 454, "Input"],
Cell[1449290, 29165, 118, 2, 225, "Text"],
Cell[1449411, 29169, 7723, 182, 2350, "Input"],
Cell[1457137, 29353, 1186, 32, 235, "Input"],
Cell[1458326, 29387, 325, 7, 225, "Input"],
Cell[1458654, 29396, 305, 6, 225, "Input"],
Cell[1458962, 29404, 143, 2, 225, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1459142, 29411, 647, 9, 53, "Subsection"],
Cell[1459792, 29422, 19307, 422, 3651, "Input"],
Cell[1479102, 29846, 10188, 170, 676, "Input"],
Cell[1489293, 30018, 733, 19, 150, "Input"],
Cell[1490029, 30039, 684, 17, 150, "Input"],
Cell[1490716, 30058, 374, 7, 150, "Input"],
Cell[1491093, 30067, 372, 7, 150, "Input"],
Cell[CellGroupData[{
Cell[1491490, 30078, 101, 1, 177, "Subsubsection"],
Cell[1491594, 30081, 314, 6, 252, "Input"],
Cell[1491911, 30089, 11779, 284, 5004, "Input"],
Cell[1503693, 30375, 371, 8, 351, "Input"],
Cell[1504067, 30385, 14808, 246, 1062, "Input"],
Cell[1518878, 30633, 3397, 56, 150, "Input"],
Cell[1522278, 30691, 9511, 183, 1278, "Input"],
Cell[1531792, 30876, 796, 13, 150, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1532637, 30895, 651, 9, 53, "Subsection"],
Cell[1533291, 30906, 20121, 438, 3624, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1553449, 31349, 707, 9, 53, "Subsection"],
Cell[1554159, 31360, 20361, 449, 3469, "Input"],
Cell[1574523, 31811, 12773, 213, 843, "Input"],
Cell[1587299, 32026, 3444, 79, 546, "Input"],
Cell[1590746, 32107, 10846, 177, 676, "Input"],
Cell[1601595, 32286, 800, 19, 150, "Input"],
Cell[1602398, 32307, 824, 20, 150, "Input"],
Cell[1603225, 32329, 478, 9, 150, "Input"],
Cell[1603706, 32340, 431, 8, 150, "Input"],
Cell[CellGroupData[{
Cell[1604162, 32352, 101, 1, 177, "Subsubsection"],
Cell[1604266, 32355, 289, 6, 252, "Input"],
Cell[1604558, 32363, 11861, 287, 5104, "Input"],
Cell[1616422, 32652, 371, 8, 351, "Input"],
Cell[1616796, 32662, 14703, 245, 1062, "Input"],
Cell[1631502, 32909, 14558, 242, 1062, "Input"],
Cell[1646063, 33153, 14889, 250, 1062, "Input"],
Cell[1660955, 33405, 4929, 109, 742, "Input"],
Cell[1665887, 33516, 3825, 73, 303, "Input"],
Cell[1669715, 33591, 3831, 70, 303, "Input"],
Cell[1673549, 33663, 395, 12, 150, "Input"],
Cell[1673947, 33677, 10606, 212, 1855, "Input"],
Cell[1684556, 33891, 54332, 1246, 2463, "Input"],
Cell[1738891, 35139, 1364, 38, 256, "Input"],
Cell[1740258, 35179, 726, 12, 150, "Input"],
Cell[1740987, 35193, 3373, 68, 303, "Input"],
Cell[1744363, 35263, 3471, 66, 351, "Input"],
Cell[1747837, 35331, 946, 27, 150, "Input"],
Cell[1748786, 35360, 474, 10, 150, "Input"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1749321, 35377, 98, 1, 96, "Section"],
Cell[1749422, 35380, 2127, 62, 694, "Input"],
Cell[1751552, 35444, 8022, 137, 820, "Input"],
Cell[1759577, 35583, 7708, 124, 234, "Input"],
Cell[1767288, 35709, 7532, 118, 234, "Input"],
Cell[1774823, 35829, 7903, 124, 234, "Input"],
Cell[1782729, 35955, 611, 16, 100, "Input"],
Cell[1783343, 35973, 413, 9, 100, "Input"],
Cell[CellGroupData[{
Cell[1783781, 35986, 683, 9, 118, "Subsubsection"],
Cell[1784467, 35997, 9424, 144, 234, "Input"],
Cell[1793894, 36143, 396, 9, 100, "Input"],
Cell[1794293, 36154, 4863, 117, 559, "Input"],
Cell[1799159, 36273, 493, 8, 100, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1799689, 36286, 668, 9, 118, "Subsubsection"],
Cell[1800360, 36297, 9421, 144, 1183, "Input"],
Cell[1809784, 36443, 5335, 131, 2827, "Input"],
Cell[1815122, 36576, 535, 8, 505, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1815706, 36590, 178, 2, 73, "Section"],
Cell[CellGroupData[{
Cell[1815909, 36596, 98, 1, 53, "Subsubsection"],
Cell[1816010, 36599, 2142, 60, 309, "Input"],
Cell[1818155, 36661, 116, 2, 45, "Input"],
Cell[1818274, 36665, 409, 13, 70, "Input"],
Cell[1818686, 36680, 156, 3, 45, "Input"],
Cell[1818845, 36685, 3210, 72, 365, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1822092, 36762, 121, 2, 53, "Subsubsection"],
Cell[1822216, 36766, 10237, 159, 133, "Input"],
Cell[1832456, 36927, 191, 4, 45, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1832684, 36936, 192, 2, 53, "Subsubsection"],
Cell[1832879, 36940, 1841, 54, 309, "Input"],
Cell[1834723, 36996, 3210, 72, 365, "Input"],
Cell[1837936, 37070, 12241, 210, 314, "Input"],
Cell[1850180, 37282, 1038, 29, 87, "Input"],
Cell[1851221, 37313, 4022, 100, 220, "Input"],
Cell[1855246, 37415, 390, 6, 45, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1855673, 37426, 158, 2, 53, "Subsubsection"],
Cell[1855834, 37430, 8595, 134, 102271, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1864466, 37569, 590, 8, 42, "Subsubsection"],
Cell[1865059, 37579, 9130, 141, 102271, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1874226, 37725, 704, 9, 42, "Subsubsection"],
Cell[1874933, 37736, 2197, 46, 345163, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1877167, 37787, 605, 8, 42, "Subsubsection"],
Cell[1877775, 37797, 2119, 45, 345163, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1879931, 37847, 651, 9, 42, "Subsubsection"],
Cell[1880585, 37858, 9187, 141, 345163, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1889809, 38004, 780, 10, 42, "Subsubsection"],
Cell[1890592, 38016, 9291, 143, 345163, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1899920, 38164, 834, 11, 42, "Subsubsection"],
Cell[1900757, 38177, 9328, 143, 345163, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1910122, 38325, 119, 1, 42, "Subsubsection"],
Cell[1910244, 38328, 935, 20, 43606, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1911216, 38353, 164, 2, 53, "Subsection"],
Cell[1911383, 38357, 152, 2, 1702, "Text"],
Cell[CellGroupData[{
Cell[1911560, 38363, 619, 8, 2007, "Subsubsection"],
Cell[1912182, 38373, 9300, 142, 3991, "Input"],
Cell[1921485, 38517, 352, 10, 1702, "Input"],
Cell[1921840, 38529, 5464, 127, 9540, "Input"],
Cell[1927307, 38658, 446, 7, 1702, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1927790, 38670, 613, 8, 2007, "Subsubsection"],
Cell[1928406, 38680, 9325, 143, 3991, "Input"],
Cell[1937734, 38825, 4424, 108, 8446, "Input"],
Cell[1942161, 38935, 488, 8, 43606, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1942686, 38948, 666, 9, 51423, "Subsubsection"],
Cell[1943355, 38959, 9372, 143, 102271, "Input"],
Cell[1952730, 39104, 4481, 109, 216451, "Input"],
Cell[1957214, 39215, 496, 8, 43606, "Input"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1957771, 39230, 169, 2, 96, "Section"],
Cell[1957943, 39234, 983, 22, 75, "Input"],
Cell[1958929, 39258, 108, 1, 45, "Input"],
Cell[CellGroupData[{
Cell[1959062, 39263, 201, 3, 53, "Subsubsection"],
Cell[1959266, 39268, 1308, 26, 45, "Input"],
Cell[1960577, 39296, 915, 17, 45, "Input"],
Cell[1961495, 39315, 1019, 18, 45, "Input"],
Cell[1962517, 39335, 1072, 19, 45, "Input"],
Cell[1963592, 39356, 1069, 19, 45, "Input"],
Cell[1964664, 39377, 1120, 19, 45, "Input"],
Cell[1965787, 39398, 339, 9, 45, "Input"],
Cell[1966129, 39409, 364, 9, 45, "Input"],
Cell[1966496, 39420, 410, 10, 45, "Input"],
Cell[1966909, 39432, 460, 10, 45, "Input"],
Cell[1967372, 39444, 507, 11, 45, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1967916, 39460, 100, 1, 42, "Subsubsection"],
Cell[1968019, 39463, 496, 11, 45, "Input"],
Cell[1968518, 39476, 448, 10, 45, "Input"],
Cell[1968969, 39488, 574, 13, 45, "Input"],
Cell[1969546, 39503, 522, 13, 45, "Input"],
Cell[1970071, 39518, 626, 14, 45, "Input"],
Cell[1970700, 39534, 620, 14, 45, "Input"],
Cell[1971323, 39550, 481, 13, 45, "Input"],
Cell[1971807, 39565, 483, 13, 45, "Input"],
Cell[1972293, 39580, 351, 10, 45, "Input"],
Cell[1972647, 39592, 424, 11, 45, "Input"],
Cell[1973074, 39605, 467, 11, 45, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1973590, 39622, 147, 2, 96, "Section"],
Cell[CellGroupData[{
Cell[1973762, 39628, 98, 1, 53, "Subsubsection"],
Cell[1973863, 39631, 217, 5, 45, "Input"],
Cell[1974083, 39638, 366, 7, 45, "Input"],
Cell[1974452, 39647, 234, 5, 45, "Input"],
Cell[1974689, 39654, 275, 6, 45, "Input"],
Cell[1974967, 39662, 320, 8, 45, "Input"],
Cell[1975290, 39672, 788, 19, 45, "Input"],
Cell[1976081, 39693, 689, 15, 45, "Input"],
Cell[1976773, 39710, 770, 16, 45, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1977580, 39731, 98, 1, 42, "Subsubsection"],
Cell[1977681, 39734, 466, 10, 670, "Input"],
Cell[1978150, 39746, 548, 12, 670, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1978735, 39763, 209, 3, 42, "Subsubsection"],
Cell[1978947, 39768, 1887, 32, 75, "Input"],
Cell[1980837, 39802, 119, 2, 45, "Text"],
Cell[1980959, 39806, 1827, 42, 111, "Input"],
Cell[1982789, 39850, 2799, 52, 129, "Input"],
Cell[1985591, 39904, 2203, 42, 77, "Input"],
Cell[1987797, 39948, 2309, 45, 77, "Input"],
Cell[1990109, 39995, 122, 2, 45, "Text"],
Cell[1990234, 39999, 2068, 49, 111, "Input"],
Cell[1992305, 40050, 2226, 44, 129, "Input"],
Cell[1994534, 40096, 2694, 52, 158, "Input"],
Cell[1997231, 40150, 1805, 37, 77, "Input"],
Cell[1999039, 40189, 1907, 39, 77, "Input"],
Cell[2000949, 40230, 2006, 42, 77, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2002992, 40277, 95, 1, 53, "Subsubsection"],
Cell[2003090, 40280, 117, 2, 45, "Text"],
Cell[2003210, 40284, 1586, 28, 45, "Input"],
Cell[2004799, 40314, 2201, 42, 45, "Input"],
Cell[2007003, 40358, 77822, 2039, 614, InheritFromParent],
Cell[2084828, 42399, 77830, 2041, 614, "Input"],
Cell[2162661, 44442, 76997, 2020, 614, "Input"],
Cell[2239661, 46464, 1029, 19, 45, "Input"],
Cell[2240693, 46485, 1003, 18, 45, "Input"],
Cell[2241699, 46505, 121, 2, 45, "Text"],
Cell[2241823, 46509, 1538, 27, 45, "Input"],
Cell[2243364, 46538, 3494, 72, 162, "Input"],
Cell[2246861, 46612, 384535, 10585, 627, InheritFromParent],
Cell[2631399, 57199, 384562, 10588, 627, "Input"],
Cell[3015964, 67789, 382711, 10542, 627, "Input"],
Cell[3398678, 78333, 1190, 19, 45, "Input"],
Cell[3399871, 78354, 1186, 21, 45, "Input"],
Cell[3401060, 78377, 1214, 21, 45, "Input"],
Cell[3402277, 78400, 584, 16, 47, "Input"],
Cell[3402864, 78418, 1859, 56, 75, "Input"],
Cell[3404726, 78476, 471, 13, 45, "Input"],
Cell[3405200, 78491, 1242, 19, 45, "Input"],
Cell[3406445, 78512, 1244, 19, 45, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3407738, 78537, 86, 1, 96, "Section"],
Cell[3407827, 78540, 7790, 178, 452, "Input"],
Cell[3415620, 78720, 452, 12, 45, "Input"],
Cell[3416075, 78734, 196, 3, 45, "Text"],
Cell[3416274, 78739, 6756, 130, 568, "Input"],
Cell[3423033, 78871, 785, 23, 109, "Input"],
Cell[3423821, 78896, 7302, 137, 568, "Input"],
Cell[3431126, 79035, 104, 2, 45, "Input"],
Cell[3431233, 79039, 210, 5, 45, "Input"],
Cell[3431446, 79046, 331, 5, 45, "Text"],
Cell[3431780, 79053, 15037, 286, 694, "Input"],
Cell[3446820, 79341, 12486, 229, 665, "Input"],
Cell[3459309, 79572, 619, 16, 45, "Input"],
Cell[3459931, 79590, 399, 8, 45, "Input"],
Cell[3460333, 79600, 382, 8, 45, "Input"],
Cell[3460718, 79610, 114, 2, 45, "Input"],
Cell[3460835, 79614, 2001, 40, 75, "Input"],
Cell[3462839, 79656, 3137, 64, 133, "Input"],
Cell[3465979, 79722, 221, 4, 45, "Input"],
Cell[3466203, 79728, 267, 8, 50, "Text"],
Cell[3466473, 79738, 626, 19, 45, "Input"],
Cell[3467102, 79759, 402, 13, 104, "Input"],
Cell[3467507, 79774, 168, 3, 150, "Text"],
Cell[3467678, 79779, 40, 0, 150, "Input"],
Cell[3467721, 79781, 13996, 295, 2187, "Input"],
Cell[3481720, 80078, 32006, 652, 1953, "Input"],
Cell[3513729, 80732, 174, 3, 150, "Text"],
Cell[3513906, 80737, 1215, 32, 150, "Input"],
Cell[3515124, 80771, 439, 11, 150, "Input"],
Cell[3515566, 80784, 12572, 273, 2152, "Input"],
Cell[3528141, 81059, 313, 5, 150, "Input"],
Cell[3528457, 81066, 362, 6, 150, "Input"],
Cell[3528822, 81074, 220, 3, 150, "Text"],
Cell[3529045, 81079, 623, 13, 150, "Input"],
Cell[3529671, 81094, 10755, 192, 1818, "Input"],
Cell[3540429, 81288, 2231, 47, 252, "Input"],
Cell[3542663, 81337, 2142, 48, 1251, "Input"],
Cell[3544808, 81387, 2005, 45, 1120, "Input"],
Cell[3546816, 81434, 2204, 48, 1255, "Text"],
Cell[3549023, 81484, 2221, 47, 1203, "Input"],
Cell[3551247, 81533, 6700, 139, 1392, "Input"],
Cell[3557950, 81674, 3609, 73, 1999, "Input"],
Cell[3561562, 81749, 3831, 79, 2034, "Input"],
Cell[3565396, 81830, 3681, 77, 2034, "Input"],
Cell[3569080, 81909, 3874, 82, 2034, "Input"],
Cell[3572957, 81993, 4271, 86, 2074, "Input"],
Cell[3577231, 82081, 459, 7, 150, "Input"],
Cell[3577693, 82090, 276, 7, 162, "Text"],
Cell[3577972, 82099, 6670, 132, 2017, "Input"],
Cell[3584645, 82233, 1453, 28, 225, "Input"],
Cell[3586101, 82263, 1588, 32, 378, "Input"],
Cell[3587692, 82297, 5848, 120, 3321, "Input"],
Cell[3593543, 82419, 748, 17, 265, "Input"],
Cell[3594294, 82438, 5991, 113, 511, "Input"],
Cell[3600288, 82553, 92, 1, 67, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
