(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    941280,      17808]
NotebookOptionsPosition[    935075,      17669]
NotebookOutlinePosition[    935431,      17685]
CellTagsIndexPosition[    935388,      17682]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" topomech wave", "Text",
 CellChangeTimes->{{3.7091941387590237`*^9, 
  3.7091941451083527`*^9}},ExpressionUUID->"e0550381-9616-43ae-8ac7-\
16827808b9ca"],

Cell[CellGroupData[{

Cell["Function Library", "Subsubsection",
 CellChangeTimes->{{3.633107868465901*^9, 3.633107871621709*^9}, 
   3.646901892311627*^9, 
   3.6515583381921062`*^9},ExpressionUUID->"97ec76cb-d563-4b07-b961-\
1c0f2c14c663"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"splineCircle", "[", 
    RowBox[{"m_List", ",", "r_", ",", 
     RowBox[{"angles_List:", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "seg", ",", "\[Phi]", ",", "start", ",", "end", ",", "pts", ",", "w", 
        ",", "k", ",", "endtemp", ",", "starttemp"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"starttemp", ",", "endtemp"}], "}"}], "=", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"angles", "//", "N"}], ",", 
          RowBox[{"2", " ", "\[Pi]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"endtemp", "\[LessEqual]", "starttemp"}], ",", 
         RowBox[{
          RowBox[{"start", "=", "endtemp"}], ";", 
          RowBox[{"end", "=", "starttemp"}], ";"}], ",", 
         RowBox[{
          RowBox[{"start", "=", "starttemp"}], ";", 
          RowBox[{"end", "=", "endtemp"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"seg", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"end", "-", "start"}], "//", "N"}], ",", 
          RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"\[Phi]", "=", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"end", "-", "start"}], "//", "N"}], ",", 
          RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"seg", "\[Equal]", "4"}], ",", 
         RowBox[{
          RowBox[{"seg", "=", "3"}], ";", 
          RowBox[{"\[Phi]", "=", 
           RowBox[{"\[Pi]", "/", "2"}]}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pts", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"r", " ", 
           RowBox[{
            RowBox[{"RotationMatrix", "[", "start", "]"}], ".", "#"}]}], 
          "&"}], "/@", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Take", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
             RowBox[{
              RowBox[{"2", " ", "seg"}], "+", "1"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"RotationMatrix", "[", 
               RowBox[{"seg", " ", 
                RowBox[{"\[Pi]", "/", "2"}]}], "]"}], ".", "#"}], "&"}], "/@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"Tan", "[", 
                 RowBox[{"\[Phi]", "/", "2"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", "\[Phi]", "]"}], ",", 
                RowBox[{"Sin", "[", "\[Phi]", "]"}]}], "}"}]}], "}"}]}]}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "2"}], ",", 
         RowBox[{"pts", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"m", "+", "#"}], "&"}], "/@", "pts"}]}], ",", 
         RowBox[{"pts", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"m", "+", "#"}], "&"}], "/@", 
           RowBox[{"Transpose", "[", 
            RowBox[{"Append", "[", 
             RowBox[{
              RowBox[{"Transpose", "[", "pts", "]"}], ",", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0", ",", 
                RowBox[{"Length", "[", "pts", "]"}]}], "]"}]}], "]"}], 
            "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"w", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"1", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1", ",", 
              RowBox[{"1", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1", ",", 
              RowBox[{"1", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "1"}], "}"}], ",", 
            RowBox[{
             RowBox[{"2", " ", "seg"}], "+", "1"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Cos", "[", 
             RowBox[{"\[Phi]", "/", "2"}], "]"}], ",", "1"}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"k", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Riffle", "[", 
             RowBox[{"#", ",", "#"}], "]"}], "&"}], "@", 
           RowBox[{"Range", "[", 
            RowBox[{"seg", "+", "1"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"seg", "+", "1"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"endtemp", "\[LessEqual]", "starttemp"}], ",", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{"Reverse", "[", "w", "]"}]}], ";", 
          RowBox[{"pts", "=", 
           RowBox[{"Reverse", "[", "pts", "]"}]}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"BSplineCurve", "[", 
        RowBox[{"pts", ",", 
         RowBox[{"SplineDegree", "\[Rule]", "2"}], ",", 
         RowBox[{"SplineKnots", "\[Rule]", "k"}], ",", 
         RowBox[{"SplineWeights", "\[Rule]", "w"}]}], "]"}]}]}], "]"}], "/;", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "2"}], "||", 
     RowBox[{
      RowBox[{"Length", "[", "m", "]"}], "\[Equal]", "3"}]}]}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicVec", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"grey", " ", "bar"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", "pivot", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "rod", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "bar", "*)"}], "\[IndentingNewLine]", "Red", ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{".2", "/", "num"}], "]"}], ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "num"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"cross", " ", "boundary", " ", "bars"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Inside", " ", "bars"}], "*)"}], "\[IndentingNewLine]", 
             
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0"}], "}"}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                 RowBox[{"r", " ", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                   "}"}]}]}]}], "}"}], "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "mass", "*)"}], "\[IndentingNewLine]", "Blue", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "vector", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicVecMass", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", "dl_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"grey", " ", "bar"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", "pivot", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "rod", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"(*", "bar", "*)"}], "\[IndentingNewLine]", "Gray", ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{
             "dl", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
             "]"}], "/", "num"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
              "dl", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
              ">", "0"}], ",", 
             RowBox[{"0.02", "/", "num"}], ",", "0"}], "]"}]}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "num"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"cross", " ", "boundary", " ", "bars"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Dashing", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], ">", "0"}], ",", 
                  RowBox[{"0.2", "/", "num"}], ",", "0"}], "]"}], "]"}], ",", 
               
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], "/", "num"}], "/", 
                 "5"}]}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Inside", " ", "bars"}], "*)"}], "\[IndentingNewLine]", 
             
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Dashing", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], ">", "0"}], ",", 
                  RowBox[{"0.2", "/", "num"}], ",", "0"}], "]"}], "]"}], ",", 
               
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], "/", "num"}], "/", 
                 "5"}]}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                    "}"}]}]}]}], "}"}], "]"}]}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"(*", "bar", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Gray", ",", 
           RowBox[{"Dashing", "[", 
            RowBox[{"{", 
             RowBox[{"0.2", "/", "num"}], "}"}], "]"}], ",", 
           RowBox[{"Thickness", "\[Rule]", 
            RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", "num"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{"cross", " ", "boundary", " ", "bars"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                   "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                   "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{"Inside", " ", "bars"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                    "}"}]}]}]}], "}"}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ","}], "*)"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "mass", "*)"}], "\[IndentingNewLine]", "Gray", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "vector", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", "Green", "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", "Green", "]"}], ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHpicVecBond", "[", 
    RowBox[{"\[Theta]_", ",", "r_", ",", "d\[Theta]_", ",", "dl_", ",", 
     RowBox[{"a_:", "1"}], ",", 
     RowBox[{"opac_:", "1"}], ",", 
     RowBox[{"vecopac_:", "1"}], ",", 
     RowBox[{"circmode_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arrowsize", ",", 
       RowBox[{"xsize", "=", ".08"}], ",", 
       RowBox[{"num", "=", 
        RowBox[{"Length", "[", "\[Theta]", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arrowsize", "=", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"4", " ", "num"}], ")"}]}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"num", "=", "10"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"grey", " ", "bar"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Opacity", "\[Rule]", "opac"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{"3", "xsize"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"num", "+", 
               RowBox[{"3", "xsize"}]}], ",", 
              RowBox[{
               RowBox[{"-", "3"}], "xsize"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", "pivot", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".025", "/", "num"}]}], ",", "Black", ",", 
         RowBox[{"(*", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}]}], "]"}], 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", "xsize"}], "}"}]}], "}"}],
               "]"}], ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "xsize"}], ",", "xsize"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", "xsize"}], ",", 
                  RowBox[{"-", "xsize"}]}], "}"}]}], "}"}], "]"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
         ",", 
         RowBox[{"Thickness", "\[Rule]", 
          RowBox[{".06", "/", "num"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "rod", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "0"}], "}"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "0"}], "}"}], "+", 
               RowBox[{"r", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
             "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "bar", "*)"}], "\[IndentingNewLine]", "Red", ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{
             "dl", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
             "]"}], "/", "num"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
              "dl", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
              ">", "0"}], ",", 
             RowBox[{"0.02", "/", "num"}], ",", "0"}], "]"}]}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "num"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"cross", " ", "boundary", " ", "bars"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Dashing", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], ">", "0"}], ",", 
                  RowBox[{"0.2", "/", "num"}], ",", "0"}], "]"}], "]"}], ",", 
               
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], "/", "num"}], "/", 
                 "5"}]}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "num", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                 "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Inside", " ", "bars"}], "*)"}], "\[IndentingNewLine]", 
             
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Dashing", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], ">", "0"}], ",", 
                  RowBox[{"0.2", "/", "num"}], ",", "0"}], "]"}], "]"}], ",", 
               
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                   "dl", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], "/", "num"}], "/", 
                 "5"}]}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "0"}], "}"}], "+", 
                   RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], 
                    "}"}]}]}]}], "}"}], "]"}]}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "mass", "*)"}], "\[IndentingNewLine]", "Gray", ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{".3", "/", "num"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "0"}], "}"}], "+", 
             RowBox[{"r", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", "vector", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Opacity", "\[Rule]", "vecopac"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "d\[Theta]", "]"}], "\[Equal]", "num"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"circmode", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"Gray", ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"3", "a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"splineCircle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "r", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}]}], "}"}]}], "]"}]}], 
                  "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}], 
             "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"Gray", ",", 
               RowBox[{"Thickness", "\[Rule]", 
                RowBox[{".05", "/", "num"}]}], ",", 
               RowBox[{"Arrowheads", "\[Rule]", "arrowsize"}], ",", 
               RowBox[{"Dashing", "[", 
                RowBox[{"{", "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", 
                    "arrowsize"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "num"}], ")"}]}]}], "]"}]}], ",", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], "+", 
                    RowBox[{"r", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"a", " ", 
                    RowBox[{"d\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}]}]}], 
                    "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"numerical", " ", "functions"}], ",", " ", 
    RowBox[{
    "components", " ", "in", " ", "the", " ", "rigidity", " ", "matrix"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"l", "[", 
     RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"]}], "-", 
      RowBox[{"2", "  ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}], "]"}]}], "*)"}], 
  "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"measure", " ", "from"}], " ", "+", 
    RowBox[{"y", " ", 
     RowBox[{"vertical", ":", " ", 
      RowBox[{
       RowBox[{"not", " ", "kane"}], "-", "lubensky"}]}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l", "[", 
   RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_", ",", 
    RowBox[{"a_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "-", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
       RowBox[{"r", " ", 
        RowBox[{"Sin", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}], ")"}], "2"]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "[", 
   RowBox[{"\[Theta]_", ",", "r_", ",", 
    RowBox[{"a_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{"4", 
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"llist", "[", "num_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"numdef", "-", "1"}]}], ",", "ldef", ",", 
       RowBox[{"Sqrt", "[", "lzerosq", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"pi", "/", "2"}], " ", "convention", " ", "for", " ", "thetas", 
    " ", "again", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"measured", " ", "from", " ", "x"}], "-", 
      RowBox[{"axis", "!"}]}], ")"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SSHq1", "[", 
   RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "r", " ", 
     RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "2"], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}]}], 
   RowBox[{"2", " ", 
    SqrtBox[
     RowBox[{"1", "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"]}], "-", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
      RowBox[{"2", " ", "r", " ", 
       RowBox[{
       "Cos", "[", "\[Theta]2", "]"}]}]}]]}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SSHq2", "[", 
    RowBox[{"\[Theta]1_", ",", "\[Theta]2_", ",", "r_"}], "]"}], ":=", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["r", "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "-", 
     RowBox[{"2", " ", "r", " ", 
      RowBox[{"Sin", "[", "\[Theta]2", "]"}]}]}], 
    RowBox[{"2", " ", 
     SqrtBox[
      RowBox[{"1", "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       RowBox[{"2", " ", "r", " ", 
        RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["r", "2"], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"\[Theta]1", "-", "\[Theta]2"}], "]"}]}], "+", 
       RowBox[{"2", " ", "r", " ", 
        RowBox[{"Cos", "[", "\[Theta]2", "]"}]}]}]]}]]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "make", " ", "rigidity", " ", "matrix", " ", "given", " ", "a", " ", 
    "system", " ", "with", " ", "equilibrium", " ", "angles", " ", "in", " ", 
    "the", " ", "list", " ", "theta", " ", "and", " ", "length", " ", "of", 
    " ", "bars", " ", "equal", " ", "to", " ", "r"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHrig", "[", 
    RowBox[{"\[Theta]_", ",", "r_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SparseArray", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", " ", 
             RowBox[{"SSHq1", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "r"}], "]"}]}], 
            ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"i", "+", "1"}]}], "}"}], "\[Rule]", " ", 
             RowBox[{"SSHq2", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "r"}], "]"}]}]}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"n", "-", "1"}], ",", "n"}], "}"}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"PBC", " ", "simulation"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSSHrig3", "[", 
    RowBox[{"\[Theta]_", ",", "r_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "\[Theta]", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SparseArray", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", " ", 
             RowBox[{"SSHq1", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"i", "<", "n"}], ",", 
                   RowBox[{"i", "+", "1"}], ",", "1"}], "]"}], "]"}], "]"}], 
               ",", "r"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"i", "<", "n"}], ",", 
                 RowBox[{"i", "+", "1"}], ",", "1"}], "]"}]}], "}"}], 
             "\[Rule]", " ", 
             RowBox[{"SSHq2", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"\[Theta]", "[", 
                RowBox[{"[", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"i", "<", "n"}], ",", 
                   RowBox[{"i", "+", "1"}], ",", "1"}], "]"}], "]"}], "]"}], 
               ",", "r"}], "]"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "n"}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"klodesystemgenparams3", "[", 
   RowBox[{
   "n_", ",", "thetadynamic_", ",", "M_", ",", "r_", ",", "k_", ",", "th0_"}],
    "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "M"}], " ", 
      SuperscriptBox["r", 
       RowBox[{"2", " "}]], 
      RowBox[{
       RowBox[{
        RowBox[{"thetadynamic", "[", "i", "]"}], "''"}], "[", "t", "]"}]}], 
     "\[Equal]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"torque", " ", "from", " ", "ahead"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", "<", "n"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", "i", "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "r"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], "-", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}]}], "]"}]}], 
           "+", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "+", "1"}], "]"}], "[", "t", "]"}], ",", "r"}], 
             "]"}]]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", "i", "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "r"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], "-", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", "1", "]"}], "[", "t", "]"}]}], 
             "]"}]}], "+", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", "1", "]"}], "[", "t", "]"}], ",", 
              "r"}], "]"}]]}], ")"}]}]}], "]"}], "+", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"torque", " ", "from", " ", "behind"}], " ", "*)"}], 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"i", ">", "1"}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", 
           RowBox[{"i", "-", "1"}], "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], "-", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}]}], 
             "]"}]}], "-", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", "-", "1"}], "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", 
                RowBox[{"i", "-", "1"}], "]"}], "[", "t", "]"}], ",", 
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              "r"}], "]"}]]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"k", "[", "n", "]"}]}], " ", "r", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", " ", 
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "n", "]"}], "[", "t", "]"}], "-", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}]}], 
             "]"}]}], "-", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], 
            "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"llist", "[", "num", "]"}], "[", 
             RowBox[{"[", "n", "]"}], "]"}], 
            RowBox[{"l", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"thetadynamic", "[", "n", "]"}], "[", "t", "]"}], ",", 
              
              RowBox[{
               RowBox[{"thetadynamic", "[", "i", "]"}], "[", "t", "]"}], ",", 
              "r"}], "]"}]]}], ")"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
    ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"klchainmd3", "[", 
    RowBox[{
    "num_", ",", "tmax_", ",", "M_", ",", "k_", ",", "r_", ",", "th0_", ",", 
     "initial_", ",", "v_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"thetadynamic", ",", "ans"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "num"}], "}"}]}], "]"}], "/.", 
       RowBox[{
        RowBox[{"NDSolve", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"klodesystemgenparams3", "[", 
             RowBox[{
             "num", ",", "thetadynamic", ",", "M", ",", "r", ",", "k", ",", 
              "th0"}], "]"}], ",", 
            RowBox[{"initialklgen", "[", 
             RowBox[{"num", ",", "initial", ",", "v", ",", "thetadynamic"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"thetadynamic", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "0", ",", "tmax"}], "}"}], ",", 
          RowBox[{"MaxSteps", "\[Rule]", "Infinity"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"End", " ", "PBC"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tencoef", "[", 
    RowBox[{"i_", ",", "j_", ",", "\[Theta]_"}], "]"}], ":=", 
   RowBox[{"Which", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"i", "-", "j"}], "]"}], "\[Equal]", "1"}], ",", 
     RowBox[{"1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"]}]]]}], ",", 
     RowBox[{"i", "\[Equal]", "j"}], ",", 
     RowBox[{"1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "-", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
           ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}], "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "-", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
           ")"}], "2"]}]]], "+", "1", "-", 
      FractionBox["lzero", 
       SqrtBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            "-", 
            RowBox[{"r", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
               RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
            "-", 
            RowBox[{"r", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{
              "\[Theta]", "\[LeftDoubleBracket]", "i", 
               "\[RightDoubleBracket]"}], "]"}]}]}], ")"}], "2"]}]]]}], ",", 
     "True", ",", "0"}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"j", ">", "i"}], ",", " ", 
    RowBox[{"j", " ", "at", " ", "right", " ", "of", " ", "i"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Prestressed", " ", "dynamical", " ", "matrix", " ", "calculation"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ghat", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"kk", "[", "p", "]"}], 
   RowBox[{"lzero", "/", 
    RowBox[{"Norm", "[", 
     RowBox[{"ll", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"ll", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "+", 
     RowBox[{"r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
        RowBox[{"p", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], "-", 
     RowBox[{"r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
       "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "\[LeftDoubleBracket]", 
        RowBox[{"p", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], "-", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{
       "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "]"}]}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"vv", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Sin", "[", 
      RowBox[{
      "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
      "]"}]}], ",", 
    RowBox[{"Cos", "[", 
     RowBox[{
     "\[Theta]", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
     "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"tension", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"kk", "[", "p", "]"}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Norm", "[", 
       RowBox[{"ll", "[", 
        RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}], "-", "lzero"}], ")"}], 
    "/", 
    RowBox[{"Norm", "[", 
     RowBox[{"ll", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"aa", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"p", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"vv", "[", 
           RowBox[{"p", ",", "\[Theta]"}], "]"}], ".", 
          RowBox[{"ll", "[", 
           RowBox[{"p", ",", "\[Theta]"}], "]"}]}]}], "/", 
        RowBox[{"Norm", "[", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p", "+", "1"}], ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{
        RowBox[{
         RowBox[{"vv", "[", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", "\[Theta]"}], "]"}], ".", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}]}], "/", 
        RowBox[{"Norm", "[", 
         RowBox[{"ll", "[", 
          RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"num", ",", "1"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Kp", "[", "\[Theta]_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ghat", "[", 
      RowBox[{"p", ",", "\[Theta]"}], "]"}], 
     RowBox[{"KroneckerProduct", "[", 
      RowBox[{
       RowBox[{"aa", "[", 
        RowBox[{"p", ",", "\[Theta]"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"aa", "[", 
         RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"p", ",", "1", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"S", "[", 
   RowBox[{"p_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"p", ",", "p"}], "}"}], "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"vv", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}], ".", 
             RowBox[{"ll", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
            RowBox[{
            "\[Theta]\[Theta]", "\[LeftDoubleBracket]", "pp", 
             "\[RightDoubleBracket]"}]}], "]"}]}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"p", ",", 
           RowBox[{"p", "+", "1"}]}], "}"}], "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"vv", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}], ".", 
             RowBox[{"ll", "[", 
              RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
            RowBox[{"\[Theta]\[Theta]", "\[LeftDoubleBracket]", 
             RowBox[{"pp", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}],
         "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", "p"}], "}"}], "\[Rule]", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"vv", "[", 
             RowBox[{
              RowBox[{"pp", "+", "1"}], ",", "\[Theta]\[Theta]"}], "]"}], ".", 
            RowBox[{"ll", "[", 
             RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
           RowBox[{
           "\[Theta]\[Theta]", "\[LeftDoubleBracket]", "pp", 
            "\[RightDoubleBracket]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"p", "+", "1"}], ",", 
           RowBox[{"p", "+", "1"}]}], "}"}], "\[Rule]", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"vv", "[", 
             RowBox[{
              RowBox[{"pp", "+", "1"}], ",", "\[Theta]\[Theta]"}], "]"}], ".", 
            RowBox[{"ll", "[", 
             RowBox[{"pp", ",", "\[Theta]\[Theta]"}], "]"}]}], ",", 
           RowBox[{"\[Theta]\[Theta]", "\[LeftDoubleBracket]", 
            RowBox[{"pp", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Theta]\[Theta]", "\[Rule]", "\[Theta]"}], ",", 
          RowBox[{"pp", "\[Rule]", "p"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"num", ",", "num"}], "}"}]}], "]"}], "*", 
   RowBox[{
    RowBox[{"tension", "[", 
     RowBox[{"p", ",", "\[Theta]"}], "]"}], "/", "r"}]}]}], "\n", 
 RowBox[{
  RowBox[{"DMat", "[", "\[Theta]_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Kp", "[", "\[Theta]", "]"}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Quiet", "[", 
      RowBox[{"S", "[", 
       RowBox[{"p", ",", "\[Theta]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "1", ",", 
       RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.618150538987588*^9, 3.618150547169888*^9}, {
   3.618150779637478*^9, 3.618150832279482*^9}, {3.618150932245859*^9, 
   3.61815097596342*^9}, {3.61815104373564*^9, 3.618151060436997*^9}, {
   3.6181514145632267`*^9, 3.618151414954941*^9}, {3.618151484123447*^9, 
   3.618151515046277*^9}, {3.6182271607461357`*^9, 3.618227216472021*^9}, {
   3.618227265295611*^9, 3.618227265849666*^9}, {3.6182280764987803`*^9, 
   3.618228081401866*^9}, {3.618228113923439*^9, 3.6182281193606577`*^9}, {
   3.6182281803271503`*^9, 3.618228249300583*^9}, {3.618228342726098*^9, 
   3.6182283435898247`*^9}, {3.6182284741107187`*^9, 3.618228474241713*^9}, 
   3.6182285734116287`*^9, {3.618228654639407*^9, 3.618228654745113*^9}, {
   3.61856261599337*^9, 3.6185626195306787`*^9}, {3.618571365841371*^9, 
   3.618571367549428*^9}, 3.618571418811494*^9, {3.618571448846992*^9, 
   3.618571493234602*^9}, {3.618571575841247*^9, 3.618571903339575*^9}, {
   3.6185721369645777`*^9, 3.618572148227907*^9}, {3.618647114038393*^9, 
   3.618647116731336*^9}, {3.618647324321237*^9, 3.6186473466247187`*^9}, {
   3.618647817599999*^9, 3.61864786323519*^9}, {3.6186480056050034`*^9, 
   3.6186480077363033`*^9}, {3.618648068705531*^9, 3.618648083755763*^9}, {
   3.618648195170536*^9, 3.61864821051621*^9}, {3.618649157248595*^9, 
   3.618649157976111*^9}, {3.6186497991829357`*^9, 3.618649819780326*^9}, 
   3.6187569485390368`*^9, 3.6187573278434277`*^9, 3.618834677692775*^9, {
   3.623069441682617*^9, 3.623069467916896*^9}, {3.623070045627194*^9, 
   3.623070061087813*^9}, {3.6230700971705437`*^9, 3.6230701673260717`*^9}, {
   3.623073904287218*^9, 3.6230739099103003`*^9}, {3.624289365803486*^9, 
   3.6242894417539053`*^9}, {3.6242895136375647`*^9, 3.624289513945546*^9}, 
   3.624289963925722*^9, {3.624290040568718*^9, 3.624290053264291*^9}, {
   3.624292193400117*^9, 3.624292198593955*^9}, {3.624294596977466*^9, 
   3.624294720195092*^9}, {3.6242948237127447`*^9, 3.624294932608865*^9}, {
   3.624294963984165*^9, 3.62429522657948*^9}, {3.624295272703333*^9, 
   3.6242952830205793`*^9}, 3.633074870875313*^9, {3.633088325821828*^9, 
   3.63308833085747*^9}, {3.633088368404194*^9, 3.6330883906255293`*^9}, {
   3.633088573539197*^9, 3.633088624563891*^9}, {3.633088659921361*^9, 
   3.633088705283955*^9}, 3.633088800455364*^9, {3.633088864220337*^9, 
   3.6330888698302507`*^9}, 3.633088911091866*^9, {3.633089094481065*^9, 
   3.6330891003475533`*^9}, {3.633089161898232*^9, 3.633089193065423*^9}, {
   3.63308923233589*^9, 3.63308929830764*^9}, 3.633089333216228*^9, {
   3.633100412976595*^9, 3.633100463898243*^9}, {3.633100519029953*^9, 
   3.633100526529237*^9}, {3.633101299955513*^9, 3.633101300392415*^9}, {
   3.6331018137843447`*^9, 3.633101813958029*^9}, {3.633101871660501*^9, 
   3.6331018719629183`*^9}, {3.633101917846643*^9, 3.633101943701149*^9}, {
   3.633102027415921*^9, 3.633102028840218*^9}, {3.633102120427668*^9, 
   3.633102121123929*^9}, 3.633102232639926*^9, {3.64094746299193*^9, 
   3.640947463364471*^9}, {3.640947564495137*^9, 3.6409475741238813`*^9}, 
   3.640951379758491*^9, {3.6452727825849333`*^9, 3.645272822920856*^9}, {
   3.645272878021719*^9, 3.6452728802936974`*^9}, {3.645273004698082*^9, 
   3.645273010602849*^9}, {3.645273984643609*^9, 3.645274078303241*^9}, 
   3.645274148630378*^9, {3.645274773844715*^9, 3.645274837966695*^9}, 
   3.645274869770154*^9, {3.645274902136812*^9, 3.645274959583123*^9}, {
   3.645274998605528*^9, 3.64527503187894*^9}, {3.645275067538681*^9, 
   3.64527507619352*^9}, {3.645275250296976*^9, 3.645275294734951*^9}, {
   3.645275589488284*^9, 3.645275652785528*^9}, {3.645275882975909*^9, 
   3.645275909678774*^9}, {3.645275970406087*^9, 3.64527605790648*^9}, {
   3.645276111268532*^9, 3.645276201812639*^9}, {3.645276267475964*^9, 
   3.645276326590911*^9}, {3.645276392976386*^9, 3.645276436943709*^9}, {
   3.64527646846441*^9, 3.645276506374337*^9}, {3.6452765640552883`*^9, 
   3.645276565912219*^9}, {3.6452773561520348`*^9, 3.645277368666152*^9}, {
   3.646400497002018*^9, 3.6464004976593513`*^9}, {3.646400553551332*^9, 
   3.646400554073206*^9}, {3.64664062186617*^9, 3.646640637228178*^9}, 
   3.6466412045257053`*^9, {3.647175899283684*^9, 3.647176012386387*^9}, {
   3.647176148206756*^9, 3.647176163175846*^9}, 3.6477733675605497`*^9, {
   3.651387603949565*^9, 3.6513876048374166`*^9}, {3.651387691413843*^9, 
   3.651387701388337*^9}, {3.651387842571313*^9, 3.651387845902524*^9}, {
   3.651387970043507*^9, 3.6513879757588663`*^9}, {3.651390783531636*^9, 
   3.651390792802196*^9}, {3.651390902564404*^9, 3.651390921145104*^9}, {
   3.6513912138769073`*^9, 3.651391215610052*^9}, {3.651393119992619*^9, 
   3.651393133431178*^9}, {3.651393919139061*^9, 3.651393920072609*^9}, {
   3.651490944742693*^9, 3.651491017134418*^9}, 3.651559934192185*^9, {
   3.651560542279643*^9, 3.651560553850471*^9}, {3.709201047424562*^9, 
   3.709201050681131*^9}, {3.709201152114373*^9, 3.709201163617364*^9}, {
   3.709201225394537*^9, 3.709201239475458*^9}, {3.7092069153693333`*^9, 
   3.709206940218092*^9}, {3.709207249338373*^9, 3.709207367087947*^9}, {
   3.709208175344832*^9, 3.7092081759567623`*^9}, {3.709208227882373*^9, 
   3.709208228285221*^9}, {3.709208281582568*^9, 3.7092083587375183`*^9}, {
   3.709208433713002*^9, 3.709208436387177*^9}, 3.709208467330985*^9, {
   3.70920856789163*^9, 3.709208577847171*^9}, 3.709208764290653*^9, {
   3.709209897371625*^9, 3.709209976762801*^9}, {3.709233922796916*^9, 
   3.709233998416409*^9}, {3.7092340304611807`*^9, 3.709234279119997*^9}, {
   3.709234356001405*^9, 3.7092344778774347`*^9}, {3.709234663804867*^9, 
   3.70923468409334*^9}, 3.709234865818417*^9, {3.7092350099732122`*^9, 
   3.709235024778145*^9}, {3.709235057002833*^9, 3.70923506611701*^9}, {
   3.709235100689011*^9, 3.709235154663856*^9}, {3.7092352332415*^9, 
   3.709235265046751*^9}, {3.709235321817869*^9, 3.7092353223114433`*^9}, {
   3.709235360488781*^9, 3.709235368856537*^9}, {3.709235444204751*^9, 
   3.709235462537691*^9}, {3.709235540028523*^9, 3.709235639542454*^9}, {
   3.709235756297443*^9, 3.709235880031089*^9}, {3.709235921322946*^9, 
   3.709235953204718*^9}, 3.709235998052895*^9, {3.709236087842309*^9, 
   3.709236110781096*^9}, {3.709236179874861*^9, 3.709236257472804*^9}, 
   3.70923630940458*^9, {3.709236369420107*^9, 3.709236421231119*^9}, {
   3.7092365518430567`*^9, 3.7092365574944553`*^9}, {3.709236617409546*^9, 
   3.709236701514407*^9}, {3.7092367392824383`*^9, 3.7092367983124866`*^9}, {
   3.709236975990656*^9, 3.70923701895269*^9}, 3.709237133597952*^9, {
   3.709237216826818*^9, 3.709237234341*^9}, {3.709237289970338*^9, 
   3.709237311478465*^9}, {3.7092374020890217`*^9, 3.709237408028508*^9}, {
   3.709237524680915*^9, 3.709237704075295*^9}, 3.70923774169601*^9, {
   3.709237807583799*^9, 3.709237824173324*^9}, {3.709237895702497*^9, 
   3.709237896084407*^9}, {3.70923793377503*^9, 3.709237974826704*^9}, {
   3.7092380474923964`*^9, 3.709238103170498*^9}, {3.709238164982992*^9, 
   3.709238167565392*^9}, {3.709238199933289*^9, 3.709238300789957*^9}, {
   3.709238375879142*^9, 3.709238496257636*^9}, {3.709238966311185*^9, 
   3.709239000043751*^9}, {3.709239074444016*^9, 3.709239075584194*^9}, {
   3.709239107714533*^9, 3.709239127380085*^9}, {3.70923918481406*^9, 
   3.709239206224411*^9}},ExpressionUUID->"66d31ba8-5800-4165-9cdf-\
42f73a5cb2ee"]
}, Closed]],

Cell[CellGroupData[{

Cell["configuration parameters", "Subsubsection",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, {
   3.633107849053135*^9, 
   3.633107856688933*^9}},ExpressionUUID->"b9dc5cf4-4351-4cc7-84cb-\
ccdd7df53ecf"],

Cell[BoxData[{
 RowBox[{"configSetup", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"num", "=", "6"}], ";", "\[IndentingNewLine]", 
    RowBox[{"a", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{"r", "=", "0.8"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<th0=\>\"", ",", 
        RowBox[{"th0", "=", 
         RowBox[{"N", "[", 
          RowBox[{"ArcSin", "[", 
           RowBox[{"a", "/", 
            RowBox[{"(", 
             RowBox[{"2", "r"}], ")"}]}], "]"}], "]"}]}]}], "]"}], ";"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<th0=\>\"", ",", 
      RowBox[{"th0", "=", "0.15"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lzerosq", "=", 
     RowBox[{
      SuperscriptBox["a", "2"], "+", 
      RowBox[{"4", 
       SuperscriptBox["r", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<lzero=\>\"", ",", 
      RowBox[{"lzero", "=", 
       SuperscriptBox["lzerosq", 
        RowBox[{"1", "/", "2"}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"th", "[", "i", "]"}], "=", "th0"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"kk", "[", "i", "]"}], "=", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ";"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"configSetup", ";"}]}], "Input",
 CellChangeTimes->{{3.616922077073403*^9, 3.616922097707636*^9}, {
   3.6169223953281727`*^9, 3.6169223996158752`*^9}, {3.616923014019743*^9, 
   3.616923014558481*^9}, 3.6169231210457172`*^9, {3.616923162275593*^9, 
   3.616923177058527*^9}, 3.616923306245955*^9, 3.6169233382167807`*^9, {
   3.6169238107105417`*^9, 3.616923829253536*^9}, 3.616925443080332*^9, 
   3.616925758922092*^9, 3.61692600083519*^9, {3.616926336461362*^9, 
   3.616926366433922*^9}, {3.6169267184532213`*^9, 3.61692680858429*^9}, {
   3.616926840343959*^9, 3.6169268741095057`*^9}, {3.61699708370796*^9, 
   3.616997085531124*^9}, 3.616997451140321*^9, {3.618149988118775*^9, 
   3.6181499898124523`*^9}, 3.6181501330748873`*^9, 3.61864961658869*^9, {
   3.619844406752118*^9, 3.619844408085453*^9}, {3.624201313338982*^9, 
   3.624201332712708*^9}, {3.6242014409076147`*^9, 3.624201441212879*^9}, {
   3.624202982419248*^9, 3.624202984031165*^9}, {3.624203112507936*^9, 
   3.6242031131529903`*^9}, {3.6330693944332314`*^9, 3.633069394882943*^9}, {
   3.6330694469935293`*^9, 3.6330694558575897`*^9}, {3.633069770021536*^9, 
   3.633069772690402*^9}, {3.633072362260166*^9, 3.633072406133362*^9}, {
   3.633072565851337*^9, 3.633072568729616*^9}, {3.633072605338372*^9, 
   3.633072721753525*^9}, {3.633072760620229*^9, 3.63307277243394*^9}, 
   3.633107849053135*^9, {3.637407083259329*^9, 3.6374070894662447`*^9}, 
   3.637410352773985*^9, 3.6374104123369713`*^9, {3.637573280481956*^9, 
   3.637573286949544*^9}, {3.637925767095634*^9, 3.637925767605172*^9}, 
   3.6379260754958897`*^9, {3.637926364749819*^9, 3.6379263660214777`*^9}, 
   3.6380028150144978`*^9, {3.6380089065901012`*^9, 3.638008912817968*^9}, {
   3.6380141868243513`*^9, 3.638014211197712*^9}, {3.709207684101407*^9, 
   3.709207684291337*^9}, {3.709207740910933*^9, 3.709207742495884*^9}, {
   3.709207814106386*^9, 3.709207876134736*^9}, {3.7092080122054*^9, 
   3.709208045076769*^9}, 3.7092132793304234`*^9, {3.709213359765005*^9, 
   3.7092133740354967`*^9}, {3.7092134434864492`*^9, 3.70921344356564*^9}, {
   3.709217932046255*^9, 3.709217986519755*^9}, {3.709218043686131*^9, 
   3.709218051812087*^9}, {3.709222264646462*^9, 3.709222282933836*^9}, 
   3.709222436728342*^9, {3.7092224815586567`*^9, 3.709222495764564*^9}, {
   3.709223964697832*^9, 3.70922396835389*^9}, {3.709226842358053*^9, 
   3.7092268479134293`*^9}, 3.709227408852805*^9, {3.709232200988229*^9, 
   3.709232207066243*^9}, {3.7092337588552837`*^9, 3.709233783733386*^9}, {
   3.709234529996543*^9, 3.709234532244618*^9}, 3.709280479695341*^9, {
   3.709280513389599*^9, 3.7092805299459047`*^9}, {3.709280605062189*^9, 
   3.7092806352817698`*^9}},ExpressionUUID->"6fde6fae-d5f7-4ca9-9b9d-\
b98f1e6019a6"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert initial angles for simulation", "Subsubsection",
 CellChangeTimes->{{3.709207882599366*^9, 
  3.709207887221005*^9}},ExpressionUUID->"c7c2a500-2a7e-4338-bd9d-\
da00cb0f3169"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"initialize", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"initial", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"True", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"th", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", "2"}], "]"}], "\[Equal]", "0"}], ",", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "+", 
             RowBox[{"th", "[", "i", "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"th", "[", "i", "]"}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"initialold", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Pi]", "/", "2"}], "-", 
         RowBox[{"initial", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "num"}], "}"}]}], "]"}]}], ";"}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"initialize", ";"}]}], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071244228053*^9}, 3.6331077790336437`*^9, {
   3.709234553804058*^9, 3.70923456159354*^9}, {3.7092354975713987`*^9, 
   3.7092355003093557`*^9}},ExpressionUUID->"78e41ef3-7068-4f24-a8f6-\
e79da4526da2"]
}, Closed]],

Cell[CellGroupData[{

Cell["Cal. Rigidity matrix and Plot configuration", "Subsubsection",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107770228497*^9}, {3.70922239426642*^9, 
   3.709222394615633*^9}, {3.7092312039089403`*^9, 
   3.7092312132833242`*^9}},ExpressionUUID->"71c61f55-294e-42ce-ad9a-\
338c403b10ca"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"calRig", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rigidityMatrix", "=", 
      RowBox[{"MakeSSHrig3", "[", 
       RowBox[{"initialold", ",", "r"}], "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"es", "=", 
      RowBox[{"Eigensystem", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", "rigidityMatrix", "]"}], ".", 
        "rigidityMatrix"}], "]"}]}]}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"calRig", ";"}]}], "Input",
 CellChangeTimes->{{3.709213267947095*^9, 3.709213273451138*^9}, {
  3.709213718416363*^9, 3.7092137568547907`*^9}, {3.7092345787761717`*^9, 
  3.709234609384676*^9}, {3.709235506146044*^9, 
  3.7092355080987587`*^9}},ExpressionUUID->"b2561b57-cc3a-4635-8e57-\
ac79bba8da9c"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"initConfig", "=", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"MakeSSHpicVec", "[", 
       RowBox[{"initialold", ",", "r", ",", 
        RowBox[{"2", 
         RowBox[{"es", "\[LeftDoubleBracket]", 
          RowBox[{"2", ",", "i"}], "\[RightDoubleBracket]"}]}]}], "]"}], ",", 
      
      RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "num"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.633069384281125*^9, 3.633069434914277*^9}, {
   3.633069481093483*^9, 3.6330694895968857`*^9}, {3.633069723115589*^9, 
   3.6330697274715023`*^9}, {3.6330700881296377`*^9, 3.633070094088673*^9}, {
   3.633071209346878*^9, 3.633071213374419*^9}, 3.633072906884775*^9, {
   3.633107758305635*^9, 3.633107761028719*^9}, {3.635240983605139*^9, 
   3.6352409903117447`*^9}, {3.709207995709407*^9, 3.7092080023326283`*^9}, {
   3.709208055240082*^9, 3.709208109603163*^9}, {3.709208202142592*^9, 
   3.709208206028987*^9}, {3.709213417247752*^9, 3.7092134843315783`*^9}, {
   3.709227420242001*^9, 3.7092274228032713`*^9}, 
   3.709231269744697*^9},ExpressionUUID->"c6b031ae-5e7e-472f-9361-\
5ef8e93507d4"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Export", "[", 
   RowBox[{"\"\<config.png\>\"", ",", "initConfig", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1500"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.624296974272217*^9, 3.624297018481681*^9}, 
   3.62429706768184*^9, 3.624297555150257*^9, {3.624299975096236*^9, 
   3.624299975182521*^9}, 3.6330797515298634`*^9, {3.6330853954542303`*^9, 
   3.633085397354917*^9}, 3.63308584074352*^9, 3.6330860514036617`*^9, {
   3.6331142892173443`*^9, 3.6331142893629417`*^9}, {3.633114393807089*^9, 
   3.633114394400502*^9}, {3.6331145255268297`*^9, 3.633114526376912*^9}, 
   3.6351592919499807`*^9, 3.63516307590872*^9, 3.6351631322939167`*^9, {
   3.635241029207752*^9, 3.635241040077496*^9}, {3.6352410716199837`*^9, 
   3.6352410811780977`*^9}},ExpressionUUID->"3402e35f-09a7-436a-823a-\
46d572d24569"],

Cell["positive", "Text",
 CellChangeTimes->{{3.709234513788794*^9, 3.709234514860265*^9}},
 FontColor->RGBColor[
  1, 0, 0],ExpressionUUID->"48f78a95-e11f-43eb-8d38-c7b5aa119259"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "i", "]"}], "=", "th0"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"initialize", ";"}]}], "Input",
 CellChangeTimes->{{3.709234568857217*^9, 3.709234571240711*^9}, {
   3.7092346171564827`*^9, 3.7092346206292877`*^9}, {3.709234701791953*^9, 
   3.709234778873321*^9}, {3.7092351825562363`*^9, 3.709235184812052*^9}, {
   3.7092356214977303`*^9, 3.709235621754384*^9}, {3.709236434942463*^9, 
   3.709236502745175*^9}, {3.709237758169591*^9, 3.709237758264524*^9}, {
   3.709238014182705*^9, 3.70923803453491*^9}, 3.7092385303848343`*^9, {
   3.709238985294368*^9, 3.709238990043994*^9}, {3.709280383957288*^9, 
   3.709280392628333*^9}, 
   3.709280487501603*^9},ExpressionUUID->"c20da155-90fe-4765-802b-\
fbd572d0b922"],

Cell[BoxData[{
 RowBox[{"calRig", ";"}], "\[IndentingNewLine]", 
 RowBox[{"configPositiveMass", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVecMass", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{"es", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"2", 
       RowBox[{"rigidityMatrix", ".", 
        RowBox[{"es", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"configPositiveBond", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVecBond", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{"es", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"2", 
       RowBox[{"rigidityMatrix", ".", 
        RowBox[{"es", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.709234568857217*^9, 3.709234571240711*^9}, {
   3.7092346171564827`*^9, 3.7092346206292877`*^9}, {3.709234701791953*^9, 
   3.709234778873321*^9}, {3.7092351825562363`*^9, 3.709235184812052*^9}, {
   3.7092356214977303`*^9, 3.709235621754384*^9}, {3.709236434942463*^9, 
   3.709236502745175*^9}, {3.709237758169591*^9, 3.709237758264524*^9}, {
   3.709238014182705*^9, 3.70923803453491*^9}, 3.7092385303848343`*^9, {
   3.709238985294368*^9, 3.709238990043994*^9}, {3.709280383957288*^9, 
   3.709280392628333*^9}, 
   3.709280487501603*^9},ExpressionUUID->"39f740c3-24fa-4819-a903-\
a1aee6d7d58f"],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configPositiveMass.pdf\>\"", ",", "configPositiveMass", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configPositiveBond.pdf\>\"", ",", "configPositiveBond", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.709234568857217*^9, 3.709234571240711*^9}, {
  3.7092346171564827`*^9, 3.7092346206292877`*^9}, {3.709234701791953*^9, 
  3.7092347640599833`*^9}},ExpressionUUID->"779ac48b-8cd0-4266-9e2b-\
159e7cc7209f"],

Cell["And an intro figure", "Text",
 CellChangeTimes->{{3.709280402279223*^9, 3.709280420657008*^9}},
 FontColor->RGBColor[
  0, 0, 1],ExpressionUUID->"a796d099-7af2-466b-89c5-b2c0706b7a1f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "i", "]"}], "=", "1."}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"initialize", ";"}], "\n", 
 RowBox[{"configIntroPos", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVec", "[", 
     RowBox[{"initialold", ",", "1", ",", "0"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.70928065427114*^9, 3.709280714283924*^9}, {
  3.709280906141243*^9, 3.70928092399539*^9}, {3.709283596353712*^9, 
  3.709283596656921*^9}},ExpressionUUID->"2781dc7c-169d-42de-862b-\
eab6ac6b1f77"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "i", "]"}], "=", 
     RowBox[{"-", "1."}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"initialize", ";"}], "\n", 
 RowBox[{"configIntroNeg", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVec", "[", 
     RowBox[{"initialold", ",", "1", ",", "0"}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.709280992848171*^9, {3.709283599968351*^9, 
   3.70928360033571*^9}},ExpressionUUID->"ca1f0f32-7902-40ed-9438-\
e71c6fabb53e"],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configIntroPos.pdf\>\"", ",", "configIntroPos", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configIntroNeg.pdf\>\"", ",", "configIntroNeg", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.709283607617094*^9, 
  3.709283632412321*^9}},ExpressionUUID->"7f80030c-38e9-4d52-bba0-\
53f5edeb82a3"],

Cell["negative", "Text",
 CellChangeTimes->{{3.709234513788794*^9, 3.709234514860265*^9}, {
  3.709239504439714*^9, 3.709239506004552*^9}},
 FontColor->RGBColor[
  1, 0, 0],ExpressionUUID->"bae1250a-dd53-4b09-8010-f85d795ef48f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"th", "[", "i", "]"}], "=", 
     RowBox[{"-", "th0"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"initialize", ";"}], "\[IndentingNewLine]", 
 RowBox[{"calRig", ";"}], "\[IndentingNewLine]", 
 RowBox[{"configNegativeMass", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVecMass", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{"es", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"2", 
       RowBox[{"rigidityMatrix", ".", 
        RowBox[{"es", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"configNegativeBond", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"MakeSSHpicVecBond", "[", 
     RowBox[{"initialold", ",", "r", ",", 
      RowBox[{"2", 
       RowBox[{"es", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"2", 
       RowBox[{"rigidityMatrix", ".", 
        RowBox[{"es", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.709234568857217*^9, 3.709234571240711*^9}, {
   3.7092346171564827`*^9, 3.7092346206292877`*^9}, {3.709234701791953*^9, 
   3.709234778873321*^9}, {3.7092351825562363`*^9, 3.709235184812052*^9}, {
   3.7092356214977303`*^9, 3.709235621754384*^9}, {3.709236434942463*^9, 
   3.709236502745175*^9}, {3.709237758169591*^9, 3.709237758264524*^9}, {
   3.709238014182705*^9, 3.70923803453491*^9}, 3.7092385303848343`*^9, {
   3.709238985294368*^9, 3.709238990043994*^9}, {3.7092395097659492`*^9, 
   3.709239516884905*^9}, {3.7092396237107153`*^9, 3.709239624717533*^9}, {
   3.709239684508679*^9, 
   3.709239686249161*^9}},ExpressionUUID->"e60a935e-e405-4ba3-a71d-\
16a6ab1e279c"],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configNegativeMass.pdf\>\"", ",", "configNegativeMass", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<configNegativeBond.pdf\>\"", ",", "configNegativeBond", ",", 
   RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.709234568857217*^9, 3.709234571240711*^9}, {
  3.7092346171564827`*^9, 3.7092346206292877`*^9}, {3.709234701791953*^9, 
  3.7092347640599833`*^9}, {3.7092397002152433`*^9, 
  3.7092397228592873`*^9}},ExpressionUUID->"636f3661-0eb6-4b32-ba68-\
c0e1e0a9c6a3"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.709233734582796*^9, 
  3.709234721441031*^9},ExpressionUUID->"dd0457ad-20d9-4a44-b6cb-\
39af7eb49315"],

Cell[BoxData[
 RowBox[{"signTable", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"EvenQ", "[", "i", "]"}], ",", "1", ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "num"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.709227689636784*^9, 3.709227783335917*^9}, 
   3.709231549501974*^9},ExpressionUUID->"4e82bfdf-cf76-4d6c-a3fd-\
60564c683b93"],

Cell[BoxData["es"], "Input",
 CellChangeTimes->{{3.709228663062148*^9, 
  3.709228663213318*^9}},ExpressionUUID->"f32afb44-a44e-416f-a68c-\
13df1d6f4359"],

Cell[BoxData[
 RowBox[{"modeA", "=", 
  RowBox[{"es", "\[LeftDoubleBracket]", 
   RowBox[{"2", ",", "6"}], "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{{3.709231246700769*^9, 3.709231248945437*^9}, {
   3.7092312998395023`*^9, 3.709231350314365*^9}, {3.709231390552725*^9, 
   3.709231395367415*^9}, 
   3.709231552351152*^9},ExpressionUUID->"bf029ae9-ef73-457f-8624-\
84090f6d6886"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"signTable", "*", "modeA"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
     "The", " ", "convention", " ", "is", " ", "all", " ", "rotor", " ", 
      "angles", " ", "measured", " ", "from", " ", "positive", " ", "y"}], 
     "-", "axis"}], ",", " ", 
    RowBox[{"so", " ", "need", " ", "to", " ", "revert", " ", "sign"}]}], 
   "*)"}]}], "\n", 
 RowBox[{"rigidityMatrix", ".", "modeA", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "while", " ", "the", " ", "rigidity", " ", "matrix", " ", "give", " ", 
     "the", " ", "correct", " ", "spring", " ", "extension"}], ",", " ", 
    RowBox[{
     RowBox[{"given", " ", "the", " ", "original"}], "-", 
     RowBox[{"convention", " ", "mode"}]}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7092313996067657`*^9, 
  3.709231523902136*^9}},ExpressionUUID->"c8ba9c58-2b6a-4c25-9471-\
0f88a9935d4a"],

Cell[BoxData[
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"signTable", "*", 
        RowBox[{"es", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "i"}], " ", "\[RightDoubleBracket]"}]}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.2"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "num"}], "}"}]}], "]"}], ",", 
   RowBox[{"Frame", "\[Rule]", "All"}], ",", 
   RowBox[{"ItemSize", "\[Rule]", "Full"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.709227447231638*^9, 3.709227479598415*^9}, {
  3.7092275102857647`*^9, 3.7092275674623957`*^9}, {3.709227636836973*^9, 
  3.709227641798012*^9}, {3.709227779016533*^9, 
  3.709227779415523*^9}},ExpressionUUID->"29d88fb7-4bb8-4488-b296-\
694e66681c30"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"es", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "i"}], " ", "\[RightDoubleBracket]"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.2"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.4"}], ",", "0.4"}], "}"}]}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"amp", " ", 
        RowBox[{"Sin", "[", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", " ", 
             RowBox[{"Pi", "/", "num"}]}], ")"}], " ", "k", " ", "x"}], "-", 
          "phi"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "2"}], "}"}], ",", "1", ",", "num", ",", "1"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "0", ",", "num", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"amp", ",", "0.25"}], "}"}], ",", "0", ",", "0.5", ",", 
     "0.01"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"phi", ",", "0", ",", 
     RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7092153115486593`*^9, 3.709215492868596*^9}, {
  3.7092155436501923`*^9, 3.7092155849462433`*^9}, {3.7092156165878897`*^9, 
  3.70921561690709*^9}, {3.709215661689662*^9, 3.7092156944254513`*^9}, {
  3.709216062762978*^9, 3.709216122587381*^9}, {3.7092161688833113`*^9, 
  3.709216260267477*^9}},ExpressionUUID->"5b6a98a1-d3f8-473b-8b35-\
c997794f72a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["TopoMech", "Subsubsection",
 CellChangeTimes->{{3.709217643857643*^9, 
  3.709217650889861*^9}},ExpressionUUID->"df49d51f-9345-4749-aed7-\
192fcaf28033"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", 
  RowBox[{"c1", ",", "c2", ",", "cq"}], "]"}]], "Input",
 CellChangeTimes->{{3.709217992919139*^9, 
  3.709218005413704*^9}},ExpressionUUID->"53898464-dfe8-466c-a471-\
da8b9b5eea8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c1", ":=", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", "r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "r", " ", 
      RowBox[{"Cos", "[", "th0", "]"}]}], 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       RowBox[{"4", 
        SuperscriptBox["r", "2"], 
        SuperscriptBox[
         RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]]]}], ";", 
   RowBox[{"c2", ":=", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", 
        RowBox[{"2", "r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "r", " ", 
      RowBox[{"Cos", "[", "th0", "]"}]}], 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       RowBox[{"4", 
        SuperscriptBox["r", "2"], 
        SuperscriptBox[
         RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]]]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "Just", " ", "to", " ", "show", " ", "the", " ", "Lubensky", " ", 
    "definiton"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.7092176398395243`*^9, 3.7092177313585777`*^9}, {
  3.709217969832554*^9, 3.709217971096141*^9}, {3.709231647829406*^9, 
  3.7092316596984663`*^9}},ExpressionUUID->"bf701d83-499d-47a6-82b2-\
62dff5c5fdf1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cq", "[", 
   RowBox[{"q_", ",", "th0_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", "r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "r", " ", 
      RowBox[{"Cos", "[", "th0", "]"}]}], 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       RowBox[{"4", 
        SuperscriptBox["r", "2"], 
        SuperscriptBox[
         RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]]]}], "+", 
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{"I", " ", "q", "*", "1."}], "]"}], 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", 
        RowBox[{"2", "r", " ", 
         RowBox[{"Sin", "[", "th0", "]"}]}]}], ")"}], "r", " ", 
      RowBox[{"Cos", "[", "th0", "]"}]}], 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       RowBox[{"4", 
        SuperscriptBox["r", "2"], 
        SuperscriptBox[
         RowBox[{"Cos", "[", "th0", "]"}], "2"]}]}]]], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Times", " ", "a", " ", "Minus", " ", "sign", " ", "to", " ", "the", 
       " ", "Lubensky", " ", "formula"}], ",", " ", 
      RowBox[{"to", " ", "be", " ", "correct"}]}], "*)"}]}]}]}]], "Input",
 CellChangeTimes->{{3.709217741910315*^9, 3.7092178201643267`*^9}, {
  3.709218148236685*^9, 3.709218161504257*^9}, {3.70922287189532*^9, 
  3.709222873976927*^9}, {3.709223982197104*^9, 3.709223984164784*^9}, {
  3.709224070510311*^9, 3.7092240728301783`*^9}, {3.709231662772242*^9, 
  3.709231745772797*^9}},ExpressionUUID->"9087e846-0f96-481d-9f0c-\
5ece71d4abc5"],

Cell[BoxData[{
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Re", "[", 
        RowBox[{"cq", "[", 
         RowBox[{"q", ",", "th0"}], "]"}], "]"}], ",", 
       RowBox[{"Im", "[", 
        RowBox[{"cq", "[", 
         RowBox[{"q", ",", "th0"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"q", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0.01"}], "}"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Re", "[", 
        RowBox[{"cq", "[", 
         RowBox[{"q", ",", 
          RowBox[{"-", "th0"}]}], "]"}], "]"}], ",", 
       RowBox[{"Im", "[", 
        RowBox[{"cq", "[", 
         RowBox[{"q", ",", 
          RowBox[{"-", "th0"}]}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"q", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0.01"}], "}"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.709225381148809*^9, 
  3.709225384778783*^9}},ExpressionUUID->"8d6d4ba7-ff9d-4114-8cc7-\
d6e0c9eb8326"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cqn", "[", 
   RowBox[{"q_", ",", "th0_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"cq", "[", 
    RowBox[{"q", ",", "th0"}], "]"}], "/", 
   RowBox[{"Abs", "[", 
    RowBox[{"cq", "[", 
     RowBox[{"q", ",", "th0"}], "]"}], "]"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Project", " ", "on", " ", "the", " ", "unit", " ", "circle"}], 
     ",", " ", "Michel"}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.70963289133842*^9, 3.709632942708351*^9}, {
  3.709638164045874*^9, 
  3.709638176958164*^9}},ExpressionUUID->"c05ed77f-61c7-4c06-b32e-\
badc238e539c"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "stylePhi", "]"}]], "Input",
 CellChangeTimes->{{3.7096402371623793`*^9, 
  3.709640241261455*^9}},ExpressionUUID->"428e228a-036e-4976-8fa3-\
eeb27eeab4b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stylePhi", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Re[\!\(\*SuperscriptBox[\(e\), \(i\[Phi] \((k)\)\)]\)]\>\"", 
           ",", "30", ",", 
           RowBox[{
           "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
          "]"}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Im[\!\(\*SuperscriptBox[\(e\), \(i\[Phi] \((k)\)\)]\)]\>\"", 
           ",", "30", ",", 
           RowBox[{
           "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
          "]"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"TicksStyle", "\[Rule]", 
      RowBox[{"Directive", "[", 
       RowBox[{"25", ",", 
        RowBox[{
        "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
       "]"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}]}], "}"}]}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.70963757698802*^9, 3.7096375847305317`*^9}, {
  3.709639775115217*^9, 3.7096397808908043`*^9}, {3.709640097215251*^9, 
  3.709640226206278*^9}, {3.709640289314774*^9, 
  3.7096403261272087`*^9}},ExpressionUUID->"2a2dbb0d-62aa-4140-9270-\
8545947a1dae"],

Cell[BoxData[{
 RowBox[{"phiPos", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Re", "[", 
         RowBox[{"cqn", "[", 
          RowBox[{"q", ",", "th0"}], "]"}], "]"}], ",", 
        RowBox[{"Im", "[", 
         RowBox[{"cqn", "[", 
          RowBox[{"q", ",", "th0"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"q", ",", "0", ",", 
        RowBox[{"2", "\[Pi]"}], ",", "0.001"}], "}"}]}], "]"}], ",", 
    RowBox[{"Evaluate", "[", "stylePhi", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"phiNeg", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Re", "[", 
         RowBox[{"cqn", "[", 
          RowBox[{"q", ",", 
           RowBox[{"-", "th0"}]}], "]"}], "]"}], ",", 
        RowBox[{"Im", "[", 
         RowBox[{"cqn", "[", 
          RowBox[{"q", ",", 
           RowBox[{"-", "th0"}]}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"q", ",", "0", ",", 
        RowBox[{"2", "\[Pi]"}], ",", "0.001"}], "}"}]}], "]"}], ",", 
    RowBox[{"Evaluate", "[", "stylePhi", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7096329654157267`*^9, 3.70963303179821*^9}, {
  3.709637315645418*^9, 3.709637413495576*^9}, {3.70963748197983*^9, 
  3.709637536120509*^9}, {3.709637595135888*^9, 3.709637651738372*^9}, {
  3.709640074382494*^9, 
  3.709640117468802*^9}},ExpressionUUID->"1ea0dc1d-797a-48ee-bac1-\
855cd3ff6a47"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"phiPos", "=", 
    RowBox[{"ContourPlot", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Re", "[", 
           RowBox[{"cqn", "[", 
            RowBox[{"q", ",", "th0"}], "]"}], "]"}], ",", 
          RowBox[{"Im", "[", 
           RowBox[{"cqn", "[", 
            RowBox[{"q", ",", "th0"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"q", ",", "0", ",", 
          RowBox[{"2", "\[Pi]"}], ",", "0.001"}], "}"}]}], "]"}], ",", 
      RowBox[{"Evaluate", "[", "stylePhi", "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"phiNeg", "=", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Re", "[", 
           RowBox[{"cqn", "[", 
            RowBox[{"q", ",", 
             RowBox[{"-", "th0"}]}], "]"}], "]"}], ",", 
          RowBox[{"Im", "[", 
           RowBox[{"cqn", "[", 
            RowBox[{"q", ",", 
             RowBox[{"-", "th0"}]}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"q", ",", "0", ",", 
          RowBox[{"2", "\[Pi]"}], ",", "0.001"}], "}"}]}], "]"}], ",", 
      RowBox[{"Evaluate", "[", "stylePhi", "]"}]}], "]"}]}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.7096329654157267`*^9, 3.70963303179821*^9}, {
  3.709637315645418*^9, 3.709637413495576*^9}, {3.70963748197983*^9, 
  3.709637536120509*^9}, {3.709637595135888*^9, 3.709637651738372*^9}, {
  3.709640074382494*^9, 3.709640117468802*^9}, {3.7096403689982758`*^9, 
  3.7096403877440157`*^9}},ExpressionUUID->"47b8329d-a76a-4e6d-8131-\
6b958b04355d"],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{"\"\<phiPos.pdf\>\"", ",", "phiPos", ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<phiNeg.pdf\>\"", ",", "phiNeg", ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.709636944231934*^9, 3.709636952069422*^9}, {
  3.70963774015486*^9, 
  3.7096377594826603`*^9}},ExpressionUUID->"59f72f52-56a9-4eb8-a2b1-\
968a2407abeb"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Re", "[", 
            RowBox[{"cq", "[", 
             RowBox[{"q", ",", "th0"}], "]"}], "]"}], ",", 
           RowBox[{"Im", "[", 
            RowBox[{"cq", "[", 
             RowBox[{"q", ",", "th0"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"q", ",", "0", ",", 
           RowBox[{"2", "\[Pi]"}], ",", "0.01"}], "}"}]}], "]"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Re", "[", 
            RowBox[{"cq", "[", 
             RowBox[{"q", ",", 
              RowBox[{"-", "th0"}]}], "]"}], "]"}], ",", 
           RowBox[{"Im", "[", 
            RowBox[{"cq", "[", 
             RowBox[{"q", ",", 
              RowBox[{"-", "th0"}]}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"q", ",", "0", ",", 
           RowBox[{"2", "\[Pi]"}], ",", "0.01"}], "}"}]}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}]}], 
    "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"th0", ",", "0", ",", 
     RowBox[{"\[Pi]", "/", "2."}], ",", "0.05"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7092177715033913`*^9, 3.709217775479102*^9}, {
  3.709217827092104*^9, 3.709217895607201*^9}, {3.709218065571638*^9, 
  3.709218133025984*^9}, {3.7092181723157043`*^9, 3.7092182030723*^9}, {
  3.709218248474868*^9, 
  3.70921837293707*^9}},ExpressionUUID->"32f1a869-f5ae-4f29-b111-\
3fa0fd270a52"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"styleBase", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", 
      RowBox[{"1", "/", "4"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", "Black", "}"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.1"}], ",", "1.1"}], "}"}]}], ",", 
     RowBox[{"Ticks", "\[Rule]", "None"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"k", "\[Equal]", "0"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<n\>\"", ",", "30", ",", 
              RowBox[{
              "FontFamily", "\[Rule]", 
               "\"\<Linux Libertine Display O\>\""}]}], "]"}], ",", 
            "\"\<\>\""}], "}"}]}], "]"}]}], ","}], "*)"}], 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"k", "\[Equal]", "0"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"i", ",", "30", ",", 
                 RowBox[{
                 "FontFamily", "\[Rule]", 
                  "\"\<Linux Libertine Display O\>\""}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{"-", "0.5"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"-", "3"}], ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
           
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<n\>\"", ",", "30", ",", 
               RowBox[{
               "FontFamily", "\[Rule]", 
                "\"\<Linux Libertine Display O\>\""}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", 
               RowBox[{"+", "0.5"}]}], "}"}]}], "]"}]}], "}"}]}], "]"}], 
       "}"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"styleTopMass", "=", 
   RowBox[{"{", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Darker", "[", "Green", "]"}], ",", 
       RowBox[{"Thickness", "[", "0.025", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"styleTopBond", "=", 
   RowBox[{"{", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Thickness", "[", "0.025", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"styleDiscreteMass", "=", 
   RowBox[{"{", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Darker", "[", 
        RowBox[{"Darker", "[", "Green", "]"}], "]"}], ",", 
       RowBox[{"PointSize", "[", "0.03", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"styleDiscreteBond", "=", 
   RowBox[{"{", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Darker", "[", "Red", "]"}], ",", 
       RowBox[{"PointSize", "[", "0.03", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ktable", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"k", ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0.", ",", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"\[Pi]", "/", "6."}]}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"headings", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{"Black", ",", "40", ",", 
         RowBox[{
         "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
        "}"}]}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<\[Delta]\[Theta]\>\"", ",", "\"\<k\>\"", ",", 
      "\"\<\[Phi]/2\[Pi]\>\"", ",", "\"\<\[Delta]l\>\""}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"klabel", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"k", ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"k", "\[NotEqual]", "0"}], ",", "\"\</a\>\""}], "]"}]}], 
         "}"}]}], ",", 
       RowBox[{"FontSize", "\[Rule]", "30"}], ",", 
       RowBox[{
       "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"\[Pi]", "/", "6"}]}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.709221186536717*^9, 3.709221199941758*^9}, {
   3.7092212887676*^9, 3.709221328684568*^9}, {3.709221364426991*^9, 
   3.7092213998989973`*^9}, {3.709221638870646*^9, 3.709221686064587*^9}, {
   3.709222519090681*^9, 3.709222519217266*^9}, {3.709223410464924*^9, 
   3.709223410527131*^9}, {3.709224476240307*^9, 3.7092244793266687`*^9}, {
   3.709224766617894*^9, 3.709224769112281*^9}, {3.709224819830492*^9, 
   3.7092249059658318`*^9}, {3.709225287811758*^9, 3.709225288849779*^9}, {
   3.7092254118341303`*^9, 3.709225445141848*^9}, 3.709225513891466*^9, {
   3.709226455772757*^9, 3.709226520904657*^9}, 3.7092266307896967`*^9, {
   3.7092294166079683`*^9, 3.7092294463144608`*^9}, {3.7092294802790747`*^9, 
   3.7092295014778557`*^9}, {3.7092295507388163`*^9, 3.709229596366259*^9}, {
   3.709229654494513*^9, 3.7092296726960773`*^9}, {3.7092297227095203`*^9, 
   3.709229762896531*^9}, 3.709229931734852*^9, 3.709230119784998*^9, {
   3.709230313160616*^9, 3.709230354148307*^9}, {3.709230392500152*^9, 
   3.7092304056003017`*^9}, {3.709230645329812*^9, 3.709230657966373*^9}, {
   3.709230783227648*^9, 3.7092308064045753`*^9}, {3.70924097020129*^9, 
   3.709240971062439*^9}, {3.709241049713578*^9, 3.709241057920446*^9}, {
   3.70924112402886*^9, 3.709241128875269*^9}, {3.709241170798168*^9, 
   3.709241188183281*^9}, {3.709241256435013*^9, 3.709241280816162*^9}, {
   3.709241400520351*^9, 3.709241407862028*^9}, {3.709241527823358*^9, 
   3.709241540813828*^9}, {3.709296270925782*^9, 3.709296272022663*^9}, 
   3.709296307634482*^9, {3.709637915068643*^9, 3.7096379539031897`*^9}, {
   3.709638099518592*^9, 3.709638146014489*^9}, {3.709638241649642*^9, 
   3.709638244004655*^9}, {3.709638333424397*^9, 3.7096383367525187`*^9}, {
   3.709638401920743*^9, 3.709638435570135*^9}, {3.70963848638732*^9, 
   3.709638498706316*^9}, {3.709638550999442*^9, 3.709638626561389*^9}, {
   3.709638668881898*^9, 3.7096386712536793`*^9}, {3.709638820698914*^9, 
   3.709638846043585*^9}, {3.709638907543376*^9, 3.7096389303262243`*^9}, 
   3.709639113029757*^9, {3.7096392217852497`*^9, 3.70963924716064*^9}, {
   3.709639291611455*^9, 3.709639296252119*^9}, {3.7096394736263657`*^9, 
   3.709639501261392*^9}, {3.7096426478296547`*^9, 3.7096426484184*^9}, {
   3.709644798276867*^9, 
   3.709644799972844*^9}},ExpressionUUID->"a2871067-7741-4561-8445-\
9b4113ba70a3"],

Cell[BoxData[{
 RowBox[{"phiPlus", ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{"Arg", "[", 
     RowBox[{"cq", "[", 
      RowBox[{"k", ",", "th0"}], "]"}], "]"}], ",", 
    RowBox[{"2.", "\[Pi]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"phiPlusTable", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"phiPlus", "/", 
            RowBox[{"(", 
             RowBox[{"2", "\[Pi]"}], ")"}]}], ",", "0.01"}], "]"}], "}"}]}], 
       ",", 
       RowBox[{"FontSize", "\[Rule]", "30"}], ",", 
       RowBox[{
       "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"\[Pi]", "/", "6"}]}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.709226982643152*^9, 3.709226985683012*^9}, {
   3.709638078876292*^9, 3.7096380972130003`*^9}, {3.7096382597255707`*^9, 
   3.7096382610857553`*^9}, 3.709638358094574*^9, {3.709638404079666*^9, 
   3.709638432464211*^9}, 3.709638505409648*^9, {3.709638639026936*^9, 
   3.709638651204323*^9}, {3.709644722104474*^9, 
   3.709644752864613*^9}},ExpressionUUID->"95454a59-22b6-4f06-b4ba-\
752e5ea7cc17"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tablePositive", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{"k", " ", "x"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleBase", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{"k", " ", "x"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", "0", ",", 
              RowBox[{"2", 
               RowBox[{"\[Pi]", "/", 
                RowBox[{"(", 
                 RowBox[{"k", "+", "0.0001"}], ")"}]}]}]}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleTopMass", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"k", " ", "x"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "3"}], ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"Evaluate", "[", "styleDiscreteMass", "]"}]}], "]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"k", ",", "ktable"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "klabel", ",", 
      "\[IndentingNewLine]", "phiPlusTable", ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{"k", " ", "x"}], "+", "phiPlus"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleBase", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{"k", " ", "x"}], "+", "phiPlus"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{
               RowBox[{"-", "phiPlus"}], "/", 
               RowBox[{"(", 
                RowBox[{"k", "+", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "5"}]]}], ")"}]}], ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "\[Pi]"}], "-", "phiPlus"}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{"k", "+", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "5"}]]}], ")"}]}]}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleTopBond", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{
                  RowBox[{"k", " ", "x"}], "+", "phiPlus"}], "]"}]}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "3"}], ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"Evaluate", "[", "styleDiscreteBond", "]"}]}], "]"}]}], 
         "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "ktable"}], "}"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.7092408509292383`*^9, {3.709241046418577*^9, 3.7092410739189453`*^9}, {
   3.709637905070298*^9, 3.709637908815074*^9}, 3.7096383961675873`*^9, {
   3.7096384455388603`*^9, 
   3.7096384651544437`*^9}},ExpressionUUID->"b5e62d5f-0353-4574-9a37-\
d0ab128d80b6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gridPositive", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Prepend", "[", 
     RowBox[{"tablePositive", ",", "headings"}], "]"}], " ", ",", 
    RowBox[{"Frame", "\[Rule]", "All"}], ",", 
    RowBox[{"ItemSize", "\[Rule]", "Full"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.709240761288122*^9, 3.709240772165099*^9}, {
  3.709240828307374*^9, 
  3.709240903212327*^9}},ExpressionUUID->"3b5764cb-bda5-4cb5-93d0-\
413f51e372c5"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"\[Delta]\[Theta]\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"k\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"\[Phi]/2\[Pi]\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"\[Delta]l\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2nlcTG8XAPDWqRRSRKFSCpXlR1GoE4VEhJCEhETJVomSJNpI1oqSQpK0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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61142#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVmHk8lN8Xx+0pVGQvikhlkmRPnZIlUnYtsiS0WlKWbKFNsvSlRIulohKJ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61183#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 7.347880794884119*^-16}, {-2., 
           4.898587196589413*^-16}, {-1., 2.4492935982947064`*^-16}, {0., 
           0.}, {1., -2.4492935982947064`*^-16}, {
           2., -4.898587196589413*^-16}, {
           3., -7.347880794884119*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{RowBox[{"2", " ", "\[Pi]"}],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.5`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2nlcTG8XAPDWqWRJEUKlVFTSj1IhJ4REC0KytCBR9kqUVKINZUmipJAk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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62031#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwl2Xk4lN37AHCyRIstFdJblBZpj2x1kyWEEkVIkiWpUKHNkuglW0WyZE1l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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62072#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -6.123233995736766*^-16}, {-2., \
-3.6739403974420594`*^-16}, {-1., -5.66553889764798*^-16}, {
           0., -3.216245299353273*^-16}, {1., 3.6739403974420594`*^-16}, {2., 
           6.123233995736766*^-16}, {3., 
           8.572527594031472*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2Xk8VF8bAPAhQ5Q2S0hCiqRIi5I8U4hSKqWfyhKtoqhIUUQqIRWylLRa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            "]]},
          Annotation[#, 
           "Charting`Private`Tag$61269#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3c8lu8XxxWhokIiu4wio0GEOpREaaEyKiKpaImIKEpFyyijb1kNKSEN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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61310#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -6.123233995736766*^-16}, {-2., 
           0.8660254037844387}, {-1., 0.8660254037844386}, {0., 0.}, {
           1., -0.8660254037844386}, {2., -0.8660254037844387}, {3., 
           6.123233995736766*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.6`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2nk4VG8bB/AZy1DKTyVJJSVaqCyVFrqJUkSUJFuoKJQWIaJEyRoVKlqk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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62158#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwV13c4lf8bB3BJilI0hURD3yKzkNEdoaSUlYzMkqKUlNKgYVQqIUmRWUIZ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            "]]},
          Annotation[#, 
           "Charting`Private`Tag$62199#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           0.6088145608610865}, {-2., -0.38262155656441343`}, {-1., \
-0.9914361174254993}, {0., -0.6088145608610864}, {1., 0.3826215565644123}, {
           2., 0.9914361174254993}, {3., 
           0.608814560861087}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwUm3lYTV8XxxvuLaGoiEIURYUyFmIdCakQKdJAhTQgCUmTSiokY6MmVOiX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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61396#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k8lN8Xx0nJlq1QWSqkEiLaJAfJUiIqW5aSJJIl27ck2je7yJoIlbJV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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61437#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -1.2864981197413093`*^-15}, {-2., \
-0.8660254037844383}, {-1., 0.8660254037844388}, {0., 0.}, {
           1., -0.8660254037844388}, {2., 0.8660254037844383}, {3., 
           1.2864981197413093`*^-15}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"4", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.56`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwUmHk8VV8Xxg33KkQRDSqJDElRKTKtWykalNIgZSZNKr8GolCIECWZy1Ch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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62285#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwV13c8Ve8fAHAhGhraKClSSX0llQofDRoqGVGhYYuyEmkYWUmyUiGkzCRC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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62326#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -0.3768754896688934}, {-2., 
           0.9906058375463944}, {-1., -0.6137303478775007}, {
           0., -0.37687548966889417`}, {1., 0.9906058375463946}, {
           2., -0.6137303478774992}, {
           3., -0.3768754896688958}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtW3k4Vd/3xr1mqZBQSRRRkjSoaJ1SkQZ9GpBMhSaKSjQrqcxJMqVMDSok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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61523#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k81F8Xxy1RiCIVWaJSoo2IkEMpP8oeIpXUU4mIQoqkkkKRIluWpLKL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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61564#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -3.6739403974420594`*^-16}, {-2., 
           2.4492935982947064`*^-16}, {-1., -1.2246467991473532`*^-16}, {0., 
           0.}, {1., 1.2246467991473532`*^-16}, {
           2., -2.4492935982947064`*^-16}, {3., 
           3.6739403974420594`*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{"\[Pi]","\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.5`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtW3k4Vd/3xr2GTAkJlUTGkqRBoXVKRRr0aUBFFI0UlVCJkgohSqaUaFIh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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62412#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmXs0Vd/XxhUp1beUhFQiUkgRXZCZKBGKSCKhVESkVBTJpUQpKkkoJSSR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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62453#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           2.4492935982947064`*^-16}, {-2., -1.2246467991473532`*^-16}, {-1., 
           0.}, {0., 1.2246467991473532`*^-16}, {
           1., -2.4492935982947064`*^-16}, {2., 3.6739403974420594`*^-16}, {
           3., -4.898587196589413*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmnk4lN/7x2fGFlopoZWypOWjpCg6j5JKFGUrlPaNaFNRKsnSghBZkiUl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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61650#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV13c81d8fB/D7ueRGJUVJQ8MoTSol1PtkRrJTUZSRUUZSmpKk4YsiJDOj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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61691#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -6.432490598706546*^-16}, {-2., 
           0.8660254037844388}, {-1., -0.8660254037844385}, {0., 0.}, {1., 
           0.8660254037844385}, {2., -0.8660254037844388}, {3., 
           6.432490598706546*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"2", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.44`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmnc8lv/3x+/FHeIjadkjlCSlktX7aqISGipJMhoiEgqlSCVZoczMjKSy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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62539#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVl3k0VW8Xx5UKZSiJojQSklTyU9QmIZoMKUkUohJSGZoURVQoJEXRQKYQ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62580#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           0.37687548966889456`}, {-2., -0.9906058375463945}, {-1., 
           0.6137303478775002}, {0., 0.376875489668894}, {
           1., -0.9906058375463944}, {2., 0.6137303478775008}, {3., 
           0.3768754896688934}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwt2Xk0lO/bAPAhDCUtlkoR+aok2rRS1xSRSClEKUvaiWxZipQKSUKURBQJ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            "]]},
          Annotation[#, 
           "Charting`Private`Tag$61777#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k4lF8Ux4VQWWbGMtIiRQvJ0oKSc1GR+klCWbJHlFDKWiIt1pAoS6RI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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61818#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           1.6538921594855151`*^-15}, {-2., -0.866025403784438}, {-1., \
-0.8660254037844389}, {0., 0.}, {1., 0.8660254037844389}, {2., 
           0.866025403784438}, {
           3., -1.6538921594855151`*^-15}}]}, {}}, {}, {}, {{}, {}}, {{}, \
{}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox["\[Pi]", "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.4`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmXk0Vd/7x++9hmuuDGWIIoRKMiUNexcZSpMSpaQkJTRRZlERKVJRktKA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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62666#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwV13c81d8fB/A7KNVNaJCMrEpKZCTUORJRVBRlKwkRUpoyomhRVBoystIQ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62707#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -0.6088145608610879}, {-2., 
           0.3826215565644116}, {-1., 0.9914361174254992}, {0., 
           0.6088145608610867}, {1., -0.3826215565644131}, {
           2., -0.9914361174254994}, {
           3., -0.608814560861085}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJxF1G0sFAAYB/C749yI+9B1ts52cbfTjqaXeZtTHVPMmDjEuuqWI9ndNJO3
RtOIK3QzVKellnciKUt1COlMOsUyaV4Sc15iXHd2x6k2nufZ/vvv9/H/5XG4
lBgWSyIQCMH/8r9jmuUr29uULsLO7TMyHHmb6N7TVcKUDbTjRHv/0ip6wXrm
6dg0+mqCW1RrDzqL870rLg+tKGcXD1LRFZP5iaGWFmDbIUEIl04Gq84I/AY4
5uAALieZzTIDezUJq9WHSWDD7TjaMS4R/EdfWXrhIAH3sIpdO6Smzl3zyDda
ncWb4BK+h4dPpgEc8zBqdqFiA6yuYVoSFTow0/r50c42LdjKfk6tqV8DS8Jz
79fWroJFPZMDzOJlMOu4KfRDtgZcF986/bZtFpyw3iK8o5gGu2SRoy3Y42Ba
+siesvJh8KhY4tQ80wdOzXAq6i9tAtff9eRXHnl2ctdFV7K/iW5+BNtog3iN
ocPgqeQ+15SccfDv9uDuVNU0uDrviUgsmwVzdA20tHINeOLFASUvfhkccW8q
f1G+Cn5UVaAMKlsDm5+TLpPTteDPorqasBwd+JUN47xesgF2VDjMU4IMYENK
zlaDYBO8aLCj1nqawI8v543YsQn8Xct9PhXs5xDB1MQG3x46Cdzh91rZxjAD
b0kvukdSzcFEytcHzlto94Ck7kCCBdjwo3Gevob2k6jkwTp0oXHGM9eAtmfY
ybQkCtj/rIw7TEOXfIlNkLuhXfqYS1bp6LQIrxLfTPT7XxHeGdnocLPCAo0M
fZ1vPKRSoFVvRqW579B7A9fpyi60cIzaoe1Fr+hPUcWDaFu3l02+E2hRrzoy
4ye6TrBoaplDeyexQhxW0LeIJ/RR6+gheXSFXI9m2F/zVxnRO/8L/BenQCsU

            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61904#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJxFz30s1AEYB/BLl7e81oXGUZPm5cTcZpcuL+O3O3NKmqmmyMslztHoTG5d
CdHJSnHdxMZ1O+KyaXREuSY03MrryArlxCG2JhS9bPU8z/bsu8+eP7579sem
hifokUik0D/7N2n25FK2XoQf6d/0Ed/pYoLu/9+dtlyP80QguCOf6s4hToJ9
met1AUQceNPqQjKTSAdHke17DxM3wCbZ61cYxD3wK+IOtZHyCCzgsNdKhpXg
KrfByrbGp+Bm1YiWN60CG+bR6nNa2sG5vOReV6EaLLZOKo8w7wR7Tlu60gVd
4PrluJCvFm/AXfbRbudEvWBt/3Zu8VQ/mB9TK9UceQtWXZRHN6S9Ay/dX+WL
Xg6AFdceunkaDoE9fpaxWn2GwTKptp5+cwT7um5dym8fBe+xyhX1mI6Bu50G
fHSR42D264yIWfF7cFM+r2VgbAK8PKoSSiw/gBvmTi8yAz+ClWY1g4msSXBS
WuikwzSaGldxV1M4Bd7VLJGmHJrGf8OYJ9a70R1CsVLI/wTOWs5tWTD6DM7o
dLYLrUYnuGQ6ylkz4KMjqeNzU+idlN3eBwu1YLU0JuC40yxYJTolS3yBlq9u
1GbFfwFfaWLFZP5CB+3we85TzIHDmiZ54Zx5vCtpmgNatLu349BSkQ68pd9Z
KHdeAFswzMs4arTNBpml4y6CDclyhWDbEjhk0rTVmYwubhP0jeujKZfZK74m
aAetzsfAGu3d46WR0NDxRR3fVJFoRaKLQfIZ9HxQyV7qWXTaZpzv9Vh0Nt+g
IDgFXRJ2zHY8Bz1Me+ZelIe2Mdrn71uArlSvxFffRj/2Kn2S9AC9aLbVYVeO
9tRxBzUV6GYZY81Lhl4XVRnPyNHMKGOqpAZ9lZHuEVyHVlMmAn4o0b8BwNww
6w==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$61945#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 0.}, {-2., 0.}, {-1., 0.}, {0., 0.}, {1., 0.}, {2., 
           0.}, {3., 0.}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "3"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-3, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "2"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "1"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "0", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {0, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "1", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "2", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "3", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {3, -0.5}]}, 
         InsetBox[
          FormBox[
           StyleBox[
           "\"n\"", 30, FontFamily -> "Linux Libertine Display O", 
            StripOnInput -> False], TraditionalForm], {3, 0.5}]}},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{"0",""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.5`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQnbx+wvv//9kPsMeIGKstW2hTp3rrQFo7gj9rtvKk
s3wI/vz7HfmBnGxwvtiFYH9NUVY4/0RAsMtpVRY430NTtURZiRnOt1oXs+y8
PhOc/6srTdhIkxHO//p9ydQ4dQY4/4jSJJN9uf/2w/jWrPWbtVP+wPlTHMzN
HWt/wfnJcyKevpr/A84/v1yOk3HWNzhfjmeD4f5tX+B8LoVn51+u+gTn54S0
zlix4gOcn3D4/mm5SW/hfCXbf4FHG1/C+SszNj/cve0pnJ/1eWNM96yHcL5e
HWskm/JtOF+48gr3tNmX4fzrKTla6x8fg/PLq7T6Tk5dB+ev6rdwWGKw1h7G
78tsvJbQdBzO5/3iY70m8DKc/6DkmElZy204/91O30PlJx7C+cvaFyakdD6F
81W/rRaumP0Szr+3SX6vdcZbOD90+oOO1xM+wPnzlvbs9Zn2Cc5nic59y1r5
Bc4/l7ByeVDLNzh/K69U7PecH3C+2izFF+w+v+D8X2Utf1cH/4HzX/+S5lth
8Q/OX5DefkVamcEBxp/geKZHUpURzufLX+10WJQJzt/nsmPvNilmOP9vbrxZ
GB8LnM/Ifmmm9l8E38yj6JAXAxuc/+vOmheinxB8vWNyb7gq2eF8aH6B8wH1
IUoO
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62793#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7XVtBtNeHeGD7DEixmrLFtpMWnvoXdIZITj/Zsub
Wxw5CL7pvyxV+dmCcP76uSFTeG8IwPnXXV5OOy+B4E/PDRTfMYkPzt87d5ln
Iz8vnF+bHJhwP5sbzp9pETTvyXlOOP9TpKbqLH8OOP+JQNiEJ+vY4HwRkUiX
+5qscP4CtU3yjWuY4fyj5xLub+djgvPVDz99Pq+HAc53m9Ww0vTK3wMw/rcz
Dy9Wz/sF5yvOeN+ttOA7nF/ft4Lvc8IXOD9clk9ZJfIjnH94nS3DP4U3cL5H
wvbwgHVP4fyWVpGlx0Puw/nO39P2TvW8BOdv1V5fOCN/B5yvNKta3TFouwOM
b/K6pjf+xCU4/2tvRteae/cQ/IPBRpp/nsL5Df+lmuKz3sD5XG0u4a9MPsL5
SokXVKpLv8D5+xevT1hd9x3OX3L8kW9vxS84P+xAVpHr5r9wvrvA4ia/aAZH
GP+U1u701L+McL7Azz/MZ5qZ4fxf219UdDOxwvleD+s4ty1kg/Nj99kFGqhy
wPnXWVduET3JCed/td37ITiVG86/qvn78cOnPHC+TMPjT7fa+OB8oaNVdwTZ
BOD8jEM3Vj86guB/+sLN+XKyIMJ+xiuO4qFCcP6VbDOlVwcQfGh+gfMBvrtH
7Q==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$62834#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 1.2246467991473532`*^-16}, {-2., 
           1.2246467991473532`*^-16}, {-1., 1.2246467991473532`*^-16}, {0., 
           1.2246467991473532`*^-16}, {1., 1.2246467991473532`*^-16}, {2., 
           1.2246467991473532`*^-16}, {3., 
           1.2246467991473532`*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "3"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-3, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "2"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "1"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "0", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {0, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "1", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "2", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "3", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {3, -0.5}]}, 
         InsetBox[
          FormBox[
           StyleBox[
           "\"n\"", 30, FontFamily -> "Linux Libertine Display O", 
            StripOnInput -> False], TraditionalForm], {3, 0.5}]}},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.709644762131926*^9, 3.709644772210582*^9}, 
   3.7096448737152348`*^9},ExpressionUUID->"d890533b-d36f-4c31-b6ea-\
0efa4e2c5924"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<gridPositive.pdf\>\"", ",", "gridPositive", ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.709233313816327*^9, 
  3.709233351844926*^9}},ExpressionUUID->"724f1dcb-a4dd-43db-909d-\
62eecb14e095"],

Cell[BoxData["\<\"gridPositive.pdf\"\>"], "Output",
 CellChangeTimes->{
  3.709644878904478*^9},ExpressionUUID->"57761a4c-29f7-4788-b302-\
c5eaded1a111"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"phiMinus", ":=", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"Arg", "[", 
      RowBox[{"cq", "[", 
       RowBox[{"k", ",", 
        RowBox[{"-", "th0"}]}], "]"}], "]"}], ",", 
     RowBox[{"2", "\[Pi]"}]}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Need", " ", "Mod"}], ",", " ", 
    RowBox[{"because", " ", "when", " ", "k", " ", "scans"}], ",", " ", 
    RowBox[{
     RowBox[{
     "phi", " ", "passes", " ", "\[Pi]", " ", "and", " ", "go", " ", "to"}], 
     " ", "-", "\[Pi]"}], ",", " ", 
    RowBox[{
     RowBox[{"creating", " ", "a", " ", 
      RowBox[{"jump", ".", " ", "This"}], " ", "is", " ", "due", " ", "to", 
      " ", "Arg", " ", "return", " ", "from"}], " ", "-", 
     RowBox[{"\[Pi]", " ", "to", " ", 
      RowBox[{"\[Pi]", ".", " ", "We"}], " ", "want", " ", "to", " ", "see", 
      " ", "a", " ", "full", " ", "cycle"}]}], ",", " ", 
    RowBox[{"so", " ", "need", " ", "go", " ", "to", " ", "2", "\[Pi]"}]}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"phiMinusTable", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"phiMinus", "/", 
            RowBox[{"(", 
             RowBox[{"2", "\[Pi]"}], ")"}]}], ",", "0.01"}], "]"}], "}"}]}], 
       ",", 
       RowBox[{"FontSize", "\[Rule]", "30"}], ",", 
       RowBox[{
       "FontFamily", "\[Rule]", "\"\<Linux Libertine Display O\>\""}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"2", "\[Pi]"}], ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"\[Pi]", "/", "6"}]}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.709222031606742*^9, {3.709222149710861*^9, 3.709222150664712*^9}, {
   3.7092225778229094`*^9, 3.709222601214017*^9}, {3.709224613524599*^9, 
   3.709224623586722*^9}, {3.7092246627541227`*^9, 3.70922473538833*^9}, {
   3.7092249249732943`*^9, 3.709225001159524*^9}, 3.7092251101942387`*^9, {
   3.709226079063748*^9, 3.709226170575635*^9}, {3.709226211135538*^9, 
   3.709226226363616*^9}, 3.7092269693002243`*^9, {3.709639530040593*^9, 
   3.709639543916494*^9}, {3.70964473121861*^9, 
   3.7096447569462957`*^9}},ExpressionUUID->"01d1c375-6450-4680-aec0-\
cc00864f2928"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tableNegative", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{"k", " ", "x"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleBase", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{"k", " ", "x"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", "0", ",", 
              RowBox[{"2", 
               RowBox[{"\[Pi]", "/", 
                RowBox[{"(", 
                 RowBox[{"k", "+", "0.0001"}], ")"}]}]}]}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleTopMass", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{"k", " ", "x"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "3"}], ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"Evaluate", "[", "styleDiscreteMass", "]"}]}], "]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"k", ",", "ktable"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "klabel", ",", 
      "\[IndentingNewLine]", "phiMinusTable", ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{"k", " ", "x"}], "+", "phiMinus"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleBase", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{
              RowBox[{"k", " ", "x"}], "+", "phiMinus"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{
               RowBox[{"-", "phiMinus"}], "/", 
               RowBox[{"(", 
                RowBox[{"k", "+", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "5"}]]}], ")"}]}], ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "\[Pi]"}], "-", "phiMinus"}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{"k", "+", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "5"}]]}], ")"}]}]}], "}"}], ",", 
            RowBox[{"Evaluate", "[", "styleTopBond", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"Sin", "[", 
                 RowBox[{
                  RowBox[{"k", " ", "x"}], "+", "phiMinus"}], "]"}]}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "3"}], ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"Evaluate", "[", "styleDiscreteBond", "]"}]}], "]"}]}], 
         "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "ktable"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7092219109297657`*^9, 3.7092219158573503`*^9}, 
   3.70922466768305*^9, {3.709225005436964*^9, 3.7092250914594107`*^9}, {
   3.709225149712554*^9, 3.709225151330471*^9}, {3.7092265395580463`*^9, 
   3.709226546294191*^9}, {3.709227099311043*^9, 3.709227101564315*^9}, {
   3.7092271326505632`*^9, 3.709227191749152*^9}, {3.7092292090887423`*^9, 
   3.709229301208024*^9}, {3.7092294000952053`*^9, 3.7092294084606657`*^9}, {
   3.709229829232686*^9, 3.709229896810671*^9}, {3.7092332786195927`*^9, 
   3.709233281931848*^9}, {3.7092409874449787`*^9, 3.709240997830122*^9}, {
   3.7092410801620493`*^9, 3.709241081790401*^9}, {3.709639548574397*^9, 
   3.709639551920888*^9}},ExpressionUUID->"57b16e85-693e-48b5-8af8-\
e0b741138f5a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gridNegative", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Prepend", "[", 
     RowBox[{"tableNegative", ",", "headings"}], "]"}], " ", ",", 
    RowBox[{"Frame", "\[Rule]", "All"}], ",", 
    RowBox[{"ItemSize", "\[Rule]", "Full"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.709241016579612*^9, 
  3.709241021875*^9}},ExpressionUUID->"0486eeb9-ae35-47c8-a949-0b804cc1ab77"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"\[Delta]\[Theta]\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"k\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"\[Phi]/2\[Pi]\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"\[Delta]l\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontFamily->"Linux Libertine Display O",
      FontSize->40,
      FontColor->GrayLevel[0]]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2nlcTG8XAPDWqRRSRKFSCpXlR1GoE4VEhJCEhETJVomSJNpI1oqSQpK0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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$63812#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVmHk8lN8Xx+0pVGQvikhlkmRPnZIlUnYtsiS0WlKWbKFNsvSlRIulohKJ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$63853#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 7.347880794884119*^-16}, {-2., 
           4.898587196589413*^-16}, {-1., 2.4492935982947064`*^-16}, {0., 
           0.}, {1., -2.4492935982947064`*^-16}, {
           2., -4.898587196589413*^-16}, {
           3., -7.347880794884119*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{RowBox[{"2", " ", "\[Pi]"}],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"1.`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2nc8Vf8fB3B7pCFKpUJEQlJRVLwVLUUqSiKj8VWkhZRIUlahISmShlQy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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64701#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVl3k41N8XxyVFEklFVIiQUCiUuCpUKCIllJLK0hcpS8lSIUv2vZIl2ZJs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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64742#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           4.898587196589413*^-16}, {-2., -6.432490598706546*^-16}, {-1., \
-8.881784197001252*^-16}, {0., -1.133107779529596*^-15}, {
           1., -4.898587196589413*^-16}, {2., -7.347880794884119*^-16}, {
           3., -9.797174393178826*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwU2Xk8VF8bAPAhQ5Q2S0hCiqRIi5I8U4hSKqWfyhKtoqhIUUQqIRWylLRa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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$63939#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3c8lu8XxxWhokIiu4wio0GEOpREaaEyKiKpaImIKEpFyyijb1kNKSEN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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$63980#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -6.123233995736766*^-16}, {-2., 
           0.8660254037844387}, {-1., 0.8660254037844386}, {0., 0.}, {
           1., -0.8660254037844386}, {2., -0.8660254037844387}, {3., 
           6.123233995736766*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.73`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwc2Hk4Vd/XAHDzpaSS+qIQMqSUZgpL0SSJkiQklUylwRTKVJFKIqIkFCFJ
KCVZJ2Mi85x5Hu69h2vm4j2/9y/Pes6z115r733O3R/SVo4nL3NxcHAk8nBw
/O/vxU/B5OIijYgo97Zt/E6CyJy4/D42jTjll5tYlE9CwaF4M5dpGpF7+VL8
WBkJziFbQz+P0wj5mWiF83UkyLd9L6GP0AjN3h1s/lYSGjbqcCgyaMR3Zb/x
kW4SApzLd18cpBG8+gF9a4ZIUPtlcjW6l0Z0qf5LcSdJGBLsftvUSSM41T/L
rxsn4ZXJ1WaRNhrhU9y6Z26KBL13UysMmmmEuVjN7//mSGCTPocf1dOIjLK4
ohvzJHzcJ3i3qJpGzOktyAgskmDhH57JWUEjBJX31LZSsVDN+mH1UhrBYwV1
JBWj5Adpt2IascwqSQ6o+LrdLpOMfBoxKp9YUkrlk/6KQUykEWEiy/+EUfNV
c+oWbsyh+ss33Pl6mgS/47Vzl77RiIKPfuJdVL07Iy22x2TSiOD8M6GXRkjo
7Rmw+ZdGI/zapLI3DJMQrnLrzZqPNCJvXVmqTC8Jhzzn6wyTaISl5FCYRRsJ
U8X+gk/iqfoU3kU01pOQuEpY+3csjbCVJXqCy0kwOR91mzuaRnSGRKf4F5Ig
8EE+TfMljegxUlP4+YOE7Mm0vtvhNOKeqUzwts8k2B/YJ/ElhEYsVfdV6I0n
YV1Q4amRIBoRnr5me2MkCXflmglrfxqht5Dx544XCVtvXJqK9aMRmCw8o3KD
hI4cpnKrF/W89Pi/DVYkHDDifnXKjUbcaV69pXI/CWNvnlQFOdGIbdPGFwNU
SHg3/B//n+s04uK+xjpfSRJ4/TY7a9nSiH/eacpa00z4Wv71g8dlGjECFXPc
PUywFt/f9fUCjehY/a1xaQUTfn8+fULZlFq/7I+/BuOY8Ljj7kbxYzRiQM7Y
jLGfCRqbBSxPH6YRRjPPn3QoMIHpGhoerE0jVM4cPLRuGRMMlidy09Sp87X8
R6tjHQNWaVa1jm2mEZ47P99/ac6AgofnRLZupBHPh59k9mgwwKmuV9dOjkZw
ad6Y9ZRgQL3DbFaHBI1wLZPuedlMh5evZEP+CtGIH0RWcZweHZJVImOzltCI
9IZbn45toEN2odDnWD4acXZf0rlNc8PQTM5UOC/wES1MmzehCcMgrlO5TJLJ
R+hu+GG2cXwIXtE9H177y0ec1jOs8rcfhBQfVoRJCR+x92dH3fY9g5Czxibx
QCEfcbfZ6dFGrkFo0TpVvOYnH/Ek5t3cYtgArAvbyIspfITgNsO3Hl/6IUqj
3nv5Yz4i/vce51V1vZBSfSx4xp+PqFFcwdwV3gs5V3696faj4sCKJbnGvdDy
LCU3y4OPSLr69hhffQ9I9Pmyz9vzEd6CbS+S/nZDdNBWtzRdPuIMfUqwLa4T
3rQHOBoK8BFrMzeopfY2geVS/gpvXj7C+F8Me9+pJpDZ478ljZOP0FY527qJ
aISEoPsMoVle4uZE9HGtiAZI1fC1LxviJS4eHRCN3V8HOa88rhwu4yWMn/xk
uXhWQvOZa+c1nvIS23551GakZ8OaylMnNq7mJcZSuqP/Wf1BsXKFBvuVvESV
GGEsF1aK68rmLFKX8RJmMsuKS4rKUPr322s7+HiJ7geb9vApVuBmYuyJxhQP
Mda1ji9/pAoPpIWWGTbxED/KtlzaF1aPjsE1R91f8xDGp4TXz95ox5tB76ty
InmIBy9NRoVm29HpscfZxTAe4lPf9lXpWh3oHiBrey+Ih5g1OxnYWdSBD7xv
BQR58RAad2y+3ynvxKjrq4rjLvAQ7Cvvmo1KuvG3wSmdUjkeYu5Ng/aZi/2o
FCEcnyPNQ1j/t3kV9+t+fNxexZsqwUPM552+yF/fjwbXDIqDV/MQtK1hB8QO
DWDjo+O6xrw8RPDSMxs3Sg7i3hrBD4c5eQjXHWsEXU4OYpR42VK1eW5C4tze
iyseDKJlku7ftRPcRBWPVoHC8CAOFB026OzhJoY82zE7ZQh1hWifqzu4iTYD
tRC9f0OYcrpoZUELN7FZcjVNWmAYr/fo1CTUchOiOxYqH1sN4zTnAWOHAm7i
x9UdzccF6Wh6lDPLnOAmZkgyuHonHXOCif9O5HAT5rYDl4PN6OgtBU3bMrkJ
w4ltyzOS6MivoW429Zab6DD8udp1LwPt7s3lDLzhJrQ6ivTfmzGwrDRbovkV
N1HhpeDNf5eBwaZq7Tmh3MTDQtUNprkMZMVOQ+pTboK7wLrqSCsDjQazYt48
4ibmOMeGL80xUNRtt5WvHzch9yRPQmYXE91xIu+WFzdxddPA618GTGzh+yJ7
2YPqv3Of+SN7JsaE7eg9fIubeMBT8eFlNBMVM1Rsll3kJuiXVU+HzTIxcJb8
vWDBTfx01L15azmJ9P2fNo6YchONBRNPXGRJTKtUHq4+yU24zn0LGTxCorAo
41iBPjdRLp1/y8SURKfzKSlfdLkJptVJ7SE7ElWZStciDnATkTlFHU4PSXy5
a6j8oSY34b3sVIPDCxLZnklbPfZyEwcavy178I5EiwKbYIfd3ARmRykQaSQS
SxVHzbdzE0dv/y4XzyFR5lS/4Ykt3ESEhXJGWBGJ914mpGspcRM7r/cFqlSS
2Nd5edV2eW7isete4eFGEo9slHOSleEm7NtfLy3sINGMxtxgKslNfOCuktDv
J/F679e6YHFugl/Q8MAqBpUv3+tB8RpuYvnV1NMiLBJfxB7ZsyBM7e8XZTXD
SRKTvVYO7FxO7a/u7+qSGRJzzZsj7JdS60dTXnaXTWL1vrdH42jcxNd8ouHq
AlWPmMNsIzd1ftKj5SMXSZyd2vlhOQc38Sw9grVIxUL18+cOsbmI28571OKo
WCazSPDONBdx51k224savyvk6c+McS4i7qaoTiSV/8h1k2tDI1yEksqCOJOa
30xfWkqawUW06FQ8u0vVd33zUMWZQS7CQin+py5V/70lGd5BvdT4Bv1vJ6n+
IgY8thV2chHWMgYx4VT/KUU6XXOtXEQFd2fEmk5qvd8tC93ezEVIEPSS6iYS
a3zrtW3ruQjf0RWWpVVUP5Zvxt9UcxFbXaIec5RQ/WjaxNeXcxFO+4Pu30Sq
/rkZPp1iLsKMQ6BsWTKJu5vystzzuQh5wfGoPdEk6mY9svmMXMTiFb79b56R
ePOWxB/Jb1yEyM1U9Y0uJD4w7HM/nclFLNgPqutdoc7L1k+bHqdR9e8PuZB6
hsRfw1pPZhK5iAgb+6htu0msLRHQVInnIjq8tL1PbSBx4H010zqWiyhdXiv7
dSWJKy5dMqiN5CL4+KddYYiJGw4ocy4N5yIk8/vEr9QxUXX95Of9IVwET5mm
VRUy0bLFf9WnQGr9PZjjjiFMdMo2KOh9wEVcWZgyjndnYkCEmPM6Py5ib2Nx
oJQVEz8Zfah/6MFFPNZ/VdSzhYkLZeWRlxy4iCXWQtIFyEDhDy90X9lwEZEH
f/hti2Og/EPLuapLXMTryduDA34MPH6QZQbmXMSxpzeSVQ8yMOrn6vXi+lzE
0MFkuxtIx72pZgkVW7mIldkDGzlDh/Fj3QqVL5u4CDu6vSTXlWFcP1/w/aUC
F6GqpnpNY+8w8ukp/70sxUVE5Zaq2LQNYfXg/NicEBcR7f6QkS4xhHZyb/Yr
MjmJNf4nDxndHsBWvVOly4Y4iW7ZzdLR+wfQwIl2eqyXk+B21uNXExjA3fmO
NrmtnMThmqPnbML7keuC1lOjv5yE49Enec2JffgyqrPFO4WTkM6asX/0qQeX
FYRZWydyEokXvVZ8utqD3sNHR4694yR6d+80h009aL03nfu/KE7qfrPg+PFd
N25v9FX6+IiTWGZq3j0e3IV/Vm1wa7LjJDx2O00NGHTgbKD1qu0bOQm7qwrZ
OTP1mHrPsVBJjpOQatorwDxXj1Z33VxlpTmJf7X5/X4/6/DPjcB/ImKcxGsN
z8fMu7X40iT17RQ/JzHnnN6jOleFavKTO34OcBA/I1oNWNkl6PbrvtGRRA7i
5M0Ax9/wFjf/COLb/46D4FS5PSM48Qo7Ml98U4vhIFS+GX8rsn2GRxKT1m2K
4CDi41fJaDhehf+e/u1ZFsBBfBcSdO+mJ8BXs9XONVc4iIP9BeCoTsDE1Lsw
CwUOYmvEdwUxh2owDch6ESXLQahG+m57w1UDhOifyGYpDkL/Y5BGekQNPFYj
XxuLchCntEVVbuTXgoyHWoK+AAchp7d8iBRugBj2q6t36hcxN7bsfF/4Pzgj
wPykYbGI4afStUKWdYGM0qrM78aLuEnldYexfhcwdVW/7TqxiIsb9AtTgrrg
3mNfQllrEWMWeI/xCXVD+vL/qiRkFlEk0sHyEK0HhNZoseZ7F1Bp3eT7zK5e
aN59efJ22wI25Grubl3bB/FnAmcn6hcwn/MRv7dRH6hH1nIxixfwhR1NZmtB
H9ius13VlrSA28Wn3YVe90OBTMjO3KsLmGizXiNrxyDo1z8ZenF5AXl39oaP
XxmExocPY26YL6C4pY7GnVeDQB/xFpQ7voA/dHKz7TiGYBU69jzavIBXFt/F
Pf01BFE37V9e3rCA4WBhwzEyBPLyVwxg3QKOcuiEf5YYhr1PLHJYSxcwcHBx
baXLMFidO/787PA8ehbJvvgnRQe60FHdHd3z2OYuvV/5CB1c8nQ4lv2bx/pT
Z/O/ONIhcKO6A/FnHnc7mI9a59Dh85SSjkLyPL6gnQnfrMeAvR/kZzniqHy/
6u/8d426P1vIpDVHzqPsMtFV254yoLFQbF3Qw3mkK/O+oZczgOM5//i4DZWP
vYzpoMOEwMM8yeWW88jgCS7LPM+kPLl4PtFkHoUazsRtcGeCotVU6bkj8xj8
7vXR2ylMSF895rNLax6ZXtJfzAqYoF7C3LNcdR5/13PoXf7HhBMqfW/zFObx
FTPqZjcfCY3dnWejpOYxgZvr75m1JFi9aF3u8h9Vb+3aAeYWElwWaj020ubx
7VlQ8ztFAkd65TbuRTb6GknYe10iIfByWX/LJBtzq8+fjnIiIbos/1RwHxs/
/2wP2h1CgqI3Cti1sal7xbOlGW9ISN/xA7Xr2dhw+fkr/RQS1Pu/OkuUs3Gy
XKOX/xsJhS/TN00VslHQQzasM48Eff3UzsqfbPyqut6ikfJyI2fyi+QvbOR5
dnqGTnnZ6kv88Xsf2RiMyvJSlP/oNrHcFvFU/jvmydcoH7qse/19z2s2Nsf2
Gv6j/MhRGeG4MoyNg09FyEujVP1+z+WGH7Pxo5e/6dJJyut7gv8V3GOjzvNN
t8pnqH6GHj2L9mSjZ7GmZCqb6ifa/7CbExsVEw0OJy9Q/Rj6zRs6sKnv1oGO
PMq/+3i9MjZdYuP9qqOdU1Ss2PdEINiMjeZJ7aPnqHhNcdT5cSM2hm71T56h
fMyd+OGLyXE2rnKtXVVF+XgkIHvpz4NsPNuguK+L8nGbbckFaU023oxM3648
QUKpbmPW/d1sPO3vsDKd8vG3Tf3Lhraw0cFcYuw61V+C4ORFfQU22kiembal
+n/O4MlOl2JT91CXQ6+p9fEpX7XiP1E2SrFiaEsbSLj2ScbaYwUbxXIK7TIo
H5sFb8tp52fjwayXb8MpH+ve0BLW4WTjB6mooUzKx3tOnrBJnJnDA4tL7ghR
PhYWuSpyY2gOi47zPHOiPMwx4WFX1zWH1oPN73wek8CoCyTU/s1h1p8MxdK7
JPx+kejAVTaHomGKTSIXSPjilpVnXTCHd9tHf642JCHubJFoac4cvs5Z5Wek
RcKdtT0FoR/nsL/f++STdSTYsVni0/FzGH0rdG+AAOX5Vs4bZtFzaJvqn5s3
wYTtb6Qk5J7OYeTHiYDpUiYMyJxz/np9DneXhmU4OzKhntuuVNx2DiW1Uns9
jJmQ3+Mm7XVhDs8PPRAoUmdCdEL438Mn53BorVeiIo0Jp5Sq5Zp2UPlj2OVq
oQzQWtrpobF5Dg26A2ZvODFgC52sit0whzAwFzxmxAD+1GV37VbPYUBh+/L6
VQzI3Xa0fm5yFh2rxQu2PKRDirDJZktyFluU94f/vkSHyDFr34L+WYyKOnAl
Hejg9OXelieNs2ix723s7bFh2KhGPJDMnkWG1tuEkZPD8Fxrz579d2ZxTNiQ
w5I1CNxFZGup8yxmvr4calYwCDePJd4zvjaLP+TsEjBsEAyNxartz8/iNr7H
CT93D4KQw5xD+P5Z/FpoofftxgAEvMC4Yd5ZVIg3tPhY1geezMNC4UEz2GG7
aG0v1Q3Dtzi+rPefwZ7QFW0hHV1gOvPt3AevGbSyMO84GtsFajxKScT1GVzQ
1b7qIN0Fk2KCOsMnZzBopez9j+s64frBytta/82g3TO3DQyONrgYZdI79GYa
C8p2/4heUQfBmf0aNS+mcbhnbYDu9VrILXMJ//F0GhN1IxesK2pAfP754cde
0+gl6PqE+3E1VJpXJSmfn0bPknCBpwsVoCmle+265DSa5M3eqHxbCGJx+6Ym
oqbwb6vVg1XtN+BQ9p8Tbc+nMOliFovP2w2dqs8mFj2eQvohe+vXWcFYyeV2
9oXnFBaEWFqEseLwwcXMH6pmU0hcdv10XjATxzcoe3usnUJrPnpU8cMCrHgv
KcD5chKVuYrUbB/WoiWD4HQKmUSuPPV9LMk6ZG2/ONsXOInLX507NJtRhyK5
74fLPCbR3ate53ZLPZrUqpRHmE/iDI+ZQqV8E3ZxaIeqSE8iDCpsaXjdircO
9T56KzaJsq6IHze2Ic9j/3trhCfx0dR1ubLMNlT4r8yZzTWJYhOVm2p+t6OD
8mmT3z0TqOWzQrlhrAMnz16RsEycwL3LTIx6F7rQ/43AmpqYCaQVjRge1+xG
0d4PQociJ3CT1FQF3OnGfddHFjcFTqDjoxz93Jlu9H5wu2vKfgIFwuS5puk9
uCTj0funWyfQtaTxosSPPnw1rRzDpTiBQYsqGV6sPtysWRnhvH4CV1if6z29
sR9PlIgEnls5gZu1d2ebhPXj8/bXDgpj4xj3eZn5c+sBlBRM24Zfx7GN5vKj
kj6I13oUW56mjuOD+FLDdMkhzM2JfWCZMI5HXmX5NZ4YQvOrof84w8ep3xMl
DcanIYwqd7mv4zyOv04XFAhT91l6Arl19dVxLNrxtGosZBj3edk0914ax3dD
B5Yuzx3G5q2mW/2NxvGZ48guciUdxZ5pNJXsGMc9N2wmd6XR0cb2q9/LTeN4
dLq3qriOjt/2b91iLzuO/9H3lgfO0tGEtd5PcNU4RjofXRGzn0Hdm3iUT7DG
0CCpx5BeyMC+TXcapIbGMLcv5u1wDwN380z6jHSO4d+OSU8RbibWZfbXP6sa
w7nqGbt2dSaKrCn1rk0bQwe6Pk0ngYmXmNqb4hPHkNnRonk7l4mZRTl1zjFj
OP5YrbeK8sYp11Sl/4LH0LQjom+Ik8S4Ewp1/f5jOP1TnTd5DYkshRivb15j
eOL1rFigEokhjc9qzzqOIWYmjyafILErbYmX0pUxLNTRTB6yJHHbQ7+NcxZj
eHF+l87RGyR6X2DXlBqP4b1d0rpF3iRWqjnfjdIfw2NxnXoXnpK4XpipePXQ
GOo5pXaLvaa8OGRdo6E5hvsP/5dCJpHUOTdRbFcew7f1hVdGCcrjt6qqP8mN
oW01+8u6UhJTj+ne8ZYYw0XG1+GLtSQuyOYrGK4eQ+uPF4uKWkjUZ++rll5G
rVd7o8DBHhKjazM9WTxjuOOEkXfbEImMFGWFfDYL1xy4MxsyQqL6/YSq0HEW
ylRcPmE1QeJjcynPS3QWVnM9NtOjfNuyK0J+Vw8LaQ3NvIaUfzcLrazibWGh
Jzt513XKx559Dz3qa1go5ZLfkkT5uTSXS/59KQuP8pmy5qlY/IVHpWs+C8uv
rnJyoGI7x3H3Iz9Y2O3JbT0xT2L24atyYhks7JxIqY6YI3HJ+r6KwWQWNuzn
LDWepuaP4i/tiGOhnu/Wfp1xEj+KbSpqeMnC/QuHhY1JEu+GH/9VHsJCOxPr
a4GDJBqsup5TGMjCj6NRsl1dlIeDQ7JyfFkoXDt23vwfiWOCX9Iz3Fno5XTl
DLuaxIKHDR+Tb7LwwLF+baQ8Hc43mxhrx8K72kaXEyhP2/itexdhxUJ3Ti/O
9EwS1TjgzVNTFg4syl3qSqTqvXPh5YOTLFS5N9a2J4qqd8Yv7I4uC3/bepSk
B1H75ZIQ7HSAhXEFqj6nqPPgNfb7kf1eFjaaPrIVp86LDGOZ71klFm59WO+y
zoDEcVuVOwYyLOTcxfAy0SSxsO+k22FxFmqLV/jkbKLq6XhxbdcSFpYsd3Fb
4CZxr3m27WYuFrYW8Xq3Mpm4tLnlkuzsKNIimfF9jUxMrZE+t3JoFF2MaOm3
k5nobaBjzN81ip9/7GnioXxt+NfacLFpFB2CvsfkuDFxvOjDYUbJKBYERldl
ajNxX/aunSVJo/h4Kwe0VDBQcI/JViJ2FHn2phV0pDGwLcNdKStyFLdHXlr8
7xkDfT/i+viHoxgtf4Nf5gQDf8ccXeZjO4pGtav//vxFx5cSDvxuF0ZRpK5n
z40oOtq/DOJ2PDuKFtZrKixc6Cj0vGbG7Ogoij8afEdXoKORv3mf6sZRfPjJ
hG/UZxjlebw7t0qP4u7LCUWhxsM45R3XIi82ihvF3L1vKw3jS/f+ahGBUVw/
F5AkXDmEHVdv4MjACI4fNLONFh5CB6P7EYmJI3jB6GuQlssAxi5k71CKHcFl
NwOendcewPrEkfIPkSO4YuBsMn35AGrNn+P9FDiCV1QWJk+/70eRhO03vziM
IN9nmUT/ij78OdV+LE9lBHOb7AP8+Xpx3W7nhSxqX/l+BK+OEu3EB4EdO39Y
kfgtSW5QuL4DR9qO2eeeIvHihSLPDaEdWOAv01iwi3rvRJ+qSAp24NWmis9V
M0w096QVqIy1Yq6n0uVhHyYesO1LUghoQsv89lLJEAbyT6uENB6sxMMa05db
fRj4qHBT2dz+CtyStYIj6gYD7x61P2k79RfZyft3ihkycP2Rl4FV50sxIuRt
1KoVDCRV8+oaFIqw8sKVq/xBdCw5O9iWpJaF+zlIIdbDYbwzutKSfTgDFN1p
SWm3h3EOTm5KZX6BFeNS2o62w8iX3PK34Pk3aOs3cKUfGUaXRfWkuraf4F6R
3t5Ho/bJct0mjZ0FkB7tkvbv/hDGtMonFcaUg4zGgmGhzyCecLCK/GTVBJUr
NTZH3hzEquihyb3jTXC3z4Pv6sVB3EBUWMjfb4bmpzPZIgcHMfHvhNny+H8Q
2jUue4l/EEXuR1mUtLQCT8DwBNfTAXQ9vYZ1U6QT0s2UKuu9BnCvfvVuhzOd
YLnNNjn5+gAKZz99ORvZCTnNfRYnTw6gkmmHSaVEFzgrdxXHrh5A9YCp2zvW
d0NfdWOkVlQ/vlJfkeol1AvP3//nJPKkH9tVdcJX6PbCAU9j/YE7/Xi/Kf2I
5P1eiJar5Qo+34+dSVHnk2d64YxbhX27TD8OubcbWrT0wW+JIo27SX2YWBsp
xu8/AC4sHtGTL/swYHSFdt73AdhQrM2Se9SHuU+XCPQMD4D39V8Jfx36sF/O
6OVZ/UFQzc9ZLqHSh9lmYaPDS4cgySaj88fXXszL2sVKtxmGWqs3UscSelHf
7k9xzvNh4DB/ZN4c1ot+53bQFnEYjA0vNk079aLNcYFeBRE6cO1dVbVrRy8O
b9p7eCidDso7F4UKZXpR/Uf0tfBGOphsGdYzEu5FnjrjxhvzdEiVyf99c7QH
5evqj6frMMB06S3i06ce5JA2FtQsYcB93vMLmm96MH6dq82RAQakLeqqlwf1
4LasWhN3Pibwjct8o1/twY5F6xBDLSZsYwpNepj34Lt5QbWJc0wwG5jdsfR4
DzoItW356UJ5u6X608bNPShsupSWlcSE1vpcxre1PZgyed+t/xcT+KuSNx1Z
2oNSDTfPqDUxwaLQ9731UDda/hklNHlJeIjXeieaunFq/aTgqBgJmd9NZe+X
dKOEjunRPGUSlqRuf/M2sRsrVLjN8CQJuxIlW7dHdGO7crT80EUSLOOWrM3z
70ZnUu/PNsrfj6ImTQxdu9GzQasqzI+Er+Fd4R3W3XjXQrxsNeXxzuDyWkfj
bnysRjf8THlc8FG28OLBbnxiqMlhQ3ncyiskSEKuG39dbHWQyyfhye27ZSki
3dh8OurBpr+UN2/ZLVHn6Ua3tQVex+pJ6L5qfKR0rAvLs/TW3Kd8KWRz4IFp
dxd+Pf1ZqJHyp5rVloLB6i68ODm6Q4dOwiUzca7beV04PPL8TAnl76fGfFr8
6V0YeiDR8Arl72wD1p0XsV3Y+SmPQ3KWhF7dth/yz6jxX3l0GZS/Vxz8M/PF
uws3nBATq6P8vQ++7jl4vQv/+uy2rKN8ba0W51x7vgtv/JYQZVLxsx1BGRdP
dOGY9jotKSrOUXYfZWl2ofivJW02lL/7Fay3+m7pQq2g4wt/qPmEZU5eXSnZ
hXHStRkHp0jQWKf5IWZZF1oFi4o2sUiwWaM0uHW+E2XqJY/dZ5AQumKNAtI7
0Zxx65ZuPwm5S7gu67d0osO3zbmKHSQM8jDjWks78fiPHov1jSSILDZ1OPzo
xG0JOU+3VZAAM4WS7OROrE8zeWZGedtu7LPZo5edWFDUlhybTULk7tF9VwI7
8X7ifRu1T5Sfb6us1XbvxHdl2zaMx5Egx/GpafZsJ3L9mxmt8SfBSJv5rf5o
J87YHvs140aC7wPliHS1Thw34xfQsSWhQzDF2E6sE2HZ8tzDh6n9MhjedUig
E5mpV0S5dlH9hiqtlpnpwBaadmGXNAkvxZJqmho7MP3mxDaxGSaclk8wOBrR
gbE1oxfsXjPhnm3vVrmADpSVurTtyj3qfUjZsJzTrQNDrPbIPrVjwoodb/9+
O9OBDX/+6VzcyYRSiNFV/K8DT21Nj9uWy4BZ3/aNPLQOLP+5eDcqmgGGjzWE
CUY7fjELJFTvMkAwcu/TrR/bcZdlAofAPgb4pO98KLS5HV/JvQ+U+UCHNtWM
w0VL2zEmcPTu9vt0UKeke3e4DWuu2Pp5WNBhsnSLHyO5DVNGnGZzhOjg0Kt4
p4xylfcZXc911sNgIipxI1ChFe0nvzNPjw7C1+hXWw/QWtG8aFjIBwdhlZw4
c6avBes3RIRNPx6E8m3/2dsmtGCj3kbzarlB0D628vIRuRb0kHUJMTkxAFvu
8p7lk/2H582Fe9m+fSCeXfligOcfih3pa/ik2we8k6/q//Q148Pha67/VvZB
y9XtRk+Tm9FpeYFsXHQvBJqfPyG6vRkF6t9krErvgX717weV9jeh/4ap74W/
uiBmzmG7/vkGnLX056+VaIVVt2uXhr+qwcf3Tj+9MVIA04szK0n3GnxO3xlT
G50PbQ+kRI+Y1qAZq+DjB708SHxut2FWtAb/2Bxjfj2OoJnGoWERXo2JnBHC
YSmZYNu/+Zr8syp8UNrwIzPkMt79sCT26rIKNF380xDzshCPfj/9UaqsHAWu
3Tc/O1yEIsUx36sCy9Hoy8XT1/b9xqSu3dW7+MsxrFCW+vn/g7ViF7kXuP5i
XsKW9fv4KlEp4MfloOk/+E7owZNQmTpsuOSg9Km7CM/pp8ebd7ZhbqvBnq8J
Rah9Ujj+r0M7Jhjv0vlpW4RNhv0K7lPt6HRkwbyULETCTyRW434Hrtgc/Kx/
rgBfKLYbWoZ24tGxjGkpkXzcaZo1hi+7UcUhglehIQ/t+cZvvGj6n389hbe8
zMPsDWynsf96sK/+4Gb19Xl4YW0Je3toD/pmN5w32fwLXfaOWCf49aIz99QT
6Ye5+NnjxLe1x/pRZwLfb12ei+Wu/0Ie+/SjcH/AL42wn/jqYMsO+6x+TP0j
PnE2NgdnaBeDHaQHsO+ZplnI92w8+PG/kXPMAcz0o7nEQDZu/rBd5r/1g+jr
XPk0tfA7thVw8e82HESps1b5f6q+YXy74eaXnwfRZP0DJe6hr1gW523xz24I
5YVP6Ky8/hUNnDNehr4YwnFuUQupyS/4YXWFXUL+ED7rT3q2j+sLOmyU8m0Q
G8Y/qX+nb4lnYClPZrAu5WFXd6WgkrBU5LulMBDZR0d95kj9p4SPOBPiLPuP
xkB5qyyp8KwUnD0n/veaIgPrjup8tmpKxgHpy5cCrzBwh5hF7dy69xj9o8v4
bisDlzzZINGlnICiy+9Hac4wsItj+PJvzXj8Fnno4zERJj4bcJ16bvkWVen2
H48eYWKbo+wusyNvcPk+KZ+C90x8ciatSNHuNVpvv3yu+ScT1UHDZOLRK1x2
Sd9WtYaJL4XOeARVvKDuucZypXNMPDrZLXhuNAyLbDs7FoRInG69Hq2w6jmO
2NGH3KRJNP4Y+IswDsap0bmdmjqUd5S2JoiPPsbiMxLxAUaUR2aOlGTsfIhv
I+bz/7tEomyE5/K+Hz74wF07msuHRK6KzZcXFjxwdXNBijnloZ9XLT+oPHDC
a6+0VrBfUj5OkWw3OmmM4T4lKZzpJPJcOLY+QFsTIlq2mdnkkJi0Jc5VMNsK
ctX1j68sIjHS7fVETd11iL1gfohdTmJrk+2nWH03yKxdJryxgfLUvt22jsVe
QFP08nrRRuIOfZ9nkjF+4COubXW4l8S6u1eu3TfzB/9YixDVYRJdPx0/Rhd9
BFyNunQ7ysPiHTsUT9UFwZ/qCYM2ypsW/E+4Wo88AzvT/PgQyqOf1nPcWKEQ
CrsCn9T6U17lULvVrs0bBplG8aU/Kc8aGvYdd+0OBytG9Z2dlHfjbM/mJP+K
gI//GXcNU/GYT5lS25uXYHiub7ybinVeQuTKu1EwKJHxZR0Vh6Wn0w6aRUN7
7MWN4VS+W73C+9QlYuDp0JqzBtR8UTf0WKcFY6Ho/sWTx6h6CubvJznOxYLP
3jMK/lS99Ido+XAoDuaiXJjcVD+r18z897bpLQgH5OT9ovyvGbe9Iuf3Oxjx
iMwneki03uLwoD4rHtZ0sUQ4qfUKyo7XGElIgPzdMu2+9SRmHWofFwh/Dyn/
jesfota7o1o0RfZ+ImxWfR92rJBE/vMnL2o4JUHd3uGBkB8kqgw/Ej9zMRmu
X2/3XfeZxLOuhVXXT36Ae54r4wbiSUx+qqr1TuUj2F6+5330CbXfBW9yaDtT
4eis7tf0uySen+ZTs9/zCUzdRU5oOpIYmDYkKvYmDTi3/LLKPU7VoyvZ8Gf9
Z7ibbFaSsY/Enh7DMM+4z2C+8bLdX0WqP7HvKzvi00Hy6DdnRw4S7TPoFc8U
MoA3aBl7eoiJEcfXB2knZUC8fut4Yi0TWT7+S95T32mY6sm6G8/EhKHT3Ncy
vkJ003F5EQ0m1tx7+EtqVxaE7Nv6vXs9EzmkfnpVfc0Cv4W7eu3cTDQ9tYG9
M/sb2PiRyebFDFyewxqfI7KhmOMx/1MdBqoby2d8PPADeDvP76mXZqDdyNkb
5wt+wDcrfVuDBToWbPjFyCvOgR87B/I7M+no9uRp38PyXAhd7rMkTJSO8Qr5
7/YZIBh9Hu8IJoex+tekFaMKIVTvudzvwmFcM5fqmGhHgN7P/HCG4zBe37qG
vvTaLxDjrnu268cQykX09FQ75cMkBLXUbxlE9csL+R++5IPcL/0hydkBPLld
9O29yXzYvnx2T1bBAHqXHbuw260AVL7Ou7SdGcBmjozWSI9CqBmXL9nm0o9B
tj71lr7FMFlovuz4814MKOX80pNbDLz1ahJPzvair7JvqM1cMSyV9T2rK9mL
rqO+BtedfkPm4zm+Awk9aHn73h8v6xJwOxCRqp/Wjdse+udG65aCm2/Ge6XU
TqxNfJLQIlwBnUcsZCqzmnHZuN6+FMMayOHkCDGfyMUVzdsvut6sAYlHXwQU
j+WgCCH66EBoDdyW1W2Sj/mO4o97mhtra6D45GFjoSOZqLjB053XpBaIq9f0
QfYtHjD68N3Cog6Kz2u/eV/0HlwyBVRX2jdAB+2i2qkdpXD7JXm+5VEDuHCt
++zjWwae3nX+71MaoFL0GKur8i/46cU2aDAb4IlilcTjXZUQ3KPqanejkXKl
l/iGP9XwQcTma75rE3RObv1V00jldSra6XLvH8goXRm3+NoBLb95xRPf/YMz
JdLWvAsd0Lju4GJTwT/g8z8wsetgJ1QW5Jdo8LZA/yOHLOXqTiBEflnwPmiB
d66i4Qf6uuBN5o+A5/6tsJjucu3iRA+85J+7WvS+Fab8Cj+U7uyFcLO9p6aL
W+EWh/WfmFu9EMTzXcKMvw1W+PB2BJK9cNfoa7rswzbQK6ERWzv6wGI8rSU9
sB2KVsgUG70dANMjI796ktuB3+/7QHHjAJyO2vp+TWk7XHw7lBS0bBDkZRpU
f/J2QLSK1pmVzoMg+ec0t/ShDnjWnuRZsG8I1jlNTKgZd0Dh8ieRH+2HQFwy
bOCkdQcExA7Ytb8cgjU3a//ee9ABG46fFxadGgIh8VMRA0UdkJuT2JmdMAyC
BaxAzoYO0BiXYhRVDsOSayF3xPs7QG84cXHl7DDw5VVZ6dE6QUxBr9BSlw4L
tgbKaYc7oelM8J+8TjqwV41IlVDufy7Y3ZnIS92Hfz4V7rrSCRIjF2ILFRkw
ubJialVAJyzuXjzxxoEBzO/H81x/d0LdQJN09hAD5ASKnTwaOkHBes70EOVX
MxMtBa++TgiPSDeXkGbCn8ntjx/wdMGtpTvVk4yYwHkoRTNwVRfsLu3qMLvK
BNUwudEnMl1w5flUh8l9JsTvEDUO0+qCu25vMxUymNDi+4w/8kQXxDr/ujXz
mwnC1Ut+RFl0gVXh2csr25iU/+el3nl2QfzL9f0r+UjIQpfq94+6IDml4/6M
KAlMoZF7H152wf1/2k5ym0gw+9g1mP6tC5y00p4cOU75iX0u6mtxFyj+TBvS
NCfhz7E6/ez6LriKh+dcHUhQHSrO+DXeBUe0t5alBZDgqLbfupC7G/w9lLo+
hZGQEJAtWiLcDTnJq8+MxJKwSuHjnUqVbtDnd9q78xsJui7yKrXQDTui7svs
ySPBu/BNV4N+NyhKFJu5l1L1ioiF/TPvhic0w8/zNVS9F0MOtzt0wyWBPDrx
j/JVxtLZLo9ucFbV6sjvournup/SF9gNgsruF/gGqfoNFyyGIrvBijNRN4BJ
1R/jupKZ2A1Jux67Hx0jgXNkJH80qxvi3Zxqj1KeVAU7l4mibugw2qv1kPKm
Y1C34kxdN1zP006mUR5NaDX7x+7phv2v/bgLKd+2bq5/wjHeDeTi7f2/KL+K
eJ7Q4uHuARm/nRZsKtYt/c2iCfeA8wV9Excq9hE/EL9Uugc6vUa2b6XGf7P9
cWa5Sg+8M62akKf8zPy2c8kq6IGc+p0fzWeo/vhTc9bo90DL1LBtzQTV3xkF
R3HzHqC7G+0PoHwemhAjLenQA6KnTY57Un7/MyFWK+3RAzb/XU351Ef1dzD0
gVwg5ZTdoT4ylHdVnwuqbYzsgUtqp8drKe86dt8f3pzYAxVFRSrFlVR/2xdf
q2T1wOY3fldmiqn+fNwMdhb1gJpz6l/7XKq/qlEu1boe+PaRjJLMJOHYevsv
+3p6wJHbaZVwEuVZx54rMNYDzOXDtw69JoFc1lB2aGUv7PEbX3XLjwR5cwMv
3fW9kPX7MmnvTPWTUrJNf2svxNf50ROsqfp1c8JPH+8FX/GKzJ5DVP0vdx09
a9YLc3LJMED5V3Uwdc7Mvhdoax/ab91A1esfa3npYS8oCEQaBy4wwfLz1U8p
kb1QWSha0D/ABPF/agvjSb1QdGpLmW01E4K2VL+6/6cXPOvzVNrimOBSx9WQ
sLQPvk1Xab5SY4LKYrkcubYPXnXfP6oiwYQhxVdOezb3QYrO7+fkIgMsPHcI
/9brA/sM220jeQw4JHvp+OCTPrC57P9hJTCA47hK1LboPrhaav99xToGZLuw
h26n9sGK1cOK+6fpsOXP84AlFX0wEbhx095UOqy5UZi/aUU/cDeZk0kr6NCX
K7/3Wkg/CFv7nfVMG4KYAVbA17h+KHfuGxTxGQJTYWxYSO+H29zrTEcNhqD8
8hnnpzX9cPg5fZcHk/KxYEBamsgA0B8+uTuzfhAemA7Kj4UPwG/+0p7eS/2g
de+L8773A7DC+UzyFaV+mP3oU+CXNQDz/kpcB8k+uMYpbiXyv+90lwRb1LUP
jBN1X+8SG4Rne76uPe3VC3KTH1a5vRqEdiX1w+9udYNooaHMh+RBSOT/vrB7
ZzcseT6l0vZ9ENaq5TFPUt+FkW3a+jqNg/D+Lkfi5ltdkHO1OWDF6iEgtc/b
hNp3glEv/0Ji0BAsD1hlsflZG/jWXh5o8hmGOys87S7crYO2dKmf+2wYMB3Z
cK1qawz8Vb2pJOPKANWbNtZcMeGQk1vwgv8BA25/qe7/ig/h1R/bm3VvGRCt
tmGX2z13NOnKUHBsZ8Af19VHMysSsGrlkZA4YyZ8v3h9b0p9LhZcv35F4CAJ
59wUnoVqV2HGZF4teYoEjX3LA980VWGc5+oD9VYkeAT52O53rEafgOx1b71J
kA6amFaNrEHNGJ5q9RwSjoTGZIX312HLFT3Jb2IjIKS2YdVK+2Y8/aIjYDh4
BERTUm8OuXdi0OGMZZyRI8DFseVv2K9O/D11P2RN7AgsednaVUDrwr0mm6L2
fx6BuV93whNCulBSzOXTi6oRUHyUvF87rhsHXi6t1xYehWs33xYeet+L0sfa
TM+Kj8JUzZE7J3p70XQurf2azChcJHymcmX6sOyc8WDkduq50Arv0ld9+Hld
LJs8OQqgwzHg8KAf3aN3y0aFjsLlw1m/HdUHMUNfIPHzq1Hgj3NM33B9EOkL
/zYXvx0F06WKzxXeDqLFeZ/drIxR6D3ulraSNoTa68uOHqkdhfyvt10Ni4bQ
szK63LxlFHK8DigZjA/hV+8bp271jEKE0yXVEOlhVOxcYx49PgpiBsNu/24P
o2DchevjIiyw2iOy9YI0HQ+e3DkhIMGCW5nV6meP0vEuF81dSo4FccGypx5d
p+OIVYqf7i4WbLqRfDoyh451slPhMadZ4CjcJqB1jIFCtSVrv5qzoPKRYNCw
AwOP3IuKKb3MgmmLnTIlTxiY3bM/edKZBT2TAgNr/jIwOv7xT71wFgQJzMv3
7meik6JeXMNrFrRP1bhpnqM8+2Gpv1U8C87d621su8XE8bRAA7dMFnzqX3Bk
xTHxzw7dXdw5LJjavyfg0ncmxnwVEA/KZ0GqiPCNtRVMPJYT0P22mgWLETPv
T08zcT0c+b2lmQX5Lk2zDUtJnPxF+/i9kwXhUvyKryUp3xU/cKkYYUHDKhs9
5n4S3XQPnTOdZkFY3TWH2ydJPP6XV6t3kQUdV52+HbSifF19T2BOaAz63iwx
ifEisfy0DvP+mjGo7C2YVqY89LaRu2aF5BhAVN35uUgq37n8rFdyY3DbVgP4
E0jUb/ONklceA0/Gs+NGlK82XDjg83nnGOz0WTzYTvlrppvTWl19DBqbdAcS
KZ+VW//SLdYegwPB1dNplN/eDXpvPXlsDLY+Dtaaonzn7qAl0npyDLxPrX3i
QfnvBLk4fcV0DEw13qdpUF7ecBNbWRfGQOkhzVeD8vLs+N28O7Zj4HP2U4s7
5ctKV833/DfG4FtIeswE5c+E2flHoW5j4Pa6KP0j5VPPOz+vS3qPwZygNjuO
8qshx53TSf5jILJRxr6O8q28n/renU/HgMOMk6VD+ZfNy5bE8DEg/aQDRqm4
OuAHt270GJxQvLLxHxUnLvUYqI0fg9oQ03pOKr4btPfv+Y9U/2UKzy9T+U6t
nP08lDkGKZ7RDnzUfIrPv4c751DP07Zd65kicWHNbQ+OAqq+u1MfFsdIrI1U
tXxUOgbPwxM1TEgSk9ZN66ypGQP/1DfAHKTyv8naGNs8BnfqG6t/dZNoJOMq
tLlrDCo+jayraSFRKX732NfBMRjwlz0iU0fiosJkw/7RMRgx1vP7VEZ5V9k5
9gzHOGzQXpi7951E77SdD7po4/B0hV7q31QST+8Yt7u6fBxmrq4xPf32//+f
sNNPchysv6hnywSSWP9ju5iQPPX81Tp+W08SUzRZ8xHK42B36Y4veZXEMzo3
ilPVx8EYhaxy9UncXKySoqYzDqMKR+7TNEnk0h0JLjg2Dj0Ryw1DNpOYesLR
tNl0HPInNYOv0Sh/n7vK4L09DpPVF+31M5m49pjx+h0+4+ARrHY67xUTt++D
U5YPx0Gw75rYOV8mWq5d+T07chyc+iKEFvSY+PNf5j3H7HEwvAUrpBoZWFv6
Oisqbxxk9p7mq/jGQPqPB0Mlf8ah7fenrckRDBSPMjHY8G8cuHemZfeeZqCL
GXtt09w47PmSbvi4iI5P9Hr1+Xgm4NaGvjNpMXR8p17us0NwAtaWjljT3OlY
sy6m/8m6CYj+Zj99UomOKq3aGQc0JiB3Ivm5l88wDpo/0k25OwFmWQpGmkuH
kEPf6U7TgwkQKzrTu75pEEU1zdP4nk7AxXT6Zd2EQTwkuXXNhTcTYLrlzJCr
5iDGtVV3riYmwEGLd6W19QCanRe/7cU5CU9vG7zrD+vDcsuk9yfvTcJN/2Un
1L260FfWa+/Eo0nIoT92KtDowl19Rn9fhE5CqMz3781znRhlzzHWEjcJjCxi
1TeXTrR3OaN55dck9FccSL94pQP5H/PWeSxMwuHOwj8D9i14IOsCV7zbFBiw
MkcPKdbgl2Xi5lMO09CYe7QsfJkP9G069OaW0zQ4ib6VZZ0MAVHdm52kxzSU
f7nJSJaMAs8Hfy4PBE7DRq8tRWNN70Fn0f1aU+I02F4PW/s74wtUj/zz+tFD
xSIWT5JCCoBZ8zrOy2wGbh6WuBlXVgPrWSU9cxdnQN/HJd7jQi2cXDEp72Y/
A/uvpD5pnqiFL3r6H667z8AhqQfhayXqwbNwIeNCxAxwOAkMHL3cCEuyzhdq
185AlmSujnlTC8i/lB6g6c1C2TK9W0lRXRAp5+ombzQL2FGf8ayzCwQ/l/Ef
NJsFn6M/34/LdcNYsetGX4dZWC68Xkb2YzcQE3/t2I9nYUzVw5uZ2QPnDN0Z
I39nYfd6zrKUxD4ob6m4s7x+Ft5Mvne27umDAzZyQlvaZiHb0MDnrlQ/KHpV
brFnUvM/MtXMD+2HyRT5671Cc/BAta30ptMABPPXsJpOzEHoeIrrauqew/1c
0W/6zBxcNnBomjs4BC5Sd1f9ZzkH03aquYouQ2C+e+NOo+tzEO6ZWGhQOwRK
l7ycy4PnwK/scPsX/2GIJmt5GRFzcLpA7WhK+jCs9FAKXxo7B7wpgQrtLcMw
/azu65HPc6Cnxv9mYgsdCnHTdF7VHGhf27mvqIQOqsd8Ajqb5uCA66kebyYd
UurrRTm65uDDwio9R2EGhDB81DRYc2Bz/KZ19xkGWK5tdM8SZkOvWu9VoSYG
1CQoL60XZ4Pal2WP9aao++52v1fjMmxwqr2yNkuECcpHt+Rs28EGb98GI6Hj
TJh1uTf/4RQbpLPaGJ8ony6pK2LAOTZsph3rSCuh7uM7BNpqrNhwZZ3MnXHK
p2rkk9y5G2yomwn6tJ9G3aOOV6Y+vc2GjtTjx3XFSTD5IPxG1ocNbZPl8aGb
SXC78sLrWDAblv3uLOnTJyGgsMmx/QUbzgea55EWJETIrrO89YYN8xedK/Zc
o/zYHqP1KpUNs7J7Mv0CSSjS6FbZ+pXqL7W19cELEupfyUnn/6TG/5Ygit+S
MHkmmXO4jA05Z1Puc2aTwPeVPnq3lg0+v/Q6ZvJJWCOytUu4hQ2SHcpdW/5S
nrl5ozqhmw3142knY+pI2FWZkbd3mA2cw4Pzx1tJ0NkymV7OYoNDZEzmnh4S
jB6rvrWaZUNaj6Ge+RAJl4bcQyc55yG6QOVNLkmC05GffoEC80BsVnh8bpyE
ewmLtyRXzsOfhvrJHdMkPOc5cClddB5WTEYWH54j4Z3VPaND6+dhNNdvOJzy
aQZRpNOsMA/qvZZG0pQ38yQFdl3bOg++zKzpPiqu9jwmx7VnHs5dLanpp+Ku
5ierwzXnIVQyuFeWilmqlbxKh+bh1CCx/RWVj+uF8OTP4/OwMe9PwXFqPuEJ
oz7D0/MgcKM+aR9Vj8ypF/W9ZvOwc2/R+CWq3m2fm4puX5oHSbtdP0uofrSW
r8ta5jAPmgWuUnZUvwZXLd7H3pqHptoI9UPUeliWxrzY5TEP5XLn9lpQ63V9
Y7d/ie88WBrv0U6n1tPbX87NPHAeeNace3CAWu/g3is2o8/m4SBX4p7lBSTE
aCeb3I+ch9Qr6U9Fqf36FEs/IhY7D329WGrxiYTcxS1qHxPnoX6yULmL2t9y
8xsb96dR9Z+1YcdR+88UmxSwxXmI/+/ayjZPEhZcVWfZRfOw7tZ1tgl1foTq
3YeCy+chcuPR18LnSVAOWfzzrXUeUl63emprkqA+sv+HXu88kHNm939Q51NP
/96HDvo81EnsarhFnV+HJQKP+dnzUHtxm8T7MSZ42hzzjOJeADmtkUWZdiY8
LnrioLJ0AbaF7RHopN6PFF/h4ybiCyD8tDZa7jUThmfXCiWqLgDL11mrYy8T
1Iv89dq0FkBR/jo3SFKefTYWKHJ0AQRkTh4s4KD8qlhK8zlL5VN2f3MwnwEu
p905Td0XQPYPzUVdkwHF6/sg2HcB7gwV/u0XZ4Ao3fBuUeACXOjWmyAm6fDD
d+Pc9lcLsLl56C9HCh040hrHl+YsQNqf2PhaQTqc9NDZcaBgAfTT5E4Kdg/D
20NpN9zKFuCrc/hL92/DcKjVn9nTsgDKoc+rFy2H4dGSPQM/56l+PyZ1VCQO
wZrLYf8cYRHI/PJHaSKDcEWFUzzh8CJ8Z1YpMdsG4Nucg0nLiUW4KZiv7JY4
AOdCdOqOWC6C3dvEh65qAxCDY+XSPovQoDrUcOJUP2wSP5lXk7cINasPRDde
6YWYK/61a2U5tMTazZyL13cCv4dNqawCh5a01Jvb+5o64HrQ0bxNmzi0oE14
995nHQBflqbt28GhtVdB8jwutkMbV/Cjc9ocWqsT+27ypLXCuuiIA68ucmht
Ew9PaxhqhIjapDTxdxxaSrasbxvK/0Lw/rLHYnKcWidvJm+6ufcbHsp9u6NF
kVMr7BwqW37MRvZej+bozZxa0c3dESlSP9Fmp5Lihp2cWvUMvkxhzl+opRCQ
v0WbU6uS6+kjz7ZCHBHUmdW+wKll4Sh+MuFuBZ5o/HHl2mtOLQNxDpmGFU3I
czpUaFssp1Zbhu4ft9gmzK6y+zL2jlPr1ttL2722NaN8qRj37RROreB21Xcp
J/7hwk/XaL8fnFqpu28/33SvFVPf7qiLaOLUUhJkxdj2dqCQ44cD+au5tB50
z6hot/Tg5bgXKxrEuLQsHcRvZq/rxZw6v7YhCS4tptuNs6/MetFW3cxdWJ5L
a4vPWe7Q5l4sEFiWfmE3lxY/2bt8Y0Ufur+7Js1xhksrdvOrSbfIAaxqMCVX
nePSyi8kJnMrBlBx6eGfCue5tKpC6DpGvINYd0Pq7IkrVHyV3mR9bRBVoDI4
2pVLa2OO9yVu1SHsa9rGoRHBpVVf//RH3/th1FgmWW4QxaVVklrfcrt6GJ9r
LYm6FMOldUfK6t8h9jDuf9+153Eil5aP8+qKh8fpGOUU6vjvG5eWyo1Ky+d9
dBx776VB5lD5anJWNyxhoO4/+6Xc/9fCuUZTua1xnDWX9YZCcjvu2Vty66Sb
yuV9colst0i6CIWkwk5RyNqbXHIXdiK6ERWh9klZxcSRqFxDiYhYsljrJdXa
VJy3Mc7H/4c5n2f8x//D8xtzjqeeAXOWgUK7NXws3GZVotfCAL8L87saQvjY
RfrLYHgfAz5kae7omeHj2xbDZanvGPBM7djSBGkBFglrjbg+zAD7Az8eHzIQ
4LsDNxVaJhhgmD5Wke0jwEyZzNEBPgN8GbrHJqIEeJ8l+/70DO2vap6IX44A
L7mz21FpngE1/Ya81mcC7PXOQtVggQE+ezLGqgcFuErm3zySgeBq/W3x558F
2Oc0Ee8vgeCic/GBXTQvcu7MukZKIZiReeDXakRhmcGhlemyCBYM324/YkXh
WqtHNVXKCEpfFpwX9aewz3CeSZw6Ar+9hrJfQym8hB1V7aqFILShy1UnlsJ3
lb2NtVYhSBaGfsm+QGGXhxYPpnURLDOsKTS/QmGhq/Z6bIggYlhK5tc7FM6f
Ju6lGiGweJo1bfWAwlzd1jK9LQgKwioWjFsonNxUoTdniuCVTkileBeF1/pk
3noGCKw6Ggbl31K4Z/HUqotWCARFd909hml+zHcv8rVF4CAlIRgYp7DGlq1a
6+0RcOoiw3P4FG7sUb0m6oygu+pkb/InCgeELKp1uCKwlTLiVn+lsJT0yOUr
7ggeNdWnrZyn8N+ljf8K3I8AH0KPG75TeI9tSY6JF4JfjhXuK1ig8I/RRHkJ
H1p3axy69/N9Nfp41pvDCCatnj1foLWNutPykqMIVLZVZ8bReopjlB4ahCBo
A/eJNX3+grvcMqsQBGe9pXeS9P2bPn9Nkg1DkF3WtD9kjsL9GX1LhsMR1LoH
CQa/0Lxm+CS+IgpBa8pmjbgZCms/v8JkRyPIe7NK3G+Kws8PR8fYxyHwiRF/
yeZSOBj5iqgkInBrYqd0DVFY7tp29kQKAstPMye931C42lT3+8MMBOd88ypX
d1DYs08yIj4bgWJgRKj+MwqjMIFw1yVaL/ecP1JD865sZ+gv+bRflX2Rw/cp
7FDx9+zMVQRqqbYmf5VQ+NNvF0/UFSJQMH7Bjr1M4ZyPZ6i0EgTHXltfqEj7
+b97f+CBUgR63p4NCtEUjq/VDJi/j6BYv7Y3z4fC+vvReHMVAlm7JSceudI8
LxzzzeEgWHdpJmeFJYWVjUq9NzTQeS3MNozVoPmxcOOeoE4E7U43p/a1C7Ar
KPWa9iDwz9lHnqgW4H8G5l0l+xCIxDkONN8QYAuFOqdb7xE4stUMzE8KcO95
O5sRCkGY50zxTkkBjtQ2fFo5S/sVyCmPofhYs0Ha8g8hnadMA+5cFx8f/dZt
rrpI53l8sawmh49/BHpt2i3FhIeNwSsqlPj40GZ+8nJZJmTop5zqEE7hJkbk
8Et5Jpjm9rKse6dwWs7FFEs1Juz47P9B78IUVq9vHVlrwISDL5fuF1mcxOZy
pumSdkxQd3yncvExj+a/ltEmByZ4JoctOGfwMOu2+9aYnUww7J4LCPTl4Taz
k2P/7GGCR3fF1zYJHvb0v2PC9WfCEfGkYBfnCfwHR+ljXRwTUgKSel3wOB6N
LTY7m8iETjWV/ltJ49jWaUOWcSoTHo20B4e4jWOZUSfz8mwm6CQXWfhNcPG1
ZQnZlwuZIGo1K8OX4OI67y8QVs+EYc7xwtKNo1iU6MrV/8GE5NnBqsr17zHr
/CmFzaJiYAiV5pXdQ1hCXDHLSkwMNmWfS9bYNoTlJD1SDiwTg+TWG+3BioN4
tTSXna4mBrIJJ1/u4PRjR8V5n1kzMVhp810jZaAX5+torXnMFoNzVtKHFX1a
8CbbkAY7ERb4H7xhqfuijkxcJ0ktZ7Kg3VxbjsNsIAdUi1T6CBY0J9pUD5j9
l4yZ6TnlL82Ca3JDudXlT8m2vC06seosoNzfs0STnpP+fJGUGlMW2FZ3+K+S
6SIvZaa7rQ1nQVnPSSHbvp+cPLs6RniWBQkmhecc+vtJGpbLa/9kQV6oac2J
gAFy1GSWcDjPgu17T9+6e+4duXZsNycghwVr1cP2/VUxRLYYq2sUPmDBhhwn
r5Uzw+T8QNlH+U8sKDnS45bQNkZaHW/OcPjKAp5idc8bKS6Z+u3D5rh5FuQv
KbKOceSSmsoqiZ8ZBCiEBx3uecElbdwTdV+tIKDyrP1729pxMoNb1CmhRICr
p+kn7blx8m1oXbiFKgEOzkke9us/kkHZwpZ7vxJQKHPeNejmRzK70+9oxkYC
vulr33/95wQ56B0t27yFAM/j/rYdDyZInel8zqIZAanTst+YvAmSI9UtEbyd
gPjw8FhVZx45/JtFqYM7AZHlE8pvZSfJNU3qUxLhBMgXy/S4nJgiz7htzbaI
IsBgqfiEV+4UWT/qZhoRTUAWr0Ahq26K3IVSUyYSCTBihyr7L+WTkfDNoDmP
gI8VT6uKc/lkY7tCz+IVAuo0PTyecviklNe6KONCAhhJBWzRfj55IyqgtbiU
7reAHdCmJCCbOa8D454QMG5HlVxPFJCydrPyNXV0v++XvsosFJAefVK1nxsJ
OJMmn5r3REBSQmsp31YCvO5JcniTAnJzwsGqy50EEMpRjUYMioxRiPJ81UOA
qNlUSooizWsb/1NuMUgA73eR7giS5o3G9t0RIwRUtB3RWuZCkbddJxfucel6
aZ5tlT40/4ywSiZ4BBy2PrvT7xQ934doOa2kCAh6GGGgF0uR8aLmwj2zBPx+
fcP4QiZFTyt7r2YICYiwvyPz4RpFKmuG2jR/I2CUxyR771Lk//dNwenaXOmf
+6b+B+khEnA=
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64828#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVl3k4lV0Xxo2hVOpVFA00USoKr1CLDClSRIkMEVKmSMmLEilSRMg8Zsgs
IdMiJSERZT45A3Kmp6Iyle/5/jrX7zpnnz2s+7732jL2HqaOfDw8PCW8PDz/
/+xRyEilLrJw9dTfAPtU2qGFlKy2kQUWdjyNXtVRZQvbV+b8GphlIXVmaY/8
Uw/w+/7M+OMUC2f5q9Xbk27C5sqKv68mWOh/d43keFwkuEOrTfYHFgodbT2W
HJMGwqbERuc0Fi57uuJz4sMS0Lx+MI19iIUmt6OFCgIRbI/Vp9S5MbFiv0PL
Lr0uiCxQc3F5NolHl9u4Dg30gSV3YRWL+RW1DC2dHdkU+PIyu1pJ6isWSXBF
PwrT4co/BgrmZydwm2fAWvNV41D/szPl4N1xVIg+fqVi5it0KC+NEQgZx6iK
/jOH+Cdh2FvvXvutcTRY/vZo0/JJWPhe63XWbxy3ymzULZedBHVu3hEft3E0
qjmjrWU0CZXjt78XniLZ3X1AJHUSSvtU9aQ3jyND5HAzaDIh+2Uqe656DFd2
H1FIs2cBe3y5+eyLMZxKqPZpvMQCZfGA+t/lY6jdxJYe8mJBs7vVw+nCMfwz
0uq/cJsFtC2Sitz0Mbxg2GlIZLJA5uEjb+q9MWzccMw3hsqCVPuQubcWYyjx
SJvZepYN45FT9i3mYyi3nXNo9Xk27Km3b39tOoaKH1+9MLvIhnoJ7eQmozFU
d53ge3ONDcMdfw7Wao3h4fcnmKYxbJD693pQsdwY/t476SrbzoYnyy4Jx84w
MH/wQ0yICgf433aFmP5k4Gq77E03NDngfvtfXrEfDORyN1s66nBAZ1ZgLpzF
QEb1/p6tJhzgjqexblEYWFi6Nw1cOaD76lOn62sGLvB2fKelc4Dw1Y7VjWLg
jXUeCT38XLBUzlvF94CBY6aPztSIcOE1seIhhjEw78KvsCcruZDoNByqHszA
pj8juhpSXNA1u+6reI2BPwb/MNbtI7/fW2QlfY6BtD1nHdVtuKA/Lik7vYOB
ptSFlD8lXJiMfL5qciv5e6Hu9YEVXIg4YMxLkWFgWmDW3K9qLnyMCB59K8XA
8OZPlO4mLljv56YmrWSgv9ngeoUeLly91Syl85uOoVsJryvTXJDYabNMbZqO
Qfa1qddnuFDTMzOn8J2OJgcLpK8tcIFnx57BtSw6/ojlXXZOgICI90+eMCl0
tN+uH9f+DwFZ693XRLfQ0ZlyLkZNiQD918KCd5vpmKpe7d6sTMBXt6zp/xrp
WDim80BfjYA9Tf09jjV07DLzilIBAmqcdaIPFNOR78zh+EojAj5WSK6kxtLR
enUFR8eJAB+b538/RdNxrXlrvKkLAZLCxty2SDq+KhfwPetKgI1V8PuKMDrK
y/3uO+FFwCQv9/69ADruXHOA90sAATwnmoUVHcn5hDWsQmMI2CndY6hsT0c9
rb/Ky+IIODVJe6hmS8dYR+7de08IyAnmW6N9lo5qHb/jXFMIMKzWljE9Tket
tuCjgzkEXL1jcuH0MTpqZF8bls0nINX0fK7lEToubRBhOBQQ8I19a7eDNh2F
AtjGH0oIiJNpPHBVhY5J15bdMawmALkf/H330TFa2Kr4TA15PrVf0H8vHU+p
KxmcqyNA4/Si3h15OqrQQ9uNGwkYDT9kGreBrJfAR/6BtwTsmq67VC1Ix3v3
8/qDPhFg1tRRVMdHR9mJtF7xPgICHw5/a1ykYQHqqqf3E9Alt3Dt3SwN5z9t
0k4fIuCatUbwIIeG+x1hvx6VgLSdhi0UJg0fd770SqIR0PrbUoQ+QcOgRNl1
TDoBUtF+kSwqDcf33k7wHCegseVl0sInGo7F7rOTZRHAjHlH4emhYWFhR6cG
m4B/zg/ICHbR0JspknmcQ4DT/Ezu8jYa6hRc8rEkCIhsFWatekvD+o2rfMy/
EVAdK7ln7WsaKifa9Rt8J2CZolrFxgYaPvIXfyc5RYDynyO/ZWtpKHp66emf
JNu0nVHfUU3DTukOvbZpAkovXG/cW07ux4hpZP2LgEGlu/zKJTRULxh3kPpN
AP9inL5aIQ0vMLjD3SSfTqjs0MqhYUfrtekdswRkTtdvEcii4fclKm29JHNP
vPF7m0bD2c/pub5zBKgXdHSHJ9NwtXZExD/zBNxd0itnnEDDrO5236ck954f
urkqjoZWCaquexYI2FxP+9wbTUPV3TlOxSRXe38PsYqg4Y6sJZ4xfwgQ+DAz
tDGMhrv0qgJnSD65k2c/7Q4NtfezY8z+EpB8Ryj86W1y/0/ul+SSPDm6gnrx
Jg1btwZ2fydZVXOtmoI/DWVES2b3LRJwO35DJOFLw0tConKXSe78sXW83IeG
S83unEskeb2xwsFrXjRcUrE8vpFkp/z9jw940JDPPbFvhORyAQ3WwmUa6h3f
svEHyX9tDx9uvEhDzMi89Idkw9qjCcGONBTQWlO/SPKTtSbf9O1paBbkt2aW
ZMYViyNLbWkYq9PrPUmy4nvb1PdWNDwzub2/i2R/OeefURZkvc7eOFxCcmuw
u5GZOQ0/83wqDyFZ/ItPloQpDdmdevImJNupB8wNGtNw94HBp+IkF8WGmKQa
0vDEgSy5D+T+577dzztvQMO04xVlt0jWN4pZ3KpH6tt3i7Y8ydG5iae/apP1
PSzS10qeL4Uvs6jgEA3/VN7ytiV5p02+gIcGDX875q7lkPW59rLUap8auf4L
KY1XSH4lXl3+U5mGG43uXOGQ9V3piSIvlWh4QD1E3o7kc+0tdv57SP13NX19
R+ojb3tnFewiz1/1YslOkrVGhh1bttLwXHL2qe4ZMi/VGHVhMjR0CkxSkiC5
P4b1z/GNNHT7USdhRurxyrG5ph4JGt7gsf5T/pPUY5XERupSGg6nFSoL/iD1
uHqTT7YQed52QZb8pD/U3bd3OAvQ8O4v//AZ0k89W1X8uH+ouO/+2qWtpN8E
ok0/z3+joqtdRtT8V1JfnLO7kUPFKC0XsfIJUl8G50NuM6n4Q+Jnsi3pZ5VF
j30iDCpa//w8kkb63cn1wcO1fVRc9rtZ5MUI6e8XrRareql4XMNYEoYJ8Fjk
3yLaTcUgvnc2TYME+Eb7VfG2U1GRsyS2mMyf8GrnUXYDFSttjct2dROwgi/r
2UQtFdcnzIZd/0BAjCHlKq2aimhTkVL7nlwPxUykv5yKe7eJ+iq0kfUWOLyv
OYeKvFPxAmWvCNhnHLBQn0XFiATBVw1kHlbGV7dUp1Pxrr5Uw+sGAhp27rUq
TqTi4x97rr4k87TrpHRIwkMqLj8xNaZXTsB08q9PHteo6P+D7zQrjVzvuFL6
JW8qfpbm1wwg8/3PXrdLjp5UvFF4xEUoiYAlzfS/lpeoeFVBKFmAvB8kJ7t2
6NtQUfhRvnfmfTKfVQpuSOtTUSVy5j9XH9J/7203vFtDxdIyg75DOqS+nkbP
315NxcUPhnWPyPut2//NgOZKKor6ZOcPaZD5oLArrlSYikb/JWWYkfdjffiv
FU/mR7EjTHzb0FYCZo484HGmjiJGwjUN8r51e1VDFygaxYDnB/JM6rggnshp
asgfxS/FnwfuVnGh7srmdN+cUfx8vEf9RTkXlsqEnmOnjWKd8vWon3lcyLtp
8qknehT7Tr8rE43lAk3za0um7yie8RpcGXeZCxZVa55p6Y5iCCWzb9NqLoSW
1w+JaI8iKzbQzVKUCxVFjst7Do5i9sr+5xFLuLAy+4Wn47+jmH/Qy6J/jgMt
Ueb/hu8cxXvlb/aI0jmgfCn2dY/YKDoFBQRPlHFAVn1nw/uaL2hIcaP6HuXA
Y0F5ufUcCpovtl5zt2ODXf/oFakJCo5tEfolT/Z/CgVPaqWpFET/sCyKCRte
nxQ+sekTBTOUzkft12HDdNKEz9Z6CmbKjNHub2PDqX05zXseUHDdo5GF319Z
sNp2i63ObgpabMsYbyP706jqDXGubiO40/M89a0lEzJzXwuxnUg+l3hZ2oQJ
FXGXb1y2G8Epb+tglyNM6Lv68tylUyMYVR7oxNnPhI1K5lsuHhjBjcxwg2RR
JhTmR5Q6CI7g+6UxnCd1k9CaON9mmTKMHuBVKSMxCTwBA4sG74dw32rZtxJV
ExBmHcH/xWAQG2rqj1z6woDQE0v4F7P60dvnr4O/OxVqBFbXty7pQ+mpkqlt
gUMg9Fl8ldGdTyjZ+PNQ7Z5eaK2m2J2l9yBFovO+Re9bMh/Sjm22/ogKEh6W
nTyl8PzGD24UpQvfFDc6Cz0oRq9EyY0SNztRmF9zsPp6K5bcUI++6duOavac
cuOxHuz9j/lnXrEVay3LOjQGh/CiQAOlfeY1bl0n+Lgljoq739ycWjHThJmf
MM6mloEvTNIW213r8e97yk25dxP4+HCGiZ9ZPbZLWJi390yg1/6sLDnNetxT
Uap3kTKBimtyj9xZVo+XE2+5Rk1NYGF/ceShZ3UYL+IVlrDhK2bbNmwqm6jF
roXtdRGeX/Gx2wjE2dfgP3P6e8dWTaJXmNQtO4sq/Ph9T2KvNhND4lrcwrSq
0HNkrqTuGBPjs65YlctVoaVp4J3UU0ysq3+rKjBbiWsG1J1PODJR8Ic3Jzeh
Em17W9oc7zHxiWWHJTH4Apca/NZyeM/Ehl0BKoHWFXh9yrgk2pSFXWpyW3L1
KvA5ljcVW7KQrtcj1rW7AjtHtp16bc9CYTt5tszf53jS4T6LfN+gyeNPmW9S
nyNvHr2uLpqFjIXdYstHy3HG6oKGTjf5DuykMJPsy7BseW3L6aNsVDbS9603
KMMYzWLfgyZstGkrEvyypwylV2kelD7LxvIW/82y86Uo8u7sz6aLbLTA9afz
YkpRsduXUXSXjUbni267hJVgSY3XsOBrNgZtT9mbdLwQCevCxFxVDvbKuh6j
rCtEB05oaMRBDspt0nCUGS9A/ne9h110OdgpMZCYG1iAlDsbti015aC0yJol
FSXPUP+BvNWkKwcrWRHDHavyUTGMw5TK4CC71D/s76enuONYDY8ePxdfRYX3
VT99ios7mNp1wlxM8HyyzdvnKSYL2CoprOCivmJF04Q4+X1+x5pfklxMK2HN
dp3Kxin1FV1Ke7hoWmx5Kas7EysoDcwjZ7h45cyVuKjENNQ5MyA1nsXFjRIP
9gmqp+E8n1KVZx4X2z7ndd4YSEUpVdrAVCEXt54eXeIgmYohPJxS+gsu9pud
uK4Sl4yqQ0Z3Xd5y8ZDpbovBRwnoc/DGV9FJLi49Prlua1gMXtj38VrBdgLF
u38p/7c5Bt3CudLROwncaC5w8mNVNO4UX/XZYw+B+6w3hd4af4Qfb//xF1Ml
8Kyb+Y9hnSgMvSV+c1yXwJNSwbG7/oRhwIZ8F4YdgRe2pLYP7ArDeZexRo0L
BPruesl7z/Ie+phnrw93JjBNg3BjVIXixCp69zJ3ArlWVvopXsEYnx+skuVH
4LoDztwNXTdwuv/1UploArWOplj67fbFIAmljV8fE3jxbE/L5/Br2HZl7/ac
eAKrbkBapJ433hhoFBNKIfDZ1b3pfNdcUFNzWP1cLoGzj5N8axWdcOei68hg
PoEGL4RMrrLssU44yv1kIYHvWcjf0WSBt8wazm4uIzBd6vuDntC1AOK5Wqdq
CPTQldrMbQcI25alG1ZH4Pxm6+J/5o0gd7hPqbKBQO2VgT450VZwcMDjzfQr
cv+hKwY8KJdAYU9Eo0A7gb+aPoebhfhBRMvjex4DBFbG5occWuYPWWc2HJ8Z
JNDHxT9QLjoATn7R2nBjmEA/4VUH/p64BWaegxT7LwTOlVQqfLQOhutKpiOf
GQQOrkuXPyITAjlyadObxgmsCQ7bXscIAd7FevHzE+T4M+c251wOhbV39rm3
T5Lj//KK+90Ig07BkgAtLjn+IkuM0AyHoHUqPUcJcvzH3uUXeO5DhrbOXsNv
5PicXCHjuxHQVTczq/KDQEuxRwLNxx6ATdC2i5umCFT38+NVW/EQfA6ODfFM
k/9//Pi8TGwkCLkc6in4SSDHSsrfUCEKtqm7nfb5ReCIWNSc4MMokG85S1H9
TWC9343ffiaPwLihcD5jhsCivVwfleePYCSgOspwlsAUhv00IR4N+mkd8hyS
A4yNvl/oj4a8ZHdnyXkCXfmbPDapx4A+li3LJPlctQp3ICkGpLudn29ZINDI
7Znr4z8x0HHF0yaFZE3ZTSxj28cQBkWiK/8QqNAX4yLS9Bi29/E2+JIsHSH8
tVk2FiR7T3kNkiyqHeAUGBILgV3h8sp/CVz4+Z2hNh4LOxyj6HdIZj9zcpg6
Egfx8ifTyX4bh22HqEX5cbCiosp21SKBHeIn7S4ui4fwhEoZQ5Lr3r2myLrF
Q6fboXF/kgsDD1iPdMaDffPhohySk/cXD8UrPoHEXS+vtZIc8VXW0jT6CcSq
JhymkeyfEt8vOv0EdLyHxaZJdjUVPfPWPAHsPQKp5PsDzwkFfQqqSoDgKv8K
8v2BRnU/T2muSwSRvs9h5PsDNa9c+vjLLxHkLR6eZ5GssP3LybLhRJhsztH4
RLL00KkPlw8lwZbMbZJVJItGtR7fnp4EgTdW/44ieUH3YMcobzJ4fLjWb08y
e7bsWJJDMqjK2dQpkDxcvP2d+ZtkoCz5nMklz6PDIemI2I4UUOZw7ueRXCcp
1tJ2LwXeWlVdtyS58H2I7h1mCox36zkJkJx8e/YVGKVCzPviMznk+fuzaVix
Mg22HPHU+UjWL1Xx+YcQjzSQs/qaYUNy49XgL2Yf0si+QfAUnaz/7b+Pbvod
SYco55yiT3MExmz2u2t/PR1u7rh8Rofk7MP2kcdy0+GE/mmzfFJPb0P3pa0X
yoAZMxUDG1J//Xnrc/n+zQDGS18oIvXJbOMrYTplQLNzUPg0qV/RlT0NNS0Z
UNsWK+1K6vtkvDfFMjQTnvBIqi5+J/D8S6vxw5WZkC7V0iVGsteQDnfneCZ4
Vn5oXE/66fEm8b9zelmgdpOeIUH6rz+3YkOSYDaUcX65vyD9OfkueVuwSjYY
vbCuDftK+okVsvuyYzbY/t5le5r0s7Si+UGNN9nA7NtR3E/6/3z1z3NDIU9h
wU3WK4jMB6/BkQvNFU9hy8ODtyUpBIYsvHEtYDyF0bfa7FwyT3K04vz/080B
L02XDyVk/jBbVZOlBHLh8YjZsEMPmWfMjdn8yrkQltXxpr6b3O9yoUKWQy5s
St8qKtZF4B6Tvtra5lwIzfqnLKWDnG/g+pBVcB74a+Q7W78hMHjelq7zPA+k
j3br+DWT+91gwNpFz4O2Ob1bkU1k3p2XnJ8/nA+vj3KlsurJ+Sar1yfzPQP6
30iW+wtyvXOzZ4eDCuCj/KtzCVkEOqm7yPa8KICgqB66cAaBR/36me8mC6Dr
73F/j1QCV8xV/ldlUght6z0ZMgkEPpn1TomWKQLicWyO1EMyT2Y4owZNxXBy
eGm2wzUCo9Ss8+FnMWTZ6qbpepPr9+24oipfAjbRPdXSngSqzTzj2/qoBJRk
Qo+VuxBInd8ffVOxFIzm3vN6nyPw8vy355Y8ZaD0vOSxoRbptyQ5ydPry+CT
QelYqiaBxhp2/ibKZfBD3efCpBqBiv990DW4WAaCWjcJByUy/+eKPql0lYGl
f8hZQobAW3OXfoullwN/FI+PHS95XrMM9bdQAXUb9otUvOTi6x0BgkIWFXBM
rXBWi7zPp83XdOl7VsCm7+fPtZRy8VS5nmNLegVIG3P8a3K5uPpyTuQb3hew
RPLjUYNYLkYNOzOam1/Ax81W/8y7czECmQ8aj1SBxYGwtjfSXKzj3LbgsauC
dzJ0AwcJLrKlpLZo+VZBKs3YbnYVFw19DasxrwqkL5bZrhQi+wWlQlqDSDWk
lNi00L5x8F6m27/17dVw4vJeZ7lmDobc+Tb68kQNaNRuniZ7aEw+3LGM91IN
+G/ZJupoxcEXi7mqBiE1YJ2jlH/PjIPjN2wjPlfXAGvM1K9Sn4MG7p3/TsnU
wkBaZ2nhTg6Knil8qDBdCxX/uf0r+J2NMXIXNdOe1MMreOLpc52N3WOE4SvP
RjjiZRvfdZmFuqphMXkBjWDxQSNe0oGFlaGyQw/DG+HD9elfFmS/mrzD/JJV
diNQd9R+eWXAQieXmnvTfY0QLGKRpLGNhXPskDfboQmud92feDXMRNnpdXB/
+SsYPhibq67PRC8+3X1mz5rhHU1l6wX+SaSN5zO8ClvAP+Pb9w+24+iSF5QW
QLyDNK78R5ShIypd3r5mvgP8Lv4S6oj/grnKSmpnf3+AaeNDTt0x/XgqXDlf
N7Eb2hUj2bsedqG6zVnpLRt6oF7xq69qchN2eo0+pG3pgc2Xo0VUTzehw11n
3sydPRD0MtVEUawJI0p9xjer9YBDi4b1mpBGpPBFl2481QMWFQzPI30NGJTb
prs+rAf0c3mdWr1rsPWbhtuqnz2w7+DQIfHcMjwn2Pyla56cr7t0s/j6Mvy+
7phpFF8vNAlqdqx4UIrrdSz+XSnWC1lO9RbMsWJ0jb3Ku3xXL1TZKIatCXiG
YupFscLne8H8Ziz3T34GZhsrC7c694L0TPOBm5HpeMCh1u+uey/Ee7d+/zWZ
ivYR72yX+PfCn1dvTnfcTCT73DF5gfheqBnkTZAqeIQGU67JzSm9YOPjEtbI
eogjQtMrgrN7oXLO8qpWUDguUeKb5i3vhZb1y5zlC4MwUS/Mqam6F9QSWmFn
sB/usRQbuIW9sPfkfPJs0RV85R5vqNXSC+p3M3bfLTuPZ4I3Nix29ML7+HvO
U6c7Gv4H5oYGQg==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64869#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 0.9914361174254993}, {-2., 
           0.3826215565644122}, {-1., -0.6088145608610869}, {
           0., -0.9914361174254992}, {1., -0.3826215565644133}, {2., 
           0.6088145608610867}, {3., 
           0.9914361174254991}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwUm3lYTV8XxxvuLaGoiEIURYUyFmIdCakQKdJAhTQgCUmTSiokY6MmVOiX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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64066#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k8lN8Xx0nJlq1QWSqkEiLaJAfJUiIqW5aSJJIl27ck2je7yJoIlbJV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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64107#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -1.2864981197413093`*^-15}, {-2., \
-0.8660254037844383}, {-1., 0.8660254037844388}, {0., 0.}, {
           1., -0.8660254037844388}, {2., 0.8660254037844383}, {3., 
           1.2864981197413093`*^-15}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"4", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.61`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwUm3c81d8fxy+XKyNltHzTUEYo7Yn3JUULpYQkpZIoKrLKisyEyohKRJTQ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64955#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwdl3k4Ve/XxiWlyZBkTJkTigwNlFXIXCFpUjIkyVehJBUlCQmRlErGIiWZ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64996#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -0.6137303478774991}, {-2., 
           0.9906058375463946}, {-1., -0.37687548966889467`}, {
           0., -0.6137303478775002}, {1., 0.9906058375463944}, {
           2., -0.3768754896688935}, {
           3., -0.6137303478774998}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtW3k4Vd/3xr1mqZBQSRRRkjSoaJ1SkQZ9GpBMhSaKSjQrqcxJMqVMDSok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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64193#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k81F8Xxy1RiCIVWaJSoo2IkEMpP8oeIpXUU4mIQoqkkkKRIluWpLKL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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64234#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -3.6739403974420594`*^-16}, {-2., 
           2.4492935982947064`*^-16}, {-1., -1.2246467991473532`*^-16}, {0., 
           0.}, {1., 1.2246467991473532`*^-16}, {
           2., -2.4492935982947064`*^-16}, {3., 
           3.6739403974420594`*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{"\[Pi]","\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.5`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtW3k4Vd/3xr2GTAkJlUTGkqRBoXVKRRr0aUBFFI0UlVCJkgohSqaUaFIh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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65082#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmXs0Vd/XxhUp1beUhFQiUkgRXZCZKBGKSCKhVESkVBTJpUQpKkkoJSSR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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65123#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           2.4492935982947064`*^-16}, {-2., -1.2246467991473532`*^-16}, {-1., 
           0.}, {0., 1.2246467991473532`*^-16}, {
           1., -2.4492935982947064`*^-16}, {2., 3.6739403974420594`*^-16}, {
           3., -4.898587196589413*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmnk4lN/7x2fGFlopoZWypOWjpCg6j5JKFGUrlPaNaFNRKsnSghBZkiUl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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64320#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV13c81d8fB/D7ueRGJUVJQ8MoTSol1PtkRrJTUZSRUUZSmpKk4YsiJDOj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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64361#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -6.432490598706546*^-16}, {-2., 
           0.8660254037844388}, {-1., -0.8660254037844385}, {0., 0.}, {1., 
           0.8660254037844385}, {2., -0.8660254037844388}, {3., 
           6.432490598706546*^-16}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox[
         RowBox[{"2", " ", "\[Pi]"}], "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.39`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwtmnk81N/3x4eZsUQSbcgeKe0b2e4blaVVWVpol4gUEilKEpJEHyJZSxRZ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65209#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVl3k81F8Xx2UplZIoQkKK1E9FSMlRZE8lLZZSicoSiZRQIaEULQhFUZJC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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65250#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           0.6137303478775009}, {-2., -0.9906058375463944}, {-1., 
           0.3768754896688939}, {0., 0.6137303478775004}, {
           1., -0.9906058375463945}, {2., 0.37687548966889445`}, {3., 
           0.6137303478775006}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwt2Xk0lO/bAPAhDCUtlkoR+aok2rRS1xSRSClEKUvaiWxZipQKSUKURBQJ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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64447#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVl3k4lF8Ux4VQWWbGMtIiRQvJ0oKSc1GR+klCWbJHlFDKWiIt1pAoS6RI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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64488#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 
           1.6538921594855151`*^-15}, {-2., -0.866025403784438}, {-1., \
-0.8660254037844389}, {0., 0.}, {1., 0.8660254037844389}, {2., 
           0.866025403784438}, {
           3., -1.6538921594855151`*^-15}}]}, {}}, {}, {}, {{}, {}}, {{}, \
{}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{FractionBox["\[Pi]", "3"],"\"/a\""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.27`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJwt2Xk0VP//B3Db3BGR0KaiRFSoVGjh/c6HNhVRUcpakZQSKu2KkKUkEYUU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            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65336#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJwV13c81d8fB3DzXrNcLaUUiZJEQxTOqSQiSiKJ7KJCKuubUEalZK8ie2dl
ZORtRkbZIyMr87ofs5Dq9/n9dR/Px+fxuJ9z3ue83ud8hE1ttS1YmJiYspiZ
mP7/azYnmXqIaRU+vNdwiZGcU+IQWNmWurwCd0v41mS6rqNMpZoXO+dW4PAp
5d72PFu07GtoxzO8AnSJPY3h8W7ohZjfsbGqFdjwdm64OvIVyjMgaiJ8VsBm
X8qbJyFvEeVTzjDT+hV4Sw8+5f0qC6VGym7/umMZjlB/yQu4AepPVBPq5v8J
Q9HWCqfONKPftY7rn0ksgo6v+OmZni6kb8u354v6PCgn8jXZ0wdQolPuZzfl
WdALznbt5BhBeTLfi3OBDqpdL5P0aGNo9ehtJpQ4Aa957mjlL0+go2WJrcIh
E2A7vUsasU4iO5XvCWxeE2BSorS9kncSjelqq9WbT8BxJk7u9yKTqM1RLvCy
6ASUPHGZwxqTKKOITfR2/DjEblA35IqeREaKUWcjYsdAc7R7ASlMoQrlL34L
UaNguaDdGG06jfIS3WOm/UYhypOZv9x6GiVRDueOuI1Cq7RL/jf7afS8Lqyj
zWQUvMMXeNceTyMdDZPteXtGYf2s5xdG3DSauLSYev/dCFhdMf4eODSN1plt
q1kqHYaFHtWddfp0xFTd2Dnzbhg2Cay/SzOhowVRt4kf0cOww43y49JNOuoe
G+HudB+Gqi9PJKsd6CjO+p12gfIwqPbPc2gH0dFRezzo0DgEaYWzDsINdHTN
w/L3r95BoGTyuDw5OoOMDgTcTW8YBNG+QlYnhRlk3FMyblQyCBEfNiiYn55B
5jK09prIQSja/C9798UZdGuoJCNIfxCyTTY+ULo9gxYei5QaZX6HTEnvoqGY
GSTF6uTRlNAPd6ts1VtZGeiQQdOdI579cGzYg6OIk4Fk34tcfW3WD/K13+XD
1jOQolnTISuRfrjV3TYvL8hAGlUio2wxfdAl7PRK4BADWT1pUlF43Qsqfb5c
8kYMlMC6myc9oAfUXKzRWhYDbea1dlS41wNDZzRLH+Yx0NPNOcNNOj2wqif3
ZukDA93Zh4pmt/TAvZIc9+YK8v1aBpay0d1QcSbho0QbA32ODCqvSOuC790b
t9otMpBCwrf9l150gUCU3RmHZQbKfCccNnqnC6TZlqvurzFQYHnWHapMF/Q8
D3l/lY1A18Yatp0v7AT6SN3J+g0EYsiwPeiu6gDVp0jlmAyBjE+oD1oldoD4
3nSRyiMEalUOVP/t3QHBe7VOnZEjUKHeLhGhcx1Adfl09ggikLurwlez5nb4
IfXsUr4GgTZ8vr+P6GuDYmfz/FOWBPJuLQl2L2uDnQZcJhetCLTcy8LEH9MG
S3aDp67cJlAfw7/ziFkbvEgQStK0J1DSxndPXCZbwUBTv7PflUByxj/62X+2
AM9yC/IKItBf2j1f6e4W+PUvSpArlEA1VUzyBsUtsLMy2s4nnEDa4tuDsx+1
wGrt4JNbUQS6xdA+Z0BtgaA3J1BPEoEOxQz+8ppshl0ZD9qFU8nxXLRJzG5o
Bs06vQHTdAJ55j9jovg3g9E8cf5LFoGiH5YXZAs0w8GrXS/PfSBQ3bU3dQVL
X+Gnd0aRbjGBLpcX7uYp/godO/l0DUoJZOPD6Ck49RW0f4cNnC8nUOymayo8
Ol9gal2icHctgSiHju0sdGiEnW4PeD06CBQUou3Cc6IRhHbb8mzsItCulTsd
Jv8aIIJH6MHbbgLJlyf48jxtAM4o0cdvewl0W5N/2SSiHvwclt2Vh8jx5xy4
VGhYDyym76sihwnktUktk0ekHi48ML8zOUKOv8/NvDDtM7iP31q0HSNQi/VM
M09pHeyW+VwnPE0goy8ckqbudeA6NnT8BJ1AUzKiPoXKdfD7SSLt/AyB2Fau
Kpo21cLFMxJ0fYJA/tccwgsDasHsig2hM0ugHeUBCzy6tbD/kJmu6hyBZH3q
UgsHPkEpl7OmwAKBqqZG2HjjP0G9y/7vi6QvaP67bnrjE0gF57R+XiSQ1SbZ
zbyzNaAUaTt07SeBfjpdvGuaVwO9/51d2/aLQI/7bjcWOtVA/ewh5xbSb+Lj
H5sy18DpB+Hh4isEsjwcY5tYXg0fWFLs20nLVL25NuFWDYyjNjpOqwRa045Q
24+qgXvzR8UNvwn0aThE1uZvFVhKWUklkva3D9yd87EKwv3UxKTWCHSV5RXf
4sMq8Kw/tieTNCH8dMr5dyV8K84+FvSHQMU5nl2lxZXwQ/L3uWXSnic9qv85
VwLTz1Zznb8E0mxxzTklXwk7sZBXMmkBE5dor+UKKCiqSZ8jPTzr4FtXWAHV
IXndh/4R6J37PSduxwro8O3mvkXaic/OQlO2Aji6hc9Ekj4Vc1s7YKkcNp94
4llOmkfaCrXnlcOF1bnP/aS7wEJyy/1ySP1usWmedJyW6darh8shT77H8g/p
7rKPPMd/ACT3qpb9I31noGAMzACu7MgTXCHN8jer/MxwGaj0bnebJB26IzWy
wbgMXjn4TDST3q8Yd//i94+w2L6ql0W6/NprzS7Dj9Bl7N7kSVrnYfBew75S
kOUUVbtIevL1S5aRq6WQenKxfiPpRyXefTd7SuA6C8ulr+T8N/S6FTD0SmBz
nfGQO+mUVSf/+53FsC1YzGEfacVt9tarOsWgQL9F+0zWt1X+lrJ7WxF8/qb+
/jrpG/rmQhTtInjGGDGYIddnzclw2bf5A2Qd1+G2J+0frttK0/oAXbpQMUOu
754PWhlhTYXw0+icmzHp4i5V7x0ahaC7sF25ntwfmr9OGsfXF4CnnAnfftJO
skc2ZtXmQ/TaArQsE4hX9wDjiEo+ROrHx28hHfdArK64Og9u7vZ+pUPux4Y8
gYefKt6DtGWV+/slAgkd/jPSX5IDF64XfmWfJ9B77Z8fzY7nwE5F39+sZD5U
7YmwyQ/ZoFPqJ7NC5mnYtCps6lYWUB9pf6wj8/bs+osbW43TIWEw8traBIFy
ox8J7jFMg0qWlOHccbJf9tt9lb6aCoZdHg+MyTxLX7t8TFUnGQy7t1bFkHnv
vCJEdVSNh5SnvRwF/QS6vzs6t1M3Dh5fct+B+8j6M3YYyVrEgqTkDuvKbwSK
oZywnmZ9Cz9a8zOyyP4TbCD/acIhDOh0nmHJFrJfzMrtSAkKge4v6yqcvhJo
nbfc/RvZQRDwQby3tIlANBNb5ca2VzAqo115oJ5Aq1y31z4VuQN/d9/N3EoC
TVh36viOOYNOQ59kOdkP+6A9+6m+PVyRfnHwUxmB9mr6qgiuqcE/r8n5YrKf
Wp86Ku6z6IKUBiPczuaS809qpol3haAiPCw285ZAD2gtxTeKw5Ci1dQGN7K/
yz1sMUuJikACSEmV8zWBPl5szd9nHoUMth16RiHPB/O/k5KhTnGoXSrYNcGX
QHap083h7Glo9XJpuc0DAlW7OfJ8fZWH2jU3hp08TaCVk0v81fz56MCpTM9g
8nyTYru3tSgkH7lOJboMnCBQxFMbsfjXBaj83sITPfJ8tAmwwI7JH9CPTf9J
DIiSeY+/dH8nlKJmFZUqJfK8lR3ZwjjmWImeyts/v1zKQBeqde/mfqhEXqEJ
Nb6FDHQrMWRRcrUSBZ9Tki7KZaCYGxt+C7tWoUiLwxErKQzETV/HwfOkGlnG
PRniC2GgwUV2kUG/T+gX65pf5C0G8qUsXn6aVI+s3Xf9FuVnoL+hiTrNY/XI
8rrm6+s8DGQnrndJQLwBaY0y0QMoDKSrWnwhJbkBRVWYJPavzqBdz93V61Ia
0ROX4ETayAzK4+U9yZH+BSnc1NSayZlBtlwbNlfrtaC1F9LX3NRmUARNkln5
WgfCkTRTB2M6Mt8b5KHo0oEaIm7QZcj7nxRaZT4W3oHUCymJYxfpqPp2HYtE
eweqixFLOXGajhi15mx8Gp3IUeKBePAeOlJ+FEXtO9GF9sSMv2aanEaMqXXr
7gv2IIUn/Ert5P1UuXpuW8K3PlRsYlHQenUKzSrfbBX73YfoP9rOi1+cQm9q
Bp6lCvYjq5/N9vfPTqGFTw3Lmdf6EUXqnt3y4SkU9zmxs2igHx2HPJ9kninE
/FU/8OvwAIoic5hQOom+0wc9XR8MIq4k0eNSWybRm1+qaymuw+jkq2qqWOE4
OvV9mCdbdQwNbOkY/O/7KOJltf7Xbz6FercOpQXYDCG97dtTR+4wUNCCV7je
o140zqpR3Cgwh/SaruxbkGpHeWFMtBO7F5DWG4eP7e21KHxjpBMz9xLSfm4W
/Y05G53g+VxyePIn6og47fb1eSbMxjJsV4hlNJ3XOSbqWAelu1aObGlfRSmy
tzVYf7RBpOKqdd3gGiqMxh6zPb0g1+H/8MfIX5RqcWo4NnQIfkp4ax0wZcLv
b5+LPVEyCvrHUUSOJTNW4xO5zvF5HG5O+Fx9ZM1Mpmn9yfS2cXAKbRZUt2HG
U5aTiqoD4xA+bxI9+oAZc20Zc7VbGIfONM/4LV7M+MzmribnHROgI1j/zjWe
GfeEi1jdsZuAC2s6lWqDzNjOpK7wE20SzpZZTw/ps+DZpR8sH05OgUaYtedr
QxYsbqq8N+bcFGjbWe+4bMKCX5re4H18aQquiVhr1d1kwcbbnq87bDEFdt5W
7zMdWbBz7qMctadTEKl587//QljwQAORcrZpChgDFtybWljwej/n3U7a07BQ
aJHwpZ0FZ1bxng2+Og3L/haKT7tZ8MLWsslU02lgPW1h+/s7C9a6V51QYT8N
AsnmbUMMFryS9askLnAaTtmavc7kYcXZIQF1+1qmIeSf8X5VVVZsUxfqrKRG
h86aU9PaGqzY4ugk2nORDgIvRNMNL7Di6X+jAmz6dIgUmJC4d4V8/pFrNfUm
HWJkbCWib7LifW2TJ0J96JBm5rpv8SkrfvduVx+jig7ltRHiMZ9ZcdWbjKUA
2Rlg8ftvPK2JFfftKPjloDgDp3UMk/NbWLGO2Mn6S8oz8Glwl3hDDyu+0C/V
s3hxBhpWksV+TrLiikEpq/bbM9C5v2CPBhcbvrLeLYsaOwP0V627l8+x4Rvv
2xUOsTKAaVdn0EdNNixvqBecysGADdk9rE+02TAel4jcuo4Bx5sHR3ivsmHx
/5zTRwQY8JSPiN9txYatqrjKd0oxQDSAW1TLhw2bPPcLkNVjgGGgsmhSFRuW
9fwn1xnPADsR1eBbtWx4c8sOunEKAzxz1dlkGthw00qM2GgGAzJatUdLWtnw
54i7B9rzGbDKb5LQMsSGnZVHza7WMiA0yFX0zz/yfQmaPn8nGPAluEBUR4Ed
t9uaxkWLESDE/6bEGrPjBfVqMy8JAmxeeWh7KLNjH4acnJkUAbzPNdwzNdix
wiFiE5ssARpuw70chuyYJe2g9zdlAj5brQv66MqObV1uavUYEyAwvrCv3YMd
fzbLrpQ2J+CmeU/5lBc79uP3kXO7QQDH9QTGFj927JqxdS+zDQEqOsfP2UeT
DpxfC3choFrJklkc2PF13cGCLYEEbCxVD1esYscDx7aMDwQTYCYvc1Cnlh2L
jk9zR4URwHJk7ZrHV3a8YU5D+u8bAk7uC/zQ+50dv0sK/HIpmQD/JEet+RF2
7Fx/zq81lYDB3YZjHBPs2DctRkE1gwB3ob0bZWfZ8csfuqYCOQSUbSiz9Wei
4Jm8rjL1YgLWBcRTktko2GHt8qBHKQFG655FfeSgYD9hgenMMgL+cOg0TPFR
MOFBL5qpJEDh76TYGWEK/jJIkfxbT0DRxKaBlZMUvOvN1lGrHgK+Hdyxp+EM
BfOMtFXPfyNgzUH09hs1ClZ2PpRzr48AzH54VekiBX/abJRu+J2AOuELmz2N
KThs/qZg6ygBUzf1DC+bU/D9VBktwTECeLKNEsRuUrCuaYfvtXECtJTuHPps
S8FVqzZCtZMEdF59rrnOjYLTNsXFKDAIWI4NCPn+mIJPYzq/CkHAtsnwvmxv
Cj56q9b37Cw5P8dk60t+FMwSLON/aJ6sT1lmjmggBdssnRHcvkBAHHvB8lII
BdsL/Uz/Q/pHULV3eBQFMzmd609ZIoDS29BkFUvBQmtPXO1/ErBXpG3jiUQK
5iOeiBz5RcDt7KG4/gwKDs7b4vJ2mQC/XxOTmdkUbNZ4QVJthYBspVlp9zwK
Du+PHJ4ivdj4t0yklILTzSuvbv5NwOaNFMoiUHA//+XtMaTlDHjP11RR8MH9
ZkPCawRcjdsYHFpLvk+lMfU16YeTgr03GijYdfXuA94/BERL7xaR/0rWf+CY
siPpckcJK642Cl7wZN3cQ3q4TCa7t5OCeR+XTh36SwArRf5XxjcKHrLUqPQk
LXoeKz0aoOCUqug3X0irBJ/10hqm4Avisc58/8j93qvZuGuMgr13ntY/R/q5
iO6G+UkKzpFzOPGQdIaV4dWqGbJefw/sSiL9Jds8NniOgi1XrlPrSM/+ujVh
sUTBUe9Z54ZI86N7B4+tUPCBPP7+BdJHvF0cOP5QsJXH0wby+wN0mzw+9jBR
sV2MaSn5/QFOG5+xpbNRsUxITBb5/QERBv7qDzmo2Gr4dOI06eK4sMDzPFSc
wHkhqoN032R0jxAfFcv51ocVkv4rnbRrdgMVq40VBweQ3uX07kbFFiquCZcI
NiN9CvIyAwWp2HjnntADpM0ppUtmO6k4cKkwkiDr4X2+SuHobioOD5mPTSWd
Elz/hCJOxTecxtINSNf3ttR3SVBxzqbkD+yk6SI9tFQpKv42olaXTNb/YM74
W3VZKq74ETLbRq6fyu6kMs7jVKxz+9NtY9JGIeb9tYpUzLM7/sQPcv1fOA9t
Uz5DxeuUelq6VglImH4rz6JGxRs07kWcIV1iaHSlXIOKk/uP56WT+2nqZG+I
gg4VR4pMjBiT+485LyJvVY+KTRV2kEcW2b/ErrR9MKDiB0lCpr/I/XuWq4Pv
qBn53EVe2pbc3wmtX3wP2FPx0UTBShYyH6XKL9OmH1DJvM+7bJwjoK1A/XOq
MxUfuSn5TIjME8vrOoqYBxVfuJCXJEjm77pZpYeQPxX3nWaaKSLz6dDhHtMX
RMW7imv0/CbIPJxFEBlGxbnHV7YakHku3V+6tvktFZvta0vsJ/O/bTHfcX0m
ub7qXSPeZH84ZHk/tCmHrHeVJ7/QAAFq3YfyffPJ9UkRfv2O7CdOpVnz1I/k
emu8LMkn+0+HZ+odpkYqvt+rftq6jaz/zxsvyr5S8XKhj3p1CwFsVmLpD9uo
mDKYmr25mfz/8/ETy9+oeFIfBSU0kv10U5TZ3CQVMz22qjGvISDZx+Bx1gwV
v7D3KveoIvvnytbYO3NUrN+/IBhWQcBMf+jA5DJZb+bYpbSPBJxL8tcfpnJg
r/UBJx3zCWA/5qnVtocDp6XfyoiLJ+BKqGjI8D4ObBd59zJ/LJmXpepvcwc4
cFbX2HrnaAK089gt+WQ5cLkCrXR/BEHeB3wenlfhwIFt/hQxP7L/Sj5PrbXk
wOOGXZtsHcjx+koQndYceHLJ/PCFewSMTNUfGbPhwBN952332pH5TOUuZ3Pk
wCFPq8+UWRHQLfay86QPB957utPb7RoB94X9WUuTOfAvVjUpfUz2Y3dptYZ0
Dvw4eT42Q4EAwcFmv29ZHPjja4vTv+QIqIymbVsp5MBY99sGexkC+LYHScvW
ceD+AAbHX2FyPptDDbMnOPAnc4sTdswEjHK/KUzYx4l/7n3P9KmIAVxHjd7Z
HODEDzzZ+S+R5/lBo13xcjKcmOd1WEh3NgNcshP8GuU48cEfo78akxlAu/zO
YvEsJ5bSvKtqEMIApeiyDcqWnLjTv3nrelsGREgP2Y7EcWK9Jq/h3u0MKNOP
t3iXxImLArkeO29hwOhjCwPHNE5sLxJfvJ6fAdIdkyrcuZw4Zsl8bQ+VAZ+c
53ccruDENS/HxldmZ2CxkrXx8XdOLGORGYirZkDzstheke1cuPmV55FLpjOQ
fateWXEXF14XnmrnZjAD/I9tTK6IcmHWiC6ZeJ0Z6MgsiPST5MJYUUm9RWUG
rnGc5f2twIUPUs7z10nMwK2SG/NthlzYWGJvsfAcHZ4Kp5Z6veXCV081Hg12
pEPFzP6LkyLc+Kh55cDCLfK+edDnzJwYNy74PM2sYDYNdnbD8isS3PgrJjwf
kvdVoYVwEc7D3LglSzlvTHUaHi6zL+49zY3/KQ6vXd8zDbKsg6E3zbhx++UI
04m+KUgTCO4bj+fGYmNXL5mqTEHw6bUbY6I8OETuvz3+rJMwz4t8Xm3ixez3
RxpYjcdAX/yP0eNt6zDWHE7/LTwC6vkHkPC69dhn0c7oYvh3eMO0j/fn2nrs
/bo+yDS4Gx42fVXjcufD1zmvT9T6NQOhoxxALPPhY/Uvjz6KqgDJs0zm3L/5
cE/9UZZHehVgLV8qK/6HDwvJDnk50SpgbMeRPiNmGs4deks18iqHgbHd4l84
abhl6UzIt54y+OLE+jFjGw3/lX7Nft2hGDLfVE5YKdDwkZ2Tp3JSc4Du96jE
S4mGL31z8czZngMSHsf9YjEN69/67ZfxKhuSLHIP9yjT8NZcy8vi05kQLRX3
SPU8DevI3DO5/DgNXpZ7bBQ3ouGhP7GHTmfFQn2u4vgpYxq2kjwgWhMcAxyJ
K0VGpjS8K0Scz3MxGjyf3b0eaknDcmvv/xo8j4SH2iZp7LY0vKxYeyA7PwCK
lXe4Ct+l4b3xxlvpTK9gWbZHS/EeDVfp6pjbhD6H+4IXl+470jB7UwXrtQoP
yOXlrfN3pmHR7Qn8we9cYPZfXWTGfzQcuHZ97Ub3XZCa97xT50rDe7akT9+m
mMLtUYxH3WhYt8eYX4CZCv8D+54nHA==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65377#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., -0.9914361174254994}, {-2., -0.3826215565644132}, \
{-1., 0.6088145608610865}, {0., 0.9914361174254992}, {1., 
           0.3826215565644117}, {2., -0.6088145608610879}, {
           3., -0.991436117425499}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{Null},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]},
    {
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJxF1G0sFAAYB/C749yI+9B1ts52cbfTjqaXeZtTHVPMmDjEuuqWI9ndNJO3
RtOIK3QzVKellnciKUt1COlMOsUyaV4Sc15iXHd2x6k2nufZ/vvv9/H/5XG4
lBgWSyIQCMH/8r9jmuUr29uULsLO7TMyHHmb6N7TVcKUDbTjRHv/0ip6wXrm
6dg0+mqCW1RrDzqL870rLg+tKGcXD1LRFZP5iaGWFmDbIUEIl04Gq84I/AY4
5uAALieZzTIDezUJq9WHSWDD7TjaMS4R/EdfWXrhIAH3sIpdO6Smzl3zyDda
ncWb4BK+h4dPpgEc8zBqdqFiA6yuYVoSFTow0/r50c42LdjKfk6tqV8DS8Jz
79fWroJFPZMDzOJlMOu4KfRDtgZcF986/bZtFpyw3iK8o5gGu2SRoy3Y42Ba
+siesvJh8KhY4tQ80wdOzXAq6i9tAtff9eRXHnl2ctdFV7K/iW5+BNtog3iN
ocPgqeQ+15SccfDv9uDuVNU0uDrviUgsmwVzdA20tHINeOLFASUvfhkccW8q
f1G+Cn5UVaAMKlsDm5+TLpPTteDPorqasBwd+JUN47xesgF2VDjMU4IMYENK
zlaDYBO8aLCj1nqawI8v543YsQn8Xct9PhXs5xDB1MQG3x46Cdzh91rZxjAD
b0kvukdSzcFEytcHzlto94Ck7kCCBdjwo3Gevob2k6jkwTp0oXHGM9eAtmfY
ybQkCtj/rIw7TEOXfIlNkLuhXfqYS1bp6LQIrxLfTPT7XxHeGdnocLPCAo0M
fZ1vPKRSoFVvRqW579B7A9fpyi60cIzaoe1Fr+hPUcWDaFu3l02+E2hRrzoy
4ye6TrBoaplDeyexQhxW0LeIJ/RR6+gheXSFXI9m2F/zVxnRO/8L/BenQCsU

            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64574#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[0, 
            NCache[
             Rational[2, 3], 0.6666666666666666], 0], Thickness[0.025], 
           Opacity[1.], LineBox[CompressedData["
1:eJxFz30s1AEYB/BLl7e81oXGUZPm5cTcZpcuL+O3O3NKmqmmyMslztHoTG5d
CdHJSnHdxMZ1O+KyaXREuSY03MrryArlxCG2JhS9bPU8z/bsu8+eP7579sem
hifokUik0D/7N2n25FK2XoQf6d/0Ed/pYoLu/9+dtlyP80QguCOf6s4hToJ9
met1AUQceNPqQjKTSAdHke17DxM3wCbZ61cYxD3wK+IOtZHyCCzgsNdKhpXg
KrfByrbGp+Bm1YiWN60CG+bR6nNa2sG5vOReV6EaLLZOKo8w7wR7Tlu60gVd
4PrluJCvFm/AXfbRbudEvWBt/3Zu8VQ/mB9TK9UceQtWXZRHN6S9Ay/dX+WL
Xg6AFdceunkaDoE9fpaxWn2GwTKptp5+cwT7um5dym8fBe+xyhX1mI6Bu50G
fHSR42D264yIWfF7cFM+r2VgbAK8PKoSSiw/gBvmTi8yAz+ClWY1g4msSXBS
WuikwzSaGldxV1M4Bd7VLJGmHJrGf8OYJ9a70R1CsVLI/wTOWs5tWTD6DM7o
dLYLrUYnuGQ6ylkz4KMjqeNzU+idlN3eBwu1YLU0JuC40yxYJTolS3yBlq9u
1GbFfwFfaWLFZP5CB+3we85TzIHDmiZ54Zx5vCtpmgNatLu349BSkQ68pd9Z
KHdeAFswzMs4arTNBpml4y6CDclyhWDbEjhk0rTVmYwubhP0jeujKZfZK74m
aAetzsfAGu3d46WR0NDxRR3fVJFoRaKLQfIZ9HxQyV7qWXTaZpzv9Vh0Nt+g
IDgFXRJ2zHY8Bz1Me+ZelIe2Mdrn71uArlSvxFffRj/2Kn2S9AC9aLbVYVeO
9tRxBzUV6GYZY81Lhl4XVRnPyNHMKGOqpAZ9lZHuEVyHVlMmAn4o0b8BwNww
6w==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$64615#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[0, 
           NCache[
            Rational[4, 9], 0.4444444444444444], 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 0.}, {-2., 0.}, {-1., 0.}, {0., 0.}, {1., 0.}, {2., 
           0.}, {3., 0.}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "3"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-3, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "2"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "1"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "0", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {0, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "1", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "2", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "3", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {3, -0.5}]}, 
         InsetBox[
          FormBox[
           StyleBox[
           "\"n\"", 30, FontFamily -> "Linux Libertine Display O", 
            StripOnInput -> False], TraditionalForm], {3, 0.5}]}},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}], 
     StyleBox[
      TemplateBox[{"0",""},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     StyleBox[
      TemplateBox[{"0.`"},
       "RowDefault"],
      StripOnInput->False,
      FontFamily->"Linux Libertine Display O",
      FontSize->30], 
     GraphicsBox[{{{{}, {}, 
         TagBox[
          {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
           LineBox[CompressedData["
1:eJxF1G0sFAAYB/C749yI+9B1ts52cbfTjqaXeZtTHVPMmDjEuuqWI9ndNJO3
RtOIK3QzVKellnciKUt1COlMOsUyaV4Sc15iXHd2x6k2nufZ/vvv9/H/5XG4
lBgWSyIQCMH/8r9jmuUr29uULsLO7TMyHHmb6N7TVcKUDbTjRHv/0ip6wXrm
6dg0+mqCW1RrDzqL870rLg+tKGcXD1LRFZP5iaGWFmDbIUEIl04Gq84I/AY4
5uAALieZzTIDezUJq9WHSWDD7TjaMS4R/EdfWXrhIAH3sIpdO6Smzl3zyDda
ncWb4BK+h4dPpgEc8zBqdqFiA6yuYVoSFTow0/r50c42LdjKfk6tqV8DS8Jz
79fWroJFPZMDzOJlMOu4KfRDtgZcF986/bZtFpyw3iK8o5gGu2SRoy3Y42Ba
+siesvJh8KhY4tQ80wdOzXAq6i9tAtff9eRXHnl2ctdFV7K/iW5+BNtog3iN
ocPgqeQ+15SccfDv9uDuVNU0uDrviUgsmwVzdA20tHINeOLFASUvfhkccW8q
f1G+Cn5UVaAMKlsDm5+TLpPTteDPorqasBwd+JUN47xesgF2VDjMU4IMYENK
zlaDYBO8aLCj1nqawI8v543YsQn8Xct9PhXs5xDB1MQG3x46Cdzh91rZxjAD
b0kvukdSzcFEytcHzlto94Ck7kCCBdjwo3Gevob2k6jkwTp0oXHGM9eAtmfY
ybQkCtj/rIw7TEOXfIlNkLuhXfqYS1bp6LQIrxLfTPT7XxHeGdnocLPCAo0M
fZ1vPKRSoFVvRqW579B7A9fpyi60cIzaoe1Fr+hPUcWDaFu3l02+E2hRrzoy
4ye6TrBoaplDeyexQhxW0LeIJ/RR6+gheXSFXI9m2F/zVxnRO/8L/BenQCsU

            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65463#1"]& ]}, {}, {}}, {{{}, {}, 
         TagBox[
          {RGBColor[1, 0, 0], Thickness[0.025], Opacity[1.], 
           LineBox[CompressedData["
1:eJxF0GlI0wEYBvC5Zps289j8e8xjaq6mljDwSJQtUzNJScu8oCTnAQqzDFM0
A6+8kNAyV+nKTTRS+6CVR0NR8cqUWpRrZZZWI0zxmC6vVZDv+8LDw+/j8zpc
FEUkkkkkUujf/OtnzoHdH/zL+KT/x7fQkBaIFMGunzbwc7qILHC6WugtIUrA
oeXrRBVRC37xUVBcTjSDM4q++ZUQneBJ5XNxMTEC5kWtyqatlOBR98OqnMav
4NK1G0OpEjV4LqmCTWMtgg8o7j1eql4Gy04E5XmoNOC0ugCyK+M3uCu2ZrWX
sQVWzPvauUbqwEczWKq77nrHdt0a36/TtpDBJZ0MQX8IBcwZrPRSjeuDXXw6
Qi6IqOA3Dwo8fQ0NwH49ucqUUkOwsYBdS+LSwdKsX0bqFiNwPStR4hNujI4a
oKxkmoDDNlNup3uZgnlvZ9udaGbg9eKV1p0x9H5eNHNvGQMcbVZFOx7DBBeO
x081WZuDZ3sonv7z6FvSbR2tm8D9ieWN69kW4Pm4hSlWiCW42u37j2S6FbhC
w0uYGUN3rpxNqxRbg4de7gsXxrLAVOWdAZGrDZjb12kqXUDXSY6Mk9tswYEd
2czaa3bgiYYY70i+PTgogaqR0tj4v0v0wnYROmheRXo/iZ7Sqwkw93YAxxVa
ZyaL0dSC0U+TWvQpmwT6mXhHcL7j8KGffWi3luAr4n70O4+x3uBBtMvJV+ea
htGvRYpC4QSaLf88M61Cy6O0tYo1dNKX7Ll8LdokddOdt4EW5u0M3dxG0xsp
mlCKEzh22SR8xBRNya26f5WBbtNnqjnmaLKVxfUiS/Qjvm2rvz06YrReu8RG
b0WwAx46ok8nOal0zuiNRRnnyUG0LJtz+TwXHbanWW7kitZWcA3kbug/QWsI
ZA==
            "]]},
          
          Annotation[#, 
           "Charting`Private`Tag$65504#1"]& ]}, {}, {}}, {{}, {{}, 
         {RGBColor[
           NCache[
            Rational[2, 3], 0.6666666666666666], 0, 0], PointSize[0.03], 
          AbsoluteThickness[1.6], 
          PointBox[{{-3., 0.}, {-2., 0.}, {-1., 0.}, {0., 0.}, {1., 0.}, {2., 
           0.}, {3., 0.}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}}},
      AspectRatio->NCache[
        Rational[1, 4], 0.25],
      Axes->{True, True},
      AxesLabel->{None, None},
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Epilog->{{{
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "3"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-3, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "2"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
             RowBox[{"-", "1"}], 30, FontFamily -> 
             "Linux Libertine Display O", StripOnInput -> False], 
            TraditionalForm], {-1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "0", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {0, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "1", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {1, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "2", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {2, -0.5}], 
          InsetBox[
           FormBox[
            StyleBox[
            "3", 30, FontFamily -> "Linux Libertine Display O", StripOnInput -> 
             False], TraditionalForm], {3, -0.5}]}, 
         InsetBox[
          FormBox[
           StyleBox[
           "\"n\"", 30, FontFamily -> "Linux Libertine Display O", 
            StripOnInput -> False], TraditionalForm], {3, 0.5}]}},
      Frame->{{False, False}, {False, False}},
      FrameLabel->{{None, None}, {None, None}},
      FrameTicks->{{Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
         Charting`ScaledFrameTicks[{Identity, Identity}]}},
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->400,
      Method->{
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None, 
        "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotRange->{{-2.9999998775510206`, 2.9999998775510206`}, {-1.1, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {0, 0}},
      Ticks->{{}, {}}]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.709644814628799*^9, 
  3.709644883231411*^9},ExpressionUUID->"6ae23b11-4413-4a5a-9402-\
04f650f01873"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<gridNegative.pdf\>\"", ",", "gridNegative", ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7092335017694073`*^9, 
  3.709233506495739*^9}},ExpressionUUID->"601c9537-7e76-412a-b05e-\
5a2b7b2877bc"],

Cell[BoxData["\<\"gridNegative.pdf\"\>"], "Output",
 CellChangeTimes->{
  3.709644889695044*^9},ExpressionUUID->"49997dbc-81e4-44d9-b0ae-\
b748400ab0ae"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{2552, 1373},
WindowMargins->{{5, Automatic}, {Automatic, 35}},
Magnification->1.5,
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 160, 3, 48, "Text", "ExpressionUUID" -> \
"e0550381-9616-43ae-8ac7-16827808b9ca"],
Cell[CellGroupData[{
Cell[743, 27, 218, 4, 52, "Subsubsection", "ExpressionUUID" -> \
"97ec76cb-d563-4b07-b961-1c0f2c14c663"],
Cell[964, 33, 107313, 2616, 8662, "Input", "ExpressionUUID" -> \
"66d31ba8-5800-4165-9cdf-42f73a5cb2ee"]
}, Closed]],
Cell[CellGroupData[{
Cell[108314, 2654, 1481, 21, 42, "Subsubsection", "ExpressionUUID" -> \
"b9dc5cf4-4351-4cc7-84cb-ccdd7df53ecf"],
Cell[109798, 2677, 4414, 86, 367, "Input", "ExpressionUUID" -> \
"6fde6fae-d5f7-4ca9-9b9d-b98f1e6019a6"]
}, Closed]],
Cell[CellGroupData[{
Cell[114249, 2768, 188, 3, 42, "Subsubsection", "ExpressionUUID" -> \
"c7c2a500-2a7e-4338-bd9d-da00cb0f3169"],
Cell[114440, 2773, 2058, 50, 347, "Input", "ExpressionUUID" -> \
"78e41ef3-7068-4f24-a8f6-e79da4526da2"]
}, Closed]],
Cell[CellGroupData[{
Cell[116535, 2828, 568, 8, 42, "Subsubsection", "ExpressionUUID" -> \
"71c61f55-294e-42ce-ad9a-338c403b10ca"],
Cell[117106, 2838, 792, 20, 149, "Input", "ExpressionUUID" -> \
"b2561b57-cc3a-4635-8e57-ac79bba8da9c"],
Cell[117901, 2860, 1218, 25, 49, "Input", "ExpressionUUID" -> \
"c6b031ae-5e7e-472f-9361-5ef8e93507d4"],
Cell[119122, 2887, 982, 16, 49, "Input", "ExpressionUUID" -> \
"3402e35f-09a7-436a-823a-46d572d24569"],
Cell[120107, 2905, 179, 3, 48, "Text", "ExpressionUUID" -> \
"48f78a95-e11f-43eb-8d38-c7b5aa119259"],
Cell[120289, 2910, 893, 19, 83, "Input", "ExpressionUUID" -> \
"c20da155-90fe-4765-802b-fbd572d0b922"],
Cell[121185, 2931, 1783, 37, 116, "Input", "ExpressionUUID" -> \
"39f740c3-24fa-4819-a903-a1aee6d7d58f"],
Cell[122971, 2970, 701, 13, 83, "Input", "ExpressionUUID" -> \
"779ac48b-8cd0-4266-9e2b-159e7cc7209f"],
Cell[123675, 2985, 190, 3, 48, "Text", "ExpressionUUID" -> \
"a796d099-7af2-466b-89c5-b2c0706b7a1f"],
Cell[123868, 2990, 718, 19, 116, "Input", "ExpressionUUID" -> \
"2781dc7c-169d-42de-862b-eab6ac6b1f77"],
Cell[124589, 3011, 671, 20, 116, "Input", "ExpressionUUID" -> \
"ca1f0f32-7902-40ed-9438-e71c6fabb53e"],
Cell[125263, 3033, 584, 12, 83, "Input", "ExpressionUUID" -> \
"7f80030c-38e9-4d52-bba0-53f5edeb82a3"],
Cell[125850, 3047, 228, 4, 48, "Text", "ExpressionUUID" -> \
"bae1250a-dd53-4b09-8010-f85d795ef48f"],
Cell[126081, 3053, 2152, 48, 182, "Input", "ExpressionUUID" -> \
"e60a935e-e405-4ba3-a71d-16a6ab1e279c"],
Cell[128236, 3103, 754, 14, 83, "Input", "ExpressionUUID" -> \
"636f3661-0eb6-4b32-ba68-c0e1e0a9c6a3"],
Cell[128993, 3119, 150, 3, 49, "Input", "ExpressionUUID" -> \
"dd0457ad-20d9-4a44-b6cb-39af7eb49315"],
Cell[129146, 3124, 440, 12, 49, "Input", "ExpressionUUID" -> \
"4e82bfdf-cf76-4d6c-a3fd-60564c683b93"],
Cell[129589, 3138, 154, 3, 49, "Input", "ExpressionUUID" -> \
"f32afb44-a44e-416f-a68c-13df1d6f4359"],
Cell[129746, 3143, 396, 8, 49, "Input", "ExpressionUUID" -> \
"bf029ae9-ef73-457f-8624-84090f6d6886"],
Cell[130145, 3153, 897, 23, 83, "Input", "ExpressionUUID" -> \
"c8ba9c58-2b6a-4c25-9471-0f88a9935d4a"],
Cell[131045, 3178, 1002, 24, 83, "Input", "ExpressionUUID" -> \
"29d88fb7-4bb8-4488-b296-694e66681c30"],
Cell[132050, 3204, 1769, 47, 83, "Input", "ExpressionUUID" -> \
"5b6a98a1-d3f8-473b-8b35-c997794f72a0"]
}, Closed]],
Cell[CellGroupData[{
Cell[133856, 3256, 159, 3, 42, "Subsubsection", "ExpressionUUID" -> \
"df49d51f-9345-4749-aed7-192fcaf28033"],
Cell[134018, 3261, 223, 5, 49, "Input", "ExpressionUUID" -> \
"53898464-dfe8-466c-a471-da8b9b5eea8f"],
Cell[134244, 3268, 1305, 40, 99, "Input", "ExpressionUUID" -> \
"bf701d83-499d-47a6-82b2-62dff5c5fdf1"],
Cell[135552, 3310, 1674, 48, 139, "Input", "ExpressionUUID" -> \
"9087e846-0f96-481d-9f0c-5ece71d4abc5"],
Cell[137229, 3360, 1778, 56, 83, "Input", "ExpressionUUID" -> \
"8d6d4ba7-ff9d-4114-8cc7-d6e0c9eb8326"],
Cell[139010, 3418, 597, 17, 51, "Input", "ExpressionUUID" -> \
"c05ed77f-61c7-4c06-b32e-badc238e539c"],
Cell[139610, 3437, 196, 4, 69, "Input", "ExpressionUUID" -> \
"428e228a-036e-4976-8fa3-eeb27eeab4b9"],
Cell[139809, 3443, 1642, 45, 187, "Input", "ExpressionUUID" -> \
"2a2dbb0d-62aa-4140-9270-8545947a1dae"],
Cell[141454, 3490, 1558, 43, 103, "Input", "ExpressionUUID" -> \
"1ea0dc1d-797a-48ee-bac1-855cd3ff6a47"],
Cell[143015, 3535, 1717, 46, 83, "Input", "ExpressionUUID" -> \
"47b8329d-a76a-4e6d-8131-6b958b04355d"],
Cell[144735, 3583, 602, 13, 103, "Input", "ExpressionUUID" -> \
"59f72f52-56a9-4eb8-a2b1-968a2407abeb"],
Cell[145340, 3598, 2427, 67, 116, "Input", "ExpressionUUID" -> \
"32f1a869-f5ae-4f29-b111-3fa0fd270a52"],
Cell[147770, 3667, 7323, 182, 433, "Input", "ExpressionUUID" -> \
"a2871067-7741-4561-8445-9b4113ba70a3"],
Cell[155096, 3851, 1418, 38, 136, "Input", "ExpressionUUID" -> \
"95454a59-22b6-4f06-b4ba-752e5ea7cc17"],
Cell[156517, 3891, 4370, 109, 674, "Input", "ExpressionUUID" -> \
"b5e62d5f-0353-4574-9a37-d0ab128d80b6"],
Cell[CellGroupData[{
Cell[160912, 4004, 464, 11, 69, "Input", "ExpressionUUID" -> \
"3b5764cb-bda5-4cb5-93d0-413f51e372c5"],
Cell[161379, 4017, 382613, 6711, 1248, "Output", "ExpressionUUID" -> \
"d890533b-d36f-4c31-b6ea-0efa4e2c5924"]
}, Open  ]],
Cell[CellGroupData[{
Cell[544029, 10733, 348, 7, 69, "Input", "ExpressionUUID" -> \
"724f1dcb-a4dd-43db-909d-62eecb14e095"],
Cell[544380, 10742, 153, 3, 69, "Output", "ExpressionUUID" -> \
"57761a4c-29f7-4788-b302-c5eaded1a111"]
}, Open  ]],
Cell[544548, 10748, 2386, 60, 169, "Input", "ExpressionUUID" -> \
"01d1c375-6450-4680-aec0-cc00864f2928"],
Cell[546937, 10810, 4820, 114, 635, "Input", "ExpressionUUID" -> \
"57b16e85-693e-48b5-8af8-e0b741138f5a"],
Cell[CellGroupData[{
Cell[551782, 10928, 410, 9, 69, "Input", "ExpressionUUID" -> \
"0486eeb9-ae35-47c8-a949-0b804cc1ab77"],
Cell[552195, 10939, 382309, 6709, 1248, "Output", "ExpressionUUID" -> \
"6ae23b11-4413-4a5a-9402-04f650f01873"]
}, Open  ]],
Cell[CellGroupData[{
Cell[934541, 17653, 350, 7, 69, "Input", "ExpressionUUID" -> \
"601c9537-7e76-412a-b05e-5a2b7b2877bc"],
Cell[934894, 17662, 153, 3, 126, "Output", "ExpressionUUID" -> \
"49997dbc-81e4-44d9-b0ae-b748400ab0ae"]
}, Open  ]]
}, Open  ]]
}
]
*)

