(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     25260,        660]
NotebookOptionsPosition[     23814,        619]
NotebookOutlinePosition[     24168,        635]
CellTagsIndexPosition[     24125,        632]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"u1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"5", 
        RowBox[{"\[Pi]", "/", "6"}]}], "+", "\[Theta]"}], "]"}], ",", 
     RowBox[{"Sin", "[", 
      RowBox[{
       RowBox[{"5", 
        RowBox[{"\[Pi]", "/", "6"}]}], "+", "\[Theta]"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"u2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"\[Theta]", "-", 
       RowBox[{"\[Pi]", "/", "2"}]}], "]"}], ",", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Theta]", "-", 
       RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"u3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"\[Pi]", "/", "6"}], "+", "\[Theta]"}], "]"}], ",", 
     RowBox[{"Sin", "[", 
      RowBox[{
       RowBox[{"\[Pi]", "/", "6"}], "+", "\[Theta]"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"origin", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "-", 
           RowBox[{"\[Pi]", "/", "2"}]}], "]"}], "-", 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"5", 
            RowBox[{"\[Pi]", "/", "6"}]}], "+", "\[Theta]"}], "]"}]}], ")"}], 
       "/", 
       RowBox[{"Tan", "[", 
        RowBox[{"\[Pi]", "/", "3"}], "]"}]}], "+", 
      RowBox[{"Cos", "[", 
       RowBox[{
        RowBox[{"5", 
         RowBox[{"\[Pi]", "/", "6"}]}], "+", "\[Theta]"}], "]"}]}], ",", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Theta]", "-", 
       RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7050663119680557`*^9, 3.705066429989398*^9}, {
  3.705066460767332*^9, 
  3.705066529820325*^9}},ExpressionUUID->"a49009b9-850b-47b5-9ab0-\
e2cbc6643605"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"a1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", "0"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{
      FractionBox[
       SqrtBox["3"], "2"], 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"factor", "=", 
   RowBox[{"2", 
    SqrtBox["3"]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.705066665577753*^9, 3.705066679771748*^9}, {
  3.705066790060096*^9, 3.705066790223363*^9}, {3.705066864562826*^9, 
  3.7050668658592243`*^9}, {3.705067779497793*^9, 3.705067784407515*^9}, {
  3.705067865286709*^9, 3.7050679368398952`*^9}, {3.705068209294857*^9, 
  3.705068209593585*^9}},ExpressionUUID->"3c76a904-4305-4f4e-90f2-\
bafbaaa9b6b4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x1", "=", 
   RowBox[{
    SuperscriptBox["factor", 
     RowBox[{"-", "1"}]], "*", 
    RowBox[{"(", 
     RowBox[{"u1", "-", "origin"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x2", "=", 
   RowBox[{
    SuperscriptBox["factor", 
     RowBox[{"-", "1"}]], "*", 
    RowBox[{"(", 
     RowBox[{"u2", "-", "origin"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x3", "=", 
   RowBox[{
    SuperscriptBox["factor", 
     RowBox[{"-", "1"}]], "*", 
    RowBox[{"(", 
     RowBox[{"u3", "-", "origin"}], ")"}]}]}], ";"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"x1", "*", "2", "l"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"x2", "*", "2", "l"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"x3", "*", "2", "l"}], "]"}]}], "Input",
 CellChangeTimes->{{3.705066538820683*^9, 3.705066561678179*^9}, {
   3.705066683626659*^9, 3.705066757781156*^9}, 3.705066857831758*^9, {
   3.70506787079875*^9, 3.705067877109097*^9}, {3.705071026614314*^9, 
   3.7050710353679543`*^9}},ExpressionUUID->"feaaef3c-ebd5-4f9f-8d64-\
c9600ad982b9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "3"], " ", "l", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "+", 
      RowBox[{"Sin", "[", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"(", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"6", " ", "\[Theta]"}]}], ")"}]}], "]"}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", "l", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "-", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.705070301993031*^9, 
  3.705071035778502*^9},ExpressionUUID->"88f28f47-3874-46ad-b21c-\
af2e7b34d7f7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"l", " ", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
    FractionBox[
     RowBox[{"l", " ", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], 
     SqrtBox["3"]]}], ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.705070301993031*^9, 
  3.70507103581039*^9},ExpressionUUID->"cd0e359d-9ed9-4693-b960-aab7a1b7540c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "6"]}], " ", "l", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "9"}], " ", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", "l", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.705070301993031*^9, 
  3.705071035843359*^9},ExpressionUUID->"ab047bb2-02ed-4ffe-b702-\
3c7a4e786a84"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"discreteColors", "[", "n_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"partL", "=", 
      RowBox[{"Ceiling", "[", 
       RowBox[{"Sqrt", "[", "n", "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Lighter", "[", 
             RowBox[{
              RowBox[{"Darker", "[", 
               RowBox[{
                RowBox[{"Hue", "[", "c", "]"}], ",", ".1"}], "]"}], ",", 
              ".25"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"c", ",", "0", ",", 
              RowBox[{"1", "-", 
               RowBox[{"1", "/", "n"}]}], ",", 
              RowBox[{"1", "/", "n"}]}], "}"}]}], "]"}], ",", "partL", ",", 
          "partL", ",", "1", ",", "0"}], "]"}], "]"}], "]"}], ",", "0"}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7050689630995617`*^9, 
  3.705068963100595*^9}},ExpressionUUID->"2d7b24fe-097f-4608-ad7a-\
3a0aa11229eb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"totalstep", "=", "100"}], ",", 
     RowBox[{"nmax", "=", "5"}], ",", 
     RowBox[{"mmax", "=", "5"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"total", "=", "totalstep"}], ";", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Thick", ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"discreteColors", "[", "total", "]"}], 
            "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "*)"}], 
          ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x1", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x1", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}], "*", "a2"}]}], ",", 
                  RowBox[{"x1", "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"n", "+", "1"}], ")"}], "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}], "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x1", "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"n", "+", "1"}], ")"}], "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}]}], "}"}], "]"}], "/.", 
             
             RowBox[{"\[Theta]", "->", 
              RowBox[{
               RowBox[{"\[Pi]", "/", "3"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "-", "1"}], ")"}], "/", "total"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "0", ",", "nmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"PlotRange", "->", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"nmax", "+", "1"}], ")"}], "*", "1.5"}]}], "}"}], ",", 
           
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}], ",", 
             RowBox[{"mmax", "+", 
              RowBox[{"1", "/", "2"}]}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "total", ",", "1"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.705067477556126*^9, 3.705067586543067*^9}, {
   3.70506763254478*^9, 3.7050676437248173`*^9}, 3.7050677370674477`*^9, {
   3.705067959052133*^9, 3.705068077886999*^9}, {3.705068128472609*^9, 
   3.7050681759172573`*^9}, {3.70506821738477*^9, 3.705068326038587*^9}, {
   3.7050684100503807`*^9, 3.7050684187514143`*^9}, {3.7050684561443987`*^9, 
   3.7050685110395308`*^9}, {3.705068547120668*^9, 3.705068621413076*^9}, {
   3.705068653409954*^9, 3.7050686815848637`*^9}, {3.705068721604225*^9, 
   3.7050687787278852`*^9}, {3.705068831713951*^9, 3.705068888986504*^9}, {
   3.705068986497633*^9, 3.70506921995575*^9}, {3.7050692897058897`*^9, 
   3.705069317234219*^9}, {3.70506936305088*^9, 3.7050694096674337`*^9}, {
   3.705069451888582*^9, 3.705069551577485*^9}, {3.7050696144331303`*^9, 
   3.705069718749289*^9}, {3.705069757070466*^9, 3.705069924775065*^9}, {
   3.705070021930378*^9, 3.705070145284439*^9}, {3.7050702268058567`*^9, 
   3.705070226891313*^9}, {3.705070342518436*^9, 
   3.705070375438076*^9}},ExpressionUUID->"00bb65b2-64e4-4abc-94c6-\
2ecaaa78e6b9"],

Cell[BoxData[
 DynamicModuleBox[{$CellContext`totalstep$$ = 100, $CellContext`nmax$$ = 
  5, $CellContext`mmax$$ = 5}, 
  TagBox[
   StyleBox[
    DynamicModuleBox[{$CellContext`i$$ = 1, Typeset`show$$ = True, 
     Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
     Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
     "\"untitled\"", Typeset`specs$$ = {{
       Hold[$CellContext`i$$], 1, 100, 1}}, Typeset`size$$ = {
     540., {176., 184.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
     Typeset`skipInitDone$$ = True, $CellContext`i$45313$$ = 0}, 
     DynamicBox[Manipulate`ManipulateBoxes[
      1, StandardForm, "Variables" :> {$CellContext`i$$ = 1}, 
       "ControllerVariables" :> {
         Hold[$CellContext`i$$, $CellContext`i$45313$$, 0]}, 
       "OtherVariables" :> {
        Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
         Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
         Typeset`specs$$, Typeset`size$$, Typeset`update$$, 
         Typeset`initDone$$, Typeset`skipInitDone$$}, "Body" :> 
       Graphics[{Thick, Null, 
          Table[
           ReplaceAll[
            
            Line[{{$CellContext`x1 + $CellContext`n $CellContext`a1 + \
$CellContext`m $CellContext`a2, $CellContext`x2 + $CellContext`n \
$CellContext`a1 + $CellContext`m $CellContext`a2}, {$CellContext`x2 + \
$CellContext`n $CellContext`a1 + $CellContext`m $CellContext`a2, \
$CellContext`x3 + $CellContext`n $CellContext`a1 + $CellContext`m \
$CellContext`a2}, {$CellContext`x1 + $CellContext`n $CellContext`a1 + \
$CellContext`m $CellContext`a2, $CellContext`x3 + $CellContext`n \
$CellContext`a1 + $CellContext`m $CellContext`a2}, {$CellContext`x2 + \
$CellContext`n $CellContext`a1 + ($CellContext`m + 
                 1) $CellContext`a2, $CellContext`x1 + ($CellContext`n + 
                 1) $CellContext`a1 + $CellContext`m $CellContext`a2}, \
{$CellContext`x2 + $CellContext`n $CellContext`a1 + ($CellContext`m + 
                 1) $CellContext`a2, $CellContext`x3 + $CellContext`n \
$CellContext`a1 + $CellContext`m $CellContext`a2}, {$CellContext`x1 + \
($CellContext`n + 
                 1) $CellContext`a1 + $CellContext`m $CellContext`a2, \
$CellContext`x3 + $CellContext`n $CellContext`a1 + $CellContext`m \
$CellContext`a2}}], $CellContext`\[Theta] -> (Pi/
              3) (($CellContext`i$$ - 
               1)/$CellContext`total)], {$CellContext`n, 
            0, $CellContext`nmax$$}, {$CellContext`m, 
            0, $CellContext`mmax$$}]}, 
         PlotRange -> {{
           0, ($CellContext`nmax$$ + 1) 1.5}, {(-1)/2, $CellContext`mmax$$ + 
            1/2}}], "Specifications" :> {{$CellContext`i$$, 1, 100, 1}}, 
       "Options" :> {}, "DefaultOptions" :> {}],
      ImageSizeCache->{608., {237., 245.}},
      SingleEvaluation->True],
     Deinitialization:>None,
     DynamicModuleValues:>{},
     SynchronousInitialization->True,
     UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
     UnsavedVariables:>{Typeset`initDone$$},
     UntrackedVariables:>{Typeset`size$$}], "Manipulate",
    Deployed->True,
    StripOnInput->False],
   Manipulate`InterpretManipulate[1]],
  DynamicModuleValues:>{}]], "Output",
 CellChangeTimes->{{3.705070068596512*^9, 3.705070145870819*^9}, {
  3.7050703435169563`*^9, 
  3.705070375898711*^9}},ExpressionUUID->"d226bdd1-bb80-418c-963b-\
64d14d981e20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"totalstep", "=", "100"}], ",", 
     RowBox[{"nmax", "=", "5"}], ",", 
     RowBox[{"mmax", "=", "5"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"total", "=", "totalstep"}], ";", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Thick", ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"discreteColors", "[", "total", "]"}], 
            "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "*)"}], 
          ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Polygon", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x1", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], "]"}], ",", 
               RowBox[{"Polygon", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x2", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}], "*", "a2"}]}], ",", 
                  RowBox[{"x1", "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"n", "+", "1"}], ")"}], "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}], ",", 
                  RowBox[{"x3", "+", 
                   RowBox[{"n", " ", "a1"}], "+", 
                   RowBox[{"m", "*", "a2"}]}]}], "}"}], "]"}]}], "}"}], "/.", 
             
             RowBox[{"\[Theta]", "->", 
              RowBox[{
               RowBox[{"\[Pi]", "/", "3"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"i", "-", "1"}], ")"}], "/", "total"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "0", ",", "nmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "0", ",", "mmax"}], "}"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"PlotRange", "->", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"nmax", "+", "1"}], ")"}], "*", "1.5"}]}], "}"}], ",", 
           
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}], ",", 
             RowBox[{"mmax", "+", 
              RowBox[{"1", "/", "2"}]}]}], "}"}]}], "}"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "total", ",", "1"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.705067477556126*^9, 3.705067586543067*^9}, {
   3.70506763254478*^9, 3.7050676437248173`*^9}, 3.7050677370674477`*^9, {
   3.705067959052133*^9, 3.705068077886999*^9}, {3.705068128472609*^9, 
   3.7050681759172573`*^9}, {3.70506821738477*^9, 3.705068326038587*^9}, {
   3.7050684100503807`*^9, 3.7050684187514143`*^9}, {3.7050684561443987`*^9, 
   3.7050685110395308`*^9}, {3.705068547120668*^9, 3.705068621413076*^9}, {
   3.705068653409954*^9, 3.7050686815848637`*^9}, {3.705068721604225*^9, 
   3.7050687787278852`*^9}, {3.705068831713951*^9, 3.705068888986504*^9}, {
   3.705068986497633*^9, 3.70506921995575*^9}, {3.7050692897058897`*^9, 
   3.705069317234219*^9}, {3.70506936305088*^9, 3.7050694096674337`*^9}, {
   3.705069451888582*^9, 3.705069551577485*^9}, {3.7050696144331303`*^9, 
   3.705069718749289*^9}, {3.705069757070466*^9, 3.705069924775065*^9}, {
   3.705070021930378*^9, 3.705070145284439*^9}, {3.7050702268058567`*^9, 
   3.705070226891313*^9}, {3.705070342518436*^9, 3.705070375438076*^9}, {
   3.705071614720414*^9, 3.7050716625684357`*^9}, {3.7050717434501057`*^9, 
   3.705071754553597*^9}, {3.7050717943692408`*^9, 
   3.70507186130373*^9}},ExpressionUUID->"3b2a1927-7db4-4394-80dd-\
acafdc03db69"],

Cell[BoxData[
 DynamicModuleBox[{$CellContext`totalstep$$ = 100, $CellContext`nmax$$ = 
  5, $CellContext`mmax$$ = 5}, 
  TagBox[
   StyleBox[
    DynamicModuleBox[{$CellContext`i$$ = 37, Typeset`show$$ = True, 
     Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
     Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
     "\"untitled\"", Typeset`specs$$ = {{
       Hold[$CellContext`i$$], 1, 100, 1}}, Typeset`size$$ = {
     540., {176., 184.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
     Typeset`skipInitDone$$ = True, $CellContext`i$47208$$ = 0}, 
     DynamicBox[Manipulate`ManipulateBoxes[
      1, StandardForm, "Variables" :> {$CellContext`i$$ = 1}, 
       "ControllerVariables" :> {
         Hold[$CellContext`i$$, $CellContext`i$47208$$, 0]}, 
       "OtherVariables" :> {
        Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
         Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
         Typeset`specs$$, Typeset`size$$, Typeset`update$$, 
         Typeset`initDone$$, Typeset`skipInitDone$$}, "Body" :> 
       Graphics[{Thick, Null, 
          Table[
           ReplaceAll[{
             
             Polygon[{$CellContext`x1 + $CellContext`n $CellContext`a1 + \
$CellContext`m $CellContext`a2, $CellContext`x2 + $CellContext`n \
$CellContext`a1 + $CellContext`m $CellContext`a2, $CellContext`x3 + \
$CellContext`n $CellContext`a1 + $CellContext`m $CellContext`a2}], 
             
             Polygon[{$CellContext`x2 + $CellContext`n $CellContext`a1 + \
($CellContext`m + 1) $CellContext`a2, $CellContext`x1 + ($CellContext`n + 
                 1) $CellContext`a1 + $CellContext`m $CellContext`a2, \
$CellContext`x3 + $CellContext`n $CellContext`a1 + $CellContext`m \
$CellContext`a2}]}, $CellContext`\[Theta] -> (Pi/
              3) (($CellContext`i$$ - 
               1)/$CellContext`total)], {$CellContext`n, 
            0, $CellContext`nmax$$}, {$CellContext`m, 
            0, $CellContext`mmax$$}]}, 
         PlotRange -> {{
           0, ($CellContext`nmax$$ + 1) 1.5}, {(-1)/2, $CellContext`mmax$$ + 
            1/2}}], "Specifications" :> {{$CellContext`i$$, 1, 100, 1}}, 
       "Options" :> {}, "DefaultOptions" :> {}],
      ImageSizeCache->{608., {237., 245.}},
      SingleEvaluation->True],
     Deinitialization:>None,
     DynamicModuleValues:>{},
     SynchronousInitialization->True,
     UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
     UnsavedVariables:>{Typeset`initDone$$},
     UntrackedVariables:>{Typeset`size$$}], "Manipulate",
    Deployed->True,
    StripOnInput->False],
   Manipulate`InterpretManipulate[1]],
  DynamicModuleValues:>{}]], "Output",
 CellChangeTimes->{{3.705071643377016*^9, 3.705071663561207*^9}, 
   3.705071755086286*^9, {3.705071833071534*^9, 
   3.705071861793515*^9}},ExpressionUUID->"cdbf9a1d-d009-4a49-8432-\
a99721cef9c4"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{0, Automatic}, {Automatic, 35}},
Magnification->1.5,
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1967, 64, 149, "Input", "ExpressionUUID" -> \
"a49009b9-850b-47b5-9ab0-e2cbc6643605"],
Cell[2528, 86, 949, 28, 162, "Input", "ExpressionUUID" -> \
"3c76a904-4305-4f4e-90f2-bafbaaa9b6b4"],
Cell[CellGroupData[{
Cell[3502, 118, 1125, 32, 235, "Input", "ExpressionUUID" -> \
"feaaef3c-ebd5-4f9f-8d64-c9600ad982b9"],
Cell[4630, 152, 771, 24, 87, "Output", "ExpressionUUID" -> \
"88f28f47-3874-46ad-b21c-af2e7b34d7f7"],
Cell[5404, 178, 388, 11, 98, "Output", "ExpressionUUID" -> \
"cd0e359d-9ed9-4693-b960-aab7a1b7540c"],
Cell[5795, 191, 739, 24, 119, "Output", "ExpressionUUID" -> \
"ab047bb2-02ed-4ffe-b702-3c7a4e786a84"]
}, Open  ]],
Cell[6549, 218, 1162, 32, 137, "Input", "ExpressionUUID" -> \
"2d7b24fe-097f-4608-ad7a-3a0aa11229eb"],
Cell[CellGroupData[{
Cell[7736, 254, 5398, 128, 235, "Input", "ExpressionUUID" -> \
"00bb65b2-64e4-4abc-94c6-2ecaaa78e6b9"],
Cell[13137, 384, 3407, 66, 527, "Output", "ExpressionUUID" -> \
"d226bdd1-bb80-418c-963b-64d14d981e20"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16581, 455, 4328, 101, 235, "Input", "ExpressionUUID" -> \
"3b2a1927-7db4-4394-80dd-acafdc03db69"],
Cell[20912, 558, 2886, 58, 559, "Output", "ExpressionUUID" -> \
"cdbf9a1d-d009-4a49-8432-a99721cef9c4"]
}, Open  ]]
}
]
*)

